/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var fe=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/path","vs/base/common/uri","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/base/common/async","vs/base/common/strings","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/promptInputModel","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],me=function(ae){for(var e=[],w=0,L=ae.length;w<L;w++)e[w]=fe[ae[w]];return e};define(fe[40],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=w,e.$gb=L,e.$hb=C,e.$ib=M,e.$jb=j,e.$kb=P,e.$lb=h,e.$nb=y,e.$ob=l,e.$pb=E,e.$qb=o,e.$rb=a;function w(g,f){const n=L(g,f);if(n!==-1)return g[n]}function L(g,f,n=g.length-1){for(let s=n;s>=0;s--){const d=g[s];if(f(d))return s}return-1}function C(g,f){const n=M(g,f);return n===-1?void 0:g[n]}function M(g,f,n=0,s=g.length){let d=n,v=s;for(;d<v;){const i=Math.floor((d+v)/2);f(g[i])?d=i+1:v=i}return d-1}function j(g,f){const n=P(g,f);return n===g.length?void 0:g[n]}function P(g,f,n=0,s=g.length){let d=n,v=s;for(;d<v;){const i=Math.floor((d+v)/2);f(g[i])?v=i:d=i+1}return d}function h(g,f,n=0,s=g.length){const d=P(g,f,n,s);return d===g.length?-1:d}class r{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(r.assertInvariants){if(this.d){for(const s of this.e)if(this.d(s)&&!f(s))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const n=M(this.e,f,this.c);return this.c=n+1,n===-1?void 0:this.e[n]}}e.$mb=r;function y(g,f){if(g.length===0)return;let n=g[0];for(let s=1;s<g.length;s++){const d=g[s];f(d,n)>0&&(n=d)}return n}function l(g,f){if(g.length===0)return;let n=g[0];for(let s=1;s<g.length;s++){const d=g[s];f(d,n)>=0&&(n=d)}return n}function E(g,f){return y(g,(n,s)=>-f(n,s))}function o(g,f){if(g.length===0)return-1;let n=0;for(let s=1;s<g.length;s++){const d=g[s];f(d,g[n])>0&&(n=s)}return n}function a(g,f){for(const n of g){const s=f(n);if(s!==void 0)return s}}}),define(fe[41],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=w,e.$L=L,e.$M=C,e.$N=M;function w(j,P){const h=Object.create(null);for(const r of j){const y=P(r);let l=h[y];l||(l=h[y]=[]),l.push(r)}return h}function L(j,P){const h=[],r=[];for(const y of j)P.has(y)||h.push(y);for(const y of P)j.has(y)||r.push(y);return{removed:h,added:r}}function C(j,P){const h=[],r=[];for(const[y,l]of j)P.has(y)||h.push(l);for(const[y,l]of P)j.has(y)||r.push(l);return{removed:h,added:r}}function M(j,P){const h=new Set;for(const r of P)j.has(r)&&h.add(r);return h}}),define(fe[14],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=L,e.$2h=C,e.$3h=M;function w(j){return(P,h,r)=>{let y=null,l=null;if(typeof r.value=="function"?(y="value",l=r.value):typeof r.get=="function"&&(y="get",l=r.get),!l)throw new Error("not supported");r[y]=j(l,h)}}function L(j,P,h){let r=null,y=null;if(typeof h.value=="function"?(r="value",y=h.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(r="get",y=h.get),!y)throw new Error("not supported");const l=`$memoize$${P}`;h[r]=function(...E){return this.hasOwnProperty(l)||Object.defineProperty(this,l,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,E)}),this[l]}}function C(j,P,h){return w((r,y)=>{const l=`$debounce$${y}`,E=`$debounce$result$${y}`;return function(...o){this[E]||(this[E]=h?h():void 0),clearTimeout(this[l]),P&&(this[E]=P(this[E],...o),o=[this[E]]),this[l]=setTimeout(()=>{r.apply(this,o),this[E]=h?h():void 0},j)}})}function M(j,P,h){return w((r,y)=>{const l=`$throttle$timer$${y}`,E=`$throttle$result$${y}`,o=`$throttle$lastRun$${y}`,a=`$throttle$pending$${y}`;return function(...g){if(this[E]||(this[E]=h?h():void 0),(this[o]===null||this[o]===void 0)&&(this[o]=-Number.MAX_VALUE),P&&(this[E]=P(this[E],...g)),this[a])return;const f=this[o]+j;f<=Date.now()?(this[o]=Date.now(),r.apply(this,[this[E]]),this[E]=h?h():void 0):(this[a]=!0,this[l]=setTimeout(()=>{this[a]=!1,this[o]=Date.now(),r.apply(this,[this[E]]),this[E]=h?h():void 0},f-Date.now()))}})}}),define(fe[7],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=L,e.$Z=C,e.$1=M,e.$2=j,e.$3=P,e.$4=r,e.$6=l,e.$7=E,e.$8=o,e.$0=g;class w{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?d.isErrorNoTelemetry(t)?new d(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(c=>{c(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=w,e.$X=new w;function L(i){e.$X.setUnexpectedErrorHandler(i)}function C(i){if(!i||typeof i!="object")return!1;const t=i;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function M(i){r(i)||e.$X.onUnexpectedError(i)}function j(i){r(i)||e.$X.onUnexpectedExternalError(i)}function P(i){if(i instanceof Error){const{name:t,message:c}=i,S=i.stacktrace||i.stack;return{$isError:!0,name:t,message:c,stack:S,noTelemetry:d.isErrorNoTelemetry(i)}}return i}const h="Canceled";function r(i){return i instanceof y?!0:i instanceof Error&&i.name===h&&i.message===h}class y extends Error{constructor(){super(h),this.name=this.message}}e.$5=y;function l(){const i=new Error(h);return i.name=i.message,i}function E(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}function o(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}class a extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=a;function g(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class n extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=n;class s extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=s;class d extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof d)return t;const c=new d;return c.message=t.message,c.stack=t.stack,c}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=d;class v extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,v.prototype)}}e.$cb=v}),define(fe[16],me([0,1,7,40]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=C,e.$tb=M,e.$ub=j,e.$vb=P,e.$wb=h,e.$xb=r,e.$yb=y,e.$zb=l,e.$Ab=E,e.$Bb=o,e.$Cb=a,e.$Db=g,e.$Eb=f,e.top=n,e.$Gb=s,e.$Hb=v,e.$Ib=i,e.$Jb=t,e.$Kb=c,e.$Lb=S,e.$Mb=p,e.$Nb=D,e.$Ob=k,e.$Pb=b,e.$Qb=z,e.$Rb=Z,e.$Sb=T,e.$Tb=R,e.$Ub=m,e.$Vb=O,e.$Wb=$,e.$Xb=A,e.$Yb=Y,e.$Zb=te,e.$1b=G,e.$2b=ee,e.$3b=ce,e.$4b=ue,e.$5b=X,e.$6b=q,e.$7b=de,e.$8b=B,e.$$b=u;function C(H,V=0){return H[H.length-(1+V)]}function M(H){if(H.length===0)throw new Error("Invalid tail call");return[H.slice(0,H.length-1),H[H.length-1]]}function j(H,V,F=(I,W)=>I===W){if(H===V)return!0;if(!H||!V||H.length!==V.length)return!1;for(let I=0,W=H.length;I<W;I++)if(!F(H[I],V[I]))return!1;return!0}function P(H,V){const F=H.length-1;V<F&&(H[V]=H[F]),H.pop()}function h(H,V,F){return r(H.length,I=>F(H[I],V))}function r(H,V){let F=0,I=H-1;for(;F<=I;){const W=(F+I)/2|0,x=V(W);if(x<0)F=W+1;else if(x>0)I=W-1;else return W}return-(F+1)}function y(H,V,F){if(H=H|0,H>=V.length)throw new TypeError("invalid index");const I=V[Math.floor(V.length*Math.random())],W=[],x=[],se=[];for(const re of V){const he=F(re,I);he<0?W.push(re):he>0?x.push(re):se.push(re)}return H<W.length?y(H,W,F):H<W.length+se.length?se[0]:y(H-(W.length+se.length),x,F)}function l(H,V){const F=[];let I;for(const W of H.slice(0).sort(V))!I||V(I[0],W)!==0?(I=[W],F.push(I)):I.push(W);return F}function*E(H,V){let F,I;for(const W of H)I!==void 0&&V(I,W)?F.push(W):(F&&(yield F),F=[W]),I=W;F&&(yield F)}function o(H,V){for(let F=0;F<=H.length;F++)V(F===0?void 0:H[F-1],F===H.length?void 0:H[F])}function a(H,V){for(let F=0;F<H.length;F++)V(F===0?void 0:H[F-1],H[F],F+1===H.length?void 0:H[F+1])}function g(H,V,F){const I=[];function W(re,he,pe){if(he===0&&pe.length===0)return;const $e=I[I.length-1];$e&&$e.start+$e.deleteCount===re?($e.deleteCount+=he,$e.toInsert.push(...pe)):I.push({start:re,deleteCount:he,toInsert:pe})}let x=0,se=0;for(;;){if(x===H.length){W(x,0,V.slice(se));break}if(se===V.length){W(x,H.length-x,[]);break}const re=H[x],he=V[se],pe=F(re,he);pe===0?(x+=1,se+=1):pe<0?(W(x,1,[]),x+=1):pe>0&&(W(x,0,[he]),se+=1)}return I}function f(H,V,F){const I=g(H,V,F),W=[],x=[];for(const se of I)W.push(...H.slice(se.start,se.start+se.deleteCount)),x.push(...se.toInsert);return{removed:W,added:x}}function n(H,V,F){if(F===0)return[];const I=H.slice(0,F).sort(V);return d(H,V,I,F,H.length),I}function s(H,V,F,I,W){return F===0?Promise.resolve([]):new Promise((x,se)=>{(async()=>{const re=H.length,he=H.slice(0,F).sort(V);for(let pe=F,$e=Math.min(F+I,re);pe<re;pe=$e,$e=Math.min($e+I,re)){if(pe>F&&await new Promise(ye=>setTimeout(ye)),W&&W.isCancellationRequested)throw new w.$5;d(H,V,he,pe,$e)}return he})().then(x,se)})}function d(H,V,F,I,W){for(const x=F.length;I<W;I++){const se=H[I];if(V(se,F[x-1])<0){F.pop();const re=(0,L.$kb)(F,he=>V(se,he)<0);F.splice(re,0,se)}}}function v(H){return H.filter(V=>!!V)}function i(H){let V=0;for(let F=0;F<H.length;F++)H[F]&&(H[V]=H[F],V+=1);H.length=V}function t(H,V,F){H.splice(F,0,H.splice(V,1)[0])}function c(H){return!Array.isArray(H)||H.length===0}function S(H){return Array.isArray(H)&&H.length>0}function p(H,V=F=>F){const F=new Set;return H.filter(I=>{const W=V(I);return F.has(W)?!1:(F.add(W),!0)})}function D(H){const V=new Set;return F=>{const I=H(F);return V.has(I)?!1:(V.add(I),!0)}}function k(H,V){return H.length>0?H[0]:V}function b(H,V){return H.length>0?H[H.length-1]:V}function z(H,V,F=(I,W)=>I===W){let I=0;for(let W=0,x=Math.min(H.length,V.length);W<x&&F(H[W],V[W]);W++)I++;return I}function Z(H){return[].concat(...H)}function T(H,V){let F=typeof V=="number"?H:0;typeof V=="number"?F=H:(F=0,V=H);const I=[];if(F<=V)for(let W=F;W<V;W++)I.push(W);else for(let W=F;W>V;W--)I.push(W);return I}function R(H,V,F){return H.reduce((I,W)=>(I[V(W)]=F?F(W):W,I),Object.create(null))}function m(H,V){return H.push(V),()=>O(H,V)}function O(H,V){const F=H.indexOf(V);if(F>-1)return H.splice(F,1),V}function $(H,V,F){const I=H.slice(0,V),W=H.slice(V);return I.concat(F,W)}function A(H,V){let F;if(typeof V=="number"){let I=V;F=()=>{const W=Math.sin(I++)*179426549;return W-Math.floor(W)}}else F=Math.random;for(let I=H.length-1;I>0;I-=1){const W=Math.floor(F()*(I+1)),x=H[I];H[I]=H[W],H[W]=x}}function Y(H,V){const F=H.indexOf(V);F>-1&&(H.splice(F,1),H.unshift(V))}function te(H,V){const F=H.indexOf(V);F>-1&&(H.splice(F,1),H.push(V))}function G(H,V){for(const F of V)H.push(F)}function ee(H,V){return Array.isArray(H)?H.map(V):V(H)}function ce(H){return Array.isArray(H)?H:[H]}function ue(H){return H[Math.floor(Math.random()*H.length)]}function X(H,V,F){const I=Q(H,V),W=H.length,x=F.length;H.length=W+x;for(let se=W-1;se>=I;se--)H[se+x]=H[se];for(let se=0;se<x;se++)H[se+I]=F[se]}function q(H,V,F,I){const W=Q(H,V);let x=H.splice(W,F);return x===void 0&&(x=[]),X(H,W,I),x}function Q(H,V){return V<0?Math.max(V+H.length,0):Math.min(V,H.length)}var K;(function(H){function V(x){return x<0}H.isLessThan=V;function F(x){return x<=0}H.isLessThanOrEqual=F;function I(x){return x>0}H.isGreaterThan=I;function W(x){return x===0}H.isNeitherLessOrGreaterThan=W,H.greaterThan=1,H.lessThan=-1,H.neitherLessOrGreaterThan=0})(K||(e.CompareResult=K={}));function de(H,V){return(F,I)=>V(H(F),H(I))}function B(...H){return(V,F)=>{for(const I of H){const W=I(V,F);if(!K.isNeitherLessOrGreaterThan(W))return W}return K.neitherLessOrGreaterThan}}const le=(H,V)=>H-V;e.$9b=le;const _=(H,V)=>(0,e.$9b)(H?1:0,V?1:0);e.$0b=_;function u(H){return(V,F)=>-H(V,F)}class N{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let F=this.c;for(;F<this.g.length&&V(this.g[F]);)F++;const I=F===this.c?null:this.g.slice(this.c,F);return this.c=F,I}takeFromEndWhile(V){let F=this.d;for(;F>=0&&V(this.g[F]);)F--;const I=F===this.d?null:this.g.slice(F+1,this.d+1);return this.d=F,I}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const F=this.g.slice(this.c,this.c+V);return this.c+=V,F}}e.$_b=N;class ie{static{this.empty=new ie(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(F=>(V(F),!0))}toArray(){const V=[];return this.iterate(F=>(V.push(F),!0)),V}filter(V){return new ie(F=>this.iterate(I=>V(I)?F(I):!0))}map(V){return new ie(F=>this.iterate(I=>F(V(I))))}some(V){let F=!1;return this.iterate(I=>(F=V(I),!F)),F}findFirst(V){let F;return this.iterate(I=>V(I)?(F=I,!1):!0),F}findLast(V){let F;return this.iterate(I=>(V(I)&&(F=I),!0)),F}findLastMaxBy(V){let F,I=!0;return this.iterate(W=>((I||K.isGreaterThan(V(W,F)))&&(I=!1,F=W),!0)),F}}e.$ac=ie;class ne{constructor(V){this.c=V}static createSortPermutation(V,F){const I=Array.from(V.keys()).sort((W,x)=>F(V[W],V[x]));return new ne(I)}apply(V){return V.map((F,I)=>V[this.c[I]])}inverse(){const V=this.c.slice();for(let F=0;F<this.c.length;F++)V[this.c[F]]=F;return new ne(V)}}e.$bc=ne}),define(fe[42],me([0,1,7]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=L,e.$fd=C,e.$gd=M,e.$hd=j,e.$id=P,e.$jd=h;function L(r,y){if(!r)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function C(r,y="Unreachable"){throw new Error(y)}function M(r){if(!r)throw new w.$cb("Assertion Failed")}function j(r){r||(0,w.$1)(new w.$cb("Soft Assertion Failed"))}function P(r){if(!r()){debugger;r(),(0,w.$1)(new w.$cb("Assertion Failed"))}}function h(r,y){let l=0;for(;l<r.length-1;){const E=r[l],o=r[l+1];if(!y(E,o))return!1;l++}return!0}}),define(fe[29],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=w;function w(L,C){const M=this;let j=!1,P;return function(){if(j)return P;if(j=!0,C)try{P=L.apply(M,arguments)}finally{C()}else P=L.apply(M,arguments);return P}}}),define(fe[43],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var w;(function(L){function C(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}L.is=C;const M=Object.freeze([]);function j(){return M}L.empty=j;function*P(t){yield t}L.single=P;function h(t){return C(t)?t:P(t)}L.wrap=h;function r(t){return t||M}L.from=r;function*y(t){for(let c=t.length-1;c>=0;c--)yield t[c]}L.reverse=y;function l(t){return!t||t[Symbol.iterator]().next().done===!0}L.isEmpty=l;function E(t){return t[Symbol.iterator]().next().value}L.first=E;function o(t,c){for(const S of t)if(c(S))return!0;return!1}L.some=o;function a(t,c){for(const S of t)if(c(S))return S}L.find=a;function*g(t,c){for(const S of t)c(S)&&(yield S)}L.filter=g;function*f(t,c){let S=0;for(const p of t)yield c(p,S++)}L.map=f;function*n(...t){for(const c of t)yield*c}L.concat=n;function s(t,c,S){let p=S;for(const D of t)p=c(p,D);return p}L.reduce=s;function*d(t,c,S=t.length){for(c<0&&(c+=t.length),S<0?S+=t.length:S>t.length&&(S=t.length);c<S;c++)yield t[c]}L.slice=d;function v(t,c=Number.POSITIVE_INFINITY){const S=[];if(c===0)return[S,t];const p=t[Symbol.iterator]();for(let D=0;D<c;D++){const k=p.next();if(k.done)return[S,L.empty()];S.push(k.value)}return[S,{[Symbol.iterator](){return p}}]}L.consume=v;async function i(t){const c=[];for await(const S of t)c.push(S);return Promise.resolve(c)}L.asyncToArray=i})(w||(e.Iterable=w={}))}),define(fe[22],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class w{constructor(C){this.d=C,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(C){this.c=C}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=w}),define(fe[44],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class w{static{this.Undefined=new w(void 0)}constructor(M){this.element=M,this.next=w.Undefined,this.prev=w.Undefined}}class L{constructor(){this.a=w.Undefined,this.b=w.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===w.Undefined}clear(){let M=this.a;for(;M!==w.Undefined;){const j=M.next;M.prev=w.Undefined,M.next=w.Undefined,M=j}this.a=w.Undefined,this.b=w.Undefined,this.c=0}unshift(M){return this.d(M,!1)}push(M){return this.d(M,!0)}d(M,j){const P=new w(M);if(this.a===w.Undefined)this.a=P,this.b=P;else if(j){const r=this.b;this.b=P,P.prev=r,r.next=P}else{const r=this.a;this.a=P,P.next=r,r.prev=P}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(P))}}shift(){if(this.a!==w.Undefined){const M=this.a.element;return this.e(this.a),M}}pop(){if(this.b!==w.Undefined){const M=this.b.element;return this.e(this.b),M}}e(M){if(M.prev!==w.Undefined&&M.next!==w.Undefined){const j=M.prev;j.next=M.next,M.next.prev=j}else M.prev===w.Undefined&&M.next===w.Undefined?(this.a=w.Undefined,this.b=w.Undefined):M.next===w.Undefined?(this.b=this.b.prev,this.b.next=w.Undefined):M.prev===w.Undefined&&(this.a=this.a.next,this.a.prev=w.Undefined);this.c-=1}*[Symbol.iterator](){let M=this.a;for(;M!==w.Undefined;)yield M.element,M=M.next}}e.$6c=L}),define(fe[25],me([0,1]),function(ae,e){"use strict";var w,L,C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=M,e.$zc=j,e.$Ac=P,e.$Jc=v;function M(i,t,c){let S=i.get(t);return S===void 0&&(S=c,i.set(t,S)),S}function j(i){const t=[];return i.forEach((c,S)=>{t.push(`${S} => ${c}`)}),`Map(${i.size}) {${t.join(", ")}}`}function P(i){const t=[];return i.forEach(c=>{t.push(c)}),`Set(${i.size}) {${t.join(", ")}}`}class h{constructor(t,c){this.uri=t,this.value=c}}function r(i){return Array.isArray(i)}class y{static{this.c=t=>t.toString()}constructor(t,c){if(this[w]="ResourceMap",t instanceof y)this.d=new Map(t.d),this.e=c??y.c;else if(r(t)){this.d=new Map,this.e=c??y.c;for(const[S,p]of t)this.set(S,p)}else this.d=new Map,this.e=t??y.c}set(t,c){return this.d.set(this.e(t),new h(t,c)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,c){typeof c<"u"&&(t=t.bind(c));for(const[S,p]of this.d)t(p.value,p.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=y;class l{constructor(t,c){this[L]="ResourceSet",!t||typeof t=="function"?this.c=new y(t):(this.c=new y(c),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,c){this.c.forEach((S,p)=>t.call(c,p,p,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=l;var E;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(E||(e.Touch=E={}));class o{constructor(){this[C]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,c=0){const S=this.c.get(t);if(S)return c!==0&&this.m(S,c),S.value}set(t,c,S=0){let p=this.c.get(t);if(p)p.value=c,S!==0&&this.m(p,S);else{switch(p={key:t,value:c,next:void 0,previous:void 0},S){case 0:this.k(p);break;case 1:this.j(p);break;case 2:this.k(p);break;default:this.k(p);break}this.c.set(t,p),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const c=this.c.get(t);if(c)return this.c.delete(t),this.l(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,c){const S=this.g;let p=this.d;for(;p;){if(c?t.bind(c)(p.value,p.key,this):t(p.value,p.key,this),this.g!==S)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const t=this,c=this.g;let S=this.d;const p={[Symbol.iterator](){return p},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(S){const D={value:S.key,done:!1};return S=S.next,D}else return{value:void 0,done:!0}}};return p}values(){const t=this,c=this.g;let S=this.d;const p={[Symbol.iterator](){return p},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(S){const D={value:S.value,done:!1};return S=S.next,D}else return{value:void 0,done:!0}}};return p}entries(){const t=this,c=this.g;let S=this.d;const p={[Symbol.iterator](){return p},next(){if(t.g!==c)throw new Error("LinkedMap got modified during iteration.");if(S){const D={value:[S.key,S.value],done:!1};return S=S.next,D}else return{value:void 0,done:!0}}};return p}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.d,S=this.size;for(;c&&S>t;)this.c.delete(c.key),c=c.next,S--;this.d=c,this.f=S,c&&(c.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let c=this.e,S=this.size;for(;c&&S>t;)this.c.delete(c.key),c=c.previous,S--;this.e=c,this.f=S,c&&(c.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const c=t.next,S=t.previous;if(!c||!S)throw new Error("Invalid list");c.previous=S,S.next=c}t.next=void 0,t.previous=void 0,this.g++}m(t,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(t===this.d)return;const S=t.next,p=t.previous;t===this.e?(p.next=void 0,this.e=p):(S.previous=p,p.next=S),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(c===2){if(t===this.e)return;const S=t.next,p=t.previous;t===this.d?(S.previous=void 0,this.d=S):(S.previous=p,p.next=S),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((c,S)=>{t.push([S,c])}),t}fromJSON(t){this.clear();for(const[c,S]of t)this.set(c,S)}}e.$Dc=o;class a extends o{constructor(t,c=1){super(),this.n=t,this.o=Math.min(Math.max(0,c),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,c=2){return super.get(t,c)}peek(t){return super.get(t,0)}set(t,c){return super.set(t,c,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class g extends a{constructor(t,c=1){super(t,c)}q(t){this.h(t)}set(t,c){return super.set(t,c),this.p(),this}}e.$Ec=g;class f extends a{constructor(t,c=1){super(t,c)}q(t){this.i(t)}set(t,c){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,c),this}}e.$Fc=f;class n{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let c=this.c.get(t)||0;return c===0?!1:(c--,c===0?this.c.delete(t):this.c.set(t,c),!0)}has(t){return this.c.has(t)}}e.$Gc=n;class s{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[c,S]of t)this.set(c,S)}clear(){this.c.clear(),this.d.clear()}set(t,c){this.c.set(t,c),this.d.set(c,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const c=this.c.get(t);return c===void 0?!1:(this.c.delete(t),this.d.delete(c),!0)}forEach(t,c){this.c.forEach((S,p)=>{t.call(c,S,p,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=s;class d{constructor(){this.c=new Map}add(t,c){let S=this.c.get(t);S||(S=new Set,this.c.set(t,S)),S.add(c)}delete(t,c){const S=this.c.get(t);S&&(S.delete(c),S.size===0&&this.c.delete(t))}forEach(t,c){const S=this.c.get(t);S&&S.forEach(c)}get(t){const c=this.c.get(t);return c||new Set}}e.$Ic=d;function v(i,t){if(i===t)return!0;if(i.size!==t.size)return!1;for(const[c,S]of i)if(!t.has(c)||t.get(c)!==S)return!1;for(const[c]of t)if(!i.has(c))return!1;return!0}}),define(fe[2],me([0,1,16,41,25,29,43]),function(ae,e,w,L,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=y,e.$Mc=l,e.$Nc=E,e.$Oc=g,e.$Pc=f,e.$Qc=n,e.$Rc=s,e.$Sc=d,e.$Tc=v,e.$4c=Z;const P=!1;let h=null;class r{constructor(){this.b=new Map}static{this.a=0}c(m){let O=this.b.get(m);return O||(O={parent:null,source:null,isSingleton:!1,value:m,idx:r.a++},this.b.set(m,O)),O}trackDisposable(m){const O=this.c(m);O.source||(O.source=new Error().stack)}setParent(m,O){const $=this.c(m);$.parent=O}markAsDisposed(m){this.b.delete(m)}markAsSingleton(m){this.c(m).isSingleton=!0}f(m,O){const $=O.get(m);if($)return $;const A=m.parent?this.f(this.c(m.parent),O):m;return O.set(m,A),A}getTrackedDisposables(){const m=new Map;return[...this.b.entries()].filter(([,$])=>$.source!==null&&!this.f($,m).isSingleton).flatMap(([$])=>$)}computeLeakingDisposables(m=10,O){let $;if(O)$=O;else{const ee=new Map,ce=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,ee).isSingleton);if(ce.length===0)return;const ue=new Set(ce.map(X=>X.value));if($=ce.filter(X=>!(X.parent&&ue.has(X.parent))),$.length===0)throw new Error("There are cyclic diposable chains!")}if(!$)return;function A(ee){function ce(X,q){for(;X.length>0&&q.some(Q=>typeof Q=="string"?Q===X[0]:X[0].match(Q));)X.shift()}const ue=ee.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return ce(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const Y=new C.$Ic;for(const ee of $){const ce=A(ee);for(let ue=0;ue<=ce.length;ue++)Y.add(ce.slice(0,ue).join(`
`),ee)}$.sort((0,w.$7b)(ee=>ee.idx,w.$9b));let te="",G=0;for(const ee of $.slice(0,m)){G++;const ce=A(ee),ue=[];for(let X=0;X<ce.length;X++){let q=ce[X];q=`(shared with ${Y.get(ce.slice(0,X+1).join(`
`)).size}/${$.length} leaks) at ${q}`;const K=Y.get(ce.slice(0,X).join(`
`)),de=(0,L.$K)([...K].map(B=>A(B)[X]),B=>B);delete de[ce[X]];for(const[B,le]of Object.entries(de))ue.unshift(`    - stacktraces of ${le.length} other leaks continue with ${B}`);ue.unshift(q)}te+=`


==================== Leaking disposable ${G}/${$.length}: ${ee.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return $.length>m&&(te+=`


... and ${$.length-m} more leaking disposables

`),{leaks:$,details:te}}}e.$Kc=r;function y(R){h=R}if(P){const R="__is_disposable_tracked__";y(new class{trackDisposable(m){const O=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[R]||console.log(O)},3e3)}setParent(m,O){if(m&&m!==t.None)try{m[R]=!0}catch{}}markAsDisposed(m){if(m&&m!==t.None)try{m[R]=!0}catch{}}markAsSingleton(m){}})}function l(R){return h?.trackDisposable(R),R}function E(R){h?.markAsDisposed(R)}function o(R,m){h?.setParent(R,m)}function a(R,m){if(h)for(const O of R)h.setParent(O,m)}function g(R){return h?.markAsSingleton(R),R}function f(R){return typeof R=="object"&&R!==null&&typeof R.dispose=="function"&&R.dispose.length===0}function n(R){if(j.Iterable.is(R)){const m=[];for(const O of R)if(O)try{O.dispose()}catch($){m.push($)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(R)?[]:R}else if(R)return R.dispose(),R}function s(R){for(const m of R)f(m)&&m.dispose();return[]}function d(...R){const m=v(()=>n(R));return a(R,m),m}function v(R){const m=l({dispose:(0,M.$db)(()=>{E(m),R()})});return m}class i{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,l(this)}dispose(){this.g||(E(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{n(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return o(m,this),this.g?i.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}delete(m){if(m){if(m===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(m),m.dispose()}}deleteAndLeak(m){m&&this.f.has(m)&&(this.f.delete(m),o(m,null))}}e.$Uc=i;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new i,l(this),o(this.q,this)}dispose(){E(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}e.$Vc=t;class c{constructor(){this.b=!1,l(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&o(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,E(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&o(m,null),m}}e.$Wc=c;class S{constructor(m){this.a=new c,this.b=!1,this.a.value=m}get value(){return this.a.value}set value(m){this.b||m===this.a.value||(this.a.value=m)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=S;class p{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=p;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,l(this)}set(m){let O=m;return this.unset=()=>O=void 0,this.isset=()=>O!==void 0,this.dispose=()=>{O&&(O(),O=void 0,E(this))},this}}e.$Zc=D;class k{constructor(){this.a=new Map}acquire(m,...O){let $=this.a.get(m);$||($={counter:0,object:this.b(m,...O)},this.a.set(m,$));const{object:A}=$,Y=(0,M.$db)(()=>{--$.counter===0&&(this.c(m,$.object),this.a.delete(m))});return $.counter++,{object:A,dispose:Y}}}e.$1c=k;class b{constructor(m){this.a=m}async acquire(m,...O){const $=this.a.acquire(m,...O);try{return{object:await $.object,dispose:()=>$.dispose()}}catch(A){throw $.dispose(),A}}}e.$2c=b;class z{constructor(m){this.object=m}dispose(){}}e.$3c=z;function Z(R){const m=new i;try{R(m)}finally{m.dispose()}}class T{constructor(){this.a=new Map,this.b=!1,l(this)}dispose(){E(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{n(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get size(){return this.a.size}get(m){return this.a.get(m)}set(m,O,$=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),$||this.a.get(m)?.dispose(),this.a.set(m,O)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=T}),define(fe[45],me([0,1,25]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=C,e.$cm=j;const L=new w.$Ec(1e4);function C(r){return h(r,"NFC",L)}const M=new w.$Ec(1e4);function j(r){return h(r,"NFD",M)}const P=/[^\u0000-\u0080]/;function h(r,y,l){if(!r)return r;const E=l.get(r);if(E)return E;let o;return P.test(r)?o=r.normalize(y):o=r,l.set(r,o),o}e.$dm=function(){const r=/[\u0300-\u036f]/g;return function(y){return j(y).replace(r,"")}}()}),function(){function ae(C){const M=[];typeof C=="number"&&M.push("code/timeOrigin",C);function j(h){M.push(h,Date.now())}function P(){const h=[];for(let r=0;r<M.length;r+=2)h.push({name:M[r],startTime:M[r+1]});return h}return{mark:j,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const j of performance.getEntriesByType("mark"))M.push({name:j.name,startTime:Math.round(C+j.startTime)});return M}};if(typeof process=="object"){const C=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function w(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return w(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=w(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=w(L))}(),define(fe[46],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const w=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(M){return new L(M)}constructor(M){this.c=w&&M===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=L}),define(fe[4],me([0,1,7,29,2,44,46]),function(ae,e,w,L,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=o;const P=!1,h=!1,r=!1;var y;(function(O){O.None=()=>C.$Vc.None;function $(re){if(r){const{onDidAddListener:he}=re,pe=g.create();let $e=0;re.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),pe.print()),he?.()}}}function A(re,he){return K(re,()=>{},0,void 0,!0,void 0,he)}O.defer=A;function Y(re){return(he,pe=null,$e)=>{let ye=!1,ve;return ve=re(ke=>{if(!ye)return ve?ve.dispose():ye=!0,he.call(pe,ke)},null,$e),ye&&ve.dispose(),ve}}O.once=Y;function te(re,he,pe){return q(($e,ye=null,ve)=>re(ke=>$e.call(ye,he(ke)),null,ve),pe)}O.map=te;function G(re,he,pe){return q(($e,ye=null,ve)=>re(ke=>{he(ke),$e.call(ye,ke)},null,ve),pe)}O.forEach=G;function ee(re,he,pe){return q(($e,ye=null,ve)=>re(ke=>he(ke)&&$e.call(ye,ke),null,ve),pe)}O.filter=ee;function ce(re){return re}O.signal=ce;function ue(...re){return(he,pe=null,$e)=>{const ye=(0,C.$Sc)(...re.map(ve=>ve(ke=>he.call(pe,ke))));return Q(ye,$e)}}O.any=ue;function X(re,he,pe,$e){let ye=pe;return te(re,ve=>(ye=he(ye,ve),ye),$e)}O.reduce=X;function q(re,he){let pe;const $e={onWillAddFirstListener(){pe=re(ye.fire,ye)},onDidRemoveLastListener(){pe?.dispose()}};he||$($e);const ye=new i($e);return he?.add(ye),ye.event}function Q(re,he){return he instanceof Array?he.push(re):he&&he.add(re),re}function K(re,he,pe=100,$e=!1,ye=!1,ve,ke){let Ee,Pe,Oe,De=0,Fe;const Be={leakWarningThreshold:ve,onWillAddFirstListener(){Ee=re(We=>{De++,Pe=he(Pe,We),$e&&!Oe&&(ze.fire(Pe),Pe=void 0),Fe=()=>{const qe=Pe;Pe=void 0,Oe=void 0,(!$e||De>1)&&ze.fire(qe),De=0},typeof pe=="number"?(clearTimeout(Oe),Oe=setTimeout(Fe,pe)):Oe===void 0&&(Oe=0,queueMicrotask(Fe))})},onWillRemoveListener(){ye&&De>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,Ee.dispose()}};ke||$(Be);const ze=new i(Be);return ke?.add(ze),ze.event}O.debounce=K;function de(re,he=0,pe){return O.debounce(re,($e,ye)=>$e?($e.push(ye),$e):[ye],he,void 0,!0,void 0,pe)}O.accumulate=de;function B(re,he=($e,ye)=>$e===ye,pe){let $e=!0,ye;return ee(re,ve=>{const ke=$e||!he(ve,ye);return $e=!1,ye=ve,ke},pe)}O.latch=B;function le(re,he,pe){return[O.filter(re,he,pe),O.filter(re,$e=>!he($e),pe)]}O.split=le;function _(re,he=!1,pe=[],$e){let ye=pe.slice(),ve=re(Pe=>{ye?ye.push(Pe):Ee.fire(Pe)});$e&&$e.add(ve);const ke=()=>{ye?.forEach(Pe=>Ee.fire(Pe)),ye=null},Ee=new i({onWillAddFirstListener(){ve||(ve=re(Pe=>Ee.fire(Pe)),$e&&$e.add(ve))},onDidAddFirstListener(){ye&&(he?setTimeout(ke):ke())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return $e&&$e.add(Ee),Ee.event}O.buffer=_;function u(re,he){return($e,ye,ve)=>{const ke=he(new ie);return re(function(Ee){const Pe=ke.evaluate(Ee);Pe!==N&&$e.call(ye,Pe)},void 0,ve)}}O.chain=u;const N=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(he){return this.f.push(he),this}forEach(he){return this.f.push(pe=>(he(pe),pe)),this}filter(he){return this.f.push(pe=>he(pe)?pe:N),this}reduce(he,pe){let $e=pe;return this.f.push(ye=>($e=he($e,ye),$e)),this}latch(he=(pe,$e)=>pe===$e){let pe=!0,$e;return this.f.push(ye=>{const ve=pe||!he(ye,$e);return pe=!1,$e=ye,ve?ye:N}),this}evaluate(he){for(const pe of this.f)if(he=pe(he),he===N)break;return he}}function ne(re,he,pe=$e=>$e){const $e=(...Ee)=>ke.fire(pe(...Ee)),ye=()=>re.on(he,$e),ve=()=>re.removeListener(he,$e),ke=new i({onWillAddFirstListener:ye,onDidRemoveLastListener:ve});return ke.event}O.fromNodeEventEmitter=ne;function H(re,he,pe=$e=>$e){const $e=(...Ee)=>ke.fire(pe(...Ee)),ye=()=>re.addEventListener(he,$e),ve=()=>re.removeEventListener(he,$e),ke=new i({onWillAddFirstListener:ye,onDidRemoveLastListener:ve});return ke.event}O.fromDOMEventEmitter=H;function V(re){return new Promise(he=>Y(re)(he))}O.toPromise=V;function F(re){const he=new i;return re.then(pe=>{he.fire(pe)},()=>{he.fire(void 0)}).finally(()=>{he.dispose()}),he.event}O.fromPromise=F;function I(re,he,pe){return he(pe),re($e=>he($e))}O.runAndSubscribe=I;class W{constructor(he,pe){this._observable=he,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{he.addObserver(this)},onDidRemoveLastListener:()=>{he.removeObserver(this)}};pe||$($e),this.emitter=new i($e),pe&&pe.add(this.emitter)}beginUpdate(he){this.f++}handlePossibleChange(he){}handleChange(he,pe){this.g=!0}endUpdate(he){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function x(re,he){return new W(re,he).emitter.event}O.fromObservable=x;function se(re){return(he,pe,$e)=>{let ye=0,ve=!1;const ke={beginUpdate(){ye++},endUpdate(){ye--,ye===0&&(re.reportChanges(),ve&&(ve=!1,he.call(pe)))},handlePossibleChange(){},handleChange(){ve=!0}};re.addObserver(ke),re.reportChanges();const Ee={dispose(){re.removeObserver(ke)}};return $e instanceof C.$Uc?$e.add(Ee):Array.isArray($e)&&$e.push(Ee),Ee}}O.fromObservableLight=se})(y||(e.Event=y={}));class l{static{this.all=new Set}static{this.f=0}constructor($){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${$}_${l.f++}`,l.all.add(this)}start($){this.g=new j.$ae,this.listenerCount=$}stop(){if(this.g){const $=this.g.elapsed();this.durations.push($),this.elapsedOverall+=$,this.invocationCount+=1,this.g=void 0}}}e.$ce=l;let E=-1;function o(O){const $=E;return E=O,{dispose(){E=$}}}class a{constructor($,A=Math.random().toString(18).slice(2,5)){this.threshold=$,this.name=A,this.g=0}dispose(){this.f?.clear()}check($,A){const Y=this.threshold;if(Y<=0||A<Y)return;this.f||(this.f=new Map);const te=this.f.get($.value)||0;if(this.f.set($.value,te+1),this.g-=1,this.g<=0){this.g=Y*.5;let G,ee=0;for(const[ce,ue]of this.f)(!G||ee<ue)&&(G=ce,ee=ue);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${ee}):`),console.warn(G)}return()=>{const G=this.f.get($.value)||0;this.f.set($.value,G-1)}}}class g{static create(){return new g(new Error().stack??"")}constructor($){this.value=$}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class n{constructor($){this.value=$,this.id=f++}}const s=2,d=(O,$)=>{if(O instanceof n)$(O);else for(let A=0;A<O.length;A++){const Y=O[A];Y&&$(Y)}},v=P?new FinalizationRegistry(O=>{typeof O=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(O))}):void 0;class i{constructor($){this.w=0,this.f=$,this.g=E>0||this.f?.leakWarningThreshold?new a(this.f?.leakWarningThreshold??E):void 0,this.j=this.f?._profName?new l(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const $=this.t;queueMicrotask(()=>{d($,A=>A.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=($,A,Y)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),C.$Vc.None;if(this.m)return C.$Vc.None;A&&($=$.bind(A));const te=new n($);let G,ee;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=g.create(),G=this.g.check(te.stack,this.w+1)),h&&(te.stack=ee??g.create()),this.t?this.t instanceof n?(this.u??=new c,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const ce=(0,C.$Tc)(()=>{v?.unregister(ce),G?.(),this.x(te)});if(Y instanceof C.$Uc?Y.add(ce):Array.isArray(Y)&&Y.push(ce),v){const ue=new Error().stack.split(`
`).slice(2).join(`
`).trim();v.register(ce,ue,ce)}return ce},this.q}x($){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const A=this.t,Y=A.indexOf($);if(Y===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,A[Y]=void 0;const te=this.u.current===this;if(this.w*s<=A.length){let G=0;for(let ee=0;ee<A.length;ee++)A[ee]?A[G++]=A[ee]:te&&(this.u.end--,G<this.u.i&&this.u.i--);A.length=G}}y($,A){if(!$)return;const Y=this.f?.onListenerError||w.$1;if(!Y){$.value(A);return}try{$.value(A)}catch(te){Y(te)}}z($){const A=$.current.t;for(;$.i<$.end;)this.y(A[$.i++],$.value);$.reset()}fire($){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof n)this.y(this.t,$);else{const A=this.u;A.enqueue(this,$,this.t.length),this.z(A)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=i;const t=()=>new c;e.$fe=t;class c{constructor(){this.i=-1,this.end=0}enqueue($,A,Y){this.i=0,this.end=Y,this.current=$,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class S extends i{async fireAsync($,A,Y){if(this.t)for(this.h||(this.h=new M.$6c),d(this.t,te=>this.h.push([te.value,$]));this.h.size>0&&!A.isCancellationRequested;){const[te,G]=this.h.shift(),ee=[],ce={...G,token:A,waitUntil:ue=>{if(Object.isFrozen(ee))throw new Error("waitUntil can NOT be called asynchronous");Y&&(ue=Y(ue,te)),ee.push(ue)}};try{te(ce)}catch(ue){(0,w.$1)(ue);continue}Object.freeze(ee),await Promise.allSettled(ee).then(ue=>{for(const X of ue)X.status==="rejected"&&(0,w.$1)(X.reason)})}}}e.$ge=S;class p extends i{get isPaused(){return this.h!==0}constructor($){super($),this.h=0,this.s=new M.$6c,this.A=$?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const $=Array.from(this.s);this.s.clear(),super.fire(this.A($))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire($){this.w&&(this.h!==0?this.s.push($):super.fire($))}}e.$he=p;class D extends p{constructor($){super($),this.k=$.delay??100}fire($){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire($)}}e.$ie=D;class k extends i{constructor($){super($),this.h=[],this.k=$?.merge}fire($){this.hasListeners()&&(this.h.push($),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$je=k;class b{constructor(){this.g=!1,this.h=[],this.f=new i({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add($){const A={event:$,listener:null};this.h.push(A),this.g&&this.m(A);const Y=()=>{this.g&&this.o(A);const te=this.h.indexOf(A);this.h.splice(te,1)};return(0,C.$Tc)((0,L.$db)(Y))}j(){this.g=!0,this.h.forEach($=>this.m($))}k(){this.g=!1,this.h.forEach($=>this.o($))}m($){$.listener=$.event(A=>this.f.fire(A))}o($){$.listener?.dispose(),$.listener=null}dispose(){this.f.dispose();for(const $ of this.h)$.listener?.dispose();this.h=[]}}e.$ke=b;class z{constructor($,A,Y,te){this.f=new C.$Uc;const G=this.f.add(new b),ee=this.f.add(new C.$5c);function ce(ue){ee.set(ue,G.add(te(ue)))}for(const ue of $)ce(ue);this.f.add(A(ue=>{ce(ue)})),this.f.add(Y(ue=>{ee.deleteAndDispose(ue)})),this.event=G.event}dispose(){this.f.dispose()}}e.$le=z;class Z{constructor(){this.f=[]}wrapEvent($){return(A,Y,te)=>$(G=>{const ee=this.f[this.f.length-1];ee?ee.push(()=>A.call(Y,G)):A.call(Y,G)},void 0,te)}bufferEvents($){const A=[];this.f.push(A);const Y=$();return this.f.pop(),A.forEach(te=>te()),Y}}e.$me=Z;class T{constructor(){this.f=!1,this.g=y.None,this.h=C.$Vc.None,this.j=new i({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input($){this.g=$,this.f&&(this.h.dispose(),this.h=$(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=T;class R{static const($){return new m($)}constructor($){this.g=$,this.f=new i,this.onDidChange=this.f.event}get value(){return this.g}set value($){$!==this.g&&(this.g=$,this.f.fire(void 0))}}e.$oe=R;class m{constructor($){this.value=$,this.onDidChange=y.None}}}),define(fe[17],me([0,1,4]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=P;const L=Object.freeze(function(h,r){const y=setTimeout(h.bind(r),0);return{dispose(){clearTimeout(y)}}});var C;(function(h){function r(y){return y===h.None||y===h.Cancelled||y instanceof M?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}h.isCancellationToken=r,h.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:w.Event.None}),h.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(C||(e.CancellationToken=C={}));class M{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new w.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(r){this.f=void 0,this.g=void 0,this.g=r&&r.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new M),this.f}cancel(){this.f?this.f instanceof M&&this.f.cancel():this.f=C.Cancelled}dispose(r=!1){r&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof M&&this.f.dispose():this.f=C.None}}e.$pe=j;function P(h){const r=new j;return h.add({dispose(){r.cancel()}}),r.token}}),define(fe[47],me([0,1,17]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=C;class L{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new w.$pe,r=this.b(h.token);return this.a={promise:r,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}e.$2e=L;function C(P){return P}class M{constructor(h,r){this.a=void 0,this.b=void 0,typeof h=="function"?(this.c=h,this.d=C):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);return this.b!==r&&(this.b=r,this.a=this.c(h)),this.a}}e.$4e=M;class j{get cachedValues(){return this.a}constructor(h,r){this.a=new Map,this.b=new Map,typeof h=="function"?(this.c=h,this.d=C):(this.c=r,this.d=h.getCacheKey)}get(h){const r=this.d(h);if(this.b.has(r))return this.b.get(r);const y=this.c(h);return this.a.set(h,y),this.b.set(r,y),y}}e.$5e=j}),define(fe[48],me([0,1,7,2]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=C,e.$se=M,e.$te=j,e.$ue=P,e.$ve=r,e.$we=y,e.$xe=l,e.$ye=E,e.$ze=o,e.$Ae=a,e.$Be=g,e.$Ce=f,e.$De=n,e.$Ee=s,e.$Fe=d;function C(v){const i=v;return i?typeof i.read=="function":!1}function M(v){const i=v;return i?[i.on,i.pause,i.resume,i.destroy].every(t=>typeof t=="function"):!1}function j(v){const i=v;return i?M(i.stream)&&Array.isArray(i.buffer)&&typeof i.ended=="boolean":!1}function P(v,i){return new h(v,i)}class h{constructor(i,t){this.e=i,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(i){if(!this.a.destroyed){if(this.a.flowing)this.g(i);else if(this.b.data.push(i),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(i){this.a.destroyed||(this.a.flowing?this.h(i):this.b.error.push(i))}end(i){this.a.destroyed||(typeof i<"u"&&this.write(i),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(i){this.c.data.slice(0).forEach(t=>t(i))}h(i){this.c.error.length===0?(0,w.$1)(i):this.c.error.slice(0).forEach(t=>t(i))}i(){this.c.end.slice(0).forEach(i=>i())}on(i,t){if(!this.a.destroyed)switch(i){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(i,t){if(this.a.destroyed)return;let c;switch(i){case"data":c=this.c.data;break;case"end":c=this.c.end;break;case"error":c=this.c.error;break}if(c){const S=c.indexOf(t);S>=0&&c.splice(S,1)}}j(){if(this.b.data.length>0){const i=this.e(this.b.data);this.g(i),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(c=>c())}}k(){if(this.c.error.length>0){for(const i of this.b.error)this.h(i);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function r(v,i){const t=[];let c;for(;(c=v.read())!==null;)t.push(c);return i(t)}function y(v,i,t){const c=[];let S;for(;(S=v.read())!==null&&c.length<t;)c.push(S);return S===null&&c.length>0?i(c):{read:()=>{if(c.length>0)return c.shift();if(typeof S<"u"){const p=S;return S=void 0,p}return v.read()}}}function l(v,i){return new Promise((t,c)=>{const S=[];E(v,{onData:p=>{i&&S.push(p)},onError:p=>{i?c(p):t(void 0)},onEnd:()=>{t(i?i(S):void 0)}})})}function E(v,i,t){v.on("error",c=>{t?.isCancellationRequested||i.onError(c)}),v.on("end",()=>{t?.isCancellationRequested||i.onEnd()}),v.on("data",c=>{t?.isCancellationRequested||i.onData(c)})}function o(v,i){return new Promise((t,c)=>{const S=new L.$Uc,p=[],D=z=>{if(p.push(z),p.length>i)return S.dispose(),v.pause(),t({stream:v,buffer:p,ended:!1})},k=z=>(S.dispose(),c(z)),b=()=>(S.dispose(),t({stream:v,buffer:p,ended:!0}));S.add((0,L.$Tc)(()=>v.removeListener("error",k))),v.on("error",k),S.add((0,L.$Tc)(()=>v.removeListener("end",b))),v.on("end",b),S.add((0,L.$Tc)(()=>v.removeListener("data",D))),v.on("data",D)})}function a(v,i){const t=P(i);return t.end(v),t}function g(){const v=P(()=>{throw new Error("not supported")});return v.end(),v}function f(v){let i=!1;return{read:()=>i?null:(i=!0,v)}}function n(v,i,t){const c=P(t);return E(v,{onData:S=>c.write(i.data(S)),onError:S=>c.error(i.error?i.error(S):S),onEnd:()=>c.end()}),c}function s(v,i,t){let c=!1;return{read:()=>{const S=i.read();return c?S:(c=!0,S!==null?t([v,S]):v)}}}function d(v,i,t){let c=!1;const S=P(t);return E(i,{onData:p=>c?S.write(p):(c=!0,S.write(t([v,p]))),onError:p=>S.error(p),onEnd:()=>{c||(c=!0,S.write(v)),S.end()}}),S}}),define(fe[18],me([0,1,22,48]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=r,e.$Ie=y,e.$Je=l,e.$Ke=E,e.$Le=o,e.$Me=a,e.$Ne=g,e.$Oe=f,e.$Pe=n,e.$Qe=s,e.$Re=d,e.$Se=v,e.$Te=i,e.$Ue=t,e.$Ve=c,e.$We=S,e.$Xe=p,e.$Ye=D,e.$Ze=k,e.$1e=Z;const C=typeof Buffer<"u",M=new w.$V(()=>new Uint8Array(256));let j,P;class h{static alloc(R){return C?new h(Buffer.allocUnsafe(R)):new h(new Uint8Array(R))}static wrap(R){return C&&!Buffer.isBuffer(R)&&(R=Buffer.from(R.buffer,R.byteOffset,R.byteLength)),new h(R)}static fromString(R,m){return!(m?.dontUseNodeBuffer||!1)&&C?new h(Buffer.from(R)):(j||(j=new TextEncoder),new h(j.encode(R)))}static fromByteArray(R){const m=h.alloc(R.length);for(let O=0,$=R.length;O<$;O++)m.buffer[O]=R[O];return m}static concat(R,m){if(typeof m>"u"){m=0;for(let A=0,Y=R.length;A<Y;A++)m+=R[A].byteLength}const O=h.alloc(m);let $=0;for(let A=0,Y=R.length;A<Y;A++){const te=R[A];O.set(te,$),$+=te.byteLength}return O}constructor(R){this.buffer=R,this.byteLength=this.buffer.byteLength}clone(){const R=h.alloc(this.byteLength);return R.set(this),R}toString(){return C?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(R,m){return new h(this.buffer.subarray(R,m))}set(R,m){if(R instanceof h)this.buffer.set(R.buffer,m);else if(R instanceof Uint8Array)this.buffer.set(R,m);else if(R instanceof ArrayBuffer)this.buffer.set(new Uint8Array(R),m);else if(ArrayBuffer.isView(R))this.buffer.set(new Uint8Array(R.buffer,R.byteOffset,R.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(R){return E(this.buffer,R)}writeUInt32BE(R,m){o(this.buffer,R,m)}readUInt32LE(R){return a(this.buffer,R)}writeUInt32LE(R,m){g(this.buffer,R,m)}readUInt8(R){return f(this.buffer,R)}writeUInt8(R,m){n(this.buffer,R,m)}indexOf(R,m=0){return r(this.buffer,R instanceof h?R.buffer:R,m)}}e.$Ge=h;function r(T,R,m=0){const O=R.byteLength,$=T.byteLength;if(O===0)return 0;if(O===1)return T.indexOf(R[0]);if(O>$-m)return-1;const A=M.value;A.fill(R.length);for(let ee=0;ee<R.length;ee++)A[R[ee]]=R.length-ee-1;let Y=m+R.length-1,te=Y,G=-1;for(;Y<$;)if(T[Y]===R[te]){if(te===0){G=Y;break}Y--,te--}else Y+=Math.max(R.length-te,A[T[Y]]),te=R.length-1;return G}function y(T,R){return T[R+0]<<0>>>0|T[R+1]<<8>>>0}function l(T,R,m){T[m+0]=R&255,R=R>>>8,T[m+1]=R&255}function E(T,R){return T[R]*2**24+T[R+1]*2**16+T[R+2]*2**8+T[R+3]}function o(T,R,m){T[m+3]=R,R=R>>>8,T[m+2]=R,R=R>>>8,T[m+1]=R,R=R>>>8,T[m]=R}function a(T,R){return T[R+0]<<0>>>0|T[R+1]<<8>>>0|T[R+2]<<16>>>0|T[R+3]<<24>>>0}function g(T,R,m){T[m+0]=R&255,R=R>>>8,T[m+1]=R&255,R=R>>>8,T[m+2]=R&255,R=R>>>8,T[m+3]=R&255}function f(T,R){return T[R]}function n(T,R,m){T[m]=R}function s(T){return L.$ve(T,R=>h.concat(R))}function d(T){return L.$Ce(T)}function v(T){return L.$xe(T,R=>h.concat(R))}async function i(T){return T.ended?h.concat(T.buffer):h.concat([...T.buffer,await v(T.stream)])}function t(T){return L.$Ae(T,R=>h.concat(R))}function c(T){return L.$De(T,{data:R=>typeof R=="string"?h.fromString(R):h.wrap(R)},R=>h.concat(R))}function S(T){return L.$ue(R=>h.concat(R),T)}function p(T,R){return L.$Ee(T,R,m=>h.concat(m))}function D(T,R){return L.$Fe(T,R,m=>h.concat(m))}function k(T){let R=0,m=0,O=0;const $=new Uint8Array(Math.floor(T.length/4*3)),A=te=>{switch(m){case 3:$[O++]=R|te,m=0;break;case 2:$[O++]=R|te>>>2,R=te<<6,m=3;break;case 1:$[O++]=R|te>>>4,R=te<<4,m=2;break;default:R=te<<2,m=1}};for(let te=0;te<T.length;te++){const G=T.charCodeAt(te);if(G>=65&&G<=90)A(G-65);else if(G>=97&&G<=122)A(G-97+26);else if(G>=48&&G<=57)A(G-48+52);else if(G===43||G===45)A(62);else if(G===47||G===95)A(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${T[te]}`)}}const Y=O;for(;m>0;)A(0);return h.wrap($).slice(0,Y)}const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",z="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function Z({buffer:T},R=!0,m=!1){const O=m?z:b;let $="";const A=T.byteLength%3;let Y=0;for(;Y<T.byteLength-A;Y+=3){const te=T[Y+0],G=T[Y+1],ee=T[Y+2];$+=O[te>>>2],$+=O[(te<<4|G>>>4)&63],$+=O[(G<<2|ee>>>6)&63],$+=O[ee&63]}if(A===1){const te=T[Y+0];$+=O[te>>>2],$+=O[te<<4&63],R&&($+="==")}else if(A===2){const te=T[Y+0],G=T[Y+1];$+=O[te>>>2],$+=O[(te<<4|G>>>4)&63],$+=O[G<<2&63],R&&($+="=")}return $}}),define(fe[12],me([0,1,47,22]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=C,e.$9e=j,e.$0e=h,e.$$e=r,e.$_e=y,e.$af=l,e.$bf=E,e.$cf=o,e.$df=a,e.$ef=g,e.$ff=f,e.$gf=n,e.$hf=s,e.$if=d,e.$jf=v,e.$kf=i,e.$lf=t,e.$mf=c,e.$nf=S,e.$of=p,e.$pf=D,e.$qf=k,e.$rf=b,e.$sf=z,e.$tf=Z,e.$uf=T,e.$vf=R,e.$wf=m,e.$xf=O,e.$yf=$,e.$zf=A,e.$Af=Y,e.$Bf=te,e.$Cf=G,e.$Df=ee,e.$Ef=ce,e.$Ff=ue,e.$If=K,e.$Jf=de,e.$Kf=B,e.$Lf=le,e.$Mf=N,e.$Nf=ne,e.$Pf=H,e.$Qf=V,e.$Rf=F,e.$Sf=I,e.$Tf=x,e.$Uf=se,e.$Wf=re,e.$Xf=he,e.$Yf=pe,e.$Zf=$e,e.$1f=ye,e.$2f=ve,e.$3f=ke,e.$4f=Ee,e.$5f=Be;function C(U){return!U||typeof U!="string"?!0:U.trim().length===0}const M=/{(\d+)}/g;function j(U,...J){return J.length===0?U:U.replace(M,function(oe,ge){const we=parseInt(ge,10);return isNaN(we)||we<0||we>=J.length?oe:J[we]})}const P=/{([^}]+)}/g;function h(U,J){return Object.keys(J).length===0?U:U.replace(P,(oe,ge)=>J[ge]??oe)}function r(U){return U.replace(/[<>"'&]/g,J=>{switch(J){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return J})}function y(U){return U.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}function l(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function E(U,J){let oe=0;const ge=J.charCodeAt(0);for(let we=U.length-1;we>=0;we--)U.charCodeAt(we)===ge&&oe++;return oe}function o(U,J,oe="\u2026"){return U.length<=J?U:`${U.substr(0,J)}${oe}`}function a(U,J,oe="\u2026"){if(U.length<=J)return U;const ge=Math.ceil(J/2)-oe.length/2,we=Math.floor(J/2)-oe.length/2;return`${U.substr(0,ge)}${oe}${U.substr(U.length-we)}`}function g(U,J=" "){const oe=f(U,J);return n(oe,J)}function f(U,J){if(!U||!J)return U;const oe=J.length;if(oe===0||U.length===0)return U;let ge=0;for(;U.indexOf(J,ge)===ge;)ge=ge+oe;return U.substring(ge)}function n(U,J){if(!U||!J)return U;const oe=J.length,ge=U.length;if(oe===0||ge===0)return U;let we=ge,Ce=-1;for(;Ce=U.lastIndexOf(J,we-1),!(Ce===-1||Ce+oe!==we);){if(Ce===0)return"";we=Ce}return U.substring(0,we)}function s(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function d(U){return U.replace(/\*/g,"")}function v(U,J,oe={}){if(!U)throw new Error("Cannot create regex from empty string");J||(U=l(U)),oe.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let ge="";return oe.global&&(ge+="g"),oe.matchCase||(ge+="i"),oe.multiline&&(ge+="m"),oe.unicode&&(ge+="u"),new RegExp(U,ge)}function i(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}function t(U){return U.split(/\r\n|\r|\n/)}function c(U){const J=[],oe=U.split(/(\r\n|\r|\n)/);for(let ge=0;ge<Math.ceil(oe.length/2);ge++)J.push(oe[2*ge]+(oe[2*ge+1]??""));return J}function S(U){for(let J=0,oe=U.length;J<oe;J++){const ge=U.charCodeAt(J);if(ge!==32&&ge!==9)return J}return-1}function p(U,J=0,oe=U.length){for(let ge=J;ge<oe;ge++){const we=U.charCodeAt(ge);if(we!==32&&we!==9)return U.substring(J,ge)}return U.substring(J,oe)}function D(U,J=U.length-1){for(let oe=J;oe>=0;oe--){const ge=U.charCodeAt(oe);if(ge!==32&&ge!==9)return oe}return-1}function k(U,J,oe){const ge=[];let we=0;for(const Ce of U.matchAll(J)){if(ge.push(U.slice(we,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");we=Ce.index+Ce[0].length,ge.push(oe(Ce[0],...Ce.slice(1),Ce.index,U,Ce.groups))}return ge.push(U.slice(we)),Promise.all(ge).then(Ce=>Ce.join(""))}function b(U,J){return U<J?-1:U>J?1:0}function z(U,J,oe=0,ge=U.length,we=0,Ce=J.length){for(;oe<ge&&we<Ce;oe++,we++){const Ae=U.charCodeAt(oe),Me=J.charCodeAt(we);if(Ae<Me)return-1;if(Ae>Me)return 1}const Se=ge-oe,Re=Ce-we;return Se<Re?-1:Se>Re?1:0}function Z(U,J){return T(U,J,0,U.length,0,J.length)}function T(U,J,oe=0,ge=U.length,we=0,Ce=J.length){for(;oe<ge&&we<Ce;oe++,we++){let Ae=U.charCodeAt(oe),Me=J.charCodeAt(we);if(Ae===Me)continue;if(Ae>=128||Me>=128)return z(U.toLowerCase(),J.toLowerCase(),oe,ge,we,Ce);m(Ae)&&(Ae-=32),m(Me)&&(Me-=32);const Le=Ae-Me;if(Le!==0)return Le}const Se=ge-oe,Re=Ce-we;return Se<Re?-1:Se>Re?1:0}function R(U){return U>=48&&U<=57}function m(U){return U>=97&&U<=122}function O(U){return U>=65&&U<=90}function $(U,J){return U.length===J.length&&T(U,J)===0}function A(U,J){const oe=J.length;return J.length>U.length?!1:T(U,J,0,oe)===0}function Y(U,J){const oe=Math.min(U.length,J.length);let ge;for(ge=0;ge<oe;ge++)if(U.charCodeAt(ge)!==J.charCodeAt(ge))return ge;return oe}function te(U,J){const oe=Math.min(U.length,J.length);let ge;const we=U.length-1,Ce=J.length-1;for(ge=0;ge<oe;ge++)if(U.charCodeAt(we-ge)!==J.charCodeAt(Ce-ge))return ge;return oe}function G(U){return 55296<=U&&U<=56319}function ee(U){return 56320<=U&&U<=57343}function ce(U,J){return(U-55296<<10)+(J-56320)+65536}function ue(U,J,oe){const ge=U.charCodeAt(oe);if(G(ge)&&oe+1<J){const we=U.charCodeAt(oe+1);if(ee(we))return ce(ge,we)}return ge}function X(U,J){const oe=U.charCodeAt(J-1);if(ee(oe)&&J>1){const ge=U.charCodeAt(J-2);if(G(ge))return ce(ge,oe)}return oe}class q{get offset(){return this.e}constructor(J,oe=0){this.c=J,this.d=J.length,this.e=oe}setOffset(J){this.e=J}prevCodePoint(){const J=X(this.c,this.e);return this.e-=J>=65536?2:1,J}nextCodePoint(){const J=ue(this.c,this.d,this.e);return this.e+=J>=65536?2:1,J}eol(){return this.e>=this.d}}e.$Gf=q;class Q{get offset(){return this.c.offset}constructor(J,oe=0){this.c=new q(J,oe)}nextGraphemeLength(){const J=De.getInstance(),oe=this.c,ge=oe.offset;let we=J.getGraphemeBreakType(oe.nextCodePoint());for(;!oe.eol();){const Ce=oe.offset,Se=J.getGraphemeBreakType(oe.nextCodePoint());if(Pe(we,Se)){oe.setOffset(Ce);break}we=Se}return oe.offset-ge}prevGraphemeLength(){const J=De.getInstance(),oe=this.c,ge=oe.offset;let we=J.getGraphemeBreakType(oe.prevCodePoint());for(;oe.offset>0;){const Ce=oe.offset,Se=J.getGraphemeBreakType(oe.prevCodePoint());if(Pe(Se,we)){oe.setOffset(Ce);break}we=Se}return ge-oe.offset}eol(){return this.c.eol()}}e.$Hf=Q;function K(U,J){return new Q(U,J).nextGraphemeLength()}function de(U,J){return new Q(U,J).prevGraphemeLength()}function B(U,J){J>0&&ee(U.charCodeAt(J))&&J--;const oe=J+K(U,J);return[oe-de(U,oe),oe]}function le(U){const J=new Q(U);let oe=0;for(;!J.eol();)oe++,J.nextGraphemeLength();return oe}let _;function u(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(U){return _||(_=u()),_.test(U)}const ie=/^[\t\n\r\x20-\x7E]*$/;function ne(U){return ie.test(U)}e.$Of=/[\u2028\u2029]/;function H(U){return e.$Of.test(U)}function V(U){return U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}function F(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129008||U>=129280&&U<=129535||U>=129648&&U<=129782}function I(U,J,oe=""){const ge=U.trimStart();if(ge.length<J)return ge;const we=/\b/g;let Ce=0;for(;we.test(ge)&&!(ge.length-we.lastIndex<J);)Ce=we.lastIndex,we.lastIndex+=1;return Ce===0?ge:oe+ge.substring(Ce).trimStart()}const W=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*x(U){let J=0;for(const oe of U.matchAll(W))J!==oe.index&&(yield{isCode:!1,str:U.substring(J,oe.index)}),yield{isCode:!0,str:oe[0]},J=oe.index+oe[0].length;J!==U.length&&(yield{isCode:!1,str:U.substring(J)})}function se(U){return U&&(U=U.replace(W,"")),U}e.$Vf="\uFEFF";function re(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}function he(U){return re(U)?U.substr(1):U}function pe(U,J){if(!U||!J||U.length<J.length)return!1;const oe=J.length,ge=U.toLowerCase();let we=0,Ce=-1;for(;we<oe;){const Se=ge.indexOf(J[we],Ce+1);if(Se<0)return!1;Ce=Se,we++}return!0}function $e(U,J=!1){return U?(J&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}function ye(U){return U.charAt(0).toUpperCase()+U.slice(1)}function ve(U,J=1){if(J===0)return"";let oe=-1;do oe=U.indexOf(`
`,oe+1),J--;while(J>0&&oe>=0);return oe===-1?U:(U[oe-1]==="\r"&&oe--,U.substr(0,oe))}function ke(U){return U=U%(2*26),U<26?String.fromCharCode(97+U):String.fromCharCode(65+U-26)}function Ee(U){return De.getInstance().getGraphemeBreakType(U)}function Pe(U,J){return U===0?J!==5&&J!==7:U===2&&J===3?!1:U===4||U===2||U===3||J===4||J===2||J===3?!0:!(U===8&&(J===8||J===9||J===11||J===12)||(U===11||U===9)&&(J===9||J===10)||(U===12||U===10)&&J===10||J===5||J===13||J===7||U===1||U===13&&J===14||U===6&&J===6)}var Oe;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Oe||(e.GraphemeBreakType=Oe={}));class De{static{this.c=null}static getInstance(){return De.c||(De.c=new De),De.c}constructor(){this.d=Fe()}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const oe=this.d,ge=oe.length/3;let we=1;for(;we<=ge;)if(J<oe[3*we])we=2*we;else if(J>oe[3*we+1])we=2*we+1;else return oe[3*we+2];return 0}}function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Be(U,J){if(U===0)return 0;const oe=ze(U,J);if(oe!==void 0)return oe;const ge=new q(J,U);return ge.prevCodePoint(),ge.offset}function ze(U,J){const oe=new q(J,U);let ge=oe.prevCodePoint();for(;We(ge)||ge===65039||ge===8419;){if(oe.offset===0)return;ge=oe.prevCodePoint()}if(!F(ge))return;let we=oe.offset;return we>0&&oe.prevCodePoint()===8205&&(we=oe.offset),we}function We(U){return 127995<=U&&U<=127999}var qe;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$6f="\xA0";class Te{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new w.$4e({getCacheKey:JSON.stringify},J=>{function oe(Le){const je=new Map;for(let Ie=0;Ie<Le.length;Ie+=2)je.set(Le[Ie],Le[Ie+1]);return je}function ge(Le,je){const Ie=new Map(Le);for(const[Ve,He]of je)Ie.set(Ve,He);return Ie}function we(Le,je){if(!Le)return je;const Ie=new Map;for(const[Ve,He]of Le)je.has(Ve)&&Ie.set(Ve,He);return Ie}const Ce=this.c.value;let Se=J.filter(Le=>!Le.startsWith("_")&&Le in Ce);Se.length===0&&(Se=["_default"]);let Re;for(const Le of Se){const je=oe(Ce[Le]);Re=we(Re,je)}const Ae=oe(Ce._common),Me=ge(Ae,Re);return new Te(Me)})}static getInstance(J){return Te.d.get(Array.from(J))}static{this.e=new L.$V(()=>Object.keys(Te.c.value).filter(J=>!J.startsWith("_")))}static getLocales(){return Te.e.value}constructor(J){this.f=J}isAmbiguous(J){return this.f.has(J)}getPrimaryConfusable(J){return this.f.get(J)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=Te;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(J){return Ue.e().has(J)}static get codePoints(){return Ue.e()}}e.$8f=Ue}),define(fe[49],me([0,1,12]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=L,e.$lj=C,e.$mj=M,e.$nj=P,e.$pj=g;function L(n){return C(n,0)}function C(n,s){switch(typeof n){case"object":return n===null?M(349,s):Array.isArray(n)?h(n,s):r(n,s);case"string":return P(n,s);case"boolean":return j(n,s);case"number":return M(n,s);case"undefined":return M(937,s);default:return M(617,s)}}function M(n,s){return(s<<5)-s+n|0}function j(n,s){return M(n?433:863,s)}function P(n,s){s=M(149417,s);for(let d=0,v=n.length;d<v;d++)s=M(n.charCodeAt(d),s);return s}function h(n,s){return s=M(104579,s),n.reduce((d,v)=>C(v,d),s)}function r(n,s){return s=M(181387,s),Object.keys(n).sort().reduce((d,v)=>(d=P(v,d),C(n[v],d)),s)}class y{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=C(s,this.g),this.g}}e.$oj=y;var l;(function(n){n[n.BLOCK_SIZE=64]="BLOCK_SIZE",n[n.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(l||(l={}));function E(n,s,d=32){const v=d-s,i=~((1<<v)-1);return(n<<s|(i&n)>>>v)>>>0}function o(n,s=0,d=n.byteLength,v=0){for(let i=0;i<d;i++)n[s+i]=v}function a(n,s,d="0"){for(;n.length<s;)n=d+n;return n}function g(n,s=32){return n instanceof ArrayBuffer?Array.from(new Uint8Array(n)).map(d=>d.toString(16).padStart(2,"0")).join(""):a((n>>>0).toString(16),s/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const d=s.length;if(d===0)return;const v=this.p;let i=this.r,t=this.u,c,S;for(t!==0?(c=t,S=-1,t=0):(c=s.charCodeAt(0),S=0);;){let p=c;if(w.$Cf(c))if(S+1<d){const D=s.charCodeAt(S+1);w.$Df(D)?(S++,p=w.$Ef(c,D)):p=65533}else{t=c;break}else w.$Df(c)&&(p=65533);if(i=this.w(v,i,p),S++,S<d)c=s.charCodeAt(S);else break}this.r=i,this.u=t}w(s,d,v){return v<128?s[d++]=v:v<2048?(s[d++]=192|(v&1984)>>>6,s[d++]=128|(v&63)>>>0):v<65536?(s[d++]=224|(v&61440)>>>12,s[d++]=128|(v&4032)>>>6,s[d++]=128|(v&63)>>>0):(s[d++]=240|(v&1835008)>>>18,s[d++]=128|(v&258048)>>>12,s[d++]=128|(v&4032)>>>6,s[d++]=128|(v&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,s[0]=s[64],s[1]=s[65],s[2]=s[66]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),g(this.h)+g(this.l)+g(this.m)+g(this.n)+g(this.o)}x(){this.p[this.r++]=128,o(this.p,this.r),this.r>56&&(this.y(),o(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=f.g,d=this.q;for(let b=0;b<64;b+=4)s.setUint32(b,d.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)s.setUint32(b,E(s.getUint32(b-12,!1)^s.getUint32(b-32,!1)^s.getUint32(b-56,!1)^s.getUint32(b-64,!1),1),!1);let v=this.h,i=this.l,t=this.m,c=this.n,S=this.o,p,D,k;for(let b=0;b<80;b++)b<20?(p=i&t|~i&c,D=1518500249):b<40?(p=i^t^c,D=1859775393):b<60?(p=i&t|i&c|t&c,D=2400959708):(p=i^t^c,D=3395469782),k=E(v,5)+p+S+D+s.getUint32(b*4,!1)&4294967295,S=c,c=t,t=E(i,30),i=v,v=k;this.h=this.h+v&4294967295,this.l=this.l+i&4294967295,this.m=this.m+t&4294967295,this.n=this.n+c&4294967295,this.o=this.o+S&4294967295}}e.$qj=f}),define(fe[50],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(fe[51],me([0,1,16,12]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class C{constructor(){this.b="",this.c=0}reset(o){return this.b=o,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(o){const a=o.charCodeAt(0),g=this.b.charCodeAt(this.c);return a-g}value(){return this.b[this.c]}}e.$yi=C;class M{constructor(o=!0){this.e=o}reset(o){return this.b=o,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let o=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(o)this.c++;else break;else o=!1;return this}cmp(o){return this.e?(0,L.$sf)(o,this.b,0,o.length,this.c,this.d):(0,L.$uf)(o,this.b,0,o.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=M;class j{constructor(o=!0,a=!0){this.f=o,this.g=a}reset(o){this.d=0,this.e=0,this.b=o,this.c=o.length;for(let a=o.length-1;a>=0;a--,this.c--){const g=this.b.charCodeAt(a);if(!(g===47||this.f&&g===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let o=!0;for(;this.e<this.c;this.e++){const a=this.b.charCodeAt(this.e);if(a===47||this.f&&a===92)if(o)this.d++;else break;else o=!1}return this}cmp(o){return this.g?(0,L.$sf)(o,this.b,0,o.length,this.d,this.e):(0,L.$uf)(o,this.b,0,o.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=j;var P;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(P||(P={}));class h{constructor(o,a){this.f=o,this.g=a,this.d=[],this.e=0}reset(o){return this.c=o,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(o)),this.b.reset(o.path),this.b.value()&&this.d.push(3)),this.g(o)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(o){if(this.d[this.e]===1)return(0,L.$tf)(o,this.c.scheme);if(this.d[this.e]===2)return(0,L.$tf)(o,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(o);if(this.d[this.e]===4)return(0,L.$rf)(o,this.c.query);if(this.d[this.e]===5)return(0,L.$rf)(o,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=h;class r{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const o=this.right;return this.right=o.left,o.left=this,this.updateHeight(),o.updateHeight(),o}rotateRight(){const o=this.left;return this.left=o.right,o.right=this,this.updateHeight(),o.updateHeight(),o}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(y||(y={}));class l{static forUris(o=()=>!1,a=()=>!1){return new l(new h(o,a))}static forPaths(o=!1){return new l(new j(void 0,!o))}static forStrings(){return new l(new C)}static forConfigKeys(){return new l(new M)}constructor(o){this.b=o}clear(){this.c=void 0}fill(o,a){if(a){const g=a.slice(0);(0,w.$Xb)(g);for(const f of g)this.set(f,o)}else{const g=o.slice(0);(0,w.$Xb)(g);for(const f of g)this.set(f[0],f[1])}}set(o,a){const g=this.b.reset(o);let f;this.c||(this.c=new r,this.c.segment=g.value());const n=[];for(f=this.c;;){const d=g.cmp(f.segment);if(d>0)f.left||(f.left=new r,f.left.segment=g.value()),n.push([-1,f]),f=f.left;else if(d<0)f.right||(f.right=new r,f.right.segment=g.value()),n.push([1,f]),f=f.right;else if(g.hasNext())g.next(),f.mid||(f.mid=new r,f.mid.segment=g.value()),n.push([0,f]),f=f.mid;else break}const s=f.value;f.value=a,f.key=o;for(let d=n.length-1;d>=0;d--){const v=n[d][1];v.updateHeight();const i=v.balanceFactor();if(i<-1||i>1){const t=n[d][0],c=n[d+1][0];if(t===1&&c===1)n[d][1]=v.rotateLeft();else if(t===-1&&c===-1)n[d][1]=v.rotateRight();else if(t===1&&c===-1)v.right=n[d+1][1]=n[d+1][1].rotateRight(),n[d][1]=v.rotateLeft();else if(t===-1&&c===1)v.left=n[d+1][1]=n[d+1][1].rotateLeft(),n[d][1]=v.rotateRight();else throw new Error;if(d>0)switch(n[d-1][0]){case-1:n[d-1][1].left=n[d][1];break;case 1:n[d-1][1].right=n[d][1];break;case 0:n[d-1][1].mid=n[d][1];break}else this.c=n[0][1]}}return s}get(o){return this.d(o)?.value}d(o){const a=this.b.reset(o);let g=this.c;for(;g;){const f=a.cmp(g.segment);if(f>0)g=g.left;else if(f<0)g=g.right;else if(a.hasNext())a.next(),g=g.mid;else break}return g}has(o){const a=this.d(o);return!(a?.value===void 0&&a?.mid===void 0)}delete(o){return this.e(o,!1)}deleteSuperstr(o){return this.e(o,!0)}e(o,a){const g=this.b.reset(o),f=[];let n=this.c;for(;n;){const s=g.cmp(n.segment);if(s>0)f.push([-1,n]),n=n.left;else if(s<0)f.push([1,n]),n=n.right;else if(g.hasNext())g.next(),f.push([0,n]),n=n.mid;else break}if(n){if(a?(n.left=void 0,n.mid=void 0,n.right=void 0,n.height=1):(n.key=void 0,n.value=void 0),!n.mid&&!n.value)if(n.left&&n.right){const s=this.f(n.right);if(s.key){const{key:d,value:v,segment:i}=s;this.e(s.key,!1),n.key=d,n.value=v,n.segment=i}}else{const s=n.left??n.right;if(f.length>0){const[d,v]=f[f.length-1];switch(d){case-1:v.left=s;break;case 0:v.mid=s;break;case 1:v.right=s;break}}else this.c=s}for(let s=f.length-1;s>=0;s--){const d=f[s][1];d.updateHeight();const v=d.balanceFactor();if(v>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),f[s][1]=d.rotateLeft()):v<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),f[s][1]=d.rotateRight()),s>0)switch(f[s-1][0]){case-1:f[s-1][1].left=f[s][1];break;case 1:f[s-1][1].right=f[s][1];break;case 0:f[s-1][1].mid=f[s][1];break}else this.c=f[0][1]}}}f(o){for(;o.left;)o=o.left;return o}findSubstr(o){const a=this.b.reset(o);let g=this.c,f;for(;g;){const n=a.cmp(g.segment);if(n>0)g=g.left;else if(n<0)g=g.right;else if(a.hasNext())a.next(),f=g.value||f,g=g.mid;else break}return g&&g.value||f}findSuperstr(o){return this.g(o,!1)}g(o,a){const g=this.b.reset(o);let f=this.c;for(;f;){const n=g.cmp(f.segment);if(n>0)f=f.left;else if(n<0)f=f.right;else if(g.hasNext())g.next(),f=f.mid;else return f.mid?this.h(f.mid):a?f.value:void 0}}hasElementOrSubtree(o){return this.g(o,!0)!==void 0}forEach(o){for(const[a,g]of this)o(g,a)}*[Symbol.iterator](){yield*this.h(this.c)}h(o){const a=[];return this.j(o,a),a[Symbol.iterator]()}j(o,a){o&&(o.left&&this.j(o.left,a),o.value&&a.push([o.key,o.value]),o.mid&&this.j(o.mid,a),o.right&&this.j(o.right,a))}_isBalanced(){const o=a=>{if(!a)return!0;const g=a.balanceFactor();return g<-1||g>1?!1:o(a.left)&&o(a.right)};return o(this.c)}}e.$Ci=l}),define(fe[9],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=w,e.$0f=L,e.$$f=C,e.$_f=M,e.$ag=j,e.$bg=P,e.$cg=h,e.$dg=r,e.$eg=y,e.$fg=l,e.$gg=E,e.$hg=o,e.$ig=a,e.$jg=f,e.$kg=n,e.$lg=s,e.$mg=d,e.$ng=v;function w(i){return typeof i=="string"}function L(i){return Array.isArray(i)&&i.every(t=>w(t))}function C(i){return typeof i=="object"&&i!==null&&!Array.isArray(i)&&!(i instanceof RegExp)&&!(i instanceof Date)}function M(i){const t=Object.getPrototypeOf(Uint8Array);return typeof i=="object"&&i instanceof t}function j(i){return typeof i=="number"&&!isNaN(i)}function P(i){return!!i&&typeof i[Symbol.iterator]=="function"}function h(i){return i===!0||i===!1}function r(i){return typeof i>"u"}function y(i){return!l(i)}function l(i){return r(i)||i===null}function E(i,t){if(!i)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function o(i){if(l(i))throw new Error("Assertion Failed: argument is undefined or null");return i}function a(...i){const t=[];for(let c=0;c<i.length;c++){const S=i[c];if(l(S))throw new Error(`Assertion Failed: argument at index ${c} is undefined or null`);t.push(S)}return t}const g=Object.prototype.hasOwnProperty;function f(i){if(!C(i))return!1;for(const t in i)if(g.call(i,t))return!1;return!0}function n(i){return typeof i=="function"}function s(...i){return i.length>0&&i.every(n)}function d(i,t){const c=Math.min(i.length,t.length);for(let S=0;S<c;S++)v(i[S],t[S])}function v(i,t){if(w(t)){if(typeof i!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(n(t)){try{if(i instanceof t)return}catch{}if(!l(i)&&i.constructor===t||t.length===1&&t.call(void 0,i)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(fe[30],me([0,1,9]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=L,e.$4n=C,e.$5n=j,e.$6n=h,e.$7n=r,e.$8n=y,e.$9n=l,e.$0n=E,e.$$n=o,e.$_n=a,e.$ao=g,e.$bo=f;function L(n){if(!n||typeof n!="object"||n instanceof RegExp)return n;const s=Array.isArray(n)?[]:{};return Object.entries(n).forEach(([d,v])=>{s[d]=v&&typeof v=="object"?L(v):v}),s}function C(n){if(!n||typeof n!="object")return n;const s=[n];for(;s.length>0;){const d=s.shift();Object.freeze(d);for(const v in d)if(M.call(d,v)){const i=d[v];typeof i=="object"&&!Object.isFrozen(i)&&!(0,w.$_f)(i)&&s.push(i)}}return n}const M=Object.prototype.hasOwnProperty;function j(n,s){return P(n,s,new Set)}function P(n,s,d){if((0,w.$fg)(n))return n;const v=s(n);if(typeof v<"u")return v;if(Array.isArray(n)){const i=[];for(const t of n)i.push(P(t,s,d));return i}if((0,w.$$f)(n)){if(d.has(n))throw new Error("Cannot clone recursive data-structure");d.add(n);const i={};for(const t in n)M.call(n,t)&&(i[t]=P(n[t],s,d));return d.delete(n),i}return n}function h(n,s,d=!0){return(0,w.$$f)(n)?((0,w.$$f)(s)&&Object.keys(s).forEach(v=>{v in n?d&&((0,w.$$f)(n[v])&&(0,w.$$f)(s[v])?h(n[v],s[v],d):n[v]=s[v]):n[v]=s[v]}),n):s}function r(n,s){if(n===s)return!0;if(n==null||s===null||s===void 0||typeof n!=typeof s||typeof n!="object"||Array.isArray(n)!==Array.isArray(s))return!1;let d,v;if(Array.isArray(n)){if(n.length!==s.length)return!1;for(d=0;d<n.length;d++)if(!r(n[d],s[d]))return!1}else{const i=[];for(v in n)i.push(v);i.sort();const t=[];for(v in s)t.push(v);if(t.sort(),!r(i,t))return!1;for(d=0;d<i.length;d++)if(!r(n[i[d]],s[i[d]]))return!1}return!0}function y(n){const s=new Set;return JSON.stringify(n,(d,v)=>{if((0,w.$$f)(v)||Array.isArray(v)){if(s.has(v))return"[Circular]";s.add(v)}return typeof v=="bigint"?`[BigInt ${v.toString()}]`:v})}function l(n,s){const d=Object.create(null);return!n||!s||Object.keys(s).forEach(i=>{const t=n[i],c=s[i];r(t,c)||(d[i]=c)}),d}function E(n,s){const d=s.toLowerCase(),v=Object.keys(n).find(i=>i.toLowerCase()===d);return v?n[v]:n[s]}function o(n,s){const d=Object.create(null);for(const[v,i]of Object.entries(n))s(v,i)&&(d[v]=i);return d}function a(n){let s=[];for(;Object.prototype!==n;)s=s.concat(Object.getOwnPropertyNames(n)),n=Object.getPrototypeOf(n);return s}function g(n){const s=[];for(const d of a(n))typeof n[d]=="function"&&s.push(d);return s}function f(n,s){const d=i=>function(){const t=Array.prototype.slice.call(arguments,0);return s(i,t)},v={};for(const i of n)v[i]=d(i);return v}}),define(fe[52],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=L;const w=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(C){return w.test(C)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(P){for(let h=0;h<P.length;h++)P[h]=Math.floor(Math.random()*256);return P};const M=new Uint8Array(16),j=[];for(let P=0;P<256;P++)j.push(P.toString(16).padStart(2,"0"));return function(){C(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let h=0,r="";return r+=j[M[h++]],r+=j[M[h++]],r+=j[M[h++]],r+=j[M[h++]],r+="-",r+=j[M[h++]],r+=j[M[h++]],r+="-",r+=j[M[h++]],r+=j[M[h++]],r+="-",r+=j[M[h++]],r+=j[M[h++]],r+="-",r+=j[M[h++]],r+=j[M[h++]],r+=j[M[h++]],r+=j[M[h++]],r+=j[M[h++]],r+=j[M[h++]],r}}()}),define(fe[31],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bX=w;function w(L){return!!L.parentPort}}),define(fe[53],me([13,10]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(fe[54],me([0,1,53]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=r,e.$3m=y,e.$4m=l;const L=60,C=L*60,M=C*24,j=M*7,P=M*30,h=M*365;function r(E,o,a,g){typeof E!="number"&&(E=E.getTime());const f=Math.round((new Date().getTime()-E)/1e3);if(f<-30)return(0,w.localize)(0,null,r(new Date().getTime()+f*1e3,!1));if(!g&&f<30)return(0,w.localize)(1,null);let n;return f<L?(n=f,o?n===1?a?(0,w.localize)(2,null,n):(0,w.localize)(3,null,n):a?(0,w.localize)(4,null,n):(0,w.localize)(5,null,n):n===1?a?(0,w.localize)(6,null,n):(0,w.localize)(7,null,n):a?(0,w.localize)(8,null,n):(0,w.localize)(9,null,n)):f<C?(n=Math.floor(f/L),o?n===1?a?(0,w.localize)(10,null,n):(0,w.localize)(11,null,n):a?(0,w.localize)(12,null,n):(0,w.localize)(13,null,n):n===1?a?(0,w.localize)(14,null,n):(0,w.localize)(15,null,n):a?(0,w.localize)(16,null,n):(0,w.localize)(17,null,n)):f<M?(n=Math.floor(f/C),o?n===1?a?(0,w.localize)(18,null,n):(0,w.localize)(19,null,n):a?(0,w.localize)(20,null,n):(0,w.localize)(21,null,n):n===1?a?(0,w.localize)(22,null,n):(0,w.localize)(23,null,n):a?(0,w.localize)(24,null,n):(0,w.localize)(25,null,n)):f<j?(n=Math.floor(f/M),o?n===1?(0,w.localize)(26,null,n):(0,w.localize)(27,null,n):n===1?(0,w.localize)(28,null,n):(0,w.localize)(29,null,n)):f<P?(n=Math.floor(f/j),o?n===1?a?(0,w.localize)(30,null,n):(0,w.localize)(31,null,n):a?(0,w.localize)(32,null,n):(0,w.localize)(33,null,n):n===1?a?(0,w.localize)(34,null,n):(0,w.localize)(35,null,n):a?(0,w.localize)(36,null,n):(0,w.localize)(37,null,n)):f<h?(n=Math.floor(f/P),o?n===1?a?(0,w.localize)(38,null,n):(0,w.localize)(39,null,n):a?(0,w.localize)(40,null,n):(0,w.localize)(41,null,n):n===1?a?(0,w.localize)(42,null,n):(0,w.localize)(43,null,n):a?(0,w.localize)(44,null,n):(0,w.localize)(45,null,n)):(n=Math.floor(f/h),o?n===1?a?(0,w.localize)(46,null,n):(0,w.localize)(47,null,n):a?(0,w.localize)(48,null,n):(0,w.localize)(49,null,n):n===1?a?(0,w.localize)(50,null,n):(0,w.localize)(51,null,n):a?(0,w.localize)(52,null,n):(0,w.localize)(53,null,n))}function y(E,o){const a=Math.abs(E/1e3);return a<1?o?(0,w.localize)(54,null,E):(0,w.localize)(55,null,E):a<L?o?(0,w.localize)(56,null,Math.round(E)/1e3):(0,w.localize)(57,null,Math.round(E)/1e3):a<C?o?(0,w.localize)(58,null,Math.round(E/(1e3*L))):(0,w.localize)(59,null,Math.round(E/(1e3*L))):a<M?o?(0,w.localize)(60,null,Math.round(E/(1e3*C))):(0,w.localize)(61,null,Math.round(E/(1e3*C))):(0,w.localize)(62,null,Math.round(E/(1e3*M)))}function l(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(fe[55],me([13,10]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(fe[56],me([0,1,16,9,55]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=h,e.$ij=r,e.$jj=y;function M(l,E){return E&&(l.stack||l.stacktrace)?C.localize(0,null,P(l),j(l.stack)||j(l.stacktrace)):P(l)}function j(l){return Array.isArray(l)?l.join(`
`):l}function P(l){return l.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${l.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof l.code=="string"&&typeof l.errno=="number"&&typeof l.syscall=="string"?C.localize(1,null,l.message):l.message||C.localize(2,null)}function h(l=null,E=!1){if(!l)return C.localize(3,null);if(Array.isArray(l)){const o=w.$Hb(l),a=h(o[0],E);return o.length>1?C.localize(4,null,a,o.length):a}if(L.$9f(l))return l;if(l.detail){const o=l.detail;if(o.error)return M(o.error,E);if(o.exception)return M(o.exception,E)}return l.stack?M(l,E):l.message?l.message:C.localize(5,null)}function r(l){const E=l;return E instanceof Error&&Array.isArray(E.actions)}function y(l,E){let o;return typeof l=="string"?o=new Error(l):o=l,o.actions=E,o}}),define(fe[57],me([13,10]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(fe[3],me([0,1,57]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=c,e.$D=z,e.$J=Z,e.$g="en";let L=!1,C=!1,M=!1,j=!1,P=!1,h=!1,r=!1,y=!1,l=!1,E=!1,o,a=e.$g,g=e.$g,f,n;const s=globalThis;let d;typeof s.vscode<"u"&&typeof s.vscode.process<"u"?d=s.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(d=process);const v=typeof d?.versions?.electron=="string",i=v&&d?.type==="renderer";if(typeof d=="object"){L=d.platform==="win32",C=d.platform==="darwin",M=d.platform==="linux",j=M&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,r=v,l=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,o=e.$g,a=e.$g;const T=d.env.VSCODE_NLS_CONFIG;if(T)try{const R=JSON.parse(T),m=R.availableLanguages["*"];o=R.locale,g=R.osLocale,a=m||e.$g,f=R._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!i?(n=navigator.userAgent,L=n.indexOf("Windows")>=0,C=n.indexOf("Macintosh")>=0,y=(n.indexOf("Macintosh")>=0||n.indexOf("iPad")>=0||n.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=n.indexOf("Linux")>=0,E=n?.indexOf("Mobi")>=0,h=!0,o=w.getConfiguredDefaultLocale(w.localize(0,null))||e.$g,a=o,g=navigator.language):console.error("Unable to resolve platform.");var t;(function(T){T[T.Web=0]="Web",T[T.Mac=1]="Mac",T[T.Linux=2]="Linux",T[T.Windows=3]="Windows"})(t||(e.Platform=t={}));function c(T){switch(T){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let S=0;C?S=1:L?S=3:M&&(S=2),e.$i=L,e.$j=C,e.$k=M,e.$l=j,e.$m=P,e.$n=r,e.$o=h,e.$p=h&&typeof s.importScripts=="function",e.$q=e.$p?s.origin:void 0,e.$r=y,e.$s=E,e.$t=l,e.$u=S,e.$v=n,e.$w=a;var p;(function(T){function R(){return e.$w}T.value=R;function m(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}T.isDefaultVariant=m;function O(){return e.$w==="en"}T.isDefault=O})(p||(e.Language=p={})),e.$x=o,e.$y=g,e.$z=f,e.$A=typeof s.postMessage=="function"&&!s.importScripts,e.$B=(()=>{if(e.$A){const T=[];s.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let O=0,$=T.length;O<$;O++){const A=T[O];if(A.id===m.data.vscodeScheduleAsyncWork){T.splice(O,1),A.callback();return}}});let R=0;return m=>{const O=++R;T.push({id:O,callback:m}),s.postMessage({vscodeScheduleAsyncWork:O},"*")}}return T=>setTimeout(T)})();var D;(function(T){T[T.Windows=1]="Windows",T[T.Macintosh=2]="Macintosh",T[T.Linux=3]="Linux"})(D||(e.OperatingSystem=D={})),e.OS=C||y?2:L?1:3;let k=!0,b=!1;function z(){if(!b){b=!0;const T=new Uint8Array(2);T[0]=1,T[1]=2,k=new Uint16Array(T.buffer)[0]===513}return k}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function Z(T){return parseFloat(T)>=20}}),define(fe[15],me([0,1,3]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let L;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.process<"u"){const M=C.process;L={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return w.$i?"win32":w.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$ec=L.platform,e.$fc=L.arch}),define(fe[5],me([0,1,15]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const L=65,C=97,M=90,j=122,P=46,h=47,r=92,y=58,l=63;class E extends Error{constructor(c,S,p){let D;typeof S=="string"&&S.indexOf("not ")===0?(D="must not be",S=S.replace(/^not /,"")):D="must be";const k=c.indexOf(".")!==-1?"property":"argument";let b=`The "${c}" ${k} ${D} of type ${S}`;b+=`. Received type ${typeof p}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function o(t,c){if(t===null||typeof t!="object")throw new E(c,"Object",t)}function a(t,c){if(typeof t!="string")throw new E(c,"string",t)}const g=w.$ec==="win32";function f(t){return t===h||t===r}function n(t){return t===h}function s(t){return t>=L&&t<=M||t>=C&&t<=j}function d(t,c,S,p){let D="",k=0,b=-1,z=0,Z=0;for(let T=0;T<=t.length;++T){if(T<t.length)Z=t.charCodeAt(T);else{if(p(Z))break;Z=h}if(p(Z)){if(!(b===T-1||z===1))if(z===2){if(D.length<2||k!==2||D.charCodeAt(D.length-1)!==P||D.charCodeAt(D.length-2)!==P){if(D.length>2){const R=D.lastIndexOf(S);R===-1?(D="",k=0):(D=D.slice(0,R),k=D.length-1-D.lastIndexOf(S)),b=T,z=0;continue}else if(D.length!==0){D="",k=0,b=T,z=0;continue}}c&&(D+=D.length>0?`${S}..`:"..",k=2)}else D.length>0?D+=`${S}${t.slice(b+1,T)}`:D=t.slice(b+1,T),k=T-b-1;b=T,z=0}else Z===P&&z!==-1?++z:z=-1}return D}function v(t,c){o(c,"pathObject");const S=c.dir||c.root,p=c.base||`${c.name||""}${c.ext||""}`;return S?S===c.root?`${S}${p}`:`${S}${t}${p}`:p}e.$gc={resolve(...t){let c="",S="",p=!1;for(let D=t.length-1;D>=-1;D--){let k;if(D>=0){if(k=t[D],a(k,"path"),k.length===0)continue}else c.length===0?k=w.cwd():(k=w.env[`=${c}`]||w.cwd(),(k===void 0||k.slice(0,2).toLowerCase()!==c.toLowerCase()&&k.charCodeAt(2)===r)&&(k=`${c}\\`));const b=k.length;let z=0,Z="",T=!1;const R=k.charCodeAt(0);if(b===1)f(R)&&(z=1,T=!0);else if(f(R))if(T=!0,f(k.charCodeAt(1))){let m=2,O=m;for(;m<b&&!f(k.charCodeAt(m));)m++;if(m<b&&m!==O){const $=k.slice(O,m);for(O=m;m<b&&f(k.charCodeAt(m));)m++;if(m<b&&m!==O){for(O=m;m<b&&!f(k.charCodeAt(m));)m++;(m===b||m!==O)&&(Z=`\\\\${$}\\${k.slice(O,m)}`,z=m)}}}else z=1;else s(R)&&k.charCodeAt(1)===y&&(Z=k.slice(0,2),z=2,b>2&&f(k.charCodeAt(2))&&(T=!0,z=3));if(Z.length>0)if(c.length>0){if(Z.toLowerCase()!==c.toLowerCase())continue}else c=Z;if(p){if(c.length>0)break}else if(S=`${k.slice(z)}\\${S}`,p=T,T&&c.length>0)break}return S=d(S,!p,"\\",f),p?`${c}\\${S}`:`${c}${S}`||"."},normalize(t){a(t,"path");const c=t.length;if(c===0)return".";let S=0,p,D=!1;const k=t.charCodeAt(0);if(c===1)return n(k)?"\\":t;if(f(k))if(D=!0,f(t.charCodeAt(1))){let z=2,Z=z;for(;z<c&&!f(t.charCodeAt(z));)z++;if(z<c&&z!==Z){const T=t.slice(Z,z);for(Z=z;z<c&&f(t.charCodeAt(z));)z++;if(z<c&&z!==Z){for(Z=z;z<c&&!f(t.charCodeAt(z));)z++;if(z===c)return`\\\\${T}\\${t.slice(Z)}\\`;z!==Z&&(p=`\\\\${T}\\${t.slice(Z,z)}`,S=z)}}}else S=1;else s(k)&&t.charCodeAt(1)===y&&(p=t.slice(0,2),S=2,c>2&&f(t.charCodeAt(2))&&(D=!0,S=3));let b=S<c?d(t.slice(S),!D,"\\",f):"";return b.length===0&&!D&&(b="."),b.length>0&&f(t.charCodeAt(c-1))&&(b+="\\"),p===void 0?D?`\\${b}`:b:D?`${p}\\${b}`:`${p}${b}`},isAbsolute(t){a(t,"path");const c=t.length;if(c===0)return!1;const S=t.charCodeAt(0);return f(S)||c>2&&s(S)&&t.charCodeAt(1)===y&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let c,S;for(let k=0;k<t.length;++k){const b=t[k];a(b,"path"),b.length>0&&(c===void 0?c=S=b:c+=`\\${b}`)}if(c===void 0)return".";let p=!0,D=0;if(typeof S=="string"&&f(S.charCodeAt(0))){++D;const k=S.length;k>1&&f(S.charCodeAt(1))&&(++D,k>2&&(f(S.charCodeAt(2))?++D:p=!1))}if(p){for(;D<c.length&&f(c.charCodeAt(D));)D++;D>=2&&(c=`\\${c.slice(D)}`)}return e.$gc.normalize(c)},relative(t,c){if(a(t,"from"),a(c,"to"),t===c)return"";const S=e.$gc.resolve(t),p=e.$gc.resolve(c);if(S===p||(t=S.toLowerCase(),c=p.toLowerCase(),t===c))return"";let D=0;for(;D<t.length&&t.charCodeAt(D)===r;)D++;let k=t.length;for(;k-1>D&&t.charCodeAt(k-1)===r;)k--;const b=k-D;let z=0;for(;z<c.length&&c.charCodeAt(z)===r;)z++;let Z=c.length;for(;Z-1>z&&c.charCodeAt(Z-1)===r;)Z--;const T=Z-z,R=b<T?b:T;let m=-1,O=0;for(;O<R;O++){const A=t.charCodeAt(D+O);if(A!==c.charCodeAt(z+O))break;A===r&&(m=O)}if(O!==R){if(m===-1)return p}else{if(T>R){if(c.charCodeAt(z+O)===r)return p.slice(z+O+1);if(O===2)return p.slice(z+O)}b>R&&(t.charCodeAt(D+O)===r?m=O:O===2&&(m=3)),m===-1&&(m=0)}let $="";for(O=D+m+1;O<=k;++O)(O===k||t.charCodeAt(O)===r)&&($+=$.length===0?"..":"\\..");return z+=m,$.length>0?`${$}${p.slice(z,Z)}`:(p.charCodeAt(z)===r&&++z,p.slice(z,Z))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const c=e.$gc.resolve(t);if(c.length<=2)return t;if(c.charCodeAt(0)===r){if(c.charCodeAt(1)===r){const S=c.charCodeAt(2);if(S!==l&&S!==P)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(s(c.charCodeAt(0))&&c.charCodeAt(1)===y&&c.charCodeAt(2)===r)return`\\\\?\\${c}`;return t},dirname(t){a(t,"path");const c=t.length;if(c===0)return".";let S=-1,p=0;const D=t.charCodeAt(0);if(c===1)return f(D)?t:".";if(f(D)){if(S=p=1,f(t.charCodeAt(1))){let z=2,Z=z;for(;z<c&&!f(t.charCodeAt(z));)z++;if(z<c&&z!==Z){for(Z=z;z<c&&f(t.charCodeAt(z));)z++;if(z<c&&z!==Z){for(Z=z;z<c&&!f(t.charCodeAt(z));)z++;if(z===c)return t;z!==Z&&(S=p=z+1)}}}}else s(D)&&t.charCodeAt(1)===y&&(S=c>2&&f(t.charCodeAt(2))?3:2,p=S);let k=-1,b=!0;for(let z=c-1;z>=p;--z)if(f(t.charCodeAt(z))){if(!b){k=z;break}}else b=!1;if(k===-1){if(S===-1)return".";k=S}return t.slice(0,k)},basename(t,c){c!==void 0&&a(c,"ext"),a(t,"path");let S=0,p=-1,D=!0,k;if(t.length>=2&&s(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(S=2),c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let b=c.length-1,z=-1;for(k=t.length-1;k>=S;--k){const Z=t.charCodeAt(k);if(f(Z)){if(!D){S=k+1;break}}else z===-1&&(D=!1,z=k+1),b>=0&&(Z===c.charCodeAt(b)?--b===-1&&(p=k):(b=-1,p=z))}return S===p?p=z:p===-1&&(p=t.length),t.slice(S,p)}for(k=t.length-1;k>=S;--k)if(f(t.charCodeAt(k))){if(!D){S=k+1;break}}else p===-1&&(D=!1,p=k+1);return p===-1?"":t.slice(S,p)},extname(t){a(t,"path");let c=0,S=-1,p=0,D=-1,k=!0,b=0;t.length>=2&&t.charCodeAt(1)===y&&s(t.charCodeAt(0))&&(c=p=2);for(let z=t.length-1;z>=c;--z){const Z=t.charCodeAt(z);if(f(Z)){if(!k){p=z+1;break}continue}D===-1&&(k=!1,D=z+1),Z===P?S===-1?S=z:b!==1&&(b=1):S!==-1&&(b=-1)}return S===-1||D===-1||b===0||b===1&&S===D-1&&S===p+1?"":t.slice(S,D)},format:v.bind(null,"\\"),parse(t){a(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const S=t.length;let p=0,D=t.charCodeAt(0);if(S===1)return f(D)?(c.root=c.dir=t,c):(c.base=c.name=t,c);if(f(D)){if(p=1,f(t.charCodeAt(1))){let m=2,O=m;for(;m<S&&!f(t.charCodeAt(m));)m++;if(m<S&&m!==O){for(O=m;m<S&&f(t.charCodeAt(m));)m++;if(m<S&&m!==O){for(O=m;m<S&&!f(t.charCodeAt(m));)m++;m===S?p=m:m!==O&&(p=m+1)}}}}else if(s(D)&&t.charCodeAt(1)===y){if(S<=2)return c.root=c.dir=t,c;if(p=2,f(t.charCodeAt(2))){if(S===3)return c.root=c.dir=t,c;p=3}}p>0&&(c.root=t.slice(0,p));let k=-1,b=p,z=-1,Z=!0,T=t.length-1,R=0;for(;T>=p;--T){if(D=t.charCodeAt(T),f(D)){if(!Z){b=T+1;break}continue}z===-1&&(Z=!1,z=T+1),D===P?k===-1?k=T:R!==1&&(R=1):k!==-1&&(R=-1)}return z!==-1&&(k===-1||R===0||R===1&&k===z-1&&k===b+1?c.base=c.name=t.slice(b,z):(c.name=t.slice(b,k),c.base=t.slice(b,z),c.ext=t.slice(k,z))),b>0&&b!==p?c.dir=t.slice(0,b-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null};const i=(()=>{if(g){const t=/\\/g;return()=>{const c=w.cwd().replace(t,"/");return c.slice(c.indexOf("/"))}}return()=>w.cwd()})();e.$hc={resolve(...t){let c="",S=!1;for(let p=t.length-1;p>=-1&&!S;p--){const D=p>=0?t[p]:i();a(D,"path"),D.length!==0&&(c=`${D}/${c}`,S=D.charCodeAt(0)===h)}return c=d(c,!S,"/",n),S?`/${c}`:c.length>0?c:"."},normalize(t){if(a(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===h,S=t.charCodeAt(t.length-1)===h;return t=d(t,!c,"/",n),t.length===0?c?"/":S?"./":".":(S&&(t+="/"),c?`/${t}`:t)},isAbsolute(t){return a(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let c;for(let S=0;S<t.length;++S){const p=t[S];a(p,"path"),p.length>0&&(c===void 0?c=p:c+=`/${p}`)}return c===void 0?".":e.$hc.normalize(c)},relative(t,c){if(a(t,"from"),a(c,"to"),t===c||(t=e.$hc.resolve(t),c=e.$hc.resolve(c),t===c))return"";const S=1,p=t.length,D=p-S,k=1,b=c.length-k,z=D<b?D:b;let Z=-1,T=0;for(;T<z;T++){const m=t.charCodeAt(S+T);if(m!==c.charCodeAt(k+T))break;m===h&&(Z=T)}if(T===z)if(b>z){if(c.charCodeAt(k+T)===h)return c.slice(k+T+1);if(T===0)return c.slice(k+T)}else D>z&&(t.charCodeAt(S+T)===h?Z=T:T===0&&(Z=0));let R="";for(T=S+Z+1;T<=p;++T)(T===p||t.charCodeAt(T)===h)&&(R+=R.length===0?"..":"/..");return`${R}${c.slice(k+Z)}`},toNamespacedPath(t){return t},dirname(t){if(a(t,"path"),t.length===0)return".";const c=t.charCodeAt(0)===h;let S=-1,p=!0;for(let D=t.length-1;D>=1;--D)if(t.charCodeAt(D)===h){if(!p){S=D;break}}else p=!1;return S===-1?c?"/":".":c&&S===1?"//":t.slice(0,S)},basename(t,c){c!==void 0&&a(c,"ext"),a(t,"path");let S=0,p=-1,D=!0,k;if(c!==void 0&&c.length>0&&c.length<=t.length){if(c===t)return"";let b=c.length-1,z=-1;for(k=t.length-1;k>=0;--k){const Z=t.charCodeAt(k);if(Z===h){if(!D){S=k+1;break}}else z===-1&&(D=!1,z=k+1),b>=0&&(Z===c.charCodeAt(b)?--b===-1&&(p=k):(b=-1,p=z))}return S===p?p=z:p===-1&&(p=t.length),t.slice(S,p)}for(k=t.length-1;k>=0;--k)if(t.charCodeAt(k)===h){if(!D){S=k+1;break}}else p===-1&&(D=!1,p=k+1);return p===-1?"":t.slice(S,p)},extname(t){a(t,"path");let c=-1,S=0,p=-1,D=!0,k=0;for(let b=t.length-1;b>=0;--b){const z=t.charCodeAt(b);if(z===h){if(!D){S=b+1;break}continue}p===-1&&(D=!1,p=b+1),z===P?c===-1?c=b:k!==1&&(k=1):c!==-1&&(k=-1)}return c===-1||p===-1||k===0||k===1&&c===p-1&&c===S+1?"":t.slice(c,p)},format:v.bind(null,"/"),parse(t){a(t,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return c;const S=t.charCodeAt(0)===h;let p;S?(c.root="/",p=1):p=0;let D=-1,k=0,b=-1,z=!0,Z=t.length-1,T=0;for(;Z>=p;--Z){const R=t.charCodeAt(Z);if(R===h){if(!z){k=Z+1;break}continue}b===-1&&(z=!1,b=Z+1),R===P?D===-1?D=Z:T!==1&&(T=1):D!==-1&&(T=-1)}if(b!==-1){const R=k===0&&S?1:k;D===-1||T===0||T===1&&D===b-1&&D===k+1?c.base=c.name=t.slice(R,b):(c.name=t.slice(R,D),c.base=t.slice(R,b),c.ext=t.slice(D,b))}return k>0?c.dir=t.slice(0,k-1):S&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=g?e.$gc.normalize:e.$hc.normalize,e.$jc=g?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=g?e.$gc.join:e.$hc.join,e.$lc=g?e.$gc.resolve:e.$hc.resolve,e.$mc=g?e.$gc.relative:e.$hc.relative,e.$nc=g?e.$gc.dirname:e.$hc.dirname,e.$oc=g?e.$gc.basename:e.$hc.basename,e.$pc=g?e.$gc.extname:e.$hc.extname,e.$qc=g?e.$gc.format:e.$hc.format,e.$rc=g?e.$gc.parse:e.$hc.parse,e.$sc=g?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=g?e.$gc.sep:e.$hc.sep,e.$uc=g?e.$gc.delimiter:e.$hc.delimiter}),define(fe[32],me([0,1,5,3,12,9]),function(ae,e,w,L,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=j,e.$pg=P,e.$qg=h,e.$rg=r,e.$sg=y,e.$tg=a,e.$ug=g,e.$vg=f,e.$wg=n,e.$xg=s,e.$yg=d,e.$zg=v,e.$Ag=i,e.$Bg=t,e.$Cg=c,e.$Dg=S,e.$Eg=k;function j(b){return b===47||b===92}function P(b){return b.replace(/[\\/]/g,w.$hc.sep)}function h(b){return b.indexOf("/")===-1&&(b=P(b)),/^[a-zA-Z]:(\/|$)/.test(b)&&(b="/"+b),b}function r(b,z=w.$hc.sep){if(!b)return"";const Z=b.length,T=b.charCodeAt(0);if(j(T)){if(j(b.charCodeAt(1))&&!j(b.charCodeAt(2))){let m=3;const O=m;for(;m<Z&&!j(b.charCodeAt(m));m++);if(O!==m&&!j(b.charCodeAt(m+1))){for(m+=1;m<Z;m++)if(j(b.charCodeAt(m)))return b.slice(0,m+1).replace(/[\\/]/g,z)}}return z}else if(n(T)&&b.charCodeAt(1)===58)return j(b.charCodeAt(2))?b.slice(0,2)+z:b.slice(0,2);let R=b.indexOf("://");if(R!==-1){for(R+=3;R<Z;R++)if(j(b.charCodeAt(R)))return b.slice(0,R+1)}return""}function y(b){if(!L.$i||!b||b.length<5)return!1;let z=b.charCodeAt(0);if(z!==92||(z=b.charCodeAt(1),z!==92))return!1;let Z=2;const T=Z;for(;Z<b.length&&(z=b.charCodeAt(Z),z!==92);Z++);return!(T===Z||(z=b.charCodeAt(Z+1),isNaN(z)||z===92))}const l=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,o=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(b,z=L.$i){const Z=z?l:E;return!(!b||b.length===0||/^\s+$/.test(b)||(Z.lastIndex=0,Z.test(b))||z&&o.test(b)||b==="."||b===".."||z&&b[b.length-1]==="."||z&&b.length!==b.trim().length||b.length>255)}function g(b,z,Z){const T=b===z;return!Z||T?T:!b||!z?!1:(0,C.$yf)(b,z)}function f(b,z,Z,T=w.sep){if(b===z)return!0;if(!b||!z||z.length>b.length)return!1;if(Z){if(!(0,C.$zf)(b,z))return!1;if(z.length===b.length)return!0;let m=z.length;return z.charAt(z.length-1)===T&&m--,b.charAt(m)===T}return z.charAt(z.length-1)!==T&&(z+=T),b.indexOf(z)===0}function n(b){return b>=65&&b<=90||b>=97&&b<=122}function s(b,z){return L.$i&&b.endsWith(":")&&(b+=w.sep),(0,w.$jc)(b)||(b=(0,w.$kc)(z,b)),b=(0,w.$ic)(b),d(b)}function d(b){return L.$i?(b=(0,C.$gf)(b,w.sep),b.endsWith(":")&&(b+=w.sep)):(b=(0,C.$gf)(b,w.sep),b||(b=w.sep)),b}function v(b){const z=(0,w.$ic)(b);return L.$i?b.length>3?!1:i(z)&&(b.length===2||z.charCodeAt(2)===92):z===w.$hc.sep}function i(b,z=L.$i){return z?n(b.charCodeAt(0))&&b.charCodeAt(1)===58:!1}function t(b,z=L.$i){return i(b,z)?b[0]:void 0}function c(b,z,Z){return z.length>b.length?-1:b===z?0:(Z&&(b=b.toLowerCase(),z=z.toLowerCase()),b.indexOf(z))}function S(b){const z=b.split(":");let Z,T,R;for(const m of z){const O=Number(m);(0,M.$ag)(O)?T===void 0?T=O:R===void 0&&(R=O):Z=Z?[Z,m].join(":"):m}if(!Z)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:Z,line:T!==void 0?T:void 0,column:R!==void 0?R:T!==void 0?1:void 0}}const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",D="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function k(b,z,Z=8){let T="";for(let m=0;m<Z;m++){let O;m===0&&L.$i&&!z&&(Z===3||Z===4)?O=D:O=p,T+=O.charAt(Math.floor(Math.random()*O.length))}let R;return z?R=`${z}-${T}`:R=T,b?(0,w.$kc)(b,R):R}}),define(fe[33],me([0,1,3]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=M,e.$nm=j;var L;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(L||(e.Source=L={}));var C;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(C||(e.TerminateResponseCode=C={}));function M(P,...h){const r=h.reduce((E,o)=>(E[o]=!0,E),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(E=>!r[E]).forEach(E=>{for(let o=0;o<y.length;o++)if(E.search(y[o])!==-1){delete P[E];break}})}function j(P){P&&(delete P.DEBUG,w.$j&&delete P.DYLD_LIBRARY_PATH,w.$k&&delete P.LD_PRELOAD)}}),define(fe[6],me([0,1,5,3]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=a,e.$xc=v;const C=/^\w[\w\d+.-]*$/,M=/^\//,j=/^\/\//;function P(p,D){if(!p.scheme&&D)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${p.authority}", path: "${p.path}", query: "${p.query}", fragment: "${p.fragment}"}`);if(p.scheme&&!C.test(p.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(p.path){if(p.authority){if(!M.test(p.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(p.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(p,D){return!p&&!D?"file":p}function r(p,D){switch(p){case"https":case"http":case"file":D?D[0]!==l&&(D=l+D):D=l;break}return D}const y="",l="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class o{static isUri(D){return D instanceof o?!0:D?typeof D.authority=="string"&&typeof D.fragment=="string"&&typeof D.path=="string"&&typeof D.query=="string"&&typeof D.scheme=="string"&&typeof D.fsPath=="string"&&typeof D.with=="function"&&typeof D.toString=="function":!1}constructor(D,k,b,z,Z,T=!1){typeof D=="object"?(this.scheme=D.scheme||y,this.authority=D.authority||y,this.path=D.path||y,this.query=D.query||y,this.fragment=D.fragment||y):(this.scheme=h(D,T),this.authority=k||y,this.path=r(this.scheme,b||y),this.query=z||y,this.fragment=Z||y,P(this,T))}get fsPath(){return v(this,!1)}with(D){if(!D)return this;let{scheme:k,authority:b,path:z,query:Z,fragment:T}=D;return k===void 0?k=this.scheme:k===null&&(k=y),b===void 0?b=this.authority:b===null&&(b=y),z===void 0?z=this.path:z===null&&(z=y),Z===void 0?Z=this.query:Z===null&&(Z=y),T===void 0?T=this.fragment:T===null&&(T=y),k===this.scheme&&b===this.authority&&z===this.path&&Z===this.query&&T===this.fragment?this:new f(k,b,z,Z,T)}static parse(D,k=!1){const b=E.exec(D);return b?new f(b[2]||y,S(b[4]||y),S(b[5]||y),S(b[7]||y),S(b[9]||y),k):new f(y,y,y,y,y)}static file(D){let k=y;if(L.$i&&(D=D.replace(/\\/g,l)),D[0]===l&&D[1]===l){const b=D.indexOf(l,2);b===-1?(k=D.substring(2),D=l):(k=D.substring(2,b),D=D.substring(b)||l)}return new f("file",k,D,y,y)}static from(D,k){return new f(D.scheme,D.authority,D.path,D.query,D.fragment,k)}static joinPath(D,...k){if(!D.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return L.$i&&D.scheme==="file"?b=o.file(w.$gc.join(v(D,!0),...k)).path:b=w.$hc.join(D.path,...k),D.with({path:b})}toString(D=!1){return i(this,D)}toJSON(){return this}static revive(D){if(D){if(D instanceof o)return D;{const k=new f(D);return k._formatted=D.external??null,k._fsPath=D._sep===g?D.fsPath??null:null,k}}else return D}}e.URI=o;function a(p){return!p||typeof p!="object"?!1:typeof p.scheme=="string"&&(typeof p.authority=="string"||typeof p.authority>"u")&&(typeof p.path=="string"||typeof p.path>"u")&&(typeof p.query=="string"||typeof p.query>"u")&&(typeof p.fragment=="string"||typeof p.fragment>"u")}const g=L.$i?1:void 0;class f extends o{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=v(this,!1)),this._fsPath}toString(D=!1){return D?i(this,!0):(this._formatted||(this._formatted=i(this,!1)),this._formatted)}toJSON(){const D={$mid:1};return this._fsPath&&(D.fsPath=this._fsPath,D._sep=g),this._formatted&&(D.external=this._formatted),this.path&&(D.path=this.path),this.scheme&&(D.scheme=this.scheme),this.authority&&(D.authority=this.authority),this.query&&(D.query=this.query),this.fragment&&(D.fragment=this.fragment),D}}const n={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function s(p,D,k){let b,z=-1;for(let Z=0;Z<p.length;Z++){const T=p.charCodeAt(Z);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||D&&T===47||k&&T===91||k&&T===93||k&&T===58)z!==-1&&(b+=encodeURIComponent(p.substring(z,Z)),z=-1),b!==void 0&&(b+=p.charAt(Z));else{b===void 0&&(b=p.substr(0,Z));const R=n[T];R!==void 0?(z!==-1&&(b+=encodeURIComponent(p.substring(z,Z)),z=-1),b+=R):z===-1&&(z=Z)}}return z!==-1&&(b+=encodeURIComponent(p.substring(z))),b!==void 0?b:p}function d(p){let D;for(let k=0;k<p.length;k++){const b=p.charCodeAt(k);b===35||b===63?(D===void 0&&(D=p.substr(0,k)),D+=n[b]):D!==void 0&&(D+=p[k])}return D!==void 0?D:p}function v(p,D){let k;return p.authority&&p.path.length>1&&p.scheme==="file"?k=`//${p.authority}${p.path}`:p.path.charCodeAt(0)===47&&(p.path.charCodeAt(1)>=65&&p.path.charCodeAt(1)<=90||p.path.charCodeAt(1)>=97&&p.path.charCodeAt(1)<=122)&&p.path.charCodeAt(2)===58?D?k=p.path.substr(1):k=p.path[1].toLowerCase()+p.path.substr(2):k=p.path,L.$i&&(k=k.replace(/\//g,"\\")),k}function i(p,D){const k=D?d:s;let b="",{scheme:z,authority:Z,path:T,query:R,fragment:m}=p;if(z&&(b+=z,b+=":"),(Z||z==="file")&&(b+=l,b+=l),Z){let O=Z.indexOf("@");if(O!==-1){const $=Z.substr(0,O);Z=Z.substr(O+1),O=$.lastIndexOf(":"),O===-1?b+=k($,!1,!1):(b+=k($.substr(0,O),!1,!1),b+=":",b+=k($.substr(O+1),!1,!0)),b+="@"}Z=Z.toLowerCase(),O=Z.lastIndexOf(":"),O===-1?b+=k(Z,!1,!0):(b+=k(Z.substr(0,O),!1,!0),b+=Z.substr(O))}if(T){if(T.length>=3&&T.charCodeAt(0)===47&&T.charCodeAt(2)===58){const O=T.charCodeAt(1);O>=65&&O<=90&&(T=`/${String.fromCharCode(O+32)}:${T.substr(3)}`)}else if(T.length>=2&&T.charCodeAt(1)===58){const O=T.charCodeAt(0);O>=65&&O<=90&&(T=`${String.fromCharCode(O+32)}:${T.substr(2)}`)}b+=k(T,!0,!1)}return R&&(b+="?",b+=k(R,!1,!1)),m&&(b+="#",b+=D?m:s(m,!1,!1)),b}function t(p){try{return decodeURIComponent(p)}catch{return p.length>3?p.substr(0,3)+t(p.substr(3)):p}}const c=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function S(p){return p.match(c)?p.replace(c,D=>t(D)):p}}),define(fe[58],me([0,1,6]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=L,e.$Wq=C,e.$Xq=M,e.log=P;function L(r){const y=r;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function C(r){const y=[];let l;try{const E=JSON.parse(r.arguments),o=E[E.length-1];o&&o.__$stack&&(E.pop(),l=o.__$stack),y.push(...E)}catch{y.push("Unable to log remote console arguments",r.arguments)}return{args:y,stack:l}}function M(r){if(typeof r!="string")return M(C(r).stack);const y=r;if(y){const l=j(y),E=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(l||"");if(E&&E.length===4)return{uri:w.URI.file(E[1]),line:Number(E[2]),column:Number(E[3])}}}function j(r){if(!r)return r;const y=r.indexOf(`
`);return y===-1?r:r.substring(0,y)}function P(r,y){const{args:l,stack:E}=C(r),o=typeof l[0]=="string"&&l.length===1;let a=j(E);a&&(a=`(${a.trim()})`);let g=[];if(typeof l[0]=="string"?a&&o?g=[`%c[${y}] %c${l[0]} %c${a}`,h("blue"),h(""),h("grey")]:g=[`%c[${y}] %c${l[0]}`,h("blue"),h(""),...l.slice(1)]:g=[`%c[${y}]%`,h("blue"),...l],a&&!o&&g.push(a),typeof console[r.severity]!="function")throw new Error("Unknown console method");console[r.severity].apply(console,g)}function h(r){return`color: ${r}`}}),define(fe[59],me([0,1,18,6]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=C,e.$5h=M,e.$6h=P;function C(h){return JSON.stringify(h,j)}function M(h){let r=JSON.parse(h);return r=P(r),r}function j(h,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:r.flags}:r}function P(h,r=0){if(!h||r>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return L.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof w.$Ge||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let y=0;y<h.length;++y)h[y]=P(h[y],r+1);else for(const y in h)Object.hasOwnProperty.call(h,y)&&(h[y]=P(h[y],r+1))}return h}}),define(fe[19],me([0,1,7,3,12,6,5]),function(ae,e,w,L,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=h,e.$Gg=r,e.$Kg=l;var P;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeManagedRemoteResource="vscode-managed-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeChatCodeBlock="vscode-chat-code-block",a.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",a.vscodeChatSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm",a.commentsInput="comment",a.codeSetting="code-setting"})(P||(e.Schemas=P={}));function h(a,g){return M.URI.isUri(a)?(0,C.$yf)(a.scheme,g):(0,C.$zf)(a,g+":")}function r(a,...g){return g.some(f=>h(a,f))}e.$Hg="vscode-tkn",e.$Ig="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(g){this.d=g}setDelegate(g){this.e=g}setServerRootPath(g,f){this.f=l(g,f)}getServerRootPath(){return this.f}get g(){return j.$hc.join(this.f,P.vscodeRemoteResource)}set(g,f,n){this.a[g]=f,this.b[g]=n}setConnectionToken(g,f){this.c[g]=f}getPreferredWebSchema(){return this.d}rewrite(g){if(this.e)try{return this.e(g)}catch(i){return w.$1(i),g}const f=g.authority;let n=this.a[f];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const s=this.b[f],d=this.c[f];let v=`path=${encodeURIComponent(g.path)}`;return typeof d=="string"&&(v+=`&${e.$Ig}=${encodeURIComponent(d)}`),M.URI.from({scheme:L.$o?this.d:P.vscodeRemoteResource,authority:`${n}:${s}`,path:this.g,query:v})}}e.$Jg=new y;function l(a,g){return j.$hc.join(g??"/",`${a.quality??"oss"}-${a.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class E{static{this.a=e.$Pg}asBrowserUri(g){const f=this.b(g,ae);return this.uriToBrowserUri(f)}uriToBrowserUri(g){return g.scheme===P.vscodeRemote?e.$Jg.rewrite(g):g.scheme===P.file&&(L.$m||L.$q===`${P.vscodeFileResource}://${E.a}`)?g.with({scheme:P.vscodeFileResource,authority:g.authority||E.a,query:null,fragment:null}):g}asFileUri(g){const f=this.b(g,ae);return this.uriToFileUri(f)}uriToFileUri(g){return g.scheme===P.vscodeFileResource?g.with({scheme:P.file,authority:g.authority!==E.a?g.authority:null,query:null,fragment:null}):g}b(g,f){return M.URI.isUri(g)?g:M.URI.parse(f.toUrl(g))}}e.$Qg=new E;var o;(function(a){const g=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(g.get("3"));const f="vscode-coi";function n(d){let v;typeof d=="string"?v=new URL(d).searchParams:d instanceof URL?v=d.searchParams:M.URI.isUri(d)&&(v=new URL(d.toString(!0)).searchParams);const i=v?.get(f);if(i)return g.get(i)}a.getHeadersFromQuery=n;function s(d,v,i){if(!globalThis.crossOriginIsolated)return;const t=v&&i?"3":i?"2":"1";d instanceof URLSearchParams?d.set(f,t):d[f]=t}a.addSearchParam=s})(o||(e.COI=o={}))}),define(fe[23],me([0,1,32,19,5,3,12,6]),function(ae,e,w,L,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=h,e.$gh=y,e.$hh=E;function h(o){return(0,P.$xc)(o,!0)}class r{constructor(a){this.a=a}compare(a,g,f=!1){return a===g?0:(0,j.$rf)(this.getComparisonKey(a,f),this.getComparisonKey(g,f))}isEqual(a,g,f=!1){return a===g?!0:!a||!g?!1:this.getComparisonKey(a,f)===this.getComparisonKey(g,f)}getComparisonKey(a,g=!1){return a.with({path:this.a(a)?a.path.toLowerCase():void 0,fragment:g?null:void 0}).toString()}ignorePathCasing(a){return this.a(a)}isEqualOrParent(a,g,f=!1){if(a.scheme===g.scheme){if(a.scheme===L.Schemas.file)return w.$vg(h(a),h(g),this.a(a))&&a.query===g.query&&(f||a.fragment===g.fragment);if((0,e.$ch)(a.authority,g.authority))return w.$vg(a.path,g.path,this.a(a),"/")&&a.query===g.query&&(f||a.fragment===g.fragment)}return!1}joinPath(a,...g){return P.URI.joinPath(a,...g)}basenameOrAuthority(a){return(0,e.$7g)(a)||a.authority}basename(a){return C.$hc.basename(a.path)}extname(a){return C.$hc.extname(a.path)}dirname(a){if(a.path.length===0)return a;let g;return a.scheme===L.Schemas.file?g=P.URI.file(C.$nc(h(a))).path:(g=C.$hc.dirname(a.path),a.authority&&g.length&&g.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),g="/")),a.with({path:g})}normalizePath(a){if(!a.path.length)return a;let g;return a.scheme===L.Schemas.file?g=P.URI.file(C.$ic(h(a))).path:g=C.$hc.normalize(a.path),a.with({path:g})}relativePath(a,g){if(a.scheme!==g.scheme||!(0,e.$ch)(a.authority,g.authority))return;if(a.scheme===L.Schemas.file){const s=C.$mc(h(a),h(g));return M.$i?w.$pg(s):s}let f=a.path||"/";const n=g.path||"/";if(this.a(a)){let s=0;for(const d=Math.min(f.length,n.length);s<d&&!(f.charCodeAt(s)!==n.charCodeAt(s)&&f.charAt(s).toLowerCase()!==n.charAt(s).toLowerCase());s++);f=n.substr(0,s)+f.substr(s)}return C.$hc.relative(f,n)}resolvePath(a,g){if(a.scheme===L.Schemas.file){const f=P.URI.file(C.$lc(h(a),g));return a.with({authority:f.authority,path:f.path})}return g=w.$qg(g),a.with({path:C.$hc.resolve(a.path,g)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,g){return a===g||a!==void 0&&g!==void 0&&(0,j.$yf)(a,g)}hasTrailingPathSeparator(a,g=C.sep){if(a.scheme===L.Schemas.file){const f=h(a);return f.length>w.$rg(f).length&&f[f.length-1]===g}else{const f=a.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,g=C.sep){return(0,e.$dh)(a,g)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,g=C.sep){let f=!1;if(a.scheme===L.Schemas.file){const n=h(a);f=n!==void 0&&n.length===w.$rg(n).length&&n[n.length-1]===g}else{g="/";const n=a.path;f=n.length===1&&n.charCodeAt(n.length-1)===47}return!f&&!(0,e.$dh)(a,g)?a.with({path:a.path+"/"}):a}}e.$Yg=r,e.$Zg=new r(()=>!1),e.$1g=new r(o=>o.scheme===L.Schemas.file?!M.$k:!0),e.$2g=new r(o=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function y(o,a){const g=[];for(let f=0;f<o.length;f++){const n=a(o[f]);o.some((s,d)=>d===f?!1:(0,e.$4g)(n,a(s)))||g.push(o[f])}return g}var l;(function(o){o.META_DATA_LABEL="label",o.META_DATA_DESCRIPTION="description",o.META_DATA_SIZE="size",o.META_DATA_MIME="mime";function a(g){const f=new Map;g.path.substring(g.path.indexOf(";")+1,g.path.lastIndexOf(";")).split(";").forEach(d=>{const[v,i]=d.split(":");v&&i&&f.set(v,i)});const s=g.path.substring(0,g.path.indexOf(";"));return s&&f.set(o.META_DATA_MIME,s),f}o.parseMetaData=a})(l||(e.DataUri=l={}));function E(o,a,g){if(a){let f=o.path;return f&&f[0]!==C.$hc.sep&&(f=C.$hc.sep+f),o.with({scheme:g,authority:a,path:f})}return o.with({scheme:g})}}),define(fe[11],me([0,1,17,7,4,2,23,3,50,22]),function(ae,e,w,L,C,M,j,P,h,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=y,e.$jh=l,e.$kh=E,e.$lh=o,e.$mh=a,e.$nh=g,e.$oh=f,e.$ph=n,e.$xh=k,e.$yh=b,e.$zh=z,e.$Ah=Z,e.$Bh=T,e.$Qh=q,e.$Yh=H;function y(F){return!!F&&typeof F.then=="function"}function l(F){const I=new w.$pe,W=F(I.token),x=new Promise((se,re)=>{const he=I.token.onCancellationRequested(()=>{he.dispose(),re(new L.$5)});Promise.resolve(W).then(pe=>{he.dispose(),I.dispose(),se(pe)},pe=>{he.dispose(),I.dispose(),re(pe)})});return new class{cancel(){I.cancel(),I.dispose()}then(se,re){return x.then(se,re)}catch(se){return this.then(void 0,se)}finally(se){return x.finally(se)}}}function E(F,I,W){return new Promise((x,se)=>{const re=I.onCancellationRequested(()=>{re.dispose(),x(W)});F.then(x,se).finally(()=>re.dispose())})}function o(F,I){return new Promise((W,x)=>{const se=I.onCancellationRequested(()=>{se.dispose(),x(new L.$5)});F.then(W,x).finally(()=>se.dispose())})}async function a(F){let I=-1;const W=F.map((x,se)=>x.then(re=>(I=se,re)));try{return await Promise.race(W)}finally{F.forEach((x,se)=>{se!==I&&x.cancel()})}}function g(F,I,W){let x;const se=setTimeout(()=>{x?.(void 0),W?.()},I);return Promise.race([F.finally(()=>clearTimeout(se)),new Promise(re=>x=re)])}function f(F){return new Promise((I,W)=>{const x=F();y(x)?x.then(I,W):I(x)})}function n(){let F,I;return{promise:new Promise((x,se)=>{F=x,I=se}),resolve:F,reject:I}}class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(I){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=I,!this.b){const W=()=>{if(this.b=null,this.f)return;const x=this.queue(this.d);return this.d=null,x};this.b=new Promise(x=>{this.a.then(W,W).then(x)})}return new Promise((W,x)=>{this.b.then(W,x)})}return this.a=I(),new Promise((W,x)=>{this.a.then(se=>{this.a=null,W(se)},se=>{this.a=null,x(se)})})}dispose(){this.f=!0}}e.$qh=s;class d{constructor(){this.a=Promise.resolve(null)}queue(I){return this.a=this.a.then(()=>I(),()=>I())}}e.$rh=d;class v{constructor(){this.a=new Map}queue(I,W){const se=(this.a.get(I)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.a.get(I)===se&&this.a.delete(I)});return this.a.set(I,se),se}}e.$sh=v;const i=(F,I)=>{let W=!0;const x=setTimeout(()=>{W=!1,I()},F);return{isTriggered:()=>W,dispose:()=>{clearTimeout(x),W=!1}}},t=F=>{let I=!0;return queueMicrotask(()=>{I&&(I=!1,F())}),{isTriggered:()=>I,dispose:()=>{I=!1}}};class c{constructor(I){this.defaultDelay=I,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(I,W=this.defaultDelay){this.g=I,this.h(),this.b||(this.b=new Promise((se,re)=>{this.d=se,this.f=re}).then(()=>{if(this.b=null,this.d=null,this.g){const se=this.g;return this.g=null,se()}}));const x=()=>{this.a=null,this.d?.(null)};return this.a=W===h.$be?t(x):i(W,x),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=c;class S{constructor(I){this.a=new c(I),this.b=new s}trigger(I,W){return this.a.trigger(()=>this.b.queue(I),W)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=S;class p{constructor(){this.a=!1,this.b=new Promise((I,W)=>{this.d=I})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=p;class D extends p{constructor(I){super(),this.f=setTimeout(()=>this.open(),I)}open(){clearTimeout(this.f),super.open()}}e.$wh=D;function k(F,I){return I?new Promise((W,x)=>{const se=setTimeout(()=>{re.dispose(),W()},F),re=I.onCancellationRequested(()=>{clearTimeout(se),re.dispose(),x(new L.$5)})}):l(W=>k(F,W))}function b(F,I=0,W){const x=setTimeout(()=>{F(),W&&se.dispose()},I),se=(0,M.$Tc)(()=>{clearTimeout(x),W?.deleteAndLeak(se)});return W?.add(se),se}function z(F){const I=[];let W=0;const x=F.length;function se(){return W<x?F[W++]():null}function re(he){he!=null&&I.push(he);const pe=se();return pe?pe.then(re):Promise.resolve(I)}return Promise.resolve(null).then(re)}function Z(F,I=x=>!!x,W=null){let x=0;const se=F.length,re=()=>{if(x>=se)return Promise.resolve(W);const he=F[x++];return Promise.resolve(he()).then($e=>I($e)?Promise.resolve($e):re())};return re()}function T(F,I=x=>!!x,W=null){if(F.length===0)return Promise.resolve(W);let x=F.length;const se=()=>{x=-1;for(const re of F)re.cancel?.()};return new Promise((re,he)=>{for(const pe of F)pe.then($e=>{--x>=0&&I($e)?(se(),re($e)):x===0&&re(W)}).catch($e=>{--x>=0&&(se(),he($e))})})}class R{constructor(I){this.a=0,this.b=!1,this.f=I,this.g=[],this.d=0,this.h=new C.$ee}whenIdle(){return this.size>0?C.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(I){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((W,x)=>{this.g.push({factory:I,c:W,e:x}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const I=this.g.shift();this.d++;const W=I.factory();W.then(I.c,I.e),W.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=R;class m extends R{constructor(){super(1)}}e.$Dh=m;class O{constructor(){this.a=new Q,this.b=0}queue(I){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,I())):this.a.run(this.b++,I())}}e.$Eh=O;class ${constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const I=new B;return this.b.add(I),I.p}g(){for(const[,I]of this.a)if(I.size>0)return!1;return!0}queueSize(I,W=j.$Zg){const x=W.getComparisonKey(I);return this.a.get(x)?.size??0}queueFor(I,W,x=j.$Zg){const se=x.getComparisonKey(I);let re=this.a.get(se);if(!re){re=new m;const he=this.f++,pe=C.Event.once(re.onDrained)(()=>{re?.dispose(),this.a.delete(se),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$5c),this.d.set(he,pe),this.a.set(se,re)}return re.queue(W)}h(){this.g()&&this.j()}j(){for(const I of this.b)I.complete();this.b.clear()}dispose(){for(const[,I]of this.a)I.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=$;class A{constructor(I,W){this.a=-1,typeof I=="function"&&typeof W=="number"&&this.setIfNotSet(I,W)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(I,W){this.cancel(),this.a=setTimeout(()=>{this.a=-1,I()},W)}setIfNotSet(I,W){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,I()},W))}}e.$Gh=A;class Y{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(I,W,x=globalThis){this.cancel();const se=x.setInterval(()=>{I()},W);this.d=(0,M.$Tc)(()=>{x.clearInterval(se),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=Y;class te{constructor(I,W){this.b=-1,this.a=I,this.d=W,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(I=this.d){this.cancel(),this.b=setTimeout(this.f,I)}get delay(){return this.d}set delay(I){this.d=I}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=te;class G{constructor(I,W){W%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.a=I,this.b=W,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(I=this.b){I%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${I}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(I/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=G;class ee extends te{constructor(I,W){super(I,W),this.j=[]}work(I){this.j.push(I),this.isScheduled()||this.schedule()}h(){const I=this.j;this.j=[],this.a?.(I)}dispose(){this.j=[],super.dispose()}}e.$Kh=ee;class ce extends M.$Vc{constructor(I,W){super(),this.g=I,this.h=W,this.a=[],this.b=this.B(new M.$Wc),this.f=!1}get pending(){return this.a.length}work(I){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+I.length>this.g.maxBufferedWork)return!1}else if(this.pending+I.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const W of I)this.a.push(W);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=ce,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(F,I)=>{(0,P.$B)(()=>{if(W)return;const x=Date.now()+15;I(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let W=!1;return{dispose(){W||(W=!0)}}}:e.$Nh=(F,I,W)=>{const x=F.requestIdleCallback(I,typeof W=="number"?{timeout:W}:void 0);let se=!1;return{dispose(){se||(se=!0,F.cancelIdleCallback(x))}}},e.$Mh=F=>(0,e.$Nh)(globalThis,F)}();class ue{constructor(I,W){this.g=!1,this.d=()=>{try{this.j=W()}catch(x){this.l=x}finally{this.g=!0}},this.f=(0,e.$Nh)(I,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=ue;class X extends ue{constructor(I){super(globalThis,I)}}e.$Ph=X;async function q(F,I,W){let x;for(let se=0;se<W;se++)try{return await F()}catch(re){x=re,await k(I)}throw x}class Q{isRunning(I){return typeof I=="number"?this.a?.taskId===I:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(I,W,x){return this.a={taskId:I,cancel:()=>x?.(),promise:W},W.then(()=>this.d(I),()=>this.d(I)),W}d(I){this.a&&I===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const I=this.b;this.b=void 0,I.run().then(I.promiseResolve,I.promiseReject)}}queue(I){if(this.b)this.b.run=I;else{const{promise:W,resolve:x,reject:se}=n();this.b={run:I,promise:W,promiseResolve:x,promiseReject:se}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=Q;class K{constructor(I,W=()=>Date.now()){this.d=I,this.f=W,this.a=0,this.b=0}increment(){const I=this.f();return I-this.a>this.d&&(this.a=I,this.b=0),this.b++,this.b}}e.$Sh=K;var de;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(de||(de={}));class B{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((I,W)=>{this.a=I,this.b=W})}complete(I){return new Promise(W=>{this.a(I),this.d={outcome:0,value:I},W()})}error(I){return new Promise(W=>{this.b(I),this.d={outcome:1,value:I},W()})}cancel(){return this.error(new L.$5)}}e.$Th=B;var le;(function(F){async function I(x){let se;const re=await Promise.all(x.map(he=>he.then(pe=>pe,pe=>{se||(se=pe)})));if(typeof se<"u")throw se;return re}F.settled=I;function W(x){return new Promise(async(se,re)=>{try{await x(se,re)}catch(he){re(he)}})}F.withAsyncBody=W})(le||(e.Promises=le={}));class _{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(I){this.a=void 0,this.b=void 0,this.d=!1,this.promise=I.then(W=>(this.a=W,this.d=!0,W),W=>{throw this.b=W,this.d=!0,W})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=_;class u{constructor(I){this.b=I,this.a=new r.$V(()=>new _(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=u;var N;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(N||(N={}));class ie{static fromArray(I){return new ie(W=>{W.emitMany(I)})}static fromPromise(I){return new ie(async W=>{W.emitMany(await I)})}static fromPromises(I){return new ie(async W=>{await Promise.all(I.map(async x=>W.emitOne(await x)))})}static merge(I){return new ie(async W=>{await Promise.all(I.map(async x=>{for await(const se of x)W.emitOne(se)}))})}static{this.EMPTY=ie.fromArray([])}constructor(I,W){this.a=0,this.b=[],this.d=null,this.f=W,this.g=new C.$ee,queueMicrotask(async()=>{const x={emitOne:se=>this.h(se),emitMany:se=>this.j(se),reject:se=>this.l(se)};try{await Promise.resolve(I(x)),this.k()}catch(se){this.l(se)}finally{x.emitOne=void 0,x.emitMany=void 0,x.reject=void 0}})}[Symbol.asyncIterator](){let I=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(I<this.b.length)return{done:!1,value:this.b[I++]};if(this.a===1)return{done:!0,value:void 0};await C.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(I,W){return new ie(async x=>{for await(const se of I)x.emitOne(W(se))})}map(I){return ie.map(this,I)}static filter(I,W){return new ie(async x=>{for await(const se of I)W(se)&&x.emitOne(se)})}filter(I){return ie.filter(this,I)}static coalesce(I){return ie.filter(I,W=>!!W)}coalesce(){return ie.coalesce(this)}static async toPromise(I){const W=[];for await(const x of I)W.push(x);return W}toPromise(){return ie.toPromise(this)}h(I){this.a===0&&(this.b.push(I),this.g.fire())}j(I){this.a===0&&(this.b=this.b.concat(I),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(I){this.a===0&&(this.a=2,this.d=I,this.g.fire())}}e.$Wh=ie;class ne extends ie{constructor(I,W){super(W),this.m=I}cancel(){this.m.cancel()}}e.$Xh=ne;function H(F){const I=new w.$pe,W=F(I.token);return new ne(I,async x=>{const se=I.token.onCancellationRequested(()=>{se.dispose(),I.dispose(),x.reject(new L.$5)});try{for await(const re of W){if(I.token.isCancellationRequested)return;x.emitOne(re)}se.dispose(),I.dispose()}catch(re){se.dispose(),I.dispose(),x.reject(re)}})}class V{constructor(I){this.a=new B,this.b=new ie(se=>{if(W){se.reject(W);return}return x&&se.emitMany(x),this.d=re=>se.reject(re),this.f=re=>se.emitOne(re),this.a.p},I);let W,x;this.f=se=>{x||(x=[]),x.push(se)},this.d=se=>{W||(W=se)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(I){this.d(I),this.a.complete()}emitOne(I){this.f(I)}}e.$Zh=V}),define(fe[60],me([0,1,18,6]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=P,e.$Bn=r,e.$Cn=y;function C(l){return l.toJSON()}class M{constructor(E){this.a=E}transformIncoming(E){const o=this.a.transformIncoming(E);return o===E?E:C(L.URI.from(o))}transformOutgoing(E){const o=this.a.transformOutgoing(E);return o===E?E:C(L.URI.from(o))}transformOutgoingURI(E){const o=this.a.transformOutgoing(E);return o===E?E:L.URI.from(o)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.$yn=M,e.$zn=new class{transformIncoming(l){return l}transformOutgoing(l){return l}transformOutgoingURI(l){return l}transformOutgoingScheme(l){return l}};function j(l,E,o){if(!l||o>200)return null;if(typeof l=="object"){if(l instanceof L.URI)return E.transformOutgoing(l);for(const a in l)if(Object.hasOwnProperty.call(l,a)){const g=j(l[a],E,o+1);g!==null&&(l[a]=g)}}return null}function P(l,E){const o=j(l,E,0);return o===null?l:o}function h(l,E,o,a){if(!l||a>200)return null;if(typeof l=="object"){if(l.$mid===1)return o?L.URI.revive(E.transformIncoming(l)):E.transformIncoming(l);if(l instanceof w.$Ge)return null;for(const g in l)if(Object.hasOwnProperty.call(l,g)){const f=h(l[g],E,o,a+1);f!==null&&(l[g]=f)}}return null}function r(l,E){const o=h(l,E,!1,0);return o===null?l:o}function y(l,E){const o=h(l,E,!0,0);return o===null?l:o}}),define(fe[24],me([0,1,106,20,107,11,32,45,5,3,23,6]),function(ae,e,w,L,C,M,j,P,h,r,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=d,e.whenDeleted=t,e.configureFlushOnWrite=k,e.writeFileSync=z;var E;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function o(G,ee=E.UNLINK,ce){if((0,j.$zg)(G))throw new Error("rimraf - will refuse to recursively delete root");return ee===E.UNLINK?g(G):a(G,ce)}async function a(G,ee=(0,j.$Eg)((0,L.tmpdir)())){try{try{await w.promises.rename(G,ee)}catch(ce){return ce.code==="ENOENT"?void 0:g(G)}g(ee).catch(ce=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function g(G){return(0,C.promisify)(w.rm)(G,{recursive:!0,force:!0,maxRetries:3})}function f(G){if((0,j.$zg)(G))throw new Error("rimraf - will refuse to recursively delete root");w.rmSync(G,{recursive:!0,force:!0,maxRetries:3})}async function n(G,ee){return v(await(ee?s(G):(0,C.promisify)(w.readdir)(G)))}async function s(G){try{return await(0,C.promisify)(w.readdir)(G,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const ee=[],ce=await n(G);for(const ue of ce){let X=!1,q=!1,Q=!1;try{const K=await e.Promises.lstat((0,h.$kc)(G,ue));X=K.isFile(),q=K.isDirectory(),Q=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}ee.push({name:ue,isFile:()=>X,isDirectory:()=>q,isSymbolicLink:()=>Q})}return ee}function d(G){return v(w.readdirSync(G))}function v(G){return G.map(ee=>typeof ee=="string"?r.$j?(0,P.$bm)(ee):ee:(ee.name=r.$j?(0,P.$bm)(ee.name):ee.name,ee))}async function i(G){const ee=await n(G),ce=[];for(const ue of ee)await c.existsDirectory((0,h.$kc)(G,ue))&&ce.push(ue);return ce}function t(G,ee=1e3){return new Promise(ce=>{let ue=!1;const X=setInterval(()=>{ue||(ue=!0,w.access(G,q=>{ue=!1,q&&(clearInterval(X),ce(void 0))}))},ee)})}var c;(function(G){async function ee(X){let q;try{if(q=await e.Promises.lstat(X),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(r.$i&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw K}throw Q}}G.stat=ee;async function ce(X){try{const{stat:q,symbolicLink:Q}=await G.stat(X);return q.isFile()&&Q?.dangling!==!0}catch{}return!1}G.existsFile=ce;async function ue(X){try{const{stat:q,symbolicLink:Q}=await G.stat(X);return q.isDirectory()&&Q?.dangling!==!0}catch{}return!1}G.existsDirectory=ue})(c||(e.SymlinkSupport=c={}));const S=new M.$Fh;function p(G,ee,ce){return S.queueFor(l.URI.file(G),()=>{const ue=Z(ce);return new Promise((X,q)=>b(G,ee,ue,Q=>Q?q(Q):X()))},y.$1g)}let D=!0;function k(G){D=G}function b(G,ee,ce,ue){if(!D)return w.writeFile(G,ee,{mode:ce.mode,flag:ce.flag},ue);w.open(G,ce.flag,ce.mode,(X,q)=>{if(X)return ue(X);w.writeFile(q,ee,Q=>{if(Q)return w.close(q,()=>ue(Q));w.fdatasync(q,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),k(!1)),w.close(q,de=>ue(de))))})})}function z(G,ee,ce){const ue=Z(ce);if(!D)return w.writeFileSync(G,ee,{mode:ue.mode,flag:ue.flag});const X=w.openSync(G,ue.flag,ue.mode);try{w.writeFileSync(X,ee);try{w.fdatasyncSync(X)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),k(!1)}}finally{w.closeSync(X)}}function Z(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function T(G,ee,ce=6e4){if(G!==ee)try{r.$i&&typeof ce=="number"?await R(G,ee,Date.now(),ce):await(0,C.promisify)(w.rename)(G,ee)}catch(ue){if(G.toLowerCase()!==ee.toLowerCase()&&ue.code==="EXDEV"||G.endsWith("."))await m(G,ee,{preserveSymlinks:!1}),await o(G,E.MOVE);else throw ue}}async function R(G,ee,ce,ue,X=0){try{return await(0,C.promisify)(w.rename)(G,ee)}catch(q){if(q.code!=="EACCES"&&q.code!=="EPERM"&&q.code!=="EBUSY")throw q;if(Date.now()-ce>=ue)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${q}`),q;if(X===0){let Q=!1;try{const{stat:K}=await c.stat(ee);K.isFile()||(Q=!0)}catch{}if(Q)throw q}return await(0,M.$xh)(Math.min(100,X*10)),R(G,ee,ce,ue,X+1)}}async function m(G,ee,ce){return $(G,ee,{root:{source:G,target:ee},options:ce,handledSourcePaths:new Set})}const O=511;async function $(G,ee,ce){if(ce.handledSourcePaths.has(G))return;ce.handledSourcePaths.add(G);const{stat:ue,symbolicLink:X}=await c.stat(G);if(X){if(ce.options.preserveSymlinks)try{return await te(G,ee,ce)}catch{}if(X.dangling)return}return ue.isDirectory()?A(G,ee,ue.mode&O,ce):Y(G,ee,ue.mode&O)}async function A(G,ee,ce,ue){await e.Promises.mkdir(ee,{recursive:!0,mode:ce});const X=await n(G);for(const q of X)await $((0,h.$kc)(G,q),(0,h.$kc)(ee,q),ue)}async function Y(G,ee,ce){await e.Promises.copyFile(G,ee),await e.Promises.chmod(ee,ce)}async function te(G,ee,ce){let ue=await e.Promises.readlink(G);(0,j.$vg)(ue,ce.root.source,!r.$k)&&(ue=(0,h.$kc)(ce.root.target,ue.substr(ce.root.source.length+1))),await e.Promises.symlink(ue,ee)}e.Promises=new class{get access(){return(0,C.promisify)(w.access)}get stat(){return(0,C.promisify)(w.stat)}get lstat(){return(0,C.promisify)(w.lstat)}get utimes(){return(0,C.promisify)(w.utimes)}get read(){return(G,ee,ce,ue,X)=>new Promise((q,Q)=>{w.read(G,ee,ce,ue,X,(K,de,B)=>K?Q(K):q({bytesRead:de,buffer:B}))})}get readFile(){return(0,C.promisify)(w.readFile)}get write(){return(G,ee,ce,ue,X)=>new Promise((q,Q)=>{w.write(G,ee,ce,ue,X,(K,de,B)=>K?Q(K):q({bytesWritten:de,buffer:B}))})}get appendFile(){return(0,C.promisify)(w.appendFile)}get fdatasync(){return(0,C.promisify)(w.fdatasync)}get truncate(){return(0,C.promisify)(w.truncate)}get copyFile(){return(0,C.promisify)(w.copyFile)}get open(){return(0,C.promisify)(w.open)}get close(){return(0,C.promisify)(w.close)}get symlink(){return(0,C.promisify)(w.symlink)}get readlink(){return(0,C.promisify)(w.readlink)}get chmod(){return(0,C.promisify)(w.chmod)}get mkdir(){return(0,C.promisify)(w.mkdir)}get unlink(){return(0,C.promisify)(w.unlink)}get rmdir(){return(0,C.promisify)(w.rmdir)}get realpath(){return(0,C.promisify)(w.realpath)}async exists(G){try{return await e.Promises.access(G),!0}catch{return!1}}get readdir(){return n}get readDirsInDir(){return i}get writeFile(){return p}get rm(){return o}get rename(){return T}get copy(){return m}}}),define(fe[61],me([0,1,20,5,24]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=s,e.$lm=d;const M=/^\d+$/,j=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var h;(function(v){v[v.x64=0]="x64",v[v.x86=1]="x86",v[v.ARM=2]="ARM"})(h||(h={}));let r;switch(process.arch){case"ia32":r=1;break;case"arm":case"arm64":r=2;break;default:r=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class l{constructor(i,t,c){this.exePath=i,this.displayName=t,this.a=c}async exists(){return this.a===void 0&&(this.a=await C.SymlinkSupport.existsFile(this.exePath)),this.a}}function E({useAlternateBitness:v=!1}={}){return v?r===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function o({useAlternateBitness:v=!1,findPreview:i=!1}={}){const t=E({useAlternateBitness:v});if(!t)return null;const c=L.$kc(t,"PowerShell");if(!await C.SymlinkSupport.existsDirectory(c))return null;let S=-1,p=null;for(const b of await C.Promises.readdir(c)){let z=-1;if(i){const T=b.indexOf("-");if(T<0)continue;const R=b.substring(0,T);if(!M.test(R)||b.substring(T+1)!=="preview")continue;z=parseInt(R,10)}else{if(!M.test(b))continue;z=parseInt(b,10)}if(z<=S)continue;const Z=L.$kc(c,b,"pwsh.exe");await C.SymlinkSupport.existsFile(Z)&&(p=Z,S=z)}if(!p)return null;const D=t.includes("x86")?" (x86)":"",k=i?" Preview":"";return new l(p,`PowerShell${k}${D}`,!0)}async function a({findPreview:v}={}){if(!process.env.LOCALAPPDATA)return null;const i=L.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await C.SymlinkSupport.existsDirectory(i))return null;const{pwshMsixDirRegex:t,pwshMsixName:c}=v?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const S of await C.Promises.readdir(i))if(t.test(S)){const p=L.$kc(i,S,"pwsh.exe");return new l(p,c)}return null}function g(){const v=L.$kc(w.homedir(),".dotnet","tools","pwsh.exe");return new l(v,".NET Core PowerShell Global Tool")}function f(){const v=L.$kc(process.env.windir,r===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new l(v,"Windows PowerShell",!0)}async function*n(){let v=await o();v&&(yield v),v=await o({useAlternateBitness:!0}),v&&(yield v),v=await a(),v&&(yield v),v=g(),v&&(yield v),v=await o({findPreview:!0}),v&&(yield v),v=await a({findPreview:!0}),v&&(yield v),v=await o({useAlternateBitness:!0,findPreview:!0}),v&&(yield v),v=f(),v&&(yield v)}async function*s(){for await(const v of n())await v.exists()&&(yield v)}async function d(){for await(const v of s())return v;return null}}),define(fe[34],me([0,1,5,3,15,33,9,24]),function(ae,e,w,L,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=h,e.$pm=r,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return M.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return M.TerminateResponseCode}});function h(l=C.env){return l.comspec||"cmd.exe"}function r(l){let E=[],o=!1;const a=function(g){if(o){E.push(g);return}(!l.send(g,n=>{if(n&&console.error(n),o=!1,E.length>0){const s=E.slice(0);E=[],s.forEach(d=>a(d))}})||L.$i)&&(o=!0)};return{send:a}}var y;(function(l){async function E(o,a,g){if(w.$jc(o))return o;if(a===void 0&&(a=C.cwd()),w.$nc(o)!=="."||(g===void 0&&j.$9f(C.env.PATH)&&(g=C.env.PATH.split(w.$uc)),g===void 0||g.length===0))return w.$kc(a,o);async function n(s){if(await P.Promises.exists(s)){let d;try{d=await P.Promises.stat(s)}catch(v){v.message.startsWith("EACCES")&&(d=await P.Promises.lstat(s))}return d?!d.isDirectory():!1}return!1}for(const s of g){let d;if(w.$jc(s)?d=w.$kc(s,o):d=w.$kc(a,s,o),await n(d))return d;let v=d+".com";if(await n(v)||(v=d+".exe",await n(v)))return v}return w.$kc(a,o)}l.findExecutable=E})(y||(e.win32=y={}))}),define(fe[62],me([0,1,26,19]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=C;function C(j){return new Promise((P,h)=>{let r;const y=new Map;function l(o,a,g,f,n){const s=y.get(a);if(o===j||s){const d={name:E(g),cmd:g,pid:o,ppid:a,load:f,mem:n};y.set(o,d),o===j&&(r=d),s&&(s.children||(s.children=[]),s.children.push(d),s.children.length>1&&(s.children=s.children.sort((v,i)=>v.pid-i.pid)))}}function E(o){const a=/--utility-sub-type=network/i,g=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,n=/conhost\.exe.+--headless/i,s=/--type=([a-zA-Z-]+)/;if(g.exec(o))return"electron-crash-reporter";if(f.exec(o))return"winpty-agent";if(n.exec(o))return"conpty-agent";let d=s.exec(o);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?a.exec(o)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const v=/[a-zA-Z-]+\.js/g;let i="";do d=v.exec(o),d&&(i+=d+" ");while(d);return i&&o.indexOf("node ")<0&&o.indexOf("node.exe")<0?`electron-nodejs (${i})`:o}if(process.platform==="win32"){const o=a=>a.indexOf("\\\\?\\")===0||a.indexOf("\\??\\")===0?a.substring(4):a.indexOf('"\\\\?\\')===0||a.indexOf('"\\??\\')===0?'"'+a.substring(5):a;new Promise((a,g)=>{ae(["@vscode/windows-process-tree"],a,g)}).then(a=>{a.getProcessList(j,g=>{if(!g){h(new Error(`Root process ${j} not found`));return}a.getProcessCpuUsage(g,f=>{const n=new Map;f.forEach(s=>{const d=o(s.commandLine||"");n.set(s.pid,{name:E(d),cmd:d,pid:s.pid,ppid:s.ppid,load:s.cpu||0,mem:s.memory||0})}),r=n.get(j),r?(n.forEach(s=>{const d=n.get(s.ppid);d&&(d.children||(d.children=[]),d.children.push(s))}),n.forEach(s=>{s.children&&(s.children=s.children.sort((d,v)=>d.pid-v.pid))}),P(r)):h(new Error(`Root process ${j} not found`))})},a.ProcessDataFlag.CommandLine|a.ProcessDataFlag.Memory)})}else{let o=function(){let a=[r];const g=[];for(;a.length;){const n=a.shift();n&&(g.push(n.pid),n.children&&(a=a.concat(n.children)))}let f=JSON.stringify(L.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+g.join(" "),(0,w.exec)(f,{},(n,s,d)=>{if(n||d)h(n||new Error(d.toString()));else{const v=s.toString().split(`
`);for(let i=0;i<g.length;i++){const t=y.get(g[i]);t.load=parseFloat(v[i])}if(!r){h(new Error(`Root process ${j} not found`));return}P(r)}})};(0,w.exec)("which ps",{},(a,g,f)=>{if(a||f)if(process.platform!=="linux")h(a||new Error(f.toString()));else{const n=JSON.stringify(L.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,w.exec)(n,{},(s,d,v)=>{s||v?h(s||new Error(v.toString())):(M(d,l),o())})}else{const n=g.toString().trim();(0,w.exec)(`${n} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,v,i)=>{d||i&&!i.includes("screen size is bogus")?h(d||new Error(i.toString())):(M(v,l),process.platform==="linux"?o():r?P(r):h(new Error(`Root process ${j} not found`)))})}})}})}function M(j,P){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,r=j.toString().split(`
`);for(const y of r){const l=h.exec(y.trim());l&&l.length===6&&P(parseInt(l[1]),parseInt(l[2]),l[5],parseFloat(l[3]),parseFloat(l[4]))}}}),define(fe[63],me([0,1,20,3,61,34]),function(ae,e,w,L,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=j;async function j(l,E){return l===1?L.$i?y():M.$om(E):h(l,E)}let P=null;function h(l,E){if(L.$k&&l===2||L.$j&&l===3)return"/bin/bash";if(!P){let o;if(L.$i)o="/bin/bash";else{if(o=E.SHELL,!o)try{o=(0,w.userInfo)().shell}catch{}o||(o="sh"),o==="/bin/false"&&(o="/bin/bash")}P=o}return P}let r=null;async function y(){return r||(r=(await(0,C.$lm)()).exePath),r}});var be=this&&this.__decorate||function(ae,e,w,L){var C=arguments.length,M=C<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,w):L,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(ae,e,w,L);else for(var P=ae.length-1;P>=0;P--)(j=ae[P])&&(M=(C<3?j(M):C>3?j(e,w,M):j(e,w))||M);return C>3&&M&&Object.defineProperty(e,w,M),M};define(fe[27],me([0,1,16,11,18,17,14,7,4,2,59,12,9]),function(ae,e,w,L,C,M,j,P,h,r,y,l,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=k,e.$0h=b,e.$ci=O,e.$di=$;var o;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(o||(o={}));function a(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var g;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(g||(g={}));function f(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var n;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(n||(n={}));function s(X){let q=0;for(let Q=0;;Q+=7){const K=X.read(1);if(q|=(K.buffer[0]&127)<<Q,!(K.buffer[0]&128))return q}}const d=S(0);function v(X,q){if(q===0){X.write(d);return}let Q=0;for(let de=q;de!==0;de=de>>>7)Q++;const K=C.$Ge.alloc(Q);for(let de=0;q!==0;de++)K.buffer[de]=q&127,q=q>>>7,q>0&&(K.buffer[de]|=128);X.write(K)}class i{constructor(q){this.b=q,this.a=0}read(q){const Q=this.b.slice(this.a,this.a+q);return this.a+=Q.byteLength,Q}}e.$7h=i;class t{constructor(){this.a=[]}get buffer(){return C.$Ge.concat(this.a)}write(q){this.a.push(q)}}e.$8h=t;var c;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(c||(c={}));function S(X){const q=C.$Ge.alloc(1);return q.writeUInt8(X,0),q}const p={Undefined:S(c.Undefined),String:S(c.String),Buffer:S(c.Buffer),VSBuffer:S(c.VSBuffer),Array:S(c.Array),Object:S(c.Object),Uint:S(c.Int)},D=typeof Buffer<"u";function k(X,q){if(typeof q>"u")X.write(p.Undefined);else if(typeof q=="string"){const Q=C.$Ge.fromString(q);X.write(p.String),v(X,Q.byteLength),X.write(Q)}else if(D&&Buffer.isBuffer(q)){const Q=C.$Ge.wrap(q);X.write(p.Buffer),v(X,Q.byteLength),X.write(Q)}else if(q instanceof C.$Ge)X.write(p.VSBuffer),v(X,q.byteLength),X.write(q);else if(Array.isArray(q)){X.write(p.Array),v(X,q.length);for(const Q of q)k(X,Q)}else if(typeof q=="number"&&(q|0)===q)X.write(p.Uint),v(X,q);else{const Q=C.$Ge.fromString(JSON.stringify(q));X.write(p.Object),v(X,Q.byteLength),X.write(Q)}}function b(X){switch(X.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return X.read(s(X)).toString();case c.Buffer:return X.read(s(X)).buffer;case c.VSBuffer:return X.read(s(X));case c.Array:{const Q=s(X),K=[];for(let de=0;de<Q;de++)K.push(b(X));return K}case c.Object:return JSON.parse(X.read(s(X)).toString());case c.Int:return s(X)}}class z{constructor(q,Q,K=null,de=1e3){this.h=q,this.j=Q,this.k=K,this.l=de,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(B=>this.q(B)),this.m({type:200})}registerChannel(q,Q){this.b.set(q,Q),setTimeout(()=>this.w(q),0)}m(q){switch(q.type){case 200:{const Q=this.o([q.type]);this.k?.logOutgoing(Q,0,1,f(q.type));return}case 201:case 202:case 204:case 203:{const Q=this.o([q.type,q.id],q.data);this.k?.logOutgoing(Q,q.id,1,f(q.type),q.data);return}}}o(q,Q=void 0){const K=new t;return k(K,q),k(K,Q),this.p(K.buffer)}p(q){try{return this.h.send(q),q.byteLength}catch{return 0}}q(q){const Q=new i(q),K=b(Q),de=b(Q),B=K[0];switch(B){case 100:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}: ${K[2]}.${K[3]}`,de),this.s({type:B,id:K[1],channelName:K[2],name:K[3],arg:de});case 102:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}: ${K[2]}.${K[3]}`,de),this.t({type:B,id:K[1],channelName:K[2],name:K[3],arg:de});case 101:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}`),this.u({type:B,id:K[1]});case 103:return this.k?.logIncoming(q.byteLength,K[1],1,`${a(B)}`),this.u({type:B,id:K[1]})}}s(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const K=new M.$pe;let de;try{de=Q.call(this.j,q.name,q.arg,K.token)}catch(_){de=Promise.reject(_)}const B=q.id;de.then(_=>{this.m({id:B,data:_,type:201})},_=>{_ instanceof Error?this.m({id:B,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:B,data:_,type:203})}).finally(()=>{le.dispose(),this.d.delete(q.id)});const le=(0,r.$Tc)(()=>K.cancel());this.d.set(q.id,le)}t(q){const Q=this.b.get(q.channelName);if(!Q){this.v(q);return}const K=q.id,B=Q.listen(this.j,q.name,q.arg)(le=>this.m({id:K,data:le,type:204}));this.d.set(q.id,B)}u(q){const Q=this.d.get(q.id);Q&&(Q.dispose(),this.d.delete(q.id))}v(q){let Q=this.g.get(q.channelName);Q||(Q=[],this.g.set(q.channelName,Q));const K=setTimeout(()=>{console.error(`Unknown channel: ${q.channelName}`),q.type===100&&this.m({id:q.id,data:{name:"Unknown channel",message:`Channel name '${q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Q.push({request:q,timeoutTimer:K})}w(q){const Q=this.g.get(q);if(Q){for(const K of Q)switch(clearTimeout(K.timeoutTimer),K.request.type){case 100:this.s(K.request);break;case 102:this.t(K.request);break}this.g.delete(q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,r.$Qc)(this.d.values()),this.d.clear()}}e.$$h=z;var Z;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(Z||(e.RequestInitiator=Z={}));class T{constructor(q,Q=null){this.l=q,this.a=!1,this.b=n.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(K=>this.s(K)),this.j=Q}getChannel(q){const Q=this;return{call(K,de,B){return Q.a?Promise.reject(new P.$5):Q.m(q,K,de,B)},listen(K,de){return Q.a?h.Event.None:Q.o(q,K,de)}}}m(q,Q,K,de=M.CancellationToken.None){const B=this.g++,_={id:B,type:100,channelName:q,name:Q,arg:K};if(de.isCancellationRequested)return Promise.reject(new P.$5);let u;return new Promise((ie,ne)=>{if(de.isCancellationRequested)return ne(new P.$5);const H=()=>{const W=x=>{switch(x.type){case 201:this.f.delete(B),ie(x.data);break;case 202:{this.f.delete(B);const se=new Error(x.data.message);se.stack=Array.isArray(x.data.stack)?x.data.stack.join(`
`):x.data.stack,se.name=x.data.name,ne(se);break}case 203:this.f.delete(B),ne(x.data);break}};this.f.set(B,W),this.p(_)};let V=null;this.b===n.Idle?H():(V=(0,L.$jh)(W=>this.u()),V.then(()=>{V=null,H()}));const F=()=>{V?(V.cancel(),V=null):this.p({id:B,type:101}),ne(new P.$5)},I=de.onCancellationRequested(F);u=(0,r.$Sc)((0,r.$Tc)(F),I),this.d.add(u)}).finally(()=>{u.dispose(),this.d.delete(u)})}o(q,Q,K){const de=this.g++,le={id:de,type:102,channelName:q,name:Q,arg:K};let _=null;const u=new h.$ee({onWillAddFirstListener:()=>{_=(0,L.$jh)(ie=>this.u()),_.then(()=>{_=null,this.d.add(u),this.p(le)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(u),this.p({id:de,type:103}))}}),N=ie=>u.fire(ie.data);return this.f.set(de,N),u.event}p(q){switch(q.type){case 100:case 102:{const Q=this.q([q.type,q.id,q.channelName,q.name],q.arg);this.j?.logOutgoing(Q,q.id,0,`${a(q.type)}: ${q.channelName}.${q.name}`,q.arg);return}case 101:case 103:{const Q=this.q([q.type,q.id]);this.j?.logOutgoing(Q,q.id,0,a(q.type));return}}}q(q,Q=void 0){const K=new t;return k(K,q),k(K,Q),this.r(K.buffer)}r(q){try{return this.l.send(q),q.byteLength}catch{return 0}}s(q){const Q=new i(q),K=b(Q),de=b(Q),B=K[0];switch(B){case 200:return this.j?.logIncoming(q.byteLength,0,0,f(B)),this.t({type:K[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(q.byteLength,K[1],0,f(B),de),this.t({type:K[0],id:K[1],data:de})}}t(q){if(q.type===200){this.b=n.Idle,this.k.fire();return}this.f.get(q.id)?.(q)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===n.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,r.$Qc)(this.d.values()),this.d.clear()}}e.$_h=T,be([j.$1h],T.prototype,"onDidInitializePromise",null);class R{get connections(){const q=[];return this.f.forEach(Q=>q.push(Q)),q}constructor(q,Q,K){this.a=new Map,this.f=new Set,this.g=new h.$ee,this.onDidAddConnection=this.g.event,this.h=new h.$ee,this.onDidRemoveConnection=this.h.event,this.j=new r.$Uc,this.j.add(q(({protocol:de,onDidClientDisconnect:B})=>{const le=h.Event.once(de.onMessage);this.j.add(le(_=>{const u=new i(_),N=b(u),ie=new z(de,N,Q,K),ne=new T(de,Q);this.a.forEach((V,F)=>ie.registerChannel(F,V));const H={channelServer:ie,channelClient:ne,ctx:N};this.f.add(H),this.g.fire(H),this.j.add(B(()=>{ie.dispose(),ne.dispose(),this.f.delete(H),this.h.fire(H)}))}))}))}getChannel(q,Q){const K=this;return{call(de,B,le){let _;if((0,E.$kg)(Q)){const N=(0,w.$4b)(K.connections.filter(Q));_=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(K.onDidAddConnection,Q))}else _=Q.routeCall(K,de,B);const u=_.then(N=>N.channelClient.getChannel(q));return O(u).call(de,B,le)},listen(de,B){if((0,E.$kg)(Q))return K.k(q,Q,de,B);const le=Q.routeEvent(K,de,B).then(_=>_.channelClient.getChannel(q));return O(le).listen(de,B)}}}k(q,Q,K,de){const B=this;let le;const _=new h.$ee({onWillAddFirstListener:()=>{le=new r.$Uc;const u=new h.$ke,N=new Map,ie=H=>{const F=H.channelClient.getChannel(q).listen(K,de),I=u.add(F);N.set(H,I)},ne=H=>{const V=N.get(H);V&&(V.dispose(),N.delete(H))};B.connections.filter(Q).forEach(ie),h.Event.filter(B.onDidAddConnection,Q)(ie,void 0,le),B.onDidRemoveConnection(ne,void 0,le),u.event(_.fire,_,le),le.add(u)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return _.event}registerChannel(q,Q){this.a.set(q,Q);for(const K of this.f)K.channelServer.registerChannel(q,Q)}dispose(){this.j.dispose();for(const q of this.f)q.channelClient.dispose(),q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=R;class m{constructor(q,Q,K=null){const de=new t;k(de,Q),q.send(de.buffer),this.a=new T(q,K),this.d=new z(q,Q,K)}getChannel(q){return this.a.getChannel(q)}registerChannel(q,Q){this.d.registerChannel(q,Q)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=m;function O(X){return{call(q,Q,K){return X.then(de=>de.call(q,Q,K))},listen(q,Q){const K=new h.$ne;return X.then(de=>K.input=de.listen(q,Q)),K.event}}}function $(X){let q=!1;return{call(Q,K,de){return q?X.call(Q,K,de):(0,L.$xh)(0).then(()=>q=!0).then(()=>X.call(Q,K,de))},listen(Q,K){if(q)return X.listen(Q,K);const de=new h.$ne;return(0,L.$xh)(0).then(()=>q=!0).then(()=>de.input=X.listen(Q,K)),de.event}}}class A{constructor(q){this.a=q}routeCall(q){return this.b(q)}routeEvent(q){return this.b(q)}async b(q){for(const Q of q.connections)if(await Promise.resolve(this.a(Q.ctx)))return Promise.resolve(Q);return await h.Event.toPromise(q.onDidAddConnection),await this.b(q)}}e.$ei=A;var Y;(function(X){function q(B,le,_){const u=B,N=_&&_.disableMarshalling,ie=new Map;for(const ne in u)K(ne)&&ie.set(ne,h.Event.buffer(u[ne],!0,void 0,le));return new class{listen(ne,H,V){const F=ie.get(H);if(F)return F;const I=u[H];if(typeof I=="function"){if(de(H))return I.call(u,V);if(K(H))return ie.set(H,h.Event.buffer(u[H],!0,void 0,le)),ie.get(H)}throw new P.$bb(`Event not found: ${H}`)}call(ne,H,V){const F=u[H];if(typeof F=="function"){if(!N&&Array.isArray(V))for(let W=0;W<V.length;W++)V[W]=(0,y.$6h)(V[W]);let I=F.apply(u,V);return I instanceof Promise||(I=Promise.resolve(I)),I}throw new P.$bb(`Method not found: ${H}`)}}}X.fromService=q;function Q(B,le){const _=le&&le.disableMarshalling;return new Proxy({},{get(u,N){if(typeof N=="string")return le?.properties?.has(N)?le.properties.get(N):de(N)?function(ie){return B.listen(N,ie)}:K(N)?B.listen(N):async function(...ie){let ne;le&&!(0,E.$fg)(le.context)?ne=[le.context,...ie]:ne=ie;const H=await B.call(N,ne);return _?H:(0,y.$6h)(H)};throw new P.$bb(`Property not found: ${String(N)}`)}})}X.toService=Q;function K(B){return B[0]==="o"&&B[1]==="n"&&l.$xf(B.charCodeAt(2))}function de(B){return/^onDynamic/.test(B)&&l.$xf(B.charCodeAt(9))}})(Y||(e.ProxyChannel=Y={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const q=X.toString();if(q!=="[object Object]")return q}return X}function ee(X){return Array.isArray(X)?X.map(G):G(X)}function ce(X,q,Q,K,de,B,le){le=ee(le);const _=te[de],u=_[K%_.length];let N=[`%c[${X}]%c[${String(q).padStart(7," ")}]%c[len: ${String(Q).padStart(5," ")}]%c${String(K).padStart(5," ")} - ${B}`,"color: darkgreen","color: grey","color: grey",`color: ${u}`];/\($/.test(B)?(N=N.concat(le),N.push(")")):N.push(le),console.log.apply(console,N)}class ue{constructor(q,Q){this.d=q,this.f=Q,this.a=0,this.b=0}logOutgoing(q,Q,K,de,B){this.b+=q,ce(this.d,this.b,q,Q,K,de,B)}logIncoming(q,Q,K,de,B){this.a+=q,ce(this.f,this.a,q,Q,K,de,B)}}e.$fi=ue}),define(fe[64],me([0,1,26,11,18,17,58,7,4,2,30,34,33,27]),function(ae,e,w,L,C,M,j,P,h,r,y,l,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class a extends o.$$h{constructor(n){super({send:s=>{try{process.send?.(s.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",s=>C.$Ge.wrap(Buffer.from(s,"base64")))},n),process.once("disconnect",()=>this.dispose())}}e.$Zq=a;class g{constructor(n,s){this.i=n,this.j=s,this.c=new Set,this.g=new Map,this.h=new h.$ee,this.onDidProcessExit=this.h.event;const d=s&&s.timeout?s.timeout:6e4;this.b=new L.$th(d),this.d=null,this.f=null}getChannel(n){const s=this;return{call(d,v,i){return s.k(n,d,v,i)},listen(d,v){return s.l(n,d,v)}}}k(n,s,d,v=M.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(v.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const i=this.n(n),t=(0,L.$jh)(p=>i.call(s,d,p)),c=v.onCancellationRequested(()=>t.cancel()),S=(0,r.$Tc)(()=>t.cancel());return this.c.add(S),t.finally(()=>{c.dispose(),this.c.delete(S),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(n,s,d){if(!this.b)return h.Event.None;this.b.cancel();let v;const i=new h.$ee({onWillAddFirstListener:()=>{v=this.n(n).listen(s,d)(i.fire,i),this.c.add(v)},onDidRemoveLastListener:()=>{this.c.delete(v),v.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return i.event}get m(){if(!this.f){const n=this.j&&this.j.args?this.j.args:[],s=Object.create(null);s.env={...(0,y.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(s.env={...s.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(s.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(s.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(s.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),s.execArgv===void 0&&(s.execArgv=process.execArgv.filter(k=>!/^--inspect(-brk)?=/.test(k)).filter(k=>!k.startsWith("--vscode-"))),(0,E.$nm)(s.env),this.d=(0,w.fork)(this.i,n,s);const d=new h.$ee,i=h.Event.fromNodeEventEmitter(this.d,"message",k=>k)(k=>{if((0,j.$Vq)(k)){(0,j.log)(k,`IPC Library: ${this.j.serverName}`);return}d.fire(C.$Ge.wrap(Buffer.from(k,"base64")))}),t=this.j.useQueue?(0,l.$pm)(this.d):this.d,c=k=>this.d&&this.d.connected&&t.send(k.buffer.toString("base64")),S=d.event,p={send:c,onMessage:S};this.f=new o.$_h(p);const D=()=>this.o();process.once("exit",D),this.d.on("error",k=>console.warn('IPC "'+this.j.serverName+'" errored with '+k)),this.d.on("exit",(k,b)=>{process.removeListener("exit",D),i.dispose(),this.c.forEach(z=>(0,r.$Qc)(z)),this.c.clear(),k!==0&&b!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+k+" and signal "+b),this.b?.cancel(),this.o(),this.h.fire({code:k,signal:b})})}return this.f}n(n){let s=this.g.get(n);return s||(s=this.m.getChannel(n),this.g.set(n,s)),s}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=g}),define(fe[65],me([0,1,31,18,27,4,9,16]),function(ae,e,w,L,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cX=void 0,e.$dX=y;class h{constructor(E){this.a=E,this.onMessage=M.Event.fromNodeEventEmitter(this.a,"message",o=>o.data?L.$Ge.wrap(o.data):L.$Ge.alloc(0)),E.start()}send(E){this.a.postMessage(E.buffer)}disconnect(){this.a.close()}}class r extends C.$ai{static b(E){(0,j.$gg)((0,w.$bX)(process),"Electron Utility Process");const o=new M.$ee;return process.parentPort.on("message",a=>{if(E?.handledClientConnection(a))return;const g=(0,P.$Ob)(a.ports);g&&o.fire(g)}),M.Event.map(o.event,a=>({protocol:new h(a),onDidClientDisconnect:M.Event.fromNodeEventEmitter(a,"close")}))}constructor(E){super(r.b(E))}}e.$cX=r;function y(l,E,o){const a=g=>{g.data===E&&(l.removeListener("message",a),o())};l.on("message",a)}}),define(fe[66],me([13,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(fe[67],me([13,10]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(fe[68],me([13,10]),function(ae,e){return ae.create("vs/platform/environment/node/argv",e)}),define(fe[69],me([13,10]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(fe[70],me([13,10]),function(ae,e){return ae.create("vs/platform/log/common/log",e)}),define(fe[71],me([13,10]),function(ae,e){return ae.create("vs/platform/terminal/node/ptyService",e)}),define(fe[72],me([13,10]),function(ae,e){return ae.create("vs/platform/terminal/node/terminalProcess",e)}),define(fe[73],me([0,1,7,67]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var C;(function(r){r[r.LParen=0]="LParen",r[r.RParen=1]="RParen",r[r.Neg=2]="Neg",r[r.Eq=3]="Eq",r[r.NotEq=4]="NotEq",r[r.Lt=5]="Lt",r[r.LtEq=6]="LtEq",r[r.Gt=7]="Gt",r[r.GtEq=8]="GtEq",r[r.RegexOp=9]="RegexOp",r[r.RegexStr=10]="RegexStr",r[r.True=11]="True",r[r.False=12]="False",r[r.In=13]="In",r[r.Not=14]="Not",r[r.And=15]="And",r[r.Or=16]="Or",r[r.Str=17]="Str",r[r.QuotedStr=18]="QuotedStr",r[r.Error=19]="Error",r[r.EOF=20]="EOF"})(C||(e.TokenType=C={}));function M(...r){switch(r.length){case 1:return(0,L.localize)(0,null,r[0]);case 2:return(0,L.localize)(1,null,r[0],r[1]);case 3:return(0,L.localize)(2,null,r[0],r[1],r[2]);default:return}}const j=(0,L.localize)(3,null),P=(0,L.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,w.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const l=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:l})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const l=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:l})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const l=this.d,E=this.c.substring(this.d,this.e),o={type:19,offset:this.d,lexeme:E};this.g.push({offset:l,lexeme:E,additionalInfo:y}),this.f.push(o)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const l=this.c.substring(this.d,this.e),E=h.b.get(l);E?this.k(E):this.f.push({type:17,lexeme:l,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,l=!1,E=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(P);return}const a=this.c.charCodeAt(y);if(l)l=!1;else if(a===47&&!E){y++;break}else a===91?E=!0:a===92?l=!0:a===93&&(E=!1);y++}for(;y<this.c.length&&h.a.has(this.c.charCodeAt(y));)y++;this.e=y;const o=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:o,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=h}),define(fe[74],me([0,1,54,14,19,5,15,23,6]),function(ae,e,w,L,C,M,j,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=y,e.$8m=l,e.$5m=/^([^.]+\..+)[:=](.+)$/;class r{get appRoot(){return(0,M.$nc)(C.$Qg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,M.$kc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,P.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:C.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const o=(0,w.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.$kc)(this.userDataPath,"logs",o)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$0g)(h.URI.file((0,M.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const o=j.env.VSCODE_PORTABLE;return o?h.URI.file((0,M.$kc)(o,"argv.json")):(0,P.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,M.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const o=this.args["builtin-extensions-dir"];return o?(0,M.$lc)(o):(0,M.$ic)((0,M.$kc)(C.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const o=this.args["extensions-download-dir"];return o?h.URI.file((0,M.$lc)(o)):h.URI.file((0,M.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const o=this.args["extensions-dir"];if(o)return(0,M.$lc)(o);const a=j.env.VSCODE_EXTENSIONS;if(a)return a;const g=j.env.VSCODE_PORTABLE;return g?(0,M.$kc)(g,"extensions"):(0,P.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const o=this.args.extensionDevelopmentPath;if(Array.isArray(o))return o.map(a=>/^[^:/?#]+?:\/\//.test(a)?h.URI.parse(a):h.URI.file((0,M.$ic)(a)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(o=>o==="ui"||o==="workspace"||o==="web"?o:"workspace")}get extensionTestsLocationURI(){const o=this.args.extensionTestsPath;if(o)return/^[^:/?#]+?:\/\//.test(o)?h.URI.parse(o):h.URI.file((0,M.$ic)(o))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const o=this.args["disable-extension"];if(o){if(typeof o=="string")return[o];if(Array.isArray(o)&&o.length>0)return o}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(o=>!e.$5m.test(o))}get extensionLogLevel(){const o=[];for(const a of this.args.log||[]){const g=e.$5m.exec(a);g&&g[1]&&g[2]&&o.push([g[1],g[2]])}return o.length?o:void 0}get serviceMachineIdResource(){return(0,P.$0g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const o=j.env.VSCODE_PORTABLE;return o?h.URI.file((0,M.$kc)(o,"policy.json")):(0,P.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(o){this.args.continueOn=o}get args(){return this.a}constructor(o,a,g){this.a=o,this.b=a,this.c=g,this.editSessionId=this.args.editSessionId}}e.$6m=r,be([L.$1h],r.prototype,"appRoot",null),be([L.$1h],r.prototype,"userHome",null),be([L.$1h],r.prototype,"userDataPath",null),be([L.$1h],r.prototype,"appSettingsHome",null),be([L.$1h],r.prototype,"tmpDir",null),be([L.$1h],r.prototype,"cacheHome",null),be([L.$1h],r.prototype,"stateResource",null),be([L.$1h],r.prototype,"userRoamingDataHome",null),be([L.$1h],r.prototype,"userDataSyncHome",null),be([L.$1h],r.prototype,"sync",null),be([L.$1h],r.prototype,"machineSettingsResource",null),be([L.$1h],r.prototype,"workspaceStorageHome",null),be([L.$1h],r.prototype,"localHistoryHome",null),be([L.$1h],r.prototype,"keyboardLayoutResource",null),be([L.$1h],r.prototype,"argvResource",null),be([L.$1h],r.prototype,"isExtensionDevelopment",null),be([L.$1h],r.prototype,"untitledWorkspacesHome",null),be([L.$1h],r.prototype,"builtinExtensionsPath",null),be([L.$1h],r.prototype,"extensionsPath",null),be([L.$1h],r.prototype,"extensionDevelopmentLocationURI",null),be([L.$1h],r.prototype,"extensionDevelopmentKind",null),be([L.$1h],r.prototype,"extensionTestsLocationURI",null),be([L.$1h],r.prototype,"debugExtensionHost",null),be([L.$1h],r.prototype,"logLevel",null),be([L.$1h],r.prototype,"extensionLogLevel",null),be([L.$1h],r.prototype,"serviceMachineIdResource",null),be([L.$1h],r.prototype,"disableTelemetry",null),be([L.$1h],r.prototype,"disableWorkspaceTrust",null),be([L.$1h],r.prototype,"useInMemorySecretStorage",null),be([L.$1h],r.prototype,"policyFile",null);function y(E,o){return l(E["inspect-extensions"],E["inspect-brk-extensions"],5870,o,E.debugId,E.extensionEnvironment)}function l(E,o,a,g,f,n){const d=Number(o||E)||(g?null:a),v=d?!!o:!1;let i;if(n)try{i=JSON.parse(n)}catch{}return{port:d,break:v,debugId:f,env:i}}}),define(fe[75],me([0,1,108,3,68]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$tm=P,e.$um=r,e.$vm=o,e.$wm=a;const M={o:(0,C.localize)(0,null),e:(0,C.localize)(1,null),t:(0,C.localize)(2,null)};e.$rm=["tunnel","serve-web"],e.$sm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,C.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,C.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,C.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,C.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,C.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,C.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,C.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,C.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,C.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,C.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,C.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,C.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,C.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,C.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,C.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,C.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,C.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,C.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,C.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,C.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,C.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,C.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,C.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,C.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,C.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,C.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,C.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,C.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,C.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,C.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,C.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,C.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,C.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(g,f,n=j){const s=g.find(k=>k.length>0&&k[0]!=="-"),d={},v=["_"],i=[],t={};let c;for(const k in f){const b=f[k];b.type==="subcommand"?k===s&&(c=b):(b.alias&&(d[k]=b.alias),b.type==="string"||b.type==="string[]"?(v.push(k),b.deprecates&&v.push(...b.deprecates)):b.type==="boolean"&&(i.push(k),b.deprecates&&i.push(...b.deprecates)),b.global&&(t[k]=b))}if(c&&s){const k=t;for(const T in c.options)k[T]=c.options[T];const b=g.filter(T=>T!==s),z=n.getSubcommandReporter?n.getSubcommandReporter(s):void 0,Z=P(b,k,z);return{[s]:Z,_:[]}}const S=w(g,{string:v,boolean:i,alias:d}),p={},D=S;p._=S._.map(k=>String(k)).filter(k=>k.length>0),delete D._;for(const k in f){const b=f[k];if(b.type==="subcommand")continue;b.alias&&delete D[b.alias];let z=D[k];if(b.deprecates)for(const Z of b.deprecates)D.hasOwnProperty(Z)&&(z||(z=D[Z],z&&n.onDeprecatedOption(Z,b.deprecationMessage||(0,C.localize)(38,null,k))),delete D[Z]);if(typeof z<"u"){if(b.type==="string[]"){if(Array.isArray(z)||(z=[z]),!b.allowEmptyValue){const Z=z.filter(T=>T.length>0);Z.length!==z.length&&(n.onEmptyValue(k),z=Z.length>0?Z:void 0)}}else b.type==="string"&&(Array.isArray(z)?(z=z.pop(),n.onMultipleValues(k,z)):!z&&!b.allowEmptyValue&&(n.onEmptyValue(k),z=void 0));p[k]=z,b.deprecationMessage&&n.onDeprecatedOption(k,b.deprecationMessage)}delete D[k]}for(const k in D)n.onUnknownOption(k);return p}function h(g,f){let n="";return f.args&&(Array.isArray(f.args)?n=` <${f.args.join("> <")}>`:n=` <${f.args}>`),f.alias?`-${f.alias} --${g}${n}`:`--${g}${n}`}function r(g,f){const n=[];for(const s in g){const d=g[s],v=h(s,d);n.push([v,d.description])}return y(n,f)}function y(g,f){const s=g.reduce((i,t)=>Math.max(i,t[0].length),12)+2+1;if(f-s<25)return g.reduce((i,t)=>i.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const d=f-s-1,v=[];for(const i of g){const t=i[0],c=E(i[1],d),S=l(s-t.length-2);v.push("  "+t+S+c[0]);for(let p=1;p<c.length;p++)v.push(l(s)+c[p])}return v}function l(g){return" ".repeat(g)}function E(g,f){const n=[];for(;g.length;){const s=g.length<f?g.length:g.lastIndexOf(" ",f),d=g.slice(0,s).trim();g=g.slice(s),n.push(d)}return n}function o(g,f,n,s,d){const v=process.stdout.isTTY&&process.stdout.columns||80,i=d?.noInputFiles!==!0?`[${(0,C.localize)(39,null)}...]`:"",t=[`${g} ${n}`];t.push(""),t.push(`${(0,C.localize)(40,null)}: ${f} [${(0,C.localize)(41,null)}]${i}`),t.push(""),d?.noPipe!==!0&&(L.$i?t.push((0,C.localize)(42,null,f)):t.push((0,C.localize)(43,null,f)),t.push(""));const c={},S=[];for(const p in s){const D=s[p];if(D.type==="subcommand")D.description&&S.push({command:p,description:D.description});else if(D.description&&D.cat){let k=c[D.cat];k||(c[D.cat]=k={}),k[p]=D}}for(const p in c){const D=p,k=c[D];k&&(t.push(M[D]),t.push(...r(k,v)),t.push(""))}return S.length&&(t.push((0,C.localize)(44,null)),t.push(...y(S.map(p=>[p.command,p.description]),v)),t.push("")),t.join(`
`)}function a(g,f){return`${g||(0,C.localize)(45,null)}
${f||(0,C.localize)(46,null)}
${process.arch}`}}),function(){"use strict";function ae(e,w,L){function C(j,P){const h=M(j,P),r=[h];return e.isAbsolute(h)||r.unshift(L),e.resolve(...r)}function M(j,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let r=process.env.VSCODE_APPDATA;if(r)return e.join(r,P);const y=j["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const l=process.env.USERPROFILE;if(typeof l!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(l,"AppData","Roaming")}break;case"darwin":r=e.join(w.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(w.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,P)}return{getUserDataPath:C}}if(typeof define=="function")define(fe[76],me([77,20,15]),function(e,w,L){return ae(e,w,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),w=require("os");module.exports=ae(e,w,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(fe[78],me([0,1,20,74,76]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=j,e.$$m=P;class M extends L.$6m{constructor(r,y){super(r,{homeDir:(0,w.homedir)(),tmpDir:(0,w.tmpdir)(),userDataDir:(0,C.getUserDataPath)(r,y.nameShort)},y)}}e.$9m=M;function j(h,r){return(0,L.$8m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,r,h.extensionEnvironment)}function P(h,r){return(0,L.$8m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,r,h.extensionEnvironment)}}),define(fe[21],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=C,e.$xi=M;var w;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function P(h){return h[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=P})(w||(e._util=w={})),e.$vi=C("instantiationService");function L(j,P,h){P[w.DI_TARGET]===P?P[w.DI_DEPENDENCIES].push({id:j,index:h}):(P[w.DI_DEPENDENCIES]=[{id:j,index:h}],P[w.DI_TARGET]=P)}function C(j){if(w.serviceIds.has(j))return w.serviceIds.get(j);const P=function(h,r,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,h,y)};return P.toString=()=>j,w.serviceIds.set(j,P),P}function M(j){return j}}),define(fe[35],me([0,1,3,12,73,21,66,7]),function(ae,e,w,L,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=r,e.$vj=c,e.$wj=S,e.$Pj=de;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",w.$j),h.set("isLinux",w.$k),h.set("isWindows",w.$i),h.set("isWeb",w.$o),h.set("isMacNative",w.$j&&!w.$o),h.set("isEdge",w.$H),h.set("isFirefox",w.$F),h.set("isChrome",w.$E),h.set("isSafari",w.$G);function r(_,u){if(h.get(_)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(_,u)}const y=Object.prototype.hasOwnProperty;var l;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(l||(e.ContextKeyExprType=l={}));const E={regexParsingWithErrorRecovery:!0},o=(0,j.localize)(0,null),a=(0,j.localize)(1,null),g=(0,j.localize)(2,null),f=(0,j.localize)(3,null),n=(0,j.localize)(4,null),s=(0,j.localize)(5,null),d=(0,j.localize)(6,null),v=(0,j.localize)(7,null);class i{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(u=E){this.k=u,this.d=new C.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(u){if(u===""){this.h.push({message:o,offset:0,lexeme:"",additionalInfo:a});return}this.f=this.d.reset(u).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const ie=this.D(),ne=ie.type===17?s:void 0;throw this.h.push({message:n,offset:ie.offset,lexeme:C.$rj.getLexeme(ie),additionalInfo:ne}),i.c}return N}catch(N){if(N!==i.c)throw N;return}}l(){return this.m()}m(){const u=[this.o()];for(;this.y(16);){const N=this.o();u.push(N)}return u.length===1?u[0]:t.or(...u)}o(){const u=[this.s()];for(;this.y(15);){const N=this.s();u.push(N)}return u.length===1?u[0]:t.and(...u)}s(){if(this.y(2)){const u=this.D();switch(u.type){case 11:return this.z(),D.INSTANCE;case 12:return this.z(),k.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,f),N?.negate()}case 17:return this.z(),m.create(u.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",u)}}return this.t()}t(){const u=this.D();switch(u.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,f),N}case 17:{const N=u.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const H=ne.lexeme,V=H.lastIndexOf("/"),F=V===H.length-1?void 0:this.w(H.substring(V+1));let I;try{I=new RegExp(H.substring(1,V),F)}catch{throw this.B("REGEX",ne)}return G.create(N,I)}switch(ne.type){case 10:case 19:{const H=[ne.lexeme];this.z();let V=this.D(),F=0;for(let re=0;re<ne.lexeme.length;re++)ne.lexeme.charCodeAt(re)===40?F++:ne.lexeme.charCodeAt(re)===41&&F--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:F++;break;case 1:F--;break;case 10:case 18:for(let re=0;re<V.lexeme.length;re++)V.lexeme.charCodeAt(re)===40?F++:ne.lexeme.charCodeAt(re)===41&&F--}if(F<0)break;H.push(C.$rj.getLexeme(V)),this.z(),V=this.D()}const I=H.join(""),W=I.lastIndexOf("/"),x=W===I.length-1?void 0:this.w(I.substring(W+1));let se;try{se=new RegExp(I.substring(1,W),x)}catch{throw this.B("REGEX",ne)}return t.regex(N,se)}case 18:{const H=ne.lexeme;this.z();let V=null;if(!(0,L.$8e)(H)){const F=H.indexOf("/"),I=H.lastIndexOf("/");if(F!==I&&F>=0){const W=H.slice(F+1,I),x=H[I+1]==="i"?"i":"";try{V=new RegExp(W,x)}catch{throw this.B("REGEX",ne)}}}if(V===null)throw this.B("REGEX",ne);return G.create(N,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,g);const ne=this.u();return t.notIn(N,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this.z(),Y.create(N,this.u());case 6:return this.z(),te.create(N,this.u());case 7:return this.z(),$.create(N,this.u());case 8:return this.z(),A.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:d,offset:u.offset,lexeme:"",additionalInfo:v}),i.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const u=this.D();switch(u.type){case 17:case 18:return this.z(),u.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(u){return u.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(u){return this.C(u)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(u,N){if(this.C(u))return this.z();throw this.B(N,this.D())}B(u,N,ie){const ne=(0,j.localize)(8,null,u,C.$rj.getLexeme(N)),H=N.offset,V=C.$rj.getLexeme(N);return this.h.push({message:ne,offset:H,lexeme:V,additionalInfo:ie}),i.c}C(u){return this.D().type===u}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=i;class t{static false(){return D.INSTANCE}static true(){return k.INSTANCE}static has(u){return b.create(u)}static equals(u,N){return z.create(u,N)}static notEquals(u,N){return R.create(u,N)}static regex(u,N){return G.create(u,N)}static in(u,N){return Z.create(u,N)}static notIn(u,N){return T.create(u,N)}static not(u){return m.create(u)}static and(...u){return ue.create(u,null,!0)}static or(...u){return X.create(u,null,!0)}static greater(u,N){return $.create(u,N)}static greaterEquals(u,N){return A.create(u,N)}static smaller(u,N){return Y.create(u,N)}static smallerEquals(u,N){return te.create(u,N)}static{this.c=new i({regexParsingWithErrorRecovery:!1})}static deserialize(u){return u==null?void 0:this.c.parse(u)}}e.$uj=t;function c(_){const u=new i({regexParsingWithErrorRecovery:!1});return _.map(N=>(u.parse(N),u.lexingErrors.length>0?u.lexingErrors.map(ie=>({errorMessage:ie.additionalInfo?(0,j.localize)(9,null,ie.additionalInfo):(0,j.localize)(10,null),offset:ie.offset,length:ie.lexeme.length})):u.parsingErrors.length>0?u.parsingErrors.map(ie=>({errorMessage:ie.additionalInfo?`${ie.message}. ${ie.additionalInfo}`:ie.message,offset:ie.offset,length:ie.lexeme.length})):[]))}function S(_,u){const N=_?_.substituteConstants():void 0,ie=u?u.substituteConstants():void 0;return!N&&!ie?!0:!N||!ie?!1:N.equals(ie)}function p(_,u){return _.cmp(u)}class D{static{this.INSTANCE=new D}constructor(){this.type=0}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!1}serialize(){return"false"}keys(){return[]}map(u){return this}negate(){return k.INSTANCE}}e.$xj=D;class k{static{this.INSTANCE=new k}constructor(){this.type=1}cmp(u){return this.type-u.type}equals(u){return u.type===this.type}substituteConstants(){return this}evaluate(u){return!0}serialize(){return"true"}keys(){return[]}map(u){return this}negate(){return D.INSTANCE}}e.$yj=k;class b{static create(u,N=null){const ie=h.get(u);return typeof ie=="boolean"?ie?k.INSTANCE:D.INSTANCE:new b(u,N)}constructor(u,N){this.key=u,this.c=N,this.type=2}cmp(u){return u.type!==this.type?this.type-u.type:Q(this.key,u.key)}equals(u){return u.type===this.type?this.key===u.key:!1}substituteConstants(){const u=h.get(this.key);return typeof u=="boolean"?u?k.INSTANCE:D.INSTANCE:this}evaluate(u){return!!u.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(u){return u.mapDefined(this.key)}negate(){return this.c||(this.c=m.create(this.key,this)),this.c}}e.$zj=b;class z{static create(u,N,ie=null){if(typeof N=="boolean")return N?b.create(u,ie):m.create(u,ie);const ne=h.get(u);return typeof ne=="boolean"?N===(ne?"true":"false")?k.INSTANCE:D.INSTANCE:new z(u,N,ie)}constructor(u,N,ie){this.c=u,this.d=N,this.f=ie,this.type=4}cmp(u){return u.type!==this.type?this.type-u.type:K(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=h.get(this.c);if(typeof u=="boolean"){const N=u?"true":"false";return this.d===N?k.INSTANCE:D.INSTANCE}return this}evaluate(u){return u.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(u){return u.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Aj=z;class Z{static create(u,N){return new Z(u,N)}constructor(u,N){this.d=u,this.f=N,this.type=10,this.c=null}cmp(u){return u.type!==this.type?this.type-u.type:K(this.d,this.f,u.d,u.f)}equals(u){return u.type===this.type?this.d===u.d&&this.f===u.f:!1}substituteConstants(){return this}evaluate(u){const N=u.getValue(this.f),ie=u.getValue(this.d);return Array.isArray(N)?N.includes(ie):typeof ie=="string"&&typeof N=="object"&&N!==null?y.call(N,ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(u){return u.mapIn(this.d,this.f)}negate(){return this.c||(this.c=T.create(this.d,this.f)),this.c}}e.$Bj=Z;class T{static create(u,N){return new T(u,N)}constructor(u,N){this.d=u,this.f=N,this.type=11,this.c=Z.create(u,N)}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(u){return u.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=T;class R{static create(u,N,ie=null){if(typeof N=="boolean")return N?m.create(u,ie):b.create(u,ie);const ne=h.get(u);return typeof ne=="boolean"?N===(ne?"true":"false")?D.INSTANCE:k.INSTANCE:new R(u,N,ie)}constructor(u,N,ie){this.c=u,this.d=N,this.f=ie,this.type=5}cmp(u){return u.type!==this.type?this.type-u.type:K(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){const u=h.get(this.c);if(typeof u=="boolean"){const N=u?"true":"false";return this.d===N?D.INSTANCE:k.INSTANCE}return this}evaluate(u){return u.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(u){return u.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$Dj=R;class m{static create(u,N=null){const ie=h.get(u);return typeof ie=="boolean"?ie?D.INSTANCE:k.INSTANCE:new m(u,N)}constructor(u,N){this.c=u,this.d=N,this.type=3}cmp(u){return u.type!==this.type?this.type-u.type:Q(this.c,u.c)}equals(u){return u.type===this.type?this.c===u.c:!1}substituteConstants(){const u=h.get(this.c);return typeof u=="boolean"?u?D.INSTANCE:k.INSTANCE:this}evaluate(u){return!u.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(u){return u.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$Ej=m;function O(_,u){if(typeof _=="string"){const N=parseFloat(_);isNaN(N)||(_=N)}return typeof _=="string"||typeof _=="number"?u(_):D.INSTANCE}class ${static create(u,N,ie=null){return O(N,ne=>new $(u,ne,ie))}constructor(u,N,ie){this.c=u,this.d=N,this.f=ie,this.type=12}cmp(u){return u.type!==this.type?this.type-u.type:K(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Fj=$;class A{static create(u,N,ie=null){return O(N,ne=>new A(u,ne,ie))}constructor(u,N,ie){this.c=u,this.d=N,this.f=ie,this.type=13}cmp(u){return u.type!==this.type?this.type-u.type:K(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(u){return u.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$Gj=A;class Y{static create(u,N,ie=null){return O(N,ne=>new Y(u,ne,ie))}constructor(u,N,ie){this.c=u,this.d=N,this.f=ie,this.type=14}cmp(u){return u.type!==this.type?this.type-u.type:K(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Hj=Y;class te{static create(u,N,ie=null){return O(N,ne=>new te(u,ne,ie))}constructor(u,N,ie){this.c=u,this.d=N,this.f=ie,this.type=15}cmp(u){return u.type!==this.type?this.type-u.type:K(this.c,this.d,u.c,u.d)}equals(u){return u.type===this.type?this.c===u.c&&this.d===u.d:!1}substituteConstants(){return this}evaluate(u){return typeof this.d=="string"?!1:parseFloat(u.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(u){return u.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.$Ij=te;class G{static create(u,N){return new G(u,N)}constructor(u,N){this.d=u,this.f=N,this.type=7,this.c=null}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.d<u.d)return-1;if(this.d>u.d)return 1;const N=this.f?this.f.source:"",ie=u.f?u.f.source:"";return N<ie?-1:N>ie?1:0}equals(u){if(u.type===this.type){const N=this.f?this.f.source:"",ie=u.f?u.f.source:"";return this.d===u.d&&N===ie}return!1}substituteConstants(){return this}evaluate(u){const N=u.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const u=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${u}`}keys(){return[this.d]}map(u){return u.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ee.create(this)),this.c}}e.$Jj=G;class ee{static create(u){return new ee(u)}constructor(u){this.c=u,this.type=8}cmp(u){return u.type!==this.type?this.type-u.type:this.c.cmp(u.c)}equals(u){return u.type===this.type?this.c.equals(u.c):!1}substituteConstants(){return this}evaluate(u){return!this.c.evaluate(u)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(u){return new ee(this.c.map(u))}negate(){return this.c}}e.$Kj=ee;function ce(_){let u=null;for(let N=0,ie=_.length;N<ie;N++){const ne=_[N].substituteConstants();if(_[N]!==ne&&u===null){u=[];for(let H=0;H<N;H++)u[H]=_[H]}u!==null&&(u[N]=ne)}return u===null?_:u}class ue{static create(u,N,ie){return ue.d(u,N,ie)}constructor(u,N){this.expr=u,this.c=N,this.type=6}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let N=0,ie=this.expr.length;N<ie;N++){const ne=p(this.expr[N],u.expr[N]);if(ne!==0)return ne}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].equals(u.expr[N]))return!1;return!0}return!1}substituteConstants(){const u=ce(this.expr);return u===this.expr?this:ue.create(u,this.c,!1)}evaluate(u){for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].evaluate(u))return!1;return!0}static d(u,N,ie){const ne=[];let H=!1;for(const V of u)if(V){if(V.type===1){H=!0;continue}if(V.type===0)return D.INSTANCE;if(V.type===6){ne.push(...V.expr);continue}ne.push(V)}if(ne.length===0&&H)return k.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(p);for(let V=1;V<ne.length;V++)ne[V-1].equals(ne[V])&&(ne.splice(V,1),V--);if(ne.length===1)return ne[0];for(;ne.length>1;){const V=ne[ne.length-1];if(V.type!==9)break;ne.pop();const F=ne.pop(),I=ne.length===0,W=X.create(V.expr.map(x=>ue.create([x,F],null,ie)),null,I);W&&(ne.push(W),ne.sort(p))}if(ne.length===1)return ne[0];if(ie){for(let V=0;V<ne.length;V++)for(let F=V+1;F<ne.length;F++)if(ne[V].negate().equals(ne[F]))return D.INSTANCE;if(ne.length===1)return ne[0]}return new ue(ne,N)}}serialize(){return this.expr.map(u=>u.serialize()).join(" && ")}keys(){const u=[];for(const N of this.expr)u.push(...N.keys());return u}map(u){return new ue(this.expr.map(N=>N.map(u)),null)}negate(){if(!this.c){const u=[];for(const N of this.expr)u.push(N.negate());this.c=X.create(u,this,!0)}return this.c}}e.$Lj=ue;class X{static create(u,N,ie){return X.d(u,N,ie)}constructor(u,N){this.expr=u,this.c=N,this.type=9}cmp(u){if(u.type!==this.type)return this.type-u.type;if(this.expr.length<u.expr.length)return-1;if(this.expr.length>u.expr.length)return 1;for(let N=0,ie=this.expr.length;N<ie;N++){const ne=p(this.expr[N],u.expr[N]);if(ne!==0)return ne}return 0}equals(u){if(u.type===this.type){if(this.expr.length!==u.expr.length)return!1;for(let N=0,ie=this.expr.length;N<ie;N++)if(!this.expr[N].equals(u.expr[N]))return!1;return!0}return!1}substituteConstants(){const u=ce(this.expr);return u===this.expr?this:X.create(u,this.c,!1)}evaluate(u){for(let N=0,ie=this.expr.length;N<ie;N++)if(this.expr[N].evaluate(u))return!0;return!1}static d(u,N,ie){let ne=[],H=!1;if(u){for(let V=0,F=u.length;V<F;V++){const I=u[V];if(I){if(I.type===0){H=!0;continue}if(I.type===1)return k.INSTANCE;if(I.type===9){ne=ne.concat(I.expr);continue}ne.push(I)}}if(ne.length===0&&H)return D.INSTANCE;ne.sort(p)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let V=1;V<ne.length;V++)ne[V-1].equals(ne[V])&&(ne.splice(V,1),V--);if(ne.length===1)return ne[0];if(ie){for(let V=0;V<ne.length;V++)for(let F=V+1;F<ne.length;F++)if(ne[V].negate().equals(ne[F]))return k.INSTANCE;if(ne.length===1)return ne[0]}return new X(ne,N)}}serialize(){return this.expr.map(u=>u.serialize()).join(" || ")}keys(){const u=[];for(const N of this.expr)u.push(...N.keys());return u}map(u){return new X(this.expr.map(N=>N.map(u)),null)}negate(){if(!this.c){const u=[];for(const N of this.expr)u.push(N.negate());for(;u.length>1;){const N=u.shift(),ie=u.shift(),ne=[];for(const H of le(N))for(const V of le(ie))ne.push(ue.create([H,V],null,!1));u.unshift(X.create(ne,null,!1))}this.c=X.create(u,this,!0)}return this.c}}e.$Mj=X;class q extends b{static{this.d=[]}static all(){return q.d.values()}constructor(u,N,ie){super(u,null),this.f=N,typeof ie=="object"?q.d.push({...ie,key:u}):ie!==!0&&q.d.push({key:u,description:ie,type:N!=null?typeof N:void 0})}bindTo(u){return u.createKey(this.key,this.f)}getValue(u){return u.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(u){return z.create(this.key,u)}notEqualsTo(u){return R.create(this.key,u)}}e.$Nj=q,e.$Oj=(0,M.$wi)("contextKeyService");function Q(_,u){return _<u?-1:_>u?1:0}function K(_,u,N,ie){return _<N?-1:_>N?1:u<ie?-1:u>ie?1:0}function de(_,u){if(_.type===0||u.type===1)return!0;if(_.type===9)return u.type===9?B(_.expr,u.expr):!1;if(u.type===9){for(const N of u.expr)if(de(_,N))return!0;return!1}if(_.type===6){if(u.type===6)return B(u.expr,_.expr);for(const N of _.expr)if(de(N,u))return!0;return!1}return _.equals(u)}function B(_,u){let N=0,ie=0;for(;N<_.length&&ie<u.length;){const ne=_[N].cmp(u[ie]);if(ne<0)return!1;ne===0&&N++,ie++}return N===_.length}function le(_){return _.type===9?_.expr:[_]}}),define(fe[79],me([0,1,51,5,12,9,6,69,21,3,19,22]),function(ae,e,w,L,C,M,j,P,h,r,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=E,e.$5k=f,e.$6k=s,e.$7k=d,e.$8k=v,e.$9k=i,e.$0k=t,e.$$k=c,e.$_k=S,e.$al=p,e.$bl=D,e.$dl=z,e.$el=Z,e.$fl=T,e.$gl=R,e.$hl=m,e.$kl=te,e.$wl=q,e.$xl=Q,e.$zl=de,e.$3k=(0,h.$wi)("fileService");function E(B){return B.create===!0}var o;(function(B){B[B.Unknown=0]="Unknown",B[B.File=1]="File",B[B.Directory=2]="Directory",B[B.SymbolicLink=64]="SymbolicLink"})(o||(e.FileType=o={}));var a;(function(B){B[B.Readonly=1]="Readonly",B[B.Locked=2]="Locked"})(a||(e.FilePermission=a={}));var g;(function(B){B[B.UPDATED=2]="UPDATED",B[B.ADDED=4]="ADDED",B[B.DELETED=8]="DELETED"})(g||(e.FileChangeFilter=g={}));function f(B){const le=B;return!!le&&typeof le.onDidChange=="function"}var n;(function(B){B[B.None=0]="None",B[B.FileReadWrite=2]="FileReadWrite",B[B.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",B[B.FileReadStream=16]="FileReadStream",B[B.FileFolderCopy=8]="FileFolderCopy",B[B.PathCaseSensitive=1024]="PathCaseSensitive",B[B.Readonly=2048]="Readonly",B[B.Trash=4096]="Trash",B[B.FileWriteUnlock=8192]="FileWriteUnlock",B[B.FileAtomicRead=16384]="FileAtomicRead",B[B.FileAtomicWrite=32768]="FileAtomicWrite",B[B.FileAtomicDelete=65536]="FileAtomicDelete",B[B.FileClone=131072]="FileClone"})(n||(e.FileSystemProviderCapabilities=n={}));function s(B){return!!(B.capabilities&2)}function d(B){return!!(B.capabilities&8)}function v(B){return!!(B.capabilities&131072)}function i(B){return!!(B.capabilities&4)}function t(B){return!!(B.capabilities&16)}function c(B){return s(B)?!!(B.capabilities&16384):!1}function S(B){return s(B)?!!(B.capabilities&32768):!1}function p(B){return!!(B.capabilities&65536)}function D(B){return!!(B.capabilities&2048)}var k;(function(B){B.FileExists="EntryExists",B.FileNotFound="EntryNotFound",B.FileNotADirectory="EntryNotADirectory",B.FileIsADirectory="EntryIsADirectory",B.FileExceedsStorageQuota="EntryExceedsStorageQuota",B.FileTooLarge="EntryTooLarge",B.FileWriteLocked="EntryWriteLocked",B.NoPermissions="NoPermissions",B.Unavailable="Unavailable",B.Unknown="Unknown"})(k||(e.FileSystemProviderErrorCode=k={}));class b extends Error{static create(le,_){const u=new b(le.toString(),_);return T(u,_),u}constructor(le,_){super(le),this.code=_}}e.$cl=b;function z(B,le){return b.create(B,le)}function Z(B){return B||z((0,P.localize)(0,null),k.Unknown)}function T(B,le){return B.name=le?`${le} (FileSystemError)`:"FileSystemError",B}function R(B){if(!B)return k.Unknown;if(B instanceof b)return B.code;const le=/^(.+) \(FileSystemError\)$/.exec(B.name);if(!le)return k.Unknown;switch(le[1]){case k.FileExists:return k.FileExists;case k.FileIsADirectory:return k.FileIsADirectory;case k.FileNotADirectory:return k.FileNotADirectory;case k.FileNotFound:return k.FileNotFound;case k.FileTooLarge:return k.FileTooLarge;case k.FileWriteLocked:return k.FileWriteLocked;case k.NoPermissions:return k.NoPermissions;case k.Unavailable:return k.Unavailable}return k.Unknown}function m(B){if(B instanceof G)return B.fileOperationResult;switch(R(B)){case k.FileNotFound:return 1;case k.FileIsADirectory:return 0;case k.FileNotADirectory:return 9;case k.FileWriteLocked:return 5;case k.NoPermissions:return 6;case k.FileExists:return 4;case k.FileTooLarge:return 7;default:return 10}}var O;(function(B){B[B.CREATE=0]="CREATE",B[B.DELETE=1]="DELETE",B[B.MOVE=2]="MOVE",B[B.COPY=3]="COPY",B[B.WRITE=4]="WRITE"})(O||(e.FileOperation=O={}));class ${constructor(le,_,u){this.resource=le,this.operation=_,this.target=u}isOperation(le){return this.operation===le}}e.$il=$;var A;(function(B){B[B.UPDATED=0]="UPDATED",B[B.ADDED=1]="ADDED",B[B.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class Y{static{this.a=null}constructor(le,_){this.c=_,this.b=void 0,this.d=new l.$V(()=>{const u=w.$Ci.forUris(()=>this.c);return u.fill(this.rawAdded.map(N=>[N,!0])),u}),this.f=new l.$V(()=>{const u=w.$Ci.forUris(()=>this.c);return u.fill(this.rawUpdated.map(N=>[N,!0])),u}),this.g=new l.$V(()=>{const u=w.$Ci.forUris(()=>this.c);return u.fill(this.rawDeleted.map(N=>[N,!0])),u}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const u of le){switch(u.type){case 1:this.rawAdded.push(u.resource);break;case 0:this.rawUpdated.push(u.resource);break;case 2:this.rawDeleted.push(u.resource);break}this.b!==Y.a&&(typeof u.cId=="number"?this.b===void 0?this.b=u.cId:this.b!==u.cId&&(this.b=Y.a):this.b!==void 0&&(this.b=Y.a))}}contains(le,..._){return this.h(le,{includeChildren:!1},..._)}affects(le,..._){return this.h(le,{includeChildren:!0},..._)}h(le,_,...u){if(!le)return!1;const N=u.length>0;return!!((!N||u.includes(1))&&(this.d.value.get(le)||_.includeChildren&&this.d.value.findSuperstr(le))||(!N||u.includes(0))&&(this.f.value.get(le)||_.includeChildren&&this.f.value.findSuperstr(le))||(!N||u.includes(2))&&(this.g.value.findSubstr(le)||_.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$jl=Y;function te(B,le,_){return!B||!le||B===le||le.length>B.length?!1:(le.charAt(le.length-1)!==L.sep&&(le+=L.sep),_?(0,C.$zf)(B,le):B.indexOf(le)===0)}class G extends Error{constructor(le,_,u){super(le),this.fileOperationResult=_,this.options=u}}e.$ll=G;class ee extends G{constructor(le,_,u,N){super(le,_,N),this.fileOperationResult=_,this.size=u}}e.$ml=ee;class ce extends G{constructor(le,_,u){super(le,2,u),this.stat=_}}e.$nl=ce;var ue;(function(B){B[B.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",B[B.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",B[B.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",B[B.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",B[B.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",B[B.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",B[B.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",B[B.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",B[B.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",B[B.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",B[B.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var X;(function(B){B[B.FILE=0]="FILE",B[B.FOLDER=1]="FOLDER",B[B.ROOT_FOLDER=2]="ROOT_FOLDER"})(X||(e.FileKind=X={})),e.$vl="";function q(B){if(!(typeof B.size!="number"||typeof B.mtime!="number"))return B.mtime.toString(29)+B.size.toString(31)}async function Q(B,le){if(!le.hasProvider(j.URI.from({scheme:B.scheme})))return new Promise(_=>{const u=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===B.scheme&&N.added&&(u.dispose(),_())})})}class K{static{this.KB=1024}static{this.MB=K.KB*K.KB}static{this.GB=K.MB*K.KB}static{this.TB=K.GB*K.KB}static formatSize(le){return(0,M.$ag)(le)||(le=0),le<K.KB?(0,P.localize)(1,null,le.toFixed(0)):le<K.MB?(0,P.localize)(2,null,(le/K.KB).toFixed(2)):le<K.GB?(0,P.localize)(3,null,(le/K.MB).toFixed(2)):le<K.TB?(0,P.localize)(4,null,(le/K.GB).toFixed(2)):(0,P.localize)(5,null,(le/K.TB).toFixed(2))}}e.$yl=K;function de(B){const le=typeof B=="string"||B?.scheme===y.Schemas.vscodeRemote;return typeof B!="string"&&B?.scheme===y.Schemas.file?1024*K.MB:le?10*K.MB:r.$o?50*K.MB:1024*K.MB}}),define(fe[8],me([0,1,70,56,4,49,2,25,3,23,9,6,35,21]),function(ae,e,w,L,C,M,j,P,h,r,y,l,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=g,e.log=n,e.$ek=b,e.$fk=z,e.$gk=Z,e.$hk=T,e.$3j=(0,o.$wi)("logService"),e.$4j=(0,o.$wi)("loggerService");function a(){return new Date().toISOString()}function g(R){return(0,y.$ag)(R)}var f;(function(R){R[R.Off=0]="Off",R[R.Trace=1]="Trace",R[R.Debug=2]="Debug",R[R.Info=3]="Info",R[R.Warning=4]="Warning",R[R.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$6j=f.Info;function n(R,m,O){switch(m){case f.Trace:R.trace(O);break;case f.Debug:R.debug(O);break;case f.Info:R.info(O);break;case f.Warning:R.warn(O);break;case f.Error:R.error(O);break;case f.Off:break;default:throw new Error(`Invalid log level ${m}`)}}function s(R,m=!1){let O="";for(let $=0;$<R.length;$++){let A=R[$];if(A instanceof Error&&(A=(0,L.$hj)(A,m)),typeof A=="object")try{A=JSON.stringify(A)}catch{}O+=($>0?" ":"")+A}return O}class d extends j.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new C.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==f.Off&&this.b<=m}}e.$8j=d;class v extends d{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...O){this.f(f.Trace)&&this.g(f.Trace,s([m,...O],!0))}debug(m,...O){this.f(f.Debug)&&this.g(f.Debug,s([m,...O]))}info(m,...O){this.f(f.Info)&&this.g(f.Info,s([m,...O]))}warn(m,...O){this.f(f.Warning)&&this.g(f.Warning,s([m,...O]))}error(m,...O){if(this.f(f.Error))if(m instanceof Error){const $=Array.prototype.slice.call(arguments);$[0]=m.stack,this.g(f.Error,s($))}else this.g(f.Error,s([m,...O]))}flush(){}}e.$9j=v;class i extends d{constructor(m=e.$6j){super(),this.setLevel(m),this.g=!h.$i}trace(m,...O){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,m,...O):console.log(`[main ${a()}]`,m,...O))}debug(m,...O){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,m,...O):console.log(`[main ${a()}]`,m,...O))}info(m,...O){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${a()}]\x1B[0m`,m,...O):console.log(`[main ${a()}]`,m,...O))}warn(m,...O){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${a()}]\x1B[0m`,m,...O):console.warn(`[main ${a()}]`,m,...O))}error(m,...O){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${a()}]\x1B[0m`,m,...O):console.error(`[main ${a()}]`,m,...O))}flush(){}}e.$0j=i;class t extends d{constructor(m=e.$6j,O=!0){super(),this.g=O,this.setLevel(m)}trace(m,...O){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...O):console.log(m,...O))}debug(m,...O){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...O):console.log(m,...O))}info(m,...O){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...O):console.log(m,...O))}warn(m,...O){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...O):console.log(m,...O))}error(m,...O){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...O):console.error(m,...O))}flush(){}}e.$$j=t;class c extends d{constructor(m,O=e.$6j){super(),this.g=m,this.setLevel(O)}trace(m,...O){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(m),...O])}debug(m,...O){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(m),...O])}info(m,...O){this.f(f.Info)&&this.g.log(f.Info,[this.h(m),...O])}warn(m,...O){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(m),...O])}error(m,...O){this.f(f.Error)&&this.g.log(f.Error,[this.h(m),...O])}h(m){return typeof m=="string"?m:(0,L.$hj)(m,this.f(f.Trace))}flush(){}}e.$_j=c;class S extends d{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const O of this.g)O.setLevel(m);super.setLevel(m)}trace(m,...O){for(const $ of this.g)$.trace(m,...O)}debug(m,...O){for(const $ of this.g)$.debug(m,...O)}info(m,...O){for(const $ of this.g)$.info(m,...O)}warn(m,...O){for(const $ of this.g)$.warn(m,...O)}error(m,...O){for(const $ of this.g)$.error(m,...O)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose();super.dispose()}}e.$ak=S;class p extends j.$Vc{constructor(m,O,$){if(super(),this.h=m,this.j=O,this.b=new P.$Bc,this.c=this.B(new C.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new C.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new C.$ee),this.onDidChangeVisibility=this.g.event,$)for(const A of $)this.b.set(A.resource,{logger:void 0,info:A})}m(m){return(0,y.$9f)(m)?[...this.b.values()].find(O=>O.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,O){const $=this.n(m),A=(0,y.$9f)(m)?m:O?.id??(0,M.$kj)($.toString()).toString(16);let Y=this.b.get($)?.logger;const te=O?.logLevel==="always"?f.Trace:O?.logLevel;Y||(Y=this.s($,te??this.getLogLevel($)??this.h,{...O,id:A}));const G={logger:Y,info:{resource:$,id:A,logLevel:te,name:O?.name,hidden:O?.hidden,extensionId:O?.extensionId,when:O?.when}};return this.registerLogger(G.info),this.b.set($,G),Y}n(m){return(0,y.$9f)(m)?(0,r.$0g)(this.j,`${m}.log`):m}setLogLevel(m,O){if(l.URI.isUri(m)){const $=m,A=O,Y=this.b.get($);Y&&A!==Y.info.logLevel&&(Y.info.logLevel=A===this.h?void 0:A,Y.logger?.setLevel(A),this.b.set(Y.info.resource,Y),this.f.fire([$,A]))}else{this.h=m;for(const[$,A]of this.b.entries())this.b.get($)?.info.logLevel===void 0&&A.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,O){const $=this.m(m);$&&O!==!$.info.hidden&&($.info.hidden=!O,this.b.set($.info.resource,$),this.g.fire([$.info.resource,O]))}getLogLevel(m){let O;return m&&(O=this.b.get(m)?.info.logLevel),O??this.h}registerLogger(m){const O=this.b.get(m.resource);O?O.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const O=this.b.get(m);O&&(O.logger&&O.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[O.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=p;class D{constructor(){this.onDidChangeLogLevel=new C.$ee().event}setLevel(m){}getLevel(){return f.Info}trace(m,...O){}debug(m,...O){}info(m,...O){}warn(m,...O){}error(m,...O){}critical(m,...O){}dispose(){}flush(){}}e.$ck=D;class k extends D{}e.$dk=k;function b(R){if(R.verbose)return f.Trace;if(typeof R.logLevel=="string"){const m=T(R.logLevel.toLowerCase());if(m!==void 0)return m}return e.$6j}function z(R){switch(R){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function Z(R){switch(R){case f.Trace:return{original:"Trace",value:w.localize(0,null)};case f.Debug:return{original:"Debug",value:w.localize(1,null)};case f.Info:return{original:"Info",value:w.localize(2,null)};case f.Warning:return{original:"Warning",value:w.localize(3,null)};case f.Error:return{original:"Error",value:w.localize(4,null)};case f.Off:return{original:"Off",value:w.localize(5,null)}}}function T(R){switch(R){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ik=new E.$Nj("logLevel",z(f.Info))}),define(fe[80],me([0,1,6,4,8,2]),function(ae,e,w,L,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=void 0;class j extends C.$bk{constructor(l,E,o,a,g){super(E,o,a),this.r=l,this.t=g,this.B(g.listen("onDidChangeLogLevel",l)(f=>{(0,C.$5j)(f)?super.setLogLevel(f):super.setLogLevel(w.URI.revive(f[0]),f[1])})),this.B(g.listen("onDidChangeVisibility",l)(([f,n])=>super.setVisibility(w.URI.revive(f),n))),this.B(g.listen("onDidChangeLoggers",l)(({added:f,removed:n})=>{for(const s of f)super.registerLogger({...s,resource:w.URI.revive(s.resource)});for(const s of n)super.deregisterLogger(s.resource)}))}createConsoleMainLogger(){return new C.$_j({log:(l,E)=>{this.t.call("consoleLog",[l,E])}})}registerLogger(l){super.registerLogger(l),this.t.call("registerLogger",[l,this.r])}deregisterLogger(l){super.deregisterLogger(l),this.t.call("deregisterLogger",[l,this.r])}setLogLevel(l,E){super.setLogLevel(l,E),this.t.call("setLogLevel",[l,E])}setVisibility(l,E){super.setVisibility(l,E),this.t.call("setVisibility",[this.n(l),E])}s(l,E,o){return new P(this.t,l,E,o,this.r)}static setLogLevel(l,E,o){return l.call("setLogLevel",[E,o])}}e.$_r=j;class P extends C.$9j{constructor(l,E,o,a,g){super(a?.logLevel==="always"),this.r=l,this.s=E,this.m=!1,this.n=[],this.setLevel(o),this.r.call("createLogger",[E,a,g]).then(()=>{this.u(this.n),this.m=!0})}g(l,E){const o=[[l,E]];this.m?this.u(o):this.n.push(...o)}u(l){this.r.call("log",[this.s,l])}}class h{constructor(l,E){this.a=l,this.b=E}listen(l,E){const o=this.b(l);switch(E){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,a=>({added:[...a.added].map(g=>this.c(g,o)),removed:[...a.removed].map(g=>this.c(g,o))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,a=>[o.transformOutgoingURI(a[0]),a[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,a=>(0,C.$5j)(a)?a:[o.transformOutgoingURI(a[0]),a[1]])}throw new Error(`Event not found: ${E}`)}async call(l,E,o){const a=this.b(l);switch(E){case"setLogLevel":return(0,C.$5j)(o[0])?this.a.setLogLevel(o[0]):this.a.setLogLevel(w.URI.revive(a.transformIncoming(o[0][0])),o[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(g=>this.c(g,a)))}throw new Error(`Call not found: ${E}`)}c(l,E){return{...l,resource:E.transformOutgoingURI(l.resource)}}}e.$as=h;class r extends M.$Vc{constructor(l,E){super(),E.call("setLogLevel",[l.getLogLevel()]),this.B(l.onDidChangeLogLevel(o=>E.call("setLogLevel",[o]))),E.call("getRegisteredLoggers").then(o=>{for(const a of o)l.registerLogger({...a,resource:w.URI.revive(a.resource)})}),this.B(E.listen("onDidChangeVisibility")(([o,a])=>l.setVisibility(w.URI.revive(o),a))),this.B(E.listen("onDidChangeLoggers")(({added:o,removed:a})=>{for(const g of o)l.registerLogger({...g,resource:w.URI.revive(g.resource)});for(const g of a)l.deregisterLogger(g.resource)}))}}e.$bs=r}),define(fe[81],me([0,1,2,8]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;class C extends w.$Vc{constructor(j,P=[]){super(),this.a=new L.$ak([j,...P]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...P){this.a.trace(j,...P)}debug(j,...P){this.a.debug(j,...P)}info(j,...P){this.a.info(j,...P)}warn(j,...P){this.a.warn(j,...P)}error(j,...P){this.a.error(j,...P)}flush(){this.a.flush()}}e.$UQ=C}),define(fe[82],me([0,1,79,8]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=void 0;var C;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(C||(C={}));async function M(r,y,l,E,o){try{const a=await new Promise((f,n)=>{ae(["@vscode/spdlog"],f,n)});a.setFlushOn(C.Trace);const g=await a.createAsyncRotatingLogger(r,y,l,E);return o?g.clearFormatters():g.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),g}catch(a){console.error(a)}return null}function j(r,y,l){switch(y){case L.LogLevel.Trace:r.trace(l);break;case L.LogLevel.Debug:r.debug(l);break;case L.LogLevel.Info:r.info(l);break;case L.LogLevel.Warning:r.warn(l);break;case L.LogLevel.Error:r.error(l);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function P(r,y){switch(y){case L.LogLevel.Trace:r.setLevel(C.Trace);break;case L.LogLevel.Debug:r.setLevel(C.Debug);break;case L.LogLevel.Info:r.setLevel(C.Info);break;case L.LogLevel.Warning:r.setLevel(C.Warning);break;case L.LogLevel.Error:r.setLevel(C.Error);break;case L.LogLevel.Off:r.setLevel(C.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class h extends L.$9j{constructor(y,l,E,o,a){super(),this.m=[],this.setLevel(a),this.n=this.s(y,l,E,o),this.B(this.onDidChangeLogLevel(g=>{this.r&&P(this.r,g)}))}async s(y,l,E,o){const a=E?6:1,g=30/a*w.$yl.MB,f=await M(y,l,g,a,o);if(f){this.r=f,P(this.r,this.getLevel());for(const{level:n,message:s}of this.m)j(this.r,n,s);this.m=[]}}g(y,l){this.r?j(this.r,y,l):this.getLevel()<=y&&this.m.push({level:y,message:l})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$JQ=h}),define(fe[83],me([0,1,52,8,82]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=void 0;class M extends L.$bk{s(P,h,r){return new C.$JQ((0,w.$Sg)(),P.fsPath,!r?.donotRotate,!!r?.donotUseFormatters,h)}}e.$KQ=M}),define(fe[84],me([0,1,15]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const C=globalThis.vscode;if(typeof C<"u"&&typeof C.context<"u"){const M=C.context.configuration();if(M)L=M.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,w.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const M=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:M.version})}}else L={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-toolsai.datawrangler":["debugFocus"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipant","chatParticipantAdditions","defaultChatParticipant","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter","debugVisualization"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"apidev.azure-api-center":["chatParticipant","languageModels"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:{github:["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatWelcomeView:{welcomeViewId:"copilot.welcome",welcomeViewTitle:"GitHub Copilot",welcomeViewContent:`You have access to GitHub Copilot, an AI-powered coding assistant, as a part of the Microsoft organization.
 Getting started with Copilot is easy - simply install the Copilot extension. [Learn more](https://code.visualstudio.com/docs/copilot/overview)
[Install GitHub Copilot](command:workbench.extensions.installExtension?%5B%22github.copilot%22%5D)`},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.89.0",sha256:"2abd9c01f711c0d60d40b722b5bed0930701be173931f3c6251906f692858221",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.89.1",commit:"dc96b837cf6bb4af9cd736aa3af08cf8279f7685",date:"2024-05-07T04:07:05.306Z"},Object.keys(L).length===0&&Object.assign(L,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(fe[85],me([0,1,21]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,w.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(fe[86],me([0,1,42,9]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class C{constructor(){this.a=new Map}add(j,P){w.ok(L.$9f(j)),w.ok(L.$$f(P)),w.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,P)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$co=new C}),define(fe[87],me([0,1,4,2]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tub=void 0;class C extends L.$Vc{constructor(j){super(),this.f=j,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new w.$ee),this.onMarkAdded=this.c.event}*markers(){for(const j of this.a.values())yield j;for(const j of this.b.values())yield j}addMark(j){const P=j?.marker||this.f.registerMarker(),h=j?.id;P&&(h?(this.a.set(h,P),P.onDispose(()=>this.a.delete(h))):(this.b.set(P.id,P),P.onDispose(()=>this.b.delete(P.id))),this.c.fire({marker:P,id:h,hidden:j?.hidden,hoverMessage:j?.hoverMessage}))}getMark(j){return this.a.get(j)}}e.$tub=C});var Ne=this&&this.__param||function(ae,e){return function(w,L){e(w,L,ae)}};define(fe[88],me([0,1,4,2,8,14]),function(ae,e,w,L,C,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;var j;(function(h){h[h.Unknown=0]="Unknown",h[h.Input=1]="Input",h[h.Execute=2]="Execute"})(j||(j={}));let P=class extends L.$Vc{get value(){return this.h}get cursorIndex(){return this.j}get ghostTextIndex(){return this.m}constructor(r,y,l,E){super(),this.u=r,this.w=E,this.a=0,this.c=0,this.g="",this.h="",this.j=0,this.m=-1,this.n=this.B(new w.$ee),this.onDidStartInput=this.n.event,this.r=this.B(new w.$ee),this.onDidChangeInput=this.r.event,this.s=this.B(new w.$ee),this.onDidFinishInput=this.s.event,this.t=this.B(new w.$ee),this.onDidInterrupt=this.t.event,this.B(w.Event.any(this.u.onCursorMove,this.u.onData,this.u.onWriteParsed)(()=>this.F())),this.B(this.u.onData(o=>this.G(o))),this.B(y(o=>this.C(o))),this.B(l(()=>this.D())),this.B(this.onDidStartInput(()=>this.z("PromptInputModel#onDidStartInput"))),this.B(this.onDidChangeInput(()=>this.z("PromptInputModel#onDidChangeInput"))),this.B(this.onDidFinishInput(()=>this.z("PromptInputModel#onDidFinishInput"))),this.B(this.onDidInterrupt(()=>this.z("PromptInputModel#onDidInterrupt")))}z(r){this.w.getLevel()===C.LogLevel.Trace&&this.w.trace(r,this.getCombinedString())}setContinuationPrompt(r){this.f=r}setConfidentCommandLine(r){this.h!==r&&(this.h=r,this.j=-1,this.m=-1,this.r.fire(this.O()))}getCombinedString(){const r=this.h.replaceAll(`
`,"\u23CE");if(this.j===-1)return r;let y=`${r.substring(0,this.cursorIndex)}|`;return this.ghostTextIndex!==-1?(y+=`${r.substring(this.cursorIndex,this.ghostTextIndex)}[`,y+=`${r.substring(this.ghostTextIndex)}]`):y+=r.substring(this.cursorIndex),y}C(r){this.a!==1&&(this.a=1,this.b=r.marker,this.c=this.u.buffer.active.cursorX,this.h="",this.j=0,this.n.fire(this.O()),this.r.fire(this.O()))}D(){if(this.a===2)return;this.j=-1,this.m!==-1&&(this.h=this.h.substring(0,this.m),this.m=-1);const r=this.O();this.g===""&&this.t.fire(r),this.a=2,this.s.fire(r),this.r.fire(r)}F(){if(this.a!==1)return;const r=this.b?.line;if(r===void 0)return;const y=this.u.buffer.active;let l=y.getLine(r);const E=l?.translateToString(!0,this.c);if(!l||E===void 0){this.w.trace("PromptInputModel#_sync: no line");return}const o=y.baseY+y.cursorY;let a=E,g=o===r?this.M(this.c,y,l):E.length+1,f=-1;o===r&&y.cursorX>1&&(f=this.H(y,l,g));for(let n=r+1;n<=o;n++){l=y.getLine(n);let s=l?.translateToString(!0);if(s&&l)if(this.f===void 0||this.J(s))s=this.I(s),a+=`
${s}`,g+=o===n?this.M(this.L(l,s),y,l):s.length+1;else break}for(let n=o+1;n<y.baseY+this.u.rows;n++){l=y.getLine(n);const s=l?.translateToString(!0);if(s&&l)if(this.f===void 0||this.J(s))a+=`
${this.I(s)}`;else break;else break}this.w.getLevel()===C.LogLevel.Trace&&this.w.trace(`PromptInputModel#_sync: ${this.getCombinedString()}`),(this.h!==a||this.j!==g||this.m!==f)&&(this.h=a,this.j=g,this.m=f,this.r.fire(this.O()))}G(r){this.g=r}H(r,y,l){let E=-1,o=!1,a=r.cursorX;for(;a>0;){const g=y.getCell(--a);if(!g)break;if(g.getChars().trim().length>0){o=!this.N(g);break}}if(o){let g=0,f=r.cursorX;for(;f<y.length;){const n=y.getCell(f++);if(!n||n.getCode()===0)break;if(this.N(n)){E=l+g;break}g+=n.getChars().length}}return E}I(r){return this.J(r)&&(r=r.substring(this.f.length)),r}J(r){return!!(this.f&&r.startsWith(this.f))}L(r,y){if(!this.f||!y.startsWith(this.f))return 0;let l="",E=0;for(;l!==this.f;)l+=r.getCell(E++).getChars();return E}M(r,y,l){return l?.translateToString(!0,r,y.cursorX).length??0}N(r){return!!(r.isItalic()||r.isDim())}O(){return Object.freeze({value:this.h,cursorIndex:this.j,ghostTextIndex:this.m})}};e.$3r=P,be([(0,M.$3h)(0)],P.prototype,"F",null),e.$3r=P=be([Ne(3,C.$3j)],P)}),define(fe[89],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=e.$4r=void 0;class w{get command(){return this.b.command}get commandLineConfidence(){return this.b.commandLineConfidence}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get duration(){return this.b.duration}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(y){this.b.endMarker=y}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(y,l){this.a=y,this.b=l}static deserialize(y,l,E){const o=y.buffer.normal,a=l.startLine!==void 0?y.registerMarker(l.startLine-(o.baseY+o.cursorY)):void 0;if(!a)return;const g=l.promptStartLine!==void 0?y.registerMarker(l.promptStartLine-(o.baseY+o.cursorY)):void 0,f=l.endLine!==void 0?y.registerMarker(l.endLine-(o.baseY+o.cursorY)):void 0,n=l.executedLine!==void 0?y.registerMarker(l.executedLine-(o.baseY+o.cursorY)):void 0;return new w(y,{command:E?"":l.command,commandLineConfidence:l.commandLineConfidence??"low",isTrusted:l.isTrusted,promptStartMarker:g,marker:a,startX:l.startX,endMarker:f,executedMarker:n,executedX:l.executedX,timestamp:l.timestamp,duration:l.duration,cwd:l.cwd,commandStartLineContent:l.commandStartLineContent,exitCode:l.exitCode,markProperties:l.markProperties,aliases:void 0,wasReplayed:!0})}serialize(y){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:y?"":this.command,commandLineConfidence:y?"low":this.commandLineConfidence,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,duration:this.duration,markProperties:this.markProperties}}extractCommandLine(){return C(this.a.buffer.active,this.a.cols,this.marker,this.startX,this.executedMarker,this.executedX)}getOutput(){if(!this.executedMarker||!this.endMarker)return;const y=this.executedMarker.line,l=this.endMarker.line;if(y===l)return;let E="",o;for(let a=y;a<l;a++)o=this.a.buffer.active.getLine(a),o&&(E+=o.translateToString(!o.isWrapped)+(o.isWrapped?"":`
`));return E===""?void 0:E}getOutputMatch(y){if(!this.executedMarker||!this.endMarker)return;const l=this.endMarker.line;if(l===-1)return;const E=this.a.buffer.active,o=Math.max(this.executedMarker.line,0),a=y.lineMatcher,g=typeof a=="string"?1:y.length||j(a),f=[];let n;if(y.anchor==="bottom")for(let s=l-(y.offset||0);s>=o;s--){let d=s;const v=s;for(;d>=o&&E.getLine(d)?.isWrapped;)d--;if(s=d,f.unshift(M(E,d,v,this.a.cols)),n||(n=f[0].match(a)),f.length>=g)break}else for(let s=o+(y.offset||0);s<l;s++){const d=s;let v=s;for(;v+1<l&&E.getLine(v+1)?.isWrapped;)v++;if(s=v,f.push(M(E,d,v,this.a.cols)),n||(n=f[f.length-1].match(a)),f.length>=g)break}return n?{regexMatch:n,outputLines:f}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return P(this,this.a.buffer.active)}getCommandRowCount(){return h(this)}}e.$4r=w;class L{constructor(y){this.c=y}serialize(y){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",commandLineConfidence:"low",isTrusted:!0,cwd:y,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,duration:0,markProperties:void 0}}promoteToFullCommand(y,l,E,o){if(l===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||E)return new w(this.c,{command:E?"":this.command||"",commandLineConfidence:E?"low":this.commandLineConfidence||"low",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),duration:this.b||0,cwd:y,exitCode:l,commandStartLineContent:this.commandStartLineContent,markProperties:o})}markExecutedTime(){this.a===void 0&&(this.a=Date.now())}markFinishedTime(){this.b===void 0&&this.a!==void 0&&(this.b=Date.now()-this.a)}extractCommandLine(){return C(this.c.buffer.active,this.c.cols,this.commandStartMarker,this.commandStartX,this.commandExecutedMarker,this.commandExecutedX)}getPromptRowCount(){return P(this,this.c.buffer.active)}getCommandRowCount(){return h(this)}}e.$5r=L;function C(r,y,l,E,o,a){if(!l||!o||E===void 0||a===void 0)return"";let g="";for(let f=l.line;f<=o.line;f++){const n=r.getLine(f);n&&(g+=n.translateToString(!0,f===l.line?E:0,f===o.line?a:y))}return g}function M(r,y,l,E){const o=Math.max(2048/E*2);l=Math.min(l,y+o);let a="";for(let g=y;g<=l;g++){const f=r.getLine(g);f&&(a+=f.translateToString(!0,0,E))}return a}function j(r){if(!r.multiline)return 1;const y=r.source;let l=1,E=y.indexOf("\\n");for(;E!==-1;)l++,E=y.indexOf("\\n",E+1);return l}function P(r,y){const l="hasOutput"in r?r.marker:r.commandStartMarker;if(!l||!r.promptStartMarker)return 1;let E=1,o=r.promptStartMarker.line;for(;o<l.line&&(y.getLine(o)?.translateToString(!0)??"").length===0;)o++;return E=l.line-o+1,E}function h(r){const y="hasOutput"in r?r.marker:r.commandStartMarker,l="hasOutput"in r?r.executedMarker:r.commandExecutedMarker;if(!y||!l)return 1;let o=Math.max(l.line,y.line)-y.line+1;return("hasOutput"in r?r.executedX:r.commandExecutedX)===0&&o--,o}}),define(fe[90],me([0,1,11,14,4,2,8,89,88]),function(ae,e,w,L,C,M,j,P,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pub=void 0,e.$qub=o;let r=class extends M.$Vc{get promptInputModel(){return this.c}get commands(){return this.f}get executingCommand(){return this.h.command}get executingCommandObject(){if(this.h.commandStartMarker)return{marker:this.h.commandStartMarker}}get currentCommand(){return this.h}get cwd(){return this.g}get C(){return!!(this.h.commandStartMarker&&!this.h.commandExecutedMarker)}get hasInput(){if(!(!this.C||!this.h?.commandStartMarker)){if(this.L.buffer.active.baseY+this.L.buffer.active.cursorY===this.h.commandStartMarker?.line){const n=this.L.buffer.active.getLine(this.L.buffer.active.cursorY)?.translateToString(!0,this.h.commandStartX);return n===void 0?void 0:n.length>0}return!0}}constructor(n,s){super(),this.L=n,this.M=s,this.type=2,this.f=[],this.h=new P.$5r(this.L),this.n=[],this.s=!1,this.D=this.B(new C.$ee),this.onCommandStarted=this.D.event,this.F=this.B(new C.$ee),this.onBeforeCommandFinished=this.F.event,this.G=this.B(new C.$ee),this.onCommandFinished=this.G.event,this.H=this.B(new C.$ee),this.onCommandExecuted=this.H.event,this.I=this.B(new C.$ee),this.onCommandInvalidated=this.I.event,this.J=this.B(new C.$ee),this.onCurrentCommandInvalidated=this.J.event,this.c=this.B(new h.$3r(this.L,this.onCommandStarted,this.onCommandExecuted,this.M)),this.B(this.onCommandExecuted(v=>{if(v.commandLineConfidence!=="high"){const i=v;v.command=i.extractCommandLine(),v.commandLineConfidence="low","getOutput"in i?i.promptStartMarker&&i.marker&&i.executedMarker&&v.command.indexOf(`
`)===-1&&i.startX!==void 0&&i.startX>0&&(v.commandLineConfidence="medium"):i.promptStartMarker&&i.commandStartMarker&&i.commandExecutedMarker&&v.command.indexOf(`
`)===-1&&i.commandStartX!==void 0&&i.commandStartX>0&&(v.commandLineConfidence="medium")}}));const d=this;this.w=new class{get onCurrentCommandInvalidatedEmitter(){return d.J}get onCommandStartedEmitter(){return d.D}get onCommandExecutedEmitter(){return d.H}get dimensions(){return d.r}get isCommandStorageDisabled(){return d.s}get commandMarkers(){return d.n}set commandMarkers(v){d.n=v}get clearCommandsInViewport(){return d.P.bind(d)}commitCommandFinished(){d.u?.flush(),d.u=void 0}},this.z=this.B(new M.$Xc(new y(this.L,this,this.w,this.M))),this.r={cols:this.L.cols,rows:this.L.rows},this.B(this.L.onResize(v=>this.N(v))),this.B(this.L.onCursorMove(()=>this.O()))}N(n){this.z.value.preHandleResize?.(n),this.r.cols=n.cols,this.r.rows=n.rows}O(){this.L.buffer.active===this.L.buffer.normal&&this.h.commandStartMarker&&this.L.buffer.active.baseY+this.L.buffer.active.cursorY<this.h.commandStartMarker.line&&(this.P(),this.h.isInvalid=!0,this.J.fire({reason:"windows"}))}P(){let n=0;for(let s=this.f.length-1;s>=0;s--){const d=this.f[s].marker?.line;if(d&&d<this.L.buffer.active.baseY)break;n++}n>0&&this.I.fire(this.f.splice(this.f.length-n,n))}setContinuationPrompt(n){this.c.setContinuationPrompt(n)}setCwd(n){this.g=n}setIsWindowsPty(n){if(n&&!(this.z.value instanceof E)){const s=this;this.z.value=new E(this.L,this,new class{get onCurrentCommandInvalidatedEmitter(){return s.J}get onCommandStartedEmitter(){return s.D}get onCommandExecutedEmitter(){return s.H}get dimensions(){return s.r}get isCommandStorageDisabled(){return s.s}get commandMarkers(){return s.n}set commandMarkers(d){s.n=d}get clearCommandsInViewport(){return s.P.bind(s)}commitCommandFinished(){s.u?.flush(),s.u=void 0}},this.M)}else!n&&!(this.z.value instanceof y)&&(this.z.value=new y(this.L,this,this.w,this.M))}setIsCommandStorageDisabled(){this.s=!0}getCommandForLine(n){if(this.h.promptStartMarker&&n>=this.h.promptStartMarker?.line)return this.h;if(this.f.length!==0&&!((this.f[0].promptStartMarker??this.f[0].marker).line>n)){for(let s=this.commands.length-1;s>=0;s--)if((this.commands[s].promptStartMarker??this.commands[s].marker).line<=n)return this.commands[s]}}getCwdForLine(n){if(this.h.promptStartMarker&&n>=this.h.promptStartMarker?.line)return this.g;const s=this.getCommandForLine(n);if(s&&"cwd"in s)return s.cwd}handlePromptStart(n){const s=this.commands.at(-1);s?.endMarker&&s?.executedMarker&&s.endMarker.line===s.executedMarker.line&&(this.M.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${s.endMarker.line} -> ${s.executedMarker.line+1}`),s.endMarker=g(this.L,s.executedMarker,1)),this.h.promptStartMarker=n?.marker||(s?.endMarker?g(this.L,s.endMarker):this.L.registerMarker(0)),this.M.debug("CommandDetectionCapability#handlePromptStart",this.L.buffer.active.cursorX,this.h.promptStartMarker?.line)}handleContinuationStart(){this.h.currentContinuationMarker=this.L.registerMarker(0),this.M.debug("CommandDetectionCapability#handleContinuationStart",this.h.currentContinuationMarker)}handleContinuationEnd(){if(!this.h.currentContinuationMarker){this.M.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.h.continuations||(this.h.continuations=[]),this.h.continuations.push({marker:this.h.currentContinuationMarker,end:this.L.buffer.active.cursorX}),this.h.currentContinuationMarker=void 0,this.M.debug("CommandDetectionCapability#handleContinuationEnd",this.h.continuations[this.h.continuations.length-1])}handleRightPromptStart(){this.h.commandRightPromptStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptStart",this.h.commandRightPromptStartX)}handleRightPromptEnd(){this.h.commandRightPromptEndX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleRightPromptEnd",this.h.commandRightPromptEndX)}handleCommandStart(n){if(this.t=n,this.h.cwd=this.g,this.h.commandStartMarker=n?.marker||this.h.commandStartMarker,this.h.commandStartMarker?.line===this.L.buffer.active.cursorY){this.h.commandStartX=this.L.buffer.active.cursorX,this.M.debug("CommandDetectionCapability#handleCommandStart",this.h.commandStartX,this.h.commandStartMarker?.line);return}this.z.value.handleCommandStart(n)}handleGenericCommand(n){n?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(n),this.handleCommandStart(n),this.handleCommandExecuted(n),this.handleCommandFinished(void 0,n)}handleCommandExecuted(n){this.z.value.handleCommandExecuted(n),this.h.markExecutedTime()}handleCommandFinished(n,s){if(this.h.markFinishedTime(),this.z.value.preHandleCommandFinished?.(),this.M.debug("CommandDetectionCapability#handleCommandFinished",this.L.buffer.active.cursorX,s?.marker?.line,this.h.command,this.h),n===void 0){const v=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.h.command&&this.h.command.length>0&&v?.command===this.h.command&&(n=v.exitCode)}if(this.h.commandStartMarker===void 0||!this.L.buffer.active)return;this.h.commandFinishedMarker=s?.marker||this.L.registerMarker(0),this.z.value.postHandleCommandFinished?.();const d=this.h.promoteToFullCommand(this.g,n,this.t?.ignoreCommandLine??!1,s?.markProperties);d&&(this.f.push(d),this.u=new w.$Ih(()=>{this.F.fire(d),this.h.isInvalid||(this.M.debug("CommandDetectionCapability#onCommandFinished",d),this.G.fire(d))},50),this.u.schedule()),this.h=new P.$5r(this.L),this.t=void 0}setCommandLine(n,s){this.M.debug("CommandDetectionCapability#setCommandLine",n,s),this.h.command=n,this.h.commandLineConfidence="high",this.h.isTrusted=s,s&&this.c.setConfidentCommandLine(n)}serialize(){const n=this.commands.map(d=>d.serialize(this.s)),s=this.h.serialize(this.g);return s&&n.push(s),{isWindowsPty:this.z.value instanceof E,commands:n}}deserialize(n){n.isWindowsPty&&this.setIsWindowsPty(n.isWindowsPty);const s=this.L.buffer.normal;for(const d of n.commands){if(!d.endLine){const i=d.startLine!==void 0?this.L.registerMarker(d.startLine-(s.baseY+s.cursorY)):void 0;if(!i)continue;this.h.commandStartMarker=d.startLine!==void 0?this.L.registerMarker(d.startLine-(s.baseY+s.cursorY)):void 0,this.h.commandStartX=d.startX,this.h.promptStartMarker=d.promptStartLine!==void 0?this.L.registerMarker(d.promptStartLine-(s.baseY+s.cursorY)):void 0,this.g=d.cwd,this.D.fire({marker:i});continue}const v=P.$4r.deserialize(this.L,d,this.s);v&&(this.f.push(v),this.M.debug("CommandDetectionCapability#onCommandFinished",v),this.G.fire(v))}}};e.$pub=r,be([(0,L.$2h)(500)],r.prototype,"O",null),e.$pub=r=be([Ne(1,j.$3j)],r);class y extends M.$Vc{constructor(n,s,d,v){super(),this.c=n,this.f=s,this.g=d,this.h=v,this.B(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&d.clearCommandsInViewport(),!1)))}handleCommandStart(n){this.g.commitCommandFinished();const s=this.f.currentCommand;s.commandStartX=this.c.buffer.active.cursorX,s.commandStartMarker=n?.marker||this.c.registerMarker(0),s.commandExecutedMarker?.dispose(),s.commandExecutedMarker=void 0,s.commandExecutedX=void 0;for(const d of this.g.commandMarkers)d.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:n?.marker||s.commandStartMarker,markProperties:n?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",s.commandStartX,s.commandStartMarker?.line)}handleCommandExecuted(n){const s=this.f.currentCommand;if(s.commandExecutedMarker=n?.marker||this.c.registerMarker(0),s.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",s.commandExecutedX,s.commandExecutedMarker?.line),!s.commandStartMarker||!s.commandExecutedMarker||s.commandStartX===void 0)return;s.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(s.commandStartMarker.line)?.translateToString(!0,s.commandStartX,s.commandRightPromptStartX).trim();let d=s.commandStartMarker.line+1;const v=s.commandExecutedMarker.line;for(;d<v;d++){const i=this.c.buffer.active.getLine(d);if(i){const t=s.continuations?.find(S=>S.marker.line===d);t&&(s.command+=`
`);const c=t?.end??0;s.command+=i.translateToString(!0,c)}}d===v&&(s.command+=this.c.buffer.active.getLine(v)?.translateToString(!0,void 0,s.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire(s)}}var l;(function(f){f[f.MaxCheckLineCount=10]="MaxCheckLineCount",f[f.Interval=20]="Interval",f[f.MaximumPollCount=10]="MaximumPollCount"})(l||(l={}));let E=class extends M.$Vc{constructor(n,s,d,v){super(),this.n=n,this.r=s,this.s=d,this.t=v,this.c=this.B(new M.$Wc),this.g=0,this.h=0,this.B(n.parser.registerCsiHandler({final:"J"},i=>(i.length>=1&&(i[0]===2||i[0]===3)&&this.s.clearCommandsInViewport(),!1))),this.B(this.r.onBeforeCommandFinished(i=>{(i.command.trim().toLowerCase()==="clear"||i.command.trim().toLowerCase()==="cls")&&(this.f?.cancel(),this.f=void 0,this.s.clearCommandsInViewport(),this.r.currentCommand.isInvalid=!0,this.s.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(n){const s=this.n.buffer.active.baseY,d=n.rows-this.s.dimensions.rows;d>0&&this.D().then(()=>{const v=Math.min(d,s);for(let i=this.r.commands.length-1;i>=0;i--){const t=this.r.commands[i];if(!t.marker||t.marker.line<s||t.commandStartLineContent===void 0)break;const c=this.n.buffer.active.getLine(t.marker.line);if(!c||c.translateToString(!0)===t.commandStartLineContent)continue;const S=t.marker.line-v;this.n.buffer.active.getLine(S)?.translateToString(!0)===t.commandStartLineContent&&this.n._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.n.buffer.active.baseY,amount:v})}})}handleCommandStart(){this.r.currentCommand.commandStartX=this.n.buffer.active.cursorX,this.s.commandMarkers.length=0;const n=this.r.currentCommand.commandStartMarker=this.r.currentCommand.promptStartMarker?g(this.n,this.r.currentCommand.promptStartMarker):this.n.registerMarker(0);this.r.currentCommand.commandStartX=0,this.g=0,this.h=0,this.f=new w.$Ih(()=>this.u(n),20),this.f.schedule()}u(n){if(this.q.isDisposed)return;const s=this.n.buffer.active;let d=this.g;for(;d<10&&n.line+d<s.baseY+this.n.rows;){if(this.C()){const v=this.F(n.line+d);if(v){const i=typeof v=="string"?v:v.prompt;if(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0),typeof v=="object"&&v.likelySingleLine){this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.r.currentCommand.promptStartMarker?.line} -> ${this.r.currentCommand.commandStartMarker.line}`),this.r.currentCommand.promptStartMarker?.dispose(),this.r.currentCommand.promptStartMarker=g(this.n,this.r.currentCommand.commandStartMarker);const t=this.r.commands.at(-1);t&&this.r.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=g(this.n,this.r.currentCommand.commandStartMarker))}this.r.currentCommand.commandStartX=i.length,this.t.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${n.line} -> ${this.r.currentCommand.commandStartMarker.line}:${this.r.currentCommand.commandStartX}`),this.w();return}}d++}d<10?(this.g=d,++this.h<10?this.f?.schedule():this.w()):this.w()}w(){if(this.f&&(this.h=10,this.f.flush(),this.f=void 0),this.s.commitCommandFinished(),this.r.currentCommand.commandExecutedMarker||(this.c.value=this.n.onCursorMove(()=>{if(this.s.commandMarkers.length===0||this.s.commandMarkers[this.s.commandMarkers.length-1].line!==this.n.buffer.active.cursorY){const n=this.n.registerMarker(0);n&&this.s.commandMarkers.push(n)}})),this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.s.onCommandStartedEmitter.fire({marker:this.r.currentCommand.commandStartMarker}),this.t.debug("CommandDetectionCapability#_handleCommandStartWindows",this.r.currentCommand.commandStartX,this.r.currentCommand.commandStartMarker?.line)}handleCommandExecuted(n){this.f&&this.w(),this.c.clear(),this.z(),this.r.currentCommand.commandExecutedX=this.n.buffer.active.cursorX,this.s.onCommandExecutedEmitter.fire(this.r.currentCommand),this.t.debug("CommandDetectionCapability#handleCommandExecuted",this.r.currentCommand.commandExecutedX,this.r.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.r.currentCommand.commandExecutedMarker||(this.s.commandMarkers.length===0&&(this.r.currentCommand.commandStartMarker||(this.r.currentCommand.commandStartMarker=this.n.registerMarker(0)),this.r.currentCommand.commandStartMarker&&this.s.commandMarkers.push(this.r.currentCommand.commandStartMarker)),this.z())}postHandleCommandFinished(){const n=this.r.currentCommand,s=n.command,d=n.commandStartMarker?.line,v=n.commandExecutedMarker?.line;if(!s||s.length===0||d===void 0||d===-1||v===void 0||v===-1)return;let i=0,t=!1;for(let c=d;c<=v;c++){const S=this.n.buffer.active.getLine(c);if(!S)break;const p=S.translateToString(!0);for(let D=0;D<p.length;D++){for(;s.length<i&&s[i]===" ";)i++;if(p[D]===s[i]&&i++,i===s.length){const k=D>=this.n.cols-1;n.commandExecutedMarker=this.n.registerMarker(c-(this.n.buffer.active.baseY+this.n.buffer.active.cursorY)+(k?1:0)),n.commandExecutedX=k?0:D+1,t=!0;break}}if(t)break}}z(){if(this.s.commandMarkers.length!==0){if(this.s.commandMarkers=this.s.commandMarkers.sort((n,s)=>n.line-s.line),this.r.currentCommand.commandStartMarker=this.s.commandMarkers[0],this.r.currentCommand.commandStartMarker){const n=this.n.buffer.active.getLine(this.r.currentCommand.commandStartMarker.line);n&&(this.r.currentCommand.commandStartLineContent=n.translateToString(!0))}this.r.currentCommand.commandExecutedMarker=this.s.commandMarkers[this.s.commandMarkers.length-1],this.s.onCommandExecutedEmitter.fire(this.r.currentCommand)}}C(){const n=this.r.commands.at(-1);if(!n)return!0;const s=this.n.buffer.active.baseY+this.n.buffer.active.cursorY,d=(n.endMarker?n.endMarker.line:n.marker?.line)??-1;return s>d}D(){const n=this.n.buffer.active.cursorX,s=this.n.buffer.active.cursorY;let d=0;return new Promise((v,i)=>{const t=setInterval(()=>{if(n!==this.n.buffer.active.cursorX||s!==this.n.buffer.active.cursorY){v(),clearInterval(t);return}d+=10,d>1e3&&(clearInterval(t),v())},10)})}F(n=this.n.buffer.active.baseY+this.n.buffer.active.cursorY){const s=this.n.buffer.active.getLine(n);if(!s)return;const d=s.translateToString(!0);if(!d)return;const v=d.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(v){const p=this.G(v,d,">");if(p)return{prompt:p,likelySingleLine:!0}}const i=d.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(i){const p=this.G(i,d,"\u276F");if(p)return p}const t=d.match(/^(?<prompt>\$)/)?.groups?.prompt;if(t){const p=this.G(t,d,"$");if(p)return p}const c=d.match(/^(?<prompt>>>> )/g)?.groups?.prompt;if(c)return{prompt:c,likelySingleLine:!0};const S=d.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return S?.groups?.prompt?{prompt:S.groups.prompt,likelySingleLine:!0}:void 0}G(n,s,d){if(n)return s===n&&n.endsWith(d)&&(n+=" "),n}};E=be([Ne(3,j.$3j)],E);function o(f,n,s,d){if(!d)return;const v=n.executedMarker,i=n.endMarker;if(!v||!i)return;const t=v.line,c=i.line,S=d.length,p=[];if(d.anchor==="bottom")for(let D=c-(d.offset||0);D>=t;D--){let k=D;const b=D;for(;k>=t&&f.getLine(k)?.isWrapped;)k--;D=k,p.unshift(a(f,k,b,s)),p.length>S&&p.pop()}else for(let D=t+(d.offset||0);D<c;D++){const k=D;let b=D;for(;b+1<c&&f.getLine(b+1)?.isWrapped;)b++;D=b,p.push(a(f,k,b,s)),p.length===S&&p.shift()}return p}function a(f,n,s,d){const v=Math.max(2048/d*2);s=Math.min(s,n+v);let i="";for(let t=n;t<=s;t++){const c=f.getLine(t);c&&(i+=c.translateToString(!0,0,d))}return i}function g(f,n,s=0){return f.registerMarker(n.line-(f.buffer.active.baseY+f.buffer.active.cursorY)+s)}}),define(fe[91],me([0,1,4,2]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rub=void 0;class C extends L.$Vc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new w.$ee),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(j){const P=this.a!==j;this.a=j;const h=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,h+1),P&&this.c.fire(j)}}e.$rub=C}),define(fe[92],me([0,1,4,2]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sub=void 0;var C;(function(j){j[j.MinimumPromptLength=2]="MinimumPromptLength"})(C||(C={}));class M extends L.$Uc{get commands(){return this.a}constructor(P){super(),this.c=P,this.type=3,this.a=[],this.b=this.add(new w.$ee),this.onCommandFinished=this.b.event,this.add(this.c.onData(h=>this.h(h))),this.add(this.c.parser.registerCsiHandler({final:"J"},h=>(h.length>=1&&(h[0]===2||h[0]===3)&&this.m(),!1)))}h(P){P==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const P=this.c.registerMarker(0);P&&(this.a.push(P),this.b.fire(P))}}m(){let P=0;for(let h=this.a.length-1;h>=0&&!(this.a[h].line<this.c.buffer.active.baseY);h--)P++;this.a.splice(this.a.length-P,P)}}e.$sub=M}),define(fe[93],me([0,1,4,2]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oub=e.$nub=void 0;class C extends L.$Vc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new w.$ee),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new w.$ee),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new w.$ee),this.onDidRemoveCapability=this.g.event,this.h=this.B(new w.$ee),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(P,h){this.a.set(P,h),this.f.fire(P),this.h.fire({id:P,capability:h})}get(P){return this.a.get(P)}remove(P){const h=this.a.get(P);h&&(this.a.delete(P),this.b.fire(P),this.h.fire({id:P,capability:h}))}has(P){return this.a.has(P)}}e.$nub=C;class M extends L.$Vc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new w.$ee),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new w.$ee),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new w.$ee),this.onDidRemoveCapability=this.f.event,this.g=this.B(new w.$ee),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const P of this._stores)for(const h of P.items)yield h}has(P){for(const h of this._stores)for(const r of h.items)if(r===P)return!0;return!1}get(P){for(const h of this._stores){const r=h.get(P);if(r)return r}}add(P){this._stores.push(P);for(const h of P.items)this.b.fire(h),this.g.fire({id:h,capability:P.get(h)});this.B(P.onDidAddCapabilityType(h=>this.b.fire(h))),this.B(P.onDidAddCapability(h=>this.g.fire(h))),this.B(P.onDidRemoveCapabilityType(h=>this.a.fire(h))),this.B(P.onDidRemoveCapability(h=>this.f.fire(h)))}}e.$oub=M}),define(fe[36],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var w;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(w||(e.EnvironmentVariableMutatorType=w={}))}),define(fe[94],me([0,1,3,36]),function(ae,e,w,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;const C=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class M{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((l,E)=>{this.d(l,E);const o=l.map.entries();let a=o.next();for(;!a.done;){const g=a.value[1],f=a.value[0];let n=this.a.get(f);if(n||(n=[],this.a.set(f,n)),n.length>0&&n[0].type===L.EnvironmentVariableMutatorType.Replace){a=o.next();continue}const s={extensionIdentifier:E,value:g.value,type:g.type,scope:g.scope,variable:g.variable,options:g.options};s.scope||delete s.scope,n.unshift(s),a=o.next()}})}async applyToProcessEnvironment(y,l,E){let o;w.$i&&(o={},Object.keys(y).forEach(a=>o[a.toLowerCase()]=a));for(const[a,g]of this.getVariableMap(l)){const f=w.$i&&o[a.toLowerCase()]||a;for(const n of g){const s=E?await E(n.value):n.value;if(n.options?.applyAtProcessCreation??!0)switch(n.type){case L.EnvironmentVariableMutatorType.Append:y[f]=(y[f]||"")+s;break;case L.EnvironmentVariableMutatorType.Prepend:y[f]=s+(y[f]||"");break;case L.EnvironmentVariableMutatorType.Replace:y[f]=s;break}if(n.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${C.get(n.type)}`;y[d]=(y[d]?y[d]+":":"")+a+"="+this.c(s)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,l){const E=new Map,o=new Map,a=new Map;if(y.getVariableMap(l).forEach((g,f)=>{const n=this.getVariableMap(l).get(f),s=P(g,n);s&&E.set(f,s)}),this.getVariableMap(l).forEach((g,f)=>{const n=y.getVariableMap(l).get(f),s=P(g,n);s&&a.set(f,s)}),this.getVariableMap(l).forEach((g,f)=>{const n=y.getVariableMap(l).get(f),s=h(g,n);s&&o.set(f,s)}),!(E.size===0&&o.size===0&&a.size===0))return{added:E,changed:o,removed:a}}getVariableMap(y){const l=new Map;for(const E of this.a.values()){const o=E.filter(a=>j(a,y));o.length>0&&l.set(o[0].variable,o)}return l}getDescriptionMap(y){const l=new Map;for(const E of this.b.values()){const o=E.filter(a=>j(a,y,!0));for(const a of o)l.set(a.extensionIdentifier,a.description)}return l}d(y,l){if(!y.descriptionMap)return;const E=y.descriptionMap.entries();let o=E.next();for(;!o.done;){const a=o.value[1],g=o.value[0];let f=this.b.get(g);f||(f=[],this.b.set(g,f));const n={extensionIdentifier:l,scope:a.scope,description:a.description};n.scope||delete n.scope,f.push(n),o=E.next()}}}e.$rs=M;function j(r,y,l=!1){return r.scope?!!(r.scope.workspaceFolder&&y?.workspaceFolder&&r.scope.workspaceFolder.index===y.workspaceFolder.index):l?y===r.scope:!0}function P(r,y){if(!y)return r;const l=new Set;y.forEach(o=>l.add(o.extensionIdentifier));const E=[];return r.forEach(o=>{l.has(o.extensionIdentifier)||E.push(o)}),E.length===0?void 0:E}function h(r,y){if(!y)return;const l=new Map;y.forEach(o=>l.set(o.extensionIdentifier,o));const E=[];return r.forEach(o=>{const a=l.get(o.extensionIdentifier);a&&(o.type!==a.type||o.value!==a.value||o.scope?.workspaceFolder?.index!==a.scope?.workspaceFolder?.index)&&E.push(a)}),E.length===0?void 0:E}}),define(fe[95],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=w,e.$ms=L,e.$ns=C,e.$os=M,e.$ps=j,e.$qs=P;function w(h){return[...h.entries()]}function L(h){return h?[...h.entries()]:[]}function C(h){return new Map(h)}function M(h){return new Map(h??[])}function j(h){return Array.from(h.entries()).map(r=>[r[0],w(r[1].map),L(r[1].descriptionMap)])}function P(h){return new Map(h.map(r=>[r[0],{map:C(r[1]),descriptionMap:M(r[2])}]))}}),define(fe[96],me([0,1,11,17,4,2,8]),function(ae,e,w,L,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;let P=class extends M.$Vc{constructor(r,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new C.$ee),this.onCreateRequest=this.g.event,this.b=r===void 0?15e3:r,this.B((0,M.$Tc)(()=>{for(const l of this.f.values())(0,M.$Qc)(l)}))}createRequest(r){return new Promise((y,l)=>{const E=++this.a;this.c.set(E,y),this.g.fire({requestId:E,...r});const o=new L.$pe;(0,w.$xh)(this.b,o.token).then(()=>l(`Request ${E} timed out (${this.b}ms)`)),this.f.set(E,[(0,M.$Tc)(()=>o.cancel())])})}acceptReply(r,y){const l=this.c.get(r);l?(this.c.delete(r),(0,M.$Qc)(this.f.get(r)||[]),this.f.delete(r),l(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${r}`)}};e.$cs=P,e.$cs=P=be([Ne(1,j.$3j)],P)}),define(fe[28],me([0,1,21,35,86]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$8r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$7r=void 0,e.$7r=new L.$Nj("terminalTabFocusMode",!1,!0);var M;(function(i){i.AutomationProfile="terminal.integrated.automationProfile.",i.DefaultProfile="terminal.integrated.defaultProfile.",i.Profiles="terminal.integrated.profiles."})(M||(e.TerminalSettingPrefix=M={}));var j;(function(i){i.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",i.AutomationProfileLinux="terminal.integrated.automationProfile.linux",i.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",i.AutomationProfileWindows="terminal.integrated.automationProfile.windows",i.ProfilesWindows="terminal.integrated.profiles.windows",i.ProfilesMacOs="terminal.integrated.profiles.osx",i.ProfilesLinux="terminal.integrated.profiles.linux",i.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",i.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",i.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",i.UseWslProfiles="terminal.integrated.useWslProfiles",i.TabsDefaultColor="terminal.integrated.tabs.defaultColor",i.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",i.TabsEnabled="terminal.integrated.tabs.enabled",i.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",i.TabsHideCondition="terminal.integrated.tabs.hideCondition",i.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",i.TabsShowActions="terminal.integrated.tabs.showActions",i.TabsLocation="terminal.integrated.tabs.location",i.TabsFocusMode="terminal.integrated.tabs.focusMode",i.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",i.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",i.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",i.CopyOnSelection="terminal.integrated.copyOnSelection",i.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",i.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",i.FontFamily="terminal.integrated.fontFamily",i.FontSize="terminal.integrated.fontSize",i.LetterSpacing="terminal.integrated.letterSpacing",i.LineHeight="terminal.integrated.lineHeight",i.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",i.TabStopWidth="terminal.integrated.tabStopWidth",i.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",i.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",i.BellDuration="terminal.integrated.bellDuration",i.FontWeight="terminal.integrated.fontWeight",i.FontWeightBold="terminal.integrated.fontWeightBold",i.CursorBlinking="terminal.integrated.cursorBlinking",i.CursorStyle="terminal.integrated.cursorStyle",i.CursorStyleInactive="terminal.integrated.cursorStyleInactive",i.CursorWidth="terminal.integrated.cursorWidth",i.Scrollback="terminal.integrated.scrollback",i.DetectLocale="terminal.integrated.detectLocale",i.DefaultLocation="terminal.integrated.defaultLocation",i.GpuAcceleration="terminal.integrated.gpuAcceleration",i.TerminalTitleSeparator="terminal.integrated.tabs.separator",i.TerminalTitle="terminal.integrated.tabs.title",i.TerminalDescription="terminal.integrated.tabs.description",i.RightClickBehavior="terminal.integrated.rightClickBehavior",i.MiddleClickBehavior="terminal.integrated.middleClickBehavior",i.Cwd="terminal.integrated.cwd",i.ConfirmOnExit="terminal.integrated.confirmOnExit",i.ConfirmOnKill="terminal.integrated.confirmOnKill",i.EnableBell="terminal.integrated.enableBell",i.EnableVisualBell="terminal.integrated.enableVisualBell",i.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",i.AllowChords="terminal.integrated.allowChords",i.AllowMnemonics="terminal.integrated.allowMnemonics",i.TabFocusMode="terminal.integrated.tabFocusMode",i.EnvMacOs="terminal.integrated.env.osx",i.EnvLinux="terminal.integrated.env.linux",i.EnvWindows="terminal.integrated.env.windows",i.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",i.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",i.ShowExitAlert="terminal.integrated.showExitAlert",i.SplitCwd="terminal.integrated.splitCwd",i.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",i.WordSeparators="terminal.integrated.wordSeparators",i.EnableFileLinks="terminal.integrated.enableFileLinks",i.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",i.UnicodeVersion="terminal.integrated.unicodeVersion",i.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",i.LocalEchoEnabled="terminal.integrated.localEchoEnabled",i.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",i.LocalEchoStyle="terminal.integrated.localEchoStyle",i.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",i.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",i.HideOnStartup="terminal.integrated.hideOnStartup",i.CustomGlyphs="terminal.integrated.customGlyphs",i.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",i.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",i.InheritEnv="terminal.integrated.inheritEnv",i.ShowLinkHover="terminal.integrated.showLinkHover",i.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",i.AutoReplies="terminal.integrated.autoReplies",i.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",i.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",i.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",i.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",i.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",i.EnableImages="terminal.integrated.enableImages",i.SmoothScrolling="terminal.integrated.smoothScrolling",i.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",i.FocusAfterRun="terminal.integrated.focusAfterRun",i.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",i.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",i.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",i.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",i.MouseWheelZoom="terminal.integrated.mouseWheelZoom",i.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",i.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",i.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var P;(function(i){i.PowerShell="pwsh",i.Bash="bash",i.Fish="fish",i.Sh="sh",i.Csh="csh",i.Ksh="ksh",i.Zsh="zsh",i.Python="python"})(P||(e.PosixShellType=P={}));var h;(function(i){i.CommandPrompt="cmd",i.PowerShell="pwsh",i.Wsl="wsl",i.GitBash="gitbash",i.Python="python"})(h||(e.WindowsShellType=h={}));var r;(function(i){i[i.Api=0]="Api",i[i.Process=1]="Process",i[i.Sequence=2]="Sequence",i[i.Config=3]="Config"})(r||(e.TitleEventSource=r={}));var y;(function(i){i.LocalPty="localPty",i.PtyHost="ptyHost",i.PtyHostWindow="ptyHostWindow",i.Logger="logger",i.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var l;(function(i){i.Cwd="cwd",i.InitialCwd="initialCwd",i.FixedDimensions="fixedDimensions",i.Title="title",i.ShellType="shellType",i.HasChildProcesses="hasChildProcesses",i.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",i.OverrideDimensions="overrideDimensions",i.FailedShellIntegrationActivation="failedShellIntegrationActivation",i.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(l||(e.ProcessPropertyType=l={})),e.$8r=(0,w.$wi)("ptyService");var E;(function(i){i[i.BeatInterval=5e3]="BeatInterval",i[i.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",i[i.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",i[i.SecondWaitMultiplier=1]="SecondWaitMultiplier",i[i.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(E||(e.HeartbeatConstants=E={}));var o;(function(i){i[i.Panel=1]="Panel",i[i.Editor=2]="Editor"})(o||(e.TerminalLocation=o={}));var a;(function(i){i.TerminalView="view",i.Editor="editor"})(a||(e.TerminalLocationString=a={}));var g;(function(i){i[i.GraceTime=6e4]="GraceTime",i[i.ShortGraceTime=6e3]="ShortGraceTime"})(g||(e.LocalReconnectConstants=g={}));var f;(function(i){i[i.HighWatermarkChars=1e5]="HighWatermarkChars",i[i.LowWatermarkChars=5e3]="LowWatermarkChars",i[i.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var n;(function(i){i.GitBash="Git Bash",i.Pwsh="PowerShell"})(n||(e.ProfileSource=n={}));var s;(function(i){i[i.Off=0]="Off",i[i.FinalTerm=1]="FinalTerm",i[i.VSCode=2]="VSCode"})(s||(e.ShellIntegrationStatus=s={}));var d;(function(i){i[i.Unknown=0]="Unknown",i[i.Shutdown=1]="Shutdown",i[i.Process=2]="Process",i[i.User=3]="User",i[i.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$9r={Backend:"workbench.contributions.terminal.processBackend"};class v{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const c=this.b(t.remoteAuthority);if(this.a.has(c))throw new Error(`A terminal backend with remote authority '${c}' was already registered.`);this.a.set(c,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}C.$co.add(e.$9r.Backend,new v),e.$0r=(0,w.$wi)("localPtyService"),e.$$r=(0,w.$wi)("terminalLogService")}),define(fe[97],me([0,1,11,2,3]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=void 0;class M extends L.$Vc{constructor(P,h,r,y){super(),this.a=0,this.b=!1,this.c=!1,this.B(P.onProcessData(l=>{if(this.b||this.c)return;const E=typeof l=="string"?l:l.data;for(let o=0;o<E.length;o++)E[o]===h[this.a]?this.a++:this.f(),this.a===h.length&&(y.debug(`Auto reply match: "${h}", response: "${r}"`),P.input(r),this.c=!0,(0,w.$xh)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){C.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$zic=M}),define(fe[98],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jvb=void 0;class w{constructor(C){this.b=C,this.a=new Map}dispose(){for(const C of this.a.values())C.dispose()}startBuffering(C,M,j=5){const P=M(h=>{const r=typeof h=="string"?h:h.data;let y=this.a.get(C);if(y){y.data.push(r);return}const l=setTimeout(()=>this.flushBuffer(C),j);y={data:[r],timeoutId:l,dispose:()=>{clearTimeout(l),this.flushBuffer(C),P.dispose()}},this.a.set(C,y)});return P}stopBuffering(C){this.a.get(C)?.dispose()}flushBuffer(C){const M=this.a.get(C);M&&(this.a.delete(C),this.b(C,M.data.join("")))}}e.$Jvb=w}),define(fe[37],me([0,1,3]),function(ae,e,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=L,e.$lQ=C,e.$mQ=M,e.$nQ=j;function L(P){let h=P;h.includes("\\")&&(h=h.replace(/\\/g,"\\\\"));const r=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return h=h.replace(r,""),`'${h}'`}function C(P,h,r){if(!P)return"";if(!h)return P;h.match(/[\/\\]$/)&&(h=h.slice(0,h.length-1));const y=P.replace(/\\/g,"/").toLowerCase(),l=h.replace(/\\/g,"/").toLowerCase();return y.includes(l)?`~${r}${P.slice(h.length+1)}`:P}function M(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),w.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function j(P){return!P.strictEnv}}),define(fe[99],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6r=L;var w;(function(C){C[C.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(w||(w={}));function L(C){const M=[];let j=0;for(let P=0;P<C.length-1;P++)(P-j+1>=50||C[P+1]==="\x1B")&&(M.push(C.substring(j,P+1)),j=P+1,P++);return j!==C.length&&M.push(C.substring(j)),M}}),define(fe[100],me([0,1]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NUb=w;function w(L,C={}){let M="";return C.excludeLeadingNewLine||(M+=`\r
`),M+="\x1B[0m\x1B[7m * ",C.loudFormatting?M+="\x1B[0;104m":M+="\x1B[0m",M+=` ${L} \x1B[0m
\r`,M}}),define(fe[101],me([0,1,2,93,90,91,92,4,87,6,37]),function(ae,e,w,L,C,M,j,P,h,r,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uub=e.ShellIntegrationOscPs=void 0,e.$vub=g,e.$wub=f,e.$xub=n;var l;(function(s){s[s.FinalTerm=133]="FinalTerm",s[s.VSCode=633]="VSCode",s[s.ITerm=1337]="ITerm",s[s.SetCwd=7]="SetCwd",s[s.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(l||(e.ShellIntegrationOscPs=l={}));var E;(function(s){s.PromptStart="A",s.CommandStart="B",s.CommandExecuted="C",s.CommandFinished="D",s.CommandLine="E",s.ContinuationStart="F",s.ContinuationEnd="G",s.RightPromptStart="H",s.RightPromptEnd="I",s.Property="P",s.SetMark="SetMark"})(E||(E={}));var o;(function(s){s.SetMark="SetMark",s.CurrentDir="CurrentDir"})(o||(o={}));class a extends w.$Vc{get status(){return this.g}constructor(d,v,i,t){super(),this.j=d,this.m=v,this.n=i,this.r=t,this.capabilities=this.B(new L.$nub),this.b=!1,this.f=[],this.g=0,this.h=new P.$ee,this.onDidChangeStatus=this.h.event,this.B((0,w.$Tc)(()=>{this.z(),this.s()}))}s(){(0,w.$Qc)(this.f),this.f.length=0}activate(d){this.a=d,this.capabilities.add(3,this.B(new j.$sub(this.a))),this.B(d.parser.registerOscHandler(633,v=>this.w(v))),this.B(d.parser.registerOscHandler(1337,v=>this.G(v))),this.f.push(d.parser.registerOscHandler(133,v=>this.t(v))),this.B(d.parser.registerOscHandler(7,v=>this.I(v))),this.B(d.parser.registerOscHandler(9,v=>this.H(v))),this.y()}getMarkerId(d,v){this.M(d).getMark(v)}t(d){const v=this.u(d);return this.g===0&&(this.g=1,this.h.fire(this.g)),v}u(d){if(!this.a)return!1;const[v,...i]=d.split(";");switch(v){case"A":return this.L(this.a).handlePromptStart(),!0;case"B":return this.L(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.L(this.a).handleCommandExecuted(),!0;case"D":{const t=i.length===1?parseInt(i[0]):void 0;return this.L(this.a).handleCommandFinished(t),!0}}return!1}w(d){const v=this.C(d);return!this.b&&v&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),v}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(d){if(!this.a)return!1;const v=d.indexOf(";"),i=v===-1?d:d.substring(0,v),t=v===-1?[]:d.substring(v+1).split(";");switch(i){case"A":return this.L(this.a).handlePromptStart(),!0;case"B":return this.L(this.a).handleCommandStart(),!0;case"C":return this.L(this.a).handleCommandExecuted(),!0;case"D":{const c=t[0],S=c!==void 0?parseInt(c):void 0;return this.L(this.a).handleCommandFinished(S),!0}case"E":{const c=t[0],S=t[1];let p;return c!==void 0?p=g(c):p="",this.L(this.a).setCommandLine(p,S===this.j),!0}case"F":return this.L(this.a).handleContinuationStart(),!0;case"G":return this.L(this.a).handleContinuationEnd(),!0;case"H":return this.L(this.a).handleRightPromptStart(),!0;case"I":return this.L(this.a).handleRightPromptEnd(),!0;case"P":{const c=t[0],S=c!==void 0?g(c):"",{key:p,value:D}=f(S);if(D===void 0)return!0;switch(p){case"ContinuationPrompt":{const k=D.replace(/\x1b\[[0-9;]*m/g,"").replace(/\\\[.*?\\\]/g,"");return this.D(k),!0}case"Cwd":return this.F(D),!0;case"IsWindows":return this.L(this.a).setIsWindowsPty(D==="True"),!0;case"Task":return this.M(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.M(this.a).addMark(n(t)),!0}return!1}D(d){this.a&&this.L(this.a).setContinuationPrompt(d)}F(d){d=(0,y.$mQ)(d),this.J().updateCwd(d),this.capabilities.get(2)?.setCwd(d)}G(d){if(!this.a)return!1;const[v]=d.split(";");switch(v){case"SetMark":this.M(this.a).addMark();default:{const{key:i,value:t}=f(v);if(t===void 0)return!0;switch(i){case"CurrentDir":return this.F(t),!0}}}return!1}H(d){if(!this.a)return!1;const[v,...i]=d.split(";");switch(v){case"9":return i.length&&this.F(i[0]),!0}return!1}I(d){if(!this.a)return!1;const[v]=d.split(";");if(v.match(/^file:\/\/.*\//)){const i=r.URI.parse(v);if(i.path&&i.path.length>0)return this.F(i.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.L(this.a).serialize()}deserialize(d){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.L(this.a).deserialize(d)}J(){let d=this.capabilities.get(0);return d||(d=this.B(new M.$rub),this.capabilities.add(0,d)),d}L(d){let v=this.capabilities.get(2);return v||(v=this.B(new C.$pub(d,this.r)),this.capabilities.add(2,v)),v}M(d){let v=this.capabilities.get(4);return v||(v=this.B(new h.$tub(d)),this.capabilities.add(4,v)),v}}e.$uub=a;function g(s){return s.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(d,v,i)=>i?String.fromCharCode(parseInt(i,16)):v)}function f(s){const d=s.indexOf("=");return d===-1?{key:s,value:void 0}:{key:s.substring(0,d),value:s.substring(1+d)}}function n(s){let d,v=!1;for(const i of s)i!==void 0&&(i==="Hidden"&&(v=!0),i.startsWith("Id=")&&(d=i.substring(3)));return{id:d,hidden:v}}}),define(fe[38],me([0,1,5,14,4,2,62,8]),function(ae,e,w,L,C,M,j,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=void 0;var h;(function(y){y[y.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",y[y.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(h||(h={})),e.$Aic=[];let r=class extends M.$Vc{set hasChildProcesses(l){this.a!==l&&(this.a=l,this.f.debug("ChildProcessMonitor: Has child processes changed",l),this.b.fire(l))}get hasChildProcesses(){return this.a}constructor(l,E){super(),this.c=l,this.f=E,this.a=!1,this.b=this.B(new C.$ee),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const l=await(0,j.$Ds)(this.c);this.hasChildProcesses=this.j(l)}catch(l){this.f.debug("ChildProcessMonitor: Fetching process tree failed",l)}}h(){this.g()}j(l){if(!l.children)return!1;if(l.children.length===1){const E=l.children[0];let o;if(E.cmd.startsWith('"'))o=E.cmd.substring(1,E.cmd.indexOf('"',1));else{const a=E.cmd.indexOf(" ");a===-1?o=E.cmd:o=E.cmd.substring(0,a)}return e.$Aic.indexOf((0,w.$rc)(o).name)===-1}return l.children.length>0}};e.$Bic=r,be([(0,L.$2h)(1e3)],r.prototype,"g",null),be([(0,L.$3h)(5e3)],r.prototype,"h",null),e.$Bic=r=be([Ne(1,P.$3j)],r)}),define(fe[102],me([0,1,4,2,28]),function(ae,e,w,L,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;class M extends L.$Vc{constructor(){super(),this.a=this.B(new w.$ee),this.onBeat=this.a.event;const P=setInterval(()=>{this.a.fire()},C.HeartbeatConstants.BeatInterval);this.B((0,L.$Tc)(()=>clearInterval(P)))}}e.$Cic=M}),define(fe[39],me([0,1,20,19,30,5,3,15,12,9,24,36,95,94]),function(ae,e,w,L,C,M,j,P,h,r,y,l,E,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=a,e.$ts=g,e.$us=f;function a(){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(w.release());let b=0;return k&&k.length===4&&(b=parseInt(k[3])),b}async function g(k,b,z,Z=P.env,T=y.Promises.exists){if(M.$jc(k))return await T(k)?k:void 0;if(b===void 0&&(b=P.cwd()),M.$nc(k)!=="."){const $=M.$kc(b,k);return await T($)?$:void 0}const m=(0,C.$0n)(Z,"PATH");if(z===void 0&&(0,r.$9f)(m)&&(z=m.split(M.$uc)),z===void 0||z.length===0){const $=M.$kc(b,k);return await T($)?$:void 0}for(const $ of z){let A;if(M.$jc($)?A=M.$kc($,k):A=M.$kc(b,$,k),await T(A))return A;if(j.$i){let Y=A+".com";if(await T(Y)||(Y=A+".exe",await T(Y)))return Y}}const O=M.$kc(b,k);return await T(O)?O:void 0}function f(k,b,z,Z,T){const R=j.$i&&(!b.windowsEnableConpty||a()<18309);if(!b.shellIntegration.enabled||!k.executable||k.isFeatureTerminal&&!k.forceShellIntegration||k.ignoreShellIntegration||R)return;const m=k.args,O=P.$ec==="win32"?M.$oc(k.executable).toLowerCase():M.$oc(k.executable),$=M.$nc(L.$Qg.asFileUri("").fsPath);let A;const Y={VSCODE_INJECTION:"1"};if(b.shellIntegration.nonce&&(Y.VSCODE_NONCE=b.shellIntegration.nonce),j.$i){if(O==="pwsh.exe"||O==="powershell.exe")return!m||p(m)?A=d.get(s.WindowsPwsh):S(m)&&(A=d.get(s.WindowsPwshLogin)),A?(A=[...A],A[A.length-1]=(0,h.$9e)(A[A.length-1],$,""),b.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),{newArgs:A,envMixin:Y}):void 0;if(O==="bash.exe")return!m||m.length===0?A=d.get(s.Bash):D(m)&&(Y.VSCODE_SHELL_LOGIN="1",n(b,Y),A=d.get(s.Bash)),A?(A=[...A],A[A.length-1]=(0,h.$9e)(A[A.length-1],$),{newArgs:A,envMixin:Y}):void 0;Z.warn(`Shell integration cannot be enabled for executable "${k.executable}" and args`,k.args);return}switch(O){case"bash":return!m||m.length===0?A=d.get(s.Bash):D(m)&&(Y.VSCODE_SHELL_LOGIN="1",n(b,Y),A=d.get(s.Bash)),A?(A=[...A],A[A.length-1]=(0,h.$9e)(A[A.length-1],$),{newArgs:A,envMixin:Y}):void 0;case"fish":{const te=z?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",G=M.$kc($,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return Y.XDG_DATA_DIRS=`${te}:${G}`,n(b,Y),{newArgs:void 0,envMixin:Y}}case"pwsh":return!m||p(m)?A=d.get(s.Pwsh):S(m)&&(A=d.get(s.PwshLogin)),A?(b.shellIntegration.suggestEnabled&&(Y.VSCODE_SUGGEST="1"),A=[...A],A[A.length-1]=(0,h.$9e)(A[A.length-1],$,""),{newArgs:A,envMixin:Y}):void 0;case"zsh":{if(!m||m.length===0?A=d.get(s.Zsh):D(m)?(A=d.get(s.ZshLogin),n(b,Y)):(m===d.get(s.Zsh)||m===d.get(s.ZshLogin))&&(A=m),!A)return;A=[...A],A[A.length-1]=(0,h.$9e)(A[A.length-1],$);let te;try{te=w.userInfo().username}catch{te="unknown"}const G=M.$kc(w.tmpdir(),`${te}-${T.applicationName}-zsh`);Y.ZDOTDIR=G;const ee=z?.ZDOTDIR??w.homedir()??"~";Y.USER_ZDOTDIR=ee;const ce=[];return ce.push({source:M.$kc($,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:M.$kc(G,".zshrc")}),ce.push({source:M.$kc($,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:M.$kc(G,".zprofile")}),ce.push({source:M.$kc($,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:M.$kc(G,".zshenv")}),ce.push({source:M.$kc($,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:M.$kc(G,".zlogin")}),{newArgs:A,envMixin:Y,filesToCopy:ce}}}Z.warn(`Shell integration cannot be enabled for executable "${k.executable}" and args`,k.args)}function n(k,b){if(j.$j&&k.environmentVariableCollections){const z=(0,E.$qs)(k.environmentVariableCollections),T=new o.$rs(z).getVariableMap({workspaceFolder:k.workspaceFolder}).get("PATH"),R=[];if(T)for(const m of T)m.type===l.EnvironmentVariableMutatorType.Prepend&&R.push(m.value);R.length>0&&(b.VSCODE_PATH_PREFIX=R.join(""))}}var s;(function(k){k.WindowsPwsh="windows-pwsh",k.WindowsPwshLogin="windows-pwsh-login",k.Pwsh="pwsh",k.PwshLogin="pwsh-login",k.Zsh="zsh",k.ZshLogin="zsh-login",k.Bash="bash"})(s||(s={}));const d=new Map;d.set(s.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(s.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(s.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(s.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(s.Zsh,["-i"]),d.set(s.ZshLogin,["-il"]),d.set(s.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const v=["-login","-l"],i=["--login","-l"],t=["-i","--interactive"],c=["-nol","-nologo"];function S(k){return typeof k=="string"?v.includes(k.toLowerCase()):k.length===1&&v.includes(k[0].toLowerCase())||k.length===2&&(v.includes(k[0].toLowerCase())||v.includes(k[1].toLowerCase()))&&(c.includes(k[0].toLowerCase())||c.includes(k[1].toLowerCase()))}function p(k){return typeof k=="string"?c.includes(k.toLowerCase()):k.length===0||k?.length===1&&c.includes(k[0].toLowerCase())}function D(k){return typeof k!="string"&&(k=k.filter(b=>!t.includes(b.toLowerCase()))),k==="string"&&i.includes(k.toLowerCase())||typeof k!="string"&&k.length===1&&i.includes(k[0].toLowerCase())}}),define(fe[103],me([0,1,11,14,4,2,3]),function(ae,e,w,L,C,M,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dic=void 0;const P=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let h;class r extends M.$Vc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(l){if(super(),this.h=l,this.c="",this.f=new C.$ee,this.g=new C.$ee,!j.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${j.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){j.$i&&(await(0,w.$xh)(300),this.getShellName().then(l=>{const E=this.getShellType(l);E!==this.b&&(this.g.fire(E),this.f.fire(l),this.b=E,this.c=l)}))}m(l){if(!l)return"";if(P.indexOf(l.name)===-1||!l.children||l.children.length===0)return l.name;let E=0;for(;E<l.children.length;E++){const o=l.children[E];if(!o.children||o.children.length===0||o.children[0].name!=="conhost.exe")break}return E>=l.children.length?l.name:this.m(l.children[E])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(h||(h=await new Promise((l,E)=>{ae(["@vscode/windows-process-tree"],l,E)})),this.a=new Promise(l=>{h.getProcessTree(this.h,E=>{const o=this.m(E);this.a=void 0,l(o)})}),this.a)}getShellType(l){switch(l.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return l.match(/python(\d(\.\d{0,2})?)?\.exe/)?"python":void 0}}}e.$Dic=r,be([(0,L.$2h)(500)],r.prototype,"checkShell",null)}),define(fe[104],me([0,1,26,11,4,2,5,3,6,24,72,8,85,38,39,103,109,99]),function(ae,e,w,L,C,M,j,P,h,r,y,l,E,o,a,g,f,n){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=void 0;var d;(function(S){S[S.DataFlushTimeout=250]="DataFlushTimeout",S[S.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(d||(d={}));var v;(function(S){S[S.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",S[S.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",S[S.WriteInterval=5]="WriteInterval"})(v||(v={}));const i=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["python","python"],["zsh","zsh"]]);let t=class extends M.$Vc{static{s=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return P.$i?this.t?.shellType:i.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(p,D,k,b,z,Z,T,R,m){super(),this.shellLaunchConfig=p,this.N=Z,this.O=T,this.P=R,this.Q=m,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new C.$ee),this.onProcessData=this.I.event,this.J=this.B(new C.$ee),this.onProcessReady=this.J.event,this.L=this.B(new C.$ee),this.onDidChangeProperty=this.L.event,this.M=this.B(new C.$ee),this.onProcessExit=this.M.event;let O;P.$i?O=j.$oc(this.shellLaunchConfig.executable||""):O="xterm-256color",this.D=D,this.a.initialCwd=this.D,this.a.cwd=this.D;const $=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,a.$ss)()>=18309;this.F={name:O,cwd:D,env:z,cols:k,rows:b,useConpty:$,conptyInheritCursor:$&&!!p.initialText},P.$i&&($&&k===0&&b===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new c,this.B(this.C.onTrigger(A=>{this.C?.dispose(),this.C=void 0,A.cols&&A.rows&&this.resize(A.cols,A.rows)}))),this.onProcessReady(A=>{this.t=this.B(new g.$Dic(A.pid)),this.B(this.t.onShellTypeChanged(Y=>this.L.fire({type:"shellType",value:Y}))),this.B(this.t.onShellNameChanged(Y=>this.L.fire({type:"title",value:Y})))})),this.B((0,M.$Tc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const D=(await Promise.all([this.R(),this.S()])).find(b=>b!==void 0);if(D)return D;let k;if(this.O.shellIntegration.enabled)if(k=(0,a.$us)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),k){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),k.envMixin)for(const[b,z]of Object.entries(k.envMixin))this.F.env||={},this.F.env[b]=z;if(k.filesToCopy)for(const b of k.filesToCopy){await r.Promises.mkdir(j.$nc(b.dest),{recursive:!0});try{await r.Promises.copyFile(b.source,b.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,k),k?.newArgs?{injectedArgs:k.newArgs}:void 0}catch(b){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",b),{message:`A native exception occurred during launch (${b.message})`}}}async R(){try{if(!(await r.Promises.stat(this.D)).isDirectory())return{message:(0,y.localize)(0,null,this.D.toString())}}catch(p){if(p?.code==="ENOENT")return{message:(0,y.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const p=this.shellLaunchConfig;if(!p.executable)throw new Error("IShellLaunchConfig.executable not set");const D=p.cwd instanceof h.URI?p.cwd.path:p.cwd,k=p.env&&p.env.PATH?p.env.PATH.split(j.$uc):void 0,b=await(0,a.$ts)(p.executable,D,k,this.N);if(!b)return{message:(0,y.localize)(2,null,p.executable)};try{const z=await r.Promises.stat(b);if(!z.isFile()&&!z.isSymbolicLink())return{message:(0,y.localize)(3,null,p.executable)};p.executable=b}catch(z){if(z?.code!=="EACCES")throw z}}async U(p,D,k){const b=k?.newArgs||p.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",p.executable,b,D);const z=(0,f.spawn)(p.executable,b,D);this.m=z,this.u=this.B(new o.$Bic(z.pid,this.P)),this.u.onDidChangeHasChildProcesses(Z=>this.L.fire({type:"hasChildProcesses",value:Z})),this.s=new Promise(Z=>{this.onProcessReady(()=>Z())}),z.onData(Z=>{this.H+=Z.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,z.pause()),this.P.trace("node-pty.IPty#onData",Z),this.I.fire(Z),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),z.onExit(Z=>{this.g=Z.exitCode,this.X()}),this.$(z.pid),this.W(z)}W(p){setTimeout(()=>this.ab(p)),P.$i||(this.w=setInterval(()=>{this.n!==p.process&&this.ab(p)},200))}X(){this.P.getLevel()===l.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!P.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-s.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,L.$xh)(250-(Date.now()-s.b)+50);s.b=Date.now()}}$(p){this.J.fire({pid:p,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(p){if(this.q.isDisposed)return;this.n=p.process,this.L.fire({type:"title",value:this.n});const D=this.currentTitle.replace(/ \(figterm\)$/g,"");D.toLowerCase().startsWith("python")?this.L.fire({type:"shellType",value:"python"}):this.L.fire({type:"shellType",value:i.get(D)})}shutdown(p){this.P.getLevel()===l.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),p&&!P.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input(p,D=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,n.$6r)(p).map(k=>({isBinary:D,data:k}))),this.bb())}async processBinary(p){this.input(p,!0)}async refreshProperty(p){switch(p){case"cwd":{const D=await this.getCwd();return D!==this.a.cwd&&(this.a.cwd=D,this.L.fire({type:"cwd",value:this.a.cwd})),D}case"initialCwd":{const D=await this.getInitialCwd();return D!==this.a.initialCwd&&(this.a.initialCwd=D,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),D}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(p,D){p==="fixedDimensions"&&(this.a.fixedDimensions=D)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const p=this.y.shift();this.P.trace("node-pty.IPty#write",p.data),p.isBinary?this.m.write(Buffer.from(p.data,"binary")):this.m.write(p.data),this.u?.handleInput()}resize(p,D){if(!this.q.isDisposed&&!(typeof p!="number"||typeof D!="number"||isNaN(p)||isNaN(D))&&this.m){if(p=Math.max(p,1),D=Math.max(D,1),this.C){this.C.cols=p,this.C.rows=D;return}this.P.trace("node-pty.IPty#resize",p,D);try{this.m.resize(p,D)}catch(k){if(this.P.trace("node-pty.IPty#resize exception "+k.message),this.g!==void 0&&k.message!=="ioctl(2) failed, EBADF"&&k.message!=="Cannot resize a pty that has already exited")throw k}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(p){this.H=Math.max(this.H-p,0),this.P.trace(`Flow control: Ack ${p} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(P.$j)return new Promise(p=>{if(!this.m){p(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,w.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(D,k,b)=>{!D&&k!==""?p(k.substring(k.indexOf("/"),k.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",D,k,b),p(this.D))})});if(P.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await r.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return P.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,a.$ss)()}:void 0}};e.$Eic=t,e.$Eic=t=s=be([Ne(7,l.$3j),Ne(8,E.$jk)],t);class c extends M.$Vc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new C.$ee),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,M.$Tc)(()=>clearTimeout(this.a)))}}}),define(fe[105],me([0,1,26,11,4,2,3,63,8,96,28,98,37,110,39,104,71,38,97,7,101,100,77,14,111]),function(ae,e,w,L,C,M,j,P,h,r,y,l,E,o,a,g,f,n,s,d,v,i,t,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0,e.$Fic=p;function p(O,$,A){if(typeof A.value!="function")throw new Error("not supported");const Y="value",te=A.value;A[Y]=async function(...G){this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${te.name}(${G.map(ce=>JSON.stringify(ce)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,L.$xh)(this.traceRpcArgs.simulatedLatency);let ee;try{ee=await te.apply(this,G)}catch(ce){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${te.name}`,ce),ce}return this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${te.name}`,ee),ee}}let D,k;class b extends M.$Vc{H($,A){return A(Y=>{this.I.getLevel()===h.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${$}.fire(${JSON.stringify(Y)})`)}),A}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor($,A,Y,te){super(),this.I=$,this.J=A,this.L=Y,this.M=te,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new C.$ee),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new C.$ee),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new C.$ee),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new C.$ee),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new C.$ee),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new C.$ee),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new C.$ee),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new C.$ee),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,M.$Tc)(()=>{for(const G of this.a.values())G.shutdown(!0);this.a.clear()})),this.f=this.B(new r.$cs(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames($){n.$Aic.length=0,n.$Aic.push(...$)}async requestDetachInstance($,A){return this.f.createRequest({workspaceId:$,instanceId:A})}async acceptDetachInstanceReply($,A){let Y;const te=this.a.get(A);te&&(Y=await this.S(A,te)),this.f.acceptReply($,Y)}async freePortKillProcess($){const Y=(await new Promise((te,G)=>{(0,w.exec)(j.$i?`netstat -ano | findstr "${$}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${$}`,{},(ee,ce)=>{if(ee)return G("Problem occurred when listing active processes");te(ce)})})).split(/\r?\n/).filter(te=>!!te.trim());if(Y.length>=1){const te=/\s+(\d+)(?:\s+|$)/,G=Y[0].match(te)?.[1];if(G)try{process.kill(Number.parseInt(G))}catch{}else throw new Error(`Processes for port ${$} were not found`);return{port:$,processId:G}}throw new Error(`Could not kill process with port ${$}`)}async serializeTerminalState($){const A=[];for(const[te,G]of this.a.entries())G.hasWrittenData&&$.indexOf(te)!==-1&&A.push(L.Promises.withAsyncBody(async ee=>{ee({id:te,shellLaunchConfig:G.shellLaunchConfig,processDetails:await this.S(te,G),processLaunchConfig:G.processLaunchOptions,unicodeVersion:G.unicodeVersion,replayEvent:await G.serializeNormalBuffer(),timestamp:Date.now()})}));const Y={version:1,state:await Promise.all(A)};return JSON.stringify(Y)}async reviveTerminalProcesses($,A,Y){const te=[];for(const G of A)te.push(this.N($,G));await Promise.all(te)}async N($,A){const Y=(0,f.localize)(0,null),te=await this.createProcess({...A.shellLaunchConfig,cwd:A.processDetails.cwd,color:A.processDetails.color,icon:A.processDetails.icon,name:A.processDetails.titleSource===y.TitleEventSource.Api?A.processDetails.title:void 0,initialText:A.replayEvent.events[0].data+(0,i.$NUb)(Y,{loudFormatting:!0})},A.processDetails.cwd,A.replayEvent.events[0].cols,A.replayEvent.events[0].rows,A.unicodeVersion,A.processLaunchConfig.env,A.processLaunchConfig.executableEnv,A.processLaunchConfig.options,!0,A.processDetails.workspaceId,A.processDetails.workspaceName,!0,A.replayEvent.events[0].data),G=this.R($,A.id);this.g.set(G,{newId:te,state:A}),this.I.info(`Revived process, old id ${G} -> new id ${te}`)}async shutdownAll(){this.dispose()}async createProcess($,A,Y,te,G,ee,ce,ue,X,q,Q,K,de){if($.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const B=++this.n,le=new g.$Eic($,A,Y,te,ee,ce,ue,this.I,this.J),_={env:ee,executableEnv:ce,options:ue},u=new Z(B,le,q,Q,X,Y,te,_,G,this.L,this.I,K&&typeof $.initialText=="string"?$.initialText:void 0,de,$.icon,$.color,$.name,$.fixedDimensions);return le.onProcessExit(N=>{u.dispose(),this.a.delete(B),this.C.fire({id:B,event:N})}),u.onProcessData(N=>this.w.fire({id:B,event:N})),u.onProcessReplay(N=>this.y.fire({id:B,event:N})),u.onProcessReady(N=>this.z.fire({id:B,event:N})),u.onProcessOrphanQuestion(()=>this.D.fire({id:B})),u.onDidChangeProperty(N=>this.G.fire({id:B,property:N})),u.onPersistentProcessReady(()=>{for(const N of this.j.entries())u.installAutoReply(N[0],N[1])}),this.a.set(B,u),B}async attachToProcess($){try{await this.U($).attach(),this.I.info(`Persistent process reconnection "${$}"`)}catch(A){throw this.I.warn(`Persistent process reconnection "${$}" failed`,A.message),A}}async updateTitle($,A,Y){this.U($).setTitle(A,Y)}async updateIcon($,A,Y,te){this.U($).setIcon(A,Y,te)}async clearBuffer($){this.U($).clearBuffer()}async refreshProperty($,A){return this.U($).refreshProperty(A)}async updateProperty($,A,Y){return this.U($).updateProperty(A,Y)}async detachFromProcess($,A){return this.U($).detach(A)}async reduceConnectionGraceTime(){for(const $ of this.a.values())$.reduceGraceTime()}async listProcesses(){const $=Array.from(this.a.entries()).filter(([te,G])=>G.shouldPersistTerminal);this.I.info(`Listing ${$.length} persistent terminals, ${this.a.size} total terminals`);const A=$.map(async([te,G])=>this.S(te,G));return(await Promise.all(A)).filter(te=>te.isOrphan)}async getPerformanceMarks(){return S.getMarks()}async start($){const A=this.a.get($);return A?A.start():{message:`Could not find pty with id "${$}"`}}async shutdown($,A){return this.a.get($)?.shutdown(A)}async input($,A){return this.U($).input(A)}async processBinary($,A){return this.U($).writeBinary(A)}async resize($,A,Y){return this.U($).resize(A,Y)}async getInitialCwd($){return this.U($).getInitialCwd()}async getCwd($){return this.U($).getCwd()}async acknowledgeDataEvent($,A){return this.U($).acknowledgeDataEvent(A)}async setUnicodeVersion($,A){return this.U($).setUnicodeVersion(A)}async getLatency(){return[]}async orphanQuestionReply($){return this.U($).orphanQuestionReply()}async installAutoReply($,A){this.j.set($,A);for(const Y of this.a.values())Y.installAutoReply($,A)}async uninstallAllAutoReplies(){for(const $ of this.j.keys())for(const A of this.a.values())A.uninstallAutoReply($)}async uninstallAutoReply($){for(const A of this.a.values())A.uninstallAutoReply($)}async getDefaultSystemShell($=j.OS){return(0,P.$qm)($,process.env)}async getEnvironment(){return{...process.env}}async getWslPath($,A){if(A==="win-to-unix"){if(!j.$i)return $;if((0,a.$ss)()<17063)return $.replace(/\\/g,"/");const Y=this.O();return Y?new Promise(te=>{(0,w.execFile)(Y,["-e","wslpath",$],{},(ee,ce,ue)=>{te(ee?$:(0,E.$kQ)(ce.trim()))}).stdin.end()}):$}if(A==="unix-to-win"&&j.$i){if((0,a.$ss)()<17063)return $;const Y=this.O();return Y?new Promise(te=>{(0,w.execFile)(Y,["-e","wslpath","-w",$],{},(ee,ce,ue)=>{te(ee?$:ce.trim())}).stdin.end()}):$}return $}O(){const $=(0,a.$ss)()>=16299,A=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),Y=process.env.SystemRoot;if(Y)return(0,t.join)(Y,A?"Sysnative":"System32",$?"wsl.exe":"bash.exe")}async getRevivedPtyNewId($,A){try{return this.g.get(this.R($,A))?.newId}catch(Y){this.I.warn(`Couldn't find terminal ID ${$}-${A}`,Y.message)}}async setTerminalLayoutInfo($){this.b.set($.workspaceId,$)}async getTerminalLayoutInfo($){S.mark("code/willGetTerminalLayoutInfo");const A=this.b.get($.workspaceId);if(A){const Y=new Set,G=(await Promise.all(A.tabs.map(async ee=>this.P($.workspaceId,ee,Y)))).filter(ee=>ee.terminals.length>0);return S.mark("code/didGetTerminalLayoutInfo"),{tabs:G}}S.mark("code/didGetTerminalLayoutInfo")}async P($,A,Y){const G=(await Promise.all(A.terminals.map(ee=>this.Q($,ee,Y)))).filter(ee=>ee.terminal!==null);return{isActive:A.isActive,activePersistentProcessId:A.activePersistentProcessId,terminals:G}}async Q($,A,Y){try{const te=this.R($,A.terminal),G=this.g.get(te)?.newId;this.I.info(`Expanding terminal instance, old id ${te} -> new id ${G}`),this.g.delete(te);const ee=G??A.terminal;if(Y.has(ee))throw new Error(`Terminal ${ee} has already been expanded`);Y.add(ee);const ce=this.U(ee);return{terminal:{...ce&&await this.S(A.terminal,ce,G!==void 0),id:ee},relativeSize:A.relativeSize}}catch(te){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",te.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",A),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:A.relativeSize}}}R($,A){return`${$}-${A}`}async S($,A,Y=!1){S.mark(`code/willBuildProcessDetails/${$}`);const[te,G]=await Promise.all([A.getCwd(),Y?!0:A.isOrphaned()]),ee={id:$,title:A.title,titleSource:A.titleSource,pid:A.pid,workspaceId:A.workspaceId,workspaceName:A.workspaceName,cwd:te,isOrphan:G,icon:A.icon,color:A.color,fixedDimensions:A.fixedDimensions,environmentVariableCollections:A.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:A.shellLaunchConfig.reconnectionProperties,waitOnExit:A.shellLaunchConfig.waitOnExit,hideFromUser:A.shellLaunchConfig.hideFromUser,isFeatureTerminal:A.shellLaunchConfig.isFeatureTerminal,type:A.shellLaunchConfig.type,hasChildProcesses:A.hasChildProcesses,shellIntegrationNonce:A.processLaunchOptions.options.shellIntegration.nonce};return S.mark(`code/didBuildProcessDetails/${$}`),ee}U($){const A=this.a.get($);if(!A)throw new d.$bb("Could not find pty on pty host");return A}}e.$Gic=b,be([c.$1h],b.prototype,"traceRpcArgs",null),be([p],b.prototype,"refreshIgnoreProcessNames",null),be([p],b.prototype,"requestDetachInstance",null),be([p],b.prototype,"acceptDetachInstanceReply",null),be([p],b.prototype,"freePortKillProcess",null),be([p],b.prototype,"serializeTerminalState",null),be([p],b.prototype,"reviveTerminalProcesses",null),be([p],b.prototype,"shutdownAll",null),be([p],b.prototype,"createProcess",null),be([p],b.prototype,"attachToProcess",null),be([p],b.prototype,"updateTitle",null),be([p],b.prototype,"updateIcon",null),be([p],b.prototype,"clearBuffer",null),be([p],b.prototype,"refreshProperty",null),be([p],b.prototype,"updateProperty",null),be([p],b.prototype,"detachFromProcess",null),be([p],b.prototype,"reduceConnectionGraceTime",null),be([p],b.prototype,"listProcesses",null),be([p],b.prototype,"getPerformanceMarks",null),be([p],b.prototype,"start",null),be([p],b.prototype,"shutdown",null),be([p],b.prototype,"input",null),be([p],b.prototype,"processBinary",null),be([p],b.prototype,"resize",null),be([p],b.prototype,"getInitialCwd",null),be([p],b.prototype,"getCwd",null),be([p],b.prototype,"acknowledgeDataEvent",null),be([p],b.prototype,"setUnicodeVersion",null),be([p],b.prototype,"getLatency",null),be([p],b.prototype,"orphanQuestionReply",null),be([p],b.prototype,"installAutoReply",null),be([p],b.prototype,"uninstallAllAutoReplies",null),be([p],b.prototype,"uninstallAutoReply",null),be([p],b.prototype,"getDefaultSystemShell",null),be([p],b.prototype,"getEnvironment",null),be([p],b.prototype,"getWslPath",null),be([p],b.prototype,"getRevivedPtyNewId",null),be([p],b.prototype,"setTerminalLayoutInfo",null),be([p],b.prototype,"getTerminalLayoutInfo",null);var z;(function(O){O.None="None",O.ReplayOnly="ReplayOnly",O.Session="Session"})(z||(z={}));class Z extends M.$Vc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle($,A){A===y.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=$,this.O=A}setIcon($,A,Y){(!this.Y||"id"in A&&"id"in this.Y&&A.id!==this.Y.id||!this.color||Y!==this.Z)&&(this.P.freeRawReviveBuffer(),$&&this.j.setValue("Session","setIcon")),this.Y=A,this.Z=Y}S($){this.R=$}constructor($,A,Y,te,G,ee,ce,ue,X,q,Q,K,de,B,le,_,u){super(),this.U=$,this.W=A,this.workspaceId=Y,this.workspaceName=te,this.shouldPersistTerminal=G,this.processLaunchOptions=ue,this.unicodeVersion=X,this.X=Q,this.Y=B,this.Z=le,this.b=new Map,this.f=new Map,this.g=!1,this.w=new L.$Dh,this.C=this.B(new C.$ee),this.onProcessReplay=this.C.event,this.D=this.B(new C.$ee),this.onProcessReady=this.D.event,this.F=this.B(new C.$ee),this.onPersistentProcessReady=this.F.event,this.G=this.B(new C.$ee),this.onProcessData=this.G.event,this.H=this.B(new C.$ee),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new C.$ee),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=y.TitleEventSource.Process,this.j=new T(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=K!==void 0,this.P=new R(ee,ce,q.scrollback,X,K,ue.options.shellIntegration.nonce,G?de:void 0,this.X),_&&this.setTitle(_,y.TitleEventSource.Api),this.R=u,this.n=null,this.u=0,this.y=this.B(new L.$Jh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${m(q.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},q.graceTime)),this.z=this.B(new L.$Jh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${m(q.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},q.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(N=>{this.L=N.pid,this.M=N.cwd,this.D.fire(N)})),this.B(this.W.onDidChangeProperty(N=>{this.I.fire(N)})),this.a=new l.$Jvb((N,ie)=>this.G.fire(ie)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(N=>this.P.handleData(N))),this.B((0,M.$Tc)(()=>{for(const N of this.b.values())N.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach($){this.shouldPersistTerminal&&(this.j.value!=="None"||$)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty($){return this.W.refreshProperty($)}async updateProperty($,A){if($==="fixedDimensions")return this.S(A)}async start(){if(!this.g){const $=await this.W.start();return $&&"message"in $||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),$}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown($){return this.W.shutdown($)}input($){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const A of this.b.values())A.handleInput();return this.W.input($)}}writeBinary($){return this.W.processBinary($)}resize($,A){if(!this.J){this.P.handleResize($,A),this.a.flushBuffer(this.U);for(const Y of this.b.values())Y.handleResize();return this.W.resize($,A)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion($){this.unicodeVersion=$,this.P.setUnicodeVersion?.($)}acknowledgeDataEvent($){if(!this.J)return this.W.acknowledgeDataEvent($)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const $=await this.P.generateReplayEvent();let A=0;for(const Y of $.events)A+=Y.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${A} chars and ${$.events.length} size events`),this.C.fire($),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply($,A){this.b.get($)?.dispose(),this.b.set($,new s.$zic(this.W,$,A,this.X))}uninstallAutoReply($){this.b.get($)?.dispose(),this.b.delete($)}sendCommandResult($,A,Y){this.f.get($)&&this.f.delete($)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const $=this.n;this.n=null,$.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new L.$wh(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class T{get value(){return this.b}setValue($,A){this.b!==$&&(this.b=$,this.f(A))}constructor($,A,Y){this.a=$,this.b=A,this.d=Y,this.f("initialized")}f($){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${$}`)}}class R{constructor($,A,Y,te,G,ee,ce,ue){this.f=ce,this.a=new o.Terminal({cols:$,rows:A,scrollback:Y,allowProposedApi:!0}),G&&this.a.writeln(G),this.setUnicodeVersion(te),this.b=new v.$uub(ee,!0,void 0,ue),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData($){this.a.write($)}handleResize($,A){this.a.resize($,A)}clearBuffer(){this.a.clear()}async generateReplayEvent($,A){const Y=new(await this._getSerializeConstructor());this.a.loadAddon(Y);const te={scrollback:this.a.options.scrollback};$&&(te.excludeAltBuffer=!0,te.excludeModes=!0);let G;return A&&this.f?G=this.f:G=Y.serialize(te),{events:[{cols:this.a.cols,rows:this.a.rows,data:G}],commands:this.b.serialize()}}async setUnicodeVersion($){this.a.unicode.activeVersion!==$&&($==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=$)}async _getUnicode11Constructor(){return k||(k=(await new Promise(($,A)=>{ae(["@xterm/addon-unicode11"],$,A)})).Unicode11Addon),k}async _getSerializeConstructor(){return D||(D=(await new Promise(($,A)=>{ae(["@xterm/addon-serialize"],$,A)})).SerializeAddon),D}}function m(O){let $=0,A=0,Y=0;O>=1e3&&(Y=Math.floor(O/1e3),O-=Y*1e3),Y>=60&&(A=Math.floor(Y/60),Y-=A*60),A>=60&&($=Math.floor(A/60),A-=$*60);const te=$?`${$}h`:"",G=A?`${A}m`:"",ee=Y?`${Y}s`:"",ce=O?`${O}ms`:"";return`${te}${G}${ee}${ce}`}}),define(fe[112],me([0,1,60,27,64,65,10,75,78,8,80,81,83,84,28,102,105,31,11,2]),function(ae,e,w,L,C,M,j,P,h,r,y,l,E,o,a,g,f,n,s,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),v();async function v(){const i=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),t=parseInt(process.env.VSCODE_LATENCY??"0"),c={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,i&&await(0,s.$xh)(i);const S=(0,n.$bX)(process);let p;S?p=new M.$cX:p=new C.$Zq(a.TerminalIpcChannels.PtyHost);const D={_serviceBrand:void 0,...o.default},k=new h.$9m((0,P.$tm)(process.argv,P.$sm),D),b=new E.$KQ((0,r.$ek)(k),k.logsHome);p.registerChannel(a.TerminalIpcChannels.Logger,new y.$as(b,()=>w.$zn));const z=b.createLogger("ptyhost",{name:(0,j.localize)(0,null)}),Z=new l.$UQ(z);i&&Z.warn(`Pty Host startup is delayed ${i}ms`),t&&Z.warn(`Pty host is simulating ${t}ms latency`);const T=new d.$Uc,R=new g.$Cic;p.registerChannel(a.TerminalIpcChannels.Heartbeat,L.ProxyChannel.fromService(R,T));const m=new f.$Gic(Z,D,c,t),O=L.ProxyChannel.fromService(m,T);p.registerChannel(a.TerminalIpcChannels.PtyHost,O),S&&p.registerChannel(a.TerminalIpcChannels.PtyHostWindow,O),process.once("exit",()=>{Z.trace("Pty host exiting"),Z.dispose(),R.dispose(),m.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc96b837cf6bb4af9cd736aa3af08cf8279f7685/core/vs/platform/terminal/node/ptyHostMain.js.map
