/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/types","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/map","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","fs","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","os","vs/base/common/process","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/base/common/iterator","vs/platform/request/common/request","vs/base/common/json","vs/base/common/performance","vs/editor/common/core/range","vs/base/parts/ipc/common/ipc","vs/platform/contextkey/common/contextkey","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/server/node/serverEnvironmentService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/marshalling","vs/base/common/uriIpc","child_process","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/lazy","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/mime","vs/base/common/processes","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/parts/ipc/node/ipc.net","vs/base/common/decorators","vs/base/common/functional","vs/base/common/themables","path","net","vs/editor/common/core/position","vs/base/common/glob","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/remote/common/remoteHosts","url","vs/platform/shell/node/shellEnv","vs/platform/extensionManagement/node/extensionSignatureVerificationService","crypto","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminal","vs/platform/workspace/common/workspace","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/common/amd","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/codiconsUtil","vs/base/common/htmlContent","vs/base/node/id","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/environmentService","vs/platform/instantiation/common/extensions","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/loggerService","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminalEnvironment","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/remoteLanguagePacks","vs/server/node/extensionsScannerService","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/platform/request/node/requestService","vs/server/node/extensionHostConnection","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/equals","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/ports","vs/editor/common/core/editOperation","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/common/labels","vs/base/node/osReleaseInfo","vs/base/node/extpath","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/editor/common/languages","vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/remoteExtensionHostAgentCli","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/nodePtyHostStarter","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remote/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostCommands","vs/workbench/services/remote/common/remoteFileSystemProviderClient","zlib","vs/server/node/remoteExtensionHostAgentCli","vs/base/node/unc","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","fs/promises","readline","util","minimist","assert","graceful-fs","https","http","vs/server/node/server.main"],Ee=function(he){for(var e=[],o=0,C=he.length;o<C;o++)e[o]=ye[he[o]];return e};define(ye[96],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class o{static get(){const S=new Map,D=new Map,I=new Map,P=new Map;function b(m,u){m.has(u.detail)||m.set(u.detail,-u.timestamp)}function g(m,u){const a=m.get(u.detail);a&&(a>=0||m.set(u.detail,a+u.timestamp))}let y=[];typeof he=="function"&&typeof he.getStats=="function"&&(y=he.getStats().slice(0).sort((m,u)=>m.timestamp-u.timestamp));for(const m of y)switch(m.type){case 10:b(S,m);break;case 11:case 12:g(S,m);break;case 21:b(D,m);break;case 22:g(D,m);break;case 33:b(I,m);break;case 34:g(I,m);break;case 31:b(P,m);break;case 32:g(P,m);break}let v=0;I.forEach(m=>v+=m);function w(m){const u=[];return m.forEach((a,f)=>u.push([f,a])),u}return{amdLoad:w(S),amdInvoke:w(D),nodeRequire:w(I),nodeEval:w(P),nodeRequireTotal:v}}static toMarkdownTable(S,D){let I="";const P=[];return S.forEach((b,g)=>{P[g]=b.length}),D.forEach(b=>{b.forEach((g,y)=>{typeof g>"u"&&(g=b[y]="-");const v=g.toString().length;P[y]=Math.max(v,P[y])})}),S.forEach((b,g)=>{I+=`| ${b+" ".repeat(P[g]-b.toString().length)} `}),I+=`|
`,S.forEach((b,g)=>{I+=`| ${"-".repeat(P[g])} `}),I+=`|
`,D.forEach(b=>{b.forEach((g,y)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(P[y]-g.toString().length)} `)}),I+=`|
`}),I}}e.$U=o}),define(ye[145],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=o,e.$gb=C,e.$hb=S,e.$ib=D,e.$jb=I,e.$kb=P,e.$lb=b,e.$nb=y,e.$ob=v,e.$pb=w,e.$qb=m,e.$rb=u;function o(a,f){const c=C(a,f);if(c!==-1)return a[c]}function C(a,f,c=a.length-1){for(let d=c;d>=0;d--){const p=a[d];if(f(p))return d}return-1}function S(a,f){const c=D(a,f);return c===-1?void 0:a[c]}function D(a,f,c=0,d=a.length){let p=c,E=d;for(;p<E;){const h=Math.floor((p+E)/2);f(a[h])?p=h+1:E=h}return p-1}function I(a,f){const c=P(a,f);return c===a.length?void 0:a[c]}function P(a,f,c=0,d=a.length){let p=c,E=d;for(;p<E;){const h=Math.floor((p+E)/2);f(a[h])?E=h:p=h+1}return p}function b(a,f,c=0,d=a.length){const p=P(a,f,c,d);return p===a.length?-1:p}class g{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(g.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!f(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const c=D(this.e,f,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}e.$mb=g;function y(a,f){if(a.length===0)return;let c=a[0];for(let d=1;d<a.length;d++){const p=a[d];f(p,c)>0&&(c=p)}return c}function v(a,f){if(a.length===0)return;let c=a[0];for(let d=1;d<a.length;d++){const p=a[d];f(p,c)>=0&&(c=p)}return c}function w(a,f){return y(a,(c,d)=>-f(c,d))}function m(a,f){if(a.length===0)return-1;let c=0;for(let d=1;d<a.length;d++){const p=a[d];f(p,a[c])>0&&(c=d)}return c}function u(a,f){for(const c of a){const d=f(c);if(d!==void 0)return d}}}),define(ye[146],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=o,e.$L=C,e.$M=S,e.$N=D;function o(I,P){const b=Object.create(null);for(const g of I){const y=P(g);let v=b[y];v||(v=b[y]=[]),v.push(g)}return b}function C(I,P){const b=[],g=[];for(const y of I)P.has(y)||b.push(y);for(const y of P)I.has(y)||g.push(y);return{removed:b,added:g}}function S(I,P){const b=[],g=[];for(const[y,v]of I)P.has(y)||b.push(v);for(const[y,v]of P)I.has(y)||g.push(v);return{removed:b,added:g}}function D(I,P){const b=new Set;for(const g of P)I.has(g)&&b.add(g);return b}}),define(ye[74],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=C,e.$2h=S,e.$3h=D;function o(I){return(P,b,g)=>{let y=null,v=null;if(typeof g.value=="function"?(y="value",v=g.value):typeof g.get=="function"&&(y="get",v=g.get),!v)throw new Error("not supported");g[y]=I(v,b)}}function C(I,P,b){let g=null,y=null;if(typeof b.value=="function"?(g="value",y=b.value,y.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof b.get=="function"&&(g="get",y=b.get),!y)throw new Error("not supported");const v=`$memoize$${P}`;b[g]=function(...w){return this.hasOwnProperty(v)||Object.defineProperty(this,v,{configurable:!1,enumerable:!1,writable:!1,value:y.apply(this,w)}),this[v]}}function S(I,P,b){return o((g,y)=>{const v=`$debounce$${y}`,w=`$debounce$result$${y}`;return function(...m){this[w]||(this[w]=b?b():void 0),clearTimeout(this[v]),P&&(this[w]=P(this[w],...m),m=[this[w]]),this[v]=setTimeout(()=>{g.apply(this,m),this[w]=b?b():void 0},I)}})}function D(I,P,b){return o((g,y)=>{const v=`$throttle$timer$${y}`,w=`$throttle$result$${y}`,m=`$throttle$lastRun$${y}`,u=`$throttle$pending$${y}`;return function(...a){if(this[w]||(this[w]=b?b():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),P&&(this[w]=P(this[w],...a)),this[u])return;const f=this[m]+I;f<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[w]]),this[w]=b?b():void 0):(this[u]=!0,this[v]=setTimeout(()=>{this[u]=!1,this[m]=Date.now(),g.apply(this,[this[w]]),this[w]=b?b():void 0},f-Date.now()))}})}}),define(ye[11],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=C,e.$Z=S,e.$1=D,e.$2=I,e.$3=P,e.$4=g,e.$6=v,e.$7=w,e.$8=m,e.$0=a;class o{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?p.isErrorNoTelemetry(t)?new p(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(s=>{s(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=o,e.$X=new o;function C(h){e.$X.setUnexpectedErrorHandler(h)}function S(h){if(!h||typeof h!="object")return!1;const t=h;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function D(h){g(h)||e.$X.onUnexpectedError(h)}function I(h){g(h)||e.$X.onUnexpectedExternalError(h)}function P(h){if(h instanceof Error){const{name:t,message:s}=h,r=h.stacktrace||h.stack;return{$isError:!0,name:t,message:s,stack:r,noTelemetry:p.isErrorNoTelemetry(h)}}return h}const b="Canceled";function g(h){return h instanceof y?!0:h instanceof Error&&h.name===b&&h.message===b}class y extends Error{constructor(){super(b),this.name=this.message}}e.$5=y;function v(){const h=new Error(b);return h.name=h.message,h}function w(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}function m(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}class u extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=u;function a(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}class f extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=f;class c extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=c;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class p extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof p)return t;const s=new p;return s.message=t.message,s.stack=t.stack,s}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=p;class E extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,E.prototype)}}e.$cb=E}),define(ye[18],Ee([1,0,11,145]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=S,e.$tb=D,e.$ub=I,e.$vb=P,e.$wb=b,e.$xb=g,e.$yb=y,e.$zb=v,e.$Ab=w,e.$Bb=m,e.$Cb=u,e.$Db=a,e.$Eb=f,e.top=c,e.$Gb=d,e.$Hb=E,e.$Ib=h,e.$Jb=t,e.$Kb=s,e.$Lb=r,e.$Mb=i,e.$Nb=n,e.$Ob=l,e.$Pb=$,e.$Qb=k,e.$Rb=j,e.$Sb=A,e.$Tb=O,e.$Ub=F,e.$Vb=V,e.$Wb=Z,e.$Xb=oe,e.$Yb=le,e.$Zb=te,e.$1b=_,e.$2b=W,e.$3b=K,e.$4b=Y,e.$5b=M,e.$6b=Q,e.$7b=be,e.$8b=re,e.$$b=N;function S(x,G=0){return x[x.length-(1+G)]}function D(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}function I(x,G,U=(T,q)=>T===q){if(x===G)return!0;if(!x||!G||x.length!==G.length)return!1;for(let T=0,q=x.length;T<q;T++)if(!U(x[T],G[T]))return!1;return!0}function P(x,G){const U=x.length-1;G<U&&(x[G]=x[U]),x.pop()}function b(x,G,U){return g(x.length,T=>U(x[T],G))}function g(x,G){let U=0,T=x-1;for(;U<=T;){const q=(U+T)/2|0,se=G(q);if(se<0)U=q+1;else if(se>0)T=q-1;else return q}return-(U+1)}function y(x,G,U){if(x=x|0,x>=G.length)throw new TypeError("invalid index");const T=G[Math.floor(G.length*Math.random())],q=[],se=[],ae=[];for(const me of G){const ee=U(me,T);ee<0?q.push(me):ee>0?se.push(me):ae.push(me)}return x<q.length?y(x,q,U):x<q.length+ae.length?ae[0]:y(x-(q.length+ae.length),se,U)}function v(x,G){const U=[];let T;for(const q of x.slice(0).sort(G))!T||G(T[0],q)!==0?(T=[q],U.push(T)):T.push(q);return U}function*w(x,G){let U,T;for(const q of x)T!==void 0&&G(T,q)?U.push(q):(U&&(yield U),U=[q]),T=q;U&&(yield U)}function m(x,G){for(let U=0;U<=x.length;U++)G(U===0?void 0:x[U-1],U===x.length?void 0:x[U])}function u(x,G){for(let U=0;U<x.length;U++)G(U===0?void 0:x[U-1],x[U],U+1===x.length?void 0:x[U+1])}function a(x,G,U){const T=[];function q(me,ee,ge){if(ee===0&&ge.length===0)return;const $e=T[T.length-1];$e&&$e.start+$e.deleteCount===me?($e.deleteCount+=ee,$e.toInsert.push(...ge)):T.push({start:me,deleteCount:ee,toInsert:ge})}let se=0,ae=0;for(;;){if(se===x.length){q(se,0,G.slice(ae));break}if(ae===G.length){q(se,x.length-se,[]);break}const me=x[se],ee=G[ae],ge=U(me,ee);ge===0?(se+=1,ae+=1):ge<0?(q(se,1,[]),se+=1):ge>0&&(q(se,0,[ee]),ae+=1)}return T}function f(x,G,U){const T=a(x,G,U),q=[],se=[];for(const ae of T)q.push(...x.slice(ae.start,ae.start+ae.deleteCount)),se.push(...ae.toInsert);return{removed:q,added:se}}function c(x,G,U){if(U===0)return[];const T=x.slice(0,U).sort(G);return p(x,G,T,U,x.length),T}function d(x,G,U,T,q){return U===0?Promise.resolve([]):new Promise((se,ae)=>{(async()=>{const me=x.length,ee=x.slice(0,U).sort(G);for(let ge=U,$e=Math.min(U+T,me);ge<me;ge=$e,$e=Math.min($e+T,me)){if(ge>U&&await new Promise(Ce=>setTimeout(Ce)),q&&q.isCancellationRequested)throw new o.$5;p(x,G,ee,ge,$e)}return ee})().then(se,ae)})}function p(x,G,U,T,q){for(const se=U.length;T<q;T++){const ae=x[T];if(G(ae,U[se-1])<0){U.pop();const me=(0,C.$kb)(U,ee=>G(ae,ee)<0);U.splice(me,0,ae)}}}function E(x){return x.filter(G=>!!G)}function h(x){let G=0;for(let U=0;U<x.length;U++)x[U]&&(x[G]=x[U],G+=1);x.length=G}function t(x,G,U){x.splice(U,0,x.splice(G,1)[0])}function s(x){return!Array.isArray(x)||x.length===0}function r(x){return Array.isArray(x)&&x.length>0}function i(x,G=U=>U){const U=new Set;return x.filter(T=>{const q=G(T);return U.has(q)?!1:(U.add(q),!0)})}function n(x){const G=new Set;return U=>{const T=x(U);return G.has(T)?!1:(G.add(T),!0)}}function l(x,G){return x.length>0?x[0]:G}function $(x,G){return x.length>0?x[x.length-1]:G}function k(x,G,U=(T,q)=>T===q){let T=0;for(let q=0,se=Math.min(x.length,G.length);q<se&&U(x[q],G[q]);q++)T++;return T}function j(x){return[].concat(...x)}function A(x,G){let U=typeof G=="number"?x:0;typeof G=="number"?U=x:(U=0,G=x);const T=[];if(U<=G)for(let q=U;q<G;q++)T.push(q);else for(let q=U;q>G;q--)T.push(q);return T}function O(x,G,U){return x.reduce((T,q)=>(T[G(q)]=U?U(q):q,T),Object.create(null))}function F(x,G){return x.push(G),()=>V(x,G)}function V(x,G){const U=x.indexOf(G);if(U>-1)return x.splice(U,1),G}function Z(x,G,U){const T=x.slice(0,G),q=x.slice(G);return T.concat(U,q)}function oe(x,G){let U;if(typeof G=="number"){let T=G;U=()=>{const q=Math.sin(T++)*179426549;return q-Math.floor(q)}}else U=Math.random;for(let T=x.length-1;T>0;T-=1){const q=Math.floor(U()*(T+1)),se=x[T];x[T]=x[q],x[q]=se}}function le(x,G){const U=x.indexOf(G);U>-1&&(x.splice(U,1),x.unshift(G))}function te(x,G){const U=x.indexOf(G);U>-1&&(x.splice(U,1),x.push(G))}function _(x,G){for(const U of G)x.push(U)}function W(x,G){return Array.isArray(x)?x.map(G):G(x)}function K(x){return Array.isArray(x)?x:[x]}function Y(x){return x[Math.floor(Math.random()*x.length)]}function M(x,G,U){const T=ce(x,G),q=x.length,se=U.length;x.length=q+se;for(let ae=q-1;ae>=T;ae--)x[ae+se]=x[ae];for(let ae=0;ae<se;ae++)x[ae+T]=U[ae]}function Q(x,G,U,T){const q=ce(x,G);let se=x.splice(q,U);return se===void 0&&(se=[]),M(x,q,T),se}function ce(x,G){return G<0?Math.max(G+x.length,0):Math.min(G,x.length)}var ie;(function(x){function G(se){return se<0}x.isLessThan=G;function U(se){return se<=0}x.isLessThanOrEqual=U;function T(se){return se>0}x.isGreaterThan=T;function q(se){return se===0}x.isNeitherLessOrGreaterThan=q,x.greaterThan=1,x.lessThan=-1,x.neitherLessOrGreaterThan=0})(ie||(e.CompareResult=ie={}));function be(x,G){return(U,T)=>G(x(U),x(T))}function re(...x){return(G,U)=>{for(const T of x){const q=T(G,U);if(!ie.isNeitherLessOrGreaterThan(q))return q}return ie.neitherLessOrGreaterThan}}const X=(x,G)=>x-G;e.$9b=X;const B=(x,G)=>(0,e.$9b)(x?1:0,G?1:0);e.$0b=B;function N(x){return(G,U)=>-x(G,U)}class z{constructor(G){this.g=G,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(G){let U=this.c;for(;U<this.g.length&&G(this.g[U]);)U++;const T=U===this.c?null:this.g.slice(this.c,U);return this.c=U,T}takeFromEndWhile(G){let U=this.d;for(;U>=0&&G(this.g[U]);)U--;const T=U===this.d?null:this.g.slice(U+1,this.d+1);return this.d=U,T}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const G=this.g[this.c];return this.c++,G}removeLast(){const G=this.g[this.d];return this.d--,G}takeCount(G){const U=this.g.slice(this.c,this.c+G);return this.c+=G,U}}e.$_b=z;class J{static{this.empty=new J(G=>{})}constructor(G){this.iterate=G}forEach(G){this.iterate(U=>(G(U),!0))}toArray(){const G=[];return this.iterate(U=>(G.push(U),!0)),G}filter(G){return new J(U=>this.iterate(T=>G(T)?U(T):!0))}map(G){return new J(U=>this.iterate(T=>U(G(T))))}some(G){let U=!1;return this.iterate(T=>(U=G(T),!U)),U}findFirst(G){let U;return this.iterate(T=>G(T)?(U=T,!1):!0),U}findLast(G){let U;return this.iterate(T=>(G(T)&&(U=T),!0)),U}findLastMaxBy(G){let U,T=!0;return this.iterate(q=>((T||ie.isGreaterThan(G(q,U)))&&(T=!1,U=q),!0)),U}}e.$ac=J;class ue{constructor(G){this.c=G}static createSortPermutation(G,U){const T=Array.from(G.keys()).sort((q,se)=>U(G[q],G[se]));return new ue(T)}apply(G){return G.map((U,T)=>G[this.c[T]])}inverse(){const G=this.c.slice();for(let U=0;U<this.c.length;U++)G[this.c[U]]=U;return new ue(G)}}e.$bc=ue}),define(ye[97],Ee([1,0,11]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.$fd=S,e.$gd=D,e.$hd=I,e.$id=P,e.$jd=b;function C(g,y){if(!g)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}function S(g,y="Unreachable"){throw new Error(y)}function D(g){if(!g)throw new o.$cb("Assertion Failed")}function I(g){g||(0,o.$1)(new o.$cb("Soft Assertion Failed"))}function P(g){if(!g()){debugger;g(),(0,o.$1)(new o.$cb("Assertion Failed"))}}function b(g,y){let v=0;for(;v<g.length-1;){const w=g[v],m=g[v+1];if(!y(w,m))return!1;v++}return!0}}),define(ye[147],Ee([1,0,18]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=void 0,e.$8c=S,e.$9c=D,e.$0c=I,e.$$c=P,e.$_c=b,e.$ad=g;const C=(m,u)=>m===u;e.$7c=C;function S(m=e.$7c){return(u,a)=>o.$ub(u,a,m)}function D(){return(m,u)=>JSON.stringify(m)===JSON.stringify(u)}function I(){return(m,u)=>m.equals(u)}function P(m,u,a){return!m||!u?m===u:a(m,u)}function b(m,u){if(m===u)return!0;if(Array.isArray(m)&&Array.isArray(u)){if(m.length!==u.length)return!1;for(let a=0;a<m.length;a++)if(!b(m[a],u[a]))return!1;return!0}if(m&&typeof m=="object"&&u&&typeof u=="object"&&Object.getPrototypeOf(m)===Object.prototype&&Object.getPrototypeOf(u)===Object.prototype){const a=m,f=u,c=Object.keys(a),d=Object.keys(f),p=new Set(d);if(c.length!==d.length)return!1;for(const E of c)if(!p.has(E)||!b(a[E],f[E]))return!1;return!0}return!1}function g(m){return JSON.stringify(w(m))}let y=0;const v=new WeakMap;function w(m){if(Array.isArray(m))return m.map(w);if(m&&typeof m=="object")if(Object.getPrototypeOf(m)===Object.prototype){const u=m,a=Object.create(null);for(const f of Object.keys(u).sort())a[f]=w(u[f]);return a}else{let u=v.get(m);return u===void 0&&(u=y++,v.set(m,u)),u+"----2b76a038c20c4bcc"}return m}}),define(ye[75],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=o;function o(C,S){const D=this;let I=!1,P;return function(){if(I)return P;if(I=!0,S)try{P=C.apply(D,arguments)}finally{S()}else P=C.apply(D,arguments);return P}}}),define(ye[41],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(C){function S(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=S;const D=Object.freeze([]);function I(){return D}C.empty=I;function*P(t){yield t}C.single=P;function b(t){return S(t)?t:P(t)}C.wrap=b;function g(t){return t||D}C.from=g;function*y(t){for(let s=t.length-1;s>=0;s--)yield t[s]}C.reverse=y;function v(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=v;function w(t){return t[Symbol.iterator]().next().value}C.first=w;function m(t,s){for(const r of t)if(s(r))return!0;return!1}C.some=m;function u(t,s){for(const r of t)if(s(r))return r}C.find=u;function*a(t,s){for(const r of t)s(r)&&(yield r)}C.filter=a;function*f(t,s){let r=0;for(const i of t)yield s(i,r++)}C.map=f;function*c(...t){for(const s of t)yield*s}C.concat=c;function d(t,s,r){let i=r;for(const n of t)i=s(i,n);return i}C.reduce=d;function*p(t,s,r=t.length){for(s<0&&(s+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);s<r;s++)yield t[s]}C.slice=p;function E(t,s=Number.POSITIVE_INFINITY){const r=[];if(s===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<s;n++){const l=i.next();if(l.done)return[r,C.empty()];r.push(l.value)}return[r,{[Symbol.iterator](){return i}}]}C.consume=E;async function h(t){const s=[];for await(const r of t)s.push(r);return Promise.resolve(s)}C.asyncToArray=h})(o||(e.Iterable=o={}))}),define(ye[43],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Hn=I,e.$In=v,e.$Jn=w,e.$Kn=m,e.$Ln=u,e.$Mn=a,e.$Nn=f,e.$On=c,e.$Pn=d,e.$Qn=p,e.$Rn=E,e.$Sn=h;var o;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(o||(e.ScanError=o={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S||(e.ParseErrorCode=S={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D||(e.ParseOptions=D={}));function I(t,s=!1){let r=0;const i=t.length;let n="",l=0,$=16,k=0;function j(le){let te=0,_=0;for(;te<le;){const W=t.charCodeAt(r);if(W>=48&&W<=57)_=_*16+W-48;else if(W>=65&&W<=70)_=_*16+W-65+10;else if(W>=97&&W<=102)_=_*16+W-97+10;else break;r++,te++}return te<le&&(_=-1),_}function A(le){r=le,n="",l=0,$=16,k=0}function O(){const le=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&g(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&g(t.charCodeAt(r)))for(r++;r<t.length&&g(t.charCodeAt(r));)r++;else return k=3,t.substring(le,r);let te=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&g(t.charCodeAt(r))){for(r++;r<t.length&&g(t.charCodeAt(r));)r++;te=r}else k=3;return t.substring(le,te)}function F(){let le="",te=r;for(;;){if(r>=i){le+=t.substring(te,r),k=2;break}const _=t.charCodeAt(r);if(_===34){le+=t.substring(te,r),r++;break}if(_===92){if(le+=t.substring(te,r),r++,r>=i){k=2;break}switch(t.charCodeAt(r++)){case 34:le+='"';break;case 92:le+="\\";break;case 47:le+="/";break;case 98:le+="\b";break;case 102:le+="\f";break;case 110:le+=`
`;break;case 114:le+="\r";break;case 116:le+="	";break;case 117:{const K=j(4);K>=0?le+=String.fromCharCode(K):k=4;break}default:k=5}te=r;continue}if(_>=0&&_<=31)if(b(_)){le+=t.substring(te,r),k=2;break}else k=6;r++}return le}function V(){if(n="",k=0,l=r,r>=i)return l=i,$=17;let le=t.charCodeAt(r);if(P(le)){do r++,n+=String.fromCharCode(le),le=t.charCodeAt(r);while(P(le));return $=15}if(b(le))return r++,n+=String.fromCharCode(le),le===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),$=14;switch(le){case 123:return r++,$=1;case 125:return r++,$=2;case 91:return r++,$=3;case 93:return r++,$=4;case 58:return r++,$=6;case 44:return r++,$=5;case 34:return r++,n=F(),$=10;case 47:{const te=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!b(t.charCodeAt(r));)r++;return n=t.substring(te,r),$=12}if(t.charCodeAt(r+1)===42){r+=2;const _=i-1;let W=!1;for(;r<_;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,k=1),n=t.substring(te,r),$=13}return n+=String.fromCharCode(le),r++,$=16}case 45:if(n+=String.fromCharCode(le),r++,r===i||!g(t.charCodeAt(r)))return $=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=O(),$=11;default:for(;r<i&&Z(le);)r++,le=t.charCodeAt(r);if(l!==r){switch(n=t.substring(l,r),n){case"true":return $=8;case"false":return $=9;case"null":return $=7}return $=16}return n+=String.fromCharCode(le),r++,$=16}}function Z(le){if(P(le)||b(le))return!1;switch(le){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let le;do le=V();while(le>=12&&le<=15);return le}return{setPosition:A,getPosition:()=>r,scan:s?oe:V,getToken:()=>$,getTokenValue:()=>n,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>k}}function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function b(t){return t===10||t===13||t===8232||t===8233}function g(t){return t>=48&&t<=57}var y;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(y||(y={}));function v(t,s){const r=[],i=new Object;let n;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let $=!1;function k(j,A,O,F){l.value=j,l.offset=A,l.length=O,l.type=F,l.colonOffset=void 0,n=l}try{p(t,{onObjectBegin:(j,A)=>{if(s<=j)throw i;n=void 0,$=s>j,r.push("")},onObjectProperty:(j,A,O)=>{if(s<A||(k(j,A,O,"property"),r[r.length-1]=j,s<=A+O))throw i},onObjectEnd:(j,A)=>{if(s<=j)throw i;n=void 0,r.pop()},onArrayBegin:(j,A)=>{if(s<=j)throw i;n=void 0,r.push(0)},onArrayEnd:(j,A)=>{if(s<=j)throw i;n=void 0,r.pop()},onLiteralValue:(j,A,O)=>{if(s<A||(k(j,A,O,h(j)),s<=A+O))throw i},onSeparator:(j,A,O)=>{if(s<=A)throw i;if(j===":"&&n&&n.type==="property")n.colonOffset=A,$=!1,n=void 0;else if(j===","){const F=r[r.length-1];typeof F=="number"?r[r.length-1]=F+1:($=!0,r[r.length-1]=""),n=void 0}}})}catch(j){if(j!==i)throw j}return{path:r,previousNode:n,isAtPropertyKey:$,matches:j=>{let A=0;for(let O=0;A<j.length&&O<r.length;O++)if(j[A]===r[O]||j[A]==="*")A++;else if(j[A]!=="**")return!1;return A===j.length}}}function w(t,s=[],r=D.DEFAULT){let i=null,n=[];const l=[];function $(j){Array.isArray(n)?n.push(j):i!==null&&(n[i]=j)}return p(t,{onObjectBegin:()=>{const j={};$(j),l.push(n),n=j,i=null},onObjectProperty:j=>{i=j},onObjectEnd:()=>{n=l.pop()},onArrayBegin:()=>{const j=[];$(j),l.push(n),n=j,i=null},onArrayEnd:()=>{n=l.pop()},onLiteralValue:$,onError:(j,A,O)=>{s.push({error:j,offset:A,length:O})}},r),n[0]}function m(t,s=[],r=D.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(j){i.type==="property"&&(i.length=j-i.offset,i=i.parent)}function l(j){return i.children.push(j),j}p(t,{onObjectBegin:j=>{i=l({type:"object",offset:j,length:-1,parent:i,children:[]})},onObjectProperty:(j,A,O)=>{i=l({type:"property",offset:A,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:j,offset:A,length:O,parent:i})},onObjectEnd:(j,A)=>{i.length=j+A-i.offset,i=i.parent,n(j+A)},onArrayBegin:(j,A)=>{i=l({type:"array",offset:j,length:-1,parent:i,children:[]})},onArrayEnd:(j,A)=>{i.length=j+A-i.offset,i=i.parent,n(j+A)},onLiteralValue:(j,A,O)=>{l({type:h(j),offset:A,length:O,parent:i,value:j}),n(A+O)},onSeparator:(j,A,O)=>{i.type==="property"&&(j===":"?i.colonOffset=A:j===","&&n(A))},onError:(j,A,O)=>{s.push({error:j,offset:A,length:O})}},r);const k=i.children[0];return k&&delete k.parent,k}function u(t,s){if(!t)return;let r=t;for(const i of s)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===i){r=l.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}function a(t){if(!t.parent||!t.parent.children)return[];const s=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}function f(t){switch(t.type){case"array":return t.children.map(f);case"object":{const s=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(s[r.children[0].value]=f(i))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function c(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}function d(t,s,r=!1){if(c(t,s,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=s;n++){const l=d(i[n],s,r);if(l)return l}return t}}function p(t,s,r=D.DEFAULT){const i=I(t,!1);function n(be){return be?()=>be(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(be){return be?re=>be(re,i.getTokenOffset(),i.getTokenLength()):()=>!0}const $=n(s.onObjectBegin),k=l(s.onObjectProperty),j=n(s.onObjectEnd),A=n(s.onArrayBegin),O=n(s.onArrayEnd),F=l(s.onLiteralValue),V=l(s.onSeparator),Z=n(s.onComment),oe=l(s.onError),le=r&&r.disallowComments,te=r&&r.allowTrailingComma;function _(){for(;;){const be=i.scan();switch(i.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:le||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(be){case 12:case 13:le?W(10):Z();break;case 16:W(1);break;case 15:case 14:break;default:return be}}}function W(be,re=[],X=[]){if(oe(be),re.length+X.length>0){let B=i.getToken();for(;B!==17;){if(re.indexOf(B)!==-1){_();break}else if(X.indexOf(B)!==-1)break;B=_()}}}function K(be){const re=i.getTokenValue();return be?F(re):k(re),_(),!0}function Y(){switch(i.getToken()){case 11:{let be=0;try{be=JSON.parse(i.getTokenValue()),typeof be!="number"&&(W(2),be=0)}catch{W(2)}F(be);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return _(),!0}function M(){return i.getToken()!==10?(W(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(V(":"),_(),ie()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){$(),_();let be=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(be||W(4,[],[]),V(","),_(),i.getToken()===2&&te)break}else be&&W(6,[],[]);M()||W(4,[],[2,5]),be=!0}return j(),i.getToken()!==2?W(7,[2],[]):_(),!0}function ce(){A(),_();let be=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(be||W(4,[],[]),V(","),_(),i.getToken()===4&&te)break}else be&&W(6,[],[]);ie()||W(4,[],[4,5]),be=!0}return O(),i.getToken()!==4?W(8,[4],[]):_(),!0}function ie(){switch(i.getToken()){case 3:return ce();case 1:return Q();case 10:return K(!0);default:return Y()}}return _(),i.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):ie()?(i.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}function E(t,s){const r=I(t),i=[];let n,l=0,$;do switch($=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:l!==$&&i.push(t.substring(l,$)),s!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,s)),l=r.getPosition();break}while(n!==17);return i.join("")}function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(ye[148],Ee([1,0,43]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tn=C,e.$Un=S,e.$Vn=P,e.$Wn=b;function C(g,y,v){let w,m,u,a,f;if(y){for(a=y.offset,f=a+y.length,u=a;u>0&&!b(g,u-1);)u--;let $=f;for(;$<g.length&&!b(g,$);)$++;m=g.substring(u,$),w=I(m,v)}else m=g,w=0,u=0,a=0,f=g.length;const c=P(v,g);let d=!1,p=0,E;v.insertSpaces?E=D(" ",v.tabSize||4):E="	";const h=(0,o.$Hn)(m,!1);let t=!1;function s(){return c+D(E,w+p)}function r(){let $=h.scan();for(d=!1;$===15||$===14;)d=d||$===14,$=h.scan();return t=$===16||h.getTokenError()!==0,$}const i=[];function n($,k,j){!t&&k<f&&j>a&&g.substring(k,j)!==$&&i.push({offset:k,length:j-k,content:$})}let l=r();if(l!==17){const $=h.getTokenOffset()+u,k=D(E,w);n(k,u,$)}for(;l!==17;){let $=h.getTokenOffset()+h.getTokenLength()+u,k=r(),j="";for(;!d&&(k===12||k===13);){const O=h.getTokenOffset()+u;n(" ",$,O),$=h.getTokenOffset()+h.getTokenLength()+u,j=k===12?s():"",k=r()}if(k===2)l!==1&&(p--,j=s());else if(k===4)l!==3&&(p--,j=s());else{switch(l){case 3:case 1:p++,j=s();break;case 5:case 12:j=s();break;case 13:d?j=s():j=" ";break;case 6:j=" ";break;case 10:if(k===6){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:k===12||k===13?j=" ":k!==5&&k!==17&&(t=!0);break;case 16:t=!0;break}d&&(k===12||k===13)&&(j=s())}const A=h.getTokenOffset()+u;n(j,$,A),l=k}return i}function S(g,y){const v=JSON.stringify(g,void 0,y.insertSpaces?y.tabSize||4:"	");return y.eol!==void 0?v.replace(/\r\n|\r|\n/g,y.eol):v}function D(g,y){let v="";for(let w=0;w<y;w++)v+=g;return v}function I(g,y){let v=0,w=0;const m=y.tabSize||4;for(;v<g.length;){const u=g.charAt(v);if(u===" ")w++;else if(u==="	")w+=m;else break;v++}return Math.floor(w/m)}function P(g,y){for(let v=0;v<y.length;v++){const w=y.charAt(v);if(w==="\r")return v+1<y.length&&y.charAt(v+1)===`
`?`\r
`:"\r";if(w===`
`)return`
`}return g&&g.eol||`
`}function b(g,y){return`\r
`.indexOf(g.charAt(y))!==-1}}),define(ye[149],Ee([1,0,43,148]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xn=S,e.$Yn=D,e.$Zn=I,e.$1n=P,e.$2n=b;function S(g,y,v){return D(g,y,void 0,v)}function D(g,y,v,w,m){const u=y.slice(),a=[],f=(0,o.$Kn)(g,a);let c,d;for(;u.length>0&&(d=u.pop(),c=(0,o.$Ln)(f,u),c===void 0&&v!==void 0);)typeof d=="string"?v={[d]:v}:v=[v];if(c)if(c.type==="object"&&typeof d=="string"&&Array.isArray(c.children)){const p=(0,o.$Ln)(c,[d]);if(p!==void 0)if(v===void 0){if(!p.parent)throw new Error("Malformed AST");const E=c.children.indexOf(p.parent);let h,t=p.parent.offset+p.parent.length;if(E>0){const s=c.children[E-1];h=s.offset+s.length}else h=c.offset+1,c.children.length>1&&(t=c.children[1].offset);return I(g,{offset:h,length:t-h,content:""},w)}else return I(g,{offset:p.offset,length:p.length,content:JSON.stringify(v)},w);else{if(v===void 0)return[];const E=`${JSON.stringify(d)}: ${JSON.stringify(v)}`,h=m?m(c.children.map(s=>s.children[0].value)):c.children.length;let t;if(h>0){const s=c.children[h-1];t={offset:s.offset+s.length,length:0,content:","+E}}else c.children.length===0?t={offset:c.offset+1,length:0,content:E}:t={offset:c.offset+1,length:0,content:E+","};return I(g,t,w)}}else if(c.type==="array"&&typeof d=="number"&&Array.isArray(c.children))if(v!==void 0){const p=`${JSON.stringify(v)}`;let E;if(c.children.length===0||d===0)E={offset:c.offset+1,length:0,content:c.children.length===0?p:p+","};else{const h=d===-1||d>c.children.length?c.children.length:d,t=c.children[h-1];E={offset:t.offset+t.length,length:0,content:","+p}}return I(g,E,w)}else{const p=d,E=c.children[p];let h;if(c.children.length===1)h={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===p){const t=c.children[p-1],s=t.offset+t.length,r=c.offset+c.length;h={offset:s,length:r-2-s,content:""}}else h={offset:E.offset,length:c.children[p+1].offset-E.offset,content:""};return I(g,h,w)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${c.type}`);else return v===void 0?[]:I(g,{offset:f?f.offset:0,length:f?f.length:0,content:JSON.stringify(v)},w)}function I(g,y,v){let w=P(g,y),m=y.offset,u=y.offset+y.content.length;if(y.length===0||y.content.length===0){for(;m>0&&!(0,C.$Wn)(w,m-1);)m--;for(;u<w.length&&!(0,C.$Wn)(w,u);)u++}const a=(0,C.$Tn)(w,{offset:m,length:u-m},v);for(let c=a.length-1;c>=0;c--){const d=a[c];w=P(w,d),m=Math.min(m,d.offset),u=Math.max(u,d.offset+d.length),u+=d.content.length-d.length}const f=g.length-(w.length-u)-m;return[{offset:m,length:f,content:w.substring(m,u)}]}function P(g,y){return g.substring(0,y.offset)+y.content+g.substring(y.offset+y.length)}function b(g,y){const v=y.slice(0).sort((m,u)=>{const a=m.offset-u.offset;return a===0?m.length-u.length:a});let w=g.length;for(let m=v.length-1;m>=0;m--){const u=v[m];if(u.offset+u.length<=w)g=P(g,u);else throw new Error("Overlapping edit");w=u.offset}return g}}),define(ye[60],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class o{constructor(S){this.d=S,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(S){this.c=S}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=o}),define(ye[98],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class o{static{this.Undefined=new o(void 0)}constructor(D){this.element=D,this.next=o.Undefined,this.prev=o.Undefined}}class C{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let D=this.a;for(;D!==o.Undefined;){const I=D.next;D.prev=o.Undefined,D.next=o.Undefined,D=I}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(D){return this.d(D,!1)}push(D){return this.d(D,!0)}d(D,I){const P=new o(D);if(this.a===o.Undefined)this.a=P,this.b=P;else if(I){const g=this.b;this.b=P,P.prev=g,g.next=P}else{const g=this.a;this.a=P,P.next=g,g.prev=P}this.c+=1;let b=!1;return()=>{b||(b=!0,this.e(P))}}shift(){if(this.a!==o.Undefined){const D=this.a.element;return this.e(this.a),D}}pop(){if(this.b!==o.Undefined){const D=this.b.element;return this.e(this.b),D}}e(D){if(D.prev!==o.Undefined&&D.next!==o.Undefined){const I=D.prev;I.next=D.next,D.next.prev=I}else D.prev===o.Undefined&&D.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):D.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):D.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let D=this.a;for(;D!==o.Undefined;)yield D.element,D=D.next}}e.$6c=C}),define(ye[24],Ee([1,0]),function(he,e){"use strict";var o,C,S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=D,e.$zc=I,e.$Ac=P,e.$Jc=E;function D(h,t,s){let r=h.get(t);return r===void 0&&(r=s,h.set(t,r)),r}function I(h){const t=[];return h.forEach((s,r)=>{t.push(`${r} => ${s}`)}),`Map(${h.size}) {${t.join(", ")}}`}function P(h){const t=[];return h.forEach(s=>{t.push(s)}),`Set(${h.size}) {${t.join(", ")}}`}class b{constructor(t,s){this.uri=t,this.value=s}}function g(h){return Array.isArray(h)}class y{static{this.c=t=>t.toString()}constructor(t,s){if(this[o]="ResourceMap",t instanceof y)this.d=new Map(t.d),this.e=s??y.c;else if(g(t)){this.d=new Map,this.e=s??y.c;for(const[r,i]of t)this.set(r,i)}else this.d=new Map,this.e=t??y.c}set(t,s){return this.d.set(this.e(t),new b(t,s)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,s){typeof s<"u"&&(t=t.bind(s));for(const[r,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=y;class v{constructor(t,s){this[C]="ResourceSet",!t||typeof t=="function"?this.c=new y(t):(this.c=new y(s),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,s){this.c.forEach((r,i)=>t.call(s,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=v;var w;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class m{constructor(){this[S]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,s=0){const r=this.c.get(t);if(r)return s!==0&&this.m(r,s),r.value}set(t,s,r=0){let i=this.c.get(t);if(i)i.value=s,r!==0&&this.m(i,r);else{switch(i={key:t,value:s,next:void 0,previous:void 0},r){case 0:this.k(i);break;case 1:this.j(i);break;case 2:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const s=this.c.get(t);if(s)return this.c.delete(t),this.l(s),this.f--,s.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,s){const r=this.g;let i=this.d;for(;i;){if(s?t.bind(s)(i.value,i.key,this):t(i.value,i.key,this),this.g!==r)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.key,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}values(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:r.value,done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}entries(){const t=this,s=this.g;let r=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==s)throw new Error("LinkedMap got modified during iteration.");if(r){const n={value:[r.key,r.value],done:!1};return r=r.next,n}else return{value:void 0,done:!0}}};return i}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.d,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.next,r--;this.d=s,this.f=r,s&&(s.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let s=this.e,r=this.size;for(;s&&r>t;)this.c.delete(s.key),s=s.previous,r--;this.e=s,this.f=r,s&&(s.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const s=t.next,r=t.previous;if(!s||!r)throw new Error("Invalid list");s.previous=r,r.next=s}t.next=void 0,t.previous=void 0,this.g++}m(t,s){if(!this.d||!this.e)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(t===this.d)return;const r=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(r.previous=i,i.next=r),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(s===2){if(t===this.e)return;const r=t.next,i=t.previous;t===this.d?(r.previous=void 0,this.d=r):(r.previous=i,i.next=r),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((s,r)=>{t.push([r,s])}),t}fromJSON(t){this.clear();for(const[s,r]of t)this.set(s,r)}}e.$Dc=m;class u extends m{constructor(t,s=1){super(),this.n=t,this.o=Math.min(Math.max(0,s),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,s=2){return super.get(t,s)}peek(t){return super.get(t,0)}set(t,s){return super.set(t,s,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class a extends u{constructor(t,s=1){super(t,s)}q(t){this.h(t)}set(t,s){return super.set(t,s),this.p(),this}}e.$Ec=a;class f extends u{constructor(t,s=1){super(t,s)}q(t){this.i(t)}set(t,s){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,s),this}}e.$Fc=f;class c{constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let s=this.c.get(t)||0;return s===0?!1:(s--,s===0?this.c.delete(t):this.c.set(t,s),!0)}has(t){return this.c.has(t)}}e.$Gc=c;class d{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[s,r]of t)this.set(s,r)}clear(){this.c.clear(),this.d.clear()}set(t,s){this.c.set(t,s),this.d.set(s,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const s=this.c.get(t);return s===void 0?!1:(this.c.delete(t),this.d.delete(s),!0)}forEach(t,s){this.c.forEach((r,i)=>{t.call(s,r,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=d;class p{constructor(){this.c=new Map}add(t,s){let r=this.c.get(t);r||(r=new Set,this.c.set(t,r)),r.add(s)}delete(t,s){const r=this.c.get(t);r&&(r.delete(s),r.size===0&&this.c.delete(t))}forEach(t,s){const r=this.c.get(t);r&&r.forEach(s)}get(t){const s=this.c.get(t);return s||new Set}}e.$Ic=p;function E(h,t){if(h===t)return!0;if(h.size!==t.size)return!1;for(const[s,r]of h)if(!t.has(s)||t.get(s)!==r)return!1;for(const[s]of t)if(!h.has(s))return!1;return!0}}),define(ye[2],Ee([1,0,18,146,24,75,41]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=y,e.$Mc=v,e.$Nc=w,e.$Oc=a,e.$Pc=f,e.$Qc=c,e.$Rc=d,e.$Sc=p,e.$Tc=E,e.$4c=j;const P=!1;let b=null;class g{constructor(){this.b=new Map}static{this.a=0}c(F){let V=this.b.get(F);return V||(V={parent:null,source:null,isSingleton:!1,value:F,idx:g.a++},this.b.set(F,V)),V}trackDisposable(F){const V=this.c(F);V.source||(V.source=new Error().stack)}setParent(F,V){const Z=this.c(F);Z.parent=V}markAsDisposed(F){this.b.delete(F)}markAsSingleton(F){this.c(F).isSingleton=!0}f(F,V){const Z=V.get(F);if(Z)return Z;const oe=F.parent?this.f(this.c(F.parent),V):F;return V.set(F,oe),oe}getTrackedDisposables(){const F=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,F).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(F=10,V){let Z;if(V)Z=V;else{const W=new Map,K=[...this.b.values()].filter(M=>M.source!==null&&!this.f(M,W).isSingleton);if(K.length===0)return;const Y=new Set(K.map(M=>M.value));if(Z=K.filter(M=>!(M.parent&&Y.has(M.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function oe(W){function K(M,Q){for(;M.length>0&&Q.some(ce=>typeof ce=="string"?ce===M[0]:M[0].match(ce));)M.shift()}const Y=W.source.split(`
`).map(M=>M.trim().replace("at ","")).filter(M=>M!=="");return K(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const le=new S.$Ic;for(const W of Z){const K=oe(W);for(let Y=0;Y<=K.length;Y++)le.add(K.slice(0,Y).join(`
`),W)}Z.sort((0,o.$7b)(W=>W.idx,o.$9b));let te="",_=0;for(const W of Z.slice(0,F)){_++;const K=oe(W),Y=[];for(let M=0;M<K.length;M++){let Q=K[M];Q=`(shared with ${le.get(K.slice(0,M+1).join(`
`)).size}/${Z.length} leaks) at ${Q}`;const ie=le.get(K.slice(0,M).join(`
`)),be=(0,C.$K)([...ie].map(re=>oe(re)[M]),re=>re);delete be[K[M]];for(const[re,X]of Object.entries(be))Y.unshift(`    - stacktraces of ${X.length} other leaks continue with ${re}`);Y.unshift(Q)}te+=`


==================== Leaking disposable ${_}/${Z.length}: ${W.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return Z.length>F&&(te+=`


... and ${Z.length-F} more leaking disposables

`),{leaks:Z,details:te}}}e.$Kc=g;function y(O){b=O}if(P){const O="__is_disposable_tracked__";y(new class{trackDisposable(F){const V=new Error("Potentially leaked disposable").stack;setTimeout(()=>{F[O]||console.log(V)},3e3)}setParent(F,V){if(F&&F!==t.None)try{F[O]=!0}catch{}}markAsDisposed(F){if(F&&F!==t.None)try{F[O]=!0}catch{}}markAsSingleton(F){}})}function v(O){return b?.trackDisposable(O),O}function w(O){b?.markAsDisposed(O)}function m(O,F){b?.setParent(O,F)}function u(O,F){if(b)for(const V of O)b.setParent(V,F)}function a(O){return b?.markAsSingleton(O),O}function f(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function c(O){if(I.Iterable.is(O)){const F=[];for(const V of O)if(V)try{V.dispose()}catch(Z){F.push(Z)}if(F.length===1)throw F[0];if(F.length>1)throw new AggregateError(F,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function d(O){for(const F of O)f(F)&&F.dispose();return[]}function p(...O){const F=E(()=>c(O));return u(O,F),F}function E(O){const F=v({dispose:(0,D.$db)(()=>{w(F),O()})});return F}class h{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,v(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(F){if(!F)return F;if(F===this)throw new Error("Cannot register a disposable on itself!");return m(F,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(F),F}delete(F){if(F){if(F===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(F),F.dispose()}}deleteAndLeak(F){F&&this.f.has(F)&&(this.f.delete(F),m(F,null))}}e.$Uc=h;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new h,v(this),m(this.q,this)}dispose(){w(this),this.q.dispose()}B(F){if(F===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(F)}}e.$Vc=t;class s{constructor(){this.b=!1,v(this)}get value(){return this.b?void 0:this.a}set value(F){this.b||F===this.a||(this.a?.dispose(),F&&m(F,this),this.a=F)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const F=this.a;return this.a=void 0,F&&m(F,null),F}}e.$Wc=s;class r{constructor(F){this.a=new s,this.b=!1,this.a.value=F}get value(){return this.a.value}set value(F){this.b||F===this.a.value||(this.a.value=F)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=r;class i{constructor(F){this.b=F,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,v(this)}set(F){let V=F;return this.unset=()=>V=void 0,this.isset=()=>V!==void 0,this.dispose=()=>{V&&(V(),V=void 0,w(this))},this}}e.$Zc=n;class l{constructor(){this.a=new Map}acquire(F,...V){let Z=this.a.get(F);Z||(Z={counter:0,object:this.b(F,...V)},this.a.set(F,Z));const{object:oe}=Z,le=(0,D.$db)(()=>{--Z.counter===0&&(this.c(F,Z.object),this.a.delete(F))});return Z.counter++,{object:oe,dispose:le}}}e.$1c=l;class ${constructor(F){this.a=F}async acquire(F,...V){const Z=this.a.acquire(F,...V);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(oe){throw Z.dispose(),oe}}}e.$2c=$;class k{constructor(F){this.object=F}dispose(){}}e.$3c=k;function j(O){const F=new h;try{O(F)}finally{F.dispose()}}class A{constructor(){this.a=new Map,this.b=!1,v(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(F){return this.a.has(F)}get size(){return this.a.size}get(F){return this.a.get(F)}set(F,V,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(F)?.dispose(),this.a.set(F,V)}deleteAndDispose(F){this.a.get(F)?.dispose(),this.a.delete(F)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=A}),function(he,e){typeof define=="function"&&define.amd?define(ye[150],Ee([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(he=typeof globalThis<"u"?globalThis:he||self,e(he.marked={}))}(this,function(he){"use strict";function e(x,G){for(var U=0;U<G.length;U++){var T=G[U];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(x,T.key,T)}}function o(x,G,U){return G&&e(x.prototype,G),U&&e(x,U),Object.defineProperty(x,"prototype",{writable:!1}),x}function C(x,G){if(x){if(typeof x=="string")return S(x,G);var U=Object.prototype.toString.call(x).slice(8,-1);if(U==="Object"&&x.constructor&&(U=x.constructor.name),U==="Map"||U==="Set")return Array.from(x);if(U==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(U))return S(x,G)}}function S(x,G){(G==null||G>x.length)&&(G=x.length);for(var U=0,T=new Array(G);U<G;U++)T[U]=x[U];return T}function D(x,G){var U=typeof Symbol<"u"&&x[Symbol.iterator]||x["@@iterator"];if(U)return(U=U.call(x)).next.bind(U);if(Array.isArray(x)||(U=C(x))||G&&x&&typeof x.length=="number"){U&&(x=U);var T=0;return function(){return T>=x.length?{done:!0}:{done:!1,value:x[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function I(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}he.defaults=I();function P(x){he.defaults=x}var b=/[&<>"']/,g=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,v=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},m=function(G){return w[G]};function u(x,G){if(G){if(b.test(x))return x.replace(g,m)}else if(y.test(x))return x.replace(v,m);return x}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(x){return x.replace(a,function(G,U){return U=U.toLowerCase(),U==="colon"?":":U.charAt(0)==="#"?U.charAt(1)==="x"?String.fromCharCode(parseInt(U.substring(2),16)):String.fromCharCode(+U.substring(1)):""})}var c=/(^|[^\[])\^/g;function d(x,G){x=typeof x=="string"?x:x.source,G=G||"";var U={replace:function(q,se){return se=se.source||se,se=se.replace(c,"$1"),x=x.replace(q,se),U},getRegex:function(){return new RegExp(x,G)}};return U}var p=/[^\w:]/g,E=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(x,G,U){if(x){var T;try{T=decodeURIComponent(f(U)).replace(p,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}G&&!E.test(U)&&(U=n(G,U));try{U=encodeURI(U).replace(/%25/g,"%")}catch{return null}return U}var t={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(x,G){t[" "+x]||(s.test(x)?t[" "+x]=x+"/":t[" "+x]=j(x,"/",!0)),x=t[" "+x];var U=x.indexOf(":")===-1;return G.substring(0,2)==="//"?U?G:x.replace(r,"$1")+G:G.charAt(0)==="/"?U?G:x.replace(i,"$1")+G:x+G}var l={exec:function(){}};function $(x){for(var G=1,U,T;G<arguments.length;G++){U=arguments[G];for(T in U)Object.prototype.hasOwnProperty.call(U,T)&&(x[T]=U[T])}return x}function k(x,G){var U=x.replace(/\|/g,function(se,ae,me){for(var ee=!1,ge=ae;--ge>=0&&me[ge]==="\\";)ee=!ee;return ee?"|":" |"}),T=U.split(/ \|/),q=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>G)T.splice(G);else for(;T.length<G;)T.push("");for(;q<T.length;q++)T[q]=T[q].trim().replace(/\\\|/g,"|");return T}function j(x,G,U){var T=x.length;if(T===0)return"";for(var q=0;q<T;){var se=x.charAt(T-q-1);if(se===G&&!U)q++;else if(se!==G&&U)q++;else break}return x.slice(0,T-q)}function A(x,G){if(x.indexOf(G[1])===-1)return-1;for(var U=x.length,T=0,q=0;q<U;q++)if(x[q]==="\\")q++;else if(x[q]===G[0])T++;else if(x[q]===G[1]&&(T--,T<0))return q;return-1}function O(x){x&&x.sanitize&&!x.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(x,G){if(G<1)return"";for(var U="";G>1;)G&1&&(U+=x),G>>=1,x+=x;return U+x}function V(x,G,U,T){var q=G.href,se=G.title?u(G.title):null,ae=x[1].replace(/\\([\[\]])/g,"$1");if(x[0].charAt(0)!=="!"){T.state.inLink=!0;var me={type:"link",raw:U,href:q,title:se,text:ae,tokens:T.inlineTokens(ae)};return T.state.inLink=!1,me}return{type:"image",raw:U,href:q,title:se,text:u(ae)}}function Z(x,G){var U=x.match(/^(\s+)(?:```)/);if(U===null)return G;var T=U[1];return G.split(`
`).map(function(q){var se=q.match(/^\s+/);if(se===null)return q;var ae=se[0];return ae.length>=T.length?q.slice(T.length):q}).join(`
`)}var oe=function(){function x(U){this.options=U||he.defaults}var G=x.prototype;return G.space=function(T){var q=this.rules.block.newline.exec(T);if(q&&q[0].length>0)return{type:"space",raw:q[0]}},G.code=function(T){var q=this.rules.block.code.exec(T);if(q){var se=q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:q[0],codeBlockStyle:"indented",text:this.options.pedantic?se:j(se,`
`)}}},G.fences=function(T){var q=this.rules.block.fences.exec(T);if(q){var se=q[0],ae=Z(se,q[3]||"");return{type:"code",raw:se,lang:q[2]?q[2].trim():q[2],text:ae}}},G.heading=function(T){var q=this.rules.block.heading.exec(T);if(q){var se=q[2].trim();if(/#$/.test(se)){var ae=j(se,"#");(this.options.pedantic||!ae||/ $/.test(ae))&&(se=ae.trim())}return{type:"heading",raw:q[0],depth:q[1].length,text:se,tokens:this.lexer.inline(se)}}},G.hr=function(T){var q=this.rules.block.hr.exec(T);if(q)return{type:"hr",raw:q[0]}},G.blockquote=function(T){var q=this.rules.block.blockquote.exec(T);if(q){var se=q[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:q[0],tokens:this.lexer.blockTokens(se,[]),text:se}}},G.list=function(T){var q=this.rules.block.list.exec(T);if(q){var se,ae,me,ee,ge,$e,Ce,je,de,Pe,De,Me,Fe=q[1].trim(),Ue=Fe.length>1,Ve={type:"list",raw:"",ordered:Ue,start:Ue?+Fe.slice(0,-1):"",loose:!1,items:[]};Fe=Ue?"\\d{1,9}\\"+Fe.slice(-1):"\\"+Fe,this.options.pedantic&&(Fe=Ue?Fe:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+Fe+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Me=!1,!(!(q=Ge.exec(T))||this.rules.block.hr.test(T)));){if(se=q[0],T=T.substring(se.length),je=q[2].split(`
`,1)[0],de=T.split(`
`,1)[0],this.options.pedantic?(ee=2,De=je.trimLeft()):(ee=q[2].search(/[^ ]/),ee=ee>4?1:ee,De=je.slice(ee),ee+=q[1].length),$e=!1,!je&&/^ *$/.test(de)&&(se+=de+`
`,T=T.substring(de.length+1),Me=!0),!Me)for(var Ze=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,ee-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,ee-1)+"}(?:```|~~~)"),xe=new RegExp("^ {0,"+Math.min(3,ee-1)+"}#");T&&(Pe=T.split(`
`,1)[0],je=Pe,this.options.pedantic&&(je=je.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(je)||xe.test(je)||Ze.test(je)||_e.test(T)));){if(je.search(/[^ ]/)>=ee||!je.trim())De+=`
`+je.slice(ee);else if(!$e)De+=`
`+je;else break;!$e&&!je.trim()&&($e=!0),se+=Pe+`
`,T=T.substring(Pe.length+1)}Ve.loose||(Ce?Ve.loose=!0:/\n *\n *$/.test(se)&&(Ce=!0)),this.options.gfm&&(ae=/^\[[ xX]\] /.exec(De),ae&&(me=ae[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:se,task:!!ae,checked:me,loose:!1,text:De}),Ve.raw+=se}Ve.items[Ve.items.length-1].raw=se.trimRight(),Ve.items[Ve.items.length-1].text=De.trimRight(),Ve.raw=Ve.raw.trimRight();var pe=Ve.items.length;for(ge=0;ge<pe;ge++){this.lexer.state.top=!1,Ve.items[ge].tokens=this.lexer.blockTokens(Ve.items[ge].text,[]);var Ie=Ve.items[ge].tokens.filter(function(Ae){return Ae.type==="space"}),Re=Ie.every(function(Ae){for(var Te=Ae.raw.split(""),Qe=0,He=D(Te),Je;!(Je=He()).done;){var it=Je.value;if(it===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Ve.loose&&Ie.length&&Re&&(Ve.loose=!0,Ve.items[ge].loose=!0)}return Ve}},G.html=function(T){var q=this.rules.block.html.exec(T);if(q){var se={type:"html",raw:q[0],pre:!this.options.sanitizer&&(q[1]==="pre"||q[1]==="script"||q[1]==="style"),text:q[0]};if(this.options.sanitize){var ae=this.options.sanitizer?this.options.sanitizer(q[0]):u(q[0]);se.type="paragraph",se.text=ae,se.tokens=this.lexer.inline(ae)}return se}},G.def=function(T){var q=this.rules.block.def.exec(T);if(q){q[3]&&(q[3]=q[3].substring(1,q[3].length-1));var se=q[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:se,raw:q[0],href:q[2],title:q[3]}}},G.table=function(T){var q=this.rules.block.table.exec(T);if(q){var se={type:"table",header:k(q[1]).map(function(Ce){return{text:Ce}}),align:q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:q[3]&&q[3].trim()?q[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(se.header.length===se.align.length){se.raw=q[0];var ae=se.align.length,me,ee,ge,$e;for(me=0;me<ae;me++)/^ *-+: *$/.test(se.align[me])?se.align[me]="right":/^ *:-+: *$/.test(se.align[me])?se.align[me]="center":/^ *:-+ *$/.test(se.align[me])?se.align[me]="left":se.align[me]=null;for(ae=se.rows.length,me=0;me<ae;me++)se.rows[me]=k(se.rows[me],se.header.length).map(function(Ce){return{text:Ce}});for(ae=se.header.length,ee=0;ee<ae;ee++)se.header[ee].tokens=this.lexer.inline(se.header[ee].text);for(ae=se.rows.length,ee=0;ee<ae;ee++)for($e=se.rows[ee],ge=0;ge<$e.length;ge++)$e[ge].tokens=this.lexer.inline($e[ge].text);return se}}},G.lheading=function(T){var q=this.rules.block.lheading.exec(T);if(q)return{type:"heading",raw:q[0],depth:q[2].charAt(0)==="="?1:2,text:q[1],tokens:this.lexer.inline(q[1])}},G.paragraph=function(T){var q=this.rules.block.paragraph.exec(T);if(q){var se=q[1].charAt(q[1].length-1)===`
`?q[1].slice(0,-1):q[1];return{type:"paragraph",raw:q[0],text:se,tokens:this.lexer.inline(se)}}},G.text=function(T){var q=this.rules.block.text.exec(T);if(q)return{type:"text",raw:q[0],text:q[0],tokens:this.lexer.inline(q[0])}},G.escape=function(T){var q=this.rules.inline.escape.exec(T);if(q)return{type:"escape",raw:q[0],text:u(q[1])}},G.tag=function(T){var q=this.rules.inline.tag.exec(T);if(q)return!this.lexer.state.inLink&&/^<a /i.test(q[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(q[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(q[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(q[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:q[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(q[0]):u(q[0]):q[0]}},G.link=function(T){var q=this.rules.inline.link.exec(T);if(q){var se=q[2].trim();if(!this.options.pedantic&&/^</.test(se)){if(!/>$/.test(se))return;var ae=j(se.slice(0,-1),"\\");if((se.length-ae.length)%2===0)return}else{var me=A(q[2],"()");if(me>-1){var ee=q[0].indexOf("!")===0?5:4,ge=ee+q[1].length+me;q[2]=q[2].substring(0,me),q[0]=q[0].substring(0,ge).trim(),q[3]=""}}var $e=q[2],Ce="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec($e);je&&($e=je[1],Ce=je[3])}else Ce=q[3]?q[3].slice(1,-1):"";return $e=$e.trim(),/^</.test($e)&&(this.options.pedantic&&!/>$/.test(se)?$e=$e.slice(1):$e=$e.slice(1,-1)),V(q,{href:$e&&$e.replace(this.rules.inline._escapes,"$1"),title:Ce&&Ce.replace(this.rules.inline._escapes,"$1")},q[0],this.lexer)}},G.reflink=function(T,q){var se;if((se=this.rules.inline.reflink.exec(T))||(se=this.rules.inline.nolink.exec(T))){var ae=(se[2]||se[1]).replace(/\s+/g," ");if(ae=q[ae.toLowerCase()],!ae||!ae.href){var me=se[0].charAt(0);return{type:"text",raw:me,text:me}}return V(se,ae,se[0],this.lexer)}},G.emStrong=function(T,q,se){se===void 0&&(se="");var ae=this.rules.inline.emStrong.lDelim.exec(T);if(ae&&!(ae[3]&&se.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var me=ae[1]||ae[2]||"";if(!me||me&&(se===""||this.rules.inline.punctuation.exec(se))){var ee=ae[0].length-1,ge,$e,Ce=ee,je=0,de=ae[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(de.lastIndex=0,q=q.slice(-1*T.length+ee);(ae=de.exec(q))!=null;)if(ge=ae[1]||ae[2]||ae[3]||ae[4]||ae[5]||ae[6],!!ge){if($e=ge.length,ae[3]||ae[4]){Ce+=$e;continue}else if((ae[5]||ae[6])&&ee%3&&!((ee+$e)%3)){je+=$e;continue}if(Ce-=$e,!(Ce>0)){if($e=Math.min($e,$e+Ce+je),Math.min(ee,$e)%2){var Pe=T.slice(1,ee+ae.index+$e);return{type:"em",raw:T.slice(0,ee+ae.index+$e+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}var De=T.slice(2,ee+ae.index+$e-1);return{type:"strong",raw:T.slice(0,ee+ae.index+$e+1),text:De,tokens:this.lexer.inlineTokens(De)}}}}}},G.codespan=function(T){var q=this.rules.inline.code.exec(T);if(q){var se=q[2].replace(/\n/g," "),ae=/[^ ]/.test(se),me=/^ /.test(se)&&/ $/.test(se);return ae&&me&&(se=se.substring(1,se.length-1)),se=u(se,!0),{type:"codespan",raw:q[0],text:se}}},G.br=function(T){var q=this.rules.inline.br.exec(T);if(q)return{type:"br",raw:q[0]}},G.del=function(T){var q=this.rules.inline.del.exec(T);if(q)return{type:"del",raw:q[0],text:q[2],tokens:this.lexer.inlineTokens(q[2])}},G.autolink=function(T,q){var se=this.rules.inline.autolink.exec(T);if(se){var ae,me;return se[2]==="@"?(ae=u(this.options.mangle?q(se[1]):se[1]),me="mailto:"+ae):(ae=u(se[1]),me=ae),{type:"link",raw:se[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},G.url=function(T,q){var se;if(se=this.rules.inline.url.exec(T)){var ae,me;if(se[2]==="@")ae=u(this.options.mangle?q(se[0]):se[0]),me="mailto:"+ae;else{var ee;do ee=se[0],se[0]=this.rules.inline._backpedal.exec(se[0])[0];while(ee!==se[0]);ae=u(se[0]),se[1]==="www."?me="http://"+ae:me=ae}return{type:"link",raw:se[0],text:ae,href:me,tokens:[{type:"text",raw:ae,text:ae}]}}},G.inlineText=function(T,q){var se=this.rules.inline.text.exec(T);if(se){var ae;return this.lexer.state.inRawBlock?ae=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(se[0]):u(se[0]):se[0]:ae=u(this.options.smartypants?q(se[0]):se[0]),{type:"text",raw:se[0],text:ae}}},x}(),le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=d(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=d(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=d(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=d(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=d(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=d(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=$({},le),le.gfm=$({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=d(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.gfm.paragraph=d(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",le.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=$({},le.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:d(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=d(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=d(le._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=d(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=d(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=d(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=d(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=d(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=d(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=d(te.reflink).replace("label",te._label).replace("ref",le._label).getRegex(),te.nolink=d(te.nolink).replace("ref",le._label).getRegex(),te.reflinkSearch=d(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=$({},te),te.pedantic=$({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=$({},te.normal,{escape:d(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=d(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=$({},te.gfm,{br:d(te.br).replace("{2,}","*").getRegex(),text:d(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function _(x){return x.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(x){var G="",U,T,q=x.length;for(U=0;U<q;U++)T=x.charCodeAt(U),Math.random()>.5&&(T="x"+T.toString(16)),G+="&#"+T+";";return G}var K=function(){function x(U){this.tokens=[],this.tokens.links=Object.create(null),this.options=U||he.defaults,this.options.tokenizer=this.options.tokenizer||new oe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:le.normal,inline:te.normal};this.options.pedantic?(T.block=le.pedantic,T.inline=te.pedantic):this.options.gfm&&(T.block=le.gfm,this.options.breaks?T.inline=te.breaks:T.inline=te.gfm),this.tokenizer.rules=T}x.lex=function(T,q){var se=new x(q);return se.lex(T)},x.lexInline=function(T,q){var se=new x(q);return se.inlineTokens(T)};var G=x.prototype;return G.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var q;q=this.inlineQueue.shift();)this.inlineTokens(q.src,q.tokens);return this.tokens},G.blockTokens=function(T,q){var se=this;q===void 0&&(q=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(Ce,je,de){return je+"    ".repeat(de.length)});for(var ae,me,ee,ge;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ce){return(ae=Ce.call({lexer:se},T,q))?(T=T.substring(ae.raw.length),q.push(ae),!0):!1}))){if(ae=this.tokenizer.space(T)){T=T.substring(ae.raw.length),ae.raw.length===1&&q.length>0?q[q.length-1].raw+=`
`:q.push(ae);continue}if(ae=this.tokenizer.code(T)){T=T.substring(ae.raw.length),me=q[q.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue[this.inlineQueue.length-1].src=me.text):q.push(ae);continue}if(ae=this.tokenizer.fences(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.heading(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.hr(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.blockquote(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.list(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.html(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.def(T)){T=T.substring(ae.raw.length),me=q[q.length-1],me&&(me.type==="paragraph"||me.type==="text")?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.raw,this.inlineQueue[this.inlineQueue.length-1].src=me.text):this.tokens.links[ae.tag]||(this.tokens.links[ae.tag]={href:ae.href,title:ae.title});continue}if(ae=this.tokenizer.table(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.lheading(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ee=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ce=1/0,je=T.slice(1),de=void 0;se.options.extensions.startBlock.forEach(function(Pe){de=Pe.call({lexer:this},je),typeof de=="number"&&de>=0&&(Ce=Math.min(Ce,de))}),Ce<1/0&&Ce>=0&&(ee=T.substring(0,Ce+1))}(),this.state.top&&(ae=this.tokenizer.paragraph(ee))){me=q[q.length-1],ge&&me.type==="paragraph"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):q.push(ae),ge=ee.length!==T.length,T=T.substring(ae.raw.length);continue}if(ae=this.tokenizer.text(T)){T=T.substring(ae.raw.length),me=q[q.length-1],me&&me.type==="text"?(me.raw+=`
`+ae.raw,me.text+=`
`+ae.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=me.text):q.push(ae);continue}if(T){var $e="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error($e);break}else throw new Error($e)}}return this.state.top=!0,q},G.inline=function(T,q){return q===void 0&&(q=[]),this.inlineQueue.push({src:T,tokens:q}),q},G.inlineTokens=function(T,q){var se=this;q===void 0&&(q=[]);var ae,me,ee,ge=T,$e,Ce,je;if(this.tokens.links){var de=Object.keys(this.tokens.links);if(de.length>0)for(;($e=this.tokenizer.rules.inline.reflinkSearch.exec(ge))!=null;)de.includes($e[0].slice($e[0].lastIndexOf("[")+1,-1))&&(ge=ge.slice(0,$e.index)+"["+F("a",$e[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;($e=this.tokenizer.rules.inline.blockSkip.exec(ge))!=null;)ge=ge.slice(0,$e.index)+"["+F("a",$e[0].length-2)+"]"+ge.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;($e=this.tokenizer.rules.inline.escapedEmSt.exec(ge))!=null;)ge=ge.slice(0,$e.index)+"++"+ge.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(Ce||(je=""),Ce=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(ae=De.call({lexer:se},T,q))?(T=T.substring(ae.raw.length),q.push(ae),!0):!1}))){if(ae=this.tokenizer.escape(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.tag(T)){T=T.substring(ae.raw.length),me=q[q.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):q.push(ae);continue}if(ae=this.tokenizer.link(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(ae.raw.length),me=q[q.length-1],me&&ae.type==="text"&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):q.push(ae);continue}if(ae=this.tokenizer.emStrong(T,ge,je)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.codespan(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.br(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.del(T)){T=T.substring(ae.raw.length),q.push(ae);continue}if(ae=this.tokenizer.autolink(T,W)){T=T.substring(ae.raw.length),q.push(ae);continue}if(!this.state.inLink&&(ae=this.tokenizer.url(T,W))){T=T.substring(ae.raw.length),q.push(ae);continue}if(ee=T,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Me=T.slice(1),Fe=void 0;se.options.extensions.startInline.forEach(function(Ue){Fe=Ue.call({lexer:this},Me),typeof Fe=="number"&&Fe>=0&&(De=Math.min(De,Fe))}),De<1/0&&De>=0&&(ee=T.substring(0,De+1))}(),ae=this.tokenizer.inlineText(ee,_)){T=T.substring(ae.raw.length),ae.raw.slice(-1)!=="_"&&(je=ae.raw.slice(-1)),Ce=!0,me=q[q.length-1],me&&me.type==="text"?(me.raw+=ae.raw,me.text+=ae.text):q.push(ae);continue}if(T){var Pe="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(Pe);break}else throw new Error(Pe)}}return q},o(x,null,[{key:"rules",get:function(){return{block:le,inline:te}}}]),x}(),Y=function(){function x(U){this.options=U||he.defaults}var G=x.prototype;return G.code=function(T,q,se){var ae=(q||"").match(/\S*/)[0];if(this.options.highlight){var me=this.options.highlight(T,ae);me!=null&&me!==T&&(se=!0,T=me)}return T=T.replace(/\n$/,"")+`
`,ae?'<pre><code class="'+this.options.langPrefix+u(ae,!0)+'">'+(se?T:u(T,!0))+`</code></pre>
`:"<pre><code>"+(se?T:u(T,!0))+`</code></pre>
`},G.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},G.html=function(T){return T},G.heading=function(T,q,se,ae){if(this.options.headerIds){var me=this.options.headerPrefix+ae.slug(se);return"<h"+q+' id="'+me+'">'+T+"</h"+q+`>
`}return"<h"+q+">"+T+"</h"+q+`>
`},G.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},G.list=function(T,q,se){var ae=q?"ol":"ul",me=q&&se!==1?' start="'+se+'"':"";return"<"+ae+me+`>
`+T+"</"+ae+`>
`},G.listitem=function(T){return"<li>"+T+`</li>
`},G.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},G.paragraph=function(T){return"<p>"+T+`</p>
`},G.table=function(T,q){return q&&(q="<tbody>"+q+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+q+`</table>
`},G.tablerow=function(T){return`<tr>
`+T+`</tr>
`},G.tablecell=function(T,q){var se=q.header?"th":"td",ae=q.align?"<"+se+' align="'+q.align+'">':"<"+se+">";return ae+T+("</"+se+`>
`)},G.strong=function(T){return"<strong>"+T+"</strong>"},G.em=function(T){return"<em>"+T+"</em>"},G.codespan=function(T){return"<code>"+T+"</code>"},G.br=function(){return this.options.xhtml?"<br/>":"<br>"},G.del=function(T){return"<del>"+T+"</del>"},G.link=function(T,q,se){if(T=h(this.options.sanitize,this.options.baseUrl,T),T===null)return se;var ae='<a href="'+u(T)+'"';return q&&(ae+=' title="'+q+'"'),ae+=">"+se+"</a>",ae},G.image=function(T,q,se){if(T=h(this.options.sanitize,this.options.baseUrl,T),T===null)return se;var ae='<img src="'+T+'" alt="'+se+'"';return q&&(ae+=' title="'+q+'"'),ae+=this.options.xhtml?"/>":">",ae},G.text=function(T){return T},x}(),M=function(){function x(){}var G=x.prototype;return G.strong=function(T){return T},G.em=function(T){return T},G.codespan=function(T){return T},G.del=function(T){return T},G.html=function(T){return T},G.text=function(T){return T},G.link=function(T,q,se){return""+se},G.image=function(T,q,se){return""+se},G.br=function(){return""},x}(),Q=function(){function x(){this.seen={}}var G=x.prototype;return G.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},G.getNextSafeSlug=function(T,q){var se=T,ae=0;if(this.seen.hasOwnProperty(se)){ae=this.seen[T];do ae++,se=T+"-"+ae;while(this.seen.hasOwnProperty(se))}return q||(this.seen[T]=ae,this.seen[se]=0),se},G.slug=function(T,q){q===void 0&&(q={});var se=this.serialize(T);return this.getNextSafeSlug(se,q.dryrun)},x}(),ce=function(){function x(U){this.options=U||he.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new M,this.slugger=new Q}x.parse=function(T,q){var se=new x(q);return se.parse(T)},x.parseInline=function(T,q){var se=new x(q);return se.parseInline(T)};var G=x.prototype;return G.parse=function(T,q){q===void 0&&(q=!0);var se="",ae,me,ee,ge,$e,Ce,je,de,Pe,De,Me,Fe,Ue,Ve,Ge,Ze,_e,et,xe,pe=T.length;for(ae=0;ae<pe;ae++){if(De=T[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(xe=this.options.extensions.renderers[De.type].call({parser:this},De),xe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){se+=xe||"";continue}switch(De.type){case"space":continue;case"hr":{se+=this.renderer.hr();continue}case"heading":{se+=this.renderer.heading(this.parseInline(De.tokens),De.depth,f(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{se+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(de="",je="",ge=De.header.length,me=0;me<ge;me++)je+=this.renderer.tablecell(this.parseInline(De.header[me].tokens),{header:!0,align:De.align[me]});for(de+=this.renderer.tablerow(je),Pe="",ge=De.rows.length,me=0;me<ge;me++){for(Ce=De.rows[me],je="",$e=Ce.length,ee=0;ee<$e;ee++)je+=this.renderer.tablecell(this.parseInline(Ce[ee].tokens),{header:!1,align:De.align[ee]});Pe+=this.renderer.tablerow(je)}se+=this.renderer.table(de,Pe);continue}case"blockquote":{Pe=this.parse(De.tokens),se+=this.renderer.blockquote(Pe);continue}case"list":{for(Me=De.ordered,Fe=De.start,Ue=De.loose,ge=De.items.length,Pe="",me=0;me<ge;me++)Ge=De.items[me],Ze=Ge.checked,_e=Ge.task,Ve="",Ge.task&&(et=this.renderer.checkbox(Ze),Ue?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=et+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=et+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:et}):Ve+=et),Ve+=this.parse(Ge.tokens,Ue),Pe+=this.renderer.listitem(Ve,_e,Ze);se+=this.renderer.list(Pe,Me,Fe);continue}case"html":{se+=this.renderer.html(De.text);continue}case"paragraph":{se+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Pe=De.tokens?this.parseInline(De.tokens):De.text;ae+1<pe&&T[ae+1].type==="text";)De=T[++ae],Pe+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);se+=q?this.renderer.paragraph(Pe):Pe;continue}default:{var Ie='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return se},G.parseInline=function(T,q){q=q||this.renderer;var se="",ae,me,ee,ge=T.length;for(ae=0;ae<ge;ae++){if(me=T[ae],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[me.type]&&(ee=this.options.extensions.renderers[me.type].call({parser:this},me),ee!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(me.type))){se+=ee||"";continue}switch(me.type){case"escape":{se+=q.text(me.text);break}case"html":{se+=q.html(me.text);break}case"link":{se+=q.link(me.href,me.title,this.parseInline(me.tokens,q));break}case"image":{se+=q.image(me.href,me.title,me.text);break}case"strong":{se+=q.strong(this.parseInline(me.tokens,q));break}case"em":{se+=q.em(this.parseInline(me.tokens,q));break}case"codespan":{se+=q.codespan(me.text);break}case"br":{se+=q.br();break}case"del":{se+=q.del(this.parseInline(me.tokens,q));break}case"text":{se+=q.text(me.text);break}default:{var $e='Token with "'+me.type+'" type was not found.';if(this.options.silent){console.error($e);return}else throw new Error($e)}}}return se},x}();function ie(x,G,U){if(typeof x>"u"||x===null)throw new Error("marked(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");if(typeof G=="function"&&(U=G,G=null),G=$({},ie.defaults,G||{}),O(G),U){var T=G.highlight,q;try{q=K.lex(x,G)}catch(ge){return U(ge)}var se=function($e){var Ce;if(!$e)try{G.walkTokens&&ie.walkTokens(q,G.walkTokens),Ce=ce.parse(q,G)}catch(je){$e=je}return G.highlight=T,$e?U($e):U(null,Ce)};if(!T||T.length<3||(delete G.highlight,!q.length))return se();var ae=0;ie.walkTokens(q,function(ge){ge.type==="code"&&(ae++,setTimeout(function(){T(ge.text,ge.lang,function($e,Ce){if($e)return se($e);Ce!=null&&Ce!==ge.text&&(ge.text=Ce,ge.escaped=!0),ae--,ae===0&&se()})},0))}),ae===0&&se();return}function me(ge){if(ge.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+u(ge.message+"",!0)+"</pre>";throw ge}try{var ee=K.lex(x,G);if(G.walkTokens){if(G.async)return Promise.all(ie.walkTokens(ee,G.walkTokens)).then(function(){return ce.parse(ee,G)}).catch(me);ie.walkTokens(ee,G.walkTokens)}return ce.parse(ee,G)}catch(ge){me(ge)}}ie.options=ie.setOptions=function(x){return $(ie.defaults,x),P(ie.defaults),ie},ie.getDefaults=I,ie.defaults=he.defaults,ie.use=function(){for(var x=arguments.length,G=new Array(x),U=0;U<x;U++)G[U]=arguments[U];var T=$.apply(void 0,[{}].concat(G)),q=ie.defaults.extensions||{renderers:{},childTokens:{}},se;G.forEach(function(ae){if(ae.extensions&&(se=!0,ae.extensions.forEach(function(ee){if(!ee.name)throw new Error("extension name required");if(ee.renderer){var ge=q.renderers?q.renderers[ee.name]:null;ge?q.renderers[ee.name]=function(){for(var $e=arguments.length,Ce=new Array($e),je=0;je<$e;je++)Ce[je]=arguments[je];var de=ee.renderer.apply(this,Ce);return de===!1&&(de=ge.apply(this,Ce)),de}:q.renderers[ee.name]=ee.renderer}if(ee.tokenizer){if(!ee.level||ee.level!=="block"&&ee.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");q[ee.level]?q[ee.level].unshift(ee.tokenizer):q[ee.level]=[ee.tokenizer],ee.start&&(ee.level==="block"?q.startBlock?q.startBlock.push(ee.start):q.startBlock=[ee.start]:ee.level==="inline"&&(q.startInline?q.startInline.push(ee.start):q.startInline=[ee.start]))}ee.childTokens&&(q.childTokens[ee.name]=ee.childTokens)})),ae.renderer&&function(){var ee=ie.defaults.renderer||new Y,ge=function(je){var de=ee[je];ee[je]=function(){for(var Pe=arguments.length,De=new Array(Pe),Me=0;Me<Pe;Me++)De[Me]=arguments[Me];var Fe=ae.renderer[je].apply(ee,De);return Fe===!1&&(Fe=de.apply(ee,De)),Fe}};for(var $e in ae.renderer)ge($e);T.renderer=ee}(),ae.tokenizer&&function(){var ee=ie.defaults.tokenizer||new oe,ge=function(je){var de=ee[je];ee[je]=function(){for(var Pe=arguments.length,De=new Array(Pe),Me=0;Me<Pe;Me++)De[Me]=arguments[Me];var Fe=ae.tokenizer[je].apply(ee,De);return Fe===!1&&(Fe=de.apply(ee,De)),Fe}};for(var $e in ae.tokenizer)ge($e);T.tokenizer=ee}(),ae.walkTokens){var me=ie.defaults.walkTokens;T.walkTokens=function(ee){var ge=[];return ge.push(ae.walkTokens.call(this,ee)),me&&(ge=ge.concat(me.call(this,ee))),ge}}se&&(T.extensions=q),ie.setOptions(T)})},ie.walkTokens=function(x,G){for(var U=[],T=function(){var me=se.value;switch(U=U.concat(G.call(ie,me)),me.type){case"table":{for(var ee=D(me.header),ge;!(ge=ee()).done;){var $e=ge.value;U=U.concat(ie.walkTokens($e.tokens,G))}for(var Ce=D(me.rows),je;!(je=Ce()).done;)for(var de=je.value,Pe=D(de),De;!(De=Pe()).done;){var Me=De.value;U=U.concat(ie.walkTokens(Me.tokens,G))}break}case"list":{U=U.concat(ie.walkTokens(me.items,G));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[me.type]?ie.defaults.extensions.childTokens[me.type].forEach(function(Fe){U=U.concat(ie.walkTokens(me[Fe],G))}):me.tokens&&(U=U.concat(ie.walkTokens(me.tokens,G)))}},q=D(x),se;!(se=q()).done;)T();return U},ie.parseInline=function(x,G){if(typeof x>"u"||x===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof x!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(x)+", string expected");G=$({},ie.defaults,G||{}),O(G);try{var U=K.lexInline(x,G);return G.walkTokens&&ie.walkTokens(U,G.walkTokens),ce.parseInline(U,G)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,G.silent)return"<p>An error occurred:</p><pre>"+u(T.message+"",!0)+"</pre>";throw T}},ie.Parser=ce,ie.parser=ce.parse,ie.Renderer=Y,ie.TextRenderer=M,ie.Lexer=K,ie.lexer=K.lex,ie.Tokenizer=oe,ie.Slugger=Q,ie.parse=ie;var be=ie.options,re=ie.setOptions,X=ie.use,B=ie.walkTokens,N=ie.parseInline,z=ie,J=ce.parse,ue=K.lex;he.Lexer=K,he.Parser=ce,he.Renderer=Y,he.Slugger=Q,he.TextRenderer=M,he.Tokenizer=oe,he.getDefaults=I,he.lexer=ue,he.marked=ie,he.options=be,he.parse=z,he.parseInline=N,he.parser=J,he.setOptions=re,he.use=X,he.walkTokens=B,Object.defineProperty(he,"__esModule",{value:!0})}),define(ye[151],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vk=o;function o(a){const f=D(a);if(f&&f.length>0)return new Uint32Array(f)}let C=0;const S=new Uint32Array(10);function D(a){if(C=0,I(a,v,4352),C>0||(I(a,w,4449),C>0)||(I(a,m,4520),C>0)||(I(a,u,12593),C))return S.subarray(0,C);if(a>=44032&&a<=55203){const f=a-44032,c=f%588,d=Math.floor(f/588),p=Math.floor(c/28),E=c%28-1;if(d<v.length?I(d,v,0):4352+d-12593<u.length&&I(4352+d,u,12593),p<w.length?I(p,w,0):4449+p-12593<u.length&&I(4449+p-12593,u,12593),E>=0&&(E<m.length?I(E,m,0):4520+E-12593<u.length&&I(4520+E-12593,u,12593)),C>0)return S.subarray(0,C)}}function I(a,f,c){a>=c&&a<c+f.length&&P(f[a-c])}function P(a){a!==0&&(S[C++]=a&255,a>>8&&(S[C++]=a>>8&255),a>>16&&(S[C++]=a>>16&255))}var b;(function(a){a[a.InitialConsonant=4352]="InitialConsonant",a[a.Vowel=4449]="Vowel",a[a.FinalConsonant=4520]="FinalConsonant",a[a.CompatibilityJamo=12593]="CompatibilityJamo"})(b||(b={}));var g;(function(a){a[a.NUL=0]="NUL",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z"})(g||(g={}));var y;(function(a){a[a.fa=24934]="fa",a[a.fg=26470]="fg",a[a.fq=29030]="fq",a[a.fr=29286]="fr",a[a.ft=29798]="ft",a[a.fv=30310]="fv",a[a.fx=30822]="fx",a[a.hk=27496]="hk",a[a.hl=27752]="hl",a[a.ho=28520]="ho",a[a.ml=27757]="ml",a[a.nj=27246]="nj",a[a.nl=27758]="nl",a[a.np=28782]="np",a[a.qt=29809]="qt",a[a.rt=29810]="rt",a[a.sg=26483]="sg",a[a.sw=30579]="sw"})(y||(y={}));const v=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),m=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),u=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ye[99],Ee([1,0,24]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dm=void 0,e.$bm=S,e.$cm=I;const C=new o.$Ec(1e4);function S(g){return b(g,"NFC",C)}const D=new o.$Ec(1e4);function I(g){return b(g,"NFD",D)}const P=/[^\u0000-\u0080]/;function b(g,y,v){if(!g)return g;const w=v.get(g);if(w)return w;let m;return P.test(g)?m=g.normalize(y):m=g,v.set(g,m),m}e.$dm=function(){const g=/[\u0300-\u036f]/g;return function(y){return I(y).replace(g,"")}}()}),define(ye[152],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=e.$Em=e.$Dm=void 0,e.$Bm=o,e.rot=C;function o(P,b,g){return Math.min(Math.max(P,b),g)}function C(P,b){return(b+P%b)%b}class S{constructor(){this.a=0}getNext(){return this.a++}}e.$Dm=S;class D{constructor(){this.a=1,this.b=0}update(b){return this.b=this.b+(b-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Em=D;class I{constructor(b){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(b),this.c.fill(0,0,b)}update(b){const g=this.c[this.d];return this.c[this.d]=b,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=b,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Fm=I}),define(ye[153],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bd=void 0,e.$cd=D,e.$dd=w;class o{constructor(u,a,f){this.owner=u,this.debugNameSource=a,this.referenceFn=f}getDebugName(u){return D(u,this)}}e.$bd=o;const C=new Map,S=new WeakMap;function D(m,u){const a=S.get(m);if(a)return a;const f=I(m,u);if(f){let c=C.get(f)??0;c++,C.set(f,c);const d=c===1?f:`${f}#${c}`;return S.set(m,d),d}}function I(m,u){const a=S.get(m);if(a)return a;const f=u.owner?y(u.owner)+".":"";let c;const d=u.debugNameSource;if(d!==void 0)if(typeof d=="function"){if(c=d(),c!==void 0)return f+c}else return f+d;const p=u.referenceFn;if(p!==void 0&&(c=w(p),c!==void 0))return f+c;if(u.owner!==void 0){const E=P(u.owner,m);if(E!==void 0)return f+E}}function P(m,u){for(const a in m)if(m[a]===u)return a}const b=new Map,g=new WeakMap;function y(m){const u=g.get(m);if(u)return u;const a=v(m);let f=b.get(a)??0;f++,b.set(a,f);const c=f===1?a:`${a}#${f}`;return g.set(m,c),c}function v(m){const u=m.constructor;return u?u.name:"Object"}function w(m){const u=m.toString(),f=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(u);return(f?f[1]:void 0)?.trim()}}),define(ye[154],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kd=void 0,e.$Id=C,e.$Jd=S;let o;function C(a){o=a}function S(){return o}class D{constructor(){this.a=0,this.d=new WeakMap}b(f){return I([P(m("|  ",this.a)),f])}c(f){return f.hadValue?f.didChange?[P(" "),g(y(f.oldValue,70),{color:"red",strikeThrough:!0}),P(" "),g(y(f.newValue,60),{color:"green"})]:[P(" (unchanged)")]:[P(" "),g(y(f.newValue,60),{color:"green"}),P(" (initial)")]}handleObservableChanged(f,c){console.log(...this.b([b("observable value changed"),g(f.debugName,{color:"BlueViolet"}),...this.c(c)]))}formatChanges(f){if(f.size!==0)return g(" (changed deps: "+[...f].map(c=>c.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(f){const c=f.handleChange;this.d.set(f,new Set),f.handleChange=(d,p)=>(this.d.get(f).add(d),c.apply(f,[d,p]))}handleDerivedRecomputed(f,c){const d=this.d.get(f);console.log(...this.b([b("derived recomputed"),g(f.debugName,{color:"BlueViolet"}),...this.c(c),this.formatChanges(d),{data:[{fn:f._computeFn}]}])),d.clear()}handleFromEventObservableTriggered(f,c){console.log(...this.b([b("observable from event triggered"),g(f.debugName,{color:"BlueViolet"}),...this.c(c),{data:[{fn:f._getValue}]}]))}handleAutorunCreated(f){const c=f.handleChange;this.d.set(f,new Set),f.handleChange=(d,p)=>(this.d.get(f).add(d),c.apply(f,[d,p]))}handleAutorunTriggered(f){const c=this.d.get(f);console.log(...this.b([b("autorun"),g(f.debugName,{color:"BlueViolet"}),this.formatChanges(c),{data:[{fn:f._runFn}]}])),c.clear(),this.a++}handleAutorunFinished(f){this.a--}handleBeginTransaction(f){let c=f.getDebugName();c===void 0&&(c=""),console.log(...this.b([b("transaction"),g(c,{color:"BlueViolet"}),{data:[{fn:f._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Kd=D;function I(a){const f=new Array,c=[];let d="";function p(h){if("length"in h)for(const t of h)t&&p(t);else"text"in h?(d+=`%c${h.text}`,f.push(h.style),h.data&&c.push(...h.data)):"data"in h&&c.push(...h.data)}p(a);const E=[d,...f];return E.push(...c),E}function P(a){return g(a,{color:"black"})}function b(a){return g(u(`${a}: `,10),{color:"black",bold:!0})}function g(a,f={color:"black"}){function c(p){return Object.entries(p).reduce((E,[h,t])=>`${E}${h}:${t};`,"")}const d={color:f.color};return f.strikeThrough&&(d["text-decoration"]="line-through"),f.bold&&(d["font-weight"]="bold"),{text:a,style:c(d)}}function y(a,f){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=f?`"${a}"`:`"${a.substr(0,f-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?v(a,f):w(a,f);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function v(a,f){let c="[ ",d=!0;for(const p of a){if(d||(c+=", "),c.length-5>f){c+="...";break}d=!1,c+=`${y(p,f-c.length)}`}return c+=" ]",c}function w(a,f){let c="{ ",d=!0;for(const[p,E]of Object.entries(a)){if(d||(c+=", "),c.length-5>f){c+="...";break}d=!1,c+=`${p}: ${y(E,f-c.length)}`}return c+=" }",c}function m(a,f){let c="";for(let d=1;d<=f;d++)c+=a;return c}function u(a,f){for(;a.length<f;)a+=" ";return a}}),define(ye[155],Ee([1,0,147,153,154]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.$4d=e.$1d=e.$Vd=e.$Ud=void 0,e.$Rd=I,e.$Sd=b,e.$Td=y,e.$Wd=m,e.$Xd=a,e.$Yd=f,e.$Zd=c,e.$2d=p,e.$3d=E,e.$5d=t;let D;function I(r){D=r}let P;function b(r){P=r}let g;function y(r){g=r}class v{get TChange(){return null}reportChanges(){this.get()}read(i){return i?i.readObservable(this):this.get()}map(i,n){const l=n===void 0?void 0:i,$=n===void 0?i:n;return g({owner:l,debugName:()=>{const k=(0,C.$dd)($);if(k!==void 0)return k;const A=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec($.toString());if(A)return`${this.debugName}.${A[2]}`;if(!l)return`${this.debugName} (mapped)`},debugReferenceFn:$},k=>$(this.read(k),k))}recomputeInitiallyAndOnChange(i,n){return i.add(D(this,n)),this}keepObserved(i){return i.add(P(this)),this}get a(){return this.get()}}e.$Ud=v;class w extends v{constructor(){super(...arguments),this.b=new Set}addObserver(i){const n=this.b.size;this.b.add(i),n===0&&this.c()}removeObserver(i){this.b.delete(i)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Vd=w;function m(r,i){const n=new d(r,i);try{r(n)}finally{n.finish()}}let u;function a(r){if(u)r(u);else{const i=new d(r,void 0);u=i;try{r(i)}finally{i.finish(),u=void 0}}}async function f(r,i){const n=new d(r,i);try{await r(n)}finally{n.finish()}}function c(r,i,n){r?i(r):m(i,n)}class d{constructor(i,n){this._fn=i,this.b=n,this.a=[],(0,S.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$dd)(this._fn)}updateObserver(i,n){this.a.push({observer:i,observable:n}),i.beginUpdate(n)}finish(){const i=this.a;for(let n=0;n<i.length;n++){const{observer:l,observable:$}=i[n];l.endUpdate($)}this.a=null,(0,S.$Jd)()?.handleEndTransaction()}}e.$1d=d;function p(r,i){let n;return typeof r=="string"?n=new C.$bd(void 0,r,void 0):n=new C.$bd(r,void 0,void 0),new h(n,i,o.$7c)}function E(r,i){return new h(new C.$bd(r.owner,r.debugName,void 0),i,r.equalsFn??o.$7c)}class h extends w{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(i,n,l){super(),this.e=i,this.g=l,this.d=n}get(){return this.d}set(i,n,l){if(this.g(this.d,i))return;let $;n||(n=$=new d(()=>{},()=>`Setting ${this.debugName}`));try{const k=this.d;this.h(i),(0,S.$Jd)()?.handleObservableChanged(this,{oldValue:k,newValue:i,change:l,didChange:!0,hadValue:!0});for(const j of this.b)n.updateObserver(j,this),j.handleChange(this,l)}finally{$&&$.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(i){this.d=i}}e.$4d=h;function t(r,i){let n;return typeof r=="string"?n=new C.$bd(void 0,r,void 0):n=new C.$bd(r,void 0,void 0),new s(n,i,o.$7c)}class s extends h{h(i){this.d!==i&&(this.d&&this.d.dispose(),this.d=i)}dispose(){this.d?.dispose()}}e.$6d=s}),function(){function he(S){const D=[];typeof S=="number"&&D.push("code/timeOrigin",S);function I(b){D.push(b,Date.now())}function P(){const b=[];for(let g=0;g<D.length;g+=2)b.push({name:D[g],startTime:D[g+1]});return b}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?he():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const I of performance.getEntriesByType("mark"))D.push({name:I.name,startTime:Math.round(S+I.startTime)});return D}};if(typeof process=="object"){const S=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return he(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),he()}function o(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=o(C))}(),define(ye[156],Ee([1,0,41]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lP=void 0;const C=Symbol("unset");class S{constructor(){this.a=new I,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||o.Iterable.empty()}insert(b,g,y){this.d(b,v=>v._value=g,y)}mutate(b,g){this.d(b,y=>y._value=g(y._value===C?void 0:y._value))}delete(b){const g=this.c(b);if(!g)return;let y=g.length-1;const v=g[y].node._value;if(v!==C){for(this.b--,g[y].node._value=C;y>0;y--){const{node:w,part:m}=g[y];if(w.children?.size||w._value!==C)break;g[y-1].node.children.delete(m)}return v}}*deleteRecursive(b){const g=this.c(b);if(!g)return;const y=g[g.length-1].node;for(let v=g.length-1;v>0;v--){const w=g[v-1];if(w.node.children.delete(g[v].part),w.node.children.size>0||w.node._value!==C)break}for(const v of D(y))v._value!==C&&(this.b--,yield v._value)}find(b){let g=this.a;for(const y of b){const v=g.children?.get(y);if(!v)return;g=v}return g._value===C?void 0:g._value}hasKeyOrParent(b){let g=this.a;for(const y of b){const v=g.children?.get(y);if(!v)return!1;if(v._value!==C)return!0;g=v}return!1}hasKeyOrChildren(b){let g=this.a;for(const y of b){const v=g.children?.get(y);if(!v)return!1;g=v}return!0}hasKey(b){let g=this.a;for(const y of b){const v=g.children?.get(y);if(!v)return!1;g=v}return g._value!==C}c(b){const g=[{part:"",node:this.a}];let y=0;for(const v of b){const w=g[y].node.children?.get(v);if(!w)return;g.push({part:v,node:w}),y++}return g}d(b,g,y){let v=this.a;for(const u of b){if(v.children)if(v.children.has(u))v=v.children.get(u);else{const a=new I;v.children.set(u,a),v=a}else{const a=new I;v.children=new Map([[u,a]]),v=a}y?.(v)}const w=v._value===C?0:1;g(v);const m=v._value===C?0:1;this.b+=m-w}*values(){for(const{_value:b}of D(this.a))b!==C&&(yield b)}}e.$lP=S;function*D(P){const b=[P];for(;b.length>0;){const g=b.pop();if(yield g,g.children)for(const y of g.children.values())b.push(y)}}class I{constructor(){this._value=C}get value(){return this._value===C?void 0:this._value}set value(b){this._value=b===void 0?C:b}}}),function(he,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var C in o)(typeof exports=="object"?exports:he)[C]=o[C]}}(typeof self<"u"?self:this,function(){return function(he){var e={};function o(C){if(e[C])return e[C].exports;var S=e[C]={i:C,l:!1,exports:{}};return he[C].call(S.exports,S,S.exports,o),S.l=!0,S.exports}return o.m=he,o.c=e,o.d=function(C,S,D){o.o(C,S)||Object.defineProperty(C,S,{enumerable:!0,get:D})},o.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},o.t=function(C,S){if(1&S&&(C=o(C)),8&S||4&S&&typeof C=="object"&&C&&C.__esModule)return C;var D=Object.create(null);if(o.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:C}),2&S&&typeof C!="string")for(var I in C)o.d(D,I,function(P){return C[P]}.bind(null,I));return D},o.n=function(C){var S=C&&C.__esModule?function(){return C.default}:function(){return C};return o.d(S,"a",S),S},o.o=function(C,S){return Object.prototype.hasOwnProperty.call(C,S)},o.p="",o(o.s=0)}([function(he,e,o){(function(C){var S;e=he.exports=X,S=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var de=Array.prototype.slice.call(arguments,0);de.unshift("SEMVER"),console.log.apply(console,de)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],b=e.src=[],g=0,y=g++;b[y]="0|[1-9]\\d*";var v=g++;b[v]="[0-9]+";var w=g++;b[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=g++;b[m]="("+b[y]+")\\.("+b[y]+")\\.("+b[y]+")";var u=g++;b[u]="("+b[v]+")\\.("+b[v]+")\\.("+b[v]+")";var a=g++;b[a]="(?:"+b[y]+"|"+b[w]+")";var f=g++;b[f]="(?:"+b[v]+"|"+b[w]+")";var c=g++;b[c]="(?:-("+b[a]+"(?:\\."+b[a]+")*))";var d=g++;b[d]="(?:-?("+b[f]+"(?:\\."+b[f]+")*))";var p=g++;b[p]="[0-9A-Za-z-]+";var E=g++;b[E]="(?:\\+("+b[p]+"(?:\\."+b[p]+")*))";var h=g++,t="v?"+b[m]+b[c]+"?"+b[E]+"?";b[h]="^"+t+"$";var s="[v=\\s]*"+b[u]+b[d]+"?"+b[E]+"?",r=g++;b[r]="^"+s+"$";var i=g++;b[i]="((?:<|>)?=?)";var n=g++;b[n]=b[v]+"|x|X|\\*";var l=g++;b[l]=b[y]+"|x|X|\\*";var $=g++;b[$]="[v=\\s]*("+b[l]+")(?:\\.("+b[l]+")(?:\\.("+b[l]+")(?:"+b[c]+")?"+b[E]+"?)?)?";var k=g++;b[k]="[v=\\s]*("+b[n]+")(?:\\.("+b[n]+")(?:\\.("+b[n]+")(?:"+b[d]+")?"+b[E]+"?)?)?";var j=g++;b[j]="^"+b[i]+"\\s*"+b[$]+"$";var A=g++;b[A]="^"+b[i]+"\\s*"+b[k]+"$";var O=g++;b[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=g++;b[F]="(?:~>?)";var V=g++;b[V]="(\\s*)"+b[F]+"\\s+",P[V]=new RegExp(b[V],"g");var Z=g++;b[Z]="^"+b[F]+b[$]+"$";var oe=g++;b[oe]="^"+b[F]+b[k]+"$";var le=g++;b[le]="(?:\\^)";var te=g++;b[te]="(\\s*)"+b[le]+"\\s+",P[te]=new RegExp(b[te],"g");var _=g++;b[_]="^"+b[le]+b[$]+"$";var W=g++;b[W]="^"+b[le]+b[k]+"$";var K=g++;b[K]="^"+b[i]+"\\s*("+s+")$|^$";var Y=g++;b[Y]="^"+b[i]+"\\s*("+t+")$|^$";var M=g++;b[M]="(\\s*)"+b[i]+"\\s*("+s+"|"+b[$]+")",P[M]=new RegExp(b[M],"g");var Q=g++;b[Q]="^\\s*("+b[$]+")\\s+-\\s+("+b[$]+")\\s*$";var ce=g++;b[ce]="^\\s*("+b[k]+")\\s+-\\s+("+b[k]+")\\s*$";var ie=g++;b[ie]="(<|>)?=?\\s*\\*";for(var be=0;be<35;be++)S(be,b[be]),P[be]||(P[be]=new RegExp(b[be]));function re(de,Pe){if(de instanceof X)return de;if(typeof de!="string"||de.length>D||!(Pe?P[r]:P[h]).test(de))return null;try{return new X(de,Pe)}catch{return null}}function X(de,Pe){if(de instanceof X){if(de.loose===Pe)return de;de=de.version}else if(typeof de!="string")throw new TypeError("Invalid Version: "+de);if(de.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof X))return new X(de,Pe);S("SemVer",de,Pe),this.loose=Pe;var De=de.trim().match(Pe?P[r]:P[h]);if(!De)throw new TypeError("Invalid Version: "+de);if(this.raw=de,this.major=+De[1],this.minor=+De[2],this.patch=+De[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");De[4]?this.prerelease=De[4].split(".").map(function(Me){if(/^[0-9]+$/.test(Me)){var Fe=+Me;if(Fe>=0&&Fe<I)return Fe}return Me}):this.prerelease=[],this.build=De[5]?De[5].split("."):[],this.format()}e.parse=re,e.valid=function(de,Pe){var De=re(de,Pe);return De?De.version:null},e.clean=function(de,Pe){var De=re(de.trim().replace(/^[=v]+/,""),Pe);return De?De.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(de){return S("SemVer.compare",this.version,this.loose,de),de instanceof X||(de=new X(de,this.loose)),this.compareMain(de)||this.comparePre(de)},X.prototype.compareMain=function(de){return de instanceof X||(de=new X(de,this.loose)),N(this.major,de.major)||N(this.minor,de.minor)||N(this.patch,de.patch)},X.prototype.comparePre=function(de){if(de instanceof X||(de=new X(de,this.loose)),this.prerelease.length&&!de.prerelease.length)return-1;if(!this.prerelease.length&&de.prerelease.length)return 1;if(!this.prerelease.length&&!de.prerelease.length)return 0;var Pe=0;do{var De=this.prerelease[Pe],Me=de.prerelease[Pe];if(S("prerelease compare",Pe,De,Me),De===void 0&&Me===void 0)return 0;if(Me===void 0)return 1;if(De===void 0)return-1;if(De!==Me)return N(De,Me)}while(++Pe)},X.prototype.inc=function(de,Pe){switch(de){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Pe),this.inc("pre",Pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Pe),this.inc("pre",Pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var De=this.prerelease.length;--De>=0;)typeof this.prerelease[De]=="number"&&(this.prerelease[De]++,De=-2);De===-1&&this.prerelease.push(0)}Pe&&(this.prerelease[0]===Pe?isNaN(this.prerelease[1])&&(this.prerelease=[Pe,0]):this.prerelease=[Pe,0]);break;default:throw new Error("invalid increment argument: "+de)}return this.format(),this.raw=this.version,this},e.inc=function(de,Pe,De,Me){typeof De=="string"&&(Me=De,De=void 0);try{return new X(de,De).inc(Pe,Me).version}catch{return null}},e.diff=function(de,Pe){if(x(de,Pe))return null;var De=re(de),Me=re(Pe);if(De.prerelease.length||Me.prerelease.length){for(var Fe in De)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&De[Fe]!==Me[Fe])return"pre"+Fe;return"prerelease"}for(var Fe in De)if((Fe==="major"||Fe==="minor"||Fe==="patch")&&De[Fe]!==Me[Fe])return Fe},e.compareIdentifiers=N;var B=/^[0-9]+$/;function N(de,Pe){var De=B.test(de),Me=B.test(Pe);return De&&Me&&(de=+de,Pe=+Pe),De&&!Me?-1:Me&&!De?1:de<Pe?-1:de>Pe?1:0}function z(de,Pe,De){return new X(de,De).compare(new X(Pe,De))}function J(de,Pe,De){return z(de,Pe,De)>0}function ue(de,Pe,De){return z(de,Pe,De)<0}function x(de,Pe,De){return z(de,Pe,De)===0}function G(de,Pe,De){return z(de,Pe,De)!==0}function U(de,Pe,De){return z(de,Pe,De)>=0}function T(de,Pe,De){return z(de,Pe,De)<=0}function q(de,Pe,De,Me){var Fe;switch(Pe){case"===":typeof de=="object"&&(de=de.version),typeof De=="object"&&(De=De.version),Fe=de===De;break;case"!==":typeof de=="object"&&(de=de.version),typeof De=="object"&&(De=De.version),Fe=de!==De;break;case"":case"=":case"==":Fe=x(de,De,Me);break;case"!=":Fe=G(de,De,Me);break;case">":Fe=J(de,De,Me);break;case">=":Fe=U(de,De,Me);break;case"<":Fe=ue(de,De,Me);break;case"<=":Fe=T(de,De,Me);break;default:throw new TypeError("Invalid operator: "+Pe)}return Fe}function se(de,Pe){if(de instanceof se){if(de.loose===Pe)return de;de=de.value}if(!(this instanceof se))return new se(de,Pe);S("comparator",de,Pe),this.loose=Pe,this.parse(de),this.semver===ae?this.value="":this.value=this.operator+this.semver.version,S("comp",this)}e.rcompareIdentifiers=function(de,Pe){return N(Pe,de)},e.major=function(de,Pe){return new X(de,Pe).major},e.minor=function(de,Pe){return new X(de,Pe).minor},e.patch=function(de,Pe){return new X(de,Pe).patch},e.compare=z,e.compareLoose=function(de,Pe){return z(de,Pe,!0)},e.rcompare=function(de,Pe,De){return z(Pe,de,De)},e.sort=function(de,Pe){return de.sort(function(De,Me){return e.compare(De,Me,Pe)})},e.rsort=function(de,Pe){return de.sort(function(De,Me){return e.rcompare(De,Me,Pe)})},e.gt=J,e.lt=ue,e.eq=x,e.neq=G,e.gte=U,e.lte=T,e.cmp=q,e.Comparator=se;var ae={};function me(de,Pe){if(de instanceof me)return de.loose===Pe?de:new me(de.raw,Pe);if(de instanceof se)return new me(de.value,Pe);if(!(this instanceof me))return new me(de,Pe);if(this.loose=Pe,this.raw=de,this.set=de.split(/\s*\|\|\s*/).map(function(De){return this.parseRange(De.trim())},this).filter(function(De){return De.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+de);this.format()}function ee(de){return!de||de.toLowerCase()==="x"||de==="*"}function ge(de,Pe,De,Me,Fe,Ue,Ve,Ge,Ze,_e,et,xe,pe){return((Pe=ee(De)?"":ee(Me)?">="+De+".0.0":ee(Fe)?">="+De+"."+Me+".0":">="+Pe)+" "+(Ge=ee(Ze)?"":ee(_e)?"<"+(+Ze+1)+".0.0":ee(et)?"<"+Ze+"."+(+_e+1)+".0":xe?"<="+Ze+"."+_e+"."+et+"-"+xe:"<="+Ge)).trim()}function $e(de,Pe){for(var De=0;De<de.length;De++)if(!de[De].test(Pe))return!1;if(Pe.prerelease.length){for(De=0;De<de.length;De++)if(S(de[De].semver),de[De].semver!==ae&&de[De].semver.prerelease.length>0){var Me=de[De].semver;if(Me.major===Pe.major&&Me.minor===Pe.minor&&Me.patch===Pe.patch)return!0}return!1}return!0}function Ce(de,Pe,De){try{Pe=new me(Pe,De)}catch{return!1}return Pe.test(de)}function je(de,Pe,De,Me){var Fe,Ue,Ve,Ge,Ze;switch(de=new X(de,Me),Pe=new me(Pe,Me),De){case">":Fe=J,Ue=T,Ve=ue,Ge=">",Ze=">=";break;case"<":Fe=ue,Ue=U,Ve=J,Ge="<",Ze="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ce(de,Pe,Me))return!1;for(var _e=0;_e<Pe.set.length;++_e){var et=Pe.set[_e],xe=null,pe=null;if(et.forEach(function(Ie){Ie.semver===ae&&(Ie=new se(">=0.0.0")),xe=xe||Ie,pe=pe||Ie,Fe(Ie.semver,xe.semver,Me)?xe=Ie:Ve(Ie.semver,pe.semver,Me)&&(pe=Ie)}),xe.operator===Ge||xe.operator===Ze||(!pe.operator||pe.operator===Ge)&&Ue(de,pe.semver)||pe.operator===Ze&&Ve(de,pe.semver))return!1}return!0}se.prototype.parse=function(de){var Pe=this.loose?P[K]:P[Y],De=de.match(Pe);if(!De)throw new TypeError("Invalid comparator: "+de);this.operator=De[1],this.operator==="="&&(this.operator=""),De[2]?this.semver=new X(De[2],this.loose):this.semver=ae},se.prototype.toString=function(){return this.value},se.prototype.test=function(de){return S("Comparator.test",de,this.loose),this.semver===ae||(typeof de=="string"&&(de=new X(de,this.loose)),q(de,this.operator,this.semver,this.loose))},se.prototype.intersects=function(de,Pe){if(!(de instanceof se))throw new TypeError("a Comparator is required");var De;if(this.operator==="")return De=new me(de.value,Pe),Ce(this.value,De,Pe);if(de.operator==="")return De=new me(this.value,Pe),Ce(de.semver,De,Pe);var Me=!(this.operator!==">="&&this.operator!==">"||de.operator!==">="&&de.operator!==">"),Fe=!(this.operator!=="<="&&this.operator!=="<"||de.operator!=="<="&&de.operator!=="<"),Ue=this.semver.version===de.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||de.operator!==">="&&de.operator!=="<="),Ge=q(this.semver,"<",de.semver,Pe)&&(this.operator===">="||this.operator===">")&&(de.operator==="<="||de.operator==="<"),Ze=q(this.semver,">",de.semver,Pe)&&(this.operator==="<="||this.operator==="<")&&(de.operator===">="||de.operator===">");return Me||Fe||Ue&&Ve||Ge||Ze},e.Range=me,me.prototype.format=function(){return this.range=this.set.map(function(de){return de.join(" ").trim()}).join("||").trim(),this.range},me.prototype.toString=function(){return this.range},me.prototype.parseRange=function(de){var Pe=this.loose;de=de.trim(),S("range",de,Pe);var De=Pe?P[ce]:P[Q];de=de.replace(De,ge),S("hyphen replace",de),de=de.replace(P[M],"$1$2$3"),S("comparator trim",de,P[M]),de=(de=(de=de.replace(P[V],"$1~")).replace(P[te],"$1^")).split(/\s+/).join(" ");var Me=Pe?P[K]:P[Y],Fe=de.split(" ").map(function(Ue){return function(Ve,Ge){return S("comp",Ve),Ve=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(et){return function(xe,pe){S("caret",xe,pe);var Ie=pe?P[W]:P[_];return xe.replace(Ie,function(Re,Ae,Te,Qe,He){var Je;return S("caret",xe,Re,Ae,Te,Qe,He),ee(Ae)?Je="":ee(Te)?Je=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":ee(Qe)?Je=Ae==="0"?">="+Ae+"."+Te+".0 <"+Ae+"."+(+Te+1)+".0":">="+Ae+"."+Te+".0 <"+(+Ae+1)+".0.0":He?(S("replaceCaret pr",He),He.charAt(0)!=="-"&&(He="-"+He),Je=Ae==="0"?Te==="0"?">="+Ae+"."+Te+"."+Qe+He+" <"+Ae+"."+Te+"."+(+Qe+1):">="+Ae+"."+Te+"."+Qe+He+" <"+Ae+"."+(+Te+1)+".0":">="+Ae+"."+Te+"."+Qe+He+" <"+(+Ae+1)+".0.0"):(S("no pr"),Je=Ae==="0"?Te==="0"?">="+Ae+"."+Te+"."+Qe+" <"+Ae+"."+Te+"."+(+Qe+1):">="+Ae+"."+Te+"."+Qe+" <"+Ae+"."+(+Te+1)+".0":">="+Ae+"."+Te+"."+Qe+" <"+(+Ae+1)+".0.0"),S("caret return",Je),Je})}(et,_e)}).join(" ")}(Ve,Ge),S("caret",Ve),Ve=function(Ze,_e){return Ze.trim().split(/\s+/).map(function(et){return function(xe,pe){var Ie=pe?P[oe]:P[Z];return xe.replace(Ie,function(Re,Ae,Te,Qe,He){var Je;return S("tilde",xe,Re,Ae,Te,Qe,He),ee(Ae)?Je="":ee(Te)?Je=">="+Ae+".0.0 <"+(+Ae+1)+".0.0":ee(Qe)?Je=">="+Ae+"."+Te+".0 <"+Ae+"."+(+Te+1)+".0":He?(S("replaceTilde pr",He),He.charAt(0)!=="-"&&(He="-"+He),Je=">="+Ae+"."+Te+"."+Qe+He+" <"+Ae+"."+(+Te+1)+".0"):Je=">="+Ae+"."+Te+"."+Qe+" <"+Ae+"."+(+Te+1)+".0",S("tilde return",Je),Je})}(et,_e)}).join(" ")}(Ve,Ge),S("tildes",Ve),Ve=function(Ze,_e){return S("replaceXRanges",Ze,_e),Ze.split(/\s+/).map(function(et){return function(xe,pe){xe=xe.trim();var Ie=pe?P[A]:P[j];return xe.replace(Ie,function(Re,Ae,Te,Qe,He,Je){S("xRange",xe,Re,Ae,Te,Qe,He,Je);var it=ee(Te),Ke=it||ee(Qe),nt=Ke||ee(He);return Ae==="="&&nt&&(Ae=""),it?Re=Ae===">"||Ae==="<"?"<0.0.0":"*":Ae&&nt?(Ke&&(Qe=0),nt&&(He=0),Ae===">"?(Ae=">=",Ke?(Te=+Te+1,Qe=0,He=0):nt&&(Qe=+Qe+1,He=0)):Ae==="<="&&(Ae="<",Ke?Te=+Te+1:Qe=+Qe+1),Re=Ae+Te+"."+Qe+"."+He):Ke?Re=">="+Te+".0.0 <"+(+Te+1)+".0.0":nt&&(Re=">="+Te+"."+Qe+".0 <"+Te+"."+(+Qe+1)+".0"),S("xRange return",Re),Re})}(et,_e)}).join(" ")}(Ve,Ge),S("xrange",Ve),Ve=function(Ze,_e){return S("replaceStars",Ze,_e),Ze.trim().replace(P[ie],"")}(Ve,Ge),S("stars",Ve),Ve}(Ue,Pe)}).join(" ").split(/\s+/);return this.loose&&(Fe=Fe.filter(function(Ue){return!!Ue.match(Me)})),Fe=Fe.map(function(Ue){return new se(Ue,Pe)})},me.prototype.intersects=function(de,Pe){if(!(de instanceof me))throw new TypeError("a Range is required");return this.set.some(function(De){return De.every(function(Me){return de.set.some(function(Fe){return Fe.every(function(Ue){return Me.intersects(Ue,Pe)})})})})},e.toComparators=function(de,Pe){return new me(de,Pe).set.map(function(De){return De.map(function(Me){return Me.value}).join(" ").trim().split(" ")})},me.prototype.test=function(de){if(!de)return!1;typeof de=="string"&&(de=new X(de,this.loose));for(var Pe=0;Pe<this.set.length;Pe++)if($e(this.set[Pe],de))return!0;return!1},e.satisfies=Ce,e.maxSatisfying=function(de,Pe,De){var Me=null,Fe=null;try{var Ue=new me(Pe,De)}catch{return null}return de.forEach(function(Ve){Ue.test(Ve)&&(Me&&Fe.compare(Ve)!==-1||(Fe=new X(Me=Ve,De)))}),Me},e.minSatisfying=function(de,Pe,De){var Me=null,Fe=null;try{var Ue=new me(Pe,De)}catch{return null}return de.forEach(function(Ve){Ue.test(Ve)&&(Me&&Fe.compare(Ve)!==1||(Fe=new X(Me=Ve,De)))}),Me},e.validRange=function(de,Pe){try{return new me(de,Pe).range||"*"}catch{return null}},e.ltr=function(de,Pe,De){return je(de,Pe,"<",De)},e.gtr=function(de,Pe,De){return je(de,Pe,">",De)},e.outside=je,e.prerelease=function(de,Pe){var De=re(de,Pe);return De&&De.prerelease.length?De.prerelease:null},e.intersects=function(de,Pe,De){return de=new me(de,De),Pe=new me(Pe,De),de.intersects(Pe)},e.coerce=function(de){if(de instanceof X)return de;if(typeof de!="string")return null;var Pe=de.match(P[O]);return Pe==null?null:re((Pe[1]||"0")+"."+(Pe[2]||"0")+"."+(Pe[3]||"0"))}}).call(this,o(1))},function(he,e){var o,C,S=he.exports={};function D(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(f){if(o===setTimeout)return setTimeout(f,0);if((o===D||!o)&&setTimeout)return o=setTimeout,setTimeout(f,0);try{return o(f,0)}catch{try{return o.call(null,f,0)}catch{return o.call(this,f,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:D}catch{o=D}try{C=typeof clearTimeout=="function"?clearTimeout:I}catch{C=I}})();var b,g=[],y=!1,v=-1;function w(){y&&b&&(y=!1,b.length?g=b.concat(g):v=-1,g.length&&m())}function m(){if(!y){var f=P(w);y=!0;for(var c=g.length;c;){for(b=g,g=[];++v<c;)b&&b[v].run();v=-1,c=g.length}b=null,y=!1,function(d){if(C===clearTimeout)return clearTimeout(d);if((C===I||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(d);try{C(d)}catch{try{return C.call(null,d)}catch{return C.call(this,d)}}}(f)}}function u(f,c){this.fun=f,this.array=c}function a(){}S.nextTick=function(f){var c=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)c[d-1]=arguments[d];g.push(new u(f,c)),g.length!==1||y||P(m)},u.prototype.run=function(){this.fun.apply(null,this.array)},S.title="browser",S.browser=!0,S.env={},S.argv=[],S.version="",S.versions={},S.on=a,S.addListener=a,S.once=a,S.off=a,S.removeListener=a,S.removeAllListeners=a,S.emit=a,S.prependListener=a,S.prependOnceListener=a,S.listeners=function(f){return[]},S.binding=function(f){throw new Error("process.binding is not supported")},S.cwd=function(){return"/"},S.chdir=function(f){throw new Error("process.chdir is not supported")},S.umask=function(){return 0}}])}),define(ye[157],Ee([1,0]),function(he,e){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class C{constructor(P,b,g){this.level=P,this.key=b,this.value=g,this.forward=[]}}const S=void 0;class D{constructor(P,b=2**16){this.comparator=P,this[o]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(b)|0),this.e=new C(this.c,S,S)}get size(){return this.f}clear(){this.e=new C(this.c,S,S),this.f=0}has(P){return!!D.g(this,P,this.comparator)}get(P){return D.g(this,P,this.comparator)?.value}set(P,b){return D.h(this,P,b,this.comparator)&&(this.f+=1),this}delete(P){const b=D.k(this,P,this.comparator);return b&&(this.f-=1),b}forEach(P,b){let g=this.e.forward[0];for(;g;)P.call(b,g.value,g.key,this),g=g.forward[0]}[(o=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",b=this.e.forward[0];for(;b;)P+=`node(${b.key}, ${b.value}, lvl:${b.level})`,b=b.forward[0];return P}static g(P,b,g){let y=P.e;for(let v=P.d-1;v>=0;v--)for(;y.forward[v]&&g(y.forward[v].key,b)<0;)y=y.forward[v];if(y=y.forward[0],y&&g(y.key,b)===0)return y}static h(P,b,g,y){const v=[];let w=P.e;for(let m=P.d-1;m>=0;m--){for(;w.forward[m]&&y(w.forward[m].key,b)<0;)w=w.forward[m];v[m]=w}if(w=w.forward[0],w&&y(w.key,b)===0)return w.value=g,!1;{const m=D.j(P);if(m>P.d){for(let u=P.d;u<m;u++)v[u]=P.e;P.d=m}w=new C(m,b,g);for(let u=0;u<m;u++)w.forward[u]=v[u].forward[u],v[u].forward[u]=w;return!0}}static j(P,b=.5){let g=1;for(;Math.random()<b&&g<P.c;)g+=1;return g}static k(P,b,g){const y=[];let v=P.e;for(let w=P.d-1;w>=0;w--){for(;v.forward[w]&&g(v.forward[w].key,b)<0;)v=v.forward[w];y[w]=v}if(v=v.forward[0],!v||g(v.key,b)!==0)return!1;for(let w=0;w<P.d&&y[w].forward[w]===v;w++)y[w].forward[w]=v.forward[w];for(;P.d>0&&P.e.forward[P.d-1]===S;)P.d-=1;return!0}}e.$zs=D}),define(ye[61],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const o=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(D){return new C(D)}constructor(D){this.c=o&&D===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=C}),define(ye[6],Ee([1,0,11,75,2,98,61]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=m;const P=!1,b=!1,g=!1;var y;(function(V){V.None=()=>S.$Vc.None;function Z(me){if(g){const{onDidAddListener:ee}=me,ge=a.create();let $e=0;me.onDidAddListener=()=>{++$e===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ge.print()),ee?.()}}}function oe(me,ee){return ie(me,()=>{},0,void 0,!0,void 0,ee)}V.defer=oe;function le(me){return(ee,ge=null,$e)=>{let Ce=!1,je;return je=me(de=>{if(!Ce)return je?je.dispose():Ce=!0,ee.call(ge,de)},null,$e),Ce&&je.dispose(),je}}V.once=le;function te(me,ee,ge){return Q(($e,Ce=null,je)=>me(de=>$e.call(Ce,ee(de)),null,je),ge)}V.map=te;function _(me,ee,ge){return Q(($e,Ce=null,je)=>me(de=>{ee(de),$e.call(Ce,de)},null,je),ge)}V.forEach=_;function W(me,ee,ge){return Q(($e,Ce=null,je)=>me(de=>ee(de)&&$e.call(Ce,de),null,je),ge)}V.filter=W;function K(me){return me}V.signal=K;function Y(...me){return(ee,ge=null,$e)=>{const Ce=(0,S.$Sc)(...me.map(je=>je(de=>ee.call(ge,de))));return ce(Ce,$e)}}V.any=Y;function M(me,ee,ge,$e){let Ce=ge;return te(me,je=>(Ce=ee(Ce,je),Ce),$e)}V.reduce=M;function Q(me,ee){let ge;const $e={onWillAddFirstListener(){ge=me(Ce.fire,Ce)},onDidRemoveLastListener(){ge?.dispose()}};ee||Z($e);const Ce=new h($e);return ee?.add(Ce),Ce.event}function ce(me,ee){return ee instanceof Array?ee.push(me):ee&&ee.add(me),me}function ie(me,ee,ge=100,$e=!1,Ce=!1,je,de){let Pe,De,Me,Fe=0,Ue;const Ve={leakWarningThreshold:je,onWillAddFirstListener(){Pe=me(Ze=>{Fe++,De=ee(De,Ze),$e&&!Me&&(Ge.fire(De),De=void 0),Ue=()=>{const _e=De;De=void 0,Me=void 0,(!$e||Fe>1)&&Ge.fire(_e),Fe=0},typeof ge=="number"?(clearTimeout(Me),Me=setTimeout(Ue,ge)):Me===void 0&&(Me=0,queueMicrotask(Ue))})},onWillRemoveListener(){Ce&&Fe>0&&Ue?.()},onDidRemoveLastListener(){Ue=void 0,Pe.dispose()}};de||Z(Ve);const Ge=new h(Ve);return de?.add(Ge),Ge.event}V.debounce=ie;function be(me,ee=0,ge){return V.debounce(me,($e,Ce)=>$e?($e.push(Ce),$e):[Ce],ee,void 0,!0,void 0,ge)}V.accumulate=be;function re(me,ee=($e,Ce)=>$e===Ce,ge){let $e=!0,Ce;return W(me,je=>{const de=$e||!ee(je,Ce);return $e=!1,Ce=je,de},ge)}V.latch=re;function X(me,ee,ge){return[V.filter(me,ee,ge),V.filter(me,$e=>!ee($e),ge)]}V.split=X;function B(me,ee=!1,ge=[],$e){let Ce=ge.slice(),je=me(De=>{Ce?Ce.push(De):Pe.fire(De)});$e&&$e.add(je);const de=()=>{Ce?.forEach(De=>Pe.fire(De)),Ce=null},Pe=new h({onWillAddFirstListener(){je||(je=me(De=>Pe.fire(De)),$e&&$e.add(je))},onDidAddFirstListener(){Ce&&(ee?setTimeout(de):de())},onDidRemoveLastListener(){je&&je.dispose(),je=null}});return $e&&$e.add(Pe),Pe.event}V.buffer=B;function N(me,ee){return($e,Ce,je)=>{const de=ee(new J);return me(function(Pe){const De=de.evaluate(Pe);De!==z&&$e.call(Ce,De)},void 0,je)}}V.chain=N;const z=Symbol("HaltChainable");class J{constructor(){this.f=[]}map(ee){return this.f.push(ee),this}forEach(ee){return this.f.push(ge=>(ee(ge),ge)),this}filter(ee){return this.f.push(ge=>ee(ge)?ge:z),this}reduce(ee,ge){let $e=ge;return this.f.push(Ce=>($e=ee($e,Ce),$e)),this}latch(ee=(ge,$e)=>ge===$e){let ge=!0,$e;return this.f.push(Ce=>{const je=ge||!ee(Ce,$e);return ge=!1,$e=Ce,je?Ce:z}),this}evaluate(ee){for(const ge of this.f)if(ee=ge(ee),ee===z)break;return ee}}function ue(me,ee,ge=$e=>$e){const $e=(...Pe)=>de.fire(ge(...Pe)),Ce=()=>me.on(ee,$e),je=()=>me.removeListener(ee,$e),de=new h({onWillAddFirstListener:Ce,onDidRemoveLastListener:je});return de.event}V.fromNodeEventEmitter=ue;function x(me,ee,ge=$e=>$e){const $e=(...Pe)=>de.fire(ge(...Pe)),Ce=()=>me.addEventListener(ee,$e),je=()=>me.removeEventListener(ee,$e),de=new h({onWillAddFirstListener:Ce,onDidRemoveLastListener:je});return de.event}V.fromDOMEventEmitter=x;function G(me){return new Promise(ee=>le(me)(ee))}V.toPromise=G;function U(me){const ee=new h;return me.then(ge=>{ee.fire(ge)},()=>{ee.fire(void 0)}).finally(()=>{ee.dispose()}),ee.event}V.fromPromise=U;function T(me,ee,ge){return ee(ge),me($e=>ee($e))}V.runAndSubscribe=T;class q{constructor(ee,ge){this._observable=ee,this.f=0,this.g=!1;const $e={onWillAddFirstListener:()=>{ee.addObserver(this)},onDidRemoveLastListener:()=>{ee.removeObserver(this)}};ge||Z($e),this.emitter=new h($e),ge&&ge.add(this.emitter)}beginUpdate(ee){this.f++}handlePossibleChange(ee){}handleChange(ee,ge){this.g=!0}endUpdate(ee){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function se(me,ee){return new q(me,ee).emitter.event}V.fromObservable=se;function ae(me){return(ee,ge,$e)=>{let Ce=0,je=!1;const de={beginUpdate(){Ce++},endUpdate(){Ce--,Ce===0&&(me.reportChanges(),je&&(je=!1,ee.call(ge)))},handlePossibleChange(){},handleChange(){je=!0}};me.addObserver(de),me.reportChanges();const Pe={dispose(){me.removeObserver(de)}};return $e instanceof S.$Uc?$e.add(Pe):Array.isArray($e)&&$e.push(Pe),Pe}}V.fromObservableLight=ae})(y||(e.Event=y={}));class v{static{this.all=new Set}static{this.f=0}constructor(Z){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${Z}_${v.f++}`,v.all.add(this)}start(Z){this.g=new I.$ae,this.listenerCount=Z}stop(){if(this.g){const Z=this.g.elapsed();this.durations.push(Z),this.elapsedOverall+=Z,this.invocationCount+=1,this.g=void 0}}}e.$ce=v;let w=-1;function m(V){const Z=w;return w=V,{dispose(){w=Z}}}class u{constructor(Z,oe=Math.random().toString(18).slice(2,5)){this.threshold=Z,this.name=oe,this.g=0}dispose(){this.f?.clear()}check(Z,oe){const le=this.threshold;if(le<=0||oe<le)return;this.f||(this.f=new Map);const te=this.f.get(Z.value)||0;if(this.f.set(Z.value,te+1),this.g-=1,this.g<=0){this.g=le*.5;let _,W=0;for(const[K,Y]of this.f)(!_||W<Y)&&(_=K,W=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${oe} listeners already. MOST frequent listener (${W}):`),console.warn(_)}return()=>{const _=this.f.get(Z.value)||0;this.f.set(Z.value,_-1)}}}class a{static create(){return new a(new Error().stack??"")}constructor(Z){this.value=Z}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class c{constructor(Z){this.value=Z,this.id=f++}}const d=2,p=(V,Z)=>{if(V instanceof c)Z(V);else for(let oe=0;oe<V.length;oe++){const le=V[oe];le&&Z(le)}},E=P?new FinalizationRegistry(V=>{typeof V=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(V))}):void 0;class h{constructor(Z){this.w=0,this.f=Z,this.g=w>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??w):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const Z=this.t;queueMicrotask(()=>{p(Z,oe=>oe.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(Z,oe,le)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),S.$Vc.None;if(this.m)return S.$Vc.None;oe&&(Z=Z.bind(oe));const te=new c(Z);let _,W;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(te.stack=a.create(),_=this.g.check(te.stack,this.w+1)),b&&(te.stack=W??a.create()),this.t?this.t instanceof c?(this.u??=new s,this.t=[this.t,te]):this.t.push(te):(this.f?.onWillAddFirstListener?.(this),this.t=te,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,S.$Tc)(()=>{E?.unregister(K),_?.(),this.x(te)});if(le instanceof S.$Uc?le.add(K):Array.isArray(le)&&le.push(K),E){const Y=new Error().stack.split(`
`).slice(2).join(`
`).trim();E.register(K,Y,K)}return K},this.q}x(Z){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const oe=this.t,le=oe.indexOf(Z);if(le===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,oe[le]=void 0;const te=this.u.current===this;if(this.w*d<=oe.length){let _=0;for(let W=0;W<oe.length;W++)oe[W]?oe[_++]=oe[W]:te&&(this.u.end--,_<this.u.i&&this.u.i--);oe.length=_}}y(Z,oe){if(!Z)return;const le=this.f?.onListenerError||o.$1;if(!le){Z.value(oe);return}try{Z.value(oe)}catch(te){le(te)}}z(Z){const oe=Z.current.t;for(;Z.i<Z.end;)this.y(oe[Z.i++],Z.value);Z.reset()}fire(Z){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof c)this.y(this.t,Z);else{const oe=this.u;oe.enqueue(this,Z,this.t.length),this.z(oe)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=h;const t=()=>new s;e.$fe=t;class s{constructor(){this.i=-1,this.end=0}enqueue(Z,oe,le){this.i=0,this.end=le,this.current=Z,this.value=oe}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class r extends h{async fireAsync(Z,oe,le){if(this.t)for(this.h||(this.h=new D.$6c),p(this.t,te=>this.h.push([te.value,Z]));this.h.size>0&&!oe.isCancellationRequested;){const[te,_]=this.h.shift(),W=[],K={..._,token:oe,waitUntil:Y=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");le&&(Y=le(Y,te)),W.push(Y)}};try{te(K)}catch(Y){(0,o.$1)(Y);continue}Object.freeze(W),await Promise.allSettled(W).then(Y=>{for(const M of Y)M.status==="rejected"&&(0,o.$1)(M.reason)})}}}e.$ge=r;class i extends h{get isPaused(){return this.h!==0}constructor(Z){super(Z),this.h=0,this.s=new D.$6c,this.A=Z?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const Z=Array.from(this.s);this.s.clear(),super.fire(this.A(Z))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(Z){this.w&&(this.h!==0?this.s.push(Z):super.fire(Z))}}e.$he=i;class n extends i{constructor(Z){super(Z),this.k=Z.delay??100}fire(Z){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(Z)}}e.$ie=n;class l extends h{constructor(Z){super(Z),this.h=[],this.k=Z?.merge}fire(Z){this.hasListeners()&&(this.h.push(Z),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(oe=>super.fire(oe)),this.h=[]}))}}e.$je=l;class ${constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(Z){const oe={event:Z,listener:null};this.h.push(oe),this.g&&this.m(oe);const le=()=>{this.g&&this.o(oe);const te=this.h.indexOf(oe);this.h.splice(te,1)};return(0,S.$Tc)((0,C.$db)(le))}j(){this.g=!0,this.h.forEach(Z=>this.m(Z))}k(){this.g=!1,this.h.forEach(Z=>this.o(Z))}m(Z){Z.listener=Z.event(oe=>this.f.fire(oe))}o(Z){Z.listener?.dispose(),Z.listener=null}dispose(){this.f.dispose();for(const Z of this.h)Z.listener?.dispose();this.h=[]}}e.$ke=$;class k{constructor(Z,oe,le,te){this.f=new S.$Uc;const _=this.f.add(new $),W=this.f.add(new S.$5c);function K(Y){W.set(Y,_.add(te(Y)))}for(const Y of Z)K(Y);this.f.add(oe(Y=>{K(Y)})),this.f.add(le(Y=>{W.deleteAndDispose(Y)})),this.event=_.event}dispose(){this.f.dispose()}}e.$le=k;class j{constructor(){this.f=[]}wrapEvent(Z){return(oe,le,te)=>Z(_=>{const W=this.f[this.f.length-1];W?W.push(()=>oe.call(le,_)):oe.call(le,_)},void 0,te)}bufferEvents(Z){const oe=[];this.f.push(oe);const le=Z();return this.f.pop(),oe.forEach(te=>te()),le}}e.$me=j;class A{constructor(){this.f=!1,this.g=y.None,this.h=S.$Vc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(Z){this.g=Z,this.f&&(this.h.dispose(),this.h=Z(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=A;class O{static const(Z){return new F(Z)}constructor(Z){this.g=Z,this.f=new h,this.onDidChange=this.f.event}get value(){return this.g}set value(Z){Z!==this.g&&(this.g=Z,this.f.fire(void 0))}}e.$oe=O;class F{constructor(Z){this.value=Z,this.onDidChange=y.None}}}),define(ye[20],Ee([1,0,6]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0,e.$qe=P;const C=Object.freeze(function(b,g){const y=setTimeout(b.bind(g),0);return{dispose(){clearTimeout(y)}}});var S;(function(b){function g(y){return y===b.None||y===b.Cancelled||y instanceof D?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=g,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(S||(e.CancellationToken=S={}));class D{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new o.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(g){this.f=void 0,this.g=void 0,this.g=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new D),this.f}cancel(){this.f?this.f instanceof D&&this.f.cancel():this.f=S.Cancelled}dispose(g=!1){g&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof D&&this.f.dispose():this.f=S.None}}e.$pe=I;function P(b){const g=new I;return b.add({dispose(){g.cancel()}}),g.token}}),define(ye[158],Ee([1,0,20]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5e=e.$4e=e.$2e=void 0,e.$3e=S;class C{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new o.$pe,g=this.b(b.token);return this.a={promise:g,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$2e=C;function S(P){return P}class D{constructor(b,g){this.a=void 0,this.b=void 0,typeof b=="function"?(this.c=b,this.d=S):(this.c=g,this.d=b.getCacheKey)}get(b){const g=this.d(b);return this.b!==g&&(this.b=g,this.a=this.c(b)),this.a}}e.$4e=D;class I{get cachedValues(){return this.a}constructor(b,g){this.a=new Map,this.b=new Map,typeof b=="function"?(this.c=b,this.d=S):(this.c=g,this.d=b.getCacheKey)}get(b){const g=this.d(b);if(this.b.has(g))return this.b.get(g);const y=this.c(b);return this.a.set(b,y),this.b.set(g,y),y}}e.$5e=I}),define(ye[52],Ee([1,0,11,2]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$re=S,e.$se=D,e.$te=I,e.$ue=P,e.$ve=g,e.$we=y,e.$xe=v,e.$ye=w,e.$ze=m,e.$Ae=u,e.$Be=a,e.$Ce=f,e.$De=c,e.$Ee=d,e.$Fe=p;function S(E){const h=E;return h?typeof h.read=="function":!1}function D(E){const h=E;return h?[h.on,h.pause,h.resume,h.destroy].every(t=>typeof t=="function"):!1}function I(E){const h=E;return h?D(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function P(E,h){return new b(E,h)}class b{constructor(h,t){this.e=h,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(t=>t(h))}h(h){this.c.error.length===0?(0,o.$1)(h):this.c.error.slice(0).forEach(t=>t(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,t){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(h,t){if(this.a.destroyed)return;let s;switch(h){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(E,h){const t=[];let s;for(;(s=E.read())!==null;)t.push(s);return h(t)}function y(E,h,t){const s=[];let r;for(;(r=E.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?h(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return E.read()}}}function v(E,h){return new Promise((t,s)=>{const r=[];w(E,{onData:i=>{h&&r.push(i)},onError:i=>{h?s(i):t(void 0)},onEnd:()=>{t(h?h(r):void 0)}})})}function w(E,h,t){E.on("error",s=>{t?.isCancellationRequested||h.onError(s)}),E.on("end",()=>{t?.isCancellationRequested||h.onEnd()}),E.on("data",s=>{t?.isCancellationRequested||h.onData(s)})}function m(E,h){return new Promise((t,s)=>{const r=new C.$Uc,i=[],n=k=>{if(i.push(k),i.length>h)return r.dispose(),E.pause(),t({stream:E,buffer:i,ended:!1})},l=k=>(r.dispose(),s(k)),$=()=>(r.dispose(),t({stream:E,buffer:i,ended:!0}));r.add((0,C.$Tc)(()=>E.removeListener("error",l))),E.on("error",l),r.add((0,C.$Tc)(()=>E.removeListener("end",$))),E.on("end",$),r.add((0,C.$Tc)(()=>E.removeListener("data",n))),E.on("data",n)})}function u(E,h){const t=P(h);return t.end(E),t}function a(){const E=P(()=>{throw new Error("not supported")});return E.end(),E}function f(E){let h=!1;return{read:()=>h?null:(h=!0,E)}}function c(E,h,t){const s=P(t);return w(E,{onData:r=>s.write(h.data(r)),onError:r=>s.error(h.error?h.error(r):r),onEnd:()=>s.end()}),s}function d(E,h,t){let s=!1;return{read:()=>{const r=h.read();return s?r:(s=!0,r!==null?t([E,r]):E)}}}function p(E,h,t){let s=!1;const r=P(t);return w(h,{onData:i=>s?r.write(i):(s=!0,r.write(t([E,i]))),onError:i=>r.error(i),onEnd:()=>{s||(s=!0,r.write(E)),r.end()}}),r}}),define(ye[15],Ee([1,0,60,52]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=void 0,e.$He=g,e.$Ie=y,e.$Je=v,e.$Ke=w,e.$Le=m,e.$Me=u,e.$Ne=a,e.$Oe=f,e.$Pe=c,e.$Qe=d,e.$Re=p,e.$Se=E,e.$Te=h,e.$Ue=t,e.$Ve=s,e.$We=r,e.$Xe=i,e.$Ye=n,e.$Ze=l,e.$1e=j;const S=typeof Buffer<"u",D=new o.$V(()=>new Uint8Array(256));let I,P;class b{static alloc(O){return S?new b(Buffer.allocUnsafe(O)):new b(new Uint8Array(O))}static wrap(O){return S&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new b(O)}static fromString(O,F){return!(F?.dontUseNodeBuffer||!1)&&S?new b(Buffer.from(O)):(I||(I=new TextEncoder),new b(I.encode(O)))}static fromByteArray(O){const F=b.alloc(O.length);for(let V=0,Z=O.length;V<Z;V++)F.buffer[V]=O[V];return F}static concat(O,F){if(typeof F>"u"){F=0;for(let oe=0,le=O.length;oe<le;oe++)F+=O[oe].byteLength}const V=b.alloc(F);let Z=0;for(let oe=0,le=O.length;oe<le;oe++){const te=O[oe];V.set(te,Z),Z+=te.byteLength}return V}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=b.alloc(this.byteLength);return O.set(this),O}toString(){return S?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(O,F){return new b(this.buffer.subarray(O,F))}set(O,F){if(O instanceof b)this.buffer.set(O.buffer,F);else if(O instanceof Uint8Array)this.buffer.set(O,F);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),F);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return w(this.buffer,O)}writeUInt32BE(O,F){m(this.buffer,O,F)}readUInt32LE(O){return u(this.buffer,O)}writeUInt32LE(O,F){a(this.buffer,O,F)}readUInt8(O){return f(this.buffer,O)}writeUInt8(O,F){c(this.buffer,O,F)}indexOf(O,F=0){return g(this.buffer,O instanceof b?O.buffer:O,F)}}e.$Ge=b;function g(A,O,F=0){const V=O.byteLength,Z=A.byteLength;if(V===0)return 0;if(V===1)return A.indexOf(O[0]);if(V>Z-F)return-1;const oe=D.value;oe.fill(O.length);for(let W=0;W<O.length;W++)oe[O[W]]=O.length-W-1;let le=F+O.length-1,te=le,_=-1;for(;le<Z;)if(A[le]===O[te]){if(te===0){_=le;break}le--,te--}else le+=Math.max(O.length-te,oe[A[le]]),te=O.length-1;return _}function y(A,O){return A[O+0]<<0>>>0|A[O+1]<<8>>>0}function v(A,O,F){A[F+0]=O&255,O=O>>>8,A[F+1]=O&255}function w(A,O){return A[O]*2**24+A[O+1]*2**16+A[O+2]*2**8+A[O+3]}function m(A,O,F){A[F+3]=O,O=O>>>8,A[F+2]=O,O=O>>>8,A[F+1]=O,O=O>>>8,A[F]=O}function u(A,O){return A[O+0]<<0>>>0|A[O+1]<<8>>>0|A[O+2]<<16>>>0|A[O+3]<<24>>>0}function a(A,O,F){A[F+0]=O&255,O=O>>>8,A[F+1]=O&255,O=O>>>8,A[F+2]=O&255,O=O>>>8,A[F+3]=O&255}function f(A,O){return A[O]}function c(A,O,F){A[F]=O}function d(A){return C.$ve(A,O=>b.concat(O))}function p(A){return C.$Ce(A)}function E(A){return C.$xe(A,O=>b.concat(O))}async function h(A){return A.ended?b.concat(A.buffer):b.concat([...A.buffer,await E(A.stream)])}function t(A){return C.$Ae(A,O=>b.concat(O))}function s(A){return C.$De(A,{data:O=>typeof O=="string"?b.fromString(O):b.wrap(O)},O=>b.concat(O))}function r(A){return C.$ue(O=>b.concat(O),A)}function i(A,O){return C.$Ee(A,O,F=>b.concat(F))}function n(A,O){return C.$Fe(A,O,F=>b.concat(F))}function l(A){let O=0,F=0,V=0;const Z=new Uint8Array(Math.floor(A.length/4*3)),oe=te=>{switch(F){case 3:Z[V++]=O|te,F=0;break;case 2:Z[V++]=O|te>>>2,O=te<<6,F=3;break;case 1:Z[V++]=O|te>>>4,O=te<<4,F=2;break;default:O=te<<2,F=1}};for(let te=0;te<A.length;te++){const _=A.charCodeAt(te);if(_>=65&&_<=90)oe(_-65);else if(_>=97&&_<=122)oe(_-97+26);else if(_>=48&&_<=57)oe(_-48+52);else if(_===43||_===45)oe(62);else if(_===47||_===95)oe(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${A[te]}`)}}const le=V;for(;F>0;)oe(0);return b.wrap(Z).slice(0,le)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:A},O=!0,F=!1){const V=F?k:$;let Z="";const oe=A.byteLength%3;let le=0;for(;le<A.byteLength-oe;le+=3){const te=A[le+0],_=A[le+1],W=A[le+2];Z+=V[te>>>2],Z+=V[(te<<4|_>>>4)&63],Z+=V[(_<<2|W>>>6)&63],Z+=V[W&63]}if(oe===1){const te=A[le+0];Z+=V[te>>>2],Z+=V[te<<4&63],O&&(Z+="==")}else if(oe===2){const te=A[le+0],_=A[le+1];Z+=V[te>>>2],Z+=V[(te<<4|_>>>4)&63],Z+=V[_<<2&63],O&&(Z+="=")}return Z}}),define(ye[17],Ee([1,0,158,60]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=e.$7f=e.$6f=e.GraphemeBreakType=e.$Vf=e.$Of=e.$Hf=e.$Gf=void 0,e.$8e=S,e.$9e=I,e.$0e=b,e.$$e=g,e.$_e=y,e.$af=v,e.$bf=w,e.$cf=m,e.$df=u,e.$ef=a,e.$ff=f,e.$gf=c,e.$hf=d,e.$if=p,e.$jf=E,e.$kf=h,e.$lf=t,e.$mf=s,e.$nf=r,e.$of=i,e.$pf=n,e.$qf=l,e.$rf=$,e.$sf=k,e.$tf=j,e.$uf=A,e.$vf=O,e.$wf=F,e.$xf=V,e.$yf=Z,e.$zf=oe,e.$Af=le,e.$Bf=te,e.$Cf=_,e.$Df=W,e.$Ef=K,e.$Ff=Y,e.$If=ie,e.$Jf=be,e.$Kf=re,e.$Lf=X,e.$Mf=z,e.$Nf=ue,e.$Pf=x,e.$Qf=G,e.$Rf=U,e.$Sf=T,e.$Tf=se,e.$Uf=ae,e.$Wf=me,e.$Xf=ee,e.$Yf=ge,e.$Zf=$e,e.$1f=Ce,e.$2f=je,e.$3f=de,e.$4f=Pe,e.$5f=Ve;function S(pe){return!pe||typeof pe!="string"?!0:pe.trim().length===0}const D=/{(\d+)}/g;function I(pe,...Ie){return Ie.length===0?pe:pe.replace(D,function(Re,Ae){const Te=parseInt(Ae,10);return isNaN(Te)||Te<0||Te>=Ie.length?Re:Ie[Te]})}const P=/{([^}]+)}/g;function b(pe,Ie){return Object.keys(Ie).length===0?pe:pe.replace(P,(Re,Ae)=>Ie[Ae]??Re)}function g(pe){return pe.replace(/[<>"'&]/g,Ie=>{switch(Ie){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Ie})}function y(pe){return pe.replace(/[<>&]/g,function(Ie){switch(Ie){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Ie}})}function v(pe){return pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function w(pe,Ie){let Re=0;const Ae=Ie.charCodeAt(0);for(let Te=pe.length-1;Te>=0;Te--)pe.charCodeAt(Te)===Ae&&Re++;return Re}function m(pe,Ie,Re="\u2026"){return pe.length<=Ie?pe:`${pe.substr(0,Ie)}${Re}`}function u(pe,Ie,Re="\u2026"){if(pe.length<=Ie)return pe;const Ae=Math.ceil(Ie/2)-Re.length/2,Te=Math.floor(Ie/2)-Re.length/2;return`${pe.substr(0,Ae)}${Re}${pe.substr(pe.length-Te)}`}function a(pe,Ie=" "){const Re=f(pe,Ie);return c(Re,Ie)}function f(pe,Ie){if(!pe||!Ie)return pe;const Re=Ie.length;if(Re===0||pe.length===0)return pe;let Ae=0;for(;pe.indexOf(Ie,Ae)===Ae;)Ae=Ae+Re;return pe.substring(Ae)}function c(pe,Ie){if(!pe||!Ie)return pe;const Re=Ie.length,Ae=pe.length;if(Re===0||Ae===0)return pe;let Te=Ae,Qe=-1;for(;Qe=pe.lastIndexOf(Ie,Te-1),!(Qe===-1||Qe+Re!==Te);){if(Qe===0)return"";Te=Qe}return pe.substring(0,Te)}function d(pe){return pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function p(pe){return pe.replace(/\*/g,"")}function E(pe,Ie,Re={}){if(!pe)throw new Error("Cannot create regex from empty string");Ie||(pe=v(pe)),Re.wholeWord&&(/\B/.test(pe.charAt(0))||(pe="\\b"+pe),/\B/.test(pe.charAt(pe.length-1))||(pe=pe+"\\b"));let Ae="";return Re.global&&(Ae+="g"),Re.matchCase||(Ae+="i"),Re.multiline&&(Ae+="m"),Re.unicode&&(Ae+="u"),new RegExp(pe,Ae)}function h(pe){return pe.source==="^"||pe.source==="^$"||pe.source==="$"||pe.source==="^\\s*$"?!1:!!(pe.exec("")&&pe.lastIndex===0)}function t(pe){return pe.split(/\r\n|\r|\n/)}function s(pe){const Ie=[],Re=pe.split(/(\r\n|\r|\n)/);for(let Ae=0;Ae<Math.ceil(Re.length/2);Ae++)Ie.push(Re[2*Ae]+(Re[2*Ae+1]??""));return Ie}function r(pe){for(let Ie=0,Re=pe.length;Ie<Re;Ie++){const Ae=pe.charCodeAt(Ie);if(Ae!==32&&Ae!==9)return Ie}return-1}function i(pe,Ie=0,Re=pe.length){for(let Ae=Ie;Ae<Re;Ae++){const Te=pe.charCodeAt(Ae);if(Te!==32&&Te!==9)return pe.substring(Ie,Ae)}return pe.substring(Ie,Re)}function n(pe,Ie=pe.length-1){for(let Re=Ie;Re>=0;Re--){const Ae=pe.charCodeAt(Re);if(Ae!==32&&Ae!==9)return Re}return-1}function l(pe,Ie,Re){const Ae=[];let Te=0;for(const Qe of pe.matchAll(Ie)){if(Ae.push(pe.slice(Te,Qe.index)),Qe.index===void 0)throw new Error("match.index should be defined");Te=Qe.index+Qe[0].length,Ae.push(Re(Qe[0],...Qe.slice(1),Qe.index,pe,Qe.groups))}return Ae.push(pe.slice(Te)),Promise.all(Ae).then(Qe=>Qe.join(""))}function $(pe,Ie){return pe<Ie?-1:pe>Ie?1:0}function k(pe,Ie,Re=0,Ae=pe.length,Te=0,Qe=Ie.length){for(;Re<Ae&&Te<Qe;Re++,Te++){const it=pe.charCodeAt(Re),Ke=Ie.charCodeAt(Te);if(it<Ke)return-1;if(it>Ke)return 1}const He=Ae-Re,Je=Qe-Te;return He<Je?-1:He>Je?1:0}function j(pe,Ie){return A(pe,Ie,0,pe.length,0,Ie.length)}function A(pe,Ie,Re=0,Ae=pe.length,Te=0,Qe=Ie.length){for(;Re<Ae&&Te<Qe;Re++,Te++){let it=pe.charCodeAt(Re),Ke=Ie.charCodeAt(Te);if(it===Ke)continue;if(it>=128||Ke>=128)return k(pe.toLowerCase(),Ie.toLowerCase(),Re,Ae,Te,Qe);F(it)&&(it-=32),F(Ke)&&(Ke-=32);const nt=it-Ke;if(nt!==0)return nt}const He=Ae-Re,Je=Qe-Te;return He<Je?-1:He>Je?1:0}function O(pe){return pe>=48&&pe<=57}function F(pe){return pe>=97&&pe<=122}function V(pe){return pe>=65&&pe<=90}function Z(pe,Ie){return pe.length===Ie.length&&A(pe,Ie)===0}function oe(pe,Ie){const Re=Ie.length;return Ie.length>pe.length?!1:A(pe,Ie,0,Re)===0}function le(pe,Ie){const Re=Math.min(pe.length,Ie.length);let Ae;for(Ae=0;Ae<Re;Ae++)if(pe.charCodeAt(Ae)!==Ie.charCodeAt(Ae))return Ae;return Re}function te(pe,Ie){const Re=Math.min(pe.length,Ie.length);let Ae;const Te=pe.length-1,Qe=Ie.length-1;for(Ae=0;Ae<Re;Ae++)if(pe.charCodeAt(Te-Ae)!==Ie.charCodeAt(Qe-Ae))return Ae;return Re}function _(pe){return 55296<=pe&&pe<=56319}function W(pe){return 56320<=pe&&pe<=57343}function K(pe,Ie){return(pe-55296<<10)+(Ie-56320)+65536}function Y(pe,Ie,Re){const Ae=pe.charCodeAt(Re);if(_(Ae)&&Re+1<Ie){const Te=pe.charCodeAt(Re+1);if(W(Te))return K(Ae,Te)}return Ae}function M(pe,Ie){const Re=pe.charCodeAt(Ie-1);if(W(Re)&&Ie>1){const Ae=pe.charCodeAt(Ie-2);if(_(Ae))return K(Ae,Re)}return Re}class Q{get offset(){return this.e}constructor(Ie,Re=0){this.c=Ie,this.d=Ie.length,this.e=Re}setOffset(Ie){this.e=Ie}prevCodePoint(){const Ie=M(this.c,this.e);return this.e-=Ie>=65536?2:1,Ie}nextCodePoint(){const Ie=Y(this.c,this.d,this.e);return this.e+=Ie>=65536?2:1,Ie}eol(){return this.e>=this.d}}e.$Gf=Q;class ce{get offset(){return this.c.offset}constructor(Ie,Re=0){this.c=new Q(Ie,Re)}nextGraphemeLength(){const Ie=Fe.getInstance(),Re=this.c,Ae=Re.offset;let Te=Ie.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const Qe=Re.offset,He=Ie.getGraphemeBreakType(Re.nextCodePoint());if(De(Te,He)){Re.setOffset(Qe);break}Te=He}return Re.offset-Ae}prevGraphemeLength(){const Ie=Fe.getInstance(),Re=this.c,Ae=Re.offset;let Te=Ie.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const Qe=Re.offset,He=Ie.getGraphemeBreakType(Re.prevCodePoint());if(De(He,Te)){Re.setOffset(Qe);break}Te=He}return Ae-Re.offset}eol(){return this.c.eol()}}e.$Hf=ce;function ie(pe,Ie){return new ce(pe,Ie).nextGraphemeLength()}function be(pe,Ie){return new ce(pe,Ie).prevGraphemeLength()}function re(pe,Ie){Ie>0&&W(pe.charCodeAt(Ie))&&Ie--;const Re=Ie+ie(pe,Ie);return[Re-be(pe,Re),Re]}function X(pe){const Ie=new ce(pe);let Re=0;for(;!Ie.eol();)Re++,Ie.nextGraphemeLength();return Re}let B;function N(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function z(pe){return B||(B=N()),B.test(pe)}const J=/^[\t\n\r\x20-\x7E]*$/;function ue(pe){return J.test(pe)}e.$Of=/[\u2028\u2029]/;function x(pe){return e.$Of.test(pe)}function G(pe){return pe>=11904&&pe<=55215||pe>=63744&&pe<=64255||pe>=65281&&pe<=65374}function U(pe){return pe>=127462&&pe<=127487||pe===8986||pe===8987||pe===9200||pe===9203||pe>=9728&&pe<=10175||pe===11088||pe===11093||pe>=127744&&pe<=128591||pe>=128640&&pe<=128764||pe>=128992&&pe<=129008||pe>=129280&&pe<=129535||pe>=129648&&pe<=129782}function T(pe,Ie,Re=""){const Ae=pe.trimStart();if(Ae.length<Ie)return Ae;const Te=/\b/g;let Qe=0;for(;Te.test(Ae)&&!(Ae.length-Te.lastIndex<Ie);)Qe=Te.lastIndex,Te.lastIndex+=1;return Qe===0?Ae:Re+Ae.substring(Qe).trimStart()}const q=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*se(pe){let Ie=0;for(const Re of pe.matchAll(q))Ie!==Re.index&&(yield{isCode:!1,str:pe.substring(Ie,Re.index)}),yield{isCode:!0,str:Re[0]},Ie=Re.index+Re[0].length;Ie!==pe.length&&(yield{isCode:!1,str:pe.substring(Ie)})}function ae(pe){return pe&&(pe=pe.replace(q,"")),pe}e.$Vf="\uFEFF";function me(pe){return!!(pe&&pe.length>0&&pe.charCodeAt(0)===65279)}function ee(pe){return me(pe)?pe.substr(1):pe}function ge(pe,Ie){if(!pe||!Ie||pe.length<Ie.length)return!1;const Re=Ie.length,Ae=pe.toLowerCase();let Te=0,Qe=-1;for(;Te<Re;){const He=Ae.indexOf(Ie[Te],Qe+1);if(He<0)return!1;Qe=He,Te++}return!0}function $e(pe,Ie=!1){return pe?(Ie&&(pe=pe.replace(/\\./g,"")),pe.toLowerCase()!==pe):!1}function Ce(pe){return pe.charAt(0).toUpperCase()+pe.slice(1)}function je(pe,Ie=1){if(Ie===0)return"";let Re=-1;do Re=pe.indexOf(`
`,Re+1),Ie--;while(Ie>0&&Re>=0);return Re===-1?pe:(pe[Re-1]==="\r"&&Re--,pe.substr(0,Re))}function de(pe){return pe=pe%(2*26),pe<26?String.fromCharCode(97+pe):String.fromCharCode(65+pe-26)}function Pe(pe){return Fe.getInstance().getGraphemeBreakType(pe)}function De(pe,Ie){return pe===0?Ie!==5&&Ie!==7:pe===2&&Ie===3?!1:pe===4||pe===2||pe===3||Ie===4||Ie===2||Ie===3?!0:!(pe===8&&(Ie===8||Ie===9||Ie===11||Ie===12)||(pe===11||pe===9)&&(Ie===9||Ie===10)||(pe===12||pe===10)&&Ie===10||Ie===5||Ie===13||Ie===7||pe===1||pe===13&&Ie===14||pe===6&&Ie===6)}var Me;(function(pe){pe[pe.Other=0]="Other",pe[pe.Prepend=1]="Prepend",pe[pe.CR=2]="CR",pe[pe.LF=3]="LF",pe[pe.Control=4]="Control",pe[pe.Extend=5]="Extend",pe[pe.Regional_Indicator=6]="Regional_Indicator",pe[pe.SpacingMark=7]="SpacingMark",pe[pe.L=8]="L",pe[pe.V=9]="V",pe[pe.T=10]="T",pe[pe.LV=11]="LV",pe[pe.LVT=12]="LVT",pe[pe.ZWJ=13]="ZWJ",pe[pe.Extended_Pictographic=14]="Extended_Pictographic"})(Me||(e.GraphemeBreakType=Me={}));class Fe{static{this.c=null}static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=Ue()}getGraphemeBreakType(Ie){if(Ie<32)return Ie===10?3:Ie===13?2:4;if(Ie<127)return 0;const Re=this.d,Ae=Re.length/3;let Te=1;for(;Te<=Ae;)if(Ie<Re[3*Te])Te=2*Te;else if(Ie>Re[3*Te+1])Te=2*Te+1;else return Re[3*Te+2];return 0}}function Ue(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ve(pe,Ie){if(pe===0)return 0;const Re=Ge(pe,Ie);if(Re!==void 0)return Re;const Ae=new Q(Ie,pe);return Ae.prevCodePoint(),Ae.offset}function Ge(pe,Ie){const Re=new Q(Ie,pe);let Ae=Re.prevCodePoint();for(;Ze(Ae)||Ae===65039||Ae===8419;){if(Re.offset===0)return;Ae=Re.prevCodePoint()}if(!U(Ae))return;let Te=Re.offset;return Te>0&&Re.prevCodePoint()===8205&&(Te=Re.offset),Te}function Ze(pe){return 127995<=pe&&pe<=127999}var _e;(function(pe){pe[pe.zwj=8205]="zwj",pe[pe.emojiVariantSelector=65039]="emojiVariantSelector",pe[pe.enclosingKeyCap=8419]="enclosingKeyCap"})(_e||(_e={})),e.$6f="\xA0";class et{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new o.$4e({getCacheKey:JSON.stringify},Ie=>{function Re(nt){const ot=new Map;for(let at=0;at<nt.length;at+=2)ot.set(nt[at],nt[at+1]);return ot}function Ae(nt,ot){const at=new Map(nt);for(const[lt,ht]of ot)at.set(lt,ht);return at}function Te(nt,ot){if(!nt)return ot;const at=new Map;for(const[lt,ht]of nt)ot.has(lt)&&at.set(lt,ht);return at}const Qe=this.c.value;let He=Ie.filter(nt=>!nt.startsWith("_")&&nt in Qe);He.length===0&&(He=["_default"]);let Je;for(const nt of He){const ot=Re(Qe[nt]);Je=Te(Je,ot)}const it=Re(Qe._common),Ke=Ae(it,Je);return new et(Ke)})}static getInstance(Ie){return et.d.get(Array.from(Ie))}static{this.e=new C.$V(()=>Object.keys(et.c.value).filter(Ie=>!Ie.startsWith("_")))}static getLocales(){return et.e.value}constructor(Ie){this.f=Ie}isAmbiguous(Ie){return this.f.has(Ie)}getPrimaryConfusable(Ie){return this.f.get(Ie)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$7f=et;class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(Ie){return xe.e().has(Ie)}static get codePoints(){return xe.e()}}e.$8f=xe}),define(ye[159],Ee([1,0,24,151,17]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jk=e.FuzzyScore=e.$yk=e.$xk=void 0,e.or=D,e.$zk=P,e.$Ak=b,e.$Bk=v,e.$Ck=l,e.$Dk=$,e.$Ek=V,e.$Fk=Z,e.$Gk=oe,e.$Hk=le,e.$Ik=z,e.$Kk=G,e.$Lk=q,e.$Mk=se;function D(...ee){return function(ge,$e){for(let Ce=0,je=ee.length;Ce<je;Ce++){const de=ee[Ce](ge,$e);if(de)return de}return null}}e.$xk=I.bind(void 0,!1),e.$yk=I.bind(void 0,!0);function I(ee,ge,$e){if(!$e||$e.length<ge.length)return null;let Ce;return ee?Ce=S.$zf($e,ge):Ce=$e.indexOf(ge)===0,Ce?ge.length>0?[{start:0,end:ge.length}]:[]:null}function P(ee,ge){const $e=ge.toLowerCase().indexOf(ee.toLowerCase());return $e===-1?null:[{start:$e,end:$e+ee.length}]}function b(ee,ge){return g(ee.toLowerCase(),ge.toLowerCase(),0,0)}function g(ee,ge,$e,Ce){if($e===ee.length)return[];if(Ce===ge.length)return null;if(ee[$e]===ge[Ce]){let je=null;return(je=g(ee,ge,$e+1,Ce+1))?E({start:Ce,end:Ce+1},je):null}return g(ee,ge,$e,Ce+1)}function y(ee){return 97<=ee&&ee<=122}function v(ee){return 65<=ee&&ee<=90}function w(ee){return 48<=ee&&ee<=57}function m(ee){return ee===32||ee===9||ee===10||ee===13}const u=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ee=>u.add(ee.charCodeAt(0)));function a(ee){return m(ee)||u.has(ee)}function f(ee,ge){return ee===ge||a(ee)&&a(ge)}const c=new Map;function d(ee){if(c.has(ee))return c.get(ee);let ge;const $e=(0,C.$vk)(ee);return $e&&(ge=$e),c.set(ee,ge),ge}function p(ee){return y(ee)||v(ee)||w(ee)}function E(ee,ge){return ge.length===0?ge=[ee]:ee.end===ge[0].start?ge[0].start=ee.start:ge.unshift(ee),ge}function h(ee,ge){for(let $e=ge;$e<ee.length;$e++){const Ce=ee.charCodeAt($e);if(v(Ce)||w(Ce)||$e>0&&!p(ee.charCodeAt($e-1)))return $e}return ee.length}function t(ee,ge,$e,Ce){if($e===ee.length)return[];if(Ce===ge.length)return null;if(ee[$e]!==ge[Ce].toLowerCase())return null;{let je=null,de=Ce+1;for(je=t(ee,ge,$e+1,Ce+1);!je&&(de=h(ge,de))<ge.length;)je=t(ee,ge,$e+1,de),de++;return je===null?null:E({start:Ce,end:Ce+1},je)}}function s(ee){let ge=0,$e=0,Ce=0,je=0,de=0;for(let Ue=0;Ue<ee.length;Ue++)de=ee.charCodeAt(Ue),v(de)&&ge++,y(de)&&$e++,p(de)&&Ce++,w(de)&&je++;const Pe=ge/ee.length,De=$e/ee.length,Me=Ce/ee.length,Fe=je/ee.length;return{upperPercent:Pe,lowerPercent:De,alphaPercent:Me,numericPercent:Fe}}function r(ee){const{upperPercent:ge,lowerPercent:$e}=ee;return $e===0&&ge>.6}function i(ee){const{upperPercent:ge,lowerPercent:$e,alphaPercent:Ce,numericPercent:je}=ee;return $e>.2&&ge<.8&&Ce>.6&&je<.2}function n(ee){let ge=0,$e=0,Ce=0,je=0;for(let de=0;de<ee.length;de++)Ce=ee.charCodeAt(de),v(Ce)&&ge++,y(Ce)&&$e++,m(Ce)&&je++;return(ge===0||$e===0)&&je===0?ee.length<=30:ge<=5}function l(ee,ge){if(!ge||(ge=ge.trim(),ge.length===0)||!n(ee))return null;ge.length>60&&(ge=ge.substring(0,60));const $e=s(ge);if(!i($e)){if(!r($e))return null;ge=ge.toLowerCase()}let Ce=null,je=0;for(ee=ee.toLowerCase();je<ge.length&&(Ce=t(ee,ge,0,je))===null;)je=h(ge,je+1);return Ce}function $(ee,ge,$e=!1){if(!ge||ge.length===0)return null;let Ce=null,je=0;for(ee=ee.toLowerCase(),ge=ge.toLowerCase();je<ge.length&&(Ce=k(ee,ge,0,je,$e),Ce===null);)je=j(ge,je+1);return Ce}function k(ee,ge,$e,Ce,je){let de=0;if($e===ee.length)return[];if(Ce===ge.length)return null;if(!f(ee.charCodeAt($e),ge.charCodeAt(Ce))){const Me=d(ee.charCodeAt($e));if(!Me)return null;for(let Fe=0;Fe<Me.length;Fe++)if(!f(Me[Fe],ge.charCodeAt(Ce+Fe)))return null;de+=Me.length-1}let Pe=null,De=Ce+de+1;if(Pe=k(ee,ge,$e+1,De,je),!je)for(;!Pe&&(De=j(ge,De))<ge.length;)Pe=k(ee,ge,$e+1,De,je),De++;if(!Pe)return null;if(ee.charCodeAt($e)!==ge.charCodeAt(Ce)){const Me=d(ee.charCodeAt($e));if(!Me)return Pe;for(let Fe=0;Fe<Me.length;Fe++)if(Me[Fe]!==ge.charCodeAt(Ce+Fe))return Pe}return E({start:Ce,end:Ce+de+1},Pe)}function j(ee,ge){for(let $e=ge;$e<ee.length;$e++)if(a(ee.charCodeAt($e))||$e>0&&a(ee.charCodeAt($e-1)))return $e;return ee.length}const A=D(e.$yk,l,P),O=D(e.$yk,l,b),F=new o.$Ec(1e4);function V(ee,ge,$e=!1){if(typeof ee!="string"||typeof ge!="string")return null;let Ce=F.get(ee);Ce||(Ce=new RegExp(S.$hf(ee),"i"),F.set(ee,Ce));const je=Ce.exec(ge);return je?[{start:je.index,end:je.index+je[0].length}]:$e?O(ee,ge):A(ee,ge)}function Z(ee,ge){const $e=G(ee,ee.toLowerCase(),0,ge,ge.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $e?le($e):null}function oe(ee,ge,$e,Ce,je,de){const Pe=Math.min(13,ee.length);for(;$e<Pe;$e++){const De=G(ee,ge,$e,Ce,je,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,de]}function le(ee){if(typeof ee>"u")return[];const ge=[],$e=ee[1];for(let Ce=ee.length-1;Ce>1;Ce--){const je=ee[Ce]+$e,de=ge[ge.length-1];de&&de.end===je?de.end=je+1:ge.push({start:je,end:je+1})}return ge}const te=128;function _(){const ee=[],ge=[];for(let $e=0;$e<=te;$e++)ge[$e]=0;for(let $e=0;$e<=te;$e++)ee.push(ge.slice(0));return ee}function W(ee){const ge=[];for(let $e=0;$e<=ee;$e++)ge[$e]=0;return ge}const K=W(2*te),Y=W(2*te),M=_(),Q=_(),ce=_(),ie=!1;function be(ee,ge,$e,Ce,je){function de(De,Me,Fe=" "){for(;De.length<Me;)De=Fe+De;return De}let Pe=` |   |${Ce.split("").map(De=>de(De,3)).join("|")}
`;for(let De=0;De<=$e;De++)De===0?Pe+=" |":Pe+=`${ge[De-1]}|`,Pe+=ee[De].slice(0,je+1).map(Me=>de(Me.toString(),3)).join("|")+`
`;return Pe}function re(ee,ge,$e,Ce){ee=ee.substr(ge),$e=$e.substr(Ce),console.log(be(Q,ee,ee.length,$e,$e.length)),console.log(be(ce,ee,ee.length,$e,$e.length)),console.log(be(M,ee,ee.length,$e,$e.length))}function X(ee,ge){if(ge<0||ge>=ee.length)return!1;const $e=ee.codePointAt(ge);switch($e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!S.$Rf($e)}}function B(ee,ge){if(ge<0||ge>=ee.length)return!1;switch(ee.charCodeAt(ge)){case 32:case 9:return!0;default:return!1}}function N(ee,ge,$e){return ge[ee]!==$e[ee]}function z(ee,ge,$e,Ce,je,de,Pe=!1){for(;ge<$e&&je<de;)ee[ge]===Ce[je]&&(Pe&&(K[ge]=je),ge+=1),je+=1;return ge===$e}var J;(function(ee){ee[ee.Diag=1]="Diag",ee[ee.Left=2]="Left",ee[ee.LeftLeft=3]="LeftLeft"})(J||(J={}));var ue;(function(ee){ee.Default=[-100,0];function ge($e){return!$e||$e.length===2&&$e[0]===-100&&$e[1]===0}ee.isDefault=ge})(ue||(e.FuzzyScore=ue={}));class x{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ge,$e){this.firstMatchCanBeWeak=ge,this.boostFullMatch=$e}}e.$Jk=x;function G(ee,ge,$e,Ce,je,de,Pe=x.default){const De=ee.length>te?te:ee.length,Me=Ce.length>te?te:Ce.length;if($e>=De||de>=Me||De-$e>Me-de||!z(ge,$e,De,je,de,Me,!0))return;U(De,Me,$e,de,ge,je);let Fe=1,Ue=1,Ve=$e,Ge=de;const Ze=[!1];for(Fe=1,Ve=$e;Ve<De;Fe++,Ve++){const Ie=K[Ve],Re=Y[Ve],Ae=Ve+1<De?Y[Ve+1]:Me;for(Ue=Ie-de+1,Ge=Ie;Ge<Ae;Ue++,Ge++){let Te=Number.MIN_SAFE_INTEGER,Qe=!1;Ge<=Re&&(Te=T(ee,ge,Ve,$e,Ce,je,Ge,Me,de,M[Fe-1][Ue-1]===0,Ze));let He=0;Te!==Number.MAX_SAFE_INTEGER&&(Qe=!0,He=Te+Q[Fe-1][Ue-1]);const Je=Ge>Ie,it=Je?Q[Fe][Ue-1]+(M[Fe][Ue-1]>0?-5:0):0,Ke=Ge>Ie+1&&M[Fe][Ue-1]>0,nt=Ke?Q[Fe][Ue-2]+(M[Fe][Ue-2]>0?-5:0):0;if(Ke&&(!Je||nt>=it)&&(!Qe||nt>=He))Q[Fe][Ue]=nt,ce[Fe][Ue]=3,M[Fe][Ue]=0;else if(Je&&(!Qe||it>=He))Q[Fe][Ue]=it,ce[Fe][Ue]=2,M[Fe][Ue]=0;else if(Qe)Q[Fe][Ue]=He,ce[Fe][Ue]=1,M[Fe][Ue]=M[Fe-1][Ue-1]+1;else throw new Error("not possible")}}if(ie&&re(ee,$e,Ce,de),!Ze[0]&&!Pe.firstMatchCanBeWeak)return;Fe--,Ue--;const _e=[Q[Fe][Ue],de];let et=0,xe=0;for(;Fe>=1;){let Ie=Ue;do{const Re=ce[Fe][Ie];if(Re===3)Ie=Ie-2;else if(Re===2)Ie=Ie-1;else break}while(Ie>=1);et>1&&ge[$e+Fe-1]===je[de+Ue-1]&&!N(Ie+de-1,Ce,je)&&et+1>M[Fe][Ie]&&(Ie=Ue),Ie===Ue?et++:et=1,xe||(xe=Ie),Fe--,Ue=Ie-1,_e.push(Ue)}Me===De&&Pe.boostFullMatch&&(_e[0]+=2);const pe=xe-De;return _e[0]-=pe,_e}function U(ee,ge,$e,Ce,je,de){let Pe=ee-1,De=ge-1;for(;Pe>=$e&&De>=Ce;)je[Pe]===de[De]&&(Y[Pe]=De,Pe--),De--}function T(ee,ge,$e,Ce,je,de,Pe,De,Me,Fe,Ue){if(ge[$e]!==de[Pe])return Number.MIN_SAFE_INTEGER;let Ve=1,Ge=!1;return Pe===$e-Ce?Ve=ee[$e]===je[Pe]?7:5:N(Pe,je,de)&&(Pe===0||!N(Pe-1,je,de))?(Ve=ee[$e]===je[Pe]?7:5,Ge=!0):X(de,Pe)&&(Pe===0||!X(de,Pe-1))?Ve=5:(X(de,Pe-1)||B(de,Pe-1))&&(Ve=5,Ge=!0),Ve>1&&$e===Ce&&(Ue[0]=!0),Ge||(Ge=N(Pe,je,de)||X(de,Pe-1)||B(de,Pe-1)),$e===Ce?Pe>Me&&(Ve-=Ge?3:5):Fe?Ve+=Ge?2:0:Ve+=Ge?0:1,Pe+1===De&&(Ve-=Ge?3:5),Ve}function q(ee,ge,$e,Ce,je,de,Pe){return ae(ee,ge,$e,Ce,je,de,!0,Pe)}function se(ee,ge,$e,Ce,je,de,Pe){return ae(ee,ge,$e,Ce,je,de,!1,Pe)}function ae(ee,ge,$e,Ce,je,de,Pe,De){let Me=G(ee,ge,$e,Ce,je,de,De);if(Me&&!Pe)return Me;if(ee.length>=3){const Fe=Math.min(7,ee.length-1);for(let Ue=$e+1;Ue<Fe;Ue++){const Ve=me(ee,Ue);if(Ve){const Ge=G(Ve,Ve.toLowerCase(),$e,Ce,je,de,De);Ge&&(Ge[0]-=3,(!Me||Ge[0]>Me[0])&&(Me=Ge))}}}return Me}function me(ee,ge){if(ge+1>=ee.length)return;const $e=ee[ge],Ce=ee[ge+1];if($e!==Ce)return ee.slice(0,ge)+Ce+$e+ee.slice(ge+2)}}),define(ye[62],Ee([1,0,17]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.$oj=void 0,e.$kj=C,e.$lj=S,e.$mj=D,e.$nj=P,e.$pj=a;function C(c){return S(c,0)}function S(c,d){switch(typeof c){case"object":return c===null?D(349,d):Array.isArray(c)?b(c,d):g(c,d);case"string":return P(c,d);case"boolean":return I(c,d);case"number":return D(c,d);case"undefined":return D(937,d);default:return D(617,d)}}function D(c,d){return(d<<5)-d+c|0}function I(c,d){return D(c?433:863,d)}function P(c,d){d=D(149417,d);for(let p=0,E=c.length;p<E;p++)d=D(c.charCodeAt(p),d);return d}function b(c,d){return d=D(104579,d),c.reduce((p,E)=>S(E,p),d)}function g(c,d){return d=D(181387,d),Object.keys(c).sort().reduce((p,E)=>(p=P(E,p),S(c[E],p)),d)}class y{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=S(d,this.g),this.g}}e.$oj=y;var v;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(v||(v={}));function w(c,d,p=32){const E=p-d,h=~((1<<E)-1);return(c<<d|(h&c)>>>E)>>>0}function m(c,d=0,p=c.byteLength,E=0){for(let h=0;h<p;h++)c[d+h]=E}function u(c,d,p="0"){for(;c.length<d;)c=p+c;return c}function a(c,d=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(p=>p.toString(16).padStart(2,"0")).join(""):u((c>>>0).toString(16),d/4)}class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const p=d.length;if(p===0)return;const E=this.p;let h=this.r,t=this.u,s,r;for(t!==0?(s=t,r=-1,t=0):(s=d.charCodeAt(0),r=0);;){let i=s;if(o.$Cf(s))if(r+1<p){const n=d.charCodeAt(r+1);o.$Df(n)?(r++,i=o.$Ef(s,n)):i=65533}else{t=s;break}else o.$Df(s)&&(i=65533);if(h=this.w(E,h,i),r++,r<p)s=d.charCodeAt(r);else break}this.r=h,this.u=t}w(d,p,E){return E<128?d[p++]=E:E<2048?(d[p++]=192|(E&1984)>>>6,d[p++]=128|(E&63)>>>0):E<65536?(d[p++]=224|(E&61440)>>>12,d[p++]=128|(E&4032)>>>6,d[p++]=128|(E&63)>>>0):(d[p++]=240|(E&1835008)>>>18,d[p++]=128|(E&258048)>>>12,d[p++]=128|(E&4032)>>>6,d[p++]=128|(E&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,d[0]=d[64],d[1]=d[65],d[2]=d[66]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),a(this.h)+a(this.l)+a(this.m)+a(this.n)+a(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=f.g,p=this.q;for(let $=0;$<64;$+=4)d.setUint32($,p.getUint32($,!1),!1);for(let $=64;$<320;$+=4)d.setUint32($,w(d.getUint32($-12,!1)^d.getUint32($-32,!1)^d.getUint32($-56,!1)^d.getUint32($-64,!1),1),!1);let E=this.h,h=this.l,t=this.m,s=this.n,r=this.o,i,n,l;for(let $=0;$<80;$++)$<20?(i=h&t|~h&s,n=1518500249):$<40?(i=h^t^s,n=1859775393):$<60?(i=h&t|h&s|t&s,n=2400959708):(i=h^t^s,n=3395469782),l=w(E,5)+i+r+n+d.getUint32($*4,!1)&4294967295,r=s,s=t,t=w(h,30),h=E,E=l;this.h=this.h+E&4294967295,this.l=this.l+h&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}e.$qj=f}),define(ye[63],Ee([1,0,17]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(C||(C={})),function(S){const D="error",I="warning",P="warn",b="info",g="ignore";function y(w){return w?o.$yf(D,w)?S.Error:o.$yf(I,w)||o.$yf(P,w)?S.Warning:o.$yf(b,w)?S.Info:S.Ignore:S.Ignore}S.fromValue=y;function v(w){switch(w){case S.Error:return D;case S.Warning:return I;case S.Info:return b;default:return g}}S.toString=v}(C||(C={})),e.default=C}),define(ye[160],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(ye[64],Ee([1,0,18,17]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=void 0;class S{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const u=m.charCodeAt(0),a=this.b.charCodeAt(this.c);return u-a}value(){return this.b[this.c]}}e.$yi=S;class D{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,C.$sf)(m,this.b,0,m.length,this.c,this.d):(0,C.$uf)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$zi=D;class I{constructor(m=!0,u=!0){this.f=m,this.g=u}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let u=m.length-1;u>=0;u--,this.c--){const a=this.b.charCodeAt(u);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const u=this.b.charCodeAt(this.e);if(u===47||this.f&&u===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,C.$sf)(m,this.b,0,m.length,this.d,this.e):(0,C.$uf)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ai=I;var P;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(P||(P={}));class b{constructor(m,u){this.f=m,this.g=u,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,C.$tf)(m,this.c.scheme);if(this.d[this.e]===2)return(0,C.$tf)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,C.$rf)(m,this.c.query);if(this.d[this.e]===5)return(0,C.$rf)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Bi=b;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var y;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(y||(y={}));class v{static forUris(m=()=>!1,u=()=>!1){return new v(new b(m,u))}static forPaths(m=!1){return new v(new I(void 0,!m))}static forStrings(){return new v(new S)}static forConfigKeys(){return new v(new D)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,u){if(u){const a=u.slice(0);(0,o.$Xb)(a);for(const f of a)this.set(f,m)}else{const a=m.slice(0);(0,o.$Xb)(a);for(const f of a)this.set(f[0],f[1])}}set(m,u){const a=this.b.reset(m);let f;this.c||(this.c=new g,this.c.segment=a.value());const c=[];for(f=this.c;;){const p=a.cmp(f.segment);if(p>0)f.left||(f.left=new g,f.left.segment=a.value()),c.push([-1,f]),f=f.left;else if(p<0)f.right||(f.right=new g,f.right.segment=a.value()),c.push([1,f]),f=f.right;else if(a.hasNext())a.next(),f.mid||(f.mid=new g,f.mid.segment=a.value()),c.push([0,f]),f=f.mid;else break}const d=f.value;f.value=u,f.key=m;for(let p=c.length-1;p>=0;p--){const E=c[p][1];E.updateHeight();const h=E.balanceFactor();if(h<-1||h>1){const t=c[p][0],s=c[p+1][0];if(t===1&&s===1)c[p][1]=E.rotateLeft();else if(t===-1&&s===-1)c[p][1]=E.rotateRight();else if(t===1&&s===-1)E.right=c[p+1][1]=c[p+1][1].rotateRight(),c[p][1]=E.rotateLeft();else if(t===-1&&s===1)E.left=c[p+1][1]=c[p+1][1].rotateLeft(),c[p][1]=E.rotateRight();else throw new Error;if(p>0)switch(c[p-1][0]){case-1:c[p-1][1].left=c[p][1];break;case 1:c[p-1][1].right=c[p][1];break;case 0:c[p-1][1].mid=c[p][1];break}else this.c=c[0][1]}}return d}get(m){return this.d(m)?.value}d(m){const u=this.b.reset(m);let a=this.c;for(;a;){const f=u.cmp(a.segment);if(f>0)a=a.left;else if(f<0)a=a.right;else if(u.hasNext())u.next(),a=a.mid;else break}return a}has(m){const u=this.d(m);return!(u?.value===void 0&&u?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,u){const a=this.b.reset(m),f=[];let c=this.c;for(;c;){const d=a.cmp(c.segment);if(d>0)f.push([-1,c]),c=c.left;else if(d<0)f.push([1,c]),c=c.right;else if(a.hasNext())a.next(),f.push([0,c]),c=c.mid;else break}if(c){if(u?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const d=this.f(c.right);if(d.key){const{key:p,value:E,segment:h}=d;this.e(d.key,!1),c.key=p,c.value=E,c.segment=h}}else{const d=c.left??c.right;if(f.length>0){const[p,E]=f[f.length-1];switch(p){case-1:E.left=d;break;case 0:E.mid=d;break;case 1:E.right=d;break}}else this.c=d}for(let d=f.length-1;d>=0;d--){const p=f[d][1];p.updateHeight();const E=p.balanceFactor();if(E>1?(p.right.balanceFactor()>=0||(p.right=p.right.rotateRight()),f[d][1]=p.rotateLeft()):E<-1&&(p.left.balanceFactor()<=0||(p.left=p.left.rotateLeft()),f[d][1]=p.rotateRight()),d>0)switch(f[d-1][0]){case-1:f[d-1][1].left=f[d][1];break;case 1:f[d-1][1].right=f[d][1];break;case 0:f[d-1][1].mid=f[d][1];break}else this.c=f[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const u=this.b.reset(m);let a=this.c,f;for(;a;){const c=u.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(u.hasNext())u.next(),f=a.value||f,a=a.mid;else break}return a&&a.value||f}findSuperstr(m){return this.g(m,!1)}g(m,u){const a=this.b.reset(m);let f=this.c;for(;f;){const c=a.cmp(f.segment);if(c>0)f=f.left;else if(c<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else return f.mid?this.h(f.mid):u?f.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[u,a]of this)m(a,u)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const u=[];return this.j(m,u),u[Symbol.iterator]()}j(m,u){m&&(m.left&&this.j(m.left,u),m.value&&u.push([m.key,m.value]),m.mid&&this.j(m.mid,u),m.right&&this.j(m.right,u))}_isBalanced(){const m=u=>{if(!u)return!0;const a=u.balanceFactor();return a<-1||a>1?!1:m(u.left)&&m(u.right)};return m(this.c)}}e.$Ci=v}),define(ye[10],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9f=o,e.$0f=C,e.$$f=S,e.$_f=D,e.$ag=I,e.$bg=P,e.$cg=b,e.$dg=g,e.$eg=y,e.$fg=v,e.$gg=w,e.$hg=m,e.$ig=u,e.$jg=f,e.$kg=c,e.$lg=d,e.$mg=p,e.$ng=E;function o(h){return typeof h=="string"}function C(h){return Array.isArray(h)&&h.every(t=>o(t))}function S(h){return typeof h=="object"&&h!==null&&!Array.isArray(h)&&!(h instanceof RegExp)&&!(h instanceof Date)}function D(h){const t=Object.getPrototypeOf(Uint8Array);return typeof h=="object"&&h instanceof t}function I(h){return typeof h=="number"&&!isNaN(h)}function P(h){return!!h&&typeof h[Symbol.iterator]=="function"}function b(h){return h===!0||h===!1}function g(h){return typeof h>"u"}function y(h){return!v(h)}function v(h){return g(h)||h===null}function w(h,t){if(!h)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function m(h){if(v(h))throw new Error("Assertion Failed: argument is undefined or null");return h}function u(...h){const t=[];for(let s=0;s<h.length;s++){const r=h[s];if(v(r))throw new Error(`Assertion Failed: argument at index ${s} is undefined or null`);t.push(r)}return t}const a=Object.prototype.hasOwnProperty;function f(h){if(!S(h))return!1;for(const t in h)if(a.call(h,t))return!1;return!0}function c(h){return typeof h=="function"}function d(...h){return h.length>0&&h.every(c)}function p(h,t){const s=Math.min(h.length,t.length);for(let r=0;r<s;r++)E(h[r],t[r])}function E(h,t){if(o(t)){if(typeof h!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(c(t)){try{if(h instanceof t)return}catch{}if(!v(h)&&h.constructor===t||t.length===1&&t.call(void 0,h)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(ye[100],Ee([1,0,10]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=S,e.$Rj=D;const C=Object.create(null);function S(I,P){if((0,o.$9f)(P)){const b=C[P];if(b===void 0)throw new Error(`${I} references an unknown codicon: ${P}`);P=b}return C[I]=P,{id:I}}function D(){return C}}),define(ye[161],Ee([1,0,100]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=void 0,e.$Sj={add:(0,o.$Qj)("add",6e4),plus:(0,o.$Qj)("plus",6e4),gistNew:(0,o.$Qj)("gist-new",6e4),repoCreate:(0,o.$Qj)("repo-create",6e4),lightbulb:(0,o.$Qj)("lightbulb",60001),lightBulb:(0,o.$Qj)("light-bulb",60001),repo:(0,o.$Qj)("repo",60002),repoDelete:(0,o.$Qj)("repo-delete",60002),gistFork:(0,o.$Qj)("gist-fork",60003),repoForked:(0,o.$Qj)("repo-forked",60003),gitPullRequest:(0,o.$Qj)("git-pull-request",60004),gitPullRequestAbandoned:(0,o.$Qj)("git-pull-request-abandoned",60004),recordKeys:(0,o.$Qj)("record-keys",60005),keyboard:(0,o.$Qj)("keyboard",60005),tag:(0,o.$Qj)("tag",60006),gitPullRequestLabel:(0,o.$Qj)("git-pull-request-label",60006),tagAdd:(0,o.$Qj)("tag-add",60006),tagRemove:(0,o.$Qj)("tag-remove",60006),person:(0,o.$Qj)("person",60007),personFollow:(0,o.$Qj)("person-follow",60007),personOutline:(0,o.$Qj)("person-outline",60007),personFilled:(0,o.$Qj)("person-filled",60007),gitBranch:(0,o.$Qj)("git-branch",60008),gitBranchCreate:(0,o.$Qj)("git-branch-create",60008),gitBranchDelete:(0,o.$Qj)("git-branch-delete",60008),sourceControl:(0,o.$Qj)("source-control",60008),mirror:(0,o.$Qj)("mirror",60009),mirrorPublic:(0,o.$Qj)("mirror-public",60009),star:(0,o.$Qj)("star",60010),starAdd:(0,o.$Qj)("star-add",60010),starDelete:(0,o.$Qj)("star-delete",60010),starEmpty:(0,o.$Qj)("star-empty",60010),comment:(0,o.$Qj)("comment",60011),commentAdd:(0,o.$Qj)("comment-add",60011),alert:(0,o.$Qj)("alert",60012),warning:(0,o.$Qj)("warning",60012),search:(0,o.$Qj)("search",60013),searchSave:(0,o.$Qj)("search-save",60013),logOut:(0,o.$Qj)("log-out",60014),signOut:(0,o.$Qj)("sign-out",60014),logIn:(0,o.$Qj)("log-in",60015),signIn:(0,o.$Qj)("sign-in",60015),eye:(0,o.$Qj)("eye",60016),eyeUnwatch:(0,o.$Qj)("eye-unwatch",60016),eyeWatch:(0,o.$Qj)("eye-watch",60016),circleFilled:(0,o.$Qj)("circle-filled",60017),primitiveDot:(0,o.$Qj)("primitive-dot",60017),closeDirty:(0,o.$Qj)("close-dirty",60017),debugBreakpoint:(0,o.$Qj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,o.$Qj)("debug-breakpoint-disabled",60017),debugHint:(0,o.$Qj)("debug-hint",60017),terminalDecorationSuccess:(0,o.$Qj)("terminal-decoration-success",60017),primitiveSquare:(0,o.$Qj)("primitive-square",60018),edit:(0,o.$Qj)("edit",60019),pencil:(0,o.$Qj)("pencil",60019),info:(0,o.$Qj)("info",60020),issueOpened:(0,o.$Qj)("issue-opened",60020),gistPrivate:(0,o.$Qj)("gist-private",60021),gitForkPrivate:(0,o.$Qj)("git-fork-private",60021),lock:(0,o.$Qj)("lock",60021),mirrorPrivate:(0,o.$Qj)("mirror-private",60021),close:(0,o.$Qj)("close",60022),removeClose:(0,o.$Qj)("remove-close",60022),x:(0,o.$Qj)("x",60022),repoSync:(0,o.$Qj)("repo-sync",60023),sync:(0,o.$Qj)("sync",60023),clone:(0,o.$Qj)("clone",60024),desktopDownload:(0,o.$Qj)("desktop-download",60024),beaker:(0,o.$Qj)("beaker",60025),microscope:(0,o.$Qj)("microscope",60025),vm:(0,o.$Qj)("vm",60026),deviceDesktop:(0,o.$Qj)("device-desktop",60026),file:(0,o.$Qj)("file",60027),fileText:(0,o.$Qj)("file-text",60027),more:(0,o.$Qj)("more",60028),ellipsis:(0,o.$Qj)("ellipsis",60028),kebabHorizontal:(0,o.$Qj)("kebab-horizontal",60028),mailReply:(0,o.$Qj)("mail-reply",60029),reply:(0,o.$Qj)("reply",60029),organization:(0,o.$Qj)("organization",60030),organizationFilled:(0,o.$Qj)("organization-filled",60030),organizationOutline:(0,o.$Qj)("organization-outline",60030),newFile:(0,o.$Qj)("new-file",60031),fileAdd:(0,o.$Qj)("file-add",60031),newFolder:(0,o.$Qj)("new-folder",60032),fileDirectoryCreate:(0,o.$Qj)("file-directory-create",60032),trash:(0,o.$Qj)("trash",60033),trashcan:(0,o.$Qj)("trashcan",60033),history:(0,o.$Qj)("history",60034),clock:(0,o.$Qj)("clock",60034),folder:(0,o.$Qj)("folder",60035),fileDirectory:(0,o.$Qj)("file-directory",60035),symbolFolder:(0,o.$Qj)("symbol-folder",60035),logoGithub:(0,o.$Qj)("logo-github",60036),markGithub:(0,o.$Qj)("mark-github",60036),github:(0,o.$Qj)("github",60036),terminal:(0,o.$Qj)("terminal",60037),console:(0,o.$Qj)("console",60037),repl:(0,o.$Qj)("repl",60037),zap:(0,o.$Qj)("zap",60038),symbolEvent:(0,o.$Qj)("symbol-event",60038),error:(0,o.$Qj)("error",60039),stop:(0,o.$Qj)("stop",60039),variable:(0,o.$Qj)("variable",60040),symbolVariable:(0,o.$Qj)("symbol-variable",60040),array:(0,o.$Qj)("array",60042),symbolArray:(0,o.$Qj)("symbol-array",60042),symbolModule:(0,o.$Qj)("symbol-module",60043),symbolPackage:(0,o.$Qj)("symbol-package",60043),symbolNamespace:(0,o.$Qj)("symbol-namespace",60043),symbolObject:(0,o.$Qj)("symbol-object",60043),symbolMethod:(0,o.$Qj)("symbol-method",60044),symbolFunction:(0,o.$Qj)("symbol-function",60044),symbolConstructor:(0,o.$Qj)("symbol-constructor",60044),symbolBoolean:(0,o.$Qj)("symbol-boolean",60047),symbolNull:(0,o.$Qj)("symbol-null",60047),symbolNumeric:(0,o.$Qj)("symbol-numeric",60048),symbolNumber:(0,o.$Qj)("symbol-number",60048),symbolStructure:(0,o.$Qj)("symbol-structure",60049),symbolStruct:(0,o.$Qj)("symbol-struct",60049),symbolParameter:(0,o.$Qj)("symbol-parameter",60050),symbolTypeParameter:(0,o.$Qj)("symbol-type-parameter",60050),symbolKey:(0,o.$Qj)("symbol-key",60051),symbolText:(0,o.$Qj)("symbol-text",60051),symbolReference:(0,o.$Qj)("symbol-reference",60052),goToFile:(0,o.$Qj)("go-to-file",60052),symbolEnum:(0,o.$Qj)("symbol-enum",60053),symbolValue:(0,o.$Qj)("symbol-value",60053),symbolRuler:(0,o.$Qj)("symbol-ruler",60054),symbolUnit:(0,o.$Qj)("symbol-unit",60054),activateBreakpoints:(0,o.$Qj)("activate-breakpoints",60055),archive:(0,o.$Qj)("archive",60056),arrowBoth:(0,o.$Qj)("arrow-both",60057),arrowDown:(0,o.$Qj)("arrow-down",60058),arrowLeft:(0,o.$Qj)("arrow-left",60059),arrowRight:(0,o.$Qj)("arrow-right",60060),arrowSmallDown:(0,o.$Qj)("arrow-small-down",60061),arrowSmallLeft:(0,o.$Qj)("arrow-small-left",60062),arrowSmallRight:(0,o.$Qj)("arrow-small-right",60063),arrowSmallUp:(0,o.$Qj)("arrow-small-up",60064),arrowUp:(0,o.$Qj)("arrow-up",60065),bell:(0,o.$Qj)("bell",60066),bold:(0,o.$Qj)("bold",60067),book:(0,o.$Qj)("book",60068),bookmark:(0,o.$Qj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,o.$Qj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,o.$Qj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,o.$Qj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,o.$Qj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,o.$Qj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,o.$Qj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,o.$Qj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,o.$Qj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,o.$Qj)("debug-breakpoint-log-disabled",60075),briefcase:(0,o.$Qj)("briefcase",60076),broadcast:(0,o.$Qj)("broadcast",60077),browser:(0,o.$Qj)("browser",60078),bug:(0,o.$Qj)("bug",60079),calendar:(0,o.$Qj)("calendar",60080),caseSensitive:(0,o.$Qj)("case-sensitive",60081),check:(0,o.$Qj)("check",60082),checklist:(0,o.$Qj)("checklist",60083),chevronDown:(0,o.$Qj)("chevron-down",60084),chevronLeft:(0,o.$Qj)("chevron-left",60085),chevronRight:(0,o.$Qj)("chevron-right",60086),chevronUp:(0,o.$Qj)("chevron-up",60087),chromeClose:(0,o.$Qj)("chrome-close",60088),chromeMaximize:(0,o.$Qj)("chrome-maximize",60089),chromeMinimize:(0,o.$Qj)("chrome-minimize",60090),chromeRestore:(0,o.$Qj)("chrome-restore",60091),circleOutline:(0,o.$Qj)("circle-outline",60092),circle:(0,o.$Qj)("circle",60092),debugBreakpointUnverified:(0,o.$Qj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,o.$Qj)("terminal-decoration-incomplete",60092),circleSlash:(0,o.$Qj)("circle-slash",60093),circuitBoard:(0,o.$Qj)("circuit-board",60094),clearAll:(0,o.$Qj)("clear-all",60095),clippy:(0,o.$Qj)("clippy",60096),closeAll:(0,o.$Qj)("close-all",60097),cloudDownload:(0,o.$Qj)("cloud-download",60098),cloudUpload:(0,o.$Qj)("cloud-upload",60099),code:(0,o.$Qj)("code",60100),collapseAll:(0,o.$Qj)("collapse-all",60101),colorMode:(0,o.$Qj)("color-mode",60102),commentDiscussion:(0,o.$Qj)("comment-discussion",60103),creditCard:(0,o.$Qj)("credit-card",60105),dash:(0,o.$Qj)("dash",60108),dashboard:(0,o.$Qj)("dashboard",60109),database:(0,o.$Qj)("database",60110),debugContinue:(0,o.$Qj)("debug-continue",60111),debugDisconnect:(0,o.$Qj)("debug-disconnect",60112),debugPause:(0,o.$Qj)("debug-pause",60113),debugRestart:(0,o.$Qj)("debug-restart",60114),debugStart:(0,o.$Qj)("debug-start",60115),debugStepInto:(0,o.$Qj)("debug-step-into",60116),debugStepOut:(0,o.$Qj)("debug-step-out",60117),debugStepOver:(0,o.$Qj)("debug-step-over",60118),debugStop:(0,o.$Qj)("debug-stop",60119),debug:(0,o.$Qj)("debug",60120),deviceCameraVideo:(0,o.$Qj)("device-camera-video",60121),deviceCamera:(0,o.$Qj)("device-camera",60122),deviceMobile:(0,o.$Qj)("device-mobile",60123),diffAdded:(0,o.$Qj)("diff-added",60124),diffIgnored:(0,o.$Qj)("diff-ignored",60125),diffModified:(0,o.$Qj)("diff-modified",60126),diffRemoved:(0,o.$Qj)("diff-removed",60127),diffRenamed:(0,o.$Qj)("diff-renamed",60128),diff:(0,o.$Qj)("diff",60129),diffSidebyside:(0,o.$Qj)("diff-sidebyside",60129),discard:(0,o.$Qj)("discard",60130),editorLayout:(0,o.$Qj)("editor-layout",60131),emptyWindow:(0,o.$Qj)("empty-window",60132),exclude:(0,o.$Qj)("exclude",60133),extensions:(0,o.$Qj)("extensions",60134),eyeClosed:(0,o.$Qj)("eye-closed",60135),fileBinary:(0,o.$Qj)("file-binary",60136),fileCode:(0,o.$Qj)("file-code",60137),fileMedia:(0,o.$Qj)("file-media",60138),filePdf:(0,o.$Qj)("file-pdf",60139),fileSubmodule:(0,o.$Qj)("file-submodule",60140),fileSymlinkDirectory:(0,o.$Qj)("file-symlink-directory",60141),fileSymlinkFile:(0,o.$Qj)("file-symlink-file",60142),fileZip:(0,o.$Qj)("file-zip",60143),files:(0,o.$Qj)("files",60144),filter:(0,o.$Qj)("filter",60145),flame:(0,o.$Qj)("flame",60146),foldDown:(0,o.$Qj)("fold-down",60147),foldUp:(0,o.$Qj)("fold-up",60148),fold:(0,o.$Qj)("fold",60149),folderActive:(0,o.$Qj)("folder-active",60150),folderOpened:(0,o.$Qj)("folder-opened",60151),gear:(0,o.$Qj)("gear",60152),gift:(0,o.$Qj)("gift",60153),gistSecret:(0,o.$Qj)("gist-secret",60154),gist:(0,o.$Qj)("gist",60155),gitCommit:(0,o.$Qj)("git-commit",60156),gitCompare:(0,o.$Qj)("git-compare",60157),compareChanges:(0,o.$Qj)("compare-changes",60157),gitMerge:(0,o.$Qj)("git-merge",60158),githubAction:(0,o.$Qj)("github-action",60159),githubAlt:(0,o.$Qj)("github-alt",60160),globe:(0,o.$Qj)("globe",60161),grabber:(0,o.$Qj)("grabber",60162),graph:(0,o.$Qj)("graph",60163),gripper:(0,o.$Qj)("gripper",60164),heart:(0,o.$Qj)("heart",60165),home:(0,o.$Qj)("home",60166),horizontalRule:(0,o.$Qj)("horizontal-rule",60167),hubot:(0,o.$Qj)("hubot",60168),inbox:(0,o.$Qj)("inbox",60169),issueReopened:(0,o.$Qj)("issue-reopened",60171),issues:(0,o.$Qj)("issues",60172),italic:(0,o.$Qj)("italic",60173),jersey:(0,o.$Qj)("jersey",60174),json:(0,o.$Qj)("json",60175),kebabVertical:(0,o.$Qj)("kebab-vertical",60176),key:(0,o.$Qj)("key",60177),law:(0,o.$Qj)("law",60178),lightbulbAutofix:(0,o.$Qj)("lightbulb-autofix",60179),linkExternal:(0,o.$Qj)("link-external",60180),link:(0,o.$Qj)("link",60181),listOrdered:(0,o.$Qj)("list-ordered",60182),listUnordered:(0,o.$Qj)("list-unordered",60183),liveShare:(0,o.$Qj)("live-share",60184),loading:(0,o.$Qj)("loading",60185),location:(0,o.$Qj)("location",60186),mailRead:(0,o.$Qj)("mail-read",60187),mail:(0,o.$Qj)("mail",60188),markdown:(0,o.$Qj)("markdown",60189),megaphone:(0,o.$Qj)("megaphone",60190),mention:(0,o.$Qj)("mention",60191),milestone:(0,o.$Qj)("milestone",60192),gitPullRequestMilestone:(0,o.$Qj)("git-pull-request-milestone",60192),mortarBoard:(0,o.$Qj)("mortar-board",60193),move:(0,o.$Qj)("move",60194),multipleWindows:(0,o.$Qj)("multiple-windows",60195),mute:(0,o.$Qj)("mute",60196),noNewline:(0,o.$Qj)("no-newline",60197),note:(0,o.$Qj)("note",60198),octoface:(0,o.$Qj)("octoface",60199),openPreview:(0,o.$Qj)("open-preview",60200),package:(0,o.$Qj)("package",60201),paintcan:(0,o.$Qj)("paintcan",60202),pin:(0,o.$Qj)("pin",60203),play:(0,o.$Qj)("play",60204),run:(0,o.$Qj)("run",60204),plug:(0,o.$Qj)("plug",60205),preserveCase:(0,o.$Qj)("preserve-case",60206),preview:(0,o.$Qj)("preview",60207),project:(0,o.$Qj)("project",60208),pulse:(0,o.$Qj)("pulse",60209),question:(0,o.$Qj)("question",60210),quote:(0,o.$Qj)("quote",60211),radioTower:(0,o.$Qj)("radio-tower",60212),reactions:(0,o.$Qj)("reactions",60213),references:(0,o.$Qj)("references",60214),refresh:(0,o.$Qj)("refresh",60215),regex:(0,o.$Qj)("regex",60216),remoteExplorer:(0,o.$Qj)("remote-explorer",60217),remote:(0,o.$Qj)("remote",60218),remove:(0,o.$Qj)("remove",60219),replaceAll:(0,o.$Qj)("replace-all",60220),replace:(0,o.$Qj)("replace",60221),repoClone:(0,o.$Qj)("repo-clone",60222),repoForcePush:(0,o.$Qj)("repo-force-push",60223),repoPull:(0,o.$Qj)("repo-pull",60224),repoPush:(0,o.$Qj)("repo-push",60225),report:(0,o.$Qj)("report",60226),requestChanges:(0,o.$Qj)("request-changes",60227),rocket:(0,o.$Qj)("rocket",60228),rootFolderOpened:(0,o.$Qj)("root-folder-opened",60229),rootFolder:(0,o.$Qj)("root-folder",60230),rss:(0,o.$Qj)("rss",60231),ruby:(0,o.$Qj)("ruby",60232),saveAll:(0,o.$Qj)("save-all",60233),saveAs:(0,o.$Qj)("save-as",60234),save:(0,o.$Qj)("save",60235),screenFull:(0,o.$Qj)("screen-full",60236),screenNormal:(0,o.$Qj)("screen-normal",60237),searchStop:(0,o.$Qj)("search-stop",60238),server:(0,o.$Qj)("server",60240),settingsGear:(0,o.$Qj)("settings-gear",60241),settings:(0,o.$Qj)("settings",60242),shield:(0,o.$Qj)("shield",60243),smiley:(0,o.$Qj)("smiley",60244),sortPrecedence:(0,o.$Qj)("sort-precedence",60245),splitHorizontal:(0,o.$Qj)("split-horizontal",60246),splitVertical:(0,o.$Qj)("split-vertical",60247),squirrel:(0,o.$Qj)("squirrel",60248),starFull:(0,o.$Qj)("star-full",60249),starHalf:(0,o.$Qj)("star-half",60250),symbolClass:(0,o.$Qj)("symbol-class",60251),symbolColor:(0,o.$Qj)("symbol-color",60252),symbolConstant:(0,o.$Qj)("symbol-constant",60253),symbolEnumMember:(0,o.$Qj)("symbol-enum-member",60254),symbolField:(0,o.$Qj)("symbol-field",60255),symbolFile:(0,o.$Qj)("symbol-file",60256),symbolInterface:(0,o.$Qj)("symbol-interface",60257),symbolKeyword:(0,o.$Qj)("symbol-keyword",60258),symbolMisc:(0,o.$Qj)("symbol-misc",60259),symbolOperator:(0,o.$Qj)("symbol-operator",60260),symbolProperty:(0,o.$Qj)("symbol-property",60261),wrench:(0,o.$Qj)("wrench",60261),wrenchSubaction:(0,o.$Qj)("wrench-subaction",60261),symbolSnippet:(0,o.$Qj)("symbol-snippet",60262),tasklist:(0,o.$Qj)("tasklist",60263),telescope:(0,o.$Qj)("telescope",60264),textSize:(0,o.$Qj)("text-size",60265),threeBars:(0,o.$Qj)("three-bars",60266),thumbsdown:(0,o.$Qj)("thumbsdown",60267),thumbsup:(0,o.$Qj)("thumbsup",60268),tools:(0,o.$Qj)("tools",60269),triangleDown:(0,o.$Qj)("triangle-down",60270),triangleLeft:(0,o.$Qj)("triangle-left",60271),triangleRight:(0,o.$Qj)("triangle-right",60272),triangleUp:(0,o.$Qj)("triangle-up",60273),twitter:(0,o.$Qj)("twitter",60274),unfold:(0,o.$Qj)("unfold",60275),unlock:(0,o.$Qj)("unlock",60276),unmute:(0,o.$Qj)("unmute",60277),unverified:(0,o.$Qj)("unverified",60278),verified:(0,o.$Qj)("verified",60279),versions:(0,o.$Qj)("versions",60280),vmActive:(0,o.$Qj)("vm-active",60281),vmOutline:(0,o.$Qj)("vm-outline",60282),vmRunning:(0,o.$Qj)("vm-running",60283),watch:(0,o.$Qj)("watch",60284),whitespace:(0,o.$Qj)("whitespace",60285),wholeWord:(0,o.$Qj)("whole-word",60286),window:(0,o.$Qj)("window",60287),wordWrap:(0,o.$Qj)("word-wrap",60288),zoomIn:(0,o.$Qj)("zoom-in",60289),zoomOut:(0,o.$Qj)("zoom-out",60290),listFilter:(0,o.$Qj)("list-filter",60291),listFlat:(0,o.$Qj)("list-flat",60292),listSelection:(0,o.$Qj)("list-selection",60293),selection:(0,o.$Qj)("selection",60293),listTree:(0,o.$Qj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,o.$Qj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,o.$Qj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,o.$Qj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,o.$Qj)("debug-stackframe-active",60297),circleSmallFilled:(0,o.$Qj)("circle-small-filled",60298),debugStackframeDot:(0,o.$Qj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,o.$Qj)("terminal-decoration-mark",60298),debugStackframe:(0,o.$Qj)("debug-stackframe",60299),debugStackframeFocused:(0,o.$Qj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,o.$Qj)("debug-breakpoint-unsupported",60300),symbolString:(0,o.$Qj)("symbol-string",60301),debugReverseContinue:(0,o.$Qj)("debug-reverse-continue",60302),debugStepBack:(0,o.$Qj)("debug-step-back",60303),debugRestartFrame:(0,o.$Qj)("debug-restart-frame",60304),debugAlt:(0,o.$Qj)("debug-alt",60305),callIncoming:(0,o.$Qj)("call-incoming",60306),callOutgoing:(0,o.$Qj)("call-outgoing",60307),menu:(0,o.$Qj)("menu",60308),expandAll:(0,o.$Qj)("expand-all",60309),feedback:(0,o.$Qj)("feedback",60310),gitPullRequestReviewer:(0,o.$Qj)("git-pull-request-reviewer",60310),groupByRefType:(0,o.$Qj)("group-by-ref-type",60311),ungroupByRefType:(0,o.$Qj)("ungroup-by-ref-type",60312),account:(0,o.$Qj)("account",60313),gitPullRequestAssignee:(0,o.$Qj)("git-pull-request-assignee",60313),bellDot:(0,o.$Qj)("bell-dot",60314),debugConsole:(0,o.$Qj)("debug-console",60315),library:(0,o.$Qj)("library",60316),output:(0,o.$Qj)("output",60317),runAll:(0,o.$Qj)("run-all",60318),syncIgnored:(0,o.$Qj)("sync-ignored",60319),pinned:(0,o.$Qj)("pinned",60320),githubInverted:(0,o.$Qj)("github-inverted",60321),serverProcess:(0,o.$Qj)("server-process",60322),serverEnvironment:(0,o.$Qj)("server-environment",60323),pass:(0,o.$Qj)("pass",60324),issueClosed:(0,o.$Qj)("issue-closed",60324),stopCircle:(0,o.$Qj)("stop-circle",60325),playCircle:(0,o.$Qj)("play-circle",60326),record:(0,o.$Qj)("record",60327),debugAltSmall:(0,o.$Qj)("debug-alt-small",60328),vmConnect:(0,o.$Qj)("vm-connect",60329),cloud:(0,o.$Qj)("cloud",60330),merge:(0,o.$Qj)("merge",60331),export:(0,o.$Qj)("export",60332),graphLeft:(0,o.$Qj)("graph-left",60333),magnet:(0,o.$Qj)("magnet",60334),notebook:(0,o.$Qj)("notebook",60335),redo:(0,o.$Qj)("redo",60336),checkAll:(0,o.$Qj)("check-all",60337),pinnedDirty:(0,o.$Qj)("pinned-dirty",60338),passFilled:(0,o.$Qj)("pass-filled",60339),circleLargeFilled:(0,o.$Qj)("circle-large-filled",60340),circleLarge:(0,o.$Qj)("circle-large",60341),circleLargeOutline:(0,o.$Qj)("circle-large-outline",60341),combine:(0,o.$Qj)("combine",60342),gather:(0,o.$Qj)("gather",60342),table:(0,o.$Qj)("table",60343),variableGroup:(0,o.$Qj)("variable-group",60344),typeHierarchy:(0,o.$Qj)("type-hierarchy",60345),typeHierarchySub:(0,o.$Qj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,o.$Qj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,o.$Qj)("git-pull-request-create",60348),runAbove:(0,o.$Qj)("run-above",60349),runBelow:(0,o.$Qj)("run-below",60350),notebookTemplate:(0,o.$Qj)("notebook-template",60351),debugRerun:(0,o.$Qj)("debug-rerun",60352),workspaceTrusted:(0,o.$Qj)("workspace-trusted",60353),workspaceUntrusted:(0,o.$Qj)("workspace-untrusted",60354),workspaceUnknown:(0,o.$Qj)("workspace-unknown",60355),terminalCmd:(0,o.$Qj)("terminal-cmd",60356),terminalDebian:(0,o.$Qj)("terminal-debian",60357),terminalLinux:(0,o.$Qj)("terminal-linux",60358),terminalPowershell:(0,o.$Qj)("terminal-powershell",60359),terminalTmux:(0,o.$Qj)("terminal-tmux",60360),terminalUbuntu:(0,o.$Qj)("terminal-ubuntu",60361),terminalBash:(0,o.$Qj)("terminal-bash",60362),arrowSwap:(0,o.$Qj)("arrow-swap",60363),copy:(0,o.$Qj)("copy",60364),personAdd:(0,o.$Qj)("person-add",60365),filterFilled:(0,o.$Qj)("filter-filled",60366),wand:(0,o.$Qj)("wand",60367),debugLineByLine:(0,o.$Qj)("debug-line-by-line",60368),inspect:(0,o.$Qj)("inspect",60369),layers:(0,o.$Qj)("layers",60370),layersDot:(0,o.$Qj)("layers-dot",60371),layersActive:(0,o.$Qj)("layers-active",60372),compass:(0,o.$Qj)("compass",60373),compassDot:(0,o.$Qj)("compass-dot",60374),compassActive:(0,o.$Qj)("compass-active",60375),azure:(0,o.$Qj)("azure",60376),issueDraft:(0,o.$Qj)("issue-draft",60377),gitPullRequestClosed:(0,o.$Qj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,o.$Qj)("git-pull-request-draft",60379),debugAll:(0,o.$Qj)("debug-all",60380),debugCoverage:(0,o.$Qj)("debug-coverage",60381),runErrors:(0,o.$Qj)("run-errors",60382),folderLibrary:(0,o.$Qj)("folder-library",60383),debugContinueSmall:(0,o.$Qj)("debug-continue-small",60384),beakerStop:(0,o.$Qj)("beaker-stop",60385),graphLine:(0,o.$Qj)("graph-line",60386),graphScatter:(0,o.$Qj)("graph-scatter",60387),pieChart:(0,o.$Qj)("pie-chart",60388),bracket:(0,o.$Qj)("bracket",60175),bracketDot:(0,o.$Qj)("bracket-dot",60389),bracketError:(0,o.$Qj)("bracket-error",60390),lockSmall:(0,o.$Qj)("lock-small",60391),azureDevops:(0,o.$Qj)("azure-devops",60392),verifiedFilled:(0,o.$Qj)("verified-filled",60393),newline:(0,o.$Qj)("newline",60394),layout:(0,o.$Qj)("layout",60395),layoutActivitybarLeft:(0,o.$Qj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,o.$Qj)("layout-activitybar-right",60397),layoutPanelLeft:(0,o.$Qj)("layout-panel-left",60398),layoutPanelCenter:(0,o.$Qj)("layout-panel-center",60399),layoutPanelJustify:(0,o.$Qj)("layout-panel-justify",60400),layoutPanelRight:(0,o.$Qj)("layout-panel-right",60401),layoutPanel:(0,o.$Qj)("layout-panel",60402),layoutSidebarLeft:(0,o.$Qj)("layout-sidebar-left",60403),layoutSidebarRight:(0,o.$Qj)("layout-sidebar-right",60404),layoutStatusbar:(0,o.$Qj)("layout-statusbar",60405),layoutMenubar:(0,o.$Qj)("layout-menubar",60406),layoutCentered:(0,o.$Qj)("layout-centered",60407),target:(0,o.$Qj)("target",60408),indent:(0,o.$Qj)("indent",60409),recordSmall:(0,o.$Qj)("record-small",60410),errorSmall:(0,o.$Qj)("error-small",60411),terminalDecorationError:(0,o.$Qj)("terminal-decoration-error",60411),arrowCircleDown:(0,o.$Qj)("arrow-circle-down",60412),arrowCircleLeft:(0,o.$Qj)("arrow-circle-left",60413),arrowCircleRight:(0,o.$Qj)("arrow-circle-right",60414),arrowCircleUp:(0,o.$Qj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,o.$Qj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,o.$Qj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,o.$Qj)("layout-sidebar-left-off",60418),blank:(0,o.$Qj)("blank",60419),heartFilled:(0,o.$Qj)("heart-filled",60420),map:(0,o.$Qj)("map",60421),mapHorizontal:(0,o.$Qj)("map-horizontal",60421),foldHorizontal:(0,o.$Qj)("fold-horizontal",60421),mapFilled:(0,o.$Qj)("map-filled",60422),mapHorizontalFilled:(0,o.$Qj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,o.$Qj)("fold-horizontal-filled",60422),circleSmall:(0,o.$Qj)("circle-small",60423),bellSlash:(0,o.$Qj)("bell-slash",60424),bellSlashDot:(0,o.$Qj)("bell-slash-dot",60425),commentUnresolved:(0,o.$Qj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,o.$Qj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,o.$Qj)("git-pull-request-new-changes",60428),searchFuzzy:(0,o.$Qj)("search-fuzzy",60429),commentDraft:(0,o.$Qj)("comment-draft",60430),send:(0,o.$Qj)("send",60431),sparkle:(0,o.$Qj)("sparkle",60432),insert:(0,o.$Qj)("insert",60433),mic:(0,o.$Qj)("mic",60434),thumbsdownFilled:(0,o.$Qj)("thumbsdown-filled",60435),thumbsupFilled:(0,o.$Qj)("thumbsup-filled",60436),coffee:(0,o.$Qj)("coffee",60437),snake:(0,o.$Qj)("snake",60438),game:(0,o.$Qj)("game",60439),vr:(0,o.$Qj)("vr",60440),chip:(0,o.$Qj)("chip",60441),piano:(0,o.$Qj)("piano",60442),music:(0,o.$Qj)("music",60443),micFilled:(0,o.$Qj)("mic-filled",60444),repoFetch:(0,o.$Qj)("repo-fetch",60445),copilot:(0,o.$Qj)("copilot",60446),lightbulbSparkle:(0,o.$Qj)("lightbulb-sparkle",60447),robot:(0,o.$Qj)("robot",60448),sparkleFilled:(0,o.$Qj)("sparkle-filled",60449),diffSingle:(0,o.$Qj)("diff-single",60450),diffMultiple:(0,o.$Qj)("diff-multiple",60451),surroundWith:(0,o.$Qj)("surround-with",60452),share:(0,o.$Qj)("share",60453),gitStash:(0,o.$Qj)("git-stash",60454),gitStashApply:(0,o.$Qj)("git-stash-apply",60455),gitStashPop:(0,o.$Qj)("git-stash-pop",60456),vscode:(0,o.$Qj)("vscode",60457),vscodeInsiders:(0,o.$Qj)("vscode-insiders",60458),codeOss:(0,o.$Qj)("code-oss",60459),runCoverage:(0,o.$Qj)("run-coverage",60460),runAllCoverage:(0,o.$Qj)("run-all-coverage",60461),coverage:(0,o.$Qj)("coverage",60462),githubProject:(0,o.$Qj)("github-project",60463),mapVertical:(0,o.$Qj)("map-vertical",60464),foldVertical:(0,o.$Qj)("fold-vertical",60464),mapVerticalFilled:(0,o.$Qj)("map-vertical-filled",60465),foldVerticalFilled:(0,o.$Qj)("fold-vertical-filled",60465),goToSearch:(0,o.$Qj)("go-to-search",60466),percentage:(0,o.$Qj)("percentage",60467),sortPercentage:(0,o.$Qj)("sort-percentage",60467)}}),define(ye[53],Ee([1,0,100,161]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vj=e.$Uj=void 0,e.$Tj=S;function S(){return Object.values(e.$Vj)}e.$Uj={dialogError:(0,o.$Qj)("dialog-error","error"),dialogWarning:(0,o.$Qj)("dialog-warning","warning"),dialogInfo:(0,o.$Qj)("dialog-info","info"),dialogClose:(0,o.$Qj)("dialog-close","close"),treeItemExpanded:(0,o.$Qj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,o.$Qj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,o.$Qj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,o.$Qj)("tree-filter-clear","close"),treeItemLoading:(0,o.$Qj)("tree-item-loading","loading"),menuSelection:(0,o.$Qj)("menu-selection","check"),menuSubmenu:(0,o.$Qj)("menu-submenu","chevron-right"),menuBarMore:(0,o.$Qj)("menubar-more","more"),scrollbarButtonLeft:(0,o.$Qj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,o.$Qj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,o.$Qj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,o.$Qj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,o.$Qj)("toolbar-more","more"),quickInputBack:(0,o.$Qj)("quick-input-back","arrow-left"),dropDownButton:(0,o.$Qj)("drop-down-button",60084),symbolCustomColor:(0,o.$Qj)("symbol-customcolor",60252),exportIcon:(0,o.$Qj)("export",60332),workspaceUnspecified:(0,o.$Qj)("workspace-unspecified",60355),newLine:(0,o.$Qj)("newline",60394),thumbsDownFilled:(0,o.$Qj)("thumbsdown-filled",60435),thumbsUpFilled:(0,o.$Qj)("thumbsup-filled",60436),gitFetch:(0,o.$Qj)("git-fetch",60445),lightbulbSparkleAutofix:(0,o.$Qj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,o.$Qj)("debug-breakpoint-pending",60377)},e.$Vj={...C.$Sj,...e.$Uj}}),define(ye[21],Ee([1,0,10]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3n=C,e.$4n=S,e.$5n=I,e.$6n=b,e.$7n=g,e.$8n=y,e.$9n=v,e.$0n=w,e.$$n=m,e.$_n=u,e.$ao=a,e.$bo=f;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const d=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([p,E])=>{d[p]=E&&typeof E=="object"?C(E):E}),d}function S(c){if(!c||typeof c!="object")return c;const d=[c];for(;d.length>0;){const p=d.shift();Object.freeze(p);for(const E in p)if(D.call(p,E)){const h=p[E];typeof h=="object"&&!Object.isFrozen(h)&&!(0,o.$_f)(h)&&d.push(h)}}return c}const D=Object.prototype.hasOwnProperty;function I(c,d){return P(c,d,new Set)}function P(c,d,p){if((0,o.$fg)(c))return c;const E=d(c);if(typeof E<"u")return E;if(Array.isArray(c)){const h=[];for(const t of c)h.push(P(t,d,p));return h}if((0,o.$$f)(c)){if(p.has(c))throw new Error("Cannot clone recursive data-structure");p.add(c);const h={};for(const t in c)D.call(c,t)&&(h[t]=P(c[t],d,p));return p.delete(c),h}return c}function b(c,d,p=!0){return(0,o.$$f)(c)?((0,o.$$f)(d)&&Object.keys(d).forEach(E=>{E in c?p&&((0,o.$$f)(c[E])&&(0,o.$$f)(d[E])?b(c[E],d[E],p):c[E]=d[E]):c[E]=d[E]}),c):d}function g(c,d){if(c===d)return!0;if(c==null||d===null||d===void 0||typeof c!=typeof d||typeof c!="object"||Array.isArray(c)!==Array.isArray(d))return!1;let p,E;if(Array.isArray(c)){if(c.length!==d.length)return!1;for(p=0;p<c.length;p++)if(!g(c[p],d[p]))return!1}else{const h=[];for(E in c)h.push(E);h.sort();const t=[];for(E in d)t.push(E);if(t.sort(),!g(h,t))return!1;for(p=0;p<h.length;p++)if(!g(c[h[p]],d[h[p]]))return!1}return!0}function y(c){const d=new Set;return JSON.stringify(c,(p,E)=>{if((0,o.$$f)(E)||Array.isArray(E)){if(d.has(E))return"[Circular]";d.add(E)}return typeof E=="bigint"?`[BigInt ${E.toString()}]`:E})}function v(c,d){const p=Object.create(null);return!c||!d||Object.keys(d).forEach(h=>{const t=c[h],s=d[h];g(t,s)||(p[h]=s)}),p}function w(c,d){const p=d.toLowerCase(),E=Object.keys(c).find(h=>h.toLowerCase()===p);return E?c[E]:c[d]}function m(c,d){const p=Object.create(null);for(const[E,h]of Object.entries(c))d(E,h)&&(p[E]=h);return p}function u(c){let d=[];for(;Object.prototype!==c;)d=d.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return d}function a(c){const d=[];for(const p of u(c))typeof c[p]=="function"&&d.push(p);return d}function f(c,d){const p=h=>function(){const t=Array.prototype.slice.call(arguments,0);return d(h,t)},E={};for(const h of c)E[h]=p(h);return E}}),define(ye[76],Ee([1,0,53]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Wj=S;var C;(function(I){function P(b){return b&&typeof b=="object"&&typeof b.id=="string"}I.isThemeColor=P})(C||(e.ThemeColor=C={}));function S(I){return{id:I}}var D;(function(I){I.iconNameSegment="[A-Za-z0-9]+",I.iconNameExpression="[A-Za-z0-9-]+",I.iconModifierExpression="~[A-Za-z]+",I.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${I.iconNameExpression})(${I.iconModifierExpression})?$`);function b(d){const p=P.exec(d.id);if(!p)return b(o.$Vj.error);const[,E,h]=p,t=["codicon","codicon-"+E];return h&&t.push("codicon-modifier-"+h.substring(1)),t}I.asClassNameArray=b;function g(d){return b(d).join(" ")}I.asClassName=g;function y(d){return"."+b(d).join(".")}I.asCSSSelector=y;function v(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||C.isThemeColor(d.color))}I.isThemeIcon=v;const w=new RegExp(`^\\$\\((${I.iconNameExpression}(?:${I.iconModifierExpression})?)\\)$`);function m(d){const p=w.exec(d);if(!p)return;const[,E]=p;return{id:E}}I.fromString=m;function u(d){return{id:d}}I.fromId=u;function a(d,p){let E=d.id;const h=E.lastIndexOf("~");return h!==-1&&(E=E.substring(0,h)),p&&(E=`${E}~${p}`),{id:E}}I.modify=a;function f(d){const p=d.id.lastIndexOf("~");if(p!==-1)return d.id.substring(p+1)}I.getModifier=f;function c(d,p){return d.id===p.id&&d.color?.id===p.color?.id}I.isEqual=c})(D||(e.ThemeIcon=D={}))}),define(ye[162],Ee([1,0,159,17,76]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nk=b,e.$Ok=y,e.$Pk=w,e.$Qk=m,e.$Rk=a,e.$Sk=f;const D="$(",I=new RegExp(`\\$\\(${S.ThemeIcon.iconNameExpression}(?:${S.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${I.source}`,"g");function b(c){return c.replace(P,(d,p)=>p?d:`\\${d}`)}const g=new RegExp(`\\\\${I.source}`,"g");function y(c){return c.replace(g,d=>`\\${d}`)}const v=new RegExp(`(\\s)?(\\\\)?${I.source}(\\s)?`,"g");function w(c){return c.indexOf(D)===-1?c:c.replace(v,(d,p,E,h)=>E?d:p||h||"")}function m(c){return c?c.replace(/\$\((.*?)\)/g,(d,p)=>` ${p} `).trim():""}const u=new RegExp(`\\$\\(${S.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(c){u.lastIndex=0;let d="";const p=[];let E=0;for(;;){const h=u.lastIndex,t=u.exec(c),s=c.substring(h,t?.index);if(s.length>0){d+=s;for(let r=0;r<s.length;r++)p.push(E)}if(!t)break;E+=t[0].length}return{text:d,iconOffsets:p}}function f(c,d,p=!1){const{text:E,iconOffsets:h}=d;if(!h||h.length===0)return(0,o.$Ek)(c,E,p);const t=(0,C.$ff)(E," "),s=E.length-t.length,r=(0,o.$Ek)(c,t,p);if(r)for(const i of r){const n=h[i.start+s]+s;i.start+=n,i.end+=n}return r}}),define(ye[22],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=void 0,e.$Rg=C;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(S){return o.test(S)}e.$Sg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let S;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?S=crypto.getRandomValues.bind(crypto):S=function(P){for(let b=0;b<P.length;b++)P[b]=Math.floor(Math.random()*256);return P};const D=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){S(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let b=0,g="";return g+=I[D[b++]],g+=I[D[b++]],g+=I[D[b++]],g+=I[D[b++]],g+="-",g+=I[D[b++]],g+=I[D[b++]],g+="-",g+=I[D[b++]],g+=I[D[b++]],g+="-",g+=I[D[b++]],g+=I[D[b++]],g+="-",g+=I[D[b++]],g+=I[D[b++]],g+=I[D[b++]],g+=I[D[b++]],g+=I[D[b++]],g+=I[D[b++]],g}}()}),define(ye[163],Ee([1,0,18,41,22]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$St=void 0,e.$Qt=D,e.$Rt=I,e.$Tt=g;function D(v){return{asString:async()=>v,asFile:()=>{},value:typeof v=="string"?v:void 0}}function I(v,w,m){const u={id:(0,S.$Sg)(),name:v,uri:w,data:m};return{asString:async()=>"",asFile:()=>u,value:void 0}}class P{constructor(){this.a=new Map}get size(){let w=0;for(const m of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const m=[...this.a.keys()];return C.Iterable.some(this,([u,a])=>a.asFile())&&m.push("files"),y(b(w),m)}get(w){return this.a.get(this.b(w))?.[0]}append(w,m){const u=this.a.get(w);u?u.push(m):this.a.set(this.b(w),[m])}replace(w,m){this.a.set(this.b(w),[m])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,m]of this.a)for(const u of m)yield[w,u]}b(w){return b(w)}}e.$St=P;function b(v){return v.toLowerCase()}function g(v,w){return y(b(v),w.map(b))}function y(v,w){if(v==="*/*")return w.length>0;if(w.includes(v))return!0;const m=v.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!m)return!1;const[u,a,f]=m;return f==="*"?w.some(c=>c.startsWith(a+"/")):!1}e.$Ut=Object.freeze({create:v=>(0,o.$Mb)(v.map(w=>w.toString())).join(`\r
`),split:v=>v.split(`\r
`),parse:v=>e.$Ut.split(v).filter(w=>!w.startsWith("#"))})}),function(){"use strict";function he(e,o,C){function S(m){return new Promise(u=>o.exists(m,u))}function D(m){return new Promise((u,a)=>{const f=new Date;o.utimes(m,f,f,c=>c?a(c):u())})}function I(m){return new Promise((u,a)=>o.mkdir(m,{recursive:!0},f=>f&&f.code!=="EEXIST"?a(f):u(m)))}function P(m){return new Promise((u,a)=>o.rm(m,{recursive:!0,force:!0,maxRetries:3},f=>f?a(f):u()))}function b(m){return new Promise((u,a)=>o.readFile(m,"utf8",(f,c)=>f?a(f):u(c)))}function g(m,u){return new Promise((a,f)=>o.writeFile(m,u,"utf8",c=>c?f(c):a()))}async function y(m){const u=e.join(m,"languagepacks.json");try{return JSON.parse(await b(u))}catch{}}function v(m,u){try{for(;u;){if(m[u])return u;{const a=u.lastIndexOf("-");if(a>0)u=u.substring(0,a);else return}}}catch(a){console.error("Resolving language pack configuration failed.",a)}}function w(m,u,a,f,c){const d=function(E){return C.mark("code/didGenerateNls"),Promise.resolve({locale:E,osLocale:c,availableLanguages:{}})};if(C.mark("code/willGenerateNls"),f==="pseudo")return Promise.resolve({locale:f,osLocale:c,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:f,osLocale:c,availableLanguages:{}});if(f&&(f==="en"||f==="en-us"))return Promise.resolve({locale:f,osLocale:c,availableLanguages:{}});const p=f;try{return m?y(u).then(E=>{if(!E)return d(p);const h=v(E,f);if(!h)return d(p);f=h;const t=E[f];let s;return!t||typeof t.hash!="string"||!t.translations||typeof(s=t.translations.vscode)!="string"?d(p):S(s).then(r=>{if(!r)return d(p);const i=t.hash+"."+f,n=e.join(u,"clp",i),l=e.join(n,m),$=e.join(n,"tcf.json"),k=e.join(n,"corrupted.info"),j={locale:p,osLocale:c,availableLanguages:{"*":f},_languagePackId:i,_translationsConfigFile:$,_cacheRoot:n,_resolvedLanguagePackCoreLocation:l,_corruptedFile:k};return S(k).then(A=>{let O;return A?O=P(n):O=Promise.resolve(void 0),O.then(()=>S(l).then(F=>F?(D(l).catch(()=>{}),C.mark("code/didGenerateNls"),j):I(l).then(()=>Promise.all([b(a),b(s)])).then(V=>{const Z=JSON.parse(V[0]),oe=JSON.parse(V[1]).contents,le=Object.keys(Z.bundles),te=[];for(const _ of le){const W=Z.bundles[_],K=Object.create(null);for(const Y of W){const M=Z.keys[Y],Q=Z.messages[Y],ce=oe[Y];let ie;if(ce){ie=[];for(let be=0;be<M.length;be++){const re=M[be],X=typeof re=="string"?re:re.key;let B=ce[X];B===void 0&&(B=Q[be]),ie.push(B)}}else ie=Q;K[Y]=ie}te.push(g(e.join(l,_.replace(/\//g,"!")+".nls.json"),JSON.stringify(K)))}return te.push(g($,JSON.stringify(t.translations))),Promise.all(te)}).then(()=>(C.mark("code/didGenerateNls"),j)).catch(V=>(console.error("Generating translation files failed.",V),d(f)))))})})}):d(p)}catch(E){return console.error("Generating translation files failed.",E),d(f)}}return{getNLSConfiguration:w}}if(typeof define=="function")define(ye[164],Ee([77,27,44]),function(e,o,C){return he(e,o,C)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),o=require("fs"),C=require("../common/performance");module.exports=he(e,o,C)}else throw new Error("Unknown context")}(),define(ye[165],Ee([1,0,30]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=D;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function S(I){const P=I.replace(/\-/g,":").toLowerCase();return!C.has(P)}function D(){const I=(0,o.networkInterfaces)();for(const P in I){const b=I[P];if(b){for(const{mac:g}of b)if(S(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(ye[166],Ee([1,0,78]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vg=void 0,e.$Ug=C,e.$Wg=D;function C(P,b,g,y=1){let v=!1;return new Promise(w=>{const m=setTimeout(()=>{if(!v)return v=!0,w(0)},g);S(P,b,y,u=>{if(!v)return v=!0,clearTimeout(m),w(u)})})}function S(P,b,g,y){if(b===0)return y(0);const v=new o.Socket;v.once("connect",()=>(I(v),S(P+g,b-1,g,y))),v.once("data",()=>{}),v.once("error",w=>(I(v),w.code!=="ECONNREFUSED"?S(P+g,b-1,g,y):y(P))),v.connect(P,"127.0.0.1")}e.$Vg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function D(P,b,g,y="127.0.0.1"){let v=!1,w,m=1;const u=o.createServer({pauseOnConnect:!0});function a(f,c){v||(v=!0,u.removeAllListeners(),u.close(),w&&clearTimeout(w),c(f))}return new Promise(f=>{w=setTimeout(()=>{a(0,f)},g),u.on("listening",()=>{a(P,f)}),u.on("error",c=>{c&&(c.code==="EADDRINUSE"||c.code==="EACCES")&&m<b?(P++,m++,u.listen(P,y)):a(0,f)}),u.on("close",()=>{a(0,f)}),u.listen(P,y)})}function I(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(b){console.error(b)}}}),function(){function he(){function e(){return process.uncHostAllowlist}function o(b){const g=new Set;if(Array.isArray(b))for(const y of b)typeof y=="string"&&g.add(y);return Array.from(g)}function C(){const b=e();return b?Array.from(b):[]}function S(b){if(process.platform!=="win32")return;const g=e();if(g)if(typeof b=="string")g.add(b.toLowerCase());else for(const y of o(b))S(y)}function D(b){if(typeof b!="string")return;const g=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let y;for(const v of g){if(b.indexOf(v)!==0)continue;const m=b.indexOf("\\",v.length);if(m===-1)continue;const u=b.substring(v.length,m);if(u){y=u;break}}return y}function I(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function P(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:S,getUNCHost:D,disableUNCAccessRestrictions:I,isUNCAccessRestrictionsDisabled:P}}typeof define=="function"?define("vs/base/node/unc",[],function(){return he()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=he():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(ye[79],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class o{constructor(S,D){this.lineNumber=S,this.column=D}with(S=this.lineNumber,D=this.column){return S===this.lineNumber&&D===this.column?this:new o(S,D)}delta(S=0,D=0){return this.with(this.lineNumber+S,this.column+D)}equals(S){return o.equals(this,S)}static equals(S,D){return!S&&!D?!0:!!S&&!!D&&S.lineNumber===D.lineNumber&&S.column===D.column}isBefore(S){return o.isBefore(this,S)}static isBefore(S,D){return S.lineNumber<D.lineNumber?!0:D.lineNumber<S.lineNumber?!1:S.column<D.column}isBeforeOrEqual(S){return o.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,D){return S.lineNumber<D.lineNumber?!0:D.lineNumber<S.lineNumber?!1:S.column<=D.column}static compare(S,D){const I=S.lineNumber|0,P=D.lineNumber|0;if(I===P){const b=S.column|0,g=D.column|0;return b-g}return I-P}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new o(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$tt=o}),define(ye[45],Ee([1,0,79]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=void 0;class C{constructor(D,I,P,b){D>P||D===P&&I>b?(this.startLineNumber=P,this.startColumn=b,this.endLineNumber=D,this.endColumn=I):(this.startLineNumber=D,this.startColumn=I,this.endLineNumber=P,this.endColumn=b)}isEmpty(){return C.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return C.containsPosition(this,D)}static containsPosition(D,I){return!(I.lineNumber<D.startLineNumber||I.lineNumber>D.endLineNumber||I.lineNumber===D.startLineNumber&&I.column<D.startColumn||I.lineNumber===D.endLineNumber&&I.column>D.endColumn)}static strictContainsPosition(D,I){return!(I.lineNumber<D.startLineNumber||I.lineNumber>D.endLineNumber||I.lineNumber===D.startLineNumber&&I.column<=D.startColumn||I.lineNumber===D.endLineNumber&&I.column>=D.endColumn)}containsRange(D){return C.containsRange(this,D)}static containsRange(D,I){return!(I.startLineNumber<D.startLineNumber||I.endLineNumber<D.startLineNumber||I.startLineNumber>D.endLineNumber||I.endLineNumber>D.endLineNumber||I.startLineNumber===D.startLineNumber&&I.startColumn<D.startColumn||I.endLineNumber===D.endLineNumber&&I.endColumn>D.endColumn)}strictContainsRange(D){return C.strictContainsRange(this,D)}static strictContainsRange(D,I){return!(I.startLineNumber<D.startLineNumber||I.endLineNumber<D.startLineNumber||I.startLineNumber>D.endLineNumber||I.endLineNumber>D.endLineNumber||I.startLineNumber===D.startLineNumber&&I.startColumn<=D.startColumn||I.endLineNumber===D.endLineNumber&&I.endColumn>=D.endColumn)}plusRange(D){return C.plusRange(this,D)}static plusRange(D,I){let P,b,g,y;return I.startLineNumber<D.startLineNumber?(P=I.startLineNumber,b=I.startColumn):I.startLineNumber===D.startLineNumber?(P=I.startLineNumber,b=Math.min(I.startColumn,D.startColumn)):(P=D.startLineNumber,b=D.startColumn),I.endLineNumber>D.endLineNumber?(g=I.endLineNumber,y=I.endColumn):I.endLineNumber===D.endLineNumber?(g=I.endLineNumber,y=Math.max(I.endColumn,D.endColumn)):(g=D.endLineNumber,y=D.endColumn),new C(P,b,g,y)}intersectRanges(D){return C.intersectRanges(this,D)}static intersectRanges(D,I){let P=D.startLineNumber,b=D.startColumn,g=D.endLineNumber,y=D.endColumn;const v=I.startLineNumber,w=I.startColumn,m=I.endLineNumber,u=I.endColumn;return P<v?(P=v,b=w):P===v&&(b=Math.max(b,w)),g>m?(g=m,y=u):g===m&&(y=Math.min(y,u)),P>g||P===g&&b>y?null:new C(P,b,g,y)}equalsRange(D){return C.equalsRange(this,D)}static equalsRange(D,I){return!D&&!I?!0:!!D&&!!I&&D.startLineNumber===I.startLineNumber&&D.startColumn===I.startColumn&&D.endLineNumber===I.endLineNumber&&D.endColumn===I.endColumn}getEndPosition(){return C.getEndPosition(this)}static getEndPosition(D){return new o.$tt(D.endLineNumber,D.endColumn)}getStartPosition(){return C.getStartPosition(this)}static getStartPosition(D){return new o.$tt(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,I){return new C(this.startLineNumber,this.startColumn,D,I)}setStartPosition(D,I){return new C(D,I,this.endLineNumber,this.endColumn)}collapseToStart(){return C.collapseToStart(this)}static collapseToStart(D){return new C(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}collapseToEnd(){return C.collapseToEnd(this)}static collapseToEnd(D){return new C(D.endLineNumber,D.endColumn,D.endLineNumber,D.endColumn)}delta(D){return new C(this.startLineNumber+D,this.startColumn,this.endLineNumber+D,this.endColumn)}static fromPositions(D,I=D){return new C(D.lineNumber,D.column,I.lineNumber,I.column)}static lift(D){return D?new C(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,I){return!(D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn||I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn)}static areIntersecting(D,I){return!(D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn||I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,I){if(D&&I){const g=D.startLineNumber|0,y=I.startLineNumber|0;if(g===y){const v=D.startColumn|0,w=I.startColumn|0;if(v===w){const m=D.endLineNumber|0,u=I.endLineNumber|0;if(m===u){const a=D.endColumn|0,f=I.endColumn|0;return a-f}return m-u}return v-w}return g-y}return(D?1:0)-(I?1:0)}static compareRangesUsingEnds(D,I){return D.endLineNumber===I.endLineNumber?D.endColumn===I.endColumn?D.startLineNumber===I.startLineNumber?D.startColumn-I.startColumn:D.startLineNumber-I.startLineNumber:D.endColumn-I.endColumn:D.endLineNumber-I.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}toJSON(){return this}}e.$ut=C}),define(ye[167],Ee([1,0,45]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class C{static insert(D,I){return{range:new o.$ut(D.lineNumber,D.column,D.lineNumber,D.column),text:I,forceMoveMarkers:!0}}static delete(D){return{range:D,text:null}}static replace(D,I){return{range:D,text:I}}static replaceMove(D,I){return{range:D,text:I,forceMoveMarkers:!0}}}e.$vt=C}),define(ye[168],Ee([1,0,6,2]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zt=void 0;class S{constructor(){this.a=new Map,this.b=new Map,this.c=new o.$ee,this.onDidChange=this.c.event,this.d=null}handleChange(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,b){return this.a.set(P,b),this.handleChange([P]),(0,C.$Tc)(()=>{this.a.get(P)===b&&(this.a.delete(P),this.handleChange([P]))})}get(P){return this.a.get(P)||null}registerFactory(P,b){this.b.get(P)?.dispose();const g=new D(this,P,b);return this.b.set(P,g),(0,C.$Tc)(()=>{const y=this.b.get(P);!y||y!==g||(this.b.delete(P),y.dispose())})}async getOrCreate(P){const b=this.get(P);if(b)return b;const g=this.b.get(P);return!g||g.isResolved?null:(await g.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const g=this.b.get(P);return!!(!g||g.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$Zt=S;class D extends C.$Vc{get isResolved(){return this.c}constructor(P,b,g){super(),this.f=P,this.g=b,this.h=g,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const P=await this.h.tokenizationSupport;this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(ye[169],Ee([8,9]),function(he,e){return he.create("vs/base/common/actions",e)}),define(ye[170],Ee([1,0,6,2,169]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=void 0,e.$gj=y;class D extends C.$Vc{constructor(w,m="",u="",a=!0,f){super(),this.h=this.B(new o.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=m,this.u=u,this.w=a,this.C=f}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,m){this.C&&await this.C(w)}}e.$bj=D;class I extends C.$Vc{constructor(){super(...arguments),this.f=this.B(new o.$ee),this.onWillRun=this.f.event,this.m=this.B(new o.$ee),this.onDidRun=this.m.event}async run(w,m){if(!w.enabled)return;this.f.fire({action:w});let u;try{await this.u(w,m)}catch(a){u=a}this.m.fire({action:w,error:u})}async u(w,m){await w.run(m)}}e.$cj=I;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let m=[];for(const u of w)u.length&&(m.length?m=[...m,new P,...u]:m=u);return m}static{this.ID="vs.actions.separator"}async run(){}}e.$dj=P;class b{get actions(){return this.a}constructor(w,m,u,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=m,this.class=a,this.a=u}async run(){}}e.$ej=b;class g extends D{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,S.localize(0,null),void 0,!1)}}e.$fj=g;function y(v){return{id:v.id,label:v.label,class:v.class,enabled:v.enabled??!0,checked:v.checked,run:async(...w)=>v.run(...w),tooltip:v.label}}}),define(ye[171],Ee([8,9]),function(he,e){return he.create("vs/base/common/date",e)}),define(ye[172],Ee([1,0,171]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2m=g,e.$3m=y,e.$4m=v;const C=60,S=C*60,D=S*24,I=D*7,P=D*30,b=D*365;function g(w,m,u,a){typeof w!="number"&&(w=w.getTime());const f=Math.round((new Date().getTime()-w)/1e3);if(f<-30)return(0,o.localize)(0,null,g(new Date().getTime()+f*1e3,!1));if(!a&&f<30)return(0,o.localize)(1,null);let c;return f<C?(c=f,m?c===1?u?(0,o.localize)(2,null,c):(0,o.localize)(3,null,c):u?(0,o.localize)(4,null,c):(0,o.localize)(5,null,c):c===1?u?(0,o.localize)(6,null,c):(0,o.localize)(7,null,c):u?(0,o.localize)(8,null,c):(0,o.localize)(9,null,c)):f<S?(c=Math.floor(f/C),m?c===1?u?(0,o.localize)(10,null,c):(0,o.localize)(11,null,c):u?(0,o.localize)(12,null,c):(0,o.localize)(13,null,c):c===1?u?(0,o.localize)(14,null,c):(0,o.localize)(15,null,c):u?(0,o.localize)(16,null,c):(0,o.localize)(17,null,c)):f<D?(c=Math.floor(f/S),m?c===1?u?(0,o.localize)(18,null,c):(0,o.localize)(19,null,c):u?(0,o.localize)(20,null,c):(0,o.localize)(21,null,c):c===1?u?(0,o.localize)(22,null,c):(0,o.localize)(23,null,c):u?(0,o.localize)(24,null,c):(0,o.localize)(25,null,c)):f<I?(c=Math.floor(f/D),m?c===1?(0,o.localize)(26,null,c):(0,o.localize)(27,null,c):c===1?(0,o.localize)(28,null,c):(0,o.localize)(29,null,c)):f<P?(c=Math.floor(f/I),m?c===1?u?(0,o.localize)(30,null,c):(0,o.localize)(31,null,c):u?(0,o.localize)(32,null,c):(0,o.localize)(33,null,c):c===1?u?(0,o.localize)(34,null,c):(0,o.localize)(35,null,c):u?(0,o.localize)(36,null,c):(0,o.localize)(37,null,c)):f<b?(c=Math.floor(f/P),m?c===1?u?(0,o.localize)(38,null,c):(0,o.localize)(39,null,c):u?(0,o.localize)(40,null,c):(0,o.localize)(41,null,c):c===1?u?(0,o.localize)(42,null,c):(0,o.localize)(43,null,c):u?(0,o.localize)(44,null,c):(0,o.localize)(45,null,c)):(c=Math.floor(f/b),m?c===1?u?(0,o.localize)(46,null,c):(0,o.localize)(47,null,c):u?(0,o.localize)(48,null,c):(0,o.localize)(49,null,c):c===1?u?(0,o.localize)(50,null,c):(0,o.localize)(51,null,c):u?(0,o.localize)(52,null,c):(0,o.localize)(53,null,c))}function y(w,m){const u=Math.abs(w/1e3);return u<1?m?(0,o.localize)(54,null,w):(0,o.localize)(55,null,w):u<C?m?(0,o.localize)(56,null,Math.round(w)/1e3):(0,o.localize)(57,null,Math.round(w)/1e3):u<S?m?(0,o.localize)(58,null,Math.round(w/(1e3*C))):(0,o.localize)(59,null,Math.round(w/(1e3*C))):u<D?m?(0,o.localize)(60,null,Math.round(w/(1e3*S))):(0,o.localize)(61,null,Math.round(w/(1e3*S))):(0,o.localize)(62,null,Math.round(w/(1e3*D)))}function v(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(ye[173],Ee([8,9]),function(he,e){return he.create("vs/base/common/errorMessage",e)}),define(ye[39],Ee([1,0,18,10,173]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=b,e.$ij=g,e.$jj=y;function D(v,w){return w&&(v.stack||v.stacktrace)?S.localize(0,null,P(v),I(v.stack)||I(v.stacktrace)):P(v)}function I(v){return Array.isArray(v)?v.join(`
`):v}function P(v){return v.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${v.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?S.localize(1,null,v.message):v.message||S.localize(2,null)}function b(v=null,w=!1){if(!v)return S.localize(3,null);if(Array.isArray(v)){const m=o.$Hb(v),u=b(m[0],w);return m.length>1?S.localize(4,null,u,m.length):u}if(C.$9f(v))return v;if(v.detail){const m=v.detail;if(m.error)return D(m.error,w);if(m.exception)return D(m.exception,w)}return v.stack?D(v,w):v.message?v.message:S.localize(5,null)}function g(v){const w=v;return w instanceof Error&&Array.isArray(w.actions)}function y(v,w){let m;return typeof v=="string"?m=new Error(v):m=v,m.actions=w,m}}),define(ye[174],Ee([8,9]),function(he,e){return he.create("vs/base/common/jsonErrorMessages",e)}),define(ye[175],Ee([1,0,174]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=C;function C(S){switch(S){case 1:return(0,o.localize)(0,null);case 2:return(0,o.localize)(1,null);case 3:return(0,o.localize)(2,null);case 4:return(0,o.localize)(3,null);case 5:return(0,o.localize)(4,null);case 6:return(0,o.localize)(5,null);case 7:return(0,o.localize)(6,null);case 8:return(0,o.localize)(7,null);case 9:return(0,o.localize)(8,null);default:return""}}}),define(ye[176],Ee([8,9]),function(he,e){return he.create("vs/base/common/platform",e)}),define(ye[3],Ee([1,0,176]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=s,e.$D=k,e.$J=j,e.$g="en";let C=!1,S=!1,D=!1,I=!1,P=!1,b=!1,g=!1,y=!1,v=!1,w=!1,m,u=e.$g,a=e.$g,f,c;const d=globalThis;let p;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?p=d.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(p=process);const E=typeof p?.versions?.electron=="string",h=E&&p?.type==="renderer";if(typeof p=="object"){C=p.platform==="win32",S=p.platform==="darwin",D=p.platform==="linux",I=D&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,g=E,v=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$g,u=e.$g;const A=p.env.VSCODE_NLS_CONFIG;if(A)try{const O=JSON.parse(A),F=O.availableLanguages["*"];m=O.locale,a=O.osLocale,u=F||e.$g,f=O._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!h?(c=navigator.userAgent,C=c.indexOf("Windows")>=0,S=c.indexOf("Macintosh")>=0,y=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,D=c.indexOf("Linux")>=0,w=c?.indexOf("Mobi")>=0,b=!0,m=o.getConfiguredDefaultLocale(o.localize(0,null))||e.$g,u=m,a=navigator.language):console.error("Unable to resolve platform.");var t;(function(A){A[A.Web=0]="Web",A[A.Mac=1]="Mac",A[A.Linux=2]="Linux",A[A.Windows=3]="Windows"})(t||(e.Platform=t={}));function s(A){switch(A){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let r=0;S?r=1:C?r=3:D&&(r=2),e.$i=C,e.$j=S,e.$k=D,e.$l=I,e.$m=P,e.$n=g,e.$o=b,e.$p=b&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=y,e.$s=w,e.$t=v,e.$u=r,e.$v=c,e.$w=u;var i;(function(A){function O(){return e.$w}A.value=O;function F(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}A.isDefaultVariant=F;function V(){return e.$w==="en"}A.isDefault=V})(i||(e.Language=i={})),e.$x=m,e.$y=a,e.$z=f,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const A=[];d.addEventListener("message",F=>{if(F.data&&F.data.vscodeScheduleAsyncWork)for(let V=0,Z=A.length;V<Z;V++){const oe=A[V];if(oe.id===F.data.vscodeScheduleAsyncWork){A.splice(V,1),oe.callback();return}}});let O=0;return F=>{const V=++O;A.push({id:V,callback:F}),d.postMessage({vscodeScheduleAsyncWork:V},"*")}}return A=>setTimeout(A)})();var n;(function(A){A[A.Windows=1]="Windows",A[A.Macintosh=2]="Macintosh",A[A.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=S||y?2:C?1:3;let l=!0,$=!1;function k(){if(!$){$=!0;const A=new Uint8Array(2);A[0]=1,A[1]=2,l=new Uint16Array(A.buffer)[0]===513}return l}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function j(A){return parseFloat(A)>=20}}),define(ye[31],Ee([1,0,3]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let C;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.process<"u"){const D=S.process;C={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return o.$i?"win32":o.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$ec=C.platform,e.$fc=C.arch}),define(ye[7],Ee([1,0,31]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const C=65,S=97,D=90,I=122,P=46,b=47,g=92,y=58,v=63;class w extends Error{constructor(s,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const l=s.indexOf(".")!==-1?"property":"argument";let $=`The "${s}" ${l} ${n} of type ${r}`;$+=`. Received type ${typeof i}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,s){if(t===null||typeof t!="object")throw new w(s,"Object",t)}function u(t,s){if(typeof t!="string")throw new w(s,"string",t)}const a=o.$ec==="win32";function f(t){return t===b||t===g}function c(t){return t===b}function d(t){return t>=C&&t<=D||t>=S&&t<=I}function p(t,s,r,i){let n="",l=0,$=-1,k=0,j=0;for(let A=0;A<=t.length;++A){if(A<t.length)j=t.charCodeAt(A);else{if(i(j))break;j=b}if(i(j)){if(!($===A-1||k===1))if(k===2){if(n.length<2||l!==2||n.charCodeAt(n.length-1)!==P||n.charCodeAt(n.length-2)!==P){if(n.length>2){const O=n.lastIndexOf(r);O===-1?(n="",l=0):(n=n.slice(0,O),l=n.length-1-n.lastIndexOf(r)),$=A,k=0;continue}else if(n.length!==0){n="",l=0,$=A,k=0;continue}}s&&(n+=n.length>0?`${r}..`:"..",l=2)}else n.length>0?n+=`${r}${t.slice($+1,A)}`:n=t.slice($+1,A),l=A-$-1;$=A,k=0}else j===P&&k!==-1?++k:k=-1}return n}function E(t,s){m(s,"pathObject");const r=s.dir||s.root,i=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${i}`:`${r}${t}${i}`:i}e.$gc={resolve(...t){let s="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let l;if(n>=0){if(l=t[n],u(l,"path"),l.length===0)continue}else s.length===0?l=o.cwd():(l=o.env[`=${s}`]||o.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==s.toLowerCase()&&l.charCodeAt(2)===g)&&(l=`${s}\\`));const $=l.length;let k=0,j="",A=!1;const O=l.charCodeAt(0);if($===1)f(O)&&(k=1,A=!0);else if(f(O))if(A=!0,f(l.charCodeAt(1))){let F=2,V=F;for(;F<$&&!f(l.charCodeAt(F));)F++;if(F<$&&F!==V){const Z=l.slice(V,F);for(V=F;F<$&&f(l.charCodeAt(F));)F++;if(F<$&&F!==V){for(V=F;F<$&&!f(l.charCodeAt(F));)F++;(F===$||F!==V)&&(j=`\\\\${Z}\\${l.slice(V,F)}`,k=F)}}}else k=1;else d(O)&&l.charCodeAt(1)===y&&(j=l.slice(0,2),k=2,$>2&&f(l.charCodeAt(2))&&(A=!0,k=3));if(j.length>0)if(s.length>0){if(j.toLowerCase()!==s.toLowerCase())continue}else s=j;if(i){if(s.length>0)break}else if(r=`${l.slice(k)}\\${r}`,i=A,A&&s.length>0)break}return r=p(r,!i,"\\",f),i?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){u(t,"path");const s=t.length;if(s===0)return".";let r=0,i,n=!1;const l=t.charCodeAt(0);if(s===1)return c(l)?"\\":t;if(f(l))if(n=!0,f(t.charCodeAt(1))){let k=2,j=k;for(;k<s&&!f(t.charCodeAt(k));)k++;if(k<s&&k!==j){const A=t.slice(j,k);for(j=k;k<s&&f(t.charCodeAt(k));)k++;if(k<s&&k!==j){for(j=k;k<s&&!f(t.charCodeAt(k));)k++;if(k===s)return`\\\\${A}\\${t.slice(j)}\\`;k!==j&&(i=`\\\\${A}\\${t.slice(j,k)}`,r=k)}}}else r=1;else d(l)&&t.charCodeAt(1)===y&&(i=t.slice(0,2),r=2,s>2&&f(t.charCodeAt(2))&&(n=!0,r=3));let $=r<s?p(t.slice(r),!n,"\\",f):"";return $.length===0&&!n&&($="."),$.length>0&&f(t.charCodeAt(s-1))&&($+="\\"),i===void 0?n?`\\${$}`:$:n?`${i}\\${$}`:`${i}${$}`},isAbsolute(t){u(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return f(r)||s>2&&d(r)&&t.charCodeAt(1)===y&&f(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let l=0;l<t.length;++l){const $=t[l];u($,"path"),$.length>0&&(s===void 0?s=r=$:s+=`\\${$}`)}if(s===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&f(r.charCodeAt(0))){++n;const l=r.length;l>1&&f(r.charCodeAt(1))&&(++n,l>2&&(f(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<s.length&&f(s.charCodeAt(n));)n++;n>=2&&(s=`\\${s.slice(n)}`)}return e.$gc.normalize(s)},relative(t,s){if(u(t,"from"),u(s,"to"),t===s)return"";const r=e.$gc.resolve(t),i=e.$gc.resolve(s);if(r===i||(t=r.toLowerCase(),s=i.toLowerCase(),t===s))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===g;)n++;let l=t.length;for(;l-1>n&&t.charCodeAt(l-1)===g;)l--;const $=l-n;let k=0;for(;k<s.length&&s.charCodeAt(k)===g;)k++;let j=s.length;for(;j-1>k&&s.charCodeAt(j-1)===g;)j--;const A=j-k,O=$<A?$:A;let F=-1,V=0;for(;V<O;V++){const oe=t.charCodeAt(n+V);if(oe!==s.charCodeAt(k+V))break;oe===g&&(F=V)}if(V!==O){if(F===-1)return i}else{if(A>O){if(s.charCodeAt(k+V)===g)return i.slice(k+V+1);if(V===2)return i.slice(k+V)}$>O&&(t.charCodeAt(n+V)===g?F=V:V===2&&(F=3)),F===-1&&(F=0)}let Z="";for(V=n+F+1;V<=l;++V)(V===l||t.charCodeAt(V)===g)&&(Z+=Z.length===0?"..":"\\..");return k+=F,Z.length>0?`${Z}${i.slice(k,j)}`:(i.charCodeAt(k)===g&&++k,i.slice(k,j))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.$gc.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===g){if(s.charCodeAt(1)===g){const r=s.charCodeAt(2);if(r!==v&&r!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(d(s.charCodeAt(0))&&s.charCodeAt(1)===y&&s.charCodeAt(2)===g)return`\\\\?\\${s}`;return t},dirname(t){u(t,"path");const s=t.length;if(s===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(s===1)return f(n)?t:".";if(f(n)){if(r=i=1,f(t.charCodeAt(1))){let k=2,j=k;for(;k<s&&!f(t.charCodeAt(k));)k++;if(k<s&&k!==j){for(j=k;k<s&&f(t.charCodeAt(k));)k++;if(k<s&&k!==j){for(j=k;k<s&&!f(t.charCodeAt(k));)k++;if(k===s)return t;k!==j&&(r=i=k+1)}}}}else d(n)&&t.charCodeAt(1)===y&&(r=s>2&&f(t.charCodeAt(2))?3:2,i=r);let l=-1,$=!0;for(let k=s-1;k>=i;--k)if(f(t.charCodeAt(k))){if(!$){l=k;break}}else $=!1;if(l===-1){if(r===-1)return".";l=r}return t.slice(0,l)},basename(t,s){s!==void 0&&u(s,"ext"),u(t,"path");let r=0,i=-1,n=!0,l;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===y&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let $=s.length-1,k=-1;for(l=t.length-1;l>=r;--l){const j=t.charCodeAt(l);if(f(j)){if(!n){r=l+1;break}}else k===-1&&(n=!1,k=l+1),$>=0&&(j===s.charCodeAt($)?--$===-1&&(i=l):($=-1,i=k))}return r===i?i=k:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=r;--l)if(f(t.charCodeAt(l))){if(!n){r=l+1;break}}else i===-1&&(n=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){u(t,"path");let s=0,r=-1,i=0,n=-1,l=!0,$=0;t.length>=2&&t.charCodeAt(1)===y&&d(t.charCodeAt(0))&&(s=i=2);for(let k=t.length-1;k>=s;--k){const j=t.charCodeAt(k);if(f(j)){if(!l){i=k+1;break}continue}n===-1&&(l=!1,n=k+1),j===P?r===-1?r=k:$!==1&&($=1):r!==-1&&($=-1)}return r===-1||n===-1||$===0||$===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:E.bind(null,"\\"),parse(t){u(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return f(n)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(f(n)){if(i=1,f(t.charCodeAt(1))){let F=2,V=F;for(;F<r&&!f(t.charCodeAt(F));)F++;if(F<r&&F!==V){for(V=F;F<r&&f(t.charCodeAt(F));)F++;if(F<r&&F!==V){for(V=F;F<r&&!f(t.charCodeAt(F));)F++;F===r?i=F:F!==V&&(i=F+1)}}}}else if(d(n)&&t.charCodeAt(1)===y){if(r<=2)return s.root=s.dir=t,s;if(i=2,f(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;i=3}}i>0&&(s.root=t.slice(0,i));let l=-1,$=i,k=-1,j=!0,A=t.length-1,O=0;for(;A>=i;--A){if(n=t.charCodeAt(A),f(n)){if(!j){$=A+1;break}continue}k===-1&&(j=!1,k=A+1),n===P?l===-1?l=A:O!==1&&(O=1):l!==-1&&(O=-1)}return k!==-1&&(l===-1||O===0||O===1&&l===k-1&&l===$+1?s.base=s.name=t.slice($,k):(s.name=t.slice($,l),s.base=t.slice($,k),s.ext=t.slice(l,k))),$>0&&$!==i?s.dir=t.slice(0,$-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const h=(()=>{if(a){const t=/\\/g;return()=>{const s=o.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.$hc={resolve(...t){let s="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:h();u(n,"path"),n.length!==0&&(s=`${n}/${s}`,r=n.charCodeAt(0)===b)}return s=p(s,!r,"/",c),r?`/${s}`:s.length>0?s:"."},normalize(t){if(u(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===b,r=t.charCodeAt(t.length-1)===b;return t=p(t,!s,"/",c),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return u(t,"path"),t.length>0&&t.charCodeAt(0)===b},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const i=t[r];u(i,"path"),i.length>0&&(s===void 0?s=i:s+=`/${i}`)}return s===void 0?".":e.$hc.normalize(s)},relative(t,s){if(u(t,"from"),u(s,"to"),t===s||(t=e.$hc.resolve(t),s=e.$hc.resolve(s),t===s))return"";const r=1,i=t.length,n=i-r,l=1,$=s.length-l,k=n<$?n:$;let j=-1,A=0;for(;A<k;A++){const F=t.charCodeAt(r+A);if(F!==s.charCodeAt(l+A))break;F===b&&(j=A)}if(A===k)if($>k){if(s.charCodeAt(l+A)===b)return s.slice(l+A+1);if(A===0)return s.slice(l+A)}else n>k&&(t.charCodeAt(r+A)===b?j=A:A===0&&(j=0));let O="";for(A=r+j+1;A<=i;++A)(A===i||t.charCodeAt(A)===b)&&(O+=O.length===0?"..":"/..");return`${O}${s.slice(l+j)}`},toNamespacedPath(t){return t},dirname(t){if(u(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===b;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===b){if(!i){r=n;break}}else i=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&u(s,"ext"),u(t,"path");let r=0,i=-1,n=!0,l;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let $=s.length-1,k=-1;for(l=t.length-1;l>=0;--l){const j=t.charCodeAt(l);if(j===b){if(!n){r=l+1;break}}else k===-1&&(n=!1,k=l+1),$>=0&&(j===s.charCodeAt($)?--$===-1&&(i=l):($=-1,i=k))}return r===i?i=k:i===-1&&(i=t.length),t.slice(r,i)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===b){if(!n){r=l+1;break}}else i===-1&&(n=!1,i=l+1);return i===-1?"":t.slice(r,i)},extname(t){u(t,"path");let s=-1,r=0,i=-1,n=!0,l=0;for(let $=t.length-1;$>=0;--$){const k=t.charCodeAt($);if(k===b){if(!n){r=$+1;break}continue}i===-1&&(n=!1,i=$+1),k===P?s===-1?s=$:l!==1&&(l=1):s!==-1&&(l=-1)}return s===-1||i===-1||l===0||l===1&&s===i-1&&s===r+1?"":t.slice(s,i)},format:E.bind(null,"/"),parse(t){u(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===b;let i;r?(s.root="/",i=1):i=0;let n=-1,l=0,$=-1,k=!0,j=t.length-1,A=0;for(;j>=i;--j){const O=t.charCodeAt(j);if(O===b){if(!k){l=j+1;break}continue}$===-1&&(k=!1,$=j+1),O===P?n===-1?n=j:A!==1&&(A=1):n!==-1&&(A=-1)}if($!==-1){const O=l===0&&r?1:l;n===-1||A===0||A===1&&n===$-1&&n===l+1?s.base=s.name=t.slice(O,$):(s.name=t.slice(O,n),s.base=t.slice(O,$),s.ext=t.slice(n,$))}return l>0?s.dir=t.slice(0,l-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=a?e.$gc.normalize:e.$hc.normalize,e.$jc=a?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=a?e.$gc.join:e.$hc.join,e.$lc=a?e.$gc.resolve:e.$hc.resolve,e.$mc=a?e.$gc.relative:e.$hc.relative,e.$nc=a?e.$gc.dirname:e.$hc.dirname,e.$oc=a?e.$gc.basename:e.$hc.basename,e.$pc=a?e.$gc.extname:e.$hc.extname,e.$qc=a?e.$gc.format:e.$hc.format,e.$rc=a?e.$gc.parse:e.$hc.parse,e.$sc=a?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=a?e.$gc.sep:e.$hc.sep,e.$uc=a?e.$gc.delimiter:e.$hc.delimiter}),define(ye[35],Ee([1,0,7,3,17,10]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=I,e.$pg=P,e.$qg=b,e.$rg=g,e.$sg=y,e.$tg=u,e.$ug=a,e.$vg=f,e.$wg=c,e.$xg=d,e.$yg=p,e.$zg=E,e.$Ag=h,e.$Bg=t,e.$Cg=s,e.$Dg=r,e.$Eg=l;function I($){return $===47||$===92}function P($){return $.replace(/[\\/]/g,o.$hc.sep)}function b($){return $.indexOf("/")===-1&&($=P($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}function g($,k=o.$hc.sep){if(!$)return"";const j=$.length,A=$.charCodeAt(0);if(I(A)){if(I($.charCodeAt(1))&&!I($.charCodeAt(2))){let F=3;const V=F;for(;F<j&&!I($.charCodeAt(F));F++);if(V!==F&&!I($.charCodeAt(F+1))){for(F+=1;F<j;F++)if(I($.charCodeAt(F)))return $.slice(0,F+1).replace(/[\\/]/g,k)}}return k}else if(c(A)&&$.charCodeAt(1)===58)return I($.charCodeAt(2))?$.slice(0,2)+k:$.slice(0,2);let O=$.indexOf("://");if(O!==-1){for(O+=3;O<j;O++)if(I($.charCodeAt(O)))return $.slice(0,O+1)}return""}function y($){if(!C.$i||!$||$.length<5)return!1;let k=$.charCodeAt(0);if(k!==92||(k=$.charCodeAt(1),k!==92))return!1;let j=2;const A=j;for(;j<$.length&&(k=$.charCodeAt(j),k!==92);j++);return!(A===j||(k=$.charCodeAt(j+1),isNaN(k)||k===92))}const v=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u($,k=C.$i){const j=k?v:w;return!(!$||$.length===0||/^\s+$/.test($)||(j.lastIndex=0,j.test($))||k&&m.test($)||$==="."||$===".."||k&&$[$.length-1]==="."||k&&$.length!==$.trim().length||$.length>255)}function a($,k,j){const A=$===k;return!j||A?A:!$||!k?!1:(0,S.$yf)($,k)}function f($,k,j,A=o.sep){if($===k)return!0;if(!$||!k||k.length>$.length)return!1;if(j){if(!(0,S.$zf)($,k))return!1;if(k.length===$.length)return!0;let F=k.length;return k.charAt(k.length-1)===A&&F--,$.charAt(F)===A}return k.charAt(k.length-1)!==A&&(k+=A),$.indexOf(k)===0}function c($){return $>=65&&$<=90||$>=97&&$<=122}function d($,k){return C.$i&&$.endsWith(":")&&($+=o.sep),(0,o.$jc)($)||($=(0,o.$kc)(k,$)),$=(0,o.$ic)($),p($)}function p($){return C.$i?($=(0,S.$gf)($,o.sep),$.endsWith(":")&&($+=o.sep)):($=(0,S.$gf)($,o.sep),$||($=o.sep)),$}function E($){const k=(0,o.$ic)($);return C.$i?$.length>3?!1:h(k)&&($.length===2||k.charCodeAt(2)===92):k===o.$hc.sep}function h($,k=C.$i){return k?c($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}function t($,k=C.$i){return h($,k)?$[0]:void 0}function s($,k,j){return k.length>$.length?-1:$===k?0:(j&&($=$.toLowerCase(),k=k.toLowerCase()),$.indexOf(k))}function r($){const k=$.split(":");let j,A,O;for(const F of k){const V=Number(F);(0,D.$ag)(V)?A===void 0?A=V:O===void 0&&(O=V):j=j?[j,F].join(":"):F}if(!j)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:j,line:A!==void 0?A:void 0,column:O!==void 0?O:A!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function l($,k,j=8){let A="";for(let F=0;F<j;F++){let V;F===0&&C.$i&&!k&&(j===3||j===4)?V=n:V=i,A+=V.charAt(Math.floor(Math.random()*V.length))}let O;return k?O=`${k}-${A}`:O=A,$?(0,o.$kc)($,O):O}}),define(ye[65],Ee([1,0,7]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qs=void 0,e.$Rs=D,e.$Ss=I,e.$Ts=P,e.$Us=g,e.$Qs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},S={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function D(y){const v=(0,o.$pc)(y),w=C[v.toLowerCase()];return w!==void 0?w:I(y)}function I(y){const v=(0,o.$pc)(y);return S[v.toLowerCase()]}function P(y){for(const v in S)if(S[v]===y)return v}const b=/^(.+)\/(.+?)(;.+)?$/;function g(y,v){const w=b.exec(y);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:v?void 0:y}}),define(ye[66],Ee([1,0,3]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$mm=D,e.$nm=I;var C;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(C||(e.Source=C={}));var S;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(S||(e.TerminateResponseCode=S={}));function D(P,...b){const g=b.reduce((w,m)=>(w[m]=!0,w),{}),y=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(w=>!g[w]).forEach(w=>{for(let m=0;m<y.length;m++)if(w.search(y[m])!==-1){delete P[w];break}})}function I(P){P&&(delete P.DEBUG,o.$j&&delete P.DYLD_LIBRARY_PATH,o.$k&&delete P.LD_PRELOAD)}}),define(ye[4],Ee([1,0,7,3]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=u,e.$xc=E;const S=/^\w[\w\d+.-]*$/,D=/^\//,I=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!S.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!D.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function b(i,n){return!i&&!n?"file":i}function g(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==v&&(n=v+n):n=v;break}return n}const y="",v="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(n){return n instanceof m?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,l,$,k,j,A=!1){typeof n=="object"?(this.scheme=n.scheme||y,this.authority=n.authority||y,this.path=n.path||y,this.query=n.query||y,this.fragment=n.fragment||y):(this.scheme=b(n,A),this.authority=l||y,this.path=g(this.scheme,$||y),this.query=k||y,this.fragment=j||y,P(this,A))}get fsPath(){return E(this,!1)}with(n){if(!n)return this;let{scheme:l,authority:$,path:k,query:j,fragment:A}=n;return l===void 0?l=this.scheme:l===null&&(l=y),$===void 0?$=this.authority:$===null&&($=y),k===void 0?k=this.path:k===null&&(k=y),j===void 0?j=this.query:j===null&&(j=y),A===void 0?A=this.fragment:A===null&&(A=y),l===this.scheme&&$===this.authority&&k===this.path&&j===this.query&&A===this.fragment?this:new f(l,$,k,j,A)}static parse(n,l=!1){const $=w.exec(n);return $?new f($[2]||y,r($[4]||y),r($[5]||y),r($[7]||y),r($[9]||y),l):new f(y,y,y,y,y)}static file(n){let l=y;if(C.$i&&(n=n.replace(/\\/g,v)),n[0]===v&&n[1]===v){const $=n.indexOf(v,2);$===-1?(l=n.substring(2),n=v):(l=n.substring(2,$),n=n.substring($)||v)}return new f("file",l,n,y,y)}static from(n,l){return new f(n.scheme,n.authority,n.path,n.query,n.fragment,l)}static joinPath(n,...l){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return C.$i&&n.scheme==="file"?$=m.file(o.$gc.join(E(n,!0),...l)).path:$=o.$hc.join(n.path,...l),n.with({path:$})}toString(n=!1){return h(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof m)return n;{const l=new f(n);return l._formatted=n.external??null,l._fsPath=n._sep===a?n.fsPath??null:null,l}}else return n}}e.URI=m;function u(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const a=C.$i?1:void 0;class f extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=E(this,!1)),this._fsPath}toString(n=!1){return n?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=a),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function d(i,n,l){let $,k=-1;for(let j=0;j<i.length;j++){const A=i.charCodeAt(j);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||n&&A===47||l&&A===91||l&&A===93||l&&A===58)k!==-1&&($+=encodeURIComponent(i.substring(k,j)),k=-1),$!==void 0&&($+=i.charAt(j));else{$===void 0&&($=i.substr(0,j));const O=c[A];O!==void 0?(k!==-1&&($+=encodeURIComponent(i.substring(k,j)),k=-1),$+=O):k===-1&&(k=j)}}return k!==-1&&($+=encodeURIComponent(i.substring(k))),$!==void 0?$:i}function p(i){let n;for(let l=0;l<i.length;l++){const $=i.charCodeAt(l);$===35||$===63?(n===void 0&&(n=i.substr(0,l)),n+=c[$]):n!==void 0&&(n+=i[l])}return n!==void 0?n:i}function E(i,n){let l;return i.authority&&i.path.length>1&&i.scheme==="file"?l=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?l=i.path.substr(1):l=i.path[1].toLowerCase()+i.path.substr(2):l=i.path,C.$i&&(l=l.replace(/\//g,"\\")),l}function h(i,n){const l=n?p:d;let $="",{scheme:k,authority:j,path:A,query:O,fragment:F}=i;if(k&&($+=k,$+=":"),(j||k==="file")&&($+=v,$+=v),j){let V=j.indexOf("@");if(V!==-1){const Z=j.substr(0,V);j=j.substr(V+1),V=Z.lastIndexOf(":"),V===-1?$+=l(Z,!1,!1):($+=l(Z.substr(0,V),!1,!1),$+=":",$+=l(Z.substr(V+1),!1,!0)),$+="@"}j=j.toLowerCase(),V=j.lastIndexOf(":"),V===-1?$+=l(j,!1,!0):($+=l(j.substr(0,V),!1,!0),$+=j.substr(V))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const V=A.charCodeAt(1);V>=65&&V<=90&&(A=`/${String.fromCharCode(V+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const V=A.charCodeAt(0);V>=65&&V<=90&&(A=`${String.fromCharCode(V+32)}:${A.substr(2)}`)}$+=l(A,!0,!1)}return O&&($+="?",$+=l(O,!1,!1)),F&&($+="#",$+=n?F:d(F,!1,!1)),$}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(s)?i.replace(s,n=>t(n)):i}}),define(ye[177],Ee([1,0,4]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vq=C,e.$Wq=S,e.$Xq=D,e.log=P;function C(g){const y=g;return y&&typeof y.type=="string"&&typeof y.severity=="string"}function S(g){const y=[];let v;try{const w=JSON.parse(g.arguments),m=w[w.length-1];m&&m.__$stack&&(w.pop(),v=m.__$stack),y.push(...w)}catch{y.push("Unable to log remote console arguments",g.arguments)}return{args:y,stack:v}}function D(g){if(typeof g!="string")return D(S(g).stack);const y=g;if(y){const v=I(y),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(v||"");if(w&&w.length===4)return{uri:o.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}function I(g){if(!g)return g;const y=g.indexOf(`
`);return y===-1?g:g.substring(0,y)}function P(g,y){const{args:v,stack:w}=S(g),m=typeof v[0]=="string"&&v.length===1;let u=I(w);u&&(u=`(${u.trim()})`);let a=[];if(typeof v[0]=="string"?u&&m?a=[`%c[${y}] %c${v[0]} %c${u}`,b("blue"),b(""),b("grey")]:a=[`%c[${y}] %c${v[0]}`,b("blue"),b(""),...v.slice(1)]:a=[`%c[${y}]%`,b("blue"),...v],u&&!m&&a.push(u),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,a)}function b(g){return`color: ${g}`}}),define(ye[54],Ee([1,0,15,4]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=S,e.$5h=D,e.$6h=P;function S(b){return JSON.stringify(b,I)}function D(b){let g=JSON.parse(b);return g=P(g),g}function I(b,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function P(b,g=0){if(!b||g>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return C.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 17:return new Date(b.source)}if(b instanceof o.$Ge||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let y=0;y<b.length;++y)b[y]=P(b[y],g+1);else for(const y in b)Object.hasOwnProperty.call(b,y)&&(b[y]=P(b[y],g+1))}return b}}),define(ye[13],Ee([1,0,11,3,17,4,7]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Jg=e.$Ig=e.$Hg=e.Schemas=void 0,e.$Fg=b,e.$Gg=g,e.$Kg=v;var P;(function(u){u.inMemory="inmemory",u.vscode="vscode",u.internal="private",u.walkThrough="walkThrough",u.walkThroughSnippet="walkThroughSnippet",u.http="http",u.https="https",u.file="file",u.mailto="mailto",u.untitled="untitled",u.data="data",u.command="command",u.vscodeRemote="vscode-remote",u.vscodeRemoteResource="vscode-remote-resource",u.vscodeManagedRemoteResource="vscode-managed-remote-resource",u.vscodeUserData="vscode-userdata",u.vscodeCustomEditor="vscode-custom-editor",u.vscodeNotebookCell="vscode-notebook-cell",u.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",u.vscodeNotebookCellOutput="vscode-notebook-cell-output",u.vscodeInteractiveInput="vscode-interactive-input",u.vscodeSettings="vscode-settings",u.vscodeWorkspaceTrust="vscode-workspace-trust",u.vscodeTerminal="vscode-terminal",u.vscodeChatCodeBlock="vscode-chat-code-block",u.vscodeChatCodeCompreBlock="vscode-chat-code-compare-block",u.vscodeChatSesssion="vscode-chat-editor",u.webviewPanel="webview-panel",u.vscodeWebview="vscode-webview",u.extension="extension",u.vscodeFileResource="vscode-file",u.tmp="tmp",u.vsls="vsls",u.vscodeSourceControl="vscode-scm",u.commentsInput="comment",u.codeSetting="code-setting"})(P||(e.Schemas=P={}));function b(u,a){return D.URI.isUri(u)?(0,S.$yf)(u.scheme,a):(0,S.$zf)(u,a+":")}function g(u,...a){return a.some(f=>b(u,f))}e.$Hg="vscode-tkn",e.$Ig="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(a){this.d=a}setDelegate(a){this.e=a}setServerRootPath(a,f){this.f=v(a,f)}getServerRootPath(){return this.f}get g(){return I.$hc.join(this.f,P.vscodeRemoteResource)}set(a,f,c){this.a[a]=f,this.b[a]=c}setConnectionToken(a,f){this.c[a]=f}getPreferredWebSchema(){return this.d}rewrite(a){if(this.e)try{return this.e(a)}catch(h){return o.$1(h),a}const f=a.authority;let c=this.a[f];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const d=this.b[f],p=this.c[f];let E=`path=${encodeURIComponent(a.path)}`;return typeof p=="string"&&(E+=`&${e.$Ig}=${encodeURIComponent(p)}`),D.URI.from({scheme:C.$o?this.d:P.vscodeRemoteResource,authority:`${c}:${d}`,path:this.g,query:E})}}e.$Jg=new y;function v(u,a){return I.$hc.join(a??"/",`${u.quality??"oss"}-${u.commit??"dev"}`)}e.$Lg="vs/../../extensions",e.$Mg="vs/../../node_modules",e.$Ng="vs/../../node_modules.asar",e.$Og="vs/../../node_modules.asar.unpacked",e.$Pg="vscode-app";class w{static{this.a=e.$Pg}asBrowserUri(a){const f=this.b(a,he);return this.uriToBrowserUri(f)}uriToBrowserUri(a){return a.scheme===P.vscodeRemote?e.$Jg.rewrite(a):a.scheme===P.file&&(C.$m||C.$q===`${P.vscodeFileResource}://${w.a}`)?a.with({scheme:P.vscodeFileResource,authority:a.authority||w.a,query:null,fragment:null}):a}asFileUri(a){const f=this.b(a,he);return this.uriToFileUri(f)}uriToFileUri(a){return a.scheme===P.vscodeFileResource?a.with({scheme:P.file,authority:a.authority!==w.a?a.authority:null,query:null,fragment:null}):a}b(a,f){return D.URI.isUri(a)?a:D.URI.parse(f.toUrl(a))}}e.$Qg=new w;var m;(function(u){const a=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);u.CoopAndCoep=Object.freeze(a.get("3"));const f="vscode-coi";function c(p){let E;typeof p=="string"?E=new URL(p).searchParams:p instanceof URL?E=p.searchParams:D.URI.isUri(p)&&(E=new URL(p.toString(!0)).searchParams);const h=E?.get(f);if(h)return a.get(h)}u.getHeadersFromQuery=c;function d(p,E,h){if(!globalThis.crossOriginIsolated)return;const t=E&&h?"3":h?"2":"1";p instanceof URLSearchParams?p.set(f,t):p[f]=t}u.addSearchParam=d})(m||(e.COI=m={}))}),define(ye[178],Ee([1,0,96,13,3,4]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7D=y;class I{constructor(w,m,u){this.id=w,this.dependencies=m,this.callback=u}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,m,u)=>{typeof w!="string"&&(u=m,m=w,w=null),(typeof m!="object"||!Array.isArray(m))&&(u=m,m=null),this.c.push(new I(w,m,u))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const m=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!m)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(m.dependencies)&&m.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${m.dependencies.join(", ")}`);return typeof m.callback=="function"?m.callback([]):m.callback}h(w){return new Promise((m,u)=>{const a=document.createElement("script");a.setAttribute("async","async"),a.setAttribute("type","text/javascript");const f=()=>{a.removeEventListener("load",c),a.removeEventListener("error",d)},c=p=>{f(),m(this.c.pop())},d=p=>{f(),u(p)};a.addEventListener("load",c),a.addEventListener("error",d),this.f&&(w=this.f.createScriptURL(w)),a.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(a)})}i(w){return new Promise((m,u)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),m(this.c.pop())}catch(a){u(a)}})}async j(w){try{const m=globalThis._VSCODE_NODE_MODULES.fs,u=globalThis._VSCODE_NODE_MODULES.vm,a=globalThis._VSCODE_NODE_MODULES.module,f=D.URI.parse(w).fsPath,c=m.readFileSync(f).toString(),d=a.wrap(c.replace(/^#!.*/,""));return new u.Script(d).runInThisContext().apply(),this.c.pop()}catch(m){throw m}}}const b=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function y(v,w,m){if(o.$T){m===void 0&&(m=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[v]&&(v=g[v]);const u=`${v}/${w}`;if(b.has(u))return b.get(u);let a;if(/^\w[\w\d+.-]*:\/\//.test(u))a=u;else{const p=`${m&&!S.$o?C.$Ng:C.$Mg}/${u}`;a=C.$Qg.asBrowserUri(p).toString(!0)}const f=P.INSTANCE.load(a);return b.set(u,f),f}else return await new Promise((u,a)=>{he([v],u,a)})}}),define(ye[19],Ee([1,0,35,13,7,3,17,4]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=void 0,e.$Xg=b,e.$gh=y,e.$hh=w;function b(m){return(0,P.$xc)(m,!0)}class g{constructor(u){this.a=u}compare(u,a,f=!1){return u===a?0:(0,I.$rf)(this.getComparisonKey(u,f),this.getComparisonKey(a,f))}isEqual(u,a,f=!1){return u===a?!0:!u||!a?!1:this.getComparisonKey(u,f)===this.getComparisonKey(a,f)}getComparisonKey(u,a=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,a,f=!1){if(u.scheme===a.scheme){if(u.scheme===C.Schemas.file)return o.$vg(b(u),b(a),this.a(u))&&u.query===a.query&&(f||u.fragment===a.fragment);if((0,e.$ch)(u.authority,a.authority))return o.$vg(u.path,a.path,this.a(u),"/")&&u.query===a.query&&(f||u.fragment===a.fragment)}return!1}joinPath(u,...a){return P.URI.joinPath(u,...a)}basenameOrAuthority(u){return(0,e.$7g)(u)||u.authority}basename(u){return S.$hc.basename(u.path)}extname(u){return S.$hc.extname(u.path)}dirname(u){if(u.path.length===0)return u;let a;return u.scheme===C.Schemas.file?a=P.URI.file(S.$nc(b(u))).path:(a=S.$hc.dirname(u.path),u.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),a="/")),u.with({path:a})}normalizePath(u){if(!u.path.length)return u;let a;return u.scheme===C.Schemas.file?a=P.URI.file(S.$ic(b(u))).path:a=S.$hc.normalize(u.path),u.with({path:a})}relativePath(u,a){if(u.scheme!==a.scheme||!(0,e.$ch)(u.authority,a.authority))return;if(u.scheme===C.Schemas.file){const d=S.$mc(b(u),b(a));return D.$i?o.$pg(d):d}let f=u.path||"/";const c=a.path||"/";if(this.a(u)){let d=0;for(const p=Math.min(f.length,c.length);d<p&&!(f.charCodeAt(d)!==c.charCodeAt(d)&&f.charAt(d).toLowerCase()!==c.charAt(d).toLowerCase());d++);f=c.substr(0,d)+f.substr(d)}return S.$hc.relative(f,c)}resolvePath(u,a){if(u.scheme===C.Schemas.file){const f=P.URI.file(S.$lc(b(u),a));return u.with({authority:f.authority,path:f.path})}return a=o.$qg(a),u.with({path:S.$hc.resolve(u.path,a)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,a){return u===a||u!==void 0&&a!==void 0&&(0,I.$yf)(u,a)}hasTrailingPathSeparator(u,a=S.sep){if(u.scheme===C.Schemas.file){const f=b(u);return f.length>o.$rg(f).length&&f[f.length-1]===a}else{const f=u.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,a=S.sep){return(0,e.$dh)(u,a)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,a=S.sep){let f=!1;if(u.scheme===C.Schemas.file){const c=b(u);f=c!==void 0&&c.length===o.$rg(c).length&&c[c.length-1]===a}else{a="/";const c=u.path;f=c.length===1&&c.charCodeAt(c.length-1)===47}return!f&&!(0,e.$dh)(u,a)?u.with({path:u.path+"/"}):u}}e.$Yg=g,e.$Zg=new g(()=>!1),e.$1g=new g(m=>m.scheme===C.Schemas.file?!D.$k:!0),e.$2g=new g(m=>!0),e.$3g=e.$Zg.isEqual.bind(e.$Zg),e.$4g=e.$Zg.isEqualOrParent.bind(e.$Zg),e.$5g=e.$Zg.getComparisonKey.bind(e.$Zg),e.$6g=e.$Zg.basenameOrAuthority.bind(e.$Zg),e.$7g=e.$Zg.basename.bind(e.$Zg),e.$8g=e.$Zg.extname.bind(e.$Zg),e.$9g=e.$Zg.dirname.bind(e.$Zg),e.$0g=e.$Zg.joinPath.bind(e.$Zg),e.$$g=e.$Zg.normalizePath.bind(e.$Zg),e.$_g=e.$Zg.relativePath.bind(e.$Zg),e.$ah=e.$Zg.resolvePath.bind(e.$Zg),e.$bh=e.$Zg.isAbsolutePath.bind(e.$Zg),e.$ch=e.$Zg.isEqualAuthority.bind(e.$Zg),e.$dh=e.$Zg.hasTrailingPathSeparator.bind(e.$Zg),e.$eh=e.$Zg.removeTrailingPathSeparator.bind(e.$Zg),e.$fh=e.$Zg.addTrailingPathSeparator.bind(e.$Zg);function y(m,u){const a=[];for(let f=0;f<m.length;f++){const c=u(m[f]);m.some((d,p)=>p===f?!1:(0,e.$4g)(c,u(d)))||a.push(m[f])}return a}var v;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function u(a){const f=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(p=>{const[E,h]=p.split(":");E&&h&&f.set(E,h)});const d=a.path.substring(0,a.path.indexOf(";"));return d&&f.set(m.META_DATA_MIME,d),f}m.parseMetaData=u})(v||(e.DataUri=v={}));function w(m,u,a){if(u){let f=m.path;return f&&f[0]!==S.$hc.sep&&(f=S.$hc.sep+f),m.with({scheme:a,authority:u,path:f})}return m.with({scheme:a})}}),define(ye[14],Ee([1,0,20,11,6,2,19,3,160,60]),function(he,e,o,C,S,D,I,P,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=e.Promises=e.$Th=e.$Sh=e.$Rh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=void 0,e.$ih=y,e.$jh=v,e.$kh=w,e.$lh=m,e.$mh=u,e.$nh=a,e.$oh=f,e.$ph=c,e.$xh=l,e.$yh=$,e.$zh=k,e.$Ah=j,e.$Bh=A,e.$Qh=Q,e.$Yh=x;function y(U){return!!U&&typeof U.then=="function"}function v(U){const T=new o.$pe,q=U(T.token),se=new Promise((ae,me)=>{const ee=T.token.onCancellationRequested(()=>{ee.dispose(),me(new C.$5)});Promise.resolve(q).then(ge=>{ee.dispose(),T.dispose(),ae(ge)},ge=>{ee.dispose(),T.dispose(),me(ge)})});return new class{cancel(){T.cancel(),T.dispose()}then(ae,me){return se.then(ae,me)}catch(ae){return this.then(void 0,ae)}finally(ae){return se.finally(ae)}}}function w(U,T,q){return new Promise((se,ae)=>{const me=T.onCancellationRequested(()=>{me.dispose(),se(q)});U.then(se,ae).finally(()=>me.dispose())})}function m(U,T){return new Promise((q,se)=>{const ae=T.onCancellationRequested(()=>{ae.dispose(),se(new C.$5)});U.then(q,se).finally(()=>ae.dispose())})}async function u(U){let T=-1;const q=U.map((se,ae)=>se.then(me=>(T=ae,me)));try{return await Promise.race(q)}finally{U.forEach((se,ae)=>{ae!==T&&se.cancel()})}}function a(U,T,q){let se;const ae=setTimeout(()=>{se?.(void 0),q?.()},T);return Promise.race([U.finally(()=>clearTimeout(ae)),new Promise(me=>se=me)])}function f(U){return new Promise((T,q)=>{const se=U();y(se)?se.then(T,q):T(se)})}function c(){let U,T;return{promise:new Promise((se,ae)=>{U=se,T=ae}),resolve:U,reject:T}}class d{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(T){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=T,!this.b){const q=()=>{if(this.b=null,this.f)return;const se=this.queue(this.d);return this.d=null,se};this.b=new Promise(se=>{this.a.then(q,q).then(se)})}return new Promise((q,se)=>{this.b.then(q,se)})}return this.a=T(),new Promise((q,se)=>{this.a.then(ae=>{this.a=null,q(ae)},ae=>{this.a=null,se(ae)})})}dispose(){this.f=!0}}e.$qh=d;class p{constructor(){this.a=Promise.resolve(null)}queue(T){return this.a=this.a.then(()=>T(),()=>T())}}e.$rh=p;class E{constructor(){this.a=new Map}queue(T,q){const ae=(this.a.get(T)??Promise.resolve()).catch(()=>{}).then(q).finally(()=>{this.a.get(T)===ae&&this.a.delete(T)});return this.a.set(T,ae),ae}}e.$sh=E;const h=(U,T)=>{let q=!0;const se=setTimeout(()=>{q=!1,T()},U);return{isTriggered:()=>q,dispose:()=>{clearTimeout(se),q=!1}}},t=U=>{let T=!0;return queueMicrotask(()=>{T&&(T=!1,U())}),{isTriggered:()=>T,dispose:()=>{T=!1}}};class s{constructor(T){this.defaultDelay=T,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(T,q=this.defaultDelay){this.g=T,this.h(),this.b||(this.b=new Promise((ae,me)=>{this.d=ae,this.f=me}).then(()=>{if(this.b=null,this.d=null,this.g){const ae=this.g;return this.g=null,ae()}}));const se=()=>{this.a=null,this.d?.(null)};return this.a=q===b.$be?t(se):h(q,se),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$th=s;class r{constructor(T){this.a=new s(T),this.b=new d}trigger(T,q){return this.a.trigger(()=>this.b.queue(T),q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$uh=r;class i{constructor(){this.a=!1,this.b=new Promise((T,q)=>{this.d=T})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$vh=i;class n extends i{constructor(T){super(),this.f=setTimeout(()=>this.open(),T)}open(){clearTimeout(this.f),super.open()}}e.$wh=n;function l(U,T){return T?new Promise((q,se)=>{const ae=setTimeout(()=>{me.dispose(),q()},U),me=T.onCancellationRequested(()=>{clearTimeout(ae),me.dispose(),se(new C.$5)})}):v(q=>l(U,q))}function $(U,T=0,q){const se=setTimeout(()=>{U(),q&&ae.dispose()},T),ae=(0,D.$Tc)(()=>{clearTimeout(se),q?.deleteAndLeak(ae)});return q?.add(ae),ae}function k(U){const T=[];let q=0;const se=U.length;function ae(){return q<se?U[q++]():null}function me(ee){ee!=null&&T.push(ee);const ge=ae();return ge?ge.then(me):Promise.resolve(T)}return Promise.resolve(null).then(me)}function j(U,T=se=>!!se,q=null){let se=0;const ae=U.length,me=()=>{if(se>=ae)return Promise.resolve(q);const ee=U[se++];return Promise.resolve(ee()).then($e=>T($e)?Promise.resolve($e):me())};return me()}function A(U,T=se=>!!se,q=null){if(U.length===0)return Promise.resolve(q);let se=U.length;const ae=()=>{se=-1;for(const me of U)me.cancel?.()};return new Promise((me,ee)=>{for(const ge of U)ge.then($e=>{--se>=0&&T($e)?(ae(),me($e)):se===0&&me(q)}).catch($e=>{--se>=0&&(ae(),ee($e))})})}class O{constructor(T){this.a=0,this.b=!1,this.f=T,this.g=[],this.d=0,this.h=new S.$ee}whenIdle(){return this.size>0?S.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(T){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((q,se)=>{this.g.push({factory:T,c:q,e:se}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const T=this.g.shift();this.d++;const q=T.factory();q.then(T.c,T.e),q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Ch=O;class F extends O{constructor(){super(1)}}e.$Dh=F;class V{constructor(){this.a=new ce,this.b=0}queue(T){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,T())):this.a.run(this.b++,T())}}e.$Eh=V;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const T=new re;return this.b.add(T),T.p}g(){for(const[,T]of this.a)if(T.size>0)return!1;return!0}queueSize(T,q=I.$Zg){const se=q.getComparisonKey(T);return this.a.get(se)?.size??0}queueFor(T,q,se=I.$Zg){const ae=se.getComparisonKey(T);let me=this.a.get(ae);if(!me){me=new F;const ee=this.f++,ge=S.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(ae),this.h(),this.d?.deleteAndDispose(ee),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new D.$5c),this.d.set(ee,ge),this.a.set(ae,me)}return me.queue(q)}h(){this.g()&&this.j()}j(){for(const T of this.b)T.complete();this.b.clear()}dispose(){for(const[,T]of this.a)T.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Fh=Z;class oe{constructor(T,q){this.a=-1,typeof T=="function"&&typeof q=="number"&&this.setIfNotSet(T,q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(T,q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,T()},q)}setIfNotSet(T,q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,T()},q))}}e.$Gh=oe;class le{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(T,q,se=globalThis){this.cancel();const ae=se.setInterval(()=>{T()},q);this.d=(0,D.$Tc)(()=>{se.clearInterval(ae),this.d=void 0})}dispose(){this.cancel()}}e.$Hh=le;class te{constructor(T,q){this.b=-1,this.a=T,this.d=q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(T=this.d){this.cancel(),this.b=setTimeout(this.f,T)}get delay(){return this.d}set delay(T){this.d=T}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Ih=te;class _{constructor(T,q){q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${q}ms is not a multiple of 1000ms.`),this.a=T,this.b=q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(T=this.b){T%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${T}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(T/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Jh=_;class W extends te{constructor(T,q){super(T,q),this.j=[]}work(T){this.j.push(T),this.isScheduled()||this.schedule()}h(){const T=this.j;this.j=[],this.a?.(T)}dispose(){this.j=[],super.dispose()}}e.$Kh=W;class K extends D.$Vc{constructor(T,q){super(),this.g=T,this.h=q,this.a=[],this.b=this.B(new D.$Wc),this.f=!1}get pending(){return this.a.length}work(T){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+T.length>this.g.maxBufferedWork)return!1}else if(this.pending+T.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const q of T)this.a.push(q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Lh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Nh=(U,T)=>{(0,P.$B)(()=>{if(q)return;const se=Date.now()+15;T(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let q=!1;return{dispose(){q||(q=!0)}}}:e.$Nh=(U,T,q)=>{const se=U.requestIdleCallback(T,typeof q=="number"?{timeout:q}:void 0);let ae=!1;return{dispose(){ae||(ae=!0,U.cancelIdleCallback(se))}}},e.$Mh=U=>(0,e.$Nh)(globalThis,U)}();class Y{constructor(T,q){this.g=!1,this.d=()=>{try{this.j=q()}catch(se){this.l=se}finally{this.g=!0}},this.f=(0,e.$Nh)(T,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Oh=Y;class M extends Y{constructor(T){super(globalThis,T)}}e.$Ph=M;async function Q(U,T,q){let se;for(let ae=0;ae<q;ae++)try{return await U()}catch(me){se=me,await l(T)}throw se}class ce{isRunning(T){return typeof T=="number"?this.a?.taskId===T:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(T,q,se){return this.a={taskId:T,cancel:()=>se?.(),promise:q},q.then(()=>this.d(T),()=>this.d(T)),q}d(T){this.a&&T===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const T=this.b;this.b=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}queue(T){if(this.b)this.b.run=T;else{const{promise:q,resolve:se,reject:ae}=c();this.b={run:T,promise:q,promiseResolve:se,promiseReject:ae}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Rh=ce;class ie{constructor(T,q=()=>Date.now()){this.d=T,this.f=q,this.a=0,this.b=0}increment(){const T=this.f();return T-this.a>this.d&&(this.a=T,this.b=0),this.b++,this.b}}e.$Sh=ie;var be;(function(U){U[U.Resolved=0]="Resolved",U[U.Rejected=1]="Rejected"})(be||(be={}));class re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((T,q)=>{this.a=T,this.b=q})}complete(T){return new Promise(q=>{this.a(T),this.d={outcome:0,value:T},q()})}error(T){return new Promise(q=>{this.b(T),this.d={outcome:1,value:T},q()})}cancel(){return this.error(new C.$5)}}e.$Th=re;var X;(function(U){async function T(se){let ae;const me=await Promise.all(se.map(ee=>ee.then(ge=>ge,ge=>{ae||(ae=ge)})));if(typeof ae<"u")throw ae;return me}U.settled=T;function q(se){return new Promise(async(ae,me)=>{try{await se(ae,me)}catch(ee){me(ee)}})}U.withAsyncBody=q})(X||(e.Promises=X={}));class B{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(T){this.a=void 0,this.b=void 0,this.d=!1,this.promise=T.then(q=>(this.a=q,this.d=!0,q),q=>{throw this.b=q,this.d=!0,q})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Uh=B;class N{constructor(T){this.b=T,this.a=new g.$V(()=>new B(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Vh=N;var z;(function(U){U[U.Initial=0]="Initial",U[U.DoneOK=1]="DoneOK",U[U.DoneError=2]="DoneError"})(z||(z={}));class J{static fromArray(T){return new J(q=>{q.emitMany(T)})}static fromPromise(T){return new J(async q=>{q.emitMany(await T)})}static fromPromises(T){return new J(async q=>{await Promise.all(T.map(async se=>q.emitOne(await se)))})}static merge(T){return new J(async q=>{await Promise.all(T.map(async se=>{for await(const ae of se)q.emitOne(ae)}))})}static{this.EMPTY=J.fromArray([])}constructor(T,q){this.a=0,this.b=[],this.d=null,this.f=q,this.g=new S.$ee,queueMicrotask(async()=>{const se={emitOne:ae=>this.h(ae),emitMany:ae=>this.j(ae),reject:ae=>this.l(ae)};try{await Promise.resolve(T(se)),this.k()}catch(ae){this.l(ae)}finally{se.emitOne=void 0,se.emitMany=void 0,se.reject=void 0}})}[Symbol.asyncIterator](){let T=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(T<this.b.length)return{done:!1,value:this.b[T++]};if(this.a===1)return{done:!0,value:void 0};await S.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(T,q){return new J(async se=>{for await(const ae of T)se.emitOne(q(ae))})}map(T){return J.map(this,T)}static filter(T,q){return new J(async se=>{for await(const ae of T)q(ae)&&se.emitOne(ae)})}filter(T){return J.filter(this,T)}static coalesce(T){return J.filter(T,q=>!!q)}coalesce(){return J.coalesce(this)}static async toPromise(T){const q=[];for await(const se of T)q.push(se);return q}toPromise(){return J.toPromise(this)}h(T){this.a===0&&(this.b.push(T),this.g.fire())}j(T){this.a===0&&(this.b=this.b.concat(T),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(T){this.a===0&&(this.a=2,this.d=T,this.g.fire())}}e.$Wh=J;class ue extends J{constructor(T,q){super(q),this.m=T}cancel(){this.m.cancel()}}e.$Xh=ue;function x(U){const T=new o.$pe,q=U(T.token);return new ue(T,async se=>{const ae=T.token.onCancellationRequested(()=>{ae.dispose(),T.dispose(),se.reject(new C.$5)});try{for await(const me of q){if(T.token.isCancellationRequested)return;se.emitOne(me)}ae.dispose(),T.dispose()}catch(me){ae.dispose(),T.dispose(),se.reject(me)}})}class G{constructor(T){this.a=new re,this.b=new J(ae=>{if(q){ae.reject(q);return}return se&&ae.emitMany(se),this.d=me=>ae.reject(me),this.f=me=>ae.emitOne(me),this.a.p},T);let q,se;this.f=ae=>{se||(se=[]),se.push(ae)},this.d=ae=>{q||(q=ae)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(T){this.d(T),this.a.complete()}emitOne(T){this.f(T)}}e.$Zh=G}),define(ye[80],Ee([1,0,18,14,35,24,7,3,17]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nk=e.$mk=void 0,e.$lk=g,e.$ok=u,e.$pk=F,e.$qk=V,e.$rk=Z,e.$sk=oe,e.$tk=le,e.$uk=K;function g(){return Object.create(null)}e.$mk="**",e.$nk="/";const y="[/\\\\]",v="[^/\\\\]",w=/\//g;function m(Y,M){switch(Y){case 0:return"";case 1:return`${v}*?`;default:return`(?:${y}|${v}+${y}${M?`|${y}${v}+`:""})*?`}}function u(Y,M){if(!Y)return[];const Q=[];let ce=!1,ie=!1,be="";for(const re of Y){switch(re){case M:if(!ce&&!ie){Q.push(be),be="";continue}break;case"{":ce=!0;break;case"}":ce=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}be+=re}return be&&Q.push(be),Q}function a(Y){if(!Y)return"";let M="";const Q=u(Y,e.$nk);if(Q.every(ce=>ce===e.$mk))M=".*";else{let ce=!1;Q.forEach((ie,be)=>{if(ie===e.$mk){if(ce)return;M+=m(2,be===Q.length-1)}else{let re=!1,X="",B=!1,N="";for(const z of ie){if(z!=="}"&&re){X+=z;continue}if(B&&(z!=="]"||!N)){let J;z==="-"?J=z:(z==="^"||z==="!")&&!N?J="^":z===e.$nk?J="":J=(0,b.$af)(z),N+=J;continue}switch(z){case"{":re=!0;continue;case"[":B=!0;continue;case"}":{const ue=`(?:${u(X,",").map(x=>a(x)).join("|")})`;M+=ue,re=!1,X="";break}case"]":{M+="["+N+"]",B=!1,N="";break}case"?":M+=v;continue;case"*":M+=m(1);continue;default:M+=(0,b.$af)(z)}}be<Q.length-1&&(Q[be+1]!==e.$mk||be+2<Q.length)&&(M+=y)}ce=ie===e.$mk})}return M}const f=/^\*\*\/\*\.[\w\.-]+$/,c=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,p=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,E=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.$Ec(1e4),s=function(){return!1},r=function(){return null};function i(Y,M){if(!Y)return r;let Q;typeof Y!="string"?Q=Y.pattern:Q=Y,Q=Q.trim();const ce=`${Q}_${!!M.trimForExclusions}`;let ie=t.get(ce);if(ie)return n(ie,Y);let be;return f.test(Q)?ie=$(Q.substr(4),Q):(be=c.exec(l(Q,M)))?ie=k(be[1],Q):(M.trimForExclusions?p:d).test(Q)?ie=j(Q,M):(be=E.exec(l(Q,M)))?ie=A(be[1].substr(1),Q,!0):(be=h.exec(l(Q,M)))?ie=A(be[1],Q,!1):ie=O(Q),t.set(ce,ie),n(ie,Y)}function n(Y,M){if(typeof M=="string")return Y;const Q=function(ce,ie){return(0,S.$vg)(ce,M.base,!P.$k)?Y((0,b.$ff)(ce.substr(M.base.length),I.sep),ie):null};return Q.allBasenames=Y.allBasenames,Q.allPaths=Y.allPaths,Q.basenames=Y.basenames,Q.patterns=Y.patterns,Q}function l(Y,M){return M.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function $(Y,M){return function(Q,ce){return typeof Q=="string"&&Q.endsWith(Y)?M:null}}function k(Y,M){const Q=`/${Y}`,ce=`\\${Y}`,ie=function(re,X){return typeof re!="string"?null:X?X===Y?M:null:re===Y||re.endsWith(Q)||re.endsWith(ce)?M:null},be=[Y];return ie.basenames=be,ie.patterns=[M],ie.allBasenames=be,ie}function j(Y,M){const Q=W(Y.slice(1,-1).split(",").map(X=>i(X,M)).filter(X=>X!==r),Y),ce=Q.length;if(!ce)return r;if(ce===1)return Q[0];const ie=function(X,B){for(let N=0,z=Q.length;N<z;N++)if(Q[N](X,B))return Y;return null},be=Q.find(X=>!!X.allBasenames);be&&(ie.allBasenames=be.allBasenames);const re=Q.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return re.length&&(ie.allPaths=re),ie}function A(Y,M,Q){const ce=I.sep===I.$hc.sep,ie=ce?Y:Y.replace(w,I.sep),be=I.sep+ie,re=I.$hc.sep+Y;let X;return Q?X=function(B,N){return typeof B=="string"&&(B===ie||B.endsWith(be)||!ce&&(B===Y||B.endsWith(re)))?M:null}:X=function(B,N){return typeof B=="string"&&(B===ie||!ce&&B===Y)?M:null},X.allPaths=[(Q?"*/":"./")+Y],X}function O(Y){try{const M=new RegExp(`^${a(Y)}$`);return function(Q){return M.lastIndex=0,typeof Q=="string"&&M.test(Q)?Y:null}}catch{return r}}function F(Y,M,Q){return!Y||typeof M!="string"?!1:V(Y)(M,void 0,Q)}function V(Y,M={}){if(!Y)return s;if(typeof Y=="string"||Z(Y)){const Q=i(Y,M);if(Q===r)return s;const ce=function(ie,be){return!!Q(ie,be)};return Q.allBasenames&&(ce.allBasenames=Q.allBasenames),Q.allPaths&&(ce.allPaths=Q.allPaths),ce}return te(Y,M)}function Z(Y){const M=Y;return M?typeof M.base=="string"&&typeof M.pattern=="string":!1}function oe(Y){return Y.allBasenames||[]}function le(Y){return Y.allPaths||[]}function te(Y,M){const Q=W(Object.getOwnPropertyNames(Y).map(X=>_(X,Y[X],M)).filter(X=>X!==r)),ce=Q.length;if(!ce)return r;if(!Q.some(X=>!!X.requiresSiblings)){if(ce===1)return Q[0];const X=function(z,J){let ue;for(let x=0,G=Q.length;x<G;x++){const U=Q[x](z,J);if(typeof U=="string")return U;(0,C.$ih)(U)&&(ue||(ue=[]),ue.push(U))}return ue?(async()=>{for(const x of ue){const G=await x;if(typeof G=="string")return G}return null})():null},B=Q.find(z=>!!z.allBasenames);B&&(X.allBasenames=B.allBasenames);const N=Q.reduce((z,J)=>J.allPaths?z.concat(J.allPaths):z,[]);return N.length&&(X.allPaths=N),X}const ie=function(X,B,N){let z,J;for(let ue=0,x=Q.length;ue<x;ue++){const G=Q[ue];G.requiresSiblings&&N&&(B||(B=(0,I.$oc)(X)),z||(z=B.substr(0,B.length-(0,I.$pc)(X).length)));const U=G(X,B,z,N);if(typeof U=="string")return U;(0,C.$ih)(U)&&(J||(J=[]),J.push(U))}return J?(async()=>{for(const ue of J){const x=await ue;if(typeof x=="string")return x}return null})():null},be=Q.find(X=>!!X.allBasenames);be&&(ie.allBasenames=be.allBasenames);const re=Q.reduce((X,B)=>B.allPaths?X.concat(B.allPaths):X,[]);return re.length&&(ie.allPaths=re),ie}function _(Y,M,Q){if(M===!1)return r;const ce=i(Y,Q);if(ce===r)return r;if(typeof M=="boolean")return ce;if(M){const ie=M.when;if(typeof ie=="string"){const be=(re,X,B,N)=>{if(!N||!ce(re,X))return null;const z=ie.replace("$(basename)",()=>B),J=N(z);return(0,C.$ih)(J)?J.then(ue=>ue?Y:null):J?Y:null};return be.requiresSiblings=!0,be}}return ce}function W(Y,M){const Q=Y.filter(X=>!!X.basenames);if(Q.length<2)return Y;const ce=Q.reduce((X,B)=>{const N=B.basenames;return N?X.concat(N):X},[]);let ie;if(M){ie=[];for(let X=0,B=ce.length;X<B;X++)ie.push(M)}else ie=Q.reduce((X,B)=>{const N=B.patterns;return N?X.concat(N):X},[]);const be=function(X,B){if(typeof X!="string")return null;if(!B){let z;for(z=X.length;z>0;z--){const J=X.charCodeAt(z-1);if(J===47||J===92)break}B=X.substr(z)}const N=ce.indexOf(B);return N!==-1?ie[N]:null};be.basenames=ce,be.patterns=ie,be.allBasenames=ce;const re=Y.filter(X=>!X.basenames);return re.push(be),re}function K(Y,M){return(0,o.$ub)(Y,M,(Q,ce)=>typeof Q=="string"&&typeof ce=="string"?Q===ce:typeof Q!="string"&&typeof ce!="string"?Q.base===ce.base&&Q.pattern===ce.pattern:!1)}}),define(ye[101],Ee([1,0,11,162,19,17,4]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tk=e.MarkdownStringTextNewlineStyle=void 0,e.$Uk=g,e.$Vk=y,e.$Wk=v,e.$Xk=w,e.$Yk=m,e.$Zk=u,e.$1k=a,e.$2k=f;var P;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class b{constructor(d="",p=!1){if(this.value=d,typeof this.value!="string")throw(0,o.$7)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(d,p=0){return this.value+=w(this.supportThemeIcons?(0,C.$Nk)(d):d).replace(/([ \t]+)/g,(E,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,p){return this.value+=`
${m(p,d)}
`,this}appendLink(d,p,E){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(d),")"),E&&(this.value+=` "${this.c(this.c(E,'"'),")")}"`),this.value+=")",this}c(d,p){const E=new RegExp((0,D.$af)(p),"g");return d.replace(E,(h,t)=>d.charAt(t-1)!=="\\"?`\\${h}`:h)}}e.$Tk=b;function g(c){return y(c)?!c.value:Array.isArray(c)?c.every(g):!0}function y(c){return c instanceof b?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}function v(c,d){return c===d?!0:!c||!d?!1:c.value===d.value&&c.isTrusted===d.isTrusted&&c.supportThemeIcons===d.supportThemeIcons&&c.supportHtml===d.supportHtml&&(c.baseUri===d.baseUri||!!c.baseUri&&!!d.baseUri&&(0,S.$3g)(I.URI.from(c.baseUri),I.URI.from(d.baseUri)))}function w(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function m(c,d){const p=c.match(/^`+/gm)?.reduce((h,t)=>h.length>t.length?h:t).length??0,E=p>=3?p+1:3;return[`${"`".repeat(E)}${d}`,c,`${"`".repeat(E)}`].join(`
`)}function u(c){return c.replace(/"/g,"&quot;")}function a(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function f(c){const d=[],p=c.split("|").map(h=>h.trim());c=p[0];const E=p[1];if(E){const h=/height=(\d+)/.exec(E),t=/width=(\d+)/.exec(E),s=h?h[1]:"",r=t?t[1]:"",i=isFinite(parseInt(r)),n=isFinite(parseInt(s));i&&d.push(`width="${r}"`),n&&d.push(`height="${s}"`)}return{href:c,dimensions:d}}}),define(ye[179],Ee([1,0,18,35,7,3,19,17]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dw=b,e.$Ew=y,e.$Fw=w,e.$Gw=m,e.$Hw=c,e.$Iw=p,e.$Jw=E,e.$Kw=h,e.$Lw=t,e.$Mw=s;function b(i,n){const{os:l,tildify:$,relative:k}=n;if(k){const O=g(i,k,l);if(typeof O=="string")return O}let j=i.fsPath;if(l===1&&!D.$i?j=j.replace(/\//g,"\\"):l!==1&&D.$i&&(j=j.replace(/\\/g,"/")),l!==1&&$?.userHome){const O=$.userHome.fsPath;let F;i.scheme!==$.userHome.scheme&&i.path[0]===S.$hc.sep&&i.path[1]!==S.$hc.sep?F=$.userHome.with({path:i.path}).fsPath:F=j,j=w(F,O,l)}return(l===1?S.$gc:S.$hc).normalize(y(j,l===1))}function g(i,n,l){const $=l===1?S.$gc:S.$hc,k=l===3?I.$Zg:I.$2g,j=n.getWorkspace(),A=(0,o.$Ob)(j.folders);if(!A)return;i.scheme!==A.uri.scheme&&i.path[0]===S.$hc.sep&&i.path[1]!==S.$hc.sep&&(i=A.uri.with({path:i.path}));const O=n.getWorkspaceFolder(i);if(!O)return;let F;if(k.isEqual(O.uri,i)?F="":F=k.relativePath(O.uri,i)??"",F&&(F=$.normalize(F)),j.folders.length>1&&!n.noPrefix){const V=O.name?O.name:k.basenameOrAuthority(O.uri);F=F?`${V} \u2022 ${F}`:V}return F}function y(i,n=D.$i){return(0,C.$Ag)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}let v=Object.create(null);function w(i,n,l=D.OS){if(l===1||!i||!n)return i;let $=v.original===n?v.normalized:void 0;$||($=n,D.$i&&($=(0,C.$pg)($)),$=`${(0,P.$gf)($,S.$hc.sep)}${S.$hc.sep}`,v={original:n,normalized:$});let k=i;return D.$i&&(k=(0,C.$pg)(k)),(l===3?k.startsWith($):(0,P.$zf)(k,$))?`~/${k.substr($.length)}`:i}function m(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}const u="\u2026",a="\\\\",f="~";function c(i,n=S.sep){const l=new Array(i.length);let $=!1;for(let k=0;k<i.length;k++){const j=i[k];if(j===""){l[k]=`.${n}`;continue}if(!j){l[k]=j;continue}$=!0;let A="",O=j;O.indexOf(a)===0?(A=O.substr(0,O.indexOf(a)+a.length),O=O.substr(O.indexOf(a)+a.length)):O.indexOf(n)===0?(A=O.substr(0,O.indexOf(n)+n.length),O=O.substr(O.indexOf(n)+n.length)):O.indexOf(f)===0&&(A=O.substr(0,O.indexOf(f)+f.length),O=O.substr(O.indexOf(f)+f.length));const F=O.split(n);for(let V=1;$&&V<=F.length;V++)for(let Z=F.length-V;$&&Z>=0;Z--){$=!1;let oe=F.slice(Z,Z+V).join(n);for(let le=0;!$&&le<i.length;le++)if(le!==k&&i[le]&&i[le].indexOf(oe)>-1){const te=Z+V===F.length,_=Z>0&&i[le].indexOf(n)>-1?n+oe:oe,W=i[le].endsWith(_);$=!te||W}if(!$){let le="";(F[0].endsWith(":")||A!=="")&&(Z===1&&(Z=0,V++,oe=F[0]+n+oe),Z>0&&(le=F[0]+n),le=A+le),Z>0&&(le=le+u+n),le=le+oe,Z+V<F.length&&(le=le+n+u),l[k]=le}}$&&(l[k]=j)}return l}var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function p(i,n=Object.create(null)){const l=[];let $=!1,k="";for(const j of i)if(j==="$"||$&&j==="{")k&&l.push({value:k,type:d.TEXT}),k="",$=!0;else if(j==="}"&&$){const A=n[k];if(typeof A=="string")A.length&&l.push({value:A,type:d.VARIABLE});else if(A){const O=l[l.length-1];(!O||O.type!==d.SEPARATOR)&&l.push({value:A.label,type:d.SEPARATOR})}k="",$=!1}else k+=j;return k&&!$&&l.push({value:k,type:d.TEXT}),l.filter((j,A)=>{if(j.type===d.SEPARATOR){const O=l[A-1],F=l[A+1];return[O,F].every(V=>V&&(V.type===d.VARIABLE||V.type===d.TEXT)&&V.value.length>0)}return!0}).map(j=>j.value).join("")}function E(i,n){return D.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.$j?"&":"&&"):i.replace(/&&|&/g,l=>l==="&"?"&&":"&")}function h(i,n){return D.$j||n?i.replace(/\(&&\w\)|&&/g,""):D.$i?i.replace(/&&|&/g,l=>l==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function s(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const l=r(i.substring(0,n)),$=i.substring(n);return{name:l.name+$,parentPath:l.parentPath}}}return r(i)}function r(i){const n=i.indexOf("/")!==-1?S.$hc:S.$gc,l=n.basename(i),$=n.dirname(i);return l.length?{name:l,parentPath:$}:{name:$,parentPath:""}}}),define(ye[55],Ee([1,0,15,4]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zn=e.$yn=void 0,e.$An=P,e.$Bn=g,e.$Cn=y;function S(v){return v.toJSON()}class D{constructor(w){this.a=w}transformIncoming(w){const m=this.a.transformIncoming(w);return m===w?w:S(C.URI.from(m))}transformOutgoing(w){const m=this.a.transformOutgoing(w);return m===w?w:S(C.URI.from(m))}transformOutgoingURI(w){const m=this.a.transformOutgoing(w);return m===w?w:C.URI.from(m)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$yn=D,e.$zn=new class{transformIncoming(v){return v}transformOutgoing(v){return v}transformOutgoingURI(v){return v}transformOutgoingScheme(v){return v}};function I(v,w,m){if(!v||m>200)return null;if(typeof v=="object"){if(v instanceof C.URI)return w.transformOutgoing(v);for(const u in v)if(Object.hasOwnProperty.call(v,u)){const a=I(v[u],w,m+1);a!==null&&(v[u]=a)}}return null}function P(v,w){const m=I(v,w,0);return m===null?v:m}function b(v,w,m,u){if(!v||u>200)return null;if(typeof v=="object"){if(v.$mid===1)return m?C.URI.revive(w.transformIncoming(v)):w.transformIncoming(v);if(v instanceof o.$Ge)return null;for(const a in v)if(Object.hasOwnProperty.call(v,a)){const f=b(v[a],w,m,u+1);f!==null&&(v[a]=f)}}return null}function g(v,w){const m=b(v,w,!1,0);return m===null?v:m}function y(v,w){const m=b(v,w,!0,0);return m===null?v:m}}),define(ye[102],Ee([1,0,30,64,22,165,3]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$En=void 0,e.$Fn=b,e.$Gn=v,e.$En=new class{c(w){return this.a||(this.a=C.$Ci.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(w)}value(){if(this.b===void 0){let w=0,m=0;const u=(0,o.networkInterfaces)();for(const a in u){const f=u[a];if(f)for(const{mac:c,internal:d}of f)d||(m+=1,this.c(c.toUpperCase())&&(w+=1))}this.b=m>0?w/m:0}return this.b}};let P;async function b(w){return P||(P=(async()=>await g(w)||S.$Sg())()),P}async function g(w){try{const m=await new Promise((a,f)=>{he(["crypto"],a,f)}),u=(0,D.$Dn)();return m.createHash("sha256").update(u,"utf8").digest("hex")}catch(m){w(m);return}}const y="Software\\Microsoft\\SQMClient";async function v(w){if(I.$i){const m=await new Promise((u,a)=>{he(["@vscode/windows-registry"],u,a)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",y,"MachineId")||""}catch(u){return w(u),""}}return""}}),define(ye[180],Ee([1,0,27,308,309,3]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tg=I;async function I(P){if(D.$j||D.$i)return;let b;for(const g of["/etc/os-release","/usr/lib/os-release","/etc/lsb-release"])try{b=await(0,C.open)(g,o.constants.R_OK);break}catch{}if(!b){P("Unable to retrieve release information from known identifier paths.");return}try{const g=new Set(["ID","DISTRIB_ID","ID_LIKE","VERSION_ID","DISTRIB_RELEASE"]),y={id:"unknown"};for await(const v of(0,S.createInterface)({input:b.createReadStream(),crlfDelay:1/0})){if(!v.includes("="))continue;const w=v.split("=")[0].toUpperCase().trim();if(g.has(w)){const m=v.split("=")[1].replace(/"/g,"").toLowerCase().trim();w==="ID"||w==="DISTRIB_ID"?y.id=m:w==="ID_LIKE"?y.id_like=m:(w==="VERSION_ID"||w==="DISTRIB_RELEASE")&&(y.version_id=m)}}return y}catch(g){P(g)}}}),define(ye[23],Ee([1,0,27,30,310,14,35,99,7,3,19,4]),function(he,e,o,C,S,D,I,P,b,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=f,e.readdirSync=p,e.whenDeleted=t,e.configureFlushOnWrite=l,e.writeFileSync=k;var w;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function m(_,W=w.UNLINK,K){if((0,I.$zg)(_))throw new Error("rimraf - will refuse to recursively delete root");return W===w.UNLINK?a(_):u(_,K)}async function u(_,W=(0,I.$Eg)((0,C.tmpdir)())){try{try{await o.promises.rename(_,W)}catch(K){return K.code==="ENOENT"?void 0:a(_)}a(W).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function a(_){return(0,S.promisify)(o.rm)(_,{recursive:!0,force:!0,maxRetries:3})}function f(_){if((0,I.$zg)(_))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(_,{recursive:!0,force:!0,maxRetries:3})}async function c(_,W){return E(await(W?d(_):(0,S.promisify)(o.readdir)(_)))}async function d(_){try{return await(0,S.promisify)(o.readdir)(_,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const W=[],K=await c(_);for(const Y of K){let M=!1,Q=!1,ce=!1;try{const ie=await e.Promises.lstat((0,b.$kc)(_,Y));M=ie.isFile(),Q=ie.isDirectory(),ce=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}W.push({name:Y,isFile:()=>M,isDirectory:()=>Q,isSymbolicLink:()=>ce})}return W}function p(_){return E(o.readdirSync(_))}function E(_){return _.map(W=>typeof W=="string"?g.$j?(0,P.$bm)(W):W:(W.name=g.$j?(0,P.$bm)(W.name):W.name,W))}async function h(_){const W=await c(_),K=[];for(const Y of W)await s.existsDirectory((0,b.$kc)(_,Y))&&K.push(Y);return K}function t(_,W=1e3){return new Promise(K=>{let Y=!1;const M=setInterval(()=>{Y||(Y=!0,o.access(_,Q=>{Y=!1,Q&&(clearInterval(M),K(void 0))}))},W)})}var s;(function(_){async function W(M){let Q;try{if(Q=await e.Promises.lstat(M),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(M),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ce){if(ce.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(g.$i&&ce.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(M)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw ie}throw ce}}_.stat=W;async function K(M){try{const{stat:Q,symbolicLink:ce}=await _.stat(M);return Q.isFile()&&ce?.dangling!==!0}catch{}return!1}_.existsFile=K;async function Y(M){try{const{stat:Q,symbolicLink:ce}=await _.stat(M);return Q.isDirectory()&&ce?.dangling!==!0}catch{}return!1}_.existsDirectory=Y})(s||(e.SymlinkSupport=s={}));const r=new D.$Fh;function i(_,W,K){return r.queueFor(v.URI.file(_),()=>{const Y=j(K);return new Promise((M,Q)=>$(_,W,Y,ce=>ce?Q(ce):M()))},y.$1g)}let n=!0;function l(_){n=_}function $(_,W,K,Y){if(!n)return o.writeFile(_,W,{mode:K.mode,flag:K.flag},Y);o.open(_,K.flag,K.mode,(M,Q)=>{if(M)return Y(M);o.writeFile(Q,W,ce=>{if(ce)return o.close(Q,()=>Y(ce));o.fdatasync(Q,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),l(!1)),o.close(Q,be=>Y(be))))})})}function k(_,W,K){const Y=j(K);if(!n)return o.writeFileSync(_,W,{mode:Y.mode,flag:Y.flag});const M=o.openSync(_,Y.flag,Y.mode);try{o.writeFileSync(M,W);try{o.fdatasyncSync(M)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),l(!1)}}finally{o.closeSync(M)}}function j(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function A(_,W,K=6e4){if(_!==W)try{g.$i&&typeof K=="number"?await O(_,W,Date.now(),K):await(0,S.promisify)(o.rename)(_,W)}catch(Y){if(_.toLowerCase()!==W.toLowerCase()&&Y.code==="EXDEV"||_.endsWith("."))await F(_,W,{preserveSymlinks:!1}),await m(_,w.MOVE);else throw Y}}async function O(_,W,K,Y,M=0){try{return await(0,S.promisify)(o.rename)(_,W)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-K>=Y)throw console.error(`[node.js fs] rename failed after ${M} retries with error: ${Q}`),Q;if(M===0){let ce=!1;try{const{stat:ie}=await s.stat(W);ie.isFile()||(ce=!0)}catch{}if(ce)throw Q}return await(0,D.$xh)(Math.min(100,M*10)),O(_,W,K,Y,M+1)}}async function F(_,W,K){return Z(_,W,{root:{source:_,target:W},options:K,handledSourcePaths:new Set})}const V=511;async function Z(_,W,K){if(K.handledSourcePaths.has(_))return;K.handledSourcePaths.add(_);const{stat:Y,symbolicLink:M}=await s.stat(_);if(M){if(K.options.preserveSymlinks)try{return await te(_,W,K)}catch{}if(M.dangling)return}return Y.isDirectory()?oe(_,W,Y.mode&V,K):le(_,W,Y.mode&V)}async function oe(_,W,K,Y){await e.Promises.mkdir(W,{recursive:!0,mode:K});const M=await c(_);for(const Q of M)await Z((0,b.$kc)(_,Q),(0,b.$kc)(W,Q),Y)}async function le(_,W,K){await e.Promises.copyFile(_,W),await e.Promises.chmod(W,K)}async function te(_,W,K){let Y=await e.Promises.readlink(_);(0,I.$vg)(Y,K.root.source,!g.$k)&&(Y=(0,b.$kc)(K.root.target,Y.substr(K.root.source.length+1))),await e.Promises.symlink(Y,W)}e.Promises=new class{get access(){return(0,S.promisify)(o.access)}get stat(){return(0,S.promisify)(o.stat)}get lstat(){return(0,S.promisify)(o.lstat)}get utimes(){return(0,S.promisify)(o.utimes)}get read(){return(_,W,K,Y,M)=>new Promise((Q,ce)=>{o.read(_,W,K,Y,M,(ie,be,re)=>ie?ce(ie):Q({bytesRead:be,buffer:re}))})}get readFile(){return(0,S.promisify)(o.readFile)}get write(){return(_,W,K,Y,M)=>new Promise((Q,ce)=>{o.write(_,W,K,Y,M,(ie,be,re)=>ie?ce(ie):Q({bytesWritten:be,buffer:re}))})}get appendFile(){return(0,S.promisify)(o.appendFile)}get fdatasync(){return(0,S.promisify)(o.fdatasync)}get truncate(){return(0,S.promisify)(o.truncate)}get copyFile(){return(0,S.promisify)(o.copyFile)}get open(){return(0,S.promisify)(o.open)}get close(){return(0,S.promisify)(o.close)}get symlink(){return(0,S.promisify)(o.symlink)}get readlink(){return(0,S.promisify)(o.readlink)}get chmod(){return(0,S.promisify)(o.chmod)}get mkdir(){return(0,S.promisify)(o.mkdir)}get unlink(){return(0,S.promisify)(o.unlink)}get rmdir(){return(0,S.promisify)(o.rmdir)}get realpath(){return(0,S.promisify)(o.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return c}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return m}get rename(){return A}get copy(){return F}}}),define(ye[181],Ee([1,0,27,7,3,17,23]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4q=P,e.$5q=b,e.$6q=g,e.$7q=y;function P(w){if(S.$k)return w;const m=(0,C.$nc)(w);if(w===m)return w;const u=((0,C.$oc)(w)||w).toLowerCase();try{const f=(0,I.readdirSync)(m).filter(c=>c.toLowerCase()===u);if(f.length===1){const c=P(m);if(c)return(0,C.$kc)(c,f[0])}else if(f.length>1){const c=f.indexOf(u);if(c>=0){const d=P(m);if(d)return(0,C.$kc)(d,f[c])}}}catch{}return null}async function b(w,m){if(S.$k)return w;const u=(0,C.$nc)(w);if(w===u)return w;const a=((0,C.$oc)(w)||w).toLowerCase();try{if(m?.isCancellationRequested)return null;const c=(await I.Promises.readdir(u)).filter(d=>d.toLowerCase()===a);if(c.length===1){const d=await b(u,m);if(d)return(0,C.$kc)(d,c[0])}else if(c.length>1){const d=c.indexOf(a);if(d>=0){const p=await b(u,m);if(p)return(0,C.$kc)(p,c[d])}}}catch{}return null}async function g(w){try{return await I.Promises.realpath(w)}catch{const u=v(w);return await I.Promises.access(u,o.constants.R_OK),u}}function y(w){try{return o.realpathSync(w)}catch{const u=v(w);return o.accessSync(u,o.constants.R_OK),u}}function v(w){return(0,D.$gf)((0,C.$ic)(w),C.sep)}}),define(ye[103],Ee([1,0,30,7,23]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=d,e.$lm=p;const D=/^\d+$/,I=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var b;(function(E){E[E.x64=0]="x64",E[E.x86=1]="x86",E[E.ARM=2]="ARM"})(b||(b={}));let g;switch(process.arch){case"ia32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let y;process.env.PROCESSOR_ARCHITEW6432?y=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?y=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?y=1:y=0;class v{constructor(h,t,s){this.exePath=h,this.displayName=t,this.a=s}async exists(){return this.a===void 0&&(this.a=await S.SymlinkSupport.existsFile(this.exePath)),this.a}}function w({useAlternateBitness:E=!1}={}){return E?g===0?process.env["ProgramFiles(x86)"]||null:y===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:E=!1,findPreview:h=!1}={}){const t=w({useAlternateBitness:E});if(!t)return null;const s=C.$kc(t,"PowerShell");if(!await S.SymlinkSupport.existsDirectory(s))return null;let r=-1,i=null;for(const $ of await S.Promises.readdir(s)){let k=-1;if(h){const A=$.indexOf("-");if(A<0)continue;const O=$.substring(0,A);if(!D.test(O)||$.substring(A+1)!=="preview")continue;k=parseInt(O,10)}else{if(!D.test($))continue;k=parseInt($,10)}if(k<=r)continue;const j=C.$kc(s,$,"pwsh.exe");await S.SymlinkSupport.existsFile(j)&&(i=j,r=k)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",l=h?" Preview":"";return new v(i,`PowerShell${l}${n}`,!0)}async function u({findPreview:E}={}){if(!process.env.LOCALAPPDATA)return null;const h=C.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await S.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=E?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const r of await S.Promises.readdir(h))if(t.test(r)){const i=C.$kc(h,r,"pwsh.exe");return new v(i,s)}return null}function a(){const E=C.$kc(o.homedir(),".dotnet","tools","pwsh.exe");return new v(E,".NET Core PowerShell Global Tool")}function f(){const E=C.$kc(process.env.windir,g===1&&y!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new v(E,"Windows PowerShell",!0)}async function*c(){let E=await m();E&&(yield E),E=await m({useAlternateBitness:!0}),E&&(yield E),E=await u(),E&&(yield E),E=a(),E&&(yield E),E=await m({findPreview:!0}),E&&(yield E),E=await u({findPreview:!0}),E&&(yield E),E=await m({useAlternateBitness:!0,findPreview:!0}),E&&(yield E),E=f(),E&&(yield E)}async function*d(){for await(const E of c())await E.exists()&&(yield E)}async function p(){for await(const E of d())return E;return null}}),define(ye[104],Ee([1,0,7,3,31,66,10,23]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$om=b,e.$pm=g,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return D.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return D.TerminateResponseCode}});function b(v=S.env){return v.comspec||"cmd.exe"}function g(v){let w=[],m=!1;const u=function(a){if(m){w.push(a);return}(!v.send(a,c=>{if(c&&console.error(c),m=!1,w.length>0){const d=w.slice(0);w=[],d.forEach(p=>u(p))}})||C.$i)&&(m=!0)};return{send:u}}var y;(function(v){async function w(m,u,a){if(o.$jc(m))return m;if(u===void 0&&(u=S.cwd()),o.$nc(m)!=="."||(a===void 0&&I.$9f(S.env.PATH)&&(a=S.env.PATH.split(o.$uc)),a===void 0||a.length===0))return o.$kc(u,m);async function c(d){if(await P.Promises.exists(d)){let p;try{p=await P.Promises.stat(d)}catch(E){E.message.startsWith("EACCES")&&(p=await P.Promises.lstat(d))}return p?!p.isDirectory():!1}return!1}for(const d of a){let p;if(o.$jc(d)?p=o.$kc(d,m):p=o.$kc(u,d,m),await c(p))return p;let E=p+".com";if(await c(E)||(E=p+".exe",await c(E)))return E}return o.$kc(u,m)}v.findExecutable=w})(y||(e.win32=y={}))}),define(ye[105],Ee([1,0,56,13]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=S;function S(I){return new Promise((P,b)=>{let g;const y=new Map;function v(m,u,a,f,c){const d=y.get(u);if(m===I||d){const p={name:w(a),cmd:a,pid:m,ppid:u,load:f,mem:c};y.set(m,p),m===I&&(g=p),d&&(d.children||(d.children=[]),d.children.push(p),d.children.length>1&&(d.children=d.children.sort((E,h)=>E.pid-h.pid)))}}function w(m){const u=/--utility-sub-type=network/i,a=/--crashes-directory/i,f=/\\pipe\\winpty-control/i,c=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(a.exec(m))return"electron-crash-reporter";if(f.exec(m))return"winpty-agent";if(c.exec(m))return"conpty-agent";let p=d.exec(m);if(p&&p.length===2)return p[1]==="renderer"?"window":p[1]==="utility"?u.exec(m)?"utility-network-service":"utility-process":p[1]==="extensionHost"?"extension-host":p[1];const E=/[a-zA-Z-]+\.js/g;let h="";do p=E.exec(m),p&&(h+=p+" ");while(p);return h&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${h})`:m}if(process.platform==="win32"){const m=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substring(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substring(5):u;new Promise((u,a)=>{he(["@vscode/windows-process-tree"],u,a)}).then(u=>{u.getProcessList(I,a=>{if(!a){b(new Error(`Root process ${I} not found`));return}u.getProcessCpuUsage(a,f=>{const c=new Map;f.forEach(d=>{const p=m(d.commandLine||"");c.set(d.pid,{name:w(p),cmd:p,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),g=c.get(I),g?(c.forEach(d=>{const p=c.get(d.ppid);p&&(p.children||(p.children=[]),p.children.push(d))}),c.forEach(d=>{d.children&&(d.children=d.children.sort((p,E)=>p.pid-E.pid))}),P(g)):b(new Error(`Root process ${I} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let m=function(){let u=[g];const a=[];for(;u.length;){const c=u.shift();c&&(a.push(c.pid),c.children&&(u=u.concat(c.children)))}let f=JSON.stringify(C.$Qg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);f+=" "+a.join(" "),(0,o.exec)(f,{},(c,d,p)=>{if(c||p)b(c||new Error(p.toString()));else{const E=d.toString().split(`
`);for(let h=0;h<a.length;h++){const t=y.get(a[h]);t.load=parseFloat(E[h])}if(!g){b(new Error(`Root process ${I} not found`));return}P(g)}})};(0,o.exec)("which ps",{},(u,a,f)=>{if(u||f)if(process.platform!=="linux")b(u||new Error(f.toString()));else{const c=JSON.stringify(C.$Qg.asFileUri("vs/base/node/ps.sh").fsPath);(0,o.exec)(c,{},(d,p,E)=>{d||E?b(d||new Error(E.toString())):(D(p,v),m())})}else{const c=a.toString().trim();(0,o.exec)(`${c} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,E,h)=>{p||h&&!h.includes("screen size is bogus")?b(p||new Error(h.toString())):(D(E,v),process.platform==="linux"?m():g?P(g):b(new Error(`Root process ${I} not found`)))})}})}})}function D(I,P){const b=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const y of g){const v=b.exec(y.trim());v&&v.length===6&&P(parseInt(v[1]),parseInt(v[2]),v[5],parseFloat(v[3]),parseFloat(v[4]))}}}),define(ye[106],Ee([1,0,30,3,103,104]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qm=I;async function I(v,w){return v===1?C.$i?y():D.$om(w):b(v,w)}let P=null;function b(v,w){if(C.$k&&v===2||C.$j&&v===3)return"/bin/bash";if(!P){let m;if(C.$i)m="/bin/bash";else{if(m=w.SHELL,!m)try{m=(0,o.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}P=m}return P}let g=null;async function y(){return g||(g=(await(0,S.$lm)()).exePath),g}});var Le=this&&this.__decorate||function(he,e,o,C){var S=arguments.length,D=S<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,o):C,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(he,e,o,C);else for(var P=he.length-1;P>=0;P--)(I=he[P])&&(D=(S<3?I(D):S>3?I(e,o,D):I(e,o))||D);return S>3&&D&&Object.defineProperty(e,o,D),D};define(ye[46],Ee([1,0,18,14,15,20,74,11,6,2,54,17,10]),function(he,e,o,C,S,D,I,P,b,g,y,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fi=e.ProxyChannel=e.$ei=e.$bi=e.$ai=e.$_h=e.RequestInitiator=e.$$h=e.$8h=e.$7h=void 0,e.$9h=l,e.$0h=$,e.$ci=V,e.$di=Z;var m;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(m||(m={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var a;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(a||(a={}));function f(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(c||(c={}));function d(M){let Q=0;for(let ce=0;;ce+=7){const ie=M.read(1);if(Q|=(ie.buffer[0]&127)<<ce,!(ie.buffer[0]&128))return Q}}const p=r(0);function E(M,Q){if(Q===0){M.write(p);return}let ce=0;for(let be=Q;be!==0;be=be>>>7)ce++;const ie=S.$Ge.alloc(ce);for(let be=0;Q!==0;be++)ie.buffer[be]=Q&127,Q=Q>>>7,Q>0&&(ie.buffer[be]|=128);M.write(ie)}class h{constructor(Q){this.b=Q,this.a=0}read(Q){const ce=this.b.slice(this.a,this.a+Q);return this.a+=ce.byteLength,ce}}e.$7h=h;class t{constructor(){this.a=[]}get buffer(){return S.$Ge.concat(this.a)}write(Q){this.a.push(Q)}}e.$8h=t;var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(s||(s={}));function r(M){const Q=S.$Ge.alloc(1);return Q.writeUInt8(M,0),Q}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},n=typeof Buffer<"u";function l(M,Q){if(typeof Q>"u")M.write(i.Undefined);else if(typeof Q=="string"){const ce=S.$Ge.fromString(Q);M.write(i.String),E(M,ce.byteLength),M.write(ce)}else if(n&&Buffer.isBuffer(Q)){const ce=S.$Ge.wrap(Q);M.write(i.Buffer),E(M,ce.byteLength),M.write(ce)}else if(Q instanceof S.$Ge)M.write(i.VSBuffer),E(M,Q.byteLength),M.write(Q);else if(Array.isArray(Q)){M.write(i.Array),E(M,Q.length);for(const ce of Q)l(M,ce)}else if(typeof Q=="number"&&(Q|0)===Q)M.write(i.Uint),E(M,Q);else{const ce=S.$Ge.fromString(JSON.stringify(Q));M.write(i.Object),E(M,ce.byteLength),M.write(ce)}}function $(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(d(M)).toString();case s.Buffer:return M.read(d(M)).buffer;case s.VSBuffer:return M.read(d(M));case s.Array:{const ce=d(M),ie=[];for(let be=0;be<ce;be++)ie.push($(M));return ie}case s.Object:return JSON.parse(M.read(d(M)).toString());case s.Int:return d(M)}}class k{constructor(Q,ce,ie=null,be=1e3){this.h=Q,this.j=ce,this.k=ie,this.l=be,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(re=>this.q(re)),this.m({type:200})}registerChannel(Q,ce){this.b.set(Q,ce),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const ce=this.o([Q.type]);this.k?.logOutgoing(ce,0,1,f(Q.type));return}case 201:case 202:case 204:case 203:{const ce=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(ce,Q.id,1,f(Q.type),Q.data);return}}}o(Q,ce=void 0){const ie=new t;return l(ie,Q),l(ie,ce),this.p(ie.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const ce=new h(Q),ie=$(ce),be=$(ce),re=ie[0];switch(re){case 100:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${u(re)}: ${ie[2]}.${ie[3]}`,be),this.s({type:re,id:ie[1],channelName:ie[2],name:ie[3],arg:be});case 102:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${u(re)}: ${ie[2]}.${ie[3]}`,be),this.t({type:re,id:ie[1],channelName:ie[2],name:ie[3],arg:be});case 101:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${u(re)}`),this.u({type:re,id:ie[1]});case 103:return this.k?.logIncoming(Q.byteLength,ie[1],1,`${u(re)}`),this.u({type:re,id:ie[1]})}}s(Q){const ce=this.b.get(Q.channelName);if(!ce){this.v(Q);return}const ie=new D.$pe;let be;try{be=ce.call(this.j,Q.name,Q.arg,ie.token)}catch(B){be=Promise.reject(B)}const re=Q.id;be.then(B=>{this.m({id:re,data:B,type:201})},B=>{B instanceof Error?this.m({id:re,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.m({id:re,data:B,type:203})}).finally(()=>{X.dispose(),this.d.delete(Q.id)});const X=(0,g.$Tc)(()=>ie.cancel());this.d.set(Q.id,X)}t(Q){const ce=this.b.get(Q.channelName);if(!ce){this.v(Q);return}const ie=Q.id,re=ce.listen(this.j,Q.name,Q.arg)(X=>this.m({id:ie,data:X,type:204}));this.d.set(Q.id,re)}u(Q){const ce=this.d.get(Q.id);ce&&(ce.dispose(),this.d.delete(Q.id))}v(Q){let ce=this.g.get(Q.channelName);ce||(ce=[],this.g.set(Q.channelName,ce));const ie=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ce.push({request:Q,timeoutTimer:ie})}w(Q){const ce=this.g.get(Q);if(ce){for(const ie of ce)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}e.$$h=k;var j;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(j||(e.RequestInitiator=j={}));class A{constructor(Q,ce=null){this.l=Q,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new b.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=ce}getChannel(Q){const ce=this;return{call(ie,be,re){return ce.a?Promise.reject(new P.$5):ce.m(Q,ie,be,re)},listen(ie,be){return ce.a?b.Event.None:ce.o(Q,ie,be)}}}m(Q,ce,ie,be=D.CancellationToken.None){const re=this.g++,B={id:re,type:100,channelName:Q,name:ce,arg:ie};if(be.isCancellationRequested)return Promise.reject(new P.$5);let N;return new Promise((J,ue)=>{if(be.isCancellationRequested)return ue(new P.$5);const x=()=>{const q=se=>{switch(se.type){case 201:this.f.delete(re),J(se.data);break;case 202:{this.f.delete(re);const ae=new Error(se.data.message);ae.stack=Array.isArray(se.data.stack)?se.data.stack.join(`
`):se.data.stack,ae.name=se.data.name,ue(ae);break}case 203:this.f.delete(re),ue(se.data);break}};this.f.set(re,q),this.p(B)};let G=null;this.b===c.Idle?x():(G=(0,C.$jh)(q=>this.u()),G.then(()=>{G=null,x()}));const U=()=>{G?(G.cancel(),G=null):this.p({id:re,type:101}),ue(new P.$5)},T=be.onCancellationRequested(U);N=(0,g.$Sc)((0,g.$Tc)(U),T),this.d.add(N)}).finally(()=>{N.dispose(),this.d.delete(N)})}o(Q,ce,ie){const be=this.g++,X={id:be,type:102,channelName:Q,name:ce,arg:ie};let B=null;const N=new b.$ee({onWillAddFirstListener:()=>{B=(0,C.$jh)(J=>this.u()),B.then(()=>{B=null,this.d.add(N),this.p(X)})},onDidRemoveLastListener:()=>{B?(B.cancel(),B=null):(this.d.delete(N),this.p({id:be,type:103}))}}),z=J=>N.fire(J.data);return this.f.set(be,z),N.event}p(Q){switch(Q.type){case 100:case 102:{const ce=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(ce,Q.id,0,`${u(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const ce=this.q([Q.type,Q.id]);this.j?.logOutgoing(ce,Q.id,0,u(Q.type));return}}}q(Q,ce=void 0){const ie=new t;return l(ie,Q),l(ie,ce),this.r(ie.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const ce=new h(Q),ie=$(ce),be=$(ce),re=ie[0];switch(re){case 200:return this.j?.logIncoming(Q.byteLength,0,0,f(re)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,ie[1],0,f(re),be),this.t({type:ie[0],id:ie[1],data:be})}}t(Q){if(Q.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return b.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}e.$_h=A,Le([I.$1h],A.prototype,"onDidInitializePromise",null);class O{get connections(){const Q=[];return this.f.forEach(ce=>Q.push(ce)),Q}constructor(Q,ce,ie){this.a=new Map,this.f=new Set,this.g=new b.$ee,this.onDidAddConnection=this.g.event,this.h=new b.$ee,this.onDidRemoveConnection=this.h.event,this.j=new g.$Uc,this.j.add(Q(({protocol:be,onDidClientDisconnect:re})=>{const X=b.Event.once(be.onMessage);this.j.add(X(B=>{const N=new h(B),z=$(N),J=new k(be,z,ce,ie),ue=new A(be,ce);this.a.forEach((G,U)=>J.registerChannel(U,G));const x={channelServer:J,channelClient:ue,ctx:z};this.f.add(x),this.g.fire(x),this.j.add(re(()=>{J.dispose(),ue.dispose(),this.f.delete(x),this.h.fire(x)}))}))}))}getChannel(Q,ce){const ie=this;return{call(be,re,X){let B;if((0,w.$kg)(ce)){const z=(0,o.$4b)(ie.connections.filter(ce));B=z?Promise.resolve(z):b.Event.toPromise(b.Event.filter(ie.onDidAddConnection,ce))}else B=ce.routeCall(ie,be,re);const N=B.then(z=>z.channelClient.getChannel(Q));return V(N).call(be,re,X)},listen(be,re){if((0,w.$kg)(ce))return ie.k(Q,ce,be,re);const X=ce.routeEvent(ie,be,re).then(B=>B.channelClient.getChannel(Q));return V(X).listen(be,re)}}}k(Q,ce,ie,be){const re=this;let X;const B=new b.$ee({onWillAddFirstListener:()=>{X=new g.$Uc;const N=new b.$ke,z=new Map,J=x=>{const U=x.channelClient.getChannel(Q).listen(ie,be),T=N.add(U);z.set(x,T)},ue=x=>{const G=z.get(x);G&&(G.dispose(),z.delete(x))};re.connections.filter(ce).forEach(J),b.Event.filter(re.onDidAddConnection,ce)(J,void 0,X),re.onDidRemoveConnection(ue,void 0,X),N.event(B.fire,B,X),X.add(N)},onDidRemoveLastListener:()=>{X?.dispose(),X=void 0}});return B.event}registerChannel(Q,ce){this.a.set(Q,ce);for(const ie of this.f)ie.channelServer.registerChannel(Q,ce)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ai=O;class F{constructor(Q,ce,ie=null){const be=new t;l(be,ce),Q.send(be.buffer),this.a=new A(Q,ie),this.d=new k(Q,ce,ie)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,ce){this.d.registerChannel(Q,ce)}dispose(){this.a.dispose(),this.d.dispose()}}e.$bi=F;function V(M){return{call(Q,ce,ie){return M.then(be=>be.call(Q,ce,ie))},listen(Q,ce){const ie=new b.$ne;return M.then(be=>ie.input=be.listen(Q,ce)),ie.event}}}function Z(M){let Q=!1;return{call(ce,ie,be){return Q?M.call(ce,ie,be):(0,C.$xh)(0).then(()=>Q=!0).then(()=>M.call(ce,ie,be))},listen(ce,ie){if(Q)return M.listen(ce,ie);const be=new b.$ne;return(0,C.$xh)(0).then(()=>Q=!0).then(()=>be.input=M.listen(ce,ie)),be.event}}}class oe{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const ce of Q.connections)if(await Promise.resolve(this.a(ce.ctx)))return Promise.resolve(ce);return await b.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$ei=oe;var le;(function(M){function Q(re,X,B){const N=re,z=B&&B.disableMarshalling,J=new Map;for(const ue in N)ie(ue)&&J.set(ue,b.Event.buffer(N[ue],!0,void 0,X));return new class{listen(ue,x,G){const U=J.get(x);if(U)return U;const T=N[x];if(typeof T=="function"){if(be(x))return T.call(N,G);if(ie(x))return J.set(x,b.Event.buffer(N[x],!0,void 0,X)),J.get(x)}throw new P.$bb(`Event not found: ${x}`)}call(ue,x,G){const U=N[x];if(typeof U=="function"){if(!z&&Array.isArray(G))for(let q=0;q<G.length;q++)G[q]=(0,y.$6h)(G[q]);let T=U.apply(N,G);return T instanceof Promise||(T=Promise.resolve(T)),T}throw new P.$bb(`Method not found: ${x}`)}}}M.fromService=Q;function ce(re,X){const B=X&&X.disableMarshalling;return new Proxy({},{get(N,z){if(typeof z=="string")return X?.properties?.has(z)?X.properties.get(z):be(z)?function(J){return re.listen(z,J)}:ie(z)?re.listen(z):async function(...J){let ue;X&&!(0,w.$fg)(X.context)?ue=[X.context,...J]:ue=J;const x=await re.call(z,ue);return B?x:(0,y.$6h)(x)};throw new P.$bb(`Property not found: ${String(z)}`)}})}M.toService=ce;function ie(re){return re[0]==="o"&&re[1]==="n"&&v.$xf(re.charCodeAt(2))}function be(re){return/^onDynamic/.test(re)&&v.$xf(re.charCodeAt(9))}})(le||(e.ProxyChannel=le={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const Q=M.toString();if(Q!=="[object Object]")return Q}return M}function W(M){return Array.isArray(M)?M.map(_):_(M)}function K(M,Q,ce,ie,be,re,X){X=W(X);const B=te[be],N=B[ie%B.length];let z=[`%c[${M}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(ce).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${re}`,"color: darkgreen","color: grey","color: grey",`color: ${N}`];/\($/.test(re)?(z=z.concat(X),z.push(")")):z.push(X),console.log.apply(console,z)}class Y{constructor(Q,ce){this.d=Q,this.f=ce,this.a=0,this.b=0}logOutgoing(Q,ce,ie,be,re){this.b+=Q,K(this.d,this.b,Q,ce,ie,be,re)}logIncoming(Q,ce,ie,be,re){this.a+=Q,K(this.f,this.a,Q,ce,ie,be,re)}}e.$fi=Y}),define(ye[107],Ee([1,0,15,6,2,46]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ki=e.$ji=e.$ii=e.$hi=e.ProtocolConstants=e.$gi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var P;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let l=0;function $(j,A){if(!n.has(j)){const O=String(++l);n.set(j,O)}return n.get(j)}function k(j,A,O,F){if(!i.enableDiagnostics)return;const V=$(j,A);if(F instanceof o.$Ge||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const Z=o.$Ge.alloc(F.byteLength);Z.set(F),i.records.push({timestamp:Date.now(),id:V,label:A,type:O,buff:Z})}else i.records.push({timestamp:Date.now(),id:V,label:A,type:O,data:F})}i.traceSocketEvent=k})(P||(e.SocketDiagnostics=P={}));var b;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b||(e.SocketCloseEventType=b={}));let g=null;function y(){return g||(g=o.$Ge.alloc(0)),g}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,l){if(n===0)return y();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const A=this.a[0];return l&&(this.a.shift(),this.b-=n),A}if(this.a[0].byteLength>n){const A=this.a[0].slice(0,n);return l&&(this.a[0]=this.a[0].slice(n),this.b-=n),A}const $=o.$Ge.alloc(n);let k=0,j=0;for(;n>0;){const A=this.a[j];if(A.byteLength>n){const O=A.slice(0,n);$.set(O,k),k+=n,l&&(this.a[j]=A.slice(n),this.b-=n),n-=n}else $.set(A,k),k+=A.byteLength,l?(this.a.shift(),this.b-=A.byteLength):j++,n-=A.byteLength}return $}}e.$gi=v;var w;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(w||(w={}));function m(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var u;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(u||(e.ProtocolConstants=u={}));class a{constructor(n,l,$,k){this.type=n,this.id=l,this.ack=$,this.data=k,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends S.$Vc{constructor(n){super(),this.f=this.B(new C.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new v,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,k=this.g.id,j=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new a($,k,j,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=o.$Ge.alloc(13);l.writeUInt8(n.type,0),l.writeUInt32BE(n.id,1),l.writeUInt32BE(n.ack,5),l.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(l,n.data)}g(n,l){const $=this.f===0;return this.d.push(n,l),this.f+=n.byteLength+l.byteLength,$}h(){const n=o.$Ge.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,l){this.g(n,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class d extends S.$Vc{constructor(n){super(),this.f=new C.$ee,this.onMessage=this.f.event,this.g=new C.$ee,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new c(this.a)),this.c=this.B(new f(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new a(1,0,0,n))}}e.$hi=d;class p extends D.$bi{static fromSocket(n,l){return new p(new d(n),l)}get onDidDispose(){return this.b.onDidDispose}constructor(n,l,$=null){super(n,l,$),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$ii=p;class E{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$ji=E;class h{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,l=this.a;for(;l;)l=l.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let l=0,$=this.a;for(;$;)n[l++]=$.data,$=$.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const l=new h(n);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class s{static{this.a=10}static{this.b=null}static getInstance(){return s.b||(s.b=new s),s.b}constructor(){this.c=[];const n=Date.now();for(let l=0;l<s.a;l++)this.c[l]=n-1e3*l;setInterval(()=>{for(let l=s.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),l=(1+s.a)*1e3;let $=0;for(let k=0;k<s.a;k++)n-this.c[k]<=l&&$++;return 1-$/s.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new E,this.onControlMessage=this.u.event,this.v=new E,this.onMessage=this.v.event,this.w=new E,this.onDidDispose=this.w.event,this.x=new E,this.onSocketClose=this.x.event,this.y=new E,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??s.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new S.$Uc,this.o=n.socket,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new a(5,0,0,y());this.p.write(n),this.p.flush()}sendPause(){const n=new a(7,0,0,y());this.p.write(n)}sendResume(){const n=new a(8,0,0,y());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,l){this.a=!0,this.r.dispose(),this.r=new S.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new c(this.o)),this.q=this.r.add(new f(this.o)),this.r.add(this.q.onMessage($=>this.z($))),this.r.add(this.o.onClose($=>this.x.fire($))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new a(3,0,this.h,y());this.p.write(n);const l=this.b.toArray();for(let $=0,k=l.length;$<k;$++)this.p.write(l[$]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const l=this.b.peek();if(l&&l.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new a(6,0,0,y())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let $=0,k=l.length;$<k;$++)this.p.write(l[$]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const l=++this.c;this.h=this.g;const $=new a(1,l,this.h,n);this.b.push($),this.a||(this.p.write($),this.B())}sendControl(n){const l=new a(2,0,0,n);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),l=Date.now()-n.writtenTime,$=Date.now()-this.q.lastReadTime,k=Date.now()-this.n;if(l>=2e4&&$>=2e4&&k>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:$});return}const j=Math.max(2e4-l,2e4-$,2e4-k,500);this.f=setTimeout(()=>{this.f=null,this.B()},j)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new a(3,0,this.h,y());this.p.write(n)}D(){this.h=this.g;const n=new a(9,0,this.h,y());this.p.write(n)}}e.$ki=r}),define(ye[108],Ee([1,0,56,14,15,20,177,11,6,2,21,104,66,46]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=void 0;class u extends m.$$h{constructor(c){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:b.Event.fromNodeEventEmitter(process,"message",d=>S.$Ge.wrap(Buffer.from(d,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$Zq=u;class a{constructor(c,d){this.i=c,this.j=d,this.c=new Set,this.g=new Map,this.h=new b.$ee,this.onDidProcessExit=this.h.event;const p=d&&d.timeout?d.timeout:6e4;this.b=new C.$th(p),this.d=null,this.f=null}getChannel(c){const d=this;return{call(p,E,h){return d.k(c,p,E,h)},listen(p,E){return d.l(c,p,E)}}}k(c,d,p,E=D.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(E.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const h=this.n(c),t=(0,C.$jh)(i=>h.call(d,p,i)),s=E.onCancellationRequested(()=>t.cancel()),r=(0,g.$Tc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{s.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(c,d,p){if(!this.b)return b.Event.None;this.b.cancel();let E;const h=new b.$ee({onWillAddFirstListener:()=>{E=this.n(c).listen(d,p)(h.fire,h),this.c.add(E)},onDidRemoveLastListener:()=>{this.c.delete(E),E.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return h.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,y.$3n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l)).filter(l=>!l.startsWith("--vscode-"))),(0,w.$nm)(d.env),this.d=(0,o.fork)(this.i,c,d);const p=new b.$ee,h=b.Event.fromNodeEventEmitter(this.d,"message",l=>l)(l=>{if((0,I.$Vq)(l)){(0,I.log)(l,`IPC Library: ${this.j.serverName}`);return}p.fire(S.$Ge.wrap(Buffer.from(l,"base64")))}),t=this.j.useQueue?(0,v.$pm)(this.d):this.d,s=l=>this.d&&this.d.connected&&t.send(l.buffer.toString("base64")),r=p.event,i={send:s,onMessage:r};this.f=new m.$_h(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",l=>console.warn('IPC "'+this.j.serverName+'" errored with '+l)),this.d.on("exit",(l,$)=>{process.removeListener("exit",n),h.dispose(),this.c.forEach(k=>(0,g.$Qc)(k)),this.c.clear(),l!==0&&$!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+l+" and signal "+$),this.b?.cancel(),this.o(),this.h.fire({code:l,signal:$})})}return this.f}n(c){let d=this.g.get(c);return d||(d=this.m.getChannel(c),this.g.set(c,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$1q=a}),define(ye[182],Ee([1,0,14,6,2,54,10]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=e.$Wp=e.StorageState=e.StorageHint=void 0,e.$Vp=b;var P;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function b(w){const m=w;return m?.changed instanceof Map||m?.deleted instanceof Set}var g;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(g||(e.StorageState=g={}));class y extends S.$Vc{static{this.a=100}constructor(m,u=Object.create(null)){super(),this.r=m,this.s=u,this.b=this.B(new C.$he),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new o.$uh(y.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((u,a)=>this.w(a,u)),m.deleted?.forEach(u=>this.w(u,void 0))}finally{this.b.resume()}}w(m,u){if(this.c===g.Closed)return;let a=!1;(0,I.$fg)(u)?a=this.f.delete(m):this.f.get(m)!==u&&(this.f.set(m,u),a=!0),a&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,u){const a=this.f.get(m);return(0,I.$fg)(a)?u:a}getBoolean(m,u){const a=this.get(m);return(0,I.$fg)(a)?u:a==="true"}getNumber(m,u){const a=this.get(m);return(0,I.$fg)(a)?u:parseInt(a,10)}getObject(m,u){const a=this.get(m);return(0,I.$fg)(a)?u:(0,D.$5h)(a)}async set(m,u,a=!1){if(this.c===g.Closed)return;if((0,I.$fg)(u))return this.delete(m,a);const f=(0,I.$$f)(u)||Array.isArray(u)?(0,D.$4h)(u):String(u);if(this.f.get(m)!==f)return this.f.set(m,f),this.j.set(m,f),this.h.delete(m),this.b.fire({key:m,external:a}),this.D()}async delete(m,u=!1){if(!(this.c===g.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:u}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$Wp=y;class v{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((u,a)=>this.a.set(a,u)),m.delete?.forEach(u=>this.a.delete(u))}async optimize(){}async close(){}}e.$Xp=v}),define(ye[183],Ee([8,9]),function(he,e){return he.create("vs/base/node/zip",e)}),define(ye[81],Ee([1,0,27,14,7,10,23,183]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0,e.zip=f,e.$jq=c,e.$kq=p,e.$gq="end of central directory record signature not found";const b=new RegExp(e.$gq);class g extends Error{constructor(h,t){let s=t.message;switch(h){case"CorruptZip":s=`Corrupt ZIP: ${s}`;break}super(s),this.type=h,this.cause=t}}e.$hq=g;function y(E){const h=E.externalFileAttributes>>16||33188;return[448,56,7].map(t=>h&t).reduce((t,s)=>t+s,h&61440)}function v(E){if(E instanceof g)return E;let h;return b.test(E.message)&&(h="CorruptZip"),new g(h,E)}function w(E,h,t,s,r,i){const n=S.$nc(h),l=S.$kc(s,n);if(!l.startsWith(s))return Promise.reject(new Error(P.localize(0,null,h)));const $=S.$kc(s,h);let k;return i.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(I.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((j,A)=>{if(!i.isCancellationRequested)try{k=(0,o.createWriteStream)($,{mode:t}),k.once("close",()=>j()),k.once("error",A),E.once("error",A),E.pipe(k)}catch(O){A(O)}}))}function m(E,h,t,s){let r=(0,C.$jh)(()=>Promise.resolve()),i=0;const n=s.onCancellationRequested(()=>{r.cancel(),E.close()});return new Promise((l,$)=>{const k=new C.$rh,j=A=>{A.isCancellationRequested||(i++,E.readEntry())};E.once("error",$),E.once("close",()=>r.then(()=>{s.isCancellationRequested||E.entryCount===i?l():$(new g("Incomplete",new Error(P.localize(1,null,i,E.entryCount))))},$)),E.readEntry(),E.on("entry",A=>{if(s.isCancellationRequested)return;if(!t.sourcePathRegex.test(A.fileName)){j(s);return}const O=A.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(O)){const Z=S.$kc(h,O);r=(0,C.$jh)(oe=>I.Promises.mkdir(Z,{recursive:!0}).then(()=>j(oe)).then(void 0,$));return}const F=a(E,A),V=y(A);r=(0,C.$jh)(Z=>k.queue(()=>F.then(oe=>w(oe,O,V,h,t,Z).then(()=>j(Z)))).then(null,$))})}).finally(()=>n.dispose())}async function u(E,h=!1){const{open:t}=await new Promise((s,r)=>{he(["yauzl"],s,r)});return new Promise((s,r)=>{t(E,h?{lazyEntries:!0}:void 0,(i,n)=>{i?r(v(i)):s((0,D.$hg)(n))})})}function a(E,h){return new Promise((t,s)=>{E.openReadStream(h,(r,i)=>{r?s(v(r)):t((0,D.$hg)(i))})})}async function f(E,h){const{ZipFile:t}=await new Promise((s,r)=>{he(["yazl"],s,r)});return new Promise((s,r)=>{const i=new t;h.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const n=(0,o.createWriteStream)(E);i.outputStream.pipe(n),i.outputStream.once("error",r),n.once("error",r),n.once("finish",()=>s(E))})}function c(E,h,t={},s){const r=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let i=u(E,!0);return t.overwrite&&(i=i.then(n=>I.Promises.rm(h).then(()=>n))),i.then(n=>m(n,h,{sourcePathRegex:r},s))}function d(E,h){return u(E).then(t=>new Promise((s,r)=>{t.on("entry",i=>{i.fileName===h&&a(t,i).then(n=>s(n),n=>r(n))}),t.once("close",()=>r(new Error(P.localize(2,null,h))))}))}function p(E,h){return d(E,h).then(t=>new Promise((s,r)=>{const i=[];t.once("error",r),t.on("data",n=>i.push(n)),t.on("end",()=>s(Buffer.concat(i)))}))}}),define(ye[184],Ee([8,9]),function(he,e){return he.create("vs/editor/common/languages",e)}),define(ye[185],Ee([1,0,53,4,167,45,168,184]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.ExternalUriOpenerPriority=e.$fu=e.$eu=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadApplicability=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$du=e.$cu=e.SymbolKinds=e.SymbolTag=e.$au=e.SymbolKind=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.DocumentPasteTriggerKind=e.CodeActionTriggerType=e.$$t=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.PartialAcceptTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.HoverVerbosityAction=e.$0t=e.$9t=e.$8t=void 0,e.$_t=r,e.$bu=n;class b{constructor(Q,ce,ie){this.offset=Q,this.type=ce,this.language=ie,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$8t=b;class g{constructor(Q,ce){this.tokens=Q,this.endState=ce,this._tokenizationResultBrand=void 0}}e.$9t=g;class y{constructor(Q,ce){this.tokens=Q,this.endState=ce,this._encodedTokenizationResultBrand=void 0}}e.$0t=y;var v;(function(M){M[M.Increase=0]="Increase",M[M.Decrease=1]="Decrease"})(v||(e.HoverVerbosityAction=v={}));var w;(function(M){M[M.Method=0]="Method",M[M.Function=1]="Function",M[M.Constructor=2]="Constructor",M[M.Field=3]="Field",M[M.Variable=4]="Variable",M[M.Class=5]="Class",M[M.Struct=6]="Struct",M[M.Interface=7]="Interface",M[M.Module=8]="Module",M[M.Property=9]="Property",M[M.Event=10]="Event",M[M.Operator=11]="Operator",M[M.Unit=12]="Unit",M[M.Value=13]="Value",M[M.Constant=14]="Constant",M[M.Enum=15]="Enum",M[M.EnumMember=16]="EnumMember",M[M.Keyword=17]="Keyword",M[M.Text=18]="Text",M[M.Color=19]="Color",M[M.File=20]="File",M[M.Reference=21]="Reference",M[M.Customcolor=22]="Customcolor",M[M.Folder=23]="Folder",M[M.TypeParameter=24]="TypeParameter",M[M.User=25]="User",M[M.Issue=26]="Issue",M[M.Snippet=27]="Snippet"})(w||(e.CompletionItemKind=w={}));var m;(function(M){const Q=new Map;Q.set(0,o.$Vj.symbolMethod),Q.set(1,o.$Vj.symbolFunction),Q.set(2,o.$Vj.symbolConstructor),Q.set(3,o.$Vj.symbolField),Q.set(4,o.$Vj.symbolVariable),Q.set(5,o.$Vj.symbolClass),Q.set(6,o.$Vj.symbolStruct),Q.set(7,o.$Vj.symbolInterface),Q.set(8,o.$Vj.symbolModule),Q.set(9,o.$Vj.symbolProperty),Q.set(10,o.$Vj.symbolEvent),Q.set(11,o.$Vj.symbolOperator),Q.set(12,o.$Vj.symbolUnit),Q.set(13,o.$Vj.symbolValue),Q.set(15,o.$Vj.symbolEnum),Q.set(14,o.$Vj.symbolConstant),Q.set(15,o.$Vj.symbolEnum),Q.set(16,o.$Vj.symbolEnumMember),Q.set(17,o.$Vj.symbolKeyword),Q.set(27,o.$Vj.symbolSnippet),Q.set(18,o.$Vj.symbolText),Q.set(19,o.$Vj.symbolColor),Q.set(20,o.$Vj.symbolFile),Q.set(21,o.$Vj.symbolReference),Q.set(22,o.$Vj.symbolCustomColor),Q.set(23,o.$Vj.symbolFolder),Q.set(24,o.$Vj.symbolTypeParameter),Q.set(25,o.$Vj.account),Q.set(26,o.$Vj.issues);function ce(re){let X=Q.get(re);return X||(console.info("No codicon found for CompletionItemKind "+re),X=o.$Vj.symbolProperty),X}M.toIcon=ce;const ie=new Map;ie.set("method",0),ie.set("function",1),ie.set("constructor",2),ie.set("field",3),ie.set("variable",4),ie.set("class",5),ie.set("struct",6),ie.set("interface",7),ie.set("module",8),ie.set("property",9),ie.set("event",10),ie.set("operator",11),ie.set("unit",12),ie.set("value",13),ie.set("constant",14),ie.set("enum",15),ie.set("enum-member",16),ie.set("enumMember",16),ie.set("keyword",17),ie.set("snippet",27),ie.set("text",18),ie.set("color",19),ie.set("file",20),ie.set("reference",21),ie.set("customcolor",22),ie.set("folder",23),ie.set("type-parameter",24),ie.set("typeParameter",24),ie.set("account",25),ie.set("issue",26);function be(re,X){let B=ie.get(re);return typeof B>"u"&&!X&&(B=9),B}M.fromString=be})(m||(e.CompletionItemKinds=m={}));var u;(function(M){M[M.Deprecated=1]="Deprecated"})(u||(e.CompletionItemTag=u={}));var a;(function(M){M[M.None=0]="None",M[M.KeepWhitespace=1]="KeepWhitespace",M[M.InsertAsSnippet=4]="InsertAsSnippet"})(a||(e.CompletionItemInsertTextRule=a={}));var f;(function(M){M[M.Word=0]="Word",M[M.Line=1]="Line",M[M.Suggest=2]="Suggest"})(f||(e.PartialAcceptTriggerKind=f={}));var c;(function(M){M[M.Invoke=0]="Invoke",M[M.TriggerCharacter=1]="TriggerCharacter",M[M.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var d;(function(M){M[M.Automatic=0]="Automatic",M[M.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class p{constructor(Q,ce,ie,be){this.range=Q,this.text=ce,this.completionKind=ie,this.isSnippetText=be}equals(Q){return D.$ut.lift(this.range).equalsRange(Q.range)&&this.text===Q.text&&this.completionKind===Q.completionKind&&this.isSnippetText===Q.isSnippetText}}e.$$t=p;var E;(function(M){M[M.Invoke=1]="Invoke",M[M.Auto=2]="Auto"})(E||(e.CodeActionTriggerType=E={}));var h;(function(M){M[M.Automatic=0]="Automatic",M[M.PasteAs=1]="PasteAs"})(h||(e.DocumentPasteTriggerKind=h={}));var t;(function(M){M[M.Invoke=1]="Invoke",M[M.TriggerCharacter=2]="TriggerCharacter",M[M.ContentChange=3]="ContentChange"})(t||(e.SignatureHelpTriggerKind=t={}));var s;(function(M){M[M.Text=0]="Text",M[M.Read=1]="Read",M[M.Write=2]="Write"})(s||(e.DocumentHighlightKind=s={}));function r(M){return M&&C.URI.isUri(M.uri)&&D.$ut.isIRange(M.range)&&(D.$ut.isIRange(M.originSelectionRange)||D.$ut.isIRange(M.targetSelectionRange))}var i;(function(M){M[M.File=0]="File",M[M.Module=1]="Module",M[M.Namespace=2]="Namespace",M[M.Package=3]="Package",M[M.Class=4]="Class",M[M.Method=5]="Method",M[M.Property=6]="Property",M[M.Field=7]="Field",M[M.Constructor=8]="Constructor",M[M.Enum=9]="Enum",M[M.Interface=10]="Interface",M[M.Function=11]="Function",M[M.Variable=12]="Variable",M[M.Constant=13]="Constant",M[M.String=14]="String",M[M.Number=15]="Number",M[M.Boolean=16]="Boolean",M[M.Array=17]="Array",M[M.Object=18]="Object",M[M.Key=19]="Key",M[M.Null=20]="Null",M[M.EnumMember=21]="EnumMember",M[M.Struct=22]="Struct",M[M.Event=23]="Event",M[M.Operator=24]="Operator",M[M.TypeParameter=25]="TypeParameter"})(i||(e.SymbolKind=i={})),e.$au={17:(0,P.localize)(0,null),16:(0,P.localize)(1,null),4:(0,P.localize)(2,null),13:(0,P.localize)(3,null),8:(0,P.localize)(4,null),9:(0,P.localize)(5,null),21:(0,P.localize)(6,null),23:(0,P.localize)(7,null),7:(0,P.localize)(8,null),0:(0,P.localize)(9,null),11:(0,P.localize)(10,null),10:(0,P.localize)(11,null),19:(0,P.localize)(12,null),5:(0,P.localize)(13,null),1:(0,P.localize)(14,null),2:(0,P.localize)(15,null),20:(0,P.localize)(16,null),15:(0,P.localize)(17,null),18:(0,P.localize)(18,null),24:(0,P.localize)(19,null),3:(0,P.localize)(20,null),6:(0,P.localize)(21,null),14:(0,P.localize)(22,null),22:(0,P.localize)(23,null),25:(0,P.localize)(24,null),12:(0,P.localize)(25,null)};function n(M,Q){return(0,P.localize)(26,null,M,e.$au[Q])}var l;(function(M){M[M.Deprecated=1]="Deprecated"})(l||(e.SymbolTag=l={}));var $;(function(M){const Q=new Map;Q.set(0,o.$Vj.symbolFile),Q.set(1,o.$Vj.symbolModule),Q.set(2,o.$Vj.symbolNamespace),Q.set(3,o.$Vj.symbolPackage),Q.set(4,o.$Vj.symbolClass),Q.set(5,o.$Vj.symbolMethod),Q.set(6,o.$Vj.symbolProperty),Q.set(7,o.$Vj.symbolField),Q.set(8,o.$Vj.symbolConstructor),Q.set(9,o.$Vj.symbolEnum),Q.set(10,o.$Vj.symbolInterface),Q.set(11,o.$Vj.symbolFunction),Q.set(12,o.$Vj.symbolVariable),Q.set(13,o.$Vj.symbolConstant),Q.set(14,o.$Vj.symbolString),Q.set(15,o.$Vj.symbolNumber),Q.set(16,o.$Vj.symbolBoolean),Q.set(17,o.$Vj.symbolArray),Q.set(18,o.$Vj.symbolObject),Q.set(19,o.$Vj.symbolKey),Q.set(20,o.$Vj.symbolNull),Q.set(21,o.$Vj.symbolEnumMember),Q.set(22,o.$Vj.symbolStruct),Q.set(23,o.$Vj.symbolEvent),Q.set(24,o.$Vj.symbolOperator),Q.set(25,o.$Vj.symbolTypeParameter);function ce(ie){let be=Q.get(ie);return be||(console.info("No codicon found for SymbolKind "+ie),be=o.$Vj.symbolProperty),be}M.toIcon=ce})($||(e.SymbolKinds=$={}));class k{static asEditOperation(Q){return S.$vt.replace(D.$ut.lift(Q.range),Q.text)}}e.$cu=k;class j{static{this.Comment=new j("comment")}static{this.Imports=new j("imports")}static{this.Region=new j("region")}static fromValue(Q){switch(Q){case"comment":return j.Comment;case"imports":return j.Imports;case"region":return j.Region}return new j(Q)}constructor(Q){this.value=Q}}e.$du=j;var A;(function(M){M[M.AIGenerated=1]="AIGenerated"})(A||(e.NewSymbolNameTag=A={}));var O;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(O||(e.NewSymbolNameTriggerKind=O={}));var F;(function(M){function Q(ce){return!ce||typeof ce!="object"?!1:typeof ce.id=="string"&&typeof ce.title=="string"}M.is=Q})(F||(e.Command=F={}));var V;(function(M){M[M.Collapsed=0]="Collapsed",M[M.Expanded=1]="Expanded"})(V||(e.CommentThreadCollapsibleState=V={}));var Z;(function(M){M[M.Unresolved=0]="Unresolved",M[M.Resolved=1]="Resolved"})(Z||(e.CommentThreadState=Z={}));var oe;(function(M){M[M.Current=0]="Current",M[M.Outdated=1]="Outdated"})(oe||(e.CommentThreadApplicability=oe={}));var le;(function(M){M[M.Editing=0]="Editing",M[M.Preview=1]="Preview"})(le||(e.CommentMode=le={}));var te;(function(M){M[M.Published=0]="Published",M[M.Draft=1]="Draft"})(te||(e.CommentState=te={}));var _;(function(M){M[M.Type=1]="Type",M[M.Parameter=2]="Parameter"})(_||(e.InlayHintKind=_={}));class W{constructor(Q){this.b=Q,this.a=null}dispose(){this.a&&this.a.then(Q=>{Q&&Q.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$eu=W,e.$fu=new I.$Zt;var K;(function(M){M[M.None=0]="None",M[M.Option=1]="Option",M[M.Default=2]="Default",M[M.Preferred=3]="Preferred"})(K||(e.ExternalUriOpenerPriority=K={}));var Y;(function(M){M[M.Invoke=0]="Invoke",M[M.Automatic=1]="Automatic"})(Y||(e.InlineEditTriggerKind=Y={}))}),define(ye[186],Ee([8,9]),function(he,e){return he.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[187],Ee([8,9]),function(he,e){return he.create("vs/platform/contextkey/common/contextkey",e)}),define(ye[188],Ee([8,9]),function(he,e){return he.create("vs/platform/contextkey/common/scanner",e)}),define(ye[189],Ee([8,9]),function(he,e){return he.create("vs/platform/environment/node/argv",e)}),define(ye[190],Ee([8,9]),function(he,e){return he.create("vs/platform/environment/node/argvHelper",e)}),define(ye[191],Ee([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ye[192],Ee([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[193],Ee([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ye[194],Ee([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ye[195],Ee([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ye[196],Ee([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ye[197],Ee([8,9]),function(he,e){return he.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ye[198],Ee([8,9]),function(he,e){return he.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[199],Ee([8,9]),function(he,e){return he.create("vs/platform/files/common/fileService",e)}),define(ye[200],Ee([8,9]),function(he,e){return he.create("vs/platform/files/common/files",e)}),define(ye[201],Ee([8,9]),function(he,e){return he.create("vs/platform/files/common/io",e)}),define(ye[202],Ee([8,9]),function(he,e){return he.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ye[203],Ee([8,9]),function(he,e){return he.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ye[204],Ee([8,9]),function(he,e){return he.create("vs/platform/log/common/log",e)}),define(ye[205],Ee([8,9]),function(he,e){return he.create("vs/platform/markers/common/markers",e)}),define(ye[206],Ee([8,9]),function(he,e){return he.create("vs/platform/request/common/request",e)}),define(ye[207],Ee([8,9]),function(he,e){return he.create("vs/platform/shell/node/shellEnv",e)}),define(ye[208],Ee([8,9]),function(he,e){return he.create("vs/platform/telemetry/common/telemetryService",e)}),define(ye[209],Ee([8,9]),function(he,e){return he.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ye[210],Ee([8,9]),function(he,e){return he.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ye[211],Ee([8,9]),function(he,e){return he.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ye[212],Ee([8,9]),function(he,e){return he.create("vs/platform/workspace/common/workspace",e)}),define(ye[213],Ee([8,9]),function(he,e){return he.create("vs/server/node/remoteExtensionHostAgentCli",e)}),define(ye[214],Ee([8,9]),function(he,e){return he.create("vs/server/node/serverEnvironmentService",e)}),define(ye[215],Ee([8,9]),function(he,e){return he.create("vs/server/node/serverServices",e)}),define(ye[216],Ee([8,9]),function(he,e){return he.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[217],Ee([8,9]),function(he,e){return he.create("vs/workbench/common/editor",e)}),define(ye[218],Ee([8,9]),function(he,e){return he.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(ye[219],Ee([8,9]),function(he,e){return he.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[220],Ee([8,9]),function(he,e){return he.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(ye[221],Ee([1,0,11,188]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rj=e.TokenType=void 0;var S;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(S||(e.TokenType=S={}));function D(...g){switch(g.length){case 1:return(0,C.localize)(0,null,g[0]);case 2:return(0,C.localize)(1,null,g[0],g[1]);case 3:return(0,C.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,C.localize)(3,null),P=(0,C.localize)(4,null);class b{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(y){switch(y.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return y.isTripleEq?"===":"==";case 4:return y.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return y.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return y.lexeme;case 18:return y.lexeme;case 19:return y.lexeme;case 20:return"EOF";default:throw(0,o.$8)(`unhandled token type: ${JSON.stringify(y)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(y=>y.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(y){return this.c=y,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const v=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:v})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const v=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:v})}else this.h(126)?this.k(9):this.l(D("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(D("&&"));break;case 124:this.h(124)?this.k(16):this.l(D("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(y){return this.r()||this.c.charCodeAt(this.e)!==y?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(y){this.f.push({type:y,offset:this.d})}l(y){const v=this.d,w=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:w};this.g.push({offset:v,lexeme:w,additionalInfo:y}),this.f.push(m)}n(){this.m.lastIndex=this.d;const y=this.m.exec(this.c);if(y){this.e=this.d+y[0].length;const v=this.c.substring(this.d,this.e),w=b.b.get(v);w?this.k(w):this.f.push({type:17,lexeme:v,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let y=this.e,v=!1,w=!1;for(;;){if(y>=this.c.length){this.e=y,this.l(P);return}const u=this.c.charCodeAt(y);if(v)v=!1;else if(u===47&&!w){y++;break}else u===91?w=!0:u===92?v=!0:u===93&&(w=!1);y++}for(;y<this.c.length&&b.a.has(this.c.charCodeAt(y));)y++;this.e=y;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$rj=b}),define(ye[222],Ee([1,0,6,2]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=e.$Io=void 0;class S{constructor(){this.a=new o.$ee,this.b=new o.$ee,this.c=new o.$ee,this.d=new o.$ee}static{this.ChannelName="extensionhostdebugservice"}call(P,b,g){switch(b){case"close":return Promise.resolve(this.a.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(P,b,g){switch(b){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Io=S;class D extends C.$Vc{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,b,g){this.b.call("attach",[P,b,g])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,b){this.b.call("terminate",[P,b])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,b){return this.b.call("openExtensionDevelopmentHostWindow",[P,b])}}e.$Jo=D}),define(ye[223],Ee([1,0,4]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;class C{constructor(I){this.a=I}listen(I,P,b){throw new Error("Invalid listen")}call(I,P,b){switch(P){case"download":return this.a.download(o.URI.revive(b[0]),o.URI.revive(b[1]))}throw new Error("Invalid call")}}e.$Lo=C;class S{constructor(I,P){this.a=I,this.b=P}async download(I,P){const b=this.b();b&&(I=b.transformOutgoingURI(I),P=b.transformOutgoingURI(P)),await this.a.call("download",[I,P])}}e.$Mo=S}),define(ye[224],Ee([1,0,172,74,13,7,31,19,4]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6m=e.$5m=void 0,e.$7m=y,e.$8m=v,e.$5m=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,D.$nc)(S.$Qg.asFileUri("").fsPath)}get userHome(){return b.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return b.URI.file((0,D.$kc)(this.userDataPath,"User"))}get tmpDir(){return b.URI.file(this.b.tmpDir)}get cacheHome(){return b.URI.file(this.userDataPath)}get stateResource(){return(0,P.$0g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:S.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$0g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,o.$4m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.$kc)(this.userDataPath,"logs",m)}return b.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$0g)(b.URI.file((0,D.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$0g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$0g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$0g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=I.env.VSCODE_PORTABLE;return m?b.URI.file((0,D.$kc)(m,"argv.json")):(0,P.$0g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return b.URI.file((0,D.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,D.$lc)(m):(0,D.$ic)((0,D.$kc)(S.$Qg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?b.URI.file((0,D.$lc)(m)):b.URI.file((0,D.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,D.$lc)(m);const u=I.env.VSCODE_EXTENSIONS;if(u)return u;const a=I.env.VSCODE_PORTABLE;return a?(0,D.$kc)(a,"extensions"):(0,P.$0g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(u=>/^[^:/?#]+?:\/\//.test(u)?b.URI.parse(u):b.URI.file((0,D.$ic)(u)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?b.URI.parse(m):b.URI.file((0,D.$ic)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return y(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$5m.test(m))}get extensionLogLevel(){const m=[];for(const u of this.args.log||[]){const a=e.$5m.exec(u);a&&a[1]&&a[2]&&m.push([a[1],a[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,P.$0g)(b.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=I.env.VSCODE_PORTABLE;return m?b.URI.file((0,D.$kc)(m,"policy.json")):(0,P.$0g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,u,a){this.a=m,this.b=u,this.c=a,this.editSessionId=this.args.editSessionId}}e.$6m=g,Le([C.$1h],g.prototype,"appRoot",null),Le([C.$1h],g.prototype,"userHome",null),Le([C.$1h],g.prototype,"userDataPath",null),Le([C.$1h],g.prototype,"appSettingsHome",null),Le([C.$1h],g.prototype,"tmpDir",null),Le([C.$1h],g.prototype,"cacheHome",null),Le([C.$1h],g.prototype,"stateResource",null),Le([C.$1h],g.prototype,"userRoamingDataHome",null),Le([C.$1h],g.prototype,"userDataSyncHome",null),Le([C.$1h],g.prototype,"sync",null),Le([C.$1h],g.prototype,"machineSettingsResource",null),Le([C.$1h],g.prototype,"workspaceStorageHome",null),Le([C.$1h],g.prototype,"localHistoryHome",null),Le([C.$1h],g.prototype,"keyboardLayoutResource",null),Le([C.$1h],g.prototype,"argvResource",null),Le([C.$1h],g.prototype,"isExtensionDevelopment",null),Le([C.$1h],g.prototype,"untitledWorkspacesHome",null),Le([C.$1h],g.prototype,"builtinExtensionsPath",null),Le([C.$1h],g.prototype,"extensionsPath",null),Le([C.$1h],g.prototype,"extensionDevelopmentLocationURI",null),Le([C.$1h],g.prototype,"extensionDevelopmentKind",null),Le([C.$1h],g.prototype,"extensionTestsLocationURI",null),Le([C.$1h],g.prototype,"debugExtensionHost",null),Le([C.$1h],g.prototype,"logLevel",null),Le([C.$1h],g.prototype,"extensionLogLevel",null),Le([C.$1h],g.prototype,"serviceMachineIdResource",null),Le([C.$1h],g.prototype,"disableTelemetry",null),Le([C.$1h],g.prototype,"disableWorkspaceTrust",null),Le([C.$1h],g.prototype,"useInMemorySecretStorage",null),Le([C.$1h],g.prototype,"policyFile",null);function y(w,m){return v(w["inspect-extensions"],w["inspect-brk-extensions"],5870,m,w.debugId,w.extensionEnvironment)}function v(w,m,u,a,f,c){const p=Number(m||w)||(a?null:u),E=p?!!m:!1;let h;if(c)try{h=JSON.parse(c)}catch{}return{port:p,break:E,debugId:f,env:h}}}),define(ye[67],Ee([1,0,311,3,189]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=void 0,e.$tm=P,e.$um=g,e.$vm=m,e.$wm=u;const D={o:(0,S.localize)(0,null),e:(0,S.localize)(1,null),t:(0,S.localize)(2,null)};e.$rm=["tunnel","serve-web"],e.$sm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,S.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,S.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,S.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,S.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,S.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,S.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,S.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,S.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,S.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,S.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,S.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,S.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,S.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,S.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,S.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,S.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,S.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,S.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,S.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,S.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,S.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,S.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,S.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,S.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,S.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,S.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,S.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,S.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,S.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,S.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,S.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,S.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,S.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(a,f,c=I){const d=a.find(l=>l.length>0&&l[0]!=="-"),p={},E=["_"],h=[],t={};let s;for(const l in f){const $=f[l];$.type==="subcommand"?l===d&&(s=$):($.alias&&(p[l]=$.alias),$.type==="string"||$.type==="string[]"?(E.push(l),$.deprecates&&E.push(...$.deprecates)):$.type==="boolean"&&(h.push(l),$.deprecates&&h.push(...$.deprecates)),$.global&&(t[l]=$))}if(s&&d){const l=t;for(const A in s.options)l[A]=s.options[A];const $=a.filter(A=>A!==d),k=c.getSubcommandReporter?c.getSubcommandReporter(d):void 0,j=P($,l,k);return{[d]:j,_:[]}}const r=o(a,{string:E,boolean:h,alias:p}),i={},n=r;i._=r._.map(l=>String(l)).filter(l=>l.length>0),delete n._;for(const l in f){const $=f[l];if($.type==="subcommand")continue;$.alias&&delete n[$.alias];let k=n[l];if($.deprecates)for(const j of $.deprecates)n.hasOwnProperty(j)&&(k||(k=n[j],k&&c.onDeprecatedOption(j,$.deprecationMessage||(0,S.localize)(38,null,l))),delete n[j]);if(typeof k<"u"){if($.type==="string[]"){if(Array.isArray(k)||(k=[k]),!$.allowEmptyValue){const j=k.filter(A=>A.length>0);j.length!==k.length&&(c.onEmptyValue(l),k=j.length>0?j:void 0)}}else $.type==="string"&&(Array.isArray(k)?(k=k.pop(),c.onMultipleValues(l,k)):!k&&!$.allowEmptyValue&&(c.onEmptyValue(l),k=void 0));i[l]=k,$.deprecationMessage&&c.onDeprecatedOption(l,$.deprecationMessage)}delete n[l]}for(const l in n)c.onUnknownOption(l);return i}function b(a,f){let c="";return f.args&&(Array.isArray(f.args)?c=` <${f.args.join("> <")}>`:c=` <${f.args}>`),f.alias?`-${f.alias} --${a}${c}`:`--${a}${c}`}function g(a,f){const c=[];for(const d in a){const p=a[d],E=b(d,p);c.push([E,p.description])}return y(c,f)}function y(a,f){const d=a.reduce((h,t)=>Math.max(h,t[0].length),12)+2+1;if(f-d<25)return a.reduce((h,t)=>h.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const p=f-d-1,E=[];for(const h of a){const t=h[0],s=w(h[1],p),r=v(d-t.length-2);E.push("  "+t+r+s[0]);for(let i=1;i<s.length;i++)E.push(v(d)+s[i])}return E}function v(a){return" ".repeat(a)}function w(a,f){const c=[];for(;a.length;){const d=a.length<f?a.length:a.lastIndexOf(" ",f),p=a.slice(0,d).trim();a=a.slice(d),c.push(p)}return c}function m(a,f,c,d,p){const E=process.stdout.isTTY&&process.stdout.columns||80,h=p?.noInputFiles!==!0?`[${(0,S.localize)(39,null)}...]`:"",t=[`${a} ${c}`];t.push(""),t.push(`${(0,S.localize)(40,null)}: ${f} [${(0,S.localize)(41,null)}]${h}`),t.push(""),p?.noPipe!==!0&&(C.$i?t.push((0,S.localize)(42,null,f)):t.push((0,S.localize)(43,null,f)),t.push(""));const s={},r=[];for(const i in d){const n=d[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let l=s[n.cat];l||(s[n.cat]=l={}),l[i]=n}}for(const i in s){const n=i,l=s[n];l&&(t.push(D[n]),t.push(...g(l,E)),t.push(""))}return r.length&&(t.push((0,S.localize)(44,null)),t.push(...y(r.map(i=>[i.command,i.description]),E)),t.push("")),t.join(`
`)}function u(a,f){return`${a||(0,S.localize)(45,null)}
${f||(0,S.localize)(46,null)}
${process.arch}`}}),define(ye[225],Ee([1,0,312,190,67]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xm=P,e.$ym=b,e.$zm=g,e.$Am=y;function D(v,w){const m=(p,E)=>{console.warn((0,C.localize)(0,null,p,E))},u=p=>{console.warn((0,C.localize)(1,null,p))},a=(p,E)=>{console.warn((0,C.localize)(2,null,p,E))},f=p=>({onUnknownOption:E=>{S.$rm.includes(p)||console.warn((0,C.localize)(3,null,E,p))},onMultipleValues:m,onEmptyValue:u,onDeprecatedOption:a,getSubcommandReporter:S.$rm.includes(p)?f:void 0}),c={onUnknownOption:p=>{console.warn((0,C.localize)(4,null,p))},onMultipleValues:m,onEmptyValue:u,onDeprecatedOption:a,getSubcommandReporter:f},d=(0,S.$tm)(v,S.$sm,w?c:void 0);return d.goto&&d._.forEach(p=>o(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(p),(0,C.localize)(5,null))),d}function I(v){const w=v.findIndex(m=>!/^-/.test(m));if(w>-1)return[...v.slice(0,w),...v.slice(w+1)]}function P(v){let[,...w]=v;process.env.VSCODE_DEV&&(w=I(w)||[]);const m=!y(process.env);return D(w,m)}function b(v){let[,,...w]=v;return process.env.VSCODE_DEV&&(w=I(w)||[]),D(w,!0)}function g(v,...w){const m=v.indexOf("--");return m===-1?v.push(...w):v.splice(m,0,...w),v}function y(v){return v.VSCODE_CLI==="1"}}),function(){"use strict";function he(e,o,C){function S(I,P){const b=D(I,P),g=[b];return e.isAbsolute(b)||g.unshift(C),e.resolve(...g)}function D(I,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const b=process.env.VSCODE_PORTABLE;if(b)return e.join(b,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,P);const y=I["user-data-dir"];if(y)return y;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const v=process.env.USERPROFILE;if(typeof v!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(v,"AppData","Roaming")}break;case"darwin":g=e.join(o.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(o.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,P)}return{getUserDataPath:S}}if(typeof define=="function")define(ye[226],Ee([77,30,31]),function(e,o,C){return he(e,o,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),o=require("os");module.exports=he(e,o,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ye[109],Ee([1,0,30,224,226]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0,e.$0m=I,e.$$m=P;class D extends C.$6m{constructor(g,y){super(g,{homeDir:(0,o.homedir)(),tmpDir:(0,o.tmpdir)(),userDataDir:(0,S.getUserDataPath)(g,y.nameShort)},y)}}e.$9m=D;function I(b,g){return(0,C.$8m)(b["inspect-ptyhost"],b["inspect-brk-ptyhost"],5877,g,b.extensionEnvironment)}function P(b,g){return(0,C.$8m)(b["inspect-sharedprocess"],b["inspect-brk-sharedprocess"],5879,g,b.extensionEnvironment)}}),define(ye[227],Ee([1,0,10,194]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=S;function S(I,P,b,g){try{D(I,P,b,g)}catch(y){I.error(y?.message??y)}return P}function D(I,P,b,g){const y=(v,w,m)=>{const u=v[w];if((0,o.$9f)(u)){const a=u,f=a.length;if(f>1&&a[0]==="%"&&a[f-1]==="%"){const c=a.substr(1,f-2);let d=b[c];d===void 0&&g&&(d=g[c]);const p=typeof d=="string"?d:d?.message,E=g?.[c],h=typeof E=="string"?E:E?.message;if(!p){h||I.warn(`[${P.name}]: ${(0,C.localize)(0,null,c)}`);return}if(m&&(w==="title"||w==="category")&&h&&h!==p){const t={value:p,original:h};v[w]=t}else v[w]=p}}else if((0,o.$$f)(u))for(const a in u)u.hasOwnProperty(a)&&(a==="commands"?y(u,a,!0):y(u,a,m));else if(Array.isArray(u))for(let a=0;a<u.length;a++)y(u,a,m)};for(const v in P)P.hasOwnProperty(v)&&y(P,v)}}),define(ye[228],Ee([1,0,81,197]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=S;function S(D){return(0,o.$kq)(D,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,C.localize)(0,null))}})}}),define(ye[82],Ee([1,0,19,63,198,57]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=b,e.$Hp=g,e.$Ip=y,e.$Jp=v,e.$Kp=w,e.$Lp=m,e.$Mp=u;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function b(c){return c=c.trim(),c==="*"||I.test(c)}function g(c){if(!b(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=c.match(I);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}function y(c){if(!c)return null;const d=c.majorBase,p=c.majorMustEqual,E=c.minorBase;let h=c.minorMustEqual;const t=c.patchBase;let s=c.patchMustEqual;c.hasCaret&&(d===0||(h=!1),s=!1);let r=0;if(c.preRelease){const i=P.exec(c.preRelease);if(i){const[,n,l,$]=i;r=Date.UTC(Number(n),Number(l)-1,Number($))}}return{majorBase:d,majorMustEqual:p,minorBase:E,minorMustEqual:h,patchBase:t,patchMustEqual:s,isMinimum:c.hasGreaterEquals,notBefore:r}}function v(c,d,p){let E;typeof c=="string"?E=y(g(c)):E=c;let h;d instanceof Date?h=d.getTime():typeof d=="string"&&(h=new Date(d).getTime());let t;if(typeof p=="string"?t=y(g(p)):t=p,!E||!t)return!1;const s=E.majorBase,r=E.minorBase,i=E.patchBase;let n=t.majorBase,l=t.minorBase,$=t.patchBase;const k=t.notBefore;let j=t.majorMustEqual,A=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?s>n?!0:s<n?!1:r>l?!0:r<l||h&&h<k?!1:i>=$:(s===1&&n===0&&(!j||!A||!O)&&(n=1,l=0,$=0,j=!0,A=!1,O=!1),s<n?!1:s>n?!j:r<l?!1:r>l?!A:i<$?!1:i>$?!O:!(h&&h<k))}function w(c,d,p,E,h){const t=[];if(typeof E.publisher<"u"&&typeof E.publisher!="string")return t.push([C.default.Error,S.localize(0,null)]),t;if(typeof E.name!="string")return t.push([C.default.Error,S.localize(1,null,"name")]),t;if(typeof E.version!="string")return t.push([C.default.Error,S.localize(2,null,"version")]),t;if(!E.engines)return t.push([C.default.Error,S.localize(3,null,"engines")]),t;if(typeof E.engines.vscode!="string")return t.push([C.default.Error,S.localize(4,null,"engines.vscode")]),t;if(typeof E.extensionDependencies<"u"&&!f(E.extensionDependencies))return t.push([C.default.Error,S.localize(5,null,"extensionDependencies")]),t;if(typeof E.activationEvents<"u"){if(!f(E.activationEvents))return t.push([C.default.Error,S.localize(6,null,"activationEvents")]),t;if(typeof E.main>"u"&&typeof E.browser>"u")return t.push([C.default.Error,S.localize(7,null,"activationEvents","main","browser")]),t}if(typeof E.extensionKind<"u"&&typeof E.main>"u"&&t.push([C.default.Warning,S.localize(8,null,"extensionKind")]),typeof E.main<"u"){if(typeof E.main!="string")return t.push([C.default.Error,S.localize(9,null,"main")]),t;{const i=(0,o.$0g)(p,E.main);(0,o.$4g)(i,p)||t.push([C.default.Warning,S.localize(10,null,i.path,p.path)])}}if(typeof E.browser<"u"){if(typeof E.browser!="string")return t.push([C.default.Error,S.localize(11,null,"browser")]),t;{const i=(0,o.$0g)(p,E.browser);(0,o.$4g)(i,p)||t.push([C.default.Warning,S.localize(12,null,i.path,p.path)])}}if(!D.valid(E.version))return t.push([C.default.Error,S.localize(13,null)]),t;const s=[];if(!m(c,d,E,h,s))for(const i of s)t.push([C.default.Error,i]);return t}function m(c,d,p,E,h){return E||typeof p.main>"u"&&typeof p.browser>"u"?!0:a(c,d,p.engines.vscode,h)}function u(c,d,p){return c==="*"||a(d,p,c)}function a(c,d,p,E=[]){const h=y(g(p));if(!h)return E.push(S.localize(14,null,p)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return E.push(S.localize(15,null,p)),!1}else if(!h.majorMustEqual)return E.push(S.localize(16,null,p)),!1;return v(c,d,h)?!0:(E.push(S.localize(17,null,c,p)),!1)}function f(c){if(!Array.isArray(c))return!1;for(let d=0,p=c.length;d<p;d++)if(typeof c[d]!="string")return!1;return!0}}),define(ye[229],Ee([1,0,15,22]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=S;async function S(D,I,P){let b=P&&P.get("storage.serviceMachineId",-1)||null;if(b)return b;try{const y=(await I.readFile(D.serviceMachineIdResource)).value.toString();b=(0,C.$Rg)(y)?y:null}catch{b=null}if(!b){b=(0,C.$Sg)();try{await I.writeFile(D.serviceMachineIdResource,o.$Ge.fromString(b))}catch{}}return P?.store("storage.serviceMachineId",b,-1,1),b}}),define(ye[68],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class o{constructor(S,D=[],I=!1){this.ctor=S,this.staticArguments=D,this.supportsDelayedInstantiation=I}}e.$ti=o}),define(ye[110],Ee([1,0,68]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$xs=D,e.$ys=I;const C=[];var S;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(S||(e.InstantiationType=S={}));function D(P,b,g){b instanceof o.$ti||(b=new o.$ti(b,[],!!g)),C.push([P,b])}function I(){return C}}),define(ye[230],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$br=e.$ar=void 0;class o{constructor(D,I){this.key=D,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$ar=o;class C{constructor(D){this.b=D,this.a=new Map}roots(){const D=[];for(const I of this.a.values())I.outgoing.size===0&&D.push(I);return D}insertEdge(D,I){const P=this.lookupOrInsertNode(D),b=this.lookupOrInsertNode(I);P.outgoing.set(b.key,b),b.incoming.set(P.key,P)}removeNode(D){const I=this.b(D);this.a.delete(I);for(const P of this.a.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(D){const I=this.b(D);let P=this.a.get(I);return P||(P=new o(I,D),this.a.set(I,P)),P}lookup(D){return this.a.get(this.b(D))}isEmpty(){return this.a.size===0}toString(){const D=[];for(const[I,P]of this.a)D.push(`${I}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return D.join(`
`)}findCycleSlow(){for(const[D,I]of this.a){const P=new Set([D]),b=this.c(I,P);if(b)return b}}c(D,I){for(const[P,b]of D.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const g=this.c(b,I);if(g)return g;I.delete(P)}}}e.$br=C}),define(ye[5],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=e._util=void 0,e.$wi=S,e.$xi=D;var o;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(b){return b[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(o||(e._util=o={})),e.$vi=S("instantiationService");function C(I,P,b){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:I,index:b}):(P[o.DI_DEPENDENCIES]=[{id:I,index:b}],P[o.DI_TARGET]=P)}function S(I){if(o.serviceIds.has(I))return o.serviceIds.get(I);const P=function(b,g,y){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,b,y)};return P.toString=()=>I,o.serviceIds.set(I,P),P}function D(I){return I}}),define(ye[25],Ee([1,0,10,4,5]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$3i=void 0,e.$4i=D,e.$5i=I,e.$6i=b,e.$7i=g,e.$8i=y,e.$9i=v,e.$0i=w,e.$$i=u,e.$_i=a,e.$aj=f,e.$3i=(0,S.$wi)("configurationService");function D(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof C.URI)}function I(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof C.URI)}var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function b(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function g(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function y(c,d){const p=Object.create(null);for(const E in c)v(p,E,c[E],d);return p}function v(c,d,p,E){const h=d.split("."),t=h.pop();let s=c;for(let r=0;r<h.length;r++){const i=h[r];let n=s[i];switch(typeof n){case"undefined":n=s[i]=Object.create(null);break;case"object":if(n===null){E(`Ignoring ${d} as ${h.slice(0,r+1).join(".")} is null`);return}break;default:E(`Ignoring ${d} as ${h.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}s=n}if(typeof s=="object"&&s!==null)try{s[t]=p}catch{E(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(s)}`)}else E(`Ignoring ${d} as ${h.join(".")} is ${JSON.stringify(s)}`)}function w(c,d){const p=d.split(".");m(c,p)}function m(c,d){const p=d.shift();if(d.length===0){delete c[p];return}if(Object.keys(c).indexOf(p)!==-1){const E=c[p];typeof E=="object"&&!Array.isArray(E)&&(m(E,d),Object.keys(E).length===0&&delete c[p])}}function u(c,d,p){function E(s,r){let i=s;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const h=d.split("."),t=E(c,h);return typeof t>"u"?p:t}function a(c,d,p){Object.keys(d).forEach(E=>{E!=="__proto__"&&(E in c?o.$$f(c[E])&&o.$$f(d[E])?a(c[E],d[E],p):p&&(c[E]=d[E]):c[E]=d[E])})}function f(c){return c.replace(/[\[\]]/g,"")}}),define(ye[47],Ee([1,0,3,17,221,5,187,11]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$uj=e.$tj=e.ContextKeyExprType=void 0,e.$sj=g,e.$vj=s,e.$wj=r,e.$Pj=be;const b=new Map;b.set("false",!1),b.set("true",!0),b.set("isMac",o.$j),b.set("isLinux",o.$k),b.set("isWindows",o.$i),b.set("isWeb",o.$o),b.set("isMacNative",o.$j&&!o.$o),b.set("isEdge",o.$H),b.set("isFirefox",o.$F),b.set("isChrome",o.$E),b.set("isSafari",o.$G);function g(B,N){if(b.get(B)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");b.set(B,N)}const y=Object.prototype.hasOwnProperty;var v;(function(B){B[B.False=0]="False",B[B.True=1]="True",B[B.Defined=2]="Defined",B[B.Not=3]="Not",B[B.Equals=4]="Equals",B[B.NotEquals=5]="NotEquals",B[B.And=6]="And",B[B.Regex=7]="Regex",B[B.NotRegex=8]="NotRegex",B[B.Or=9]="Or",B[B.In=10]="In",B[B.NotIn=11]="NotIn",B[B.Greater=12]="Greater",B[B.GreaterEquals=13]="GreaterEquals",B[B.Smaller=14]="Smaller",B[B.SmallerEquals=15]="SmallerEquals"})(v||(e.ContextKeyExprType=v={}));const w={regexParsingWithErrorRecovery:!0},m=(0,I.localize)(0,null),u=(0,I.localize)(1,null),a=(0,I.localize)(2,null),f=(0,I.localize)(3,null),c=(0,I.localize)(4,null),d=(0,I.localize)(5,null),p=(0,I.localize)(6,null),E=(0,I.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(N=w){this.k=N,this.d=new S.$rj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(N){if(N===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:u});return}this.f=this.d.reset(N).scan(),this.g=0,this.h=[];try{const z=this.l();if(!this.E()){const J=this.D(),ue=J.type===17?d:void 0;throw this.h.push({message:c,offset:J.offset,lexeme:S.$rj.getLexeme(J),additionalInfo:ue}),h.c}return z}catch(z){if(z!==h.c)throw z;return}}l(){return this.m()}m(){const N=[this.o()];for(;this.y(16);){const z=this.o();N.push(z)}return N.length===1?N[0]:t.or(...N)}o(){const N=[this.s()];for(;this.y(15);){const z=this.s();N.push(z)}return N.length===1?N[0]:t.and(...N)}s(){if(this.y(2)){const N=this.D();switch(N.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const z=this.l();return this.A(1,f),z?.negate()}case 17:return this.z(),F.create(N.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",N)}}return this.t()}t(){const N=this.D();switch(N.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const z=this.l();return this.A(1,f),z}case 17:{const z=N.lexeme;if(this.z(),this.y(9)){const ue=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ue.type!==10)throw this.B("REGEX",ue);const x=ue.lexeme,G=x.lastIndexOf("/"),U=G===x.length-1?void 0:this.w(x.substring(G+1));let T;try{T=new RegExp(x.substring(1,G),U)}catch{throw this.B("REGEX",ue)}return _.create(z,T)}switch(ue.type){case 10:case 19:{const x=[ue.lexeme];this.z();let G=this.D(),U=0;for(let me=0;me<ue.lexeme.length;me++)ue.lexeme.charCodeAt(me)===40?U++:ue.lexeme.charCodeAt(me)===41&&U--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:U++;break;case 1:U--;break;case 10:case 18:for(let me=0;me<G.lexeme.length;me++)G.lexeme.charCodeAt(me)===40?U++:ue.lexeme.charCodeAt(me)===41&&U--}if(U<0)break;x.push(S.$rj.getLexeme(G)),this.z(),G=this.D()}const T=x.join(""),q=T.lastIndexOf("/"),se=q===T.length-1?void 0:this.w(T.substring(q+1));let ae;try{ae=new RegExp(T.substring(1,q),se)}catch{throw this.B("REGEX",ue)}return t.regex(z,ae)}case 18:{const x=ue.lexeme;this.z();let G=null;if(!(0,C.$8e)(x)){const U=x.indexOf("/"),T=x.lastIndexOf("/");if(U!==T&&U>=0){const q=x.slice(U+1,T),se=x[T+1]==="i"?"i":"";try{G=new RegExp(q,se)}catch{throw this.B("REGEX",ue)}}}if(G===null)throw this.B("REGEX",ue);return _.create(z,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const ue=this.u();return t.notIn(z,ue)}switch(this.D().type){case 3:{this.z();const ue=this.u();if(this.x().type===18)return t.equals(z,ue);switch(ue){case"true":return t.has(z);case"false":return t.not(z);default:return t.equals(z,ue)}}case 4:{this.z();const ue=this.u();if(this.x().type===18)return t.notEquals(z,ue);switch(ue){case"true":return t.not(z);case"false":return t.has(z);default:return t.notEquals(z,ue)}}case 5:return this.z(),le.create(z,this.u());case 6:return this.z(),te.create(z,this.u());case 7:return this.z(),Z.create(z,this.u());case 8:return this.z(),oe.create(z,this.u());case 13:return this.z(),t.in(z,this.u());default:return t.has(z)}}case 20:throw this.h.push({message:p,offset:N.offset,lexeme:"",additionalInfo:E}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const N=this.D();switch(N.type){case 17:case 18:return this.z(),N.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(N){return N.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(N){return this.C(N)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(N,z){if(this.C(N))return this.z();throw this.B(z,this.D())}B(N,z,J){const ue=(0,I.localize)(8,null,N,S.$rj.getLexeme(z)),x=z.offset,G=S.$rj.getLexeme(z);return this.h.push({message:ue,offset:x,lexeme:G,additionalInfo:J}),h.c}C(N){return this.D().type===N}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$tj=h;class t{static false(){return n.INSTANCE}static true(){return l.INSTANCE}static has(N){return $.create(N)}static equals(N,z){return k.create(N,z)}static notEquals(N,z){return O.create(N,z)}static regex(N,z){return _.create(N,z)}static in(N,z){return j.create(N,z)}static notIn(N,z){return A.create(N,z)}static not(N){return F.create(N)}static and(...N){return Y.create(N,null,!0)}static or(...N){return M.create(N,null,!0)}static greater(N,z){return Z.create(N,z)}static greaterEquals(N,z){return oe.create(N,z)}static smaller(N,z){return le.create(N,z)}static smallerEquals(N,z){return te.create(N,z)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(N){return N==null?void 0:this.c.parse(N)}}e.$uj=t;function s(B){const N=new h({regexParsingWithErrorRecovery:!1});return B.map(z=>(N.parse(z),N.lexingErrors.length>0?N.lexingErrors.map(J=>({errorMessage:J.additionalInfo?(0,I.localize)(9,null,J.additionalInfo):(0,I.localize)(10,null),offset:J.offset,length:J.lexeme.length})):N.parsingErrors.length>0?N.parsingErrors.map(J=>({errorMessage:J.additionalInfo?`${J.message}. ${J.additionalInfo}`:J.message,offset:J.offset,length:J.lexeme.length})):[]))}function r(B,N){const z=B?B.substituteConstants():void 0,J=N?N.substituteConstants():void 0;return!z&&!J?!0:!z||!J?!1:z.equals(J)}function i(B,N){return B.cmp(N)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!1}serialize(){return"false"}keys(){return[]}map(N){return this}negate(){return l.INSTANCE}}e.$xj=n;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(N){return this.type-N.type}equals(N){return N.type===this.type}substituteConstants(){return this}evaluate(N){return!0}serialize(){return"true"}keys(){return[]}map(N){return this}negate(){return n.INSTANCE}}e.$yj=l;class ${static create(N,z=null){const J=b.get(N);return typeof J=="boolean"?J?l.INSTANCE:n.INSTANCE:new $(N,z)}constructor(N,z){this.key=N,this.c=z,this.type=2}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.key,N.key)}equals(N){return N.type===this.type?this.key===N.key:!1}substituteConstants(){const N=b.get(this.key);return typeof N=="boolean"?N?l.INSTANCE:n.INSTANCE:this}evaluate(N){return!!N.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(N){return N.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$zj=$;class k{static create(N,z,J=null){if(typeof z=="boolean")return z?$.create(N,J):F.create(N,J);const ue=b.get(N);return typeof ue=="boolean"?z===(ue?"true":"false")?l.INSTANCE:n.INSTANCE:new k(N,z,J)}constructor(N,z,J){this.c=N,this.d=z,this.f=J,this.type=4}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=b.get(this.c);if(typeof N=="boolean"){const z=N?"true":"false";return this.d===z?l.INSTANCE:n.INSTANCE}return this}evaluate(N){return N.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(N){return N.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$Aj=k;class j{static create(N,z){return new j(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=10,this.c=null}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.d,this.f,N.d,N.f)}equals(N){return N.type===this.type?this.d===N.d&&this.f===N.f:!1}substituteConstants(){return this}evaluate(N){const z=N.getValue(this.f),J=N.getValue(this.d);return Array.isArray(z)?z.includes(J):typeof J=="string"&&typeof z=="object"&&z!==null?y.call(z,J):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(N){return N.mapIn(this.d,this.f)}negate(){return this.c||(this.c=A.create(this.d,this.f)),this.c}}e.$Bj=j;class A{static create(N,z){return new A(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=11,this.c=j.create(N,z)}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(N){return N.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Cj=A;class O{static create(N,z,J=null){if(typeof z=="boolean")return z?F.create(N,J):$.create(N,J);const ue=b.get(N);return typeof ue=="boolean"?z===(ue?"true":"false")?n.INSTANCE:l.INSTANCE:new O(N,z,J)}constructor(N,z,J){this.c=N,this.d=z,this.f=J,this.type=5}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){const N=b.get(this.c);if(typeof N=="boolean"){const z=N?"true":"false";return this.d===z?n.INSTANCE:l.INSTANCE}return this}evaluate(N){return N.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(N){return N.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Dj=O;class F{static create(N,z=null){const J=b.get(N);return typeof J=="boolean"?J?n.INSTANCE:l.INSTANCE:new F(N,z)}constructor(N,z){this.c=N,this.d=z,this.type=3}cmp(N){return N.type!==this.type?this.type-N.type:ce(this.c,N.c)}equals(N){return N.type===this.type?this.c===N.c:!1}substituteConstants(){const N=b.get(this.c);return typeof N=="boolean"?N?n.INSTANCE:l.INSTANCE:this}evaluate(N){return!N.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(N){return N.mapNot(this.c)}negate(){return this.d||(this.d=$.create(this.c,this)),this.d}}e.$Ej=F;function V(B,N){if(typeof B=="string"){const z=parseFloat(B);isNaN(z)||(B=z)}return typeof B=="string"||typeof B=="number"?N(B):n.INSTANCE}class Z{static create(N,z,J=null){return V(z,ue=>new Z(N,ue,J))}constructor(N,z,J){this.c=N,this.d=z,this.f=J,this.type=12}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=te.create(this.c,this.d,this)),this.f}}e.$Fj=Z;class oe{static create(N,z,J=null){return V(z,ue=>new oe(N,ue,J))}constructor(N,z,J){this.c=N,this.d=z,this.f=J,this.type=13}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(N){return N.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=le.create(this.c,this.d,this)),this.f}}e.$Gj=oe;class le{static create(N,z,J=null){return V(z,ue=>new le(N,ue,J))}constructor(N,z,J){this.c=N,this.d=z,this.f=J,this.type=14}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$Hj=le;class te{static create(N,z,J=null){return V(z,ue=>new te(N,ue,J))}constructor(N,z,J){this.c=N,this.d=z,this.f=J,this.type=15}cmp(N){return N.type!==this.type?this.type-N.type:ie(this.c,this.d,N.c,N.d)}equals(N){return N.type===this.type?this.c===N.c&&this.d===N.d:!1}substituteConstants(){return this}evaluate(N){return typeof this.d=="string"?!1:parseFloat(N.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(N){return N.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.$Ij=te;class _{static create(N,z){return new _(N,z)}constructor(N,z){this.d=N,this.f=z,this.type=7,this.c=null}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.d<N.d)return-1;if(this.d>N.d)return 1;const z=this.f?this.f.source:"",J=N.f?N.f.source:"";return z<J?-1:z>J?1:0}equals(N){if(N.type===this.type){const z=this.f?this.f.source:"",J=N.f?N.f.source:"";return this.d===N.d&&z===J}return!1}substituteConstants(){return this}evaluate(N){const z=N.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const N=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${N}`}keys(){return[this.d]}map(N){return N.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$Jj=_;class W{static create(N){return new W(N)}constructor(N){this.c=N,this.type=8}cmp(N){return N.type!==this.type?this.type-N.type:this.c.cmp(N.c)}equals(N){return N.type===this.type?this.c.equals(N.c):!1}substituteConstants(){return this}evaluate(N){return!this.c.evaluate(N)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(N){return new W(this.c.map(N))}negate(){return this.c}}e.$Kj=W;function K(B){let N=null;for(let z=0,J=B.length;z<J;z++){const ue=B[z].substituteConstants();if(B[z]!==ue&&N===null){N=[];for(let x=0;x<z;x++)N[x]=B[x]}N!==null&&(N[z]=ue)}return N===null?B:N}class Y{static create(N,z,J){return Y.d(N,z,J)}constructor(N,z){this.expr=N,this.c=z,this.type=6}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let z=0,J=this.expr.length;z<J;z++){const ue=i(this.expr[z],N.expr[z]);if(ue!==0)return ue}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let z=0,J=this.expr.length;z<J;z++)if(!this.expr[z].equals(N.expr[z]))return!1;return!0}return!1}substituteConstants(){const N=K(this.expr);return N===this.expr?this:Y.create(N,this.c,!1)}evaluate(N){for(let z=0,J=this.expr.length;z<J;z++)if(!this.expr[z].evaluate(N))return!1;return!0}static d(N,z,J){const ue=[];let x=!1;for(const G of N)if(G){if(G.type===1){x=!0;continue}if(G.type===0)return n.INSTANCE;if(G.type===6){ue.push(...G.expr);continue}ue.push(G)}if(ue.length===0&&x)return l.INSTANCE;if(ue.length!==0){if(ue.length===1)return ue[0];ue.sort(i);for(let G=1;G<ue.length;G++)ue[G-1].equals(ue[G])&&(ue.splice(G,1),G--);if(ue.length===1)return ue[0];for(;ue.length>1;){const G=ue[ue.length-1];if(G.type!==9)break;ue.pop();const U=ue.pop(),T=ue.length===0,q=M.create(G.expr.map(se=>Y.create([se,U],null,J)),null,T);q&&(ue.push(q),ue.sort(i))}if(ue.length===1)return ue[0];if(J){for(let G=0;G<ue.length;G++)for(let U=G+1;U<ue.length;U++)if(ue[G].negate().equals(ue[U]))return n.INSTANCE;if(ue.length===1)return ue[0]}return new Y(ue,z)}}serialize(){return this.expr.map(N=>N.serialize()).join(" && ")}keys(){const N=[];for(const z of this.expr)N.push(...z.keys());return N}map(N){return new Y(this.expr.map(z=>z.map(N)),null)}negate(){if(!this.c){const N=[];for(const z of this.expr)N.push(z.negate());this.c=M.create(N,this,!0)}return this.c}}e.$Lj=Y;class M{static create(N,z,J){return M.d(N,z,J)}constructor(N,z){this.expr=N,this.c=z,this.type=9}cmp(N){if(N.type!==this.type)return this.type-N.type;if(this.expr.length<N.expr.length)return-1;if(this.expr.length>N.expr.length)return 1;for(let z=0,J=this.expr.length;z<J;z++){const ue=i(this.expr[z],N.expr[z]);if(ue!==0)return ue}return 0}equals(N){if(N.type===this.type){if(this.expr.length!==N.expr.length)return!1;for(let z=0,J=this.expr.length;z<J;z++)if(!this.expr[z].equals(N.expr[z]))return!1;return!0}return!1}substituteConstants(){const N=K(this.expr);return N===this.expr?this:M.create(N,this.c,!1)}evaluate(N){for(let z=0,J=this.expr.length;z<J;z++)if(this.expr[z].evaluate(N))return!0;return!1}static d(N,z,J){let ue=[],x=!1;if(N){for(let G=0,U=N.length;G<U;G++){const T=N[G];if(T){if(T.type===0){x=!0;continue}if(T.type===1)return l.INSTANCE;if(T.type===9){ue=ue.concat(T.expr);continue}ue.push(T)}}if(ue.length===0&&x)return n.INSTANCE;ue.sort(i)}if(ue.length!==0){if(ue.length===1)return ue[0];for(let G=1;G<ue.length;G++)ue[G-1].equals(ue[G])&&(ue.splice(G,1),G--);if(ue.length===1)return ue[0];if(J){for(let G=0;G<ue.length;G++)for(let U=G+1;U<ue.length;U++)if(ue[G].negate().equals(ue[U]))return l.INSTANCE;if(ue.length===1)return ue[0]}return new M(ue,z)}}serialize(){return this.expr.map(N=>N.serialize()).join(" || ")}keys(){const N=[];for(const z of this.expr)N.push(...z.keys());return N}map(N){return new M(this.expr.map(z=>z.map(N)),null)}negate(){if(!this.c){const N=[];for(const z of this.expr)N.push(z.negate());for(;N.length>1;){const z=N.shift(),J=N.shift(),ue=[];for(const x of X(z))for(const G of X(J))ue.push(Y.create([x,G],null,!1));N.unshift(M.create(ue,null,!1))}this.c=M.create(N,this,!0)}return this.c}}e.$Mj=M;class Q extends ${static{this.d=[]}static all(){return Q.d.values()}constructor(N,z,J){super(N,null),this.f=z,typeof J=="object"?Q.d.push({...J,key:N}):J!==!0&&Q.d.push({key:N,description:J,type:z!=null?typeof z:void 0})}bindTo(N){return N.createKey(this.key,this.f)}getValue(N){return N.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(N){return k.create(this.key,N)}notEqualsTo(N){return O.create(this.key,N)}}e.$Nj=Q,e.$Oj=(0,D.$wi)("contextKeyService");function ce(B,N){return B<N?-1:B>N?1:0}function ie(B,N,z,J){return B<z?-1:B>z?1:N<J?-1:N>J?1:0}function be(B,N){if(B.type===0||N.type===1)return!0;if(B.type===9)return N.type===9?re(B.expr,N.expr):!1;if(N.type===9){for(const z of N.expr)if(be(B,z))return!0;return!1}if(B.type===6){if(N.type===6)return re(N.expr,B.expr);for(const z of B.expr)if(be(z,N))return!0;return!1}return B.equals(N)}function re(B,N){let z=0,J=0;for(;z<B.length&&J<N.length;){const ue=B[z].cmp(N[J]);if(ue<0)return!1;ue===0&&z++,J++}return z===B.length}function X(B){return B.type===9?B.expr:[B]}}),define(ye[231],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fn=e.$dn=e.ID=void 0,e.$en=C,e.ID="diagnosticsService",e.$dn=(0,o.$wi)(e.ID);function C(D){return!!D.hostName&&!!D.errorMessage}class S{async getPerformanceInfo(I,P){return{}}async getSystemInfo(I,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,P){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$fn=S}),define(ye[83],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=void 0,e.$Ko=(0,o.$wi)("downloadService")}),define(ye[26],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=void 0,e.$Di=(0,o.$wi)("environmentService"),e.$Ei=(0,o.$xi)(e.$Di)}),define(ye[32],Ee([1,0,192,5]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.ExtensionGalleryErrorCode=e.$7o=e.ExtensionManagementErrorCode=e.$6o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=void 0,e.$Zo=S,e.$1o=D,e.$2o=I,e.$3o=P,e.$4o=b,e.$5o=g,e.$To="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Uo=new RegExp(e.$To),e.$Vo="__web_extension",e.$Wo="skipWalkthrough",e.$Xo="extensionsSync",e.$Yo="dependecyOrPackExtensionInstall";function S(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function D(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function I(d,p){switch(d){case 3:return p==="x64"?"win32-x64":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function P(d,p){return p==="web"&&!d.includes("web")}function b(d,p,E){return P(p,E)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===E}function g(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}var y;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(y||(e.SortBy=y={}));var v;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var w;(function(d){d.Install="install",d.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var m;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$6o=(0,C.$wi)("extensionGalleryService");var u;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Cancelled="Cancelled",d.Unknown="Unknown",d.Internal="Internal"})(u||(e.ExtensionManagementErrorCode=u={}));class a extends Error{constructor(p,E){super(p),this.code=E,this.name=E}}e.$7o=a;var f;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(f||(e.ExtensionGalleryErrorCode=f={}));class c extends Error{constructor(p,E){super(p),this.code=E,this.name=E}}e.$8o=c,e.$9o=(0,C.$wi)("extensionManagementService"),e.$0o="extensionsIdentifiers/disabled",e.$$o="extensionsIdentifiers/enabled",e.$_o=(0,C.$wi)("IGlobalExtensionEnablementService"),e.$ap=(0,C.$wi)("IExtensionTipsService"),e.$bp=(0,o.localize2)(0,"Extensions"),e.$cp=(0,o.localize2)(1,"Preferences")}),define(ye[232],Ee([1,0,6,2,21,4,55,32]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=void 0;function b(f,c){return f?D.URI.revive(c?c.transformIncoming(f):f):void 0}function g(f,c){return c?c.transformOutgoingURI(f):f}function y(f,c){c=c||I.$zn;const d=f.manifest;return{...(0,I.$Cn)({...f,manifest:void 0},c),manifest:d}}function v(f,c){return f?.profileLocation?(0,I.$Cn)(f,c??I.$zn):f}function w(f,c){return c?(0,S.$5n)(f,d=>d instanceof D.URI?c.transformOutgoingURI(d):void 0):f}class m{constructor(c,d){this.a=c,this.b=d,this.onInstallExtension=o.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtensions=o.Event.buffer(c.onDidInstallExtensions,!0),this.onUninstallExtension=o.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=o.Event.buffer(c.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=o.Event.buffer(c.onDidUpdateExtensionMetadata,!0)}listen(c,d){const p=this.b(c);switch(d){case"onInstallExtension":return o.Event.map(this.onInstallExtension,E=>({...E,profileLocation:E.profileLocation?g(E.profileLocation,p):E.profileLocation}));case"onDidInstallExtensions":return o.Event.map(this.onDidInstallExtensions,E=>E.map(h=>({...h,local:h.local?w(h.local,p):h.local,profileLocation:h.profileLocation?g(h.profileLocation,p):h.profileLocation})));case"onUninstallExtension":return o.Event.map(this.onUninstallExtension,E=>({...E,profileLocation:E.profileLocation?g(E.profileLocation,p):E.profileLocation}));case"onDidUninstallExtension":return o.Event.map(this.onDidUninstallExtension,E=>({...E,profileLocation:E.profileLocation?g(E.profileLocation,p):E.profileLocation}));case"onDidUpdateExtensionMetadata":return o.Event.map(this.onDidUpdateExtensionMetadata,E=>w(E,p))}throw new Error("Invalid listen")}async call(c,d,p){const E=this.b(c);switch(d){case"zip":{const h=y(p[0],E),t=await this.a.zip(h);return g(t,E)}case"unzip":return this.a.unzip(b(p[0],E));case"install":return this.a.install(b(p[0],E),v(p[1],E));case"installFromLocation":return this.a.installFromLocation(b(p[0],E),b(p[1],E));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(p[0],b(p[1],E),b(p[2],E));case"getManifest":return this.a.getManifest(b(p[0],E));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(p[0]);case"installFromGallery":return this.a.installFromGallery(p[0],v(p[1],E));case"installGalleryExtensions":{const h=p[0];return this.a.installGalleryExtensions(h.map(({extension:t,options:s})=>({extension:t,options:v(s,E)??{}})))}case"uninstall":return this.a.uninstall(y(p[0],E),v(p[1],E));case"reinstallFromGallery":return this.a.reinstallFromGallery(y(p[0],E));case"getInstalled":return(await this.a.getInstalled(p[0],b(p[1],E),p[2])).map(t=>w(t,E));case"toggleAppliationScope":{const h=await this.a.toggleAppliationScope(y(p[0],E),b(p[1],E));return w(h,E)}case"copyExtensions":return this.a.copyExtensions(b(p[0],E),b(p[1],E));case"updateMetadata":{const h=await this.a.updateMetadata(y(p[0],E),p[1],b(p[2],E));return w(h,E)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(p[0],p[1],p[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$dq=m;class u extends C.$Vc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(c){super(),this.m=c,this.c=this.B(new o.$ee),this.f=this.B(new o.$ee),this.g=this.B(new o.$ee),this.h=this.B(new o.$ee),this.j=this.B(new o.$ee),this.B(this.m.listen("onInstallExtension")(d=>this.n(this.c,{...d,source:this.r(d.source)?D.URI.revive(d.source):d.source,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(d=>this.n(this.f,d.map(p=>({...p,local:p.local?y(p.local,null):p.local,source:this.r(p.source)?D.URI.revive(p.source):p.source,profileLocation:D.URI.revive(p.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(d=>this.n(this.g,{...d,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(d=>this.n(this.h,{...d,profileLocation:D.URI.revive(d.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(d=>this.j.fire(y(d,null))))}n(c,d){c.fire(d)}r(c){return c?typeof c.path=="string"&&typeof c.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(c){const d=await this.getTargetPlatform();return c.allTargetPlatforms.some(p=>(0,P.$4o)(p,c.allTargetPlatforms,d))}zip(c){return Promise.resolve(this.m.call("zip",[c]).then(d=>D.URI.revive(d)))}unzip(c){return Promise.resolve(this.m.call("unzip",[c]))}install(c,d){return Promise.resolve(this.m.call("install",[c,d])).then(p=>y(p,null))}installFromLocation(c,d){return Promise.resolve(this.m.call("installFromLocation",[c,d])).then(p=>y(p,null))}async installExtensionsFromProfile(c,d,p){return(await this.m.call("installExtensionsFromProfile",[c,d,p])).map(h=>y(h,null))}getManifest(c){return Promise.resolve(this.m.call("getManifest",[c]))}installFromGallery(c,d){return Promise.resolve(this.m.call("installFromGallery",[c,d])).then(p=>y(p,null))}async installGalleryExtensions(c){return(await this.m.call("installGalleryExtensions",[c])).map(p=>({...p,local:p.local?y(p.local,null):p.local,source:this.r(p.source)?D.URI.revive(p.source):p.source,profileLocation:D.URI.revive(p.profileLocation)}))}uninstall(c,d){if(c.isWorkspaceScoped)throw new Error("Cannot uninstall a workspace extension");return Promise.resolve(this.m.call("uninstall",[c,d]))}reinstallFromGallery(c){return Promise.resolve(this.m.call("reinstallFromGallery",[c])).then(d=>y(d,null))}getInstalled(c=null,d,p){return Promise.resolve(this.m.call("getInstalled",[c,d,p])).then(E=>E.map(h=>y(h,null)))}updateMetadata(c,d,p){return Promise.resolve(this.m.call("updateMetadata",[c,d,p])).then(E=>y(E,null))}toggleAppliationScope(c,d){return this.m.call("toggleAppliationScope",[c,d]).then(p=>y(p,null))}copyExtensions(c,d){return this.m.call("copyExtensions",[c,d])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(c,d,p){const E=await this.m.call("download",[c,d,p]);return D.URI.revive(E)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$eq=u;class a{constructor(c){this.a=c}listen(c,d){throw new Error("Invalid listen")}call(c,d,p){switch(d){case"getConfigBasedTips":return this.a.getConfigBasedTips(D.URI.revive(p[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$fq=a}),define(ye[16],Ee([1,0,64,7,17,10,4,200,5,3,13,60]),function(he,e,o,C,S,D,I,P,b,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yl=e.$vl=e.FileKind=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.FileOperationResult=e.$nl=e.$ml=e.$ll=e.$jl=e.FileChangeType=e.$il=e.FileOperation=e.$cl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$3k=void 0,e.$4k=w,e.$5k=f,e.$6k=d,e.$7k=p,e.$8k=E,e.$9k=h,e.$0k=t,e.$$k=s,e.$_k=r,e.$al=i,e.$bl=n,e.$dl=k,e.$el=j,e.$fl=A,e.$gl=O,e.$hl=F,e.$kl=te,e.$wl=Q,e.$xl=ce,e.$zl=be,e.$3k=(0,b.$wi)("fileService");function w(re){return re.create===!0}var m;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var u;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(u||(e.FilePermission=u={}));var a;(function(re){re[re.UPDATED=2]="UPDATED",re[re.ADDED=4]="ADDED",re[re.DELETED=8]="DELETED"})(a||(e.FileChangeFilter=a={}));function f(re){const X=re;return!!X&&typeof X.onDidChange=="function"}var c;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function d(re){return!!(re.capabilities&2)}function p(re){return!!(re.capabilities&8)}function E(re){return!!(re.capabilities&131072)}function h(re){return!!(re.capabilities&4)}function t(re){return!!(re.capabilities&16)}function s(re){return d(re)?!!(re.capabilities&16384):!1}function r(re){return d(re)?!!(re.capabilities&32768):!1}function i(re){return!!(re.capabilities&65536)}function n(re){return!!(re.capabilities&2048)}var l;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(l||(e.FileSystemProviderErrorCode=l={}));class $ extends Error{static create(X,B){const N=new $(X.toString(),B);return A(N,B),N}constructor(X,B){super(X),this.code=B}}e.$cl=$;function k(re,X){return $.create(re,X)}function j(re){return re||k((0,P.localize)(0,null),l.Unknown)}function A(re,X){return re.name=X?`${X} (FileSystemError)`:"FileSystemError",re}function O(re){if(!re)return l.Unknown;if(re instanceof $)return re.code;const X=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!X)return l.Unknown;switch(X[1]){case l.FileExists:return l.FileExists;case l.FileIsADirectory:return l.FileIsADirectory;case l.FileNotADirectory:return l.FileNotADirectory;case l.FileNotFound:return l.FileNotFound;case l.FileTooLarge:return l.FileTooLarge;case l.FileWriteLocked:return l.FileWriteLocked;case l.NoPermissions:return l.NoPermissions;case l.Unavailable:return l.Unavailable}return l.Unknown}function F(re){if(re instanceof _)return re.fileOperationResult;switch(O(re)){case l.FileNotFound:return 1;case l.FileIsADirectory:return 0;case l.FileNotADirectory:return 9;case l.FileWriteLocked:return 5;case l.NoPermissions:return 6;case l.FileExists:return 4;case l.FileTooLarge:return 7;default:return 10}}var V;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(V||(e.FileOperation=V={}));class Z{constructor(X,B,N){this.resource=X,this.operation=B,this.target=N}isOperation(X){return this.operation===X}}e.$il=Z;var oe;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(oe||(e.FileChangeType=oe={}));class le{static{this.a=null}constructor(X,B){this.c=B,this.b=void 0,this.d=new v.$V(()=>{const N=o.$Ci.forUris(()=>this.c);return N.fill(this.rawAdded.map(z=>[z,!0])),N}),this.f=new v.$V(()=>{const N=o.$Ci.forUris(()=>this.c);return N.fill(this.rawUpdated.map(z=>[z,!0])),N}),this.g=new v.$V(()=>{const N=o.$Ci.forUris(()=>this.c);return N.fill(this.rawDeleted.map(z=>[z,!0])),N}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const N of X){switch(N.type){case 1:this.rawAdded.push(N.resource);break;case 0:this.rawUpdated.push(N.resource);break;case 2:this.rawDeleted.push(N.resource);break}this.b!==le.a&&(typeof N.cId=="number"?this.b===void 0?this.b=N.cId:this.b!==N.cId&&(this.b=le.a):this.b!==void 0&&(this.b=le.a))}}contains(X,...B){return this.h(X,{includeChildren:!1},...B)}affects(X,...B){return this.h(X,{includeChildren:!0},...B)}h(X,B,...N){if(!X)return!1;const z=N.length>0;return!!((!z||N.includes(1))&&(this.d.value.get(X)||B.includeChildren&&this.d.value.findSuperstr(X))||(!z||N.includes(0))&&(this.f.value.get(X)||B.includeChildren&&this.f.value.findSuperstr(X))||(!z||N.includes(2))&&(this.g.value.findSubstr(X)||B.includeChildren&&this.g.value.findSuperstr(X)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(X){return this.b===X}hasCorrelation(){return typeof this.b=="number"}}e.$jl=le;function te(re,X,B){return!re||!X||re===X||X.length>re.length?!1:(X.charAt(X.length-1)!==C.sep&&(X+=C.sep),B?(0,S.$zf)(re,X):re.indexOf(X)===0)}class _ extends Error{constructor(X,B,N){super(X),this.fileOperationResult=B,this.options=N}}e.$ll=_;class W extends _{constructor(X,B,N,z){super(X,B,z),this.fileOperationResult=B,this.size=N}}e.$ml=W;class K extends _{constructor(X,B,N){super(X,2,N),this.stat=B}}e.$nl=K;var Y;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$ol={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$pl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$ql="files.associations",e.$rl="files.exclude",e.$sl="files.readonlyInclude",e.$tl="files.readonlyExclude",e.$ul="files.readonlyFromPermissions";var M;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(M||(e.FileKind=M={})),e.$vl="";function Q(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}async function ce(re,X){if(!X.hasProvider(I.URI.from({scheme:re.scheme})))return new Promise(B=>{const N=X.onDidChangeFileSystemProviderRegistrations(z=>{z.scheme===re.scheme&&z.added&&(N.dispose(),B())})})}class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(X){return(0,D.$ag)(X)||(X=0),X<ie.KB?(0,P.localize)(1,null,X.toFixed(0)):X<ie.MB?(0,P.localize)(2,null,(X/ie.KB).toFixed(2)):X<ie.GB?(0,P.localize)(3,null,(X/ie.MB).toFixed(2)):X<ie.TB?(0,P.localize)(4,null,(X/ie.GB).toFixed(2)):(0,P.localize)(5,null,(X/ie.TB).toFixed(2))}}e.$yl=ie;function be(re){const X=typeof re=="string"||re?.scheme===y.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===y.Schemas.file?1024*ie.MB:X?10*ie.MB:g.$o?50*ie.MB:1024*ie.MB}}),define(ye[111],Ee([1,0,15,11,201,16]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=I;async function I(y,v,w,m,u,a){let f;try{await P(y,v,w,m,u,a)}catch(c){f=c}finally{f&&u.errorTransformer&&(f=u.errorTransformer(f)),typeof f<"u"&&w.error(f),w.end()}}async function P(y,v,w,m,u,a){b(a);const f=await y.open(v,{create:!1});try{b(a);let c=0,d=0,p=u&&typeof u.length=="number"?u.length:void 0,E=o.$Ge.alloc(Math.min(u.bufferSize,typeof p=="number"?p:u.bufferSize)),h=u&&typeof u.position=="number"?u.position:0,t=0;do d=await y.read(f,h,E.buffer,t,E.byteLength-t),h+=d,t+=d,c+=d,typeof p=="number"&&(p-=d),t===E.byteLength&&(await w.write(m(E)),E=o.$Ge.alloc(Math.min(u.bufferSize,typeof p=="number"?p:u.bufferSize)),t=0);while(d>0&&(typeof p!="number"||p>0)&&b(a)&&g(c,u));if(t>0){let s=t;typeof p=="number"&&(s=Math.min(t,p)),w.write(m(E.slice(0,s)))}}catch(c){throw(0,D.$el)(c)}finally{await y.close(f)}}function b(y){if(y.isCancellationRequested)throw(0,C.$6)();return!0}function g(y,v){if(typeof v?.limits?.size=="number"&&y>v.limits.size)throw(0,D.$dl)((0,S.localize)(0,null),D.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ye[48],Ee([1,0,80,2,7,3,4,16]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=e.$Mq=e.$Lq=void 0,e.$Jq=b,e.$Kq=g,e.$Oq=m,e.$Pq=u,e.$Qq=a,e.$Rq=f,e.$Sq=d,e.$Tq=p;function b(E){return typeof E.correlationId=="number"}function g(E){return E.recursive===!0}class y extends C.$Vc{static{this.a=5}constructor(h,t,s,r){super(),this.h=h,this.j=t,this.m=s,this.n=r,this.c=this.B(new C.$Wc),this.f=void 0,this.g=0}s(){const h=new C.$Uc;this.c.value=h,this.b=this.r(h),this.b.setVerboseLogging(this.m),h.add(this.b.onDidChangeFile(t=>this.h(t))),h.add(this.b.onDidLogMessage(t=>this.j(t))),h.add(this.b.onDidError(t=>this.t(t)))}t(h){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${h}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${h}`):this.w(h)}u(h){this.g++,this.s(),this.watch(h)}async watch(h){this.f=h,await this.b?.watch(h)}async setVerboseLogging(h){this.m=h,await this.b?.setVerboseLogging(h)}w(h){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${h}`})}y(h){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${h}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Lq=y;class v extends y{constructor(h,t,s){super(h,t,s,{type:"node.js",restartOnError:!1})}}e.$Mq=v;class w extends y{constructor(h,t,s){super(h,t,s,{type:"universal",restartOnError:!0})}}e.$Nq=w;function m(E){return E.map(h=>({type:h.type,resource:I.URI.revive(h.resource),cId:h.cId}))}function u(E){const h=new c;for(const t of E)h.processEvent(t);return h.coalesce()}function a(E,h){return typeof h=="string"&&!h.startsWith(o.$mk)&&!(0,S.$jc)(h)?{base:E,pattern:h}:h}function f(E,h){const t=[];for(const s of h)t.push((0,o.$qk)(a(E,s)));return t}class c{constructor(){this.a=new Set,this.b=new Map}c(h){return D.$k?h.resource.fsPath:h.resource.fsPath.toLowerCase()}processEvent(h){const t=this.b.get(this.c(h));let s=!1;if(t){const r=t.type,i=h.type;t.resource.fsPath!==h.resource.fsPath&&(h.type===2||h.type===1)?s=!0:r===1&&i===2?(this.b.delete(this.c(h)),this.a.delete(t)):r===2&&i===1?t.type=0:r===1&&i===0||(t.type=i)}else s=!0;s&&(this.a.add(h),this.b.set(this.c(h),h))}coalesce(){const h=[],t=[];return Array.from(this.a).filter(s=>s.type!==2?(h.push(s),!1):!0).sort((s,r)=>s.resource.fsPath.length-r.resource.fsPath.length).filter(s=>t.some(r=>(0,P.$kl)(s.resource.fsPath,r,!D.$k))?!1:(t.push(s.resource.fsPath),!0)).concat(h)}}function d(E,h){if(typeof h=="number")switch(E.type){case 1:return(h&4)===0;case 2:return(h&8)===0;case 0:return(h&2)===0}return!1}function p(E){if(typeof E=="number"){const h=[];return E&4&&h.push("Added"),E&8&&h.push("Deleted"),E&2&&h.push("Updated"),h.length===0?"<all>":`[${h.join(", ")}]`}return"<none>"}}),define(ye[233],Ee([1,0,15,39,11,6,2,52,22,16,48]),function(he,e,o,C,S,D,I,P,b,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DQ=e.$CQ=void 0,e.$CQ="localFilesystem";class v extends I.$Vc{constructor(m,u){super(),this.a=m,this.b=u,this.onDidChangeCapabilities=D.Event.None,this.f=this.B(new D.$ee),this.onDidChangeFile=this.f.event,this.g=this.B(new D.$ee),this.onDidWatchError=this.g.event,this.h=(0,b.$Sg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,u){const{buffer:a}=await this.a.call("readFile",[m,u]);return a}readFileStream(m,u,a){const f=(0,P.$ue)(d=>o.$Ge.concat(d.map(p=>o.$Ge.wrap(p))).buffer),c=new I.$Uc;return c.add(this.a.listen("readFileStream",[m,u])(d=>{if(d instanceof o.$Ge)f.write(d.buffer);else{if(d==="end")f.end();else{let p;if(d instanceof Error)p=d;else{const E=d;p=(0,g.$dl)(E.message??(0,C.$hj)(E),E.code??g.FileSystemProviderErrorCode.Unknown)}f.error(p),f.end()}c.dispose()}})),c.add(a.onCancellationRequested(()=>{f.error((0,S.$6)()),f.end(),c.dispose()})),f}writeFile(m,u,a){return this.a.call("writeFile",[m,o.$Ge.wrap(u),a])}open(m,u){return this.a.call("open",[m,u])}close(m){return this.a.call("close",[m])}async read(m,u,a,f,c){const[d,p]=await this.a.call("read",[m,u,c]);return a.set(d.buffer.slice(0,p),f),p}write(m,u,a,f,c){return this.a.call("write",[m,u,o.$Ge.wrap(a),f,c])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,u){return this.a.call("delete",[m,u])}rename(m,u,a){return this.a.call("rename",[m,u,a])}copy(m,u,a){return this.a.call("copy",[m,u,a])}cloneFile(m,u){return this.a.call("cloneFile",[m,u])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const u=m;this.f.fire((0,y.$Oq)(u))}else{const u=m;this.g.fire(u)}}))}watch(m,u){const a=(0,b.$Sg)();return this.a.call("watch",[this.h,a,m,u]),(0,I.$Tc)(()=>this.a.call("unwatch",[this.h,a]))}}e.$DQ=v}),define(ye[234],Ee([1,0,27,2,48,6,4,14]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=void 0;class b extends C.$Vc{constructor(){super(),this.a=this.B(new D.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new D.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new C.$5c),this.m=new Set,this.n=5007,this.r=new P.$Th,this.P=!1,this.B(this.f(y=>this.s(y)))}s(y){this.t(y)&&this.w(y)}t(y){return(0,S.$Jq)(y)}async watch(y){this.r.isSettled||this.r.complete(),this.r=new P.$Th;try{this.h.clear(),this.g.clear();for(const v of y)this.t(v)?this.h.set(v.correlationId,v):this.g.add(v);for(const[v]of this.j)this.h.has(v)||(this.j.deleteAndDispose(v),this.m.delete(v));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(y=>!this.j.has(y.correlationId))])}isSuspended(y){return typeof y.correlationId!="number"?!1:this.m.has(y.correlationId)?"polling":this.j.has(y.correlationId)}async w(y){if(this.j.has(y.correlationId))return;const v=new C.$Uc;this.j.set(y.correlationId,v),await this.r.p,!v.isDisposed&&(this.z(y,v),this.u())}y(y){this.j.deleteAndDispose(y.correlationId),this.m.delete(y.correlationId),this.u()}z(y,v){this.C(y,v)?(this.N(`reusing an existing recursive watcher to monitor ${y.path}`),this.m.delete(y.correlationId)):(this.D(y,v),this.m.add(y.correlationId))}C(y,v){const w=this.M?.subscribe(y.path,(m,u)=>{v.isDisposed||(m?this.z(y,v):u?.type===1&&this.F(y))});return w?(v.add(w),!0):!1}D(y,v){let w=!1;const m=(u,a)=>{if(v.isDisposed)return;const f=this.G(u),c=this.G(a),d=w;w=f,!f&&(c||d)&&this.F(y)};this.N(`starting fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,o.watchFile)(y.path,{persistent:!1,interval:this.n},m)}catch(u){this.O(`fs.watchFile() failed with error ${u} on path ${y.path} (correlationId: ${y.correlationId})`)}v.add((0,C.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${y.path} (correlationId: ${y.correlationId})`);try{(0,o.unwatchFile)(y.path,m)}catch(u){this.O(`fs.unwatchFile() failed with error ${u} on path ${y.path} (correlationId: ${y.correlationId})`)}}))}F(y){this.N(`detected ${y.path} exists again, resuming watcher (correlationId: ${y.correlationId})`);const v={resource:I.URI.file(y.path),type:1,cId:y.correlationId};this.a.fire([v]),this.H(v,y),this.y(y)}G(y){return y.ctimeMs===0&&y.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(y,v){if(this.P){const w=` >> normalized ${y.type===1?"[ADDED]":y.type===2?"[DELETED]":"[CHANGED]"} ${y.resource.fsPath}`;this.I(w,v)}}I(y,v){this.P&&this.N(`${y}${typeof v.correlationId=="number"?` <${v.correlationId}> `:""}`)}J(y){return`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"}, filter: ${(0,S.$Tq)(y.filter)}, correlationId: ${typeof y.correlationId=="number"?y.correlationId:"<none>"})`}async setVerboseLogging(y){this.P=y}}e.$3q=b}),define(ye[235],Ee([1,0,27,14,20,35,2,99,7,3,19,4,181,23,48]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0,e.$9q=f;class a extends I.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(d,p,E,h,t,s){super(),this.s=d,this.t=p,this.u=E,this.w=h,this.y=t,this.z=s,this.c=this.B(new C.$Lh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},r=>this.u(r))),this.f=this.B(new C.$Kh(r=>this.M(r),a.b)),this.g=(0,u.$Rq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,u.$Rq)(this.s.path,this.s.includes):void 0,this.j=(0,u.$Jq)(this.s)?this.s.filter:void 0,this.m=new S.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const d=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const p=await m.Promises.stat(d);if(this.m.token.isCancellationRequested)return;this.B(await this.G(d,p.isDirectory()))}catch(d){d.code!=="ENOENT"?this.O(d):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${d})`),this.D()}}D(){this.r=!0,this.w?.()}async F(d){let p=d.path;try{p=await m.Promises.realpath(d.path),d.path===p&&(p=await(0,w.$5q)(d.path,this.m.token)??d.path),d.path!==p&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${p})`)}catch{}return p}async G(d,p){const E=new I.$Uc;return this.H(d,p,E)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(d,p,E)),E}H(d,p,E){if(p)return!1;const h=v.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(s,r)=>{if(!E.isDisposed)if(s){const i=await this.G(d,p);E.isDisposed?i.dispose():E.add(i)}else r&&(typeof r.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:h,type:r.type,cId:this.s.correlationId},!0)});return t?(E.add(t),!0):!1}async I(d,p,E){if(g.$j&&(0,D.$vg)(d,"/Volumes/",!0)){this.O(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const h=new S.$pe(this.m.token);E.add((0,I.$Tc)(()=>h.dispose(!0)));const t=new I.$Uc;E.add(t);try{const s=v.URI.file(this.s.path),r=(0,b.$oc)(d),i=(0,o.watch)(d);t.add((0,I.$Tc)(()=>{i.removeAllListeners(),i.close()})),this.Q(`Started watching: '${d}'`);const n=new Set;if(p)try{for(const $ of await m.Promises.readdir(d))n.add($)}catch($){this.O($)}if(h.token.isCancellationRequested)return;const l=new Map;t.add((0,I.$Tc)(()=>{for(const[,$]of l)$.dispose();l.clear()})),i.on("error",($,k)=>{h.token.isCancellationRequested||(this.O(`Failed to watch ${d} for changes using fs.watch() (${$}, ${k})`),this.D())}),i.on("change",($,k)=>{if(h.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${$}"] ${k}`);let j="";if(k&&(j=k.toString(),g.$j&&(j=(0,P.$bm)(j))),!(!j||$!=="change"&&$!=="rename"))if(p)if($==="rename"){l.get(j)?.dispose();const A=setTimeout(async()=>{if(l.delete(j),j===r&&!await m.Promises.exists(d)){this.J(s);return}if(h.token.isCancellationRequested)return;const O=await this.N((0,b.$kc)(d,j));if(h.token.isCancellationRequested)return;let F;O?n.has(j)?F=0:(F=1,n.add(j)):(n.delete(j),F=2),this.L({resource:(0,y.$0g)(s,j),type:F,cId:this.s.correlationId})},a.a);l.set(j,(0,I.$Tc)(()=>clearTimeout(A)))}else{let A;n.has(j)?A=0:(A=1,n.add(j)),this.L({resource:(0,y.$0g)(s,j),type:A,cId:this.s.correlationId})}else if($==="rename"||j!==r){const A=setTimeout(async()=>{const O=await m.Promises.exists(d);h.token.isCancellationRequested||(O?(this.L({resource:s,type:0,cId:this.s.correlationId},!0),t.add(await this.G(d,!1))):this.J(s))},a.a);t.clear(),t.add((0,I.$Tc)(()=>clearTimeout(A)))}else this.L({resource:s,type:0,cId:this.s.correlationId},!0)})}catch(s){h.token.isCancellationRequested||this.O(`Failed to watch ${d} for changes using fs.watch() (${s.toString()})`),this.D()}}J(d){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:d,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(d,p=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!p&&this.g.some(E=>E(d.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${d.resource.fsPath}`):!p&&this.h&&this.h.length>0&&!this.h.some(E=>E(d.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}M(d){const p=(0,u.$Pq)(d),E=[];for(const t of p){if((0,u.$Sq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}E.push(t)}if(E.length===0)return;if(this.z)for(const t of E)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(E)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${E.length}, most recent change: ${E[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(d){if(g.$k)return m.Promises.exists(d);try{const p=(0,b.$oc)(d);return(await m.Promises.readdir((0,b.$nc)(d))).some(h=>h===p)}catch(p){return this.Q(p),!1}}setVerboseLogging(d){this.z=d}O(d){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}P(d){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}Q(d){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}R(d){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${d}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$8q=a;async function f(c,d,p,E,h=512){const t=await m.Promises.open(c,"r"),s=Buffer.allocUnsafe(h),r=new S.$pe(E);let i,n=!1;const l={path:c,excludes:[],recursive:!1},$=new a(l,void 0,k=>{(async()=>{for(const{type:j}of k)if(j===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:A}=await m.Promises.read(t,s,0,h,null);if(!A||r.token.isCancellationRequested)break;d(s.slice(0,A))}}catch(A){i=new Error(A),r.dispose(!0)}finally{n=!1}}})()});return await $.ready,p(),new Promise((k,j)=>{r.token.onCancellationRequested(async()=>{$.dispose();try{await m.Promises.close(t)}catch(A){i=new Error(A)}i?j(i):k()})})}}),define(ye[236],Ee([1,0,6,80,234,3,235,35]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class b extends S.$3q{constructor(y){super(),this.M=y,this.onDidError=o.Event.None,this.watchers=new Set}async L(y){y=this.X(y);const v=[],w=new Set(Array.from(this.watchers));for(const m of y){const u=this.S(m);u&&(0,C.$uk)(u.request.excludes,m.excludes)&&(0,C.$uk)(u.request.includes,m.includes)?w.delete(u):v.push(m)}v.length&&this.N(`Request to start watching: ${v.map(m=>this.J(m)).join(",")}`),w.size&&this.N(`Request to stop watching: ${Array.from(w).map(m=>this.J(m.request)).join(",")}`);for(const m of w)this.W(m);for(const m of v)this.U(m)}S(y){for(const v of this.watchers)if(typeof y.correlationId=="number"||typeof v.request.correlationId=="number"){if(v.request.correlationId===y.correlationId)return v}else if((0,P.$ug)(v.request.path,y.path,!D.$k))return v}U(y){const v=new I.$8q(y,this.M,m=>this.a.fire(m),()=>this.c.fire(y),m=>this.b.fire(m),this.P),w={request:y,instance:v};this.watchers.add(w)}async stop(){await super.stop();for(const y of this.watchers)this.W(y)}W(y){this.N("stopping file watcher",y),this.watchers.delete(y),y.instance.dispose()}X(y){const v=new Map;for(const w of y){const m=D.$k?w.path:w.path.toLowerCase();let u=v.get(w.correlationId);u||(u=new Map,v.set(w.correlationId,u)),u.has(m)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(w)}`),u.set(m,w)}return Array.from(v.values()).map(w=>Array.from(w.values())).flat()}async setVerboseLogging(y){super.setVerboseLogging(y);for(const v of this.watchers)v.instance.setVerboseLogging(y)}N(y,v){this.P&&this.b.fire({type:"trace",message:this.$(y,v)})}O(y){this.b.fire({type:"warn",message:this.$(y)})}$(y,v){return v?`[File Watcher (node.js)] ${y} (${this.J(v.request)})`:`[File Watcher (node.js)] ${y}`}}e.$0q=b}),define(ye[237],Ee([1,0,48,236]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0;class S extends o.$Mq{constructor(I,P,b){super(I,P,b),this.s()}r(I){return I.add(new C.$0q(void 0))}}e.$$q=S}),define(ye[238],Ee([1,0,13,46,108,48]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class I extends D.$Nq{constructor(b,g,y){super(b,g,y),this.s()}r(b){const g=b.add(new S.$1q(o.$Qg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return b.add(g.onDidProcessExit(({code:y,signal:v})=>this.t(`terminated by itself with code ${y}, signal: ${v} (ETERM)`))),C.ProxyChannel.toService((0,C.$di)(g.getChannel("watcher")))}}e.$2q=I}),define(ye[84],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=void 0;class o{constructor(...S){this.a=new Map;for(const[D,I]of S)this.set(D,I)}set(S,D){const I=this.a.get(S);return this.a.set(S,D),I}has(S){return this.a.has(S)}get(S){return this.a.get(S)}}e.$ui=o}),define(ye[112],Ee([1,0,14,11,2,68,230,5,84,98]),function(he,e,o,C,S,D,I,P,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=e.$cr=void 0;const y=!1;class v extends Error{constructor(f){super("cyclic dependency between services"),this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class w{constructor(f=new b.$ui,c=!1,d,p=y){this.i=f,this.j=c,this.k=d,this.l=p,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(P.$vi,this),this._globalGraph=p?d?._globalGraph??new I.$br(E=>E):void 0}dispose(){if(!this.f){this.f=!0,(0,S.$Qc)(this.h),this.h.clear();for(const f of this.g)(0,S.$Pc)(f)&&f.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(f){this.m();const c=new class extends w{dispose(){this.h.delete(c),super.dispose()}}(f,this.j,this,this.l);return this.h.add(c),c}invokeFunction(f,...c){this.m();const d=u.traceInvocation(this.l,f);let p=!1;try{return f({get:h=>{if(p)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(h,d);if(!t)throw new Error(`[invokeFunction] unknown service '${h}'`);return t}},...c)}finally{p=!0,d.stop()}}createInstance(f,...c){this.m();let d,p;return f instanceof D.$ti?(d=u.traceCreation(this.l,f.ctor),p=this.o(f.ctor,f.staticArguments.concat(c),d)):(d=u.traceCreation(this.l,f),p=this.o(f,c,d)),d.stop(),p}o(f,c=[],d){const p=P._util.getServiceDependencies(f).sort((t,s)=>t.index-s.index),E=[];for(const t of p){const s=this.s(t.id,d);s||this.y(`[createInstance] ${f.name} depends on UNKNOWN service ${t.id}.`,!1),E.push(s)}const h=p.length>0?p[0].index:c.length;if(c.length!==h){console.trace(`[createInstance] First service dependency of ${f.name} at position ${h+1} conflicts with ${c.length} static arguments`);const t=h-c.length;t>0?c=c.concat(new Array(t)):c=c.slice(0,h)}return Reflect.construct(f,c.concat(E))}q(f,c){if(this.i.get(f)instanceof D.$ti)this.i.set(f,c);else if(this.k)this.k.q(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(f){const c=this.i.get(f);return!c&&this.k?this.k.r(f):c}s(f,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(f));const d=this.r(f);return d instanceof D.$ti?this.u(f,d,c.branch(f,!0)):(c.branch(f,!1),d)}u(f,c,d){if(this.t.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this.t.add(f);try{return this.v(f,c,d)}finally{this.t.delete(f)}}v(f,c,d){const p=new I.$br(t=>t.id.toString());let E=0;const h=[{id:f,desc:c,_trace:d}];for(;h.length;){const t=h.pop();if(p.lookupOrInsertNode(t),E++>1e3)throw new v(p);for(const s of P._util.getServiceDependencies(t.desc.ctor)){const r=this.r(s.id);if(r||this.y(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof D.$ti){const i={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};p.insertEdge(t,i),h.push(i)}}}for(;;){const t=p.roots();if(t.length===0){if(!p.isEmpty())throw new v(p);break}for(const{data:s}of t){if(this.r(s.id)instanceof D.$ti){const i=this.w(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.q(s.id,i)}p.removeNode(s)}}return this.r(f)}w(f,c,d=[],p,E){if(this.i.get(f)instanceof D.$ti)return this.x(f,c,d,p,E,this.g);if(this.k)return this.k.w(f,c,d,p,E);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(f,c,d=[],p,E,h){if(p){const t=new w(void 0,this.j,this,this.l);t.c=String(f);const s=new Map,r=new o.$Ph(()=>{const i=t.o(c,d,E);for(const[n,l]of s){const $=i[n];if(typeof $=="function")for(const k of l)k.disposable=$.apply(i,k.listener)}return s.clear(),h.add(i),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let k=s.get(n);return k||(k=new g.$6c,s.set(n,k)),(A,O,F)=>{if(r.isInitialized)return r.value[n](A,O,F);{const V={listener:[A,O,F],disposable:void 0},Z=k.push(V);return(0,S.$Tc)(()=>{Z(),V.disposable?.dispose()})}}}if(n in i)return i[n];const l=r.value;let $=l[n];return typeof $!="function"||($=$.bind(l),i[n]=$),$},set(i,n,l){return r.value[n]=l,!0},getPrototypeOf(i){return c.prototype}})}else{const t=this.o(c,d,E);return h.add(t),t}}y(f,c){if(c&&console.warn(f),this.j)throw new Error(f)}}e.$cr=w;var m;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})(m||(m={}));class u{static{this.all=new Set}static{this.c=new class extends u{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(f,c){return f?new u(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):u.c}static traceCreation(f,c){return f?new u(1,c.name):u.c}static{this.f=0}constructor(f,c){this.type=f,this.name=c,this.g=Date.now(),this.h=[]}branch(f,c){const d=new u(3,f.toString());return this.h.push([f,c,d]),d}stop(){const f=Date.now()-this.g;u.f+=f;let c=!1;function d(E,h){const t=[],s=new Array(E+1).join("	");for(const[r,i,n]of h.h)if(i&&n){c=!0,t.push(`${s}CREATES -> ${r}`);const l=d(E+1,n);l&&t.push(l)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${u.f.toFixed(2)}ms)`];(f>2||c)&&u.all.add(p.join(`
`))}}e.$dr=u}),define(ye[239],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.$9v=void 0,e.$9v=(0,o.$wi)("labelService");var C;(function(S){S[S.SHORT=0]="SHORT",S[S.MEDIUM=1]="MEDIUM",S[S.LONG=2]="LONG"})(C||(e.Verbosity=C={}))});var Ne=this&&this.__param||function(he,e){return function(o,C){e(o,C,he)}};define(ye[85],Ee([1,0,20,2,3,203,32,5]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=e.$Rr=void 0,e.$Qr=b;function b(y){return y.tags.find(v=>v.startsWith("lp-"))?.split("lp-")[1]}e.$Rr=(0,P.$wi)("languagePackService");let g=class extends C.$Vc{constructor(v){super(),this.c=v}async getAvailableLanguages(){const v=new o.$pe;setTimeout(()=>v.cancel(),1e3);let w;try{w=await this.c.query({text:'category:"language packs"',pageSize:20},v.token)}catch{return[]}const u=w.firstPage.filter(a=>a.properties.localizedLanguages?.length&&a.tags.some(f=>f.startsWith("lp-"))).map(a=>{const f=a.properties.localizedLanguages?.[0],c=b(a);return{...this.f(c,f,a),extensionId:a.identifier.id,galleryExtension:a}});return u.push(this.f("en","English")),u}f(v,w,m){const u=w??v;let a;if(u!==v&&(a=`(${v})`),v.toLowerCase()===S.$w.toLowerCase()&&(a??="",a+=(0,D.localize)(0,null)),m?.installCount){a??="";const f=m.installCount;let c;f>1e6?c=`${Math.floor(f/1e5)/10}M`:f>1e3?c=`${Math.floor(f/1e3)}K`:c=String(f),a+=` $(cloud-download) ${c}`}return{id:v,label:u,description:a}}};e.$Sr=g,e.$Sr=g=Le([Ne(0,I.$6o)],g)}),define(ye[12],Ee([1,0,204,39,6,62,2,24,3,19,10,4,47,5]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$6j=e.LogLevel=e.$4j=e.$3j=void 0,e.$5j=a,e.log=c,e.$ek=$,e.$fk=k,e.$gk=j,e.$hk=A,e.$3j=(0,m.$wi)("logService"),e.$4j=(0,m.$wi)("loggerService");function u(){return new Date().toISOString()}function a(O){return(0,y.$ag)(O)}var f;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$6j=f.Info;function c(O,F,V){switch(F){case f.Trace:O.trace(V);break;case f.Debug:O.debug(V);break;case f.Info:O.info(V);break;case f.Warning:O.warn(V);break;case f.Error:O.error(V);break;case f.Off:break;default:throw new Error(`Invalid log level ${F}`)}}function d(O,F=!1){let V="";for(let Z=0;Z<O.length;Z++){let oe=O[Z];if(oe instanceof Error&&(oe=(0,C.$hj)(oe,F)),typeof oe=="object")try{oe=JSON.stringify(oe)}catch{}V+=(Z>0?" ":"")+oe}return V}class p extends I.$Vc{constructor(){super(...arguments),this.b=e.$6j,this.c=this.B(new S.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(F){this.b!==F&&(this.b=F,this.c.fire(this.b))}getLevel(){return this.b}f(F){return this.b!==f.Off&&this.b<=F}}e.$8j=p;class E extends p{constructor(F){super(),this.h=F}f(F){return this.h||super.f(F)}trace(F,...V){this.f(f.Trace)&&this.g(f.Trace,d([F,...V],!0))}debug(F,...V){this.f(f.Debug)&&this.g(f.Debug,d([F,...V]))}info(F,...V){this.f(f.Info)&&this.g(f.Info,d([F,...V]))}warn(F,...V){this.f(f.Warning)&&this.g(f.Warning,d([F,...V]))}error(F,...V){if(this.f(f.Error))if(F instanceof Error){const Z=Array.prototype.slice.call(arguments);Z[0]=F.stack,this.g(f.Error,d(Z))}else this.g(f.Error,d([F,...V]))}flush(){}}e.$9j=E;class h extends p{constructor(F=e.$6j){super(),this.setLevel(F),this.g=!b.$i}trace(F,...V){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,F,...V):console.log(`[main ${u()}]`,F,...V))}debug(F,...V){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,F,...V):console.log(`[main ${u()}]`,F,...V))}info(F,...V){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,F,...V):console.log(`[main ${u()}]`,F,...V))}warn(F,...V){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,F,...V):console.warn(`[main ${u()}]`,F,...V))}error(F,...V){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,F,...V):console.error(`[main ${u()}]`,F,...V))}flush(){}}e.$0j=h;class t extends p{constructor(F=e.$6j,V=!0){super(),this.g=V,this.setLevel(F)}trace(F,...V){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",F,...V):console.log(F,...V))}debug(F,...V){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",F,...V):console.log(F,...V))}info(F,...V){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",F,...V):console.log(F,...V))}warn(F,...V){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",F,...V):console.log(F,...V))}error(F,...V){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",F,...V):console.error(F,...V))}flush(){}}e.$$j=t;class s extends p{constructor(F,V=e.$6j){super(),this.g=F,this.setLevel(V)}trace(F,...V){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(F),...V])}debug(F,...V){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(F),...V])}info(F,...V){this.f(f.Info)&&this.g.log(f.Info,[this.h(F),...V])}warn(F,...V){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(F),...V])}error(F,...V){this.f(f.Error)&&this.g.log(f.Error,[this.h(F),...V])}h(F){return typeof F=="string"?F:(0,C.$hj)(F,this.f(f.Trace))}flush(){}}e.$_j=s;class r extends p{constructor(F){super(),this.g=F,F.length&&this.setLevel(F[0].getLevel())}setLevel(F){for(const V of this.g)V.setLevel(F);super.setLevel(F)}trace(F,...V){for(const Z of this.g)Z.trace(F,...V)}debug(F,...V){for(const Z of this.g)Z.debug(F,...V)}info(F,...V){for(const Z of this.g)Z.info(F,...V)}warn(F,...V){for(const Z of this.g)Z.warn(F,...V)}error(F,...V){for(const Z of this.g)Z.error(F,...V)}flush(){for(const F of this.g)F.flush()}dispose(){for(const F of this.g)F.dispose();super.dispose()}}e.$ak=r;class i extends I.$Vc{constructor(F,V,Z){if(super(),this.h=F,this.j=V,this.b=new P.$Bc,this.c=this.B(new S.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new S.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new S.$ee),this.onDidChangeVisibility=this.g.event,Z)for(const oe of Z)this.b.set(oe.resource,{logger:void 0,info:oe})}m(F){return(0,y.$9f)(F)?[...this.b.values()].find(V=>V.info.id===F):this.b.get(F)}getLogger(F){return this.m(F)?.logger}createLogger(F,V){const Z=this.n(F),oe=(0,y.$9f)(F)?F:V?.id??(0,D.$kj)(Z.toString()).toString(16);let le=this.b.get(Z)?.logger;const te=V?.logLevel==="always"?f.Trace:V?.logLevel;le||(le=this.s(Z,te??this.getLogLevel(Z)??this.h,{...V,id:oe}));const _={logger:le,info:{resource:Z,id:oe,logLevel:te,name:V?.name,hidden:V?.hidden,extensionId:V?.extensionId,when:V?.when}};return this.registerLogger(_.info),this.b.set(Z,_),le}n(F){return(0,y.$9f)(F)?(0,g.$0g)(this.j,`${F}.log`):F}setLogLevel(F,V){if(v.URI.isUri(F)){const Z=F,oe=V,le=this.b.get(Z);le&&oe!==le.info.logLevel&&(le.info.logLevel=oe===this.h?void 0:oe,le.logger?.setLevel(oe),this.b.set(le.info.resource,le),this.f.fire([Z,oe]))}else{this.h=F;for(const[Z,oe]of this.b.entries())this.b.get(Z)?.info.logLevel===void 0&&oe.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(F,V){const Z=this.m(F);Z&&V!==!Z.info.hidden&&(Z.info.hidden=!V,this.b.set(Z.info.resource,Z),this.g.fire([Z.info.resource,V]))}getLogLevel(F){let V;return F&&(V=this.b.get(F)?.info.logLevel),V??this.h}registerLogger(F){const V=this.b.get(F.resource);V?V.info.hidden!==F.hidden&&this.setVisibility(F.resource,!F.hidden):(this.b.set(F.resource,{info:F,logger:void 0}),this.c.fire({added:[F],removed:[]}))}deregisterLogger(F){const V=this.b.get(F);V&&(V.logger&&V.logger.dispose(),this.b.delete(F),this.c.fire({added:[],removed:[V.info]}))}*getRegisteredLoggers(){for(const F of this.b.values())yield F.info}getRegisteredLogger(F){return this.b.get(F)?.info}dispose(){this.b.forEach(F=>F.logger?.dispose()),this.b.clear(),super.dispose()}}e.$bk=i;class n{constructor(){this.onDidChangeLogLevel=new S.$ee().event}setLevel(F){}getLevel(){return f.Info}trace(F,...V){}debug(F,...V){}info(F,...V){}warn(F,...V){}error(F,...V){}critical(F,...V){}dispose(){}flush(){}}e.$ck=n;class l extends n{}e.$dk=l;function $(O){if(O.verbose)return f.Trace;if(typeof O.logLevel=="string"){const F=A(O.logLevel.toLowerCase());if(F!==void 0)return F}return e.$6j}function k(O){switch(O){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}function j(O){switch(O){case f.Trace:return{original:"Trace",value:o.localize(0,null)};case f.Debug:return{original:"Debug",value:o.localize(1,null)};case f.Info:return{original:"Info",value:o.localize(2,null)};case f.Warning:return{original:"Warning",value:o.localize(3,null)};case f.Error:return{original:"Error",value:o.localize(4,null)};case f.Off:return{original:"Off",value:o.localize(5,null)}}}function A(O){switch(O){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$ik=new w.$Nj("logLevel",k(f.Info))}),define(ye[240],Ee([1,0,18,14,11,6,35,2,7,48,12]),function(he,e,o,C,S,D,I,P,b,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=void 0;class v extends P.$Vc{constructor(m,u){super(),this.a=m,this.b=u,this.c=this.B(new D.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new D.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$uh(0)),this.w=[],this.y=this.B(new C.$uh(0))}watch(m,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(m,u):this.z(m,u)}n(m,u){const a={path:this.J(m),excludes:u.excludes,includes:u.includes,recursive:u.recursive,filter:u.filter,correlationId:u.correlationId},f=(0,o.$Ub)(this.j,a);return this.r(),(0,P.$Tc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,S.$1)(m))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,g.$Oq)(u)),u=>this.G(u),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const u of this.j)(0,g.$Kq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const u of this.j)(0,g.$Kq)(u)&&m.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,u){const a={path:this.J(m),excludes:u.excludes,includes:u.includes,recursive:!1,filter:u.filter,correlationId:u.correlationId},f=(0,o.$Ub)(this.w,a);return this.C(),(0,P.$Tc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,S.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,g.$Oq)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,b.$ic)(m.fsPath)}J(m){const u=this.I(m);return(0,I.$yg)(u)}}e.$Uq=v}),define(ye[113],Ee([1,0,18,14,15,20,6,62,41,2,64,13,44,19,52,199,16,111,12,11]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Iq=void 0;let h=class extends g.$Vc{static{E=this}constructor(s){super(),this.b=s,this.a=256*1024,this.c=this.B(new I.$ee),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$ee),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$ee),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$ee),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$ee),this.Y=this.B(new I.$ee),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$ee),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$Fh)}registerProvider(s,r){if(this.h.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,w.mark)(`code/registerFilesystem/${s}`);const i=new g.$Uc;return this.h.set(s,r),this.c.fire({added:!0,scheme:s,provider:r}),i.add(r.onDidChangeFile(n=>{const l=new f.$jl(n,!this.S(r));this.X.fire(l),l.hasCorrelation()||this.Y.fire(l)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:s}))),(0,g.$Tc)(()=>{this.c.fire({added:!1,scheme:s,provider:r}),this.h.delete(s),(0,g.$Qc)(i)})}getProvider(s){return this.h.get(s)}async activateProvider(s){const r=[];this.f.fire({scheme:s,join(i){r.push(i)}}),!this.h.has(s)&&await C.Promises.settled(r)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.h.has(s.scheme)}hasCapability(s,r){const i=this.h.get(s.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return b.Iterable.map(this.h,([s,r])=>({scheme:s,capabilities:r.capabilities}))}async j(s){if(!(0,m.$bh)(s))throw new f.$ll((0,a.localize)(0,null,this.sb(s)),8);await this.activateProvider(s.scheme);const r=this.h.get(s.scheme);if(!r){const i=new p.$bb;throw i.message=(0,a.localize)(1,null,s.toString()),i}return r}async m(s){const r=await this.j(s);if((0,f.$9k)(r)||(0,f.$6k)(r)||(0,f.$0k)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(s){const r=await this.j(s);if((0,f.$9k)(r)||(0,f.$6k)(r))return r;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,r){try{return await this.s(s,r)}catch(i){throw(0,f.$gl)(i)===f.FileSystemProviderErrorCode.FileNotFound?new f.$ll((0,a.localize)(2,null,this.sb(s)),1):(0,f.$el)(i)}}async s(s,r){const i=await this.j(s),n=this.S(i),l=r?.resolveTo,$=r?.resolveSingleChildDescendants,k=r?.resolveMetadata,j=await i.stat(s);let A;return this.t(i,s,j,void 0,!!k,(O,F)=>(A||(A=y.$Ci.forUris(()=>!n),A.set(s,!0),l&&A.fill(!0,l)),A.get(O.resource)||A.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&$?F===1:!1))}async t(s,r,i,n,l,$){const{providerExtUri:k}=this.R(s),j={resource:r,name:k.basename(r),isFile:(i.type&f.FileType.File)!==0,isDirectory:(i.type&f.FileType.Directory)!==0,isSymbolicLink:(i.type&f.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&f.FilePermission.Readonly)||!!(s.capabilities&2048),locked:!!((i.permissions??0)&f.FilePermission.Locked),etag:(0,f.$wl)({mtime:i.mtime,size:i.size}),children:void 0};if(j.isDirectory&&$(j,n)){try{const A=await s.readdir(r),O=await C.Promises.settled(A.map(async([F,V])=>{try{const Z=k.joinPath(r,F),oe=l?await s.stat(Z):{type:V};return await this.t(s,Z,oe,A.length,l,$)}catch(Z){return this.b.trace(Z),null}}));j.children=(0,o.$Hb)(O)}catch(A){this.b.trace(A),j.children=[]}return j}return j}async resolveAll(s){return C.Promises.settled(s.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(s){const r=await this.j(s),i=await r.stat(s);return this.t(r,s,i,void 0,!0,()=>!1)}async exists(s){const r=await this.j(s);try{return!!await r.stat(s)}catch{return!1}}async canCreateFile(s,r){try{await this.u(s,r)}catch(i){return i}return!0}async u(s,r){if(!r?.overwrite&&await this.exists(s))throw new f.$ll((0,a.localize)(3,null,this.sb(s)),3,r)}async createFile(s,r=S.$Ge.fromString(""),i){await this.u(s,i);const n=await this.writeFile(s,r);return this.r.fire(new f.$il(s,0,n)),n}async writeFile(s,r,i){const n=this.qb(await this.n(s),s),{providerExtUri:l}=this.R(n);let $=i;if((0,f.$_k)(n)&&!$?.atomic){const k=n.enforceAtomicWriteFile?.(s);k&&($={...i,atomic:k})}try{await this.w(n,s,$)||await this.U(n,l.dirname(s));let j;if((0,f.$6k)(n)&&!(r instanceof S.$Ge))if((0,u.$se)(r)){const A=await(0,u.$ze)(r,3);A.ended?j=S.$Ge.concat(A.buffer):j=A}else j=(0,u.$we)(r,A=>S.$Ge.concat(A),3);else j=r;!(0,f.$9k)(n)||(0,f.$6k)(n)&&j instanceof S.$Ge||(0,f.$6k)(n)&&(0,f.$_k)(n)&&$?.atomic?await this.hb(n,s,$,j):await this.db(n,s,$,j instanceof S.$Ge?(0,S.$Re)(j):j),this.r.fire(new f.$il(s,4))}catch(k){throw new f.$ll((0,a.localize)(4,null,this.sb(s),(0,f.$el)(k).toString()),(0,f.$hl)(k),$)}return this.resolve(s,{resolveMetadata:!0})}async w(s,r,i){const n=!!i?.unlock;if(n&&!(s.capabilities&8192))throw new Error((0,a.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(s.capabilities&32768))throw new Error((0,a.localize)(6,null,this.sb(r)));if(!(s.capabilities&2))throw new Error((0,a.localize)(7,null,this.sb(r)));if(n)throw new Error((0,a.localize)(8,null,this.sb(r)))}let $;try{$=await s.stat(r)}catch{return}if($.type&f.FileType.Directory)throw new f.$ll((0,a.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,$),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==f.$vl&&typeof $.mtime=="number"&&typeof $.size=="number"&&i.mtime<$.mtime&&i.etag!==(0,f.$wl)({mtime:i.mtime,size:$.size}))throw new f.$ll((0,a.localize)(10,null),3,i);return $}async readFile(s,r,i){const n=await this.m(s);return r?.atomic?this.z(n,s,r,i):this.C(n,s,r,i)}async z(s,r,i,n){return new Promise((l,$)=>{this.cb.queueFor(r,async()=>{try{const k=await this.C(s,r,i,n);l(k)}catch(k){$(k)}},this.R(s).providerExtUri)})}async C(s,r,i,n){const l=await this.D(s,r,{...i,preferUnbuffered:!0},n);return{...l,value:await(0,S.$Se)(l.value)}}async readFileStream(s,r,i){const n=await this.m(s);return this.D(n,s,r,i)}async D(s,r,i,n){const l=new D.$pe(n);let $=i;(0,f.$$k)(s)&&s.enforceAtomicReadFile?.(r)&&($={...i,atomic:!0});const k=this.J(r,$).then(A=>A,A=>{throw l.dispose(!0),A});let j;try{return typeof $?.etag=="string"&&$.etag!==f.$vl&&await k,$?.atomic&&(0,f.$$k)(s)||!((0,f.$9k)(s)||(0,f.$0k)(s))||(0,f.$6k)(s)&&$?.preferUnbuffered?j=this.I(s,r,$):(0,f.$0k)(s)?j=this.G(s,r,l.token,$):j=this.H(s,r,l.token,$),j.on("end",()=>l.dispose()),j.on("error",()=>l.dispose()),{...await k,value:j}}catch(A){throw j&&await(0,u.$xe)(j),this.F(A,r,$)}}F(s,r,i){const n=(0,a.localize)(11,null,this.sb(r),(0,f.$el)(s).toString());return s instanceof f.$nl?new f.$nl(n,s.stat,i):s instanceof f.$ml?new f.$ml(n,s.fileOperationResult,s.size,s.options):new f.$ll(n,(0,f.$hl)(s),i)}G(s,r,i,n=Object.create(null)){const l=s.readFileStream(r,n,i);return(0,u.$De)(l,{data:$=>$ instanceof S.$Ge?$:S.$Ge.wrap($),error:$=>this.F($,r,n)},$=>S.$Ge.concat($))}H(s,r,i,n=Object.create(null)){const l=(0,S.$We)();return(0,c.$Hq)(s,r,l,$=>$,{...n,bufferSize:this.a,errorTransformer:$=>this.F($,r,n)},i),l}I(s,r,i){const n=(0,u.$ue)(l=>S.$Ge.concat(l));return(async()=>{try{let l;i?.atomic&&(0,f.$$k)(s)?l=await s.readFile(r,{atomic:!0}):l=await s.readFile(r),typeof i?.position=="number"&&(l=l.slice(i.position)),typeof i?.length=="number"&&(l=l.slice(0,i.length)),this.L(r,l.byteLength,i),n.end(S.$Ge.wrap(l))}catch(l){n.error(l),n.end()}})(),n}async J(s,r){const i=await this.resolve(s,{resolveMetadata:!0});if(i.isDirectory)throw new f.$ll((0,a.localize)(12,null,this.sb(s)),0,r);if(typeof r?.etag=="string"&&r.etag!==f.$vl&&r.etag===i.etag)throw new f.$nl((0,a.localize)(13,null),i,r);return this.L(s,i.size,r),i}L(s,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new f.$ml((0,a.localize)(14,null,this.sb(s)),7,r,i)}async canMove(s,r,i){return this.M(s,r,"move",i)}async canCopy(s,r,i){return this.M(s,r,"copy",i)}async M(s,r,i,n){if(s.toString()!==r.toString())try{const l=i==="move"?this.qb(await this.n(s),s):await this.m(s),$=this.qb(await this.n(r),r);await this.Q(l,s,$,r,i,n)}catch(l){return l}return!0}async move(s,r,i){const n=this.qb(await this.n(s),s),l=this.qb(await this.n(r),r),$=await this.N(n,s,l,r,"move",!!i),k=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new f.$il(s,$==="move"?2:3,k)),k}async copy(s,r,i){const n=await this.m(s),l=this.qb(await this.n(r),r),$=await this.N(n,s,l,r,"copy",!!i),k=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new f.$il(s,$==="copy"?3:2,k)),k}async N(s,r,i,n,l,$){if(r.toString()===n.toString())return l;const{exists:k,isSameResourceWithDifferentPathCase:j}=await this.Q(s,r,i,n,l,$);if(k&&!j&&$&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),l==="copy"){if(s===i&&(0,f.$7k)(s))await s.copy(r,n,{overwrite:$});else{const A=await this.resolve(r);A.isDirectory?await this.P(s,A,i,n):await this.O(s,r,i,n)}return l}else return s===i?(await s.rename(r,n,{overwrite:$}),l):(await this.N(s,r,i,n,"copy",$),await this.del(r,{recursive:!0}),"copy")}async O(s,r,i,n){if((0,f.$9k)(s)&&(0,f.$9k)(i))return this.jb(s,r,i,n);if((0,f.$9k)(s)&&(0,f.$6k)(i))return this.pb(s,r,i,n);if((0,f.$6k)(s)&&(0,f.$9k)(i))return this.nb(s,r,i,n);if((0,f.$6k)(s)&&(0,f.$6k)(i))return this.lb(s,r,i,n)}async P(s,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await C.Promises.settled(r.children.map(async l=>{const $=this.R(i).providerExtUri.joinPath(n,l.name);return l.isDirectory?this.P(s,await this.resolve(l.resource),i,$):this.O(s,l.resource,i,$)}))}async Q(s,r,i,n,l,$){let k=!1;if(s===i){const{providerExtUri:A,isPathCaseSensitive:O}=this.R(s);if(O||(k=A.isEqual(r,n)),k&&l==="copy")throw new Error((0,a.localize)(15,null,this.sb(r),this.sb(n)));if(!k&&A.isEqualOrParent(n,r))throw new Error((0,a.localize)(16,null,this.sb(r),this.sb(n)))}const j=await this.exists(n);if(j&&!k){if(!$)throw new f.$ll((0,a.localize)(17,null,this.sb(r),this.sb(n)),4);if(s===i){const{providerExtUri:A}=this.R(s);if(A.isEqualOrParent(r,n))throw new Error((0,a.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:j,isSameResourceWithDifferentPathCase:k}}R(s){const r=this.S(s);return{providerExtUri:r?m.$Zg:m.$2g,isPathCaseSensitive:r}}S(s){return!!(s.capabilities&1024)}async createFolder(s){const r=this.qb(await this.j(s),s);await this.U(r,s);const i=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new f.$il(s,0,i)),i}async U(s,r){const i=[],{providerExtUri:n}=this.R(s);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await s.stat(r)).type&f.FileType.Directory))throw new Error((0,a.localize)(19,null,this.sb(r)));break}catch(l){if((0,f.$gl)(l)!==f.FileSystemProviderErrorCode.FileNotFound)throw l;i.push(n.basename(r)),r=n.dirname(r)}for(let l=i.length-1;l>=0;l--){r=n.joinPath(r,i[l]);try{await s.mkdir(r)}catch($){if((0,f.$gl)($)!==f.FileSystemProviderErrorCode.FileExists)throw $}}}async canDelete(s,r){try{await this.W(s,r)}catch(i){return i}return!0}async W(s,r){const i=this.qb(await this.j(s),s),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,a.localize)(20,null,this.sb(s)));const l=r?.atomic;if(l&&!(i.capabilities&65536))throw new Error((0,a.localize)(21,null,this.sb(s)));if(n&&l)throw new Error((0,a.localize)(22,null,this.sb(s)));let $;try{$=await i.stat(s)}catch{}if($)this.rb(s,$);else throw new f.$ll((0,a.localize)(23,null,this.sb(s)),1);if(!!!r?.recursive){const j=await this.resolve(s);if(j.isDirectory&&Array.isArray(j.children)&&j.children.length>0)throw new Error((0,a.localize)(24,null,this.sb(s)))}return i}async del(s,r){const i=await this.W(s,r);let n=r;if((0,f.$al)(i)&&!n?.atomic){const j=i.enforceAtomicDelete?.(s);j&&(n={...r,atomic:j})}const l=!!n?.useTrash,$=!!n?.recursive,k=n?.atomic??!1;await i.delete(s,{recursive:$,useTrash:l,atomic:k}),this.r.fire(new f.$il(s,1))}async cloneFile(s,r){const i=await this.j(s),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(s,r)))return i===n&&(0,f.$8k)(i)?i.cloneFile(s,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,f.$7k)(i)?this.cb.queueFor(s,()=>i.copy(s,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(s,()=>this.O(i,s,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(s,r){return this.watch(s,{...r,correlationId:E.ab++})}watch(s,r={recursive:!1,excludes:[]}){const i=new g.$Uc;let n=!1,l=()=>{n=!0};i.add((0,g.$Tc)(()=>l())),(async()=>{try{const k=await this.bb(s,r);n?(0,g.$Qc)(k):l=()=>(0,g.$Qc)(k)}catch(k){this.b.error(k)}})();const $=r.correlationId;if(typeof $=="number"){const k=i.add(new I.$ee);return i.add(this.X.event(A=>{A.correlates($)&&k.fire(A)})),{onDidChange:k.event,dispose:()=>i.dispose()}}return i}async bb(s,r){const i=await this.j(s),n=(0,P.$kj)([this.R(i).providerExtUri.getComparisonKey(s),r]);let l=this.$.get(n);return l||(l={count:0,disposable:i.watch(s,r)},this.$.set(n,l)),l.count+=1,(0,g.$Tc)(()=>{l&&(l.count--,l.count===0&&((0,g.$Qc)(l.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,s]of this.$)(0,g.$Qc)(s.disposable);this.$.clear()}async db(s,r,i,n){return this.cb.queueFor(r,async()=>{const l=await s.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,u.$se)(n)||(0,u.$te)(n)?await this.eb(s,l,n):await this.fb(s,l,n)}catch($){throw(0,f.$el)($)}finally{await s.close(l)}},this.R(s).providerExtUri)}async eb(s,r,i){let n=0,l;if((0,u.$te)(i)){if(i.buffer.length>0){const $=S.$Ge.concat(i.buffer);await this.gb(s,r,$,$.byteLength,n,0),n+=$.byteLength}if(i.ended)return;l=i.stream}else l=i;return new Promise(($,k)=>{(0,u.$ye)(l,{onData:async j=>{l.pause();try{await this.gb(s,r,j,j.byteLength,n,0)}catch(A){return k(A)}n+=j.byteLength,setTimeout(()=>l.resume())},onError:j=>k(j),onEnd:()=>$()})})}async fb(s,r,i){let n=0,l;for(;(l=i.read())!==null;)await this.gb(s,r,l,l.byteLength,n,0),n+=l.byteLength}async gb(s,r,i,n,l,$){let k=0;for(;k<n;){const j=await s.write(r,l+k,i.buffer,$+k,n-k);k+=j}}async hb(s,r,i,n){return this.cb.queueFor(r,()=>this.ib(s,r,i,n),this.R(s).providerExtUri)}async ib(s,r,i,n){let l;n instanceof S.$Ge?l=n:(0,u.$se)(n)?l=await(0,S.$Se)(n):(0,u.$te)(n)?l=await(0,S.$Te)(n):l=(0,S.$Qe)(n),await s.writeFile(r,l.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(s,r,i,n){return this.cb.queueFor(n,()=>this.kb(s,r,i,n),this.R(i).providerExtUri)}async kb(s,r,i,n){let l,$;try{l=await s.open(r,{create:!1}),$=await i.open(n,{create:!0,unlock:!1});const k=S.$Ge.alloc(this.a);let j=0,A=0,O=0;do O=await s.read(l,j,k.buffer,A,k.byteLength-A),await this.gb(i,$,k,O,j,A),j+=O,A+=O,A===k.byteLength&&(A=0);while(O>0)}catch(k){throw(0,f.$el)(k)}finally{await C.Promises.settled([typeof l=="number"?s.close(l):Promise.resolve(),typeof $=="number"?i.close($):Promise.resolve()])}}async lb(s,r,i,n){return this.cb.queueFor(n,()=>this.mb(s,r,i,n),this.R(i).providerExtUri)}async mb(s,r,i,n){return i.writeFile(n,await s.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(s,r,i,n){return this.cb.queueFor(n,()=>this.ob(s,r,i,n),this.R(i).providerExtUri)}async ob(s,r,i,n){const l=await i.open(n,{create:!0,unlock:!1});try{const $=await s.readFile(r);await this.gb(i,l,S.$Ge.wrap($),$.byteLength,0,0)}catch($){throw(0,f.$el)($)}finally{await i.close(l)}}async pb(s,r,i,n){const l=await(0,S.$Se)(this.H(s,r,D.CancellationToken.None));await this.hb(i,n,void 0,l)}qb(s,r){if(s.capabilities&2048)throw new f.$ll((0,a.localize)(25,null,this.sb(r)),6);return s}rb(s,r){if((r.permissions??0)&f.FilePermission.Readonly)throw new f.$ll((0,a.localize)(26,null,this.sb(s)),6)}sb(s){return s.scheme===v.Schemas.file?s.fsPath:s.toString(!0)}};e.$Iq=h,e.$Iq=h=E=Le([Ne(0,d.$3j)],h)}),define(ye[69],Ee([1,0,27,313,14,24,15,6,35,2,7,3,19,52,23,202,16,111,240,39,238,237]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_q=void 0,(()=>{try{(0,C.gracefulify)(o)}catch(s){console.error(`Error enabling graceful-fs: ${(0,p.$hj)(s)}`)}})();class t extends d.$Uq{static{this.L=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=P.Event.None,this.P=new D.$Bc(n=>w.$1g.getComparisonKey(n)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,v.$k&&(this.M|=1024)),this.M}async stat(r){try{const{stat:i,symbolicLink:n}=await u.SymlinkSupport.stat(this.I(r));return{type:this.O(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:f.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await u.Promises.readdir(this.I(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async l=>{try{let $;l.isSymbolicLink()?$=(await this.stat((0,w.$0g)(r,l.name))).type:$=this.O(l),n.push([l.name,$])}catch($){this.a.trace($)}})),n}catch(i){throw this.hb(i)}}O(r,i){let n;return i?.dangling?n=f.FileType.Unknown:r.isFile()?n=f.FileType.File:r.isDirectory()?n=f.FileType.Directory:n=f.FileType.Unknown,i&&(n|=f.FileType.SymbolicLink),n}async Q(r){const i=this.I(r);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.P.get(r);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const l=new S.$vh;return this.P.set(r,l),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,g.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(r)===l&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(r)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(r)})`),n=await this.Q(r));const l=this.I(r);return await u.Promises.readFile(l)}catch(l){throw this.hb(l)}finally{n?.dispose()}}R(r){t.L&&this.a.trace(r)}readFileStream(r,i,n){const l=(0,m.$ue)($=>I.$Ge.concat($.map(k=>I.$Ge.wrap(k))).buffer);return(0,c.$Hq)(this,r,l,$=>$.buffer,{...i,bufferSize:256*1024},n),l}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.S(r)?this.U(r,(0,w.$0g)((0,w.$9g)(r),`${(0,w.$7g)(r)}${n.atomic.postfix}`),i,n):this.W(r,i,n)}async S(r){try{const i=this.I(r),{symbolicLink:n}=await u.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async U(r,i,n,l){const $=new g.$Uc;try{$.add(await this.Q(r)),$.add(await this.Q(i)),await this.W(i,n,l,!0);try{await this.rename(i,r,{overwrite:!0})}catch(k){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw k}}finally{$.dispose()}}async W(r,i,n,l){let $;try{const k=this.I(r);if(!n.create||!n.overwrite){if(await u.Promises.exists(k)){if(!n.overwrite)throw(0,f.$dl)((0,a.localize)(0,null),f.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,f.$dl)((0,a.localize)(1,null),f.FileSystemProviderErrorCode.FileNotFound)}$=await this.open(r,{create:!0,unlock:n.unlock},l),await this.write($,0,i,0,i.byteLength)}catch(k){throw await this.ib(r,k)}finally{typeof $=="number"&&await this.close($)}}static{this.$=!0}static configureFlushOnWrite(r){t.$=r}async open(r,i,n){const l=this.I(r);let $;(0,f.$4k)(i)&&!n&&($=await this.Q(r));let k;try{if((0,f.$4k)(i)&&i.unlock)try{const{stat:A}=await u.SymlinkSupport.stat(l);A.mode&128||await u.Promises.chmod(l,A.mode|128)}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}let j;if((0,f.$4k)(i)){if(v.$i)try{await u.Promises.truncate(l,0),j="r+"}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}j||(j="w")}else j="r";k=await u.Promises.open(l,j)}catch(j){throw $?.dispose(),(0,f.$4k)(i)?await this.ib(r,j):this.hb(j)}if(this.X.set(k,0),(0,f.$4k)(i)&&this.Z.set(k,r),$){const j=this.Y.get(k);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${k} (${l})`),this.Y.set(k,$),j&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${k} (${l})`),j.dispose())}return k}async close(r){const i=this.Y.get(r);try{if(this.X.delete(r),this.Z.delete(r)&&t.$)try{await u.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await u.Promises.close(r)}catch(n){throw this.hb(n)}finally{i&&(this.Y.get(r)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.Y.delete(r)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,l,$){const k=this.ab(r,i);let j=null;try{j=(await u.Promises.read(r,n,l,$,k)).bytesRead}catch(A){throw this.hb(A)}finally{this.bb(r,k,j)}return j}ab(r,i){return i===this.X.get(r)?null:i}bb(r,i,n){const l=this.X.get(r);typeof l=="number"&&(typeof i=="number"||(typeof n=="number"?this.X.set(r,l+n):this.X.delete(r)))}async write(r,i,n,l,$){return(0,S.$Qh)(()=>this.cb(r,i,n,l,$),100,3)}async cb(r,i,n,l,$){const k=this.ab(r,i);let j=null;try{j=(await u.Promises.write(r,n,l,$,k)).bytesWritten}catch(A){throw await this.ib(this.Z.get(r),A)}finally{this.bb(r,k,j)}return j}async mkdir(r){try{await u.Promises.mkdir(this.I(r))}catch(i){throw this.hb(i)}}async delete(r,i){try{const n=this.I(r);if(i.recursive){let l;i?.atomic!==!1&&i.atomic.postfix&&(l=(0,y.$kc)((0,y.$nc)(n),`${(0,y.$oc)(n)}${i.atomic.postfix}`)),await u.Promises.rm(n,u.RimRafMode.MOVE,l)}else try{await u.Promises.unlink(n)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let $=!1;try{const{stat:k,symbolicLink:j}=await u.SymlinkSupport.stat(n);$=k.isDirectory()&&!j}catch{}if($)await u.Promises.rmdir(n);else throw l}else throw l}}catch(n){throw this.hb(n)}}async rename(r,i,n){const l=this.I(r),$=this.I(i);if(l!==$)try{await this.db(r,i,"move",n.overwrite),await u.Promises.rename(l,$)}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,a.localize)(2,null,(0,y.$oc)(l),(0,y.$oc)((0,y.$nc)($)),k.toString()))),this.hb(k)}}async copy(r,i,n){const l=this.I(r),$=this.I(i);if(l!==$)try{await this.db(r,i,"copy",n.overwrite),await u.Promises.copy(l,$,{preserveSymlinks:!0})}catch(k){throw(k.code==="EINVAL"||k.code==="EBUSY"||k.code==="ENAMETOOLONG")&&(k=new Error((0,a.localize)(3,null,(0,y.$oc)(l),(0,y.$oc)((0,y.$nc)($)),k.toString()))),this.hb(k)}}async db(r,i,n,l){const $=this.I(r),k=this.I(i);let j=!1;if(!!(this.capabilities&1024)||(j=(0,b.$ug)($,k,!0)),j){if(n==="copy")throw(0,f.$dl)((0,a.localize)(4,null),f.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const O=await this.N(r);if(!O)throw(0,f.$dl)((0,a.localize)(5,null),f.FileSystemProviderErrorCode.FileNotFound);const F=await this.N(i);if(F){if(!l)throw(0,f.$dl)((0,a.localize)(6,null),f.FileSystemProviderErrorCode.FileExists);O.type&f.FileType.File&&F.type&f.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.eb(r,i,!1)}async eb(r,i,n){const l=this.I(r),$=this.I(i),k=!!(this.capabilities&1024);if((0,b.$ug)(l,$,!k))return;const j=new g.$Uc;try{j.add(await this.Q(r)),j.add(await this.Q(i)),n&&await u.Promises.mkdir((0,y.$nc)($),{recursive:!0}),await u.Promises.copyFile(l,$)}catch(A){if(A.code==="ENOENT"&&!n)return this.eb(r,i,!0);throw this.hb(A)}finally{j.dispose()}}t(r,i,n){return new E.$2q(l=>r(l),l=>i(l),n)}F(r,i,n){return new h.$$q(l=>r(l),l=>i(l),n)}hb(r){if(r instanceof f.$cl)return r;let i=r,n;switch(r.code){case"ENOENT":n=f.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=f.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=f.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=f.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=f.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=f.FileSystemProviderErrorCode.Unknown;break;default:n=f.FileSystemProviderErrorCode.Unknown}return(0,f.$dl)(i,n)}async ib(r,i){let n=this.hb(i);if(r&&n.code===f.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await u.SymlinkSupport.stat(this.I(r));l.mode&128||(n=(0,f.$dl)(i,f.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return n}}e.$_q=t}),define(ye[241],Ee([1,0,6,69,2,15,52,20]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ks=e.$Js=void 0;class b extends S.$Vc{constructor(v,w){super(),this.a=v,this.b=w,this.F=new Map,this.G=new Map}call(v,w,m){const u=this.c(v);switch(w){case"stat":return this.g(u,m[0]);case"readdir":return this.h(u,m[0]);case"open":return this.r(u,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(u,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(u,m[0],m[1],m[2]);case"rename":return this.z(u,m[0],m[1],m[2]);case"copy":return this.C(u,m[0],m[1],m[2]);case"cloneFile":return this.D(u,m[0],m[1]);case"mkdir":return this.w(u,m[0]);case"delete":return this.y(u,m[0],m[1]);case"watch":return this.I(u,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${w} not found`)}listen(v,w,m){const u=this.c(v);switch(w){case"fileChange":return this.H(u,m[0]);case"readFileStream":return this.m(u,m[0],m[1])}throw new Error(`Unknown event ${w}`)}g(v,w){const m=this.f(v,w,!0);return this.a.stat(m)}h(v,w){const m=this.f(v,w);return this.a.readdir(m)}async j(v,w,m){const u=this.f(v,w,!0),a=await this.a.readFile(u,m);return D.$Ge.wrap(a)}m(v,w,m){const u=this.f(v,w,!0),a=new P.$pe,f=new o.$ee({onDidRemoveLastListener:()=>{a.cancel()}}),c=this.a.readFileStream(u,m,a.token);return(0,I.$ye)(c,{onData:d=>f.fire(D.$Ge.wrap(d)),onError:d=>f.fire(d),onEnd:()=>{f.fire("end"),f.dispose(),a.dispose()}}),f.event}n(v,w,m,u){const a=this.f(v,w);return this.a.writeFile(a,m.buffer,u)}r(v,w,m){const u=this.f(v,w,!0);return this.a.open(u,m)}s(v){return this.a.close(v)}async t(v,w,m){const u=D.$Ge.alloc(m),f=await this.a.read(v,w,u.buffer,0,m);return[u,f]}u(v,w,m,u,a){return this.a.write(v,w,m.buffer,u,a)}w(v,w){const m=this.f(v,w);return this.a.mkdir(m)}y(v,w,m){const u=this.f(v,w);return this.a.delete(u,m)}z(v,w,m,u){const a=this.f(v,w),f=this.f(v,m);return this.a.rename(a,f,u)}C(v,w,m,u){const a=this.f(v,w),f=this.f(v,m);return this.a.copy(a,f,u)}D(v,w,m){const u=this.f(v,w),a=this.f(v,m);return this.a.cloneFile(u,a)}H(v,w){const m=new o.$ee({onWillAddFirstListener:()=>{this.F.set(w,this.L(v,m))},onDidRemoveLastListener:()=>{(0,S.$Qc)(this.F.get(w)),this.F.delete(w)}});return m.event}async I(v,w,m,u,a){const f=this.F.get(w);if(f){const c=this.f(v,u),d=f.watch(m,c,a);this.G.set(w+m,d)}}async J(v,w){const m=v+w,u=this.G.get(m);u&&((0,S.$Qc)(u),this.G.delete(m))}dispose(){super.dispose();for(const[,v]of this.G)v.dispose();this.G.clear();for(const[,v]of this.F)v.dispose();this.F.clear()}}e.$Js=b;class g extends S.$Vc{constructor(v,w,m,u){super(),this.c=v,this.f=m,this.g=u,this.a=new Map,this.b=this.B(new C.$_q(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(w)}h(v){const w=this.B(new o.$ee);this.B(w.event(m=>{v.fire(m.map(u=>({resource:this.c.transformOutgoingURI(u.resource),type:u.type,cId:u.cId})))})),this.B(this.b.onDidChangeFile(m=>w.fire(m))),this.B(this.b.onDidWatchError(m=>v.fire(m)))}j(v){}m(v){}watch(v,w,m){const u=this.m(this.g);return Array.isArray(u)&&(m.excludes=[...m.excludes,...u]),this.a.set(v,this.b.watch(w,m)),(0,S.$Tc)(()=>{(0,S.$Qc)(this.a.get(v)),this.a.delete(v)})}dispose(){for(const[,v]of this.a)v.dispose();this.a.clear(),super.dispose()}}e.$Ks=g}),define(ye[114],Ee([1,0,4,6,12,2]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=e.$as=e.$_r=void 0;class I extends S.$bk{constructor(v,w,m,u,a){super(w,m,u),this.r=v,this.t=a,this.B(a.listen("onDidChangeLogLevel",v)(f=>{(0,S.$5j)(f)?super.setLogLevel(f):super.setLogLevel(o.URI.revive(f[0]),f[1])})),this.B(a.listen("onDidChangeVisibility",v)(([f,c])=>super.setVisibility(o.URI.revive(f),c))),this.B(a.listen("onDidChangeLoggers",v)(({added:f,removed:c})=>{for(const d of f)super.registerLogger({...d,resource:o.URI.revive(d.resource)});for(const d of c)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new S.$_j({log:(v,w)=>{this.t.call("consoleLog",[v,w])}})}registerLogger(v){super.registerLogger(v),this.t.call("registerLogger",[v,this.r])}deregisterLogger(v){super.deregisterLogger(v),this.t.call("deregisterLogger",[v,this.r])}setLogLevel(v,w){super.setLogLevel(v,w),this.t.call("setLogLevel",[v,w])}setVisibility(v,w){super.setVisibility(v,w),this.t.call("setVisibility",[this.n(v),w])}s(v,w,m){return new P(this.t,v,w,m,this.r)}static setLogLevel(v,w,m){return v.call("setLogLevel",[w,m])}}e.$_r=I;class P extends S.$9j{constructor(v,w,m,u,a){super(u?.logLevel==="always"),this.r=v,this.s=w,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[w,u,a]).then(()=>{this.u(this.n),this.m=!0})}g(v,w){const m=[[v,w]];this.m?this.u(m):this.n.push(...m)}u(v){this.r.call("log",[this.s,v])}}class b{constructor(v,w){this.a=v,this.b=w}listen(v,w){const m=this.b(v);switch(w){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,u=>({added:[...u.added].map(a=>this.c(a,m)),removed:[...u.removed].map(a=>this.c(a,m))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,u=>[m.transformOutgoingURI(u[0]),u[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,u=>(0,S.$5j)(u)?u:[m.transformOutgoingURI(u[0]),u[1]])}throw new Error(`Event not found: ${w}`)}async call(v,w,m){const u=this.b(v);switch(w){case"setLogLevel":return(0,S.$5j)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(o.URI.revive(u.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(a=>this.c(a,u)))}throw new Error(`Call not found: ${w}`)}c(v,w){return{...v,resource:w.transformOutgoingURI(v.resource)}}}e.$as=b;class g extends D.$Vc{constructor(v,w){super(),w.call("setLogLevel",[v.getLogLevel()]),this.B(v.onDidChangeLogLevel(m=>w.call("setLogLevel",[m]))),w.call("getRegisteredLoggers").then(m=>{for(const u of m)v.registerLogger({...u,resource:o.URI.revive(u.resource)})}),this.B(w.listen("onDidChangeVisibility")(([m,u])=>v.setVisibility(o.URI.revive(m),u))),this.B(w.listen("onDidChangeLoggers")(({added:m,removed:u})=>{for(const a of m)v.registerLogger({...a,resource:o.URI.revive(a.resource)});for(const a of u)v.deregisterLogger(a.resource)}))}}e.$bs=g}),define(ye[115],Ee([1,0,2,12]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UQ=void 0;class S extends o.$Vc{constructor(I,P=[]){super(),this.a=new C.$ak([I,...P]),this.B(I.onDidChangeLogLevel(b=>this.setLevel(b)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...P){this.a.trace(I,...P)}debug(I,...P){this.a.debug(I,...P)}info(I,...P){this.a.info(I,...P)}warn(I,...P){this.a.warn(I,...P)}error(I,...P){this.a.error(I,...P)}flush(){this.a.flush()}}e.$UQ=S}),define(ye[242],Ee([1,0,16,12]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=void 0;var S;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(S||(S={}));async function D(g,y,v,w,m){try{const u=await new Promise((f,c)=>{he(["@vscode/spdlog"],f,c)});u.setFlushOn(S.Trace);const a=await u.createAsyncRotatingLogger(g,y,v,w);return m?a.clearFormatters():a.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),a}catch(u){console.error(u)}return null}function I(g,y,v){switch(y){case C.LogLevel.Trace:g.trace(v);break;case C.LogLevel.Debug:g.debug(v);break;case C.LogLevel.Info:g.info(v);break;case C.LogLevel.Warning:g.warn(v);break;case C.LogLevel.Error:g.error(v);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${y}`)}}function P(g,y){switch(y){case C.LogLevel.Trace:g.setLevel(S.Trace);break;case C.LogLevel.Debug:g.setLevel(S.Debug);break;case C.LogLevel.Info:g.setLevel(S.Info);break;case C.LogLevel.Warning:g.setLevel(S.Warning);break;case C.LogLevel.Error:g.setLevel(S.Error);break;case C.LogLevel.Off:g.setLevel(S.Off);break;default:throw new Error(`Invalid log level ${y}`)}}class b extends C.$9j{constructor(y,v,w,m,u){super(),this.m=[],this.setLevel(u),this.n=this.s(y,v,w,m),this.B(this.onDidChangeLogLevel(a=>{this.r&&P(this.r,a)}))}async s(y,v,w,m){const u=w?6:1,a=30/u*o.$yl.MB,f=await D(y,v,a,u,m);if(f){this.r=f,P(this.r,this.getLevel());for(const{level:c,message:d}of this.m)I(this.r,c,d);this.m=[]}}g(y,v){this.r?I(this.r,y,v):this.getLevel()<=y&&this.m.push({level:y,message:v})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$JQ=b}),define(ye[116],Ee([1,0,22,12,242]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KQ=void 0;class D extends C.$bk{s(P,b,g){return new S.$JQ((0,o.$Sg)(),P.fsPath,!g?.donotRotate,!!g?.donotUseFormatters,b)}}e.$KQ=D}),define(ye[243],Ee([1,0,63,205,5]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(b){b[b.Unnecessary=1]="Unnecessary",b[b.Deprecated=2]="Deprecated"})(D||(e.MarkerTag=D={}));var I;(function(b){b[b.Hint=1]="Hint",b[b.Info=2]="Info",b[b.Warning=4]="Warning",b[b.Error=8]="Error"})(I||(e.MarkerSeverity=I={})),function(b){function g(u,a){return a-u}b.compare=g;const y=Object.create(null);y[b.Error]=(0,C.localize)(0,null),y[b.Warning]=(0,C.localize)(1,null),y[b.Info]=(0,C.localize)(2,null);function v(u){return y[u]||""}b.toString=v;function w(u){switch(u){case o.default.Error:return b.Error;case o.default.Warning:return b.Warning;case o.default.Info:return b.Info;case o.default.Ignore:return b.Hint}}b.fromSeverity=w;function m(u){switch(u){case b.Error:return o.default.Error;case b.Warning:return o.default.Warning;case b.Info:return o.default.Info;case b.Hint:return o.default.Ignore}}b.toSeverity=m}(I||(e.MarkerSeverity=I={}));var P;(function(b){const g="";function y(w){return v(w,!0)}b.makeKey=y;function v(w,m){const u=[g];return w.source?u.push(w.source.replace("\xA6","\\\xA6")):u.push(g),w.code?typeof w.code=="string"?u.push(w.code.replace("\xA6","\\\xA6")):u.push(w.code.value.replace("\xA6","\\\xA6")):u.push(g),w.severity!==void 0&&w.severity!==null?u.push(I.toString(w.severity)):u.push(g),w.message&&m?u.push(w.message.replace("\xA6","\\\xA6")):u.push(g),w.startLineNumber!==void 0&&w.startLineNumber!==null?u.push(w.startLineNumber.toString()):u.push(g),w.startColumn!==void 0&&w.startColumn!==null?u.push(w.startColumn.toString()):u.push(g),w.endLineNumber!==void 0&&w.endLineNumber!==null?u.push(w.endLineNumber.toString()):u.push(g),w.endColumn!==void 0&&w.endColumn!==null?u.push(w.endColumn.toString()):u.push(g),u.push(g),u.join("\xA6")}b.makeKeyOptionalMessage=v})(P||(e.IMarkerData=P={})),e.$7t=(0,S.$wi)("markerService")}),define(ye[70],Ee([1,0,6,41,2,5]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=e.$fo=e.$eo=void 0,e.$eo=(0,D.$wi)("policy");class I extends S.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new o.$ee),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const y=Object.keys(this.f).length;return this.f={...g,...this.f},y!==Object.keys(this.f).length&&await this.j(g),C.Iterable.reduce(this.g.entries(),(v,[w,m])=>({...v,[w]:m}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(g,[y,v])=>({...g,[y]:{definition:v,value:this.g.get(y)}}),{})}}e.$fo=I;class P{constructor(){this.onDidChange=o.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$go=P}),define(ye[58],Ee([1,0,31]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const S=globalThis.vscode;if(typeof S<"u"&&typeof S.context<"u"){const D=S.context.configuration();if(D)C=D.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,o.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const D=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:D.version})}}else C={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"vscode",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",serverGreeting:[],serverLicense:["*","* Visual Studio Code Server","*","* By using the software, you agree to","* the Visual Studio Code Server License Terms (https://aka.ms/vscode-server-license) and","* the Microsoft Privacy Statement (https://privacy.microsoft.com/en-US/privacystatement).","*"],serverLicensePrompt:"Do you accept the terms in the License Agreement (Y/n)?",serverApplicationName:"code-server",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webUrl:"https://vscode.dev",webEndpointUrl:"https://main.vscode-cdn.net",webEndpointUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",quality:"stable",extensionsGallery:{nlsBaseUrl:"https://www.vscode-unpkg.net/_lp/",serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",itemUrl:"https://marketplace.visualstudio.com/items",publisherUrl:"https://marketplace.visualstudio.com/publishers",resourceUrlTemplate:"https://{publisher}.vscode-unpkg.net/{publisher}/{name}/{version}/{path}",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json"},profileTemplatesUrl:"https://az764295.vo.msecnd.net/profile-templates/profile-templates.json",extensionRecommendations:{"ms-dotnettools.csdevkit":{onFileOpen:[{pathGlob:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}",important:!0},{languages:["csharp"],important:!0},{pathGlob:"{**/project.json,**/appsettings.json}"}]},"ms-python.python":{onFileOpen:[{pathGlob:"{**/*.py}",important:!0},{languages:["python"],important:!0},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.jupyter":{onFileOpen:[{pathGlob:"{**/*.py}",contentPattern:"^#\\s*%%$",important:!0,whenInstalled:["ms-python.python"]},{pathGlob:"{**/*.ipynb}"}]},"ms-toolsai.datawrangler":{onFileOpen:[{pathGlob:"{**/*.ipynb}",contentPattern:"import\\s*pandas|from\\s*pandas",whenInstalled:["ms-toolsai.jupyter"]}]},"golang.Go":{onFileOpen:[{pathGlob:"**/*.go",important:!0},{languages:["go"],important:!0}]},"vscjava.vscode-java-pack":{onFileOpen:[{pathGlob:"{**/*.java}",important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},{languages:["java"],important:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}]},"ms-vscode.PowerShell":{onFileOpen:[{pathGlob:"{**/*.ps1,**/*.psd1,**/*.psm1}",important:!0},{languages:["powershell"],important:!0},{pathGlob:"{**/*.ps.config,**/*.ps1.config}"}]},"ms-vscode.cpptools-extension-pack":{onFileOpen:[{pathGlob:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}",important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]},{languages:["c","cpp"],important:!0,whenNotInstalled:["llvm-vs-code-extensions.vscode-clangd"]}]},"ms-azuretools.vscode-docker":{onFileOpen:[{pathGlob:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}",important:!0},{languages:["dockerfile"],important:!0},{pathGlob:"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}"}]},"vue.volar":{onFileOpen:[{pathGlob:"{**/*.vue}",important:!0},{languages:["vue"],important:!0}]},"ms-vscode.makefile-tools":{onFileOpen:[{pathGlob:"{**/makefile,**/Makefile}",important:!0},{languages:["makefile"],important:!0}]},"ms-vscode.cmake-tools":{onFileOpen:[{pathGlob:"{**/CMakeLists.txt}",important:!0}]},"ms-azure-devops.azure-pipelines":{onFileOpen:[{pathGlob:"{**/azure-pipelines.yaml}",important:!0}]},"msazurermtools.azurerm-vscode-tools":{onFileOpen:[{pathGlob:"{**/azuredeploy.json}",important:!0}]},"ms-vscode-remote.remote-containers":{onFileOpen:[{pathGlob:"{**/devcontainer.json}",important:!0}]},"ms-azuretools.vscode-bicep":{onFileOpen:[{pathGlob:"{**/*.bicep}",important:!0,whenNotInstalled:["ms-azuretools.rad-vscode-bicep"]}]},"svelte.svelte-vscode":{onFileOpen:[{pathGlob:"{**/*.svelte}",important:!0}]},"ms-vscode.vscode-github-issue-notebooks":{onFileOpen:[{pathGlob:"{**/*.github-issues}",important:!0}]},"ms-playwright.playwright":{onFileOpen:[{pathGlob:"{**/*playwright*.config.ts,**/*playwright*.config.js,**/*playwright*.config.mjs}",important:!0}]},"vscjava.vscode-gradle":{onFileOpen:[{pathGlob:"{**/gradlew,**/gradlew.bat,**/build.gradle,**/build.gradle.kts,**/settings.gradle,**/settings.gradle.kts}",important:!0}]},"REditorSupport.r":{onFileOpen:[{pathGlob:"{**/*.r}",important:!0},{languages:["r"],important:!0}]},"firefox-devtools.vscode-firefox-debug":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}"}]},"ms-edgedevtools.vscode-edge-devtools":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.css,**/*.html}"}]},"Ionide.Ionide-fsharp":{onFileOpen:[{pathGlob:"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}"}]},"dbaeumer.vscode-eslint":{onFileOpen:[{pathGlob:"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}"}]},"bmewburn.vscode-intelephense-client":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"xdebug.php-debug":{onFileOpen:[{pathGlob:"{**/*.php,**/php.ini}"}]},"rust-lang.rust-analyzer":{onFileOpen:[{pathGlob:"{**/*.rs,**/*.rslib}"}]},"DavidAnson.vscode-markdownlint":{onFileOpen:[{pathGlob:"{**/*.md}"}]},"EditorConfig.EditorConfig":{onFileOpen:[{pathGlob:"{**/.editorconfig}"}]},"HookyQR.beautify":{onFileOpen:[{pathGlob:"{**/.jsbeautifyrc}"}]},"donjayamanne.githistory":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"eamodio.gitlens":{onFileOpen:[{pathGlob:"{**/.gitignore,**/.git}"}]},"Shopify.ruby-lsp":{onFileOpen:[{pathGlob:"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}"}]},"DotJoshJohnson.xml":{onFileOpen:[{pathGlob:"{**/*.xml}"}]},"stylelint.vscode-stylelint":{onFileOpen:[{pathGlob:"{**/.stylelintrc,**/stylelint.config.js}"}]},"ms-mssql.mssql":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"mtxr.sqltools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"usqlextpublisher.usql-vscode-ext":{onFileOpen:[{pathGlob:"{**/*.usql}"}]},"ms-vscode.sublime-keybindings":{onFileOpen:[{pathGlob:"{**/.sublime-project,**/.sublime-workspace}"}]},"k--kato.intellij-idea-keybindings":{onFileOpen:[{pathGlob:"{**/.idea}"}]},"christian-kohler.npm-intellisense":{onFileOpen:[{pathGlob:"{**/package.json}"}]},"cake-build.cake-vscode":{onFileOpen:[{pathGlob:"{**/build.cake}"}]},"Angular.ng-template":{onFileOpen:[{pathGlob:"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}"}]},"vscjava.vscode-maven":{onFileOpen:[{pathGlob:"**/pom.xml"}]},"ms-azuretools.vscode-azureterraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"HashiCorp.terraform":{onFileOpen:[{pathGlob:"**/*.tf"}]},"vsciot-vscode.vscode-arduino":{onFileOpen:[{pathGlob:"**/*.ino"}]},"ms-kubernetes-tools.vscode-kubernetes-tools":{onFileOpen:[{pathGlob:"{**/Chart.yaml}"}]},"Oracle.oracledevtools":{onFileOpen:[{pathGlob:"{**/*.sql}"}]},"betterthantomorrow.calva":{onFileOpen:[{pathGlob:"{**/*.clj,**/*.cljs}"}]},"vmware.vscode-boot-dev-pack":{onFileOpen:[{pathGlob:"{**/application.properties}"}]},"GitHub.copilot":{onFileOpen:[{pathGlob:"{**/*.ts,**/*.tsx,**/*.js,**/*.py,**/*.go,**/*.rb}"}],onSettingsEditorOpen:{}},"GitHub.vscode-github-actions":{onFileOpen:[{pathGlob:"{**/.github/workflows/*.yml}",important:!0}]},"circleci.circleci":{onFileOpen:[{pathGlob:"{**/.circleci/config.yml}"}]},"mechatroner.rainbow-csv":{onFileOpen:[{pathGlob:"**/*.csv",important:!0}]},"tomoki1207.pdf":{onFileOpen:[{pathGlob:"**/*.pdf",important:!0}]}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","lfs.vscode-emacs-friendly","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools-extension-pack","ms-dotnettools.csdevkit","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","vue.volar","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust-analyzer","Shopify.ruby-lsp","GitHub.copilot"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",contentPattern:"^\\s*url\\s*=\\s*https:\\/\\/github\\.com.*$"},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]},"vmware.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"github-pull-request":{configPath:".vscode/.github-pull-request.rec",configName:"GitHub",configScheme:"vscode-vfs",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",important:!0}}},"pyproject-formatter":{configPath:"pyproject.toml",configName:"Python Formatter",recommendations:{"ms-python.black-formatter":{name:"Black Formatter",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?black"?\\s*[\\].])|("black\\s*["[(<=>!~;@])'},"ms-python.autopep8":{name:"Autopep8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?autopep8"?\\s*[\\].])|("autopep8\\s*["[(<=>!~;@])'}}},"pep8-formatter":{configPath:".pep8",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8"}}},"python-setup-cgf-formatter":{configPath:"setup.cfg",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"tox-ini-formatter":{configPath:"tox.ini",configName:"Python Formatter",recommendations:{"ms-python.autopep8":{name:"Autopep8",contentPattern:"^\\[pep8\\]"}}},"pyproject-linter":{configPath:"pyproject.toml",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?pylint"?\\s*[\\].])|("pylint\\s*["[(<=>!~;@])'},"charliermarsh.ruff":{name:"Ruff",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?ruff"?\\s*[\\].])|("ruff\\s*["[(<=>!~;@])'},"ms-python.mypy-type-checker":{name:"Mypy Type Checker",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?mypy"?\\s*[\\].])|("mypy\\s*["[(<=>!~;@])'},"ms-python.flake8":{name:"Flake8",contentPattern:'(^\\s*\\[\\[?\\s*"?tool"?\\s*\\.\\s*"?flake8"?\\s*[\\].])|("flake8\\s*["[(<=>!~;@])'}}},".pylintrc-linter":{configPath:".pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"pylintrc-linter":{configPath:"pylintrc",configName:"Python Linter",recommendations:{"ms-python.pylint":{name:"Pylint"}}},"mypy-ini-linter":{configPath:".mypy.ini",configName:"Python Linter",recommendations:{"ms-python.mypy-type-checker":{name:"Mypy Type Checker"}}},"tox-ini-linter":{configPath:"tox.ini",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}},".flake8-linter":{configPath:".flake8",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8"}}},"python-setup-cgf-linter":{configPath:"setup.cfg",configName:"Python Linter",recommendations:{"ms-python.flake8":{name:"Flake8",contentPattern:"^\\[flake8\\]"}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},azd:{friendlyName:"Azure Dev CLI",windowsPath:"%USERPROFILE%\\AppData\\Local\\Programs\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},"azd-user":{friendlyName:"Azure Dev CLI",windowsPath:"%ProgramFiles%\\Azure Dev CLI\\azd.exe",recommendations:{"ms-azuretools.azure-dev":{name:"Azure Developer CLI"},"ms-azuretools.vscode-azureresourcegroups":{name:"Azure Resources"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Dev Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},git:{friendlyName:"Git",windowsPath:"%ProgramFiles%\\Git\\git-bash.exe",recommendations:{"eamodio.gitlens":{name:"GitLens"}}},svn:{friendlyName:"Subversion",windowsPath:"%ProgramFiles%\\TortoiseSVN\\bin\\TortoiseProc.exe",recommendations:{"johnstoncode.svn-scm":{name:"SVN"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0,whenNotInstalled:["ASF.apache-netbeans-java","Oracle.oracle-java"]}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"ms-edgedevtools.vscode-edge-devtools":{name:"Microsoft Edge Developer Tools"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Dev Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"WSL",important:!0}}}},webExtensionTips:["tyriar.luna-paint","codespaces-contrib.codeswing","ms-vscode.vscode-github-issue-notebooks","esbenp.prettier-vscode","hediet.vscode-drawio"],virtualWorkspaceExtensionTips:{"vscode-vfs":{friendlyName:"Remote Repositories",extensionId:"ms-vscode.remote-repositories",startEntry:{helpLink:"https://aka.ms/vscode-remote/remote-repositories",startConnectLabel:"Remote Repository",startCommand:"remoteHub.continueOn.openRepository",priority:5}}},remoteExtensionTips:{wsl:{friendlyName:"WSL",extensionId:"ms-vscode-remote.remote-wsl",supportedPlatforms:["Windows","Web"],startEntry:{helpLink:"https://aka.ms/vscode-remote/wsl",startConnectLabel:"WSL",startCommand:"remote-wsl.connect",priority:3}},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/ssh",startConnectLabel:"SSH ",startCommand:"opensshremotes.openEmptyWindowInCurrentWindow",priority:1}},"dev-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers",supportedPlatforms:["Windows","Linux","Mac"],startEntry:{helpLink:"https://aka.ms/vscode-remote/containers",startConnectLabel:"Dev Container",startCommand:"remote-containers.reopenInContainer",priority:2}},"attached-container":{friendlyName:"Dev Containers",extensionId:"ms-vscode-remote.remote-containers"},codespaces:{friendlyName:"GitHub Codespaces",extensionId:"github.codespaces",startEntry:{helpLink:"https://aka.ms/vscode-remote-codespaces",startConnectLabel:"GitHub Codespace ",startCommand:"github.codespaces.connect",priority:4}},tunnel:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server",startEntry:{helpLink:"https://aka.ms/remote-tunnels-doc",startConnectLabel:"Tunnel",startCommand:"remote-tunnels.connectCurrentWindowToTunnel",priority:0}}},commandPaletteSuggestedCommandIds:["workbench.action.files.openFile","workbench.action.files.openFileFolder","workbench.action.files.openFolder","workbench.action.remote.showMenu","editor.action.formatDocument","editor.action.commentLine","workbench.action.tasks.runTask","workbench.action.openSettings2","workbench.action.selectTheme","workbench.action.openWalkthrough","workbench.action.openIssueReporter"],extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/(actions\\/)?workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{ariaKey:"5bbf946d11a54f6783919c455abaddaf-fd62977b-c92d-4714-a45d-649d06980372-7168"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",serverDocumentationUrl:"https://aka.ms/vscode-server-doc",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",youTubeUrl:"https://aka.ms/vscode-youtube",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",serverLicenseUrl:"https://aka.ms/vscode-server-license",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=521839",showTelemetryOptOut:!0,npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",nodejsRepository:"Microsoft/vscode-node",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05},{surveyId:"csharp.1",surveyUrl:"https://www.research.net/r/8KGJ9V8",languageId:"csharp",editCount:10,userProbability:.1}],extensionEnabledApiProposals:{"ms-vscode.vscode-selfhost-test-provider":["testObserver"],"VisualStudioExptTeam.vscodeintellicode-completions":["inlineCompletionsAdditions"],"ms-toolsai.datawrangler":["debugFocus"],"ms-vsliveshare.vsliveshare":["contribMenuBarHome","contribShareMenu","contribStatusBarItems","diffCommand","documentFiltersExclusive","fileSearchProvider","findTextInFiles","notebookCellExecutionState","notebookLiveShare","terminalDimensions","terminalDataWriteEvent","textSearchProvider"],"ms-vscode.js-debug":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-toolsai.vscode-ai-remote":["resolvers"],"ms-python.python":["contribEditorContentMenu","quickPickSortByLabel","portsAttributes","testObserver","quickPickItemTooltip","terminalDataWriteEvent","terminalExecuteCommandEvent","contribIssueReporter","terminalShellIntegration"],"ms-dotnettools.dotnet-interactive-vscode":["notebookMessaging"],"GitHub.codespaces":["contribEditSessions","contribMenuBarHome","contribRemoteHelp","contribViewsRemote","resolvers","tunnels","terminalDataWriteEvent","treeViewReveal","notebookKernelSource"],"ms-vscode.azure-repos":["extensionRuntime","fileSearchProvider","textSearchProvider"],"ms-vscode.remote-repositories":["canonicalUriProvider","contribEditSessions","contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","contribShareMenu","documentFiltersExclusive","editSessionIdentityProvider","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","shareProvider","scmActionButton","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-vscode-remote.remote-wsl":["resolvers","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode-remote.remote-ssh":["resolvers","tunnels","terminalDataWriteEvent","contribRemoteHelp","contribViewsRemote","telemetry"],"ms-vscode.remote-server":["resolvers","tunnels","contribViewsWelcome"],"ms-vscode.remote-explorer":["contribRemoteHelp","contribViewsRemote","extensionsAny"],"ms-vscode-remote.remote-containers":["contribEditSessions","resolvers","portsAttributes","tunnels","workspaceTrust","terminalDimensions","contribRemoteHelp","contribViewsRemote"],"ms-vscode.js-debug-nightly":["portsAttributes","findTextInFiles","workspaceTrust","tunnels"],"ms-vscode.lsif-browser":["documentFiltersExclusive"],"ms-vscode.vscode-speech":["speech"],"GitHub.vscode-pull-request-github":["activeComment","codiconDecoration","codeActionRanges","commentingRangeHint","commentReactor","commentThreadApplicability","contribAccessibilityHelpContent","contribCommentEditorActionsMenu","contribCommentPeekContext","contribCommentThreadAdditionalMenu","contribCommentsViewThreadMenus","contribEditorContentMenu","contribShareMenu","diffCommand","fileComments","quickDiffProvider","shareProvider","tabInputTextMerge","tokenInformation","treeViewMarkdownMessage"],"GitHub.copilot":["inlineCompletionsAdditions"],"GitHub.copilot-nightly":["inlineCompletionsAdditions"],"GitHub.copilot-chat":["interactive","terminalDataWriteEvent","terminalExecuteCommandEvent","terminalSelection","terminalQuickFixProvider","chatParticipant","chatParticipantAdditions","defaultChatParticipant","chatVariableResolver","chatProvider","mappedEditsProvider","aiRelatedInformation","codeActionAI","findTextInFiles","textSearchProvider","contribSourceControlInputBoxMenu","newSymbolNamesProvider","findFiles2","extensionsAny","authLearnMore","testObserver"],"GitHub.remotehub":["contribRemoteHelp","contribMenuBarHome","contribViewsRemote","contribViewsWelcome","documentFiltersExclusive","extensionRuntime","fileSearchProvider","quickPickSortByLabel","workspaceTrust","scmSelectedProvider","scmValidation","textSearchProvider","timeline"],"ms-python.gather":["notebookCellExecutionState"],"ms-python.vscode-pylance":["notebookCellExecutionState"],"ms-python.debugpy":["portsAttributes","contribIssueReporter","debugVisualization"],"ms-toolsai.jupyter-renderers":["contribNotebookStaticPreloads"],"ms-toolsai.jupyter":["notebookDeprecated","notebookMessaging","notebookMime","notebookCellExecutionState","portsAttributes","quickPickSortByLabel","notebookKernelSource","interactiveWindow","notebookControllerAffinityHidden","contribNotebookStaticPreloads","quickPickItemTooltip","notebookExecution","notebookCellExecution","notebookVariableProvider"],"dbaeumer.vscode-eslint":["notebookCellExecutionState"],"ms-vscode.azure-sphere-tools-ui":["tunnels"],"ms-azuretools.vscode-azureappservice":["terminalDataWriteEvent"],"ms-azuretools.vscode-azureresourcegroups":["authGetSessions"],"ms-vscode.anycode":["extensionsAny"],"ms-vscode.cpptools":["terminalDataWriteEvent"],"redhat.java":["documentPaste"],"ms-dotnettools.csdevkit":["inlineCompletionsAdditions"],"ms-dotnettools.vscodeintellicode-csharp":["inlineCompletionsAdditions"],"microsoft-IsvExpTools.powerplatform-vscode":["fileSearchProvider","textSearchProvider"],"microsoft-IsvExpTools.powerplatform-vscode-preview":["fileSearchProvider","textSearchProvider"],"apidev.azure-api-center":["chatParticipant","languageModels"]},tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"],"vscodevim.vim":["ui"],"ollyhayes.colmak-vim":["ui"]},extensionPointExtensionKind:{typescriptServerPlugins:["workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"octref.vetur":{default:!1},"formulahendry.code-runner":{default:!1},"xdebug.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"xdebug.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://*.gallerycdn.vsassets.io","https://*.github.com","https://login.microsoftonline.com","https://*.vscode.dev","https://*.github.dev","https://gh.io","https://portal.azure.com"],trustedExtensionAuthAccess:{github:["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],"github-enterprise":["vscode.github","github.remotehub","ms-vscode.remote-server","github.vscode-pull-request-github","github.codespaces","github.copilot","github.copilot-chat","ms-vsliveshare.vsliveshare"],microsoft:["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"],"microsoft-sovereign-cloud":["ms-vscode.azure-repos","ms-vscode.remote-server","ms-vsliveshare.vsliveshare","ms-azuretools.vscode-azureresourcegroups","ms-edu.vscode-learning"]},trustedExtensionProtocolHandlers:["vscode.git","vscode.github-authentication","vscode.microsoft-authentication"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{github:{scopes:["user:email"]},microsoft:{scopes:["openid","profile","email","offline_access"]}}},"editSessions.store":{url:"https://vscode-sync.trafficmanager.net/",authenticationProviders:{microsoft:{scopes:["openid","profile","email","offline_access"]},github:{scopes:["user:email"]}}},tunnelServerQualities:{stable:{serverApplicationName:"code-server"},exploration:{serverApplicationName:"code-server-exploration"},insider:{serverApplicationName:"code-server-insiders"}},tunnelApplicationName:"code-tunnel",tunnelApplicationConfig:{editorWebUrl:"https://vscode.dev",extension:{friendlyName:"Remote - Tunnels",extensionId:"ms-vscode.remote-server"},authenticationProviders:{github:{scopes:["user:email","read:org"]},microsoft:{scopes:["46da2f7e-b5ef-422a-88d4-2a7f9de6a0b2/.default","profile","openid"]}}},win32TunnelServiceMutex:"vscode-tunnelservice",win32TunnelMutex:"vscode-tunnel",commonlyUsedSettings:["files.autoSave","editor.fontSize","editor.fontFamily","GitHub.copilot.manageExtension","editor.tabSize","editor.renderWhitespace","editor.cursorStyle","editor.multiCursorModifier","editor.insertSpaces","editor.wordWrap","files.exclude","files.associations","workbench.editor.enablePreview"],aiGeneratedWorkspaceTrust:{title:"This workspace was generated by GitHub Copilot",checkboxText:"Trust the contents of all files in this workspace",trustOption:"Yes, I trust the contents",dontTrustOption:"No, I don't trust the contents",startupTrustRequestLearnMore:"If you don't trust the contents of the files generated by GitHub Copilot, we recommend continuing in restricted mode. See [our docs](https://aka.ms/vscode-workspace-trust) to learn more. "},gitHubEntitlement:{providerId:"github",command:{title:"Install GitHub Copilot (Paid for by {{org}})...",titleWithoutPlaceHolder:"Install GitHub Copilot",action:"workbench.extensions.installExtension",when:"workbench.accounts.experimental.showEntitlements"},entitlementUrl:"https://api.github.com/copilot_internal/user",extensionId:"github.copilot",enablementKey:"chat_enabled",confirmationAction:"Install",confirmationMessage:"Are you sure you want to install GitHub Copilot?"},chatWelcomeView:{welcomeViewId:"copilot.welcome",welcomeViewTitle:"GitHub Copilot",welcomeViewContent:`You have access to GitHub Copilot, an AI-powered coding assistant, as a part of the Microsoft organization.
 Getting started with Copilot is easy - simply install the Copilot extension. [Learn more](https://code.visualstudio.com/docs/copilot/overview)
[Install GitHub Copilot](command:workbench.extensions.installExtension?%5B%22github.copilot%22%5D)`},chatParticipantRegistry:"https://az764295.vo.msecnd.net/extensions/chat.json",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.1.2",sha256:"e034b8b41beb4e97e02c70f7175bd88abe66048374c2bd629f54bb33354bc2aa",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.89.0",sha256:"2abd9c01f711c0d60d40b722b5bed0930701be173931f3c6251906f692858221",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.9",sha256:"3b62ee4276a2bbea3fe230f94b1d5edd915b05966090ea56f882e1e0ab53e1a6",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],version:"1.89.1",commit:"dc96b837cf6bb4af9cd736aa3af08cf8279f7685",date:"2024-05-07T04:07:05.306Z"},Object.keys(C).length===0&&Object.assign(C,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(ye[28],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$jk=void 0,e.$jk=(0,o.$wi)("productService"),e.$kk="vscode://schemas/vscode-product"}),define(ye[36],Ee([1,0,97,10]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0;class S{constructor(){this.a=new Map}add(I,P){o.ok(C.$9f(I)),o.ok(C.$$f(P)),o.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,P)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$co=new S}),define(ye[244],Ee([1,0,6,36]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do={JSONContribution:"base.contributions.json"};function S(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class D{constructor(){this.b=new o.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(b,g){this.a[S(b)]=g,this.b.fire(b)}notifySchemaChanged(b){this.b.fire(b)}getSchemaContributions(){return{schemas:this.a}}}const I=new D;C.$co.add(e.$do.JSONContribution,I)}),define(ye[49],Ee([1,0,18,6,10,186,25,244,36]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ConfigurationScope=e.$ho=e.EditPresentationTypes=void 0,e.$so=a,e.$to=f,e.$uo=c,e.$vo=p,e.$wo=E;var g;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$ho={Configuration:"base.contributions.configuration"};var y;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y||(e.ConfigurationScope=y={})),e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo="vscode://schemas/settings/resourceLanguage",e.$po="vscode://schemas/settings/configurationDefaults";const v=b.$co.as(P.$do.JSONContribution);class w{constructor(){this.h=new Set,this.i=new C.$ee,this.onDidSchemaChange=this.i.event,this.j=new C.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},v.registerSchema(e.$oo,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.n(t,s,r),v.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.o(t,s),v.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.o(s,r),this.n(t,!1,r),v.registerSchema(e.$oo,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const r=[];for(const{overrides:i,source:n}of t)for(const l in i)if(s.add(l),e.$ro.test(l)){const $=this.a.get(l),k=$?.valuesSources??new Map;if(n)for(const F of Object.keys(i[l]))k.set(F,n);const j={...$?.value||{},...i[l]};this.a.set(l,{source:n,value:j,valuesSources:k});const A=(0,I.$aj)(l),O={type:"object",default:j,description:D.localize(1,null,A),$ref:e.$oo,defaultDefaultValue:j,source:S.$9f(n)?void 0:n,defaultValueSource:n};r.push(...a(l)),this.d[l]=O,this.b.properties[l]=O}else{this.a.set(l,{value:i[l],source:n});const $=this.d[l];$&&(this.w(l,$),this.r(l,$))}this.m(r)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:r,source:i}of t)for(const n in r){const l=this.a.get(n),$=S.$9f(i)?i:i?.id,k=S.$9f(l?.source)?l?.source:l?.source?.id;if($===k)if(s.add(n),this.a.delete(n),e.$ro.test(n))delete this.d[n],delete this.b.properties[n];else{const j=this.d[n];j&&(this.w(n,j),this.r(n,j))}}this.u()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,r){t.forEach(i=>{this.p(i,s,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,s){const r=i=>{if(i.properties)for(const n in i.properties){s.add(n);const l=this.d[n];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,s=!0,r,i,n=3,l){n=S.$fg(t.scope)?n:t.scope;const $=t.properties;if($)for(const j in $){const A=$[j];if(s&&p(j,A)){delete $[j];continue}if(A.source=r,A.defaultDefaultValue=$[j].default,this.w(j,A),e.$ro.test(j)?A.scope=void 0:(A.scope=S.$fg(A.scope)?n:A.scope,A.restricted=S.$fg(A.restricted)?!!i?.includes(j):A.restricted),$[j].hasOwnProperty("included")&&!$[j].included){this.f[j]=$[j],delete $[j];continue}else this.d[j]=$[j],$[j].policy?.name&&this.e.set($[j].policy.name,j);!$[j].deprecationMessage&&$[j].markdownDeprecationMessage&&($[j].deprecationMessage=$[j].markdownDeprecationMessage),l.add(j)}const k=t.allOf;if(k)for(const j of k)this.p(j,s,r,i,n,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=r=>{const i=r.properties;if(i)for(const l in i)this.r(l,i[l]);r.allOf?.forEach(s)};s(t)}r(t,s){switch(e.$io.properties[t]=s,s.scope){case 1:e.$jo.properties[t]=s;break;case 2:e.$ko.properties[t]=s;break;case 6:e.$lo.properties[t]=s;break;case 3:e.$mo.properties[t]=s;break;case 4:e.$no.properties[t]=s;break;case 5:e.$no.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.$io.properties[t],s.scope){case 1:delete e.$jo.properties[t];break;case 2:delete e.$ko.properties[t];break;case 6:delete e.$lo.properties[t];break;case 3:delete e.$mo.properties[t];break;case 4:case 5:delete e.$no.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,r={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:e.$oo};this.w(s,r),e.$io.properties[s]=r,e.$jo.properties[s]=r,e.$ko.properties[s]=r,e.$lo.properties[s]=r,e.$mo.properties[s]=r,e.$no.properties[s]=r}}v(){const t={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:e.$oo};e.$io.patternProperties[e.$qo]=t,e.$jo.patternProperties[e.$qo]=t,e.$ko.patternProperties[e.$qo]=t,e.$lo.patternProperties[e.$qo]=t,e.$mo.patternProperties[e.$qo]=t,e.$no.patternProperties[e.$qo]=t,this.i.fire()}w(t,s){const r=this.a.get(t);let i=r?.value,n=r?.source;S.$dg(i)&&(i=s.defaultDefaultValue,n=void 0),S.$dg(i)&&(i=c(s.type)),s.default=i,s.defaultValueSource=n}}const m="\\[([^\\]]+)\\]",u=new RegExp(m,"g");e.$qo=`^(${m})+$`,e.$ro=new RegExp(e.$qo);function a(h){const t=[];if(e.$ro.test(h)){let s=u.exec(h);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=u.exec(h)}}return(0,o.$Mb)(t)}function f(h){return h.reduce((t,s)=>`${t}[${s}]`,"")}function c(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const d=new w;b.$co.add(e.$ho.Configuration,d);function p(h,t){return h.trim()?e.$ro.test(h)?D.localize(7,null,h):d.getConfigurationProperties()[h]!==void 0?D.localize(8,null,h):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?D.localize(9,null,h,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:D.localize(6,null)}function E(){const h=[],t=d.getConfigurationProperties();for(const s of Object.keys(t))h.push([s,t[s].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(ye[117],Ee([1,0,18,6,43,2,24,21,10,4,25,49,36]),function(he,e,o,C,S,D,I,P,b,g,y,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Co=e.$Ao=e.$zo=e.$yo=e.$xo=void 0,e.$Bo=p;function m(s){return Object.isFrozen(s)?s:P.$4n(s)}class u{static createEmptyModel(r){return new u({},[],[],void 0,r)}constructor(r,i,n,l,$){this.b=r,this.c=i,this.d=n,this.raw=l,this.f=$,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof u)return i;const n=new a("",this.f);return n.parseRaw(i),n.configurationModel});this.g=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,y.$$i)(this.contents,r):this.contents}inspect(r,i){const n=this;return{get value(){return m(n.rawConfiguration.getValue(r))},get override(){return i?m(n.rawConfiguration.getOverrideValue(r,i)):void 0},get merged(){return m(i?n.rawConfiguration.override(i).getValue(r):n.rawConfiguration.getValue(r))},get overrides(){const l=[];for(const{contents:$,identifiers:k,keys:j}of n.rawConfiguration.overrides){const A=new u($,j,[],void 0,n.f).getValue(r);A!==void 0&&l.push({identifiers:k,value:A})}return l.length?m(l):void 0}}}getOverrideValue(r,i){const n=this.j(i);return n?r?(0,y.$$i)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return o.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return o.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.h(r),this.a.set(r,i)),i}merge(...r){const i=P.$3n(this.contents),n=P.$3n(this.overrides),l=[...this.keys],$=this.raw?.length?[...this.raw]:[this];for(const k of r)if($.push(...k.raw?.length?k.raw:[k]),!k.isEmpty()){this.i(i,k.contents);for(const j of k.overrides){const[A]=n.filter(O=>o.$ub(O.identifiers,j.identifiers));A?(this.i(A.contents,j.contents),A.keys.push(...j.keys),A.keys=o.$Mb(A.keys)):n.push(P.$3n(j))}for(const j of k.keys)l.indexOf(j)===-1&&l.push(j)}return new u(i,l,n,$.every(k=>k instanceof u)?void 0:$,this.f)}h(r){const i=this.j(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const l of o.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let $=this.contents[l];const k=i[l];k&&(typeof $=="object"&&typeof k=="object"?($=P.$3n($),this.i($,k)):$=k),n[l]=$}return new u(n,this.keys,this.overrides,void 0,this.f)}i(r,i){for(const n of Object.keys(i)){if(n in r&&b.$$f(r[n])&&b.$$f(i[n])){this.i(r[n],i[n]);continue}r[n]=P.$3n(i[n])}}j(r){let i=null,n=null;const l=$=>{$&&(n?this.i(n,$):n=P.$3n($))};for(const $ of this.overrides)$.identifiers.length===1&&$.identifiers[0]===r?i=$.contents:$.identifiers.includes(r)&&l($.contents);return l(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.k(r,i,!0)}setValue(r,i){this.k(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,y.$0i)(this.contents,r),v.$ro.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>o.$ub(n.identifiers,(0,v.$so)(r))),1))}k(r,i,n){(0,y.$9i)(this.contents,r,i,l=>this.f.error(l)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),v.$ro.test(r)&&this.overrides.push({identifiers:(0,v.$so)(r),keys:Object.keys(this.contents[r]),contents:(0,y.$8i)(this.contents[r],l=>this.f.error(l))})}}e.$xo=u;class a{constructor(r,i){this.f=r,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||u.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!b.$fg(r)){const n=this.h(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:l,overrides:$,restricted:k,hasExcludedProperties:j}=this.i(r,i);this.b=new u(n,l,$,j?[r]:void 0,this.g),this.c=k||[]}h(r){let i={},n=null,l=[];const $=[],k=[];function j(O){Array.isArray(l)?l.push(O):n!==null&&(l[n]=O)}const A={onObjectBegin:()=>{const O={};j(O),$.push(l),l=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{l=$.pop()},onArrayBegin:()=>{const O=[];j(O),$.push(l),l=O,n=null},onArrayEnd:()=>{l=$.pop()},onLiteralValue:j,onError:(O,F,V)=>{k.push({error:O,offset:F,length:V})}};if(r)try{S.$Qn(r,A),i=l[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}i(r,i){const n=w.$co.as(v.$ho.Configuration).getConfigurationProperties(),l=this.j(r,n,!0,i);r=l.raw;const $=(0,y.$8i)(r,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`)),k=Object.keys(r),j=this.l(r,A=>this.g.error(`Conflict in settings file ${this.f}: ${A}`));return{contents:$,keys:k,overrides:j,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}j(r,i,n,l){let $=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:$};const k={},j=[];for(const A in r)if(v.$ro.test(A)&&n){const O=this.j(r[A],i,!1,l);k[A]=O.raw,$=$||O.hasExcludedProperties,j.push(...O.restricted)}else{const O=i[A],F=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&j.push(A),!l.exclude?.includes(A)&&(l.include?.includes(A)||(F===void 0||l.scopes===void 0||l.scopes.includes(F))&&!(l.skipRestricted&&O?.restricted))?k[A]=r[A]:$=!0}return{raw:k,restricted:j,hasExcludedProperties:$}}l(r,i){const n=[];for(const l of Object.keys(r))if(v.$ro.test(l)){const $={};for(const k in r[l])$[k]=r[l][k];n.push({identifiers:(0,v.$so)(l),keys:Object.keys($),contents:(0,y.$8i)($,i)})}return n}}e.$yo=a;class f extends D.$Vc{constructor(r,i,n,l,$){super(),this.c=r,this.f=i,this.g=l,this.h=$,this.b=this.B(new C.$ee),this.onDidChange=this.b.event,this.a=new a(this.c.toString(),$),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&n.isEqual(k.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return u.createEmptyModel(this.h)}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$zo=f;class c{constructor(r,i,n,l,$,k,j,A,O,F,V,Z,oe){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=l,this.d=$,this.f=k,this.g=j,this.h=A,this.i=O,this.j=F,this.k=V,this.l=Z,this.m=oe}get value(){return m(this.c)}n(r){return r?.value!==void 0||r?.override!==void 0||r?.overrides!==void 0?r:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class d{constructor(r,i,n,l,$,k,j,A,O,F){this.j=r,this.l=i,this.m=n,this.n=l,this.p=$,this.q=k,this.r=j,this.s=A,this.t=O,this.u=F,this.h=null,this.i=new I.$Bc,this.v=null}getValue(r,i,n){return this.w(r,i,n).getValue(r)}updateValue(r,i,n={}){let l;n.resource?(l=this.t.get(n.resource),l||(l=u.createEmptyModel(this.u),this.t.set(n.resource,l))):l=this.s,i===void 0?l.removeValue(r):l.setValue(r,i),n.resource||(this.h=null)}inspect(r,i,n){const l=this.w(r,i,n),$=this.A(i.resource,n),k=i.resource?this.t.get(i.resource)||this.s:this.s,j=new Set;for(const A of l.overrides)for(const O of A.identifiers)l.getOverrideValue(r,O)!==void 0&&j.add(O);return new c(r,i,l.getValue(r),j.size?[...j]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.q:void 0,$||void 0,k)}keys(r){const i=this.A(void 0,r);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.j=r,this.h=null,this.i.clear()}updatePolicyConfiguration(r){this.l=r}updateApplicationConfiguration(r){this.m=r,this.h=null,this.i.clear()}updateLocalUserConfiguration(r){this.n=r,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(r){this.p=r,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(r){this.q=r,this.h=null,this.i.clear()}updateFolderConfiguration(r,i){this.r.set(r,i),this.i.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.i.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:l,updated:$,removed:k}=h(this.j,r);i=[...l,...$,...k]}for(const l of i)for(const $ of(0,v.$so)(l)){const k=this.j.getKeysForOverrideIdentifier($),j=r.getKeysForOverrideIdentifier($),A=[...j.filter(O=>k.indexOf(O)===-1),...k.filter(O=>j.indexOf(O)===-1),...k.filter(O=>!P.$7n(this.j.override($).getValue(O),r.override($).getValue(O)))];n.push([$,A])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:l}=h(this.l,r),$=[...i,...n,...l];return $.length&&this.updatePolicyConfiguration(r),{keys:$,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:l,overrides:$}=h(this.applicationConfiguration,r),k=[...i,...n,...l];return k.length&&this.updateApplicationConfiguration(r),{keys:k,overrides:$}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:l,overrides:$}=h(this.localUserConfiguration,r),k=[...i,...n,...l];return k.length&&this.updateLocalUserConfiguration(r),{keys:k,overrides:$}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:l,overrides:$}=h(this.remoteUserConfiguration,r),k=[...i,...n,...l];return k.length&&this.updateRemoteUserConfiguration(r),{keys:k,overrides:$}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:l,overrides:$}=h(this.workspaceConfiguration,r),k=[...i,...n,...l];return k.length&&this.updateWorkspaceConfiguration(r),{keys:k,overrides:$}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:l,updated:$,removed:k,overrides:j}=h(n,i),A=[...l,...$,...k];return(A.length||!n)&&this.updateFolderConfiguration(r,i),{keys:A,overrides:j}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:l,removed:$,overrides:k}=h(i,void 0);return{keys:[...n,...l,...$],overrides:k}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(r,i,n){let l=this.x(i,n);return i.overrideIdentifier&&(l=l.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(r)!==void 0&&(l=l.merge(this.l)),l}x({resource:r},i){let n=this.y();if(i&&r){const l=i.getFolder(r);l&&(n=this.z(l.uri)||n);const $=this.t.get(r);$&&(n=n.merge($))}return n}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(r){let i=this.i.get(r);if(!i){const n=this.y(),l=this.r.get(r);l?(i=n.merge(l),this.i.set(r,i)):i=n}return i}A(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.r.get(n.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((r,i)=>{const{contents:n,overrides:l,keys:$}=this.r.get(i);return r.push([i,{contents:n,overrides:l,keys:$}]),r},[])}}allKeys(){const r=new Set;return this.j.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.q.keys.forEach(i=>r.add(i)),this.r.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}B(){const r=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}D(r){const i=new Set;return this.j.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.q.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.r.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(l=>i.add(l))),[...i.values()]}static parse(r,i){const n=this.E(r.defaults,i),l=this.E(r.policy,i),$=this.E(r.application,i),k=this.E(r.user,i),j=this.E(r.workspace,i),A=r.folders.reduce((O,F)=>(O.set(g.URI.revive(F[0]),this.E(F[1],i)),O),new I.$Bc);return new d(n,l,$,k,u.createEmptyModel(i),j,A,u.createEmptyModel(i),new I.$Bc,i)}static E(r,i){return new u(r.contents,r.keys,r.overrides,void 0,i)}}e.$Ao=d;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,i=new Map;for(const l of s)l.keys.forEach($=>r.add($)),l.overrides.forEach(([$,k])=>{const j=(0,I.$yc)(i,$,new Set);k.forEach(A=>j.add(A))});const n=[];return i.forEach((l,$)=>n.push([$,[...l.values()]])),{keys:[...r.values()],overrides:n}}class E{constructor(r,i,n,l,$){this.change=r,this.f=i,this.g=n,this.h=l,this.i=$,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const k of r.keys)this.affectedKeys.add(k);for(const[,k]of r.overrides)for(const j of k)this.affectedKeys.add(j);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=d.parse(this.f.data,this.i)),this.j}affectsConfiguration(r,i){const n=this.a+r,l=this.d.indexOf(n);if(l<0)return!1;const $=l+n.length;if($>=this.d.length)return!1;const k=this.d.charCodeAt($);if(k!==this.b&&k!==this.c)return!1;if(i){const j=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,A=this.g.getValue(r,i,this.h);return!P.$7n(j,A)}return!0}}e.$Co=E;function h(s,r){const{added:i,removed:n,updated:l}=t(r?.rawConfiguration,s?.rawConfiguration),$=[],k=s?.getAllOverrideIdentifiers()||[],j=r?.getAllOverrideIdentifiers()||[];if(r){const A=j.filter(O=>!k.includes(O));for(const O of A)$.push([O,r.getKeysForOverrideIdentifier(O)])}if(s){const A=k.filter(O=>!j.includes(O));for(const O of A)$.push([O,s.getKeysForOverrideIdentifier(O)])}if(r&&s){for(const A of k)if(j.includes(A)){const O=t({contents:s.getOverrideValue(void 0,A)||{},keys:s.getKeysForOverrideIdentifier(A)},{contents:r.getOverrideValue(void 0,A)||{},keys:r.getKeysForOverrideIdentifier(A)});$.push([A,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:n,updated:l,overrides:$}}function t(s,r){const i=s?r?s.keys.filter($=>r.keys.indexOf($)===-1):[...s.keys]:[],n=r?s?r.keys.filter($=>s.keys.indexOf($)===-1):[...r.keys]:[],l=[];if(s&&r){for(const $ of r.keys)if(s.keys.indexOf($)!==-1){const k=(0,y.$$i)(r.contents,$),j=(0,y.$$i)(s.contents,$);P.$7n(k,j)||l.push($)}}return{added:i,removed:n,updated:l}}}),define(ye[245],Ee([1,0,18,6,2,21,10,117,49,12,70,36]),function(he,e,o,C,S,D,I,P,b,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Eo=e.$Do=void 0;class w extends S.$Vc{get configurationModel(){return this.b}constructor(f){super(),this.c=f,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=P.$xo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(v.$co.as(b.$ho.Configuration).onDidUpdateConfiguration(({properties:f,defaultsOverrides:c})=>this.f(Array.from(f),c))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(f,c){this.j(f,v.$co.as(b.$ho.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:f})}g(){return{}}h(){this.b=P.$xo.createEmptyModel(this.c);const f=v.$co.as(b.$ho.Configuration).getConfigurationProperties();this.j(Object.keys(f),f)}j(f,c){const d=this.g();for(const p of f){const E=d[p],h=c[p];E!==void 0?this.b.addValue(p,E):h?this.b.addValue(p,h.default):this.b.removeValue(p)}}}e.$Do=w;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=P.$xo.createEmptyModel(new g.$dk)}async initialize(){return this.configurationModel}}e.$Eo=m;let u=class extends S.$Vc{get configurationModel(){return this.b}constructor(f,c,d){super(),this.c=f,this.f=c,this.g=d,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=P.$xo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(f=>this.j(f))),this.B(this.c.onDidChangeConfiguration(async({properties:f})=>this.m(await this.h(f),!0))),this.b}async h(f){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",f);const c={},d=[],p=v.$co.as(b.$ho.Configuration).getConfigurationProperties();for(const E of f){const h=p[E];if(!h){d.push(E);continue}if(h.policy){if(h.type!=="string"&&h.type!=="number"){this.g.warn(`Policy ${h.policy.name} has unsupported type ${h.type}`);continue}d.push(E),c[h.policy.name]={type:h.type}}}return(0,I.$jg)(c)||await this.f.updatePolicyDefinitions(c),d}j(f){this.g.trace("PolicyConfiguration#onDidChangePolicies",f);const c=v.$co.as(b.$ho.Configuration).getPolicyConfigurations(),d=(0,o.$Hb)(f.map(p=>c.get(p)));this.m(d,!0)}m(f,c){this.g.trace("PolicyConfiguration#update",f);const d=v.$co.as(b.$ho.Configuration).getConfigurationProperties(),p=[],E=this.b.isEmpty();for(const h of f){const t=d[h]?.policy?.name;if(t){const s=this.f.getPolicyValue(t);(E?s!==void 0:!(0,D.$7n)(this.b.getValue(h),s))&&p.push([h,s])}else this.b.getValue(h)!==void 0&&p.push([h,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const h=this.b;this.b=P.$xo.createEmptyModel(this.g);for(const t of h.keys)this.b.setValue(t,h.getValue(t));for(const[t,s]of p)s===void 0?this.b.removeValue(t):this.b.setValue(t,s);c&&this.a.fire(this.b)}}};e.$Fo=u,e.$Fo=u=Le([Ne(1,y.$eo),Ne(2,g.$3j)],u)}),define(ye[118],Ee([1,0,18,14,15,6,43,149,2,24,21,3,19,25,117,49,245,70]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Go=void 0;class d extends b.$Vc{constructor(h,t,s,r){super(),this.m=h,this.n=r,this.h=this.B(new D.$ee),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new f.$Do(r)),this.c=s instanceof c.$go?new f.$Eo:this.B(new f.$Fo(this.b,s,r)),this.f=this.B(new u.$zo(this.m,{},w.$1g,t,r)),this.a=new u.$Ao(this.b.configurationModel,this.c.configurationModel,u.$xo.createEmptyModel(r),u.$xo.createEmptyModel(r),u.$xo.createEmptyModel(r),u.$xo.createEmptyModel(r),new g.$Bc,u.$xo.createEmptyModel(r),new g.$Bc,r),this.j=new p(h,t,this),this.g=this.B(new C.$Ih(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:n})=>this.s(i,n))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,t,s]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new u.$Ao(h,t,u.$xo.createEmptyModel(this.n),s,u.$xo.createEmptyModel(this.n),u.$xo.createEmptyModel(this.n),new g.$Bc,u.$xo.createEmptyModel(this.n),new g.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(h,t){const s=typeof h=="string"?h:void 0,r=(0,m.$4i)(h)?h:(0,m.$4i)(t)?t:{};return this.a.getValue(s,r,void 0)}async updateValue(h,t,s,r,i){const n=(0,m.$5i)(s)?s:(0,m.$4i)(s)?{resource:s.resource,overrideIdentifiers:s.overrideIdentifier?[s.overrideIdentifier]:void 0}:void 0,l=n?r:s;if(l!==void 0&&l!==3&&l!==2)throw new Error(`Unable to write ${h} to target ${l}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,o.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const $=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if($.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,y.$7n)(t,$.defaultValue)&&(t=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const j=n.overrideIdentifiers.sort(),A=this.a.localUserConfiguration.overrides.find(O=>(0,o.$ub)([...O.identifiers].sort(),j));A&&(n.overrideIdentifiers=A.identifiers)}const k=n?.overrideIdentifiers?.length?[(0,a.$to)(n.overrideIdentifiers),h]:[h];await this.j.write(k,t),await this.reloadConfiguration()}inspect(h,t={}){return this.a.inspect(h,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.r(h)}r(h){const t=this.a.toData(),s=this.a.compareAndUpdateLocalUserConfiguration(h);this.u(s,t,2)}s(h,t){const s=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,t);this.u(r,s,7)}t(h){const t=this.a.toData(),s=this.a.compareAndUpdatePolicyConfiguration(h);this.u(s,t,7)}u(h,t,s){const r=new u.$Co(h,{data:t},this.a,void 0,this.n);r.source=s,this.h.fire(r)}}e.$Go=d;class p{constructor(h,t,s){this.b=h,this.c=t,this.d=s,this.a=new C.$Dh}write(h,t){return this.a.queue(()=>this.e(h,t))}async e(h,t){let s;try{s=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)s="{}";else throw n}const r=[];if((0,I.$Jn)(s,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(s,h,t);s=(0,P.$2n)(s,i),await this.c.writeFile(this.b,S.$Ge.fromString(s))}f(h,t,s){const{tabSize:r,insertSpaces:i,eol:n}=this.h;if(!t.length){const l=JSON.stringify(s,null,i?" ".repeat(r):"	");return[{content:l,length:l.length,offset:0}]}return(0,P.$Yn)(h,t,s,{tabSize:r,insertSpaces:i,eol:n})}get h(){if(!this.g){let h=v.OS===3||v.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(h=t),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ye[119],Ee([1,0,11,5]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.RemoteAuthorityResolverErrorCode=e.$Jl=e.$Il=e.RemoteConnectionType=e.$Hl=void 0,e.$Ll=g,e.$Hl=(0,C.$wi)("remoteAuthorityResolverService");var S;(function(y){y[y.WebSocket=0]="WebSocket",y[y.Managed=1]="Managed"})(S||(e.RemoteConnectionType=S={}));class D{constructor(v){this.id=v,this.type=1}toString(){return`Managed(${this.id})`}}e.$Il=D;class I{constructor(v,w){this.host=v,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Jl=I;var P;(function(y){y.Unknown="Unknown",y.NotAvailable="NotAvailable",y.TemporarilyNotAvailable="TemporarilyNotAvailable",y.NoResolverFound="NoResolverFound",y.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class b extends o.$bb{static isNotAvailable(v){return v instanceof b&&v._code===P.NotAvailable}static isTemporarilyNotAvailable(v){return v instanceof b&&v._code===P.TemporarilyNotAvailable}static isNoResolverFound(v){return v instanceof b&&v._code===P.NoResolverFound}static isInvalidAuthority(v){return v instanceof b&&v._code===P.InvalidAuthority}static isHandled(v){return v instanceof b&&v.isHandled}constructor(v,w=P.Unknown,m){super(v),this._message=v,this._code=w,this._detail=m,this.isHandled=w===P.NotAvailable&&m===!0,Object.setPrototypeOf(this,b.prototype)}}e.$Kl=b;function g(y){const v=y.indexOf("+");return v===-1?y:y.substring(0,v)}}),define(ye[246],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XQ=e.$WQ=void 0,e.$WQ=(0,o.$wi)("IRemoteExtensionsScannerService"),e.$XQ="remoteExtensionsScanner"}),define(ye[86],Ee([1,0,13]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=C,e.$Im=S,e.$Jm=D,e.$Km=I;function C(b){return b.scheme===o.Schemas.vscodeRemote?b.authority:void 0}function S(b){if(!b)return;const g=b.indexOf("+");return g<0?b:b.substr(0,g)}function D(b){const{host:g,port:y}=P(b);if(typeof y>"u")throw new Error(`Invalid remote authority: ${b}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:g,port:y}}function I(b,g){let{host:y,port:v}=P(b);return typeof v>"u"&&(v=g),{host:y,port:v}}function P(b){const g=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(g)return{host:g[1],port:parseInt(g[2],10)};const y=b.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const v=b.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:b,port:void 0}}}),define(ye[40],Ee([1,0,17,5,86]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ym=e.$Tm=e.$Sm=e.$Rm=e.TargetPlatform=e.ExtensionType=e.$Qm=e.$Om=e.$Nm=e.$Mm=e.$Lm=void 0,e.$Pm=D,e.$Um=v,e.$Vm=w,e.$Wm=m,e.$Xm=u,e.$Lm="extensions.user.cache",e.$Mm="extensions.builtin.cache",e.$Nm="undefined_publisher",e.$Om=["ui","workspace","web"];function D(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$Qm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var I;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(I||(e.ExtensionType=I={}));var P;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class b{constructor(f){this.value=f,this._lower=f.toLowerCase()}static equals(f,c){if(typeof f>"u"||f===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof f=="string"||typeof c=="string"){const d=typeof f=="string"?f:f.value,p=typeof c=="string"?c:c.value;return o.$yf(d,p)}return f._lower===c._lower}static toKey(f){return typeof f=="string"?f.toLowerCase():f._lower}}e.$Rm=b;class g{get size(){return this.c.size}constructor(f){if(this.c=new Set,f)for(const c of f)this.add(c)}add(f){this.c.add(b.toKey(f))}delete(f){return this.c.delete(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}}e.$Sm=g;class y{constructor(){this.c=new Map}clear(){this.c.clear()}delete(f){this.c.delete(b.toKey(f))}get(f){return this.c.get(b.toKey(f))}has(f){return this.c.has(b.toKey(f))}set(f,c){this.c.set(b.toKey(f),c)}values(){return this.c.values()}forEach(f){this.c.forEach(f)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Tm=y;function v(a){return w(a)}function w(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}function m(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}function u(a,f){if(f){const c=`onResolveRemoteAuthority:${(0,S.$Im)(f)}`;return!!a.activationEvents?.includes(c)}return!1}e.$Ym=(0,C.$wi)("IBuiltinExtensionsScannerService")}),define(ye[247],Ee([1,0,2,40,16]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0;class D extends o.$Vc{constructor(P,b,g,y,v){super(),this.a=P,this.b=b,this.c=g,this.f=v,this.B(y.onDidInstallExtensions(w=>this.g(w))),this.B(y.onDidUninstallExtension(w=>this.h(w)))}g(P){for(const b of P)b.local&&this.invalidate(b.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const b of this.a.profiles)this.c.extUri.isEqual(b.extensionsResource,P)&&await this.j(b);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,C.$Lm))}catch(b){(0,S.$hl)(b)!==1&&this.f.error(b)}}}e.$Bq=D}),define(ye[42],Ee([1,0,15,11,2,206,49,5,12,36]),function(he,e,o,C,S,D,I,P,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Op=e.$Np=void 0,e.$Pp=w,e.$Qp=m,e.$Rp=u,e.$Sp=a,e.$Tp=f,e.$Up=c,e.$Np=(0,P.$wi)("requestService");class y{constructor(h){this.b=h}toJSON(){if(!this.a){const h=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?h[t]="*****":h[t]=this.b[t];this.a=h}return this.a}}class v extends S.$Vc{constructor(h){super(),this.b=0,this.a=h.createLogger("network",{name:(0,D.localize)(0,null),when:b.$ik.isEqualTo((0,b.$fk)(b.LogLevel.Trace)).serialize()})}async c(h,t,s){const r=`${h} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new y(t.headers??{}));try{const i=await s();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,C.$0)(i)),i}}}e.$Op=v;function w(E){return E.res.statusCode&&E.res.statusCode>=200&&E.res.statusCode<300||E.res.statusCode===1223}function m(E){return E.res.statusCode===204}async function u(E){return m(E)?null:(await(0,o.$Se)(E.stream)).toString()}async function a(E){if(!w(E))throw new Error("Server returned "+E.res.statusCode);return u(E)}async function f(E){if(!w(E))throw new Error("Server returned "+E.res.statusCode);if(m(E))return null;const t=(await(0,o.$Se)(E.stream)).toString();try{return JSON.parse(t)}catch(s){throw s.message+=`:
`+t,s}}function c(E){p(E)}let d;function p(E){const h=g.$co.as(I.$ho.Configuration),t=d;d={id:"http",order:15,title:(0,D.localize)(1,null),type:"object",scope:E,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,D.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(6,null),(0,D.localize)(7,null),(0,D.localize)(8,null),(0,D.localize)(9,null)],default:"override",description:(0,D.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,D.localize)(12,null),restricted:!0}}},h.updateConfigurations({add:[d],remove:t?[t]:[]})}p(1)}),define(ye[248],Ee([1,0,20,13,16,42]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Q=void 0;let I=class{constructor(b,g){this.a=b,this.b=g}async download(b,g,y=o.CancellationToken.None){if(b.scheme===C.Schemas.file||b.scheme===C.Schemas.vscodeRemote){await this.b.copy(b,g);return}const v={type:"GET",url:b.toString(!0)},w=await this.a.request(v,y);if(w.res.statusCode===200)await this.b.writeFile(g,w.stream);else{const m=await(0,D.$Sp)(w);throw new Error(`Expected 200, got back ${w.res.statusCode} instead.

${m}`)}}};e.$0Q=I,e.$0Q=I=Le([Ne(0,D.$Np),Ne(1,S.$3k)],I)}),define(ye[249],Ee([1,0,15,20]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=void 0;class S{constructor(P){this.a=P}listen(P,b){throw new Error("Invalid listen")}call(P,b,g,y=C.CancellationToken.None){switch(b){case"request":return this.a.request(g[0],y).then(async({res:v,stream:w})=>{const m=await(0,o.$Se)(w);return[{statusCode:v.statusCode,headers:v.headers},m]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Ur=S;class D{constructor(P){this.a=P}async request(P,b){const[g,y]=await this.a.call("request",[P],b);return{res:g,stream:(0,o.$Ue)(y)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Vr=D}),define(ye[250],Ee([1,0,87,10]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=D;function S(I,P){return I.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:I.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function D(I,P,b={}){const g=(0,o.parse)(I),y=b.proxyUrl||S(g,P);if(!y)return null;const v=(0,o.parse)(y);if(!/^https?:$/.test(v.protocol||""))return null;const w={host:v.hostname||"",port:(v.port?+v.port:0)||(v.protocol==="https"?443:80),auth:v.auth,rejectUnauthorized:(0,C.$cg)(b.strictSSL)?b.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((m,u)=>{he(["http-proxy-agent"],m,u)})).HttpProxyAgent(y,w):new(await new Promise((m,u)=>{he(["https-proxy-agent"],m,u)})).HttpsProxyAgent(y,w)}}),define(ye[88],Ee([1,0,56,7,207,20,39,11,3,22,106,225,14,152]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=a;let u;async function a(c,d,p,E){return p["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):b.$i?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,v.$Am)(E)&&!p["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,v.$Am)(E)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=w.Promises.withAsyncBody(async(h,t)=>{const s=new D.$pe;let r=1e4;const i=c.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,m.$Bm)(i,1,120)*1e3);const n=setTimeout(()=>{s.dispose(!0),t(new Error((0,S.localize)(0,null)))},r);try{h(await f(d,s.token))}catch(l){!(0,P.$4)(l)&&!s.token.isCancellationRequested?t(new Error((0,S.localize)(1,null,(0,I.$hj)(l)))):h({})}finally{clearTimeout(n),s.dispose()}})),u)}async function f(c,d){const p=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",p);const E=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",E);const h=(0,g.$Sg)().replace(/-/g,"").substr(0,12),t=new RegExp(h+"({.*})"+h),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",s);const r=await(0,y.$qm)(b.OS,s);return c.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(d.isCancellationRequested)return n(new P.$5);const l=(0,C.$oc)(r);let $,k;const j="";/^pwsh(-preview)?$/.test(l)?($=`& '${process.execPath}' ${j} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,k=["-Login","-Command"]):l==="nu"?($=`^'${process.execPath}' ${j} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,k=["-i","-l","-c"]):l==="xonsh"?($=`import os, json; print("${h}", json.dumps(dict(os.environ)), "${h}")`,k=["-i","-l","-c"]):($=`'${process.execPath}' ${j} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,l==="tcsh"||l==="csh"?k=["-ic"]:k=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),$);const A=(0,o.spawn)(r,[...k,$],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});d.onCancellationRequested(()=>(A.kill(),n(new P.$5))),A.on("error",V=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,I.$hj)(V)),n(V)});const O=[];A.stdout.on("data",V=>O.push(V));const F=[];A.stderr.on("data",V=>F.push(V)),A.on("close",(V,Z)=>{const oe=Buffer.concat(O).toString("utf8");c.trace("getUnixShellEnvironment#raw",oe);const le=Buffer.concat(F).toString("utf8");if(le.trim()&&c.trace("getUnixShellEnvironment#stderr",le),V||Z)return n(new Error((0,S.localize)(2,null,V,Z)));const te=t.exec(oe),_=te?te[1]:"{}";try{const W=JSON.parse(_);p?W.ELECTRON_RUN_AS_NODE=p:delete W.ELECTRON_RUN_AS_NODE,E?W.ELECTRON_NO_ATTACH_CONSOLE=E:delete W.ELECTRON_NO_ATTACH_CONSOLE,delete W.VSCODE_RESOLVING_ENVIRONMENT,delete W.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",W),i(W)}catch(W){c.error("getUnixShellEnvironment#errorCaught",(0,I.$hj)(W)),n(W)}})})}}),define(ye[251],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MQ=e.$LQ=void 0,e.$LQ=(0,o.$wi)("stateReadService"),e.$MQ=(0,o.$wi)("stateService")}),define(ye[252],Ee([1,0,14,15,2,10,26,16,12]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PQ=e.$OQ=e.$NQ=e.SaveStrategy=void 0;var g;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(g||(e.SaveStrategy=g={}));class y extends S.$Vc{constructor(u,a,f,c){super(),this.h=u,this.j=a,this.m=f,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new o.$uh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(u){u.fileOperationResult!==1&&this.m.error(u)}}getItem(u,a){const f=this.a[u];return(0,D.$fg)(f)?a:f}setItem(u,a){this.setItems([{key:u,data:a}])}setItems(u){let a=!1;for(const{key:f,data:c}of u)this.a[f]!==c&&((0,D.$fg)(c)?(0,D.$dg)(this.a[f])||(this.a[f]=void 0,a=!0):(this.a[f]=c,a=!0));a&&this.s()}removeItem(u){(0,D.$dg)(this.a[u])||(this.a[u]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const u=JSON.stringify(this.a,null,4);if(u!==this.b)try{await this.n.writeFile(this.h,C.$Ge.fromString(u),{atomic:{postfix:".vsctmp"}}),this.b=u}catch(a){this.m.error(a)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$NQ=y;let v=class extends S.$Vc{constructor(u,a,f,c){super(),this.a=this.B(new y(a.stateResource,u,f,c))}async init(){await this.a.init()}getItem(u,a){return this.a.getItem(u,a)}};e.$OQ=v,e.$OQ=v=Le([Ne(1,I.$Di),Ne(2,b.$3j),Ne(3,P.$3k)],v);class w extends v{setItem(u,a){this.a.setItem(u,a)}setItems(u){this.a.setItems(u)}removeItem(u){this.a.removeItem(u)}close(){return this.a.close()}}e.$PQ=w}),define(ye[120],Ee([1,0,3,31,22]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dp=I,e.$ep=P;function D(b){if(o.$u===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}function I(b,g,y,v,w,m,u,a,f){const c=Object.create(null);c["common.machineId"]=m,c["common.sqmId"]=u,c.sessionID=(0,S.$Sg)()+Date.now(),c.commitHash=v,c.version=w,c["common.platformVersion"]=(b||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,o.$h)(o.$u),c["common.nodePlatform"]=C.$ec,c["common.nodeArch"]=y,c["common.product"]=f||"desktop",a&&(c["common.msftInternal"]=a);let d=0;const p=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),o.$l&&(c["common.snap"]="true");const E=D(g);return E&&(c["common.platformDetail"]=E),c}function P(b){const g=C.env.USERDNSDOMAIN;if(!g)return!1;const y=g.toLowerCase();return b.some(v=>y===v)}}),define(ye[253],Ee([1,0,18,11,2,21,16]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function(g){function y(v,w){return v.callstack<w.callstack?-1:v.callstack>w.callstack?1:0}g.compare=y})(P||(e.ErrorEvent=P={}));class b{static{this.ERROR_FLUSH_TIMEOUT=5*1e3}constructor(y,v=b.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new S.$Uc,this.c=y,this.d=v;const w=C.$X.addListener(m=>this.j(m));this.h.add((0,S.$Tc)(w)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(y){if(!y||y.code||(y.detail&&y.detail.stack&&(y=y.detail),C.$bb.isErrorNoTelemetry(y)||y instanceof I.$ll||typeof y?.message=="string"&&y.message.includes("Unable to read file")))return;const v=Array.isArray(y.stack)?y.stack.join(`
`):y.stack,w=y.message?y.message:(0,D.$8n)(y);v&&this.k({msg:w,callstack:v})}k(y){const v=(0,o.$wb)(this.g,y,P.compare);v<0?(y.count=1,this.g.splice(~v,0,y)):(this.g[v].count||(this.g[v].count=0),this.g[v].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const y of this.g)this.c.publicLogError2("UnhandledError",y);this.g.length=0}}e.default=b}),define(ye[254],Ee([1,0,2]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0;class C extends o.$Vc{constructor(D,I){super(),this.a=D,this.b=I}async call(D,I,P){switch(I){case"updateTelemetryLevel":{const{telemetryLevel:b}=P;return this.a.updateInjectedTelemetryLevel(b)}case"logTelemetry":{const{eventName:b,data:g}=P;return this.b?this.b.log(b,g):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${I} not found`)}listen(D,I,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.$Ps=C}),define(ye[29],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=void 0,e.$2l=(0,o.$wi)("telemetryService"),e.$3l=(0,o.$wi)("customEndpointTelemetryService"),e.$4l="telemetry.currentSessionDate",e.$5l="telemetry.firstSessionDate",e.$6l="telemetry.lastSessionDate",e.$7l="telemetry.machineId",e.$8l="telemetry.sqmId",e.$9l="telemetry",e.$0l="telemetry.telemetryLevel",e.$$l="telemetry.enableCrashReporter",e.$_l="telemetry.enableTelemetry";var C;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var S;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(S||(e.TelemetryConfiguration=S={}))}),define(ye[255],Ee([1,0,30,14,43,13,7,3,4,102,23,105,231,16,28,29]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hs=void 0,e.$Es=c,e.$Fs=p,e.$Gs=E;const f=new Map;async function c(t,s){const r=`${t}::${s.join(":")}`,i=f.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],l=new Map,$=new Map,k=2e4;function j(O,F,V,Z){const oe=F.substring(O.length+1);return C.Promises.withAsyncBody(async le=>{let te;try{te=await y.Promises.readdir(F,{withFileTypes:!0})}catch{le();return}if(Z.count>=k){Z.count+=te.length,Z.maxReached=!0,le();return}let _=te.length;if(_===0){le();return}let W=te;Z.count+te.length>k&&(Z.maxReached=!0,_=k-Z.count,W=te.slice(0,_)),Z.count+=te.length;for(const K of W)if(K.isDirectory()){if(V.includes(K.name)||await j(O,(0,I.$kc)(F,K.name),V,Z),--_===0){le();return}}else{const Y=K.name.lastIndexOf(".");if(Y>=0){const M=K.name.substring(Y+1);M&&l.set(M,(l.get(M)??0)+1)}for(const M of n)M.relativePathPattern?.test(oe)!==!1&&M.filePattern.test(K.name)&&$.set(M.tag,($.get(M.tag)??0)+1);if(--_===0){le();return}}})}const A=C.Promises.withAsyncBody(async O=>{const F={count:0,maxReached:!1};await j(t,t,s,F);const V=await E(t);O({configFiles:d($),fileTypes:d(l),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:V})});return f.set(r,A),A}function d(t){return Array.from(t.entries(),([s,r])=>({name:s,count:r})).sort((s,r)=>r.count-s.count)}function p(){const t={os:`${o.type()} ${o.arch()} ${o.release()}`,memory:`${(o.totalmem()/m.$yl.GB).toFixed(2)}GB (${(o.freemem()/m.$yl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$En.value()*100)}%`},s=o.cpus();return s&&s.length>0&&(t.cpus=`${s[0].model} (${s.length} x ${s[0].speed})`),t}async function E(t){try{const s=new Map,r=(0,I.$kc)(t,".vscode","launch.json"),i=await y.Promises.readFile(r),n=[],l=(0,S.$Jn)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,S.$Sn)(l)==="object"&&l.configurations)for(const $ of l.configurations){const k=$.type;k&&(s.has(k)?s.set(k,s.get(k)+1):s.set(k,1))}return d(s)}catch{return[]}}let h=class{constructor(s,r){this.c=s,this.d=r}f(s){const r=[];return r.push(`OS Version:       ${s.os}`),r.push(`CPUs:             ${s.cpus}`),r.push(`Memory (System):  ${s.memory}`),r.push(`VM:               ${s.vmHint}`),r.join(`
`)}g(s){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${o.type()} ${o.arch()} ${o.release()}`);const i=o.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(o.totalmem()/m.$yl.GB).toFixed(2)}GB (${(o.freemem()/m.$yl.GB).toFixed(2)}GB free)`),P.$i||r.push(`Load (avg):       ${o.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(g.$En.value()*100)}%`),r.push(`Screen Reader:    ${s.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${s.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(s.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(s,r){return Promise.all([(0,v.$Ds)(s.mainPID),this.k(s)]).then(async i=>{let[n,l]=i,$=this.m(s,n);return r.forEach(k=>{if((0,w.$en)(k))$+=`
${k.errorMessage}`,l+=`
${k.errorMessage}`;else if($+=`

Remote: ${k.hostName}`,k.processes&&($+=`
${this.m(s,k.processes)}`),k.workspaceMetadata){l+=`
|  Remote: ${k.hostName}`;for(const j of Object.keys(k.workspaceMetadata)){const A=k.workspaceMetadata[j];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),l+=`|    Folder (${j}): ${O}`,l+=this.h(A)}}}),{processInfo:$,workspaceInfo:l}})}async getSystemInfo(s,r){const{memory:i,vmHint:n,os:l,cpus:$}=p(),k={os:l,memory:i,cpus:$,vmHint:n,processArgs:`${s.mainArguments.join(" ")}`,gpuStatus:s.gpuFeatureStatus,screenReader:`${s.screenReader?"yes":"no"}`,remoteData:r};return P.$i||(k.load=`${o.loadavg().map(j=>Math.round(j)).join(", ")}`),P.$k&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(s,r){const i=[];return(0,v.$Ds)(s.mainPID).then(async n=>(i.push(""),i.push(this.g(s)),i.push(""),i.push(this.m(s,n)),s.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(s))),r.forEach(l=>{if((0,w.$en)(l))i.push(`
${l.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${l.hostName}`),i.push(this.f(l.machineInfo)),l.processes&&i.push(this.m(s,l.processes)),l.workspaceMetadata)for(const $ of Object.keys(l.workspaceMetadata)){const k=l.workspaceMetadata[$];let j=`${k.fileCount} files`;k.maxFilesReached&&(j=`more than ${j}`),i.push(`Folder (${$}): ${j}`),i.push(this.h(k))}}),i.push(""),i.push(""),i.join(`
`)))}h(s){const r=[];let n=0;const l=(A,O)=>{const F=` ${A}(${O})`;n+F.length>60?(r.push($),$="|                 ",n=$.length):n+=F.length,$+=F};let $="|      File types:";const k=10,j=s.fileTypes.length>k?k:s.fileTypes.length;for(let A=0;A<j;A++){const O=s.fileTypes[A];l(O.name,O.count)}if(r.push($),s.configFiles.length>=0&&($="|      Conf files:",n=0,s.configFiles.forEach(A=>{l(A.name,A.count)}),r.push($)),s.launchConfigFiles.length>0){let A="|      Launch Configs:";s.launchConfigFiles.forEach(O=>{const F=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;A+=F}),r.push(A)}return r.join(`
`)}j(s){const r=Math.max(...Object.keys(s).map(i=>i.length));return Object.keys(s).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${s[i]}`).join(`
                  `)}k(s){const r=[],i=[];return s.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(l=>{const $=b.URI.revive(l);if($.scheme===D.Schemas.file){const k=$.fsPath;i.push(c(k,["node_modules",".git"]).then(j=>{let A=`${j.fileCount} files`;j.maxFilesReached&&(A=`more than ${A}`),r.push(`|    Folder (${(0,I.$oc)(k)}): ${A}`),r.push(this.h(j))}).catch(j=>{r.push(`|      Error: Unable to collect workspace stats for folder ${k} (${j.toString()})`)}))}else r.push(`|    Folder (${$.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(s,r){const i=new Map;s.windows.forEach(l=>i.set(l.pid,`window [${l.id}] (${l.title})`)),s.pidToNames.forEach(({pid:l,name:$})=>i.set(l,$));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(s.mainPID,i,n,r,0),n.join(`
`)}n(s,r,i,n,l){const $=l===0;let k;$?k=n.pid===s?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?k=r.get(n.pid):k=`${"  ".repeat(l)} ${n.name}`;const j=process.platform==="win32"?n.mem:o.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(j/m.$yl.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(n.children)&&n.children.forEach(A=>this.n(s,r,i,A,l+1))}async getWorkspaceFileExtensions(s){const r=new Set;for(const{uri:i}of s.folders){const n=b.URI.revive(i);if(n.scheme!==D.Schemas.file)continue;const l=n.fsPath;try{(await c(l,["node_modules",".git"])).fileTypes.forEach(k=>r.add(k.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(s){for(const{uri:r}of s.folders){const i=b.URI.revive(r);if(i.scheme!==D.Schemas.file)continue;const n=i.fsPath;try{const l=await c(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":s.telemetryId,rendererSessionId:s.rendererSessionId}),l.fileTypes.forEach($=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:s.rendererSessionId,type:$.name,count:$.count})}),l.launchConfigFiles.forEach($=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:s.rendererSessionId,type:$.name,count:$.count})}),l.configFiles.forEach($=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:s.rendererSessionId,type:$.name,count:$.count})})}catch{}}}};e.$Hs=h,e.$Hs=h=Le([Ne(0,a.$2l),Ne(1,u.$jk)],h)}),define(ye[89],Ee([1,0,11,5,12,29]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=e.$aq=e.ExtensionSignatureVerificationCode=e.$_p=void 0,e.$_p=(0,C.$wi)("IExtensionSignatureVerificationService");var I;(function(g){g.None="None",g.RequiredArgumentMissing="RequiredArgumentMissing",g.InvalidArgument="InvalidArgument",g.PackageIsUnreadable="PackageIsUnreadable",g.UnhandledException="UnhandledException",g.SignatureManifestIsMissing="SignatureManifestIsMissing",g.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",g.SignatureIsMissing="SignatureIsMissing",g.SignatureIsUnreadable="SignatureIsUnreadable",g.CertificateIsUnreadable="CertificateIsUnreadable",g.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",g.FileAlreadyExists="FileAlreadyExists",g.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",g.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",g.Success="Success",g.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",g.SignatureIsInvalid="SignatureIsInvalid",g.SignatureManifestIsInvalid="SignatureManifestIsInvalid",g.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",g.EntryIsMissing="EntryIsMissing",g.EntryIsTampered="EntryIsTampered",g.Untrusted="Untrusted",g.CertificateRevoked="CertificateRevoked",g.SignatureIsNotValid="SignatureIsNotValid",g.UnknownError="UnknownError",g.PackageIsInvalidZip="PackageIsInvalidZip",g.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(I||(e.ExtensionSignatureVerificationCode=I={}));class P extends Error{constructor(y){super(y),this.code=y}}e.$aq=P;let b=class{constructor(y,v){this.b=y,this.c=v}d(){return this.a||(this.a=new Promise((y,v)=>he(["@vscode/vsce-sign"],async w=>y(w),v))),this.a}async verify(y,v,w){let m;try{m=await this.d()}catch(c){return this.b.error("Could not load vsce-sign module",(0,o.$0)(c)),this.b.info(`Extension signature verification is not done: ${y}`),!1}const u=new Date().getTime();let a;try{a=await m.verify(v,w,this.b.getLevel()===S.LogLevel.Trace)}catch(c){a={code:"UnknownError",didExecute:!1,output:(0,o.$0)(c)}}const f=new Date().getTime()-u;if(this.b.info(`Extension signature verification result for ${y}: ${a.code}. Duration: ${f}ms.`),this.b.trace(`Extension signature verification output for ${y}:
${a.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:y,code:a.code,duration:f,didExecute:a.didExecute}),a.code==="Success")return!0;throw new P(a.code)}};e.$bq=b,e.$bq=b=Le([Ne(0,S.$3j),Ne(1,D.$2l)],b)}),define(ye[37],Ee([1,0,21,10,86,120,29]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=void 0,e.$mp=y,e.$np=v,e.$op=w,e.$pp=m,e.$qp=a,e.$rp=c,e.$sp=d,e.$tp=h;class P{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.$fp=P;class b{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$gp=b,e.$hp=new b;class g{async publicLog(s,r,i){}async publicLogError(s,r,i){}}e.$ip=g,e.$jp="telemetry",e.$kp="extensionTelemetryLog",e.$lp={log:()=>null,flush:()=>Promise.resolve(null)};function y(t,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!t.enableTelemetry)}function v(t,s){return s.extensionTestsLocationURI?!0:!(s.isBuilt||s.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function w(t){const s=t.getValue(I.$0l),r=t.getValue(I.$$l);if(t.getValue(I.$_l)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(t){const s={},r={},i={};f(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const l=i[n];typeof l=="number"?r[n]=l:typeof l=="boolean"?r[n]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${l.length}`),s[n]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(s[n]=l)}return{properties:s,measurements:r}}const u=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function a(t){if(!t)return"none";const s=(0,S.$Im)(t);return u.has(s)?s:"other"}function f(t,s,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const l=t[n],$=i?i+n:n;Array.isArray(l)?s[$]=(0,o.$8n)(l):l instanceof Date?s[$]=l.toISOString():(0,C.$$f)(l)?r<2?f(l,s,r+1,$+"."):s[$]=(0,o.$8n)(l):s[$]=l}}function c(t,s){const r=t.msftInternalDomains||[],i=s.getValue("telemetry.internalTesting");return(0,D.$ep)(r)||i}function d(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function p(t,s){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const k of s)for(;;){const j=k.exec(t);if(!j)break;i.push([j.index,k.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let $=0;for(r="";;){const k=l.exec(t);if(!k)break;const j=i.some(([A,O])=>k.index<O&&A<l.lastIndex);!n.test(k[0])&&!j&&(r+=t.substring($,k.index)+"<REDACTED: user-file-path>",$=l.lastIndex)}return $<t.length&&(r+=t.substr($)),r}function E(t){if(!t)return t;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of s)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function h(t,s){return(0,o.$5n)(t,r=>{if(r instanceof P||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=p(i,s);for(const n of s)i=i.replace(n,"");return i=E(i),i}})}}),define(ye[38],Ee([1,0,17,32,40,3,4,11,31,37]),function(he,e,o,C,S,D,I,P,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dp=e.$vp=void 0,e.$up=y,e.$wp=u,e.$xp=a,e.$yp=f,e.$zp=c,e.$Ap=d,e.$Bp=p,e.$Cp=E,e.$Ep=h,e.$Fp=s;function y(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,o.$tf)(r.id,i.id)===0}const v=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(i){const n=i.manifest?i.manifest.version:i.version,l=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new w(i.identifier,n,l)}static parse(i){const n=v.exec(i);return n&&n[1]&&n[2]?new w({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,l="undefined"){this.version=n,this.targetPlatform=l,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof w?y(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$vp=w;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function u(r){const i=m.exec(r);return i&&i[1]?[f(i[1]),i[2]]:[f(r),void 0]}function a(r,i){return`${r}.${i}`}function f(r){return r.toLowerCase()}function c(r,i){return f(a(r??S.$Nm,i))}function d(r,i){const n=[],l=$=>{for(const k of n)if(k.some(j=>y(i(j),i($))))return k;return null};for(const $ of r){const k=l($);k?k.push($):n.push([$])}return n}function p(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}function E(r){return{id:new g.$fp(r.identifier.id),name:new g.$fp(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$Dp=new S.$Rm("pprice.better-merge");function h(r,i){const n=[],l=i.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const $=l.shift();if($&&n.every(k=>!y(k.identifier,{id:$}))){const k=r.filter(j=>y(j.identifier,{id:$}));k.length===1&&(n.push(k[0]),l.push(...k[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}async function t(r,i){if(!D.$k)return!1;let n;try{n=(await r.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch($){i.debug("Error while getting the os-release file.",(0,P.$0)($))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,i){const n=await t(r,i),l=(0,C.$2o)(n?"alpine":D.$u,b.$fc);return i.debug("ComputeTargetPlatform:",l),l}}),define(ye[121],Ee([1,0,20,11,13,19,57,4,193,32,38,40]),function(he,e,o,C,S,D,I,P,b,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;const w=a=>(0,b.localize)(0,null,a),m=(0,b.localize)(1,null,"ms-dotnettools.csharp");let u=class{constructor(f,c,d){this.a=f,this.b=c,this.d=d}get f(){}async listExtensions(f,c,d){let p=await this.b.getInstalled(1,d);const E=v.$Qm.map(t=>t.toLowerCase());if(c&&c!==""){if(E.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(t=>t.manifest.categories?t.manifest.categories.map(r=>r.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),E.forEach(t=>{this.a.info(t)});return}this.f&&this.a.info((0,b.localize)(2,null,this.f)),p=p.sort((t,s)=>t.identifier.id.localeCompare(s.identifier.id));let h;for(const t of p)h!==t.identifier.id&&(h=t.identifier.id,this.a.info(f?`${h}@${t.manifest.version}`:h))}async installExtensions(f,c,d,p){const E=[];try{f.length&&this.a.info(this.f?(0,b.localize)(3,null,this.f):(0,b.localize)(4,null));const h=[],t=[],s=(i,n,l)=>{t.push({id:i,version:n!=="prerelease"?n:void 0,installOptions:{...d,isBuiltin:l,installPreReleaseVersion:n==="prerelease"||d.installPreReleaseVersion}})};for(const i of f)if(i instanceof P.URI)h.push({vsix:i,installOptions:d});else{const[n,l]=(0,y.$wp)(i);s(n,l,!1)}for(const i of c)if(i instanceof P.URI)h.push({vsix:i,installOptions:{...d,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[n,l]=(0,y.$wp)(i);s(n,l,!0)}const r=await this.b.getInstalled(void 0,d.profileLocation);if(h.length&&await Promise.all(h.map(async({vsix:i,installOptions:n})=>{try{await this.h(i,n,p,r)}catch(l){this.a.error(l),E.push(i.toString())}})),t.length){const i=await this.g(t,r,p);E.push(...i)}}catch(h){throw this.a.error((0,b.localize)(5,null,(0,C.$0)(h))),h}if(E.length)throw new Error((0,b.localize)(6,null,E.join(", ")))}async updateExtensions(f){const c=await this.b.getInstalled(1,f),d=[];for(const t of c)t.identifier.uuid&&d.push({...t.identifier,preRelease:t.preRelease});this.a.trace((0,b.localize)(7,null,d.length));const p=await this.d.getExtensions(d,{compatible:!0},o.CancellationToken.None),E=[];for(const t of p)for(const s of c)(0,y.$up)(s.identifier,t.identifier)&&(0,I.gt)(t.version,s.manifest.version)&&E.push({extension:t,options:{operation:3,installPreReleaseVersion:s.preRelease,profileLocation:f}});if(!E.length){this.a.info((0,b.localize)(8,null));return}this.a.info((0,b.localize)(9,null,E.map(t=>t.extension.identifier.id).join(", ")));const h=await this.b.installGalleryExtensions(E);for(const t of h)t.error?this.a.error((0,b.localize)(10,null,t.identifier.id,(0,C.$0)(t.error))):this.a.info((0,b.localize)(11,null,t.identifier.id,t.local?.manifest.version))}async g(f,c,d){if(f=f.filter(({id:t,version:s})=>{const r=c.find(i=>(0,y.$up)(i.identifier,{id:t}));if(r){if(!d&&(!s||s==="prerelease"&&r.preRelease))return this.a.info((0,b.localize)(12,null,t,r.manifest.version,t)),!1;if(s&&r.manifest.version===s)return this.a.info((0,b.localize)(13,null,`${t}@${s}`)),!1}return!0}),!f.length)return[];const p=[],E=[],h=await this.j(f);if(await Promise.all(f.map(async({id:t,version:s,installOptions:r})=>{const i=h.get(t.toLowerCase());if(!i){this.a.error(`${w(s?`${t}@${s}`:t)}
${m}`),p.push(t);return}try{const l=await this.d.getManifest(i,o.CancellationToken.None);if(l&&!this.k(l))return}catch(l){this.a.error(l.message||l.stack||l),p.push(t);return}const n=c.find(l=>(0,y.$up)(l.identifier,i.identifier));if(n){if(i.version===n.manifest.version){this.a.info((0,b.localize)(14,null,s?`${t}@${s}`:t));return}this.a.info((0,b.localize)(15,null,t,i.version))}r.isBuiltin?this.a.info(s?(0,b.localize)(16,null,t,s):(0,b.localize)(17,null,t)):this.a.info(s?(0,b.localize)(18,null,t,s):(0,b.localize)(19,null,t)),E.push({extension:i,options:{...r,installGivenVersion:!!s}})})),E.length){const t=await this.b.installGalleryExtensions(E);for(const s of t)s.error?(this.a.error((0,b.localize)(20,null,s.identifier.id,(0,C.$0)(s.error))),p.push(s.identifier.id)):this.a.info((0,b.localize)(21,null,s.identifier.id,s.local?.manifest.version))}return p}async h(f,c,d,p){const E=await this.b.getManifest(f);if(!E)throw new Error("Invalid vsix");if(await this.l(E,d,c.profileLocation,p))try{await this.b.install(f,c),this.a.info((0,b.localize)(22,null,(0,D.$7g)(f)))}catch(t){if((0,C.$4)(t))this.a.info((0,b.localize)(23,null,(0,D.$7g)(f)));else throw t}}async j(f){const c=new Map,d=f.some(h=>h.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),E=[];for(const h of f)g.$Uo.test(h.id)&&E.push({...h,preRelease:d});if(E.length){const h=await this.d.getExtensions(E,{targetPlatform:p},o.CancellationToken.None);for(const t of h)c.set(t.identifier.id.toLowerCase(),t)}return c}k(f){return!0}async l(f,c,d,p){if(!c){const E={id:(0,y.$zp)(f.publisher,f.name)},h=p.find(t=>(0,y.$up)(E,t.identifier)&&(0,I.gt)(t.manifest.version,f.version));if(h)return this.a.info((0,b.localize)(24,null,h.identifier.id,h.manifest.version,f.version)),!1}return this.k(f)}async uninstallExtensions(f,c,d){const p=async h=>{if(h instanceof P.URI){const t=await this.b.getManifest(h);return(0,y.$xp)(t.publisher,t.name)}return h},E=[];for(const h of f){const t=await p(h),r=(await this.b.getInstalled(void 0,d)).filter(i=>(0,y.$up)(i.identifier,{id:t}));if(!r.length)throw new Error(`${this.m(t)}
${m}`);if(r.some(i=>i.type===0)){this.a.info((0,b.localize)(25,null,t));return}if(!c&&r.some(i=>i.isBuiltin)){this.a.info((0,b.localize)(26,null,t));return}this.a.info((0,b.localize)(27,null,t));for(const i of r)await this.b.uninstall(i,{profileLocation:d}),E.push(i);this.f?this.a.info((0,b.localize)(28,null,t,this.f)):this.a.info((0,b.localize)(29,null,t))}}async locateExtension(f){const c=await this.b.getInstalled();f.forEach(d=>{c.forEach(p=>{if(p.identifier.id===d&&p.location.scheme===S.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(f){return this.f?(0,b.localize)(30,null,f,this.f):(0,b.localize)(31,null,f)}};e.$cq=u,e.$cq=u=Le([Ne(1,g.$9o),Ne(2,g.$6o)],u)}),define(ye[256],Ee([1,0,14,11,2,13,19,57,10,22,23,81,25,26,32,38,89,16,12]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=void 0;let E=class extends S.$Vc{static{p=this}static{this.c=".sigzip"}constructor(t,s,r,i,n,l){super(),this.h=s,this.j=r,this.m=i,this.n=n,this.r=l,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(t,s,r){await this.g;const i=(0,I.$0g)(this.extensionsDownloadDir,this.z(t));try{await this.w(t,i,l=>this.j.download(t,l,s))}catch(l){throw new u.$7o(l.message,u.ExtensionManagementErrorCode.Download)}let n=!1;if(r&&this.t(t)){const l=await this.u(t);try{n=await this.n.verify(t.identifier.id,i.fsPath,l.fsPath)}catch($){if(n=$.code,n==="PackageIsInvalidZip"||n==="SignatureArchiveIsInvalidZip"){try{await this.delete(i)}catch(j){this.r.error(j)}throw new u.$7o(v.$gq,u.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(l)}catch($){this.r.error($)}}}return{location:i,verificationStatus:n}}t(t){if(!t.isSigned)return this.r.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,b.$cg)(s)?s:!0}async u(t){await this.g;const s=(0,I.$0g)(this.extensionsDownloadDir,`${this.z(t)}${p.c}`);try{await this.w(t,s,r=>this.j.downloadSignatureArchive(t,r))}catch(r){throw new u.$7o(r.message,u.ExtensionManagementErrorCode.DownloadSignature)}return s}async w(t,s,r){if(await this.h.exists(s))return;if(s.scheme!==D.Schemas.file){await r(s);return}const i=(0,I.$0g)(this.extensionsDownloadDir,`.${(0,g.$Sg)()}`);await this.h.exists(i)||await r(i);try{await y.Promises.rename(i.fsPath,s.fsPath,2*60*1e3)}catch(n){try{await this.h.del(i)}catch{}if(n.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.r.info(`Rename failed because of ${(0,C.$0)(n)}. Deleted the file from downloaded location`,i.path),n}}async delete(t){await this.g,await this.h.del(t)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],r=[],i=[];for(const $ of t.children)if($.name.endsWith(p.c))i.push($.resource);else{const k=a.$vp.parse($.name);k&&r.push([k,$])}const n=(0,a.$Ap)(r,([$])=>$),l=[];for(const $ of n)$.sort((k,j)=>P.rcompare(k[0].version,j[0].version)),s.push(...$.slice(1).map(k=>k[1].resource)),l.push($[0][1]);l.sort(($,k)=>$.mtime-k.mtime),s.push(...l.slice(0,Math.max(0,l.length-this.f)).map($=>$.resource)),s.push(...i),await o.Promises.settled(s.map($=>(this.r.trace("Deleting from cache",$.path),this.h.del($))))}}catch(t){this.r.error(t)}}z(t){return this.f?a.$vp.create(t).toString().toLowerCase():(0,g.$Sg)()}};e.$yq=E,e.$yq=E=p=Le([Ne(0,m.$Ei),Ne(1,c.$3k),Ne(2,u.$6o),Ne(3,w.$3i),Ne(4,f.$_p),Ne(5,d.$3j)],E)}),define(ye[257],Ee([1,0,6,2,24,38,40]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=void 0;class P extends C.$Vc{constructor(g,y,v,w,m,u,a){super(),this.f=g,this.g=y,this.h=v,this.j=w,this.m=m,this.n=u,this.r=a,this.a=this.B(new o.$ee),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new C.$5c),this.s().then(null,f=>a.error(f))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(y=>(this.c.set(y.id,(0,C.$Sc)(this.n.watch(this.m.extUri.dirname(y.extensionsResource)),this.n.watch(y.extensionsResource))),this.G(y.extensionsResource))))}catch(y){throw this.r.error(y),y}}async w(g){for(const y of g.extensions)this.I(this.L(y.identifier,y.version),g.profileLocation)}async y(g){for(const y of g.extensions){const v=this.L(y.identifier,y.version);g.error?this.J(v,g.profileLocation):this.I(v,g.profileLocation)}}async z(g){for(const y of g.extensions)this.J(this.L(y.identifier,y.version),g.profileLocation)}async C(g){const y=[],v=[];for(const w of g.extensions){const m=this.L(w.identifier,w.version);g.error?this.I(m,g.profileLocation):(this.J(m,g.profileLocation),this.b.has(m)||(this.r.debug("Extension is removed from all profiles",w.identifier.id,w.version),v.push(this.f.scanInstalledExtensionAtLocation(w.location).then(u=>{u?y.push(u):this.r.info("Extension not found at the location",w.location.toString())},u=>this.r.error(u)))))}try{await Promise.all(v),y.length&&await this.H(y)}catch(w){this.r.error(w)}}D(g){for(const y of this.h.profiles)g.contains(y.extensionsResource,0,1)&&this.F(y.extensionsResource)}async F(g){const y=[],v=[],w=await this.j.scanProfileExtensions(g),m=new Set,u=new Set;for(const[a,f]of this.b)f.has(g)&&u.add(a);for(const a of w){const f=this.L(a.identifier,a.version);m.add(f),u.has(f)||(y.push(a.identifier),this.I(f,g))}for(const a of u)if(!m.has(a)){const f=this.M(a);f&&(v.push(f.identifier),this.J(a,g))}(y.length||v.length)&&this.a.fire({added:y.length?{extensions:y,profileLocation:g}:void 0,removed:v.length?{extensions:v,profileLocation:g}:void 0})}async G(g){const y=await this.j.scanProfileExtensions(g);for(const v of y)this.I(this.L(v.identifier,v.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(v=>!this.b.has(this.L(v.identifier,v.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,y){let v=this.b.get(g);v||this.b.set(g,v=new S.$Cc(w=>this.m.extUri.getComparisonKey(w))),v.add(y)}J(g,y){const v=this.b.get(g);v&&v.delete(y),v?.size||this.b.delete(g)}L(g,y){return`${I.$Rm.toKey(g.id)}@${y}`}M(g){const[y,v]=(0,D.$wp)(g);return v?{identifier:{id:y},version:v}:void 0}}e.$Cq=P}),define(ye[258],Ee([1,0,229,37]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=S;async function S(D,I,P,b,g,y,v){const w={"X-Market-Client-Id":`VSCode ${D}`,"User-Agent":`VSCode ${D} (${I.nameShort})`};if((0,C.$mp)(I,P)&&(0,C.$op)(b)===3){const m=await(0,o.$7p)(P,g,y);w["X-Market-User-Id"]=m,w["VSCode-SessionId"]=v.machineId||m}return w}}),define(ye[122],Ee([1,0,90,18,14,2,13,7,23,26,32,38,12,85,4]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=void 0;let a=class extends m.$Sr{constructor(p,E,h,t){super(h),this.h=p,this.j=t,this.g=this.B(new f(E,t)),this.h.registerParticipant({postInstall:async s=>this.m(s),postUninstall:async s=>this.n(s)})}async getBuiltInExtensionTranslationsUri(p,E){const t=(await this.g.getLanguagePacks())[E];if(!t){this.j.warn(`No language pack found for ${E}`);return}const s=t.translations[p];return s?u.URI.file(s):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),E=Object.keys(p).map(h=>{const t=p[h];return{...this.f(h,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return E.push(this.f("en","English")),E.sort((h,t)=>h.label.localeCompare(t.label)),E}async m(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",p.identifier.id),await this.update())}async n(p){const E=await this.g.getLanguagePacks();Object.keys(E).some(h=>E[h]&&E[h].extensions.some(t=>(0,v.$up)(t.extensionIdentifier,p.identifier)))&&(this.j.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,E]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),h=await this.g.update(E);return!(0,C.$ub)(Object.keys(p),Object.keys(h))}};e.$Tr=a,e.$Tr=a=Le([Ne(0,y.$9o),Ne(1,g.$Ei),Ne(2,y.$6o),Ne(3,w.$3j)],a);let f=class extends D.$Vc{constructor(p,E){super(),this.j=E,this.c={},this.f=(0,P.$kc)(p.userDataPath,"languagepacks.json"),this.g=new S.$Dh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.s(E=>{Object.keys(E).forEach(h=>delete E[h]),this.m(E,...p)}).then(()=>this.c)}m(p,...E){for(const h of E)h&&h.manifest&&h.manifest.contributes&&h.manifest.contributes.localizations&&h.manifest.contributes.localizations.length&&this.n(p,h);Object.keys(p).forEach(h=>this.r(p[h]))}n(p,E){const h=E.identifier,t=E.manifest.contributes&&E.manifest.contributes.localizations?E.manifest.contributes.localizations:[];for(const s of t)if(E.location.scheme===I.Schemas.file&&c(s)){let r=p[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},p[s.languageId]=r);const i=r.extensions.filter(n=>(0,v.$up)(n.extensionIdentifier,h))[0];i?i.version=E.manifest.version:r.extensions.push({extensionIdentifier:h,version:E.manifest.version});for(const n of s.translations)r.translations[n.id]=(0,P.$kc)(E.location.fsPath,n.path)}}r(p){if(p){const E=(0,o.createHash)("md5");for(const h of p.extensions)E.update(h.extensionIdentifier.uuid||h.extensionIdentifier.id).update(h.version);p.hash=E.digest("hex")}}s(p=()=>null){return this.g.queue(()=>{let E=null;return b.Promises.readFile(this.f,"utf8").then(void 0,h=>h.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(h)).then(h=>{try{return JSON.parse(h)}catch{return{}}}).then(h=>(E=p(h),h)).then(h=>{for(const s of Object.keys(h))h[s]||delete h[s];this.c=h,this.h=!0;const t=JSON.stringify(this.c);return this.j.debug("Writing language packs",t),b.Promises.writeFile(this.f,t)}).then(()=>E,h=>this.j.error(h))})}};f=Le([Ne(0,g.$Ei),Ne(1,w.$3j)],f);function c(d){if(typeof d.languageId!="string"||!Array.isArray(d.translations)||d.translations.length===0)return!1;for(const p of d.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(d.languageName&&typeof d.languageName!="string"||d.localizedLanguageName&&typeof d.localizedLanguageName!="string")}}),define(ye[259],Ee([1,0,178,11,21,37]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function b(y,v,w){const m=await(0,o.$7D)("@microsoft/1ds-core-js","dist/ms.core.js"),u=await(0,o.$7D)("@microsoft/1ds-post-js","dist/ms.post.js"),a=new m.AppInsightsCore,f=new u.PostChannel,c={instrumentationKey:y,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(w){c.extensionConfig={};const d={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:w};c.extensionConfig[f.identifier]=d}return a.initialize(c,[]),a.addTelemetryInitializer(d=>{d.ext=d.ext??{},d.ext.web=d.ext.web??{},d.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',v&&(d.ext.utc=d.ext.utc??{},d.ext.utc.flags=8462029)}),a}class g{constructor(v,w,m,u,a){this.e=v,this.f=w,this.g=m,this.h=a,this.c=I,this.d=P,this.g||(this.g={}),typeof u=="function"?this.a=u():this.a=u,this.b=null}i(v){if(this.a){if(typeof this.a!="string"){v(this.a);return}this.b||(this.b=b(this.a,this.e,this.h)),this.b.then(w=>{v(w)},w=>{(0,C.$1)(w),console.error(w)})}}log(v,w){if(!this.a)return;w=(0,S.$6n)(w,this.g),w=(0,D.$pp)(w);const m=this.f+"/"+v;try{this.i(u=>{u.pluginVersionString=w?.properties.version??"Unknown",u.track({name:m,baseData:{name:m,properties:w?.properties,measurements:w?.measurements}})})}catch{}}flush(){return this.a?new Promise(v=>{this.i(w=>{w.unload(!0,()=>{this.a=void 0,v(void 0)})})}):Promise.resolve(void 0)}}e.$HQ=g}),define(ye[260],Ee([1,0,2,21,3,17,208,25,49,58,28,36,29,37]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=void 0;let u=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,d,p){this.k=d,this.l=p,this.d={},this.i=new o.$Uc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const E of this.f)this.j.push(new RegExp((0,D.$af)(E),"gi")),E.indexOf("\\")>=0&&this.j.push(new RegExp((0,D.$af)(E.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(E=>{(E.affectsConfiguration(w.$0l)||E.affectsConfiguration(w.$_l)||E.affectsConfiguration(w.$$l))&&this.m()}))}setExperimentProperty(c,d){this.d[c]=d}m(){let c=(0,m.$op)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const p=d.usage?3:d.error?2:0;c=Math.min(c,p)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,d,p){this.g<d||(p=(0,C.$6n)(p,this.d),p=(0,m.$tp)(p,this.j),p=(0,C.$6n)(p,this.c),this.b.forEach(E=>E.log(c,p)))}publicLog(c,d){this.n(c,3,d)}publicLog2(c,d){this.publicLog(c,d)}publicLogError(c,d){this.h&&this.n(c,2,d)}publicLogError2(c,d){this.publicLogError(c,d)}};e.$Zr=u,e.$Zr=u=Le([Ne(1,P.$3i),Ne(2,y.$jk)],u);function a(){const f=(0,I.localize)(0,null,g.default.nameLong),c=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=S.$o?"":(0,I.localize)(3,null),p=(0,I.localize)(4,null),E=(0,I.localize)(5,null),h=(0,I.localize)(6,null),t=(0,I.localize)(7,null),s=`
|       | ${p} | ${E} | ${h} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,I.localize)(8,null);return`
${f} ${c} ${d}

&nbsp;

${t}
${s}

&nbsp;

${r}
`}v.$co.as(b.$ho.Configuration).registerConfiguration({id:w.$9l,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[w.$0l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:a(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.$co.as(b.$ho.Configuration).registerConfiguration({id:w.$9l,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[w.$_l]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${w.$0l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ye[261],Ee([1,0,25,5,28,29,260,37]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Os=e.$Ns=e.$Ms=void 0;let b=class extends I.$Zr{constructor(y,v,w,m){super(y,w,m),this.o=v}publicLog(y,v){if(!(this.o<3))return super.publicLog(y,v)}publicLog2(y,v){return this.publicLog(y,v)}publicLogError(y,v){return this.o<2?Promise.resolve(void 0):super.publicLogError(y,v)}publicLogError2(y,v){return this.publicLogError(y,v)}async updateInjectedTelemetryLevel(y){if(y===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,y):y,this.o===0&&this.dispose()}};e.$Ms=b,e.$Ms=b=Le([Ne(2,o.$3i),Ne(3,S.$jk)],b),e.$Ns=new class extends P.$gp{async updateInjectedTelemetryLevel(){}},e.$Os=(0,C.$xi)(D.$2l)}),define(ye[262],Ee([1,0,15,20,314,259]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=void 0;async function I(y,v){const w=await v.request(y,C.CancellationToken.None),m=(await(0,o.$Se)(w.stream)).toString(),u=w.res.statusCode??200;return{headers:w.res.headers,statusCode:u,responseData:m}}async function P(y){const v={method:y.type,headers:y.headers};return new Promise((m,u)=>{const a=S.request(y.url??"",v,f=>{f.on("data",function(c){m({headers:f.headers,statusCode:f.statusCode??200,responseData:c.toString()})}),f.on("error",function(c){u(c)})});a.write(y.data,f=>{f&&u(f)}),a.end()})}async function b(y,v,w){const m=typeof v.data=="string"?v.data:new TextDecoder().decode(v.data),u={type:"POST",headers:{...v.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(v.data).toString()},url:v.urlString,data:m};try{const a=y?await I(u,y):await P(u);w(a.statusCode,a.headers,a.responseData)}catch{w(0,{})}}class g extends D.$HQ{constructor(v,w,m,u,a){const f={sendPOST:(c,d)=>{b(v,c,d)}};super(w,m,u,a,f)}}e.$IQ=g}),define(ye[263],Ee([1,0,11,253]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class S extends C.default{i(){(0,o.setUnexpectedErrorHandler)(P=>console.error(P));const I=[];process.on("unhandledRejection",(P,b)=>{I.push(b),setTimeout(()=>{const g=I.indexOf(b);g>=0&&b.catch(y=>{I.splice(g,1),(0,o.$4)(y)||(console.warn(`rejected promise not handled within 1 second: ${y}`),y.stack&&console.warn(`stack trace: ${y.stack}`),P&&(0,o.$1)(P))})},1e3)}),process.on("rejectionHandled",P=>{const b=I.indexOf(P);b>=0&&I.splice(b,1)}),process.on("uncaughtException",P=>{(0,o.$Z)(P)||(0,o.$1)(P)})}}e.default=S}),define(ye[123],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var o;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(o||(e.EnvironmentVariableMutatorType=o={}))}),define(ye[124],Ee([1,0,3,123]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=void 0;const S=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class D{constructor(y){this.collections=y,this.a=new Map,this.b=new Map,y.forEach((v,w)=>{this.d(v,w);const m=v.map.entries();let u=m.next();for(;!u.done;){const a=u.value[1],f=u.value[0];let c=this.a.get(f);if(c||(c=[],this.a.set(f,c)),c.length>0&&c[0].type===C.EnvironmentVariableMutatorType.Replace){u=m.next();continue}const d={extensionIdentifier:w,value:a.value,type:a.type,scope:a.scope,variable:a.variable,options:a.options};d.scope||delete d.scope,c.unshift(d),u=m.next()}})}async applyToProcessEnvironment(y,v,w){let m;o.$i&&(m={},Object.keys(y).forEach(u=>m[u.toLowerCase()]=u));for(const[u,a]of this.getVariableMap(v)){const f=o.$i&&m[u.toLowerCase()]||u;for(const c of a){const d=w?await w(c.value):c.value;if(c.options?.applyAtProcessCreation??!0)switch(c.type){case C.EnvironmentVariableMutatorType.Append:y[f]=(y[f]||"")+d;break;case C.EnvironmentVariableMutatorType.Prepend:y[f]=d+(y[f]||"");break;case C.EnvironmentVariableMutatorType.Replace:y[f]=d;break}if(c.options?.applyAtShellIntegration??!1){const p=`VSCODE_ENV_${S.get(c.type)}`;y[p]=(y[p]?y[p]+":":"")+u+"="+this.c(d)}}}}c(y){return y.replaceAll(":","\\x3a")}diff(y,v){const w=new Map,m=new Map,u=new Map;if(y.getVariableMap(v).forEach((a,f)=>{const c=this.getVariableMap(v).get(f),d=P(a,c);d&&w.set(f,d)}),this.getVariableMap(v).forEach((a,f)=>{const c=y.getVariableMap(v).get(f),d=P(a,c);d&&u.set(f,d)}),this.getVariableMap(v).forEach((a,f)=>{const c=y.getVariableMap(v).get(f),d=b(a,c);d&&m.set(f,d)}),!(w.size===0&&m.size===0&&u.size===0))return{added:w,changed:m,removed:u}}getVariableMap(y){const v=new Map;for(const w of this.a.values()){const m=w.filter(u=>I(u,y));m.length>0&&v.set(m[0].variable,m)}return v}getDescriptionMap(y){const v=new Map;for(const w of this.b.values()){const m=w.filter(u=>I(u,y,!0));for(const u of m)v.set(u.extensionIdentifier,u.description)}return v}d(y,v){if(!y.descriptionMap)return;const w=y.descriptionMap.entries();let m=w.next();for(;!m.done;){const u=m.value[1],a=m.value[0];let f=this.b.get(a);f||(f=[],this.b.set(a,f));const c={extensionIdentifier:v,scope:u.scope,description:u.description};c.scope||delete c.scope,f.push(c),m=w.next()}}}e.$rs=D;function I(g,y,v=!1){return g.scope?!!(g.scope.workspaceFolder&&y?.workspaceFolder&&g.scope.workspaceFolder.index===y.workspaceFolder.index):v?y===g.scope:!0}function P(g,y){if(!y)return g;const v=new Set;y.forEach(m=>v.add(m.extensionIdentifier));const w=[];return g.forEach(m=>{v.has(m.extensionIdentifier)||w.push(m)}),w.length===0?void 0:w}function b(g,y){if(!y)return;const v=new Map;y.forEach(m=>v.set(m.extensionIdentifier,m));const w=[];return g.forEach(m=>{const u=v.get(m.extensionIdentifier);u&&(m.type!==u.type||m.value!==u.value||m.scope?.workspaceFolder?.index!==u.scope?.workspaceFolder?.index)&&w.push(u)}),w.length===0?void 0:w}}),define(ye[91],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=o,e.$ms=C,e.$ns=S,e.$os=D,e.$ps=I,e.$qs=P;function o(b){return[...b.entries()]}function C(b){return b?[...b.entries()]:[]}function S(b){return new Map(b)}function D(b){return new Map(b??[])}function I(b){return Array.from(b.entries()).map(g=>[g[0],o(g[1].map),C(g[1].descriptionMap)])}function P(b){return new Map(b.map(g=>[g[0],{map:S(g[1]),descriptionMap:D(g[2])}]))}}),define(ye[264],Ee([1,0,14,20,6,2,12]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=void 0;let P=class extends D.$Vc{constructor(g,y){super(),this.h=y,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new S.$ee),this.onCreateRequest=this.g.event,this.b=g===void 0?15e3:g,this.B((0,D.$Tc)(()=>{for(const v of this.f.values())(0,D.$Qc)(v)}))}createRequest(g){return new Promise((y,v)=>{const w=++this.a;this.c.set(w,y),this.g.fire({requestId:w,...g});const m=new C.$pe;(0,o.$xh)(this.b,m.token).then(()=>v(`Request ${w} timed out (${this.b}ms)`)),this.f.set(w,[(0,D.$Tc)(()=>m.cancel())])})}acceptReply(g,y){const v=this.c.get(g);v?(this.c.delete(g),(0,D.$Qc)(this.f.get(g)||[]),this.f.delete(g),v(y)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${g}`)}};e.$cs=P,e.$cs=P=Le([Ne(1,I.$3j)],P)}),define(ye[92],Ee([1,0,5,47,36]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$r=e.$0r=e.$9r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$8r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$7r=void 0,e.$7r=new C.$Nj("terminalTabFocusMode",!1,!0);var D;(function(h){h.AutomationProfile="terminal.integrated.automationProfile.",h.DefaultProfile="terminal.integrated.defaultProfile.",h.Profiles="terminal.integrated.profiles."})(D||(e.TerminalSettingPrefix=D={}));var I;(function(h){h.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",h.AutomationProfileLinux="terminal.integrated.automationProfile.linux",h.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",h.AutomationProfileWindows="terminal.integrated.automationProfile.windows",h.ProfilesWindows="terminal.integrated.profiles.windows",h.ProfilesMacOs="terminal.integrated.profiles.osx",h.ProfilesLinux="terminal.integrated.profiles.linux",h.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",h.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",h.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",h.UseWslProfiles="terminal.integrated.useWslProfiles",h.TabsDefaultColor="terminal.integrated.tabs.defaultColor",h.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",h.TabsEnabled="terminal.integrated.tabs.enabled",h.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",h.TabsHideCondition="terminal.integrated.tabs.hideCondition",h.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",h.TabsShowActions="terminal.integrated.tabs.showActions",h.TabsLocation="terminal.integrated.tabs.location",h.TabsFocusMode="terminal.integrated.tabs.focusMode",h.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",h.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",h.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",h.CopyOnSelection="terminal.integrated.copyOnSelection",h.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",h.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",h.FontFamily="terminal.integrated.fontFamily",h.FontSize="terminal.integrated.fontSize",h.LetterSpacing="terminal.integrated.letterSpacing",h.LineHeight="terminal.integrated.lineHeight",h.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",h.TabStopWidth="terminal.integrated.tabStopWidth",h.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",h.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",h.BellDuration="terminal.integrated.bellDuration",h.FontWeight="terminal.integrated.fontWeight",h.FontWeightBold="terminal.integrated.fontWeightBold",h.CursorBlinking="terminal.integrated.cursorBlinking",h.CursorStyle="terminal.integrated.cursorStyle",h.CursorStyleInactive="terminal.integrated.cursorStyleInactive",h.CursorWidth="terminal.integrated.cursorWidth",h.Scrollback="terminal.integrated.scrollback",h.DetectLocale="terminal.integrated.detectLocale",h.DefaultLocation="terminal.integrated.defaultLocation",h.GpuAcceleration="terminal.integrated.gpuAcceleration",h.TerminalTitleSeparator="terminal.integrated.tabs.separator",h.TerminalTitle="terminal.integrated.tabs.title",h.TerminalDescription="terminal.integrated.tabs.description",h.RightClickBehavior="terminal.integrated.rightClickBehavior",h.MiddleClickBehavior="terminal.integrated.middleClickBehavior",h.Cwd="terminal.integrated.cwd",h.ConfirmOnExit="terminal.integrated.confirmOnExit",h.ConfirmOnKill="terminal.integrated.confirmOnKill",h.EnableBell="terminal.integrated.enableBell",h.EnableVisualBell="terminal.integrated.enableVisualBell",h.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",h.AllowChords="terminal.integrated.allowChords",h.AllowMnemonics="terminal.integrated.allowMnemonics",h.TabFocusMode="terminal.integrated.tabFocusMode",h.EnvMacOs="terminal.integrated.env.osx",h.EnvLinux="terminal.integrated.env.linux",h.EnvWindows="terminal.integrated.env.windows",h.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",h.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",h.ShowExitAlert="terminal.integrated.showExitAlert",h.SplitCwd="terminal.integrated.splitCwd",h.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",h.WordSeparators="terminal.integrated.wordSeparators",h.EnableFileLinks="terminal.integrated.enableFileLinks",h.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",h.UnicodeVersion="terminal.integrated.unicodeVersion",h.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",h.LocalEchoEnabled="terminal.integrated.localEchoEnabled",h.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",h.LocalEchoStyle="terminal.integrated.localEchoStyle",h.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",h.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",h.HideOnStartup="terminal.integrated.hideOnStartup",h.CustomGlyphs="terminal.integrated.customGlyphs",h.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",h.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",h.InheritEnv="terminal.integrated.inheritEnv",h.ShowLinkHover="terminal.integrated.showLinkHover",h.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",h.AutoReplies="terminal.integrated.autoReplies",h.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",h.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",h.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",h.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",h.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",h.EnableImages="terminal.integrated.enableImages",h.SmoothScrolling="terminal.integrated.smoothScrolling",h.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",h.FocusAfterRun="terminal.integrated.focusAfterRun",h.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",h.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",h.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",h.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",h.MouseWheelZoom="terminal.integrated.mouseWheelZoom",h.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",h.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",h.DevMode="terminal.integrated.developer.devMode"})(I||(e.TerminalSettingId=I={}));var P;(function(h){h.PowerShell="pwsh",h.Bash="bash",h.Fish="fish",h.Sh="sh",h.Csh="csh",h.Ksh="ksh",h.Zsh="zsh",h.Python="python"})(P||(e.PosixShellType=P={}));var b;(function(h){h.CommandPrompt="cmd",h.PowerShell="pwsh",h.Wsl="wsl",h.GitBash="gitbash",h.Python="python"})(b||(e.WindowsShellType=b={}));var g;(function(h){h[h.Api=0]="Api",h[h.Process=1]="Process",h[h.Sequence=2]="Sequence",h[h.Config=3]="Config"})(g||(e.TitleEventSource=g={}));var y;(function(h){h.LocalPty="localPty",h.PtyHost="ptyHost",h.PtyHostWindow="ptyHostWindow",h.Logger="logger",h.Heartbeat="heartbeat"})(y||(e.TerminalIpcChannels=y={}));var v;(function(h){h.Cwd="cwd",h.InitialCwd="initialCwd",h.FixedDimensions="fixedDimensions",h.Title="title",h.ShellType="shellType",h.HasChildProcesses="hasChildProcesses",h.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",h.OverrideDimensions="overrideDimensions",h.FailedShellIntegrationActivation="failedShellIntegrationActivation",h.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(v||(e.ProcessPropertyType=v={})),e.$8r=(0,o.$wi)("ptyService");var w;(function(h){h[h.BeatInterval=5e3]="BeatInterval",h[h.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",h[h.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",h[h.SecondWaitMultiplier=1]="SecondWaitMultiplier",h[h.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w||(e.HeartbeatConstants=w={}));var m;(function(h){h[h.Panel=1]="Panel",h[h.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var u;(function(h){h.TerminalView="view",h.Editor="editor"})(u||(e.TerminalLocationString=u={}));var a;(function(h){h[h.GraceTime=6e4]="GraceTime",h[h.ShortGraceTime=6e3]="ShortGraceTime"})(a||(e.LocalReconnectConstants=a={}));var f;(function(h){h[h.HighWatermarkChars=1e5]="HighWatermarkChars",h[h.LowWatermarkChars=5e3]="LowWatermarkChars",h[h.CharCountAckSize=5e3]="CharCountAckSize"})(f||(e.FlowControlConstants=f={}));var c;(function(h){h.GitBash="Git Bash",h.Pwsh="PowerShell"})(c||(e.ProfileSource=c={}));var d;(function(h){h[h.Off=0]="Off",h[h.FinalTerm=1]="FinalTerm",h[h.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var p;(function(h){h[h.Unknown=0]="Unknown",h[h.Shutdown=1]="Shutdown",h[h.Process=2]="Process",h[h.User=3]="User",h[h.Extension=4]="Extension"})(p||(e.TerminalExitReason=p={})),e.$9r={Backend:"workbench.contributions.terminal.processBackend"};class E{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const s=this.b(t.remoteAuthority);if(this.a.has(s))throw new Error(`A terminal backend with remote authority '${s}' was already registered.`);this.a.set(s,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}S.$co.add(e.$9r.Backend,new E),e.$0r=(0,o.$wi)("localPtyService"),e.$$r=(0,o.$wi)("terminalLogService")}),define(ye[125],Ee([1,0,3]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kQ=C,e.$lQ=S,e.$mQ=D,e.$nQ=I;function C(P){let b=P;b.includes("\\")&&(b=b.replace(/\\/g,"\\\\"));const g=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return b=b.replace(g,""),`'${b}'`}function S(P,b,g){if(!P)return"";if(!b)return P;b.match(/[\/\\]$/)&&(b=b.slice(0,b.length-1));const y=P.replace(/\\/g,"/").toLowerCase(),v=b.replace(/\\/g,"/").toLowerCase();return y.includes(v)?`~${g}${P.slice(b.length+1)}`:P}function D(P){return P.match(/^['"].*['"]$/)&&(P=P.substring(1,P.length-1)),o.OS===1&&P&&P[1]===":"?P[0].toUpperCase()+P.substring(1):P}function I(P){return!P.strictEnv}}),define(ye[265],Ee([1,0,53,4,210,76]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ds=I,e.$es=g,e.$fs=y,e.$gs=v;function I(w,m){const u=[{name:null,description:(0,S.localize)(0,null)}];return u.push(...w.map(a=>({name:a.profileName,description:P(a)}))),m&&u.push(...m.map(a=>({name:a.title,description:b(a)}))),{values:u.map(a=>a.name),markdownDescriptions:u.map(a=>a.description)}}function P(w){let m=`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:o.$Vj.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?m+=`
- args: "${w.args}"`:m+=`
- args: [${w.args.length===0?"":`'${w.args.join("','")}'`}]`),w.overrideName!==void 0&&(m+=`
- overrideName: ${w.overrideName}`),w.color&&(m+=`
- color: ${w.color}`),w.env&&(m+=`
- env: ${JSON.stringify(w.env)}`),m}function b(w){return`$(${D.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:o.$Vj.terminal.id}) ${w.title}
- extensionIdentifier: ${w.extensionIdentifier}`}function g(w,m){if(!w&&!m)return!0;if(typeof w=="string"&&typeof m=="string")return w===m;if(Array.isArray(w)&&Array.isArray(m)){if(w.length!==m.length)return!1;for(let u=0;u<w.length;u++)if(w[u]!==m[u])return!1;return!0}return!1}function y(w,m){if(!w&&!m)return!0;if(!w||!m)return!1;if(D.ThemeIcon.isThemeIcon(w)&&D.ThemeIcon.isThemeIcon(m))return w.id===m.id&&w.color===m.color;if(typeof w=="object"&&"light"in w&&"dark"in w&&typeof m=="object"&&"light"in m&&"dark"in m){const u=w,a=m;if((C.URI.isUri(u.light)||v(u.light))&&(C.URI.isUri(u.dark)||v(u.dark))&&(C.URI.isUri(a.light)||v(a.light))&&(C.URI.isUri(a.dark)||v(a.dark)))return u.light.path===a.light.path&&u.dark.path===a.dark.path}if(C.URI.isUri(w)&&C.URI.isUri(m)||v(w)||v(m)){const u=w,a=m;return u.path===a.path&&u.scheme===a.scheme}return!1}function v(w){return w?typeof w.path=="string"&&typeof w.scheme=="string":!1}}),define(ye[266],Ee([1,0,53,3,209,49,36,265]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$is=e.$hs=void 0,e.$js=m,e.$ks=a,e.$hs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$is={type:"string",enum:Array.from((0,o.$Tj)(),f=>f.id),markdownEnumDescriptions:Array.from((0,o.$Tj)(),f=>`$(${f.id})`)};const b={args:{description:(0,S.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,S.localize)(1,null),type:"boolean"},icon:{description:(0,S.localize)(2,null),...e.$is},color:{description:(0,S.localize)(3,null),...e.$hs},env:{markdownDescription:(0,S.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},g={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},y={type:"object",required:["path"],properties:{path:{description:(0,S.localize)(6,null),type:["string"],items:{type:"string"}},...b}};function v(f){const c=f===2?"linux":f===1?"osx":"windows";return(0,S.localize)(7,null,(0,C.$h)(f),'```json\n"terminal.integrated.profile.'+c+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const w={id:"terminal",order:100,title:(0,S.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},y],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:v(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,S.localize)(12,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(13,null),type:"string"},id:{description:(0,S.localize)(14,null),type:"string"},title:{description:(0,S.localize)(15,null),type:"string"},...b}},{type:"null"},g]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:v(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(16,null),type:"string"},id:{description:(0,S.localize)(17,null),type:"string"},title:{description:(0,S.localize)(18,null),type:"string"},...b}},{type:"null"},g]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:v(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,S.localize)(19,null),type:"string"},id:{description:(0,S.localize)(20,null),type:"string"},title:{description:(0,S.localize)(21,null),type:"string"},...b}},{type:"null"},g]}},"terminal.integrated.useWslProfiles":{description:(0,S.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,S.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,S.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,S.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,S.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){I.$co.as(D.$ho.Configuration).registerConfiguration(w),a()}let u;function a(f,c){const d=I.$co.as(D.$ho.Configuration);let p;f&&(p=(0,P.$ds)(f?.profiles,c));const E=u;u={id:"terminal",order:100,title:(0,S.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,S.localize)(28,null),type:["string","null"],default:null,enum:f?.os===3?p?.values:void 0,markdownEnumDescriptions:f?.os===3?p?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,S.localize)(29,null),type:["string","null"],default:null,enum:f?.os===2?p?.values:void 0,markdownEnumDescriptions:f?.os===2?p?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,S.localize)(30,null),type:["string","null"],default:null,enum:f?.os===1?p?.values:void 0,markdownEnumDescriptions:f?.os===1?p?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[u],remove:E?[E]:[]})}}),define(ye[267],Ee([1,0,2,13,108,26,109]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3Q=void 0;let P=class extends o.$Vc{constructor(g,y){super(),this.a=g,this.b=y}start(){const g={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.b.logsHome.with({scheme:C.Schemas.file}).fsPath],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.a.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.a.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.a.scrollback}},y=(0,I.$0m)(this.b.args,this.b.isBuilt);y&&(y.break&&y.port?g.debugBrk=y.port:!y.break&&y.port&&(g.debug=y.port));const v=new S.$1q(C.$Qg.asFileUri("bootstrap-fork").fsPath,g),w=new o.$Uc;return w.add(v),{client:v,store:w,onDidProcessExit:v.onDidProcessExit}}};e.$3Q=P,e.$3Q=P=Le([Ne(1,D.$Di)],P)}),define(ye[268],Ee([1,0,30,13,21,7,3,31,17,10,23,123,91,124]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=u,e.$ts=a,e.$us=f;function u(){const l=/(\d+)\.(\d+)\.(\d+)/g.exec(o.release());let $=0;return l&&l.length===4&&($=parseInt(l[3])),$}async function a(l,$,k,j=P.env,A=y.Promises.exists){if(D.$jc(l))return await A(l)?l:void 0;if($===void 0&&($=P.cwd()),D.$nc(l)!=="."){const Z=D.$kc($,l);return await A(Z)?Z:void 0}const F=(0,S.$0n)(j,"PATH");if(k===void 0&&(0,g.$9f)(F)&&(k=F.split(D.$uc)),k===void 0||k.length===0){const Z=D.$kc($,l);return await A(Z)?Z:void 0}for(const Z of k){let oe;if(D.$jc(Z)?oe=D.$kc(Z,l):oe=D.$kc($,Z,l),await A(oe))return oe;if(I.$i){let le=oe+".com";if(await A(le)||(le=oe+".exe",await A(le)))return le}}const V=D.$kc($,l);return await A(V)?V:void 0}function f(l,$,k,j,A){const O=I.$i&&(!$.windowsEnableConpty||u()<18309);if(!$.shellIntegration.enabled||!l.executable||l.isFeatureTerminal&&!l.forceShellIntegration||l.ignoreShellIntegration||O)return;const F=l.args,V=P.$ec==="win32"?D.$oc(l.executable).toLowerCase():D.$oc(l.executable),Z=D.$nc(C.$Qg.asFileUri("").fsPath);let oe;const le={VSCODE_INJECTION:"1"};if($.shellIntegration.nonce&&(le.VSCODE_NONCE=$.shellIntegration.nonce),I.$i){if(V==="pwsh.exe"||V==="powershell.exe")return!F||i(F)?oe=p.get(d.WindowsPwsh):r(F)&&(oe=p.get(d.WindowsPwshLogin)),oe?(oe=[...oe],oe[oe.length-1]=(0,b.$9e)(oe[oe.length-1],Z,""),$.shellIntegration.suggestEnabled&&(le.VSCODE_SUGGEST="1"),{newArgs:oe,envMixin:le}):void 0;if(V==="bash.exe")return!F||F.length===0?oe=p.get(d.Bash):n(F)&&(le.VSCODE_SHELL_LOGIN="1",c($,le),oe=p.get(d.Bash)),oe?(oe=[...oe],oe[oe.length-1]=(0,b.$9e)(oe[oe.length-1],Z),{newArgs:oe,envMixin:le}):void 0;j.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args);return}switch(V){case"bash":return!F||F.length===0?oe=p.get(d.Bash):n(F)&&(le.VSCODE_SHELL_LOGIN="1",c($,le),oe=p.get(d.Bash)),oe?(oe=[...oe],oe[oe.length-1]=(0,b.$9e)(oe[oe.length-1],Z),{newArgs:oe,envMixin:le}):void 0;case"fish":{const te=k?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",_=D.$kc(Z,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return le.XDG_DATA_DIRS=`${te}:${_}`,c($,le),{newArgs:void 0,envMixin:le}}case"pwsh":return!F||i(F)?oe=p.get(d.Pwsh):r(F)&&(oe=p.get(d.PwshLogin)),oe?($.shellIntegration.suggestEnabled&&(le.VSCODE_SUGGEST="1"),oe=[...oe],oe[oe.length-1]=(0,b.$9e)(oe[oe.length-1],Z,""),{newArgs:oe,envMixin:le}):void 0;case"zsh":{if(!F||F.length===0?oe=p.get(d.Zsh):n(F)?(oe=p.get(d.ZshLogin),c($,le)):(F===p.get(d.Zsh)||F===p.get(d.ZshLogin))&&(oe=F),!oe)return;oe=[...oe],oe[oe.length-1]=(0,b.$9e)(oe[oe.length-1],Z);let te;try{te=o.userInfo().username}catch{te="unknown"}const _=D.$kc(o.tmpdir(),`${te}-${A.applicationName}-zsh`);le.ZDOTDIR=_;const W=k?.ZDOTDIR??o.homedir()??"~";le.USER_ZDOTDIR=W;const K=[];return K.push({source:D.$kc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:D.$kc(_,".zshrc")}),K.push({source:D.$kc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:D.$kc(_,".zprofile")}),K.push({source:D.$kc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:D.$kc(_,".zshenv")}),K.push({source:D.$kc(Z,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:D.$kc(_,".zlogin")}),{newArgs:oe,envMixin:le,filesToCopy:K}}}j.warn(`Shell integration cannot be enabled for executable "${l.executable}" and args`,l.args)}function c(l,$){if(I.$j&&l.environmentVariableCollections){const k=(0,w.$qs)(l.environmentVariableCollections),A=new m.$rs(k).getVariableMap({workspaceFolder:l.workspaceFolder}).get("PATH"),O=[];if(A)for(const F of A)F.type===v.EnvironmentVariableMutatorType.Prepend&&O.push(F.value);O.length>0&&($.VSCODE_PATH_PREFIX=O.join(""))}}var d;(function(l){l.WindowsPwsh="windows-pwsh",l.WindowsPwshLogin="windows-pwsh-login",l.Pwsh="pwsh",l.PwshLogin="pwsh-login",l.Zsh="zsh",l.ZshLogin="zsh-login",l.Bash="bash"})(d||(d={}));const p=new Map;p.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),p.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),p.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),p.set(d.Zsh,["-i"]),p.set(d.ZshLogin,["-il"]),p.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const E=["-login","-l"],h=["--login","-l"],t=["-i","--interactive"],s=["-nol","-nologo"];function r(l){return typeof l=="string"?E.includes(l.toLowerCase()):l.length===1&&E.includes(l[0].toLowerCase())||l.length===2&&(E.includes(l[0].toLowerCase())||E.includes(l[1].toLowerCase()))&&(s.includes(l[0].toLowerCase())||s.includes(l[1].toLowerCase()))}function i(l){return typeof l=="string"?s.includes(l.toLowerCase()):l.length===0||l?.length===1&&s.includes(l[0].toLowerCase())}function n(l){return typeof l!="string"&&(l=l.filter($=>!t.includes($.toLowerCase()))),l==="string"&&h.includes(l.toLowerCase())||typeof l!="string"&&l.length===1&&h.includes(l[0].toLowerCase())}}),define(ye[269],Ee([1,0,56,53,7,3,10,23,103,268,77]),function(he,e,o,C,S,D,I,P,b,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=u;var v;(function(l){l.UnixShellsPath="/etc/shells"})(v||(v={}));let w,m=!0;function u(l,$,k,j,A=process.env,O,F,V,Z){return O=O||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},D.$i?a(k,O,A,F,j.getValue("terminal.integrated.useWslProfiles")!==!1,l&&typeof l=="object"?{...l}:j.getValue("terminal.integrated.profiles.windows"),typeof $=="string"?$:j.getValue("terminal.integrated.defaultProfile.windows"),Z,V):r(O,F,k,l&&typeof l=="object"?{...l}:j.getValue(D.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof $=="string"?$:j.getValue(D.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),Z,V,A)}async function a(l,$,k,j,A,O,F,V,Z){const oe=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),le=`${process.env.windir}\\${oe?"Sysnative":"System32"}`;let te=!1;(0,g.$ss)()>=16299&&(te=!0),await p(V);const _=new Map;if(l){_.set("PowerShell",{source:"PowerShell",icon:C.$Vj.terminalPowershell,isAutoDetected:!0}),_.set("Windows PowerShell",{path:`${le}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Vj.terminalPowershell,isAutoDetected:!0}),_.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),_.set("Command Prompt",{path:`${le}\\cmd.exe`,icon:C.$Vj.terminalCmd,isAutoDetected:!0}),_.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),_.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$Vj.terminalBash,isAutoDetected:!0});const K=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;_.set("Cmder",{path:`${le}\\cmd.exe`,args:["/K",K],requiresPath:process.env.CMDER_ROOT?K:{path:K,isUnsafe:!0},isAutoDetected:!0})}i(O,_);const W=await f(_.entries(),F,$,k,j,Z);if(l&&A)try{const K=await t(`${le}\\${te?"wsl":"bash"}.exe`,F);for(const Y of K)(!O||!(Y.profileName in O))&&W.push(Y)}catch{m&&(j?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return W}async function f(l,$,k,j=process.env,A,O){const F=[];for(const[V,Z]of l)F.push(c(V,Z,$,k,j,A,O));return(await Promise.all(F)).filter(V=>!!V)}async function c(l,$,k,j,A=process.env,O,F){if($===null)return;let V,Z,oe;if("source"in $&&!("path"in $)){const W=w?.get($.source);if(!W)return;V=W.paths,Z=$.args||W.args,$.icon?oe=d($.icon):W.icon&&(oe=W.icon)}else V=Array.isArray($.path)?$.path:[$.path],Z=D.$i||Array.isArray($.args)?$.args:void 0,oe=d($.icon);let le;if(F){const W=V.map(Y=>typeof Y=="string"?Y:Y.path),K=await F(W);le=new Array(V.length);for(let Y=0;Y<V.length;Y++)typeof V[Y]=="string"?le[Y]=K[Y]:le[Y]={path:K[Y],isUnsafe:!0}}else le=V.slice();let te;if($.requiresPath){let W;if((0,I.$9f)($.requiresPath)?W=$.requiresPath:(W=$.requiresPath.path,$.requiresPath.isUnsafe&&(te=W)),!await j.existsFile(W))return}const _=await n(l,k,le,j,A,Z,$.env,$.overrideName,$.isAutoDetected,te);if(!_){O?.debug("Terminal profile not validated",l,V);return}return _.isAutoDetected=$.isAutoDetected,_.icon=oe,_.color=$.color,_}function d(l){return typeof l=="string"?{id:l}:l}async function p(l){if(w&&!l)return;const[$,k]=await Promise.all([E(),l||h()]);w=new Map,w.set("Git Bash",{profileName:"Git Bash",paths:$,args:["--login","-i"]}),w.set("PowerShell",{profileName:"PowerShell",paths:k,icon:C.$Vj.terminalPowershell})}async function E(){const l=new Set,$=await(0,g.$ts)("git.exe");if($){const A=(0,y.dirname)($);l.add((0,y.resolve)(A,"../.."))}function k(A,O){O&&A.add(O)}k(l,process.env.ProgramW6432),k(l,process.env.ProgramFiles),k(l,process.env["ProgramFiles(X86)"]),k(l,`${process.env.LocalAppData}\\Program`);const j=[];for(const A of l)j.push(`${A}\\Git\\bin\\bash.exe`,`${A}\\Git\\usr\\bin\\bash.exe`,`${A}\\usr\\bin\\bash.exe`);return j.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),j.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),j}async function h(){const l=[];for await(const $ of(0,b.$km)())l.push($.exePath);return l}async function t(l,$){const k=[],j=await new Promise((F,V)=>{o.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(Z,oe)=>{if(Z)return V("Problem occurred when getting wsl distros");F(oe)})});if(!j)return[];const A=new RegExp(/[\r?\n]/),O=j.split(A).filter(F=>F.trim().length>0&&F!=="");for(const F of O){if(F===""||F.startsWith("docker-desktop"))continue;const V=`${F} (WSL)`,Z={profileName:V,path:l,args:["-d",`${F}`],isDefault:V===$,icon:s(F),isAutoDetected:!1};k.push(Z)}return k}function s(l){return l.includes("Ubuntu")?C.$Vj.terminalUbuntu:l.includes("Debian")?C.$Vj.terminalDebian:C.$Vj.terminalLinux}async function r(l,$,k,j,A,O,F,V){const Z=new Map;if(k&&await l.existsFile("/etc/shells")){const oe=(await l.readFile("/etc/shells")).toString(),le=(O||oe.split(`
`)).map(_=>{const W=_.indexOf("#");return W===-1?_:_.substring(0,W)}).filter(_=>_.trim().length>0),te=new Map;for(const _ of le){let W=(0,S.$oc)(_),K=te.get(W)||0;K++,K>1&&(W=`${W} (${K})`),te.set(W,K),Z.set(W,{path:_,isAutoDetected:!0})}}return i(j,Z),await f(Z.entries(),A,l,V,$,F)}function i(l,$){if(l)for(const[k,j]of Object.entries(l))j===null||typeof j!="object"||!("path"in j)&&!("source"in j)?$.delete(k):(j.icon=j.icon||$.get(k)?.icon,$.set(k,j))}async function n(l,$,k,j,A,O,F,V,Z,oe){if(k.length===0)return Promise.resolve(void 0);const le=k.shift();if(le==="")return n(l,$,k,j,A,O,F,V,Z);const te=typeof le!="string"&&le.isUnsafe,_=typeof le=="string"?le:le.path,W={profileName:l,path:_,args:O,env:F,overrideName:V,isAutoDetected:Z,isDefault:l===$,isUnsafePath:te,requiresUnsafePath:oe};if((0,S.$oc)(_)===_){const Y=A.PATH?A.PATH.split(S.$uc):void 0,M=await(0,g.$ts)(_,void 0,Y,void 0,j.existsFile);return M?(W.path=M,W.isFromPath=!0,W):n(l,$,k,j,A,O)}return await j.existsFile((0,S.$ic)(_))?W:n(l,$,k,j,A,O,F,V,Z)}}),define(ye[270],Ee([1,0,6,2,3,46,25,12,114,88,264,92,266,269,106,61]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ws=void 0;var f;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=class extends C.$Vc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(p,E,h,t){super(),this.M=p,this.N=E,this.O=h,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new o.$ee),this.onPtyHostExit=this.u.event,this.w=this.B(new o.$ee),this.onPtyHostStart=this.w.event,this.y=this.B(new o.$ee),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new o.$ee),this.onPtyHostResponsive=this.z.event,this.C=this.B(new o.$ee),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new o.$ee),this.onProcessData=this.D.event,this.F=this.B(new o.$ee),this.onProcessReady=this.F.event,this.G=this.B(new o.$ee),this.onProcessReplay=this.G.event,this.H=this.B(new o.$ee),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new o.$ee),this.onDidRequestDetach=this.I.event,this.J=this.B(new o.$ee),this.onDidChangeProperty=this.J.event,this.L=this.B(new o.$ee),this.onProcessExit=this.L.event,(0,w.$js)(),this.B(this.M),this.B((0,C.$Tc)(()=>this.W())),this.j=this.B(new y.$cs(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&o.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(S.$i)return process.env;try{return await(0,g.$Gm)(this.N,this.O,{_:[]},process.env)}catch(p){return this.O.error("ptyHost was unable to resolve shell environment",p),{}}}U(){const p=this.M.start(),E=p.client;this.O.getLevel()===P.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),D.ProxyChannel.toService(E.getChannel(v.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(p.onDidProcessExit(s=>{this.u.fire(s.code),!this.m&&!this.q.isDisposed&&(this.n<=f.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${s.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${s.code}, giving up`))}));const t=D.ProxyChannel.toService(E.getChannel(v.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(s=>this.D.fire(s))),this.B(t.onProcessReady(s=>this.F.fire(s))),this.B(t.onProcessExit(s=>this.L.fire(s))),this.B(t.onDidChangeProperty(s=>this.J.fire(s))),this.B(t.onProcessReplay(s=>this.G.fire(s))),this.B(t.onProcessOrphanQuestion(s=>this.H.fire(s))),this.B(t.onDidRequestDetach(s=>this.I.fire(s))),this.B(new b.$bs(this.P,E.getChannel(v.TerminalIpcChannels.Logger))),this.a=p,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async s=>{s.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[p,t]}async createProcess(p,E,h,t,s,r,i,n,l,$,k){const j=setTimeout(()=>this.$(),v.HeartbeatConstants.CreateProcessTimeout),A=await this.f.createProcess(p,E,h,t,s,r,i,n,l,$,k);return clearTimeout(j),A}updateTitle(p,E,h){return this.f.updateTitle(p,E,h)}updateIcon(p,E,h,t){return this.f.updateIcon(p,E,h,t)}attachToProcess(p){return this.f.attachToProcess(p)}detachFromProcess(p,E){return this.f.detachFromProcess(p,E)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(p){return this.f.start(p)}shutdown(p,E){return this.f.shutdown(p,E)}input(p,E){return this.f.input(p,E)}processBinary(p,E){return this.f.processBinary(p,E)}resize(p,E,h){return this.f.resize(p,E,h)}clearBuffer(p){return this.f.clearBuffer(p)}acknowledgeDataEvent(p,E){return this.f.acknowledgeDataEvent(p,E)}setUnicodeVersion(p,E){return this.f.setUnicodeVersion(p,E)}getInitialCwd(p){return this.f.getInitialCwd(p)}getCwd(p){return this.f.getCwd(p)}async getLatency(){const p=new a.$ae,E=await this.f.getLatency();return p.stop(),[{label:"ptyhostservice<->ptyhost",latency:p.elapsed()},...E]}orphanQuestionReply(p){return this.f.orphanQuestionReply(p)}installAutoReply(p,E){return this.f.installAutoReply(p,E)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(p){return this.f.uninstallAutoReply(p)}getDefaultSystemShell(p){return this.g?.getDefaultSystemShell(p)??(0,u.$qm)(p??S.OS,process.env)}async getProfiles(p,E,h,t=!1){const s=await this.S();return(0,m.$vs)(E,h,t,this.N,s,void 0,this.O,this.bb.bind(this,p))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(p,E){return this.f.getWslPath(p,E)}getRevivedPtyNewId(p,E){return this.f.getRevivedPtyNewId(p,E)}setTerminalLayoutInfo(p){return this.f.setTerminalLayoutInfo(p)}async getTerminalLayoutInfo(p){return this.g?.getTerminalLayoutInfo(p)}async requestDetachInstance(p,E){return this.f.requestDetachInstance(p,E)}async acceptDetachInstanceReply(p,E){return this.f.acceptDetachInstanceReply(p,E)}async freePortKillProcess(p){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(p)}async serializeTerminalState(p){return this.f.serializeTerminalState(p)}async reviveTerminalProcesses(p,E,h){return this.f.reviveTerminalProcesses(p,E,h)}async refreshProperty(p,E){return this.f.refreshProperty(p,E)}async updateProperty(p,E,h){return this.f.updateProperty(p,E,h)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(p){this.ab(),this.s=setTimeout(()=>this.Y(),p?v.HeartbeatConstants.ConnectingBeatInterval:v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier+v.HeartbeatConstants.BeatInterval*v.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${v.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(p,E){return this.j.createRequest({workspaceId:p,originalText:E})}async acceptPtyHostResolvedVariables(p,E){this.j.acceptReply(p,E)}};e.$ws=c,e.$ws=c=Le([Ne(1,I.$3i),Ne(2,P.$3j),Ne(3,P.$4j)],c)}),define(ye[34],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=void 0,e.$Al=(0,o.$wi)("IUriIdentityService")}),define(ye[126],Ee([1,0,34,110,16,19,157,6,2]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$As=void 0;class g{static{this._clock=0}constructor(w){this.uri=w,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let y=class{constructor(w){this.g=w,this.c=new b.$Uc,this.f=2**16;const m=new Map,u=a=>{let f=m.get(a.scheme);return f===void 0&&(f=w.hasProvider(a)&&!this.g.hasCapability(a,1024),m.set(a.scheme,f)),f};this.c.add(P.Event.any(w.onDidChangeFileSystemProviderRegistrations,w.onDidChangeFileSystemProviderCapabilities)(a=>{m.delete(a.scheme)})),this.extUri=new D.$Yg(u),this.d=new I.$zs((a,f)=>this.extUri.compare(a,f,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(w){this.g.hasProvider(w)&&(w=(0,D.$$g)(w));const m=this.d.get(w);return m?m.touch().uri.with({fragment:w.fragment}):(this.d.set(w,new g(w)),this.h(),w)}h(){if(this.d.size<this.f)return;const w=[...this.d.entries()].sort((u,a)=>u[1].time<a[1].time?1:u[1].time>a[1].time?-1:0);g._clock=0,this.d.clear();const m=this.f*.5;for(let u=0;u<m;u++)this.d.set(w[u][0],w[u][1].touch())}};e.$As=y,e.$As=y=Le([Ne(0,S.$3k)],y),(0,C.$xs)(o.$Al,y,1)}),define(ye[93],Ee([1,0,212,7,64,19,4,5,13]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yi=e.$Vi=e.$Ui=e.$Ti=e.$Si=e.$Qi=e.$Pi=e.WorkbenchState=e.$Ji=e.$Ii=e.$Fi=void 0,e.$Gi=g,e.$Hi=y,e.$Ki=v,e.$Li=w,e.$Mi=m,e.$Ni=a,e.$Oi=f,e.$Ri=p,e.$Wi=E,e.$Xi=h,e.$Zi=t,e.$1i=s,e.$2i=r,e.$Fi=(0,P.$wi)("contextService");function g(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.uri)}function y(i){return typeof i?.id=="string"&&!g(i)&&!w(i)}e.$Ii={id:"ext-dev"},e.$Ji={id:"empty-window"};function v(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$oc)(i)}:n?e.$Ii:e.$Ji;const l=i;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}function w(i){const n=i;return typeof n?.id=="string"&&I.URI.isUri(n.configPath)}function m(i){const n=i;if(n?.uri)return{id:n.id,uri:I.URI.revive(n.uri)};const l=i;if(l?.configPath)return{id:l.id,configPath:I.URI.revive(l.configPath)};if(i?.id)return{id:i.id}}var u;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(u||(e.WorkbenchState=u={}));function a(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}function f(i){const n=i;return!!(n&&typeof n=="object"&&I.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}class c{constructor(n,l,$,k,j){this.h=n,this.j=$,this.k=k,this.l=j,this.c=S.$Ci.forUris(this.l,()=>!0),this.folders=l}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=S.$Ci.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Pi=c;class d{constructor(n,l){this.raw=l,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,D.$0g)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Qi=d;function p(i){return new d({uri:i,index:0,name:(0,D.$6g)(i)},{uri:i.toString()})}e.$Si="code-workspace",e.$Ti=`.${e.$Si}`,e.$Ui=[{name:(0,o.localize)(0,null),extensions:[e.$Si]}],e.$Vi="workspace.json";function E(i,n){return D.$1g.isEqualOrParent(i,n.untitledWorkspacesHome)}function h(i){let n;return I.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===b.Schemas.tmp}e.$Yi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Yi}function s(i,n){return!E(i,n)&&!h(i)}function r(i){return(typeof i=="string"?(0,C.$pc)(i):(0,D.$8g)(i))===e.$Ti}}),define(ye[33],Ee([1,0,62,6,2,19,4,211,26,16,5,12,93,24,34,14,22,17,10]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gl=e.$Fl=e.$Cl=e.ProfileResourceType=void 0,e.$Bl=E,e.$Dl=h,e.$El=t;var p;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(p||(e.ProfileResourceType=p={}));function E(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&I.URI.isUri(n.location)&&I.URI.isUri(n.globalStorageHome)&&I.URI.isUri(n.settingsResource)&&I.URI.isUri(n.keybindingsResource)&&I.URI.isUri(n.tasksResource)&&I.URI.isUri(n.snippetsHome)&&I.URI.isUri(n.extensionsResource))}e.$Cl=(0,y.$wi)("IUserDataProfilesService");function h(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:I.URI.revive(i.location).with({scheme:n}),globalStorageHome:I.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:I.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:I.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:I.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:I.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:I.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:I.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,n,l,$,k,j){return{id:i,name:n,location:l,isDefault:!1,shortName:k?.shortName,icon:k?.icon,globalStorageHome:j&&k?.useDefaultFlags?.globalState?j.globalStorageHome:(0,D.$0g)(l,"globalStorage"),settingsResource:j&&k?.useDefaultFlags?.settings?j.settingsResource:(0,D.$0g)(l,"settings.json"),keybindingsResource:j&&k?.useDefaultFlags?.keybindings?j.keybindingsResource:(0,D.$0g)(l,"keybindings.json"),tasksResource:j&&k?.useDefaultFlags?.tasks?j.tasksResource:(0,D.$0g)(l,"tasks.json"),snippetsHome:j&&k?.useDefaultFlags?.snippets?j.snippetsHome:(0,D.$0g)(l,"snippets"),extensionsResource:j&&k?.useDefaultFlags?.extensions?j.extensionsResource:(0,D.$0g)(l,"extensions.json"),cacheHome:(0,D.$0g)($,i),useDefaultFlags:k?.useDefaultFlags,isTransient:k?.transient}}let s=class extends S.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,l,$,k){super(),this.t=n,this.u=l,this.w=$,this.y=k,this.f=!0,this.h=this.B(new C.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Bc,emptyWindows:new Map},this.profilesHome=(0,D.$0g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,D.$0g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),l=[n];if(this.f)try{for(const j of this.O()){if(!j.name||!(0,d.$9f)(j.name)||!j.location){this.y.warn("Skipping the invalid stored profile",j.location||j.name);continue}l.push(t((0,D.$7g)(j.location),j.name,j.location,this.g,{shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags},n))}}catch(j){this.y.error(j)}const $=new m.$Bc,k=new Map;if(l.length)try{const j=this.Q();if(j.workspaces)for(const[A,O]of Object.entries(j.workspaces)){const F=I.URI.parse(A),V=l.find(Z=>Z.id===O);V&&$.set(F,V)}if(j.emptyWindows)for(const[A,O]of Object.entries(j.emptyWindows)){const F=l.find(V=>V.id===O);F&&k.set(A,F)}}catch(j){this.y.error(j)}this.z={profiles:l,workspaces:$,emptyWindows:k}}return this.z}D(){const n=t("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const l="Temp",$=new RegExp(`${(0,c.$af)(l)}\\s(\\d+)`);let k=0;for(const A of this.profiles){const O=$.exec(A.name),F=O?parseInt(O[1]):0;k=F>k?F:k}const j=`${l} ${k+1}`;return this.createProfile((0,o.$kj)((0,f.$Sg)()).toString(16),j,{transient:!0},n)}async createNamedProfile(n,l,$){return this.createProfile((0,o.$kj)((0,f.$Sg)()).toString(16),n,l,$)}async createProfile(n,l,$,k){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const j=await this.F(n,l,$);return k&&await this.setProfileForWorkspace(k,j),j}async F(n,l,$){if(!(0,d.$9f)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let k=this.r.get(l);return k||(k=(async()=>{try{if(this.profiles.find(F=>F.name===l||F.id===n))throw new Error(`Profile with ${l} name already exists`);const A=t(n,l,(0,D.$0g)(this.profilesHome,n),this.g,$,this.defaultProfile);await this.u.createFolder(A.location);const O=[];return this.j.fire({profile:A,join(F){O.push(F)}}),await a.Promises.settled(O),this.I([A],[],[]),A}finally{this.r.delete(l)}})(),this.r.set(l,k)),k}async updateProfile(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let $=this.profiles.find(k=>k.id===n.id);if(!$)throw new Error(`Profile '${n.name}' does not exist`);return $=t($.id,l.name??$.name,$.location,this.g,{shortName:l.shortName??$.shortName,icon:l.icon===null?void 0:l.icon??$.icon,transient:l.transient??$.isTransient,useDefaultFlags:l.useDefaultFlags??$.useDefaultFlags},this.defaultProfile),this.I([],[],[$]),$}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(k=>k.id===n.id);if(!l)throw new Error(`Profile '${n.name}' does not exist`);const $=[];this.m.fire({profile:l,join(k){$.push(k)}});try{await Promise.allSettled($)}catch(k){this.y.error(k)}for(const k of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(k)?.id&&this.C.emptyWindows.delete(k);for(const k of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(k)?.id&&this.C.workspaces.delete(k);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(k){(0,g.$hl)(k)!==1&&this.y.error(k)}}async setProfileForWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const $=this.profiles.find(k=>k.id===l.id);if(!$)throw new Error(`Profile '${l.name}' does not exist`);this.L(n,$)}unsetWorkspace(n,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(l=>l.isDirectory&&this.profiles.every($=>!this.w.extUri.isEqual($.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(n.map(l=>this.removeProfile(l)))}getProfileForWorkspace(n){const l=this.G(n);return I.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(n){return(0,w.$Gi)(n)?n.uri:(0,w.$Li)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,n.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,n.location)))}I(n,l,$){const k=[...this.profiles,...n],j=[];this.s.profiles=[];for(let A of k)A.isDefault||l.some(O=>A.id===O.id)||(A=$.find(O=>A.id===O.id)??A,A.isTransient?this.s.profiles.push(A):j.push({location:A.location,name:A.name,shortName:A.shortName,icon:A.icon,useDefaultFlags:A.useDefaultFlags}));this.P(j),this.z=void 0,this.J(n,l,$)}J(n,l,$){this.h.fire({added:n,removed:l,updated:$,all:this.profiles})}L(n,l,$){$=l?.isTransient?!0:$,$||this.L(n,void 0,!0);const k=this.G(n),j=$?this.s:this.C;I.URI.isUri(k)?(j.workspaces.delete(k),l&&j.workspaces.set(k,l)):(j.emptyWindows.delete(k),l&&j.emptyWindows.set(k,l)),$||this.M()}M(){const n={};for(const[$,k]of this.C.workspaces.entries())n[$.toString()]=k.id;const l={};for(const[$,k]of this.C.emptyWindows.entries())l[$.toString()]=k.id;this.R({workspaces:n,emptyWindows:l}),this.z=void 0}N(n){const l={},$=this.D();if(n.workspaces)for(const[j,A]of Object.entries(n.workspaces)){const O=I.URI.parse(A);l[j]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}const k={};if(n.emptyWindows)for(const[j,A]of Object.entries(n.emptyWindows)){const O=I.URI.parse(A);k[j]=this.w.extUri.isEqual(O,$.location)?$.id:this.w.extUri.basename(O)}return{workspaces:l,emptyWindows:k}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$Fl=s,e.$Fl=s=Le([Ne(0,b.$Di),Ne(1,g.$3k),Ne(2,u.$Al),Ne(3,v.$3j)],s);class r extends s{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$Gl=r}),define(ye[271],Ee([1,0,18,14,20,11,6,2,3,10,4,191,32,38,40,12,28,29,34,33]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nq=e.$lq=void 0,e.$mq=h;let E=class extends P.$Vc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(i,n,l,$,k,j){super(),this.z=i,this.C=n,this.D=l,this.F=$,this.G=k,this.H=j,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$ee),this.s=this.B(new I.$ee),this.t=this.B(new I.$ee),this.u=this.B(new I.$ee),this.w=this.B(new I.$ee),this.y=[],this.B((0,P.$Tc)(()=>{this.j.forEach(({task:A})=>A.cancel()),this.m.forEach(A=>A.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(i){const n=await this.getTargetPlatform();return i.allTargetPlatforms.some(l=>(0,w.$4o)(l,i.allTargetPlatforms,n))}async installFromGallery(i,n={}){try{const $=(await this.installGalleryExtensions([{extension:i,options:n}])).find(({identifier:k})=>(0,m.$up)(k,i.identifier));if($?.local)return $?.local;throw $?.error?$.error:new w.$7o(`Unknown error while installing extension ${i.identifier.id}`,w.ExtensionManagementErrorCode.Unknown)}catch(l){throw h(l)}}async installGalleryExtensions(i){if(!this.z.isEnabled())throw new w.$7o(v.localize(0,null),w.ExtensionManagementErrorCode.NotAllowed);const n=[],l=[];return await Promise.allSettled(i.map(async({extension:$,options:k})=>{try{const j=await this.N($,!!k?.installGivenVersion,!!k?.installPreReleaseVersion,k.productVersion??{version:this.G.version,date:this.G.date});l.push({...j,options:k})}catch(j){n.push({identifier:$.identifier,operation:2,source:$,error:j})}})),l.length&&n.push(...await this.I(l)),n}async uninstall(i,n={}){return this.F.trace("ExtensionManagementService#uninstall",i.identifier.id),this.P(i,n)}async toggleAppliationScope(i,n){if((0,u.$Um)(i.manifest)||i.isBuiltin)return i;if(i.isApplicationScoped){let l=await this.updateMetadata(i,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)||(l=await this.$(i,this.H.defaultProfile.extensionsResource,n));for(const $ of this.H.profiles){const k=(await this.getInstalled(1,$.extensionsResource)).find(j=>(0,m.$up)(j.identifier,i.identifier));k?this.w.fire(k):this.u.fire({identifier:i.identifier,profileLocation:$.extensionsResource})}return l}else{const l=this.D.extUri.isEqual(n,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(i,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(i,n,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:l.identifier,operation:2,local:l,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),l}}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.W(),this.h=i),this.g}registerParticipant(i){this.y.push(i)}async I(i){const n=new Map,l=new Map,$=[],k=(A,O)=>`${m.$vp.create(A).toString()}-${O.toString()}`,j=(A,O,F,V)=>{const Z=this.Y(A,O,F),oe=`${(0,m.$zp)(A.publisher,A.name)}-${F.profileLocation.toString()}`;l.set(oe,{task:Z,root:V}),this.n.fire({identifier:Z.identifier,source:O,profileLocation:F.profileLocation}),this.F.info("Installing extension:",Z.identifier.id),y.URI.isUri(O)||this.j.set(k(O,F.profileLocation),{task:Z,waitingTasks:[]})};try{for(const{manifest:A,extension:O,options:F}of i){const V=F.isApplicationScoped||F.isBuiltin||(0,u.$Um)(A),Z={...F,installOnlyNewlyAddedFromExtensionPack:F.installOnlyNewlyAddedFromExtensionPack??!y.URI.isUri(O),isApplicationScoped:V,profileLocation:V?this.H.defaultProfile.extensionsResource:F.profileLocation??this.X(),productVersion:F.productVersion??{version:this.G.version,date:this.G.date}},oe=y.URI.isUri(O)?void 0:this.j.get(k(O,Z.profileLocation));oe?(this.F.info("Extension is already requested to install",oe.task.identifier.id),$.push(oe.task.waitUntilTaskIsFinished())):j(A,O,Z,void 0)}return await Promise.all([...l.values()].map(async({task:A})=>{if(A.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",A.identifier.id);else try{const O=await this.M(A.identifier,A.manifest,!!A.options.installOnlyNewlyAddedFromExtensionPack,!!A.options.installPreReleaseVersion,A.options.profileLocation,A.options.productVersion),F=await this.getInstalled(void 0,A.options.profileLocation,A.options.productVersion),V={...A.options,context:{...A.options.context,[w.$Yo]:!0}};for(const{gallery:Z,manifest:oe}of(0,o.$Mb)(O,({gallery:le})=>le.identifier.id)){if(l.has(`${Z.identifier.id.toLowerCase()}-${V.profileLocation.toString()}`))continue;const le=this.j.get(k(Z,V.profileLocation));if(le){if(this.J(A,le.task)){const te=le.task.identifier;this.F.info("Waiting for already requested installing extension",te.id,A.identifier.id),le.waitingTasks.push(A),$.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,_=>_.some(W=>(0,m.$up)(W.identifier,te)))).then(_=>{if(this.F.info("Finished waiting for already requested installing extension",te.id,A.identifier.id),!_.find(K=>(0,m.$up)(K.identifier,te))?.local)throw new Error(`Extension ${te.id} is not installed`)}))}}else F.some(({identifier:te})=>(0,m.$up)(te,Z.identifier))||j(oe,Z,V,A)}}catch(O){if(y.URI.isUri(A.source))(0,o.$Lb)(A.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",A.identifier.id,O.message),(0,o.$Lb)(A.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",A.identifier.id,O.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",A.identifier.id),O}})),await this.L([...l.entries()].map(async([A,{task:O}])=>{const F=new Date().getTime();try{const V=await O.run();if(await this.L(this.y.map(Z=>Z.postInstall(V,O.source,O.options,S.CancellationToken.None))),!y.URI.isUri(O.source)){const Z=O.operation===3,oe=Z?void 0:(new Date().getTime()-O.source.lastUpdated)/1e3;if(t(this.C,Z?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Cp)(O.source),verificationStatus:O.verificationStatus,duration:new Date().getTime()-F,durationSinceUpdate:oe}),b.$o&&O.operation!==3)try{await this.z.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch{}}n.set(A,{local:V,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.profileLocation,applicationScoped:V.isApplicationScoped})}catch(V){const Z=h(V);throw y.URI.isUri(O.source)||t(this.C,O.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,m.$Cp)(O.source),error:Z}),n.set(A,{error:Z,identifier:O.identifier,operation:O.operation,source:O.source,context:O.options.context,profileLocation:O.profileLocation,applicationScoped:O.options.isApplicationScoped}),this.F.error("Error while installing the extension",O.identifier.id,(0,D.$0)(Z)),Z}})),$.length&&await this.L($),[...n.values()]}catch(A){const O=(Z,oe,le)=>{const te=[];Z.manifest.extensionDependencies?.length&&te.push(...Z.manifest.extensionDependencies),Z.manifest.extensionPack?.length&&te.push(...Z.manifest.extensionPack);for(const _ of te){if(le.includes(_.toLowerCase()))continue;le.push(_.toLowerCase());const W=n.get(`${_.toLowerCase()}-${oe.toString()}`);W?.local&&(le=O(W.local,oe,le))}return le},F=Z=>({identifier:Z.identifier,operation:2,source:Z.source,context:Z.options.context,profileLocation:Z.profileLocation,error:A}),V=[];for(const[Z,{task:oe,root:le}]of l){const te=n.get(Z);te?te.local&&le&&!n.get(`${le.identifier.id.toLowerCase()}-${oe.profileLocation.toString()}`)?.local&&(V.push(this.Z(te.local,{versionOnly:!0,profileLocation:oe.profileLocation})),n.set(Z,F(oe))):(oe.cancel(),n.set(Z,F(oe)))}for(const[Z,{task:oe}]of l){const le=n.get(Z);if(!le?.local||oe.options.donotIncludePackAndDependencies)continue;O(le.local,oe.profileLocation,[le.local.identifier.id.toLowerCase()]).slice(1).some(_=>l.has(`${_.toLowerCase()}-${oe.profileLocation.toString()}`)&&!n.get(`${_.toLowerCase()}-${oe.profileLocation.toString()}`)?.local)&&(V.push(this.Z(le.local,{versionOnly:!0,profileLocation:oe.profileLocation})),n.set(Z,F(oe)))}throw V.length&&await Promise.allSettled(V.map(async Z=>{try{await Z.run(),this.F.info("Rollback: Uninstalled extension",Z.extension.identifier.id)}catch(oe){this.F.warn("Rollback: Error while uninstalling extension",Z.extension.identifier.id,(0,D.$0)(oe))}})),A}finally{for(const{task:A}of l.values())A.source&&!y.URI.isUri(A.source)&&this.j.delete(k(A.source,A.profileLocation));if(n.size){const A=[...n.values()];for(const O of A)O.local&&this.F.info("Extension installed successfully:",O.identifier.id);this.s.fire(A)}}}J(i,n){for(const[,{task:l,waitingTasks:$}]of this.j.entries())if(l===i&&($.includes(n)||$.some(k=>this.J(k,n)))||l===n&&$[0]&&!this.J(i,$[0]))return!1;return!0}async L(i){const n=[],l=[],$=await Promise.allSettled(i);for(const k of $)k.status==="fulfilled"?n.push(k.value):l.push(k.reason);if(l.length){if(l.length===1)throw l[0];let k=new w.$7o("",w.ExtensionManagementErrorCode.Unknown);for(const j of l){const A=j instanceof w.$7o?j.code:w.ExtensionManagementErrorCode.Unknown;k=new w.$7o(j.message?`${j.message}, ${k.message}`:k.message,A!==w.ExtensionManagementErrorCode.Unknown&&A!==w.ExtensionManagementErrorCode.Internal?A:k.code)}throw k}return n}async M(i,n,l,$,k,j){if(!this.z.isEnabled())return[];const A=await this.getInstalled(void 0,k,j),O=[],F=[],V=async(Z,oe)=>{O.push(Z);const le=oe.extensionDependencies||[],te=[...le];if(oe.extensionPack){const _=l?A.find(W=>(0,m.$up)(W.identifier,Z)):void 0;for(const W of oe.extensionPack)_&&_.manifest.extensionPack&&_.manifest.extensionPack.some(K=>(0,m.$up)({id:K},{id:W}))||te.every(K=>!(0,m.$up)({id:K},{id:W}))&&te.push(W)}if(te.length){const _=te.filter(W=>O.every(K=>!(0,m.$up)(K,{id:W})));if(_.length){const W=await this.z.getExtensions(_.map(K=>({id:K,preRelease:$})),S.CancellationToken.None);for(const K of W){if(O.find(Q=>(0,m.$up)(Q,K.identifier)))continue;const Y=le.some(Q=>(0,m.$up)({id:Q},K.identifier));let M;try{M=await this.N(K,!1,$,j)}catch(Q){if(Y)throw Q;this.F.info("Skipping the packed extension as it cannot be installed",K.identifier.id,(0,D.$0)(Q));continue}F.push({gallery:M.extension,manifest:M.manifest}),await V(M.extension.identifier,M.manifest)}}}};return await V(i,n),F}async N(i,n,l,$){let k;const j=await this.getExtensionsControlManifest();if(j.malicious.some(F=>(0,m.$up)(i.identifier,F)))throw new w.$7o(v.localize(1,null,i.identifier.id),w.ExtensionManagementErrorCode.Malicious);const A=j.deprecated[i.identifier.id.toLowerCase()];if(A?.extension?.autoMigrate){if(this.F.info(`The '${i.identifier.id}' extension is deprecated, fetching the compatible '${A.extension.id}' extension instead.`),k=(await this.z.getExtensions([{id:A.extension.id,preRelease:A.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:$},S.CancellationToken.None))[0],!k)throw new w.$7o(v.localize(2,null,i.identifier.id,A.extension.id),w.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(i)){const F=await this.getTargetPlatform();throw new w.$7o(v.localize(3,null,i.identifier.id,this.G.nameLong,(0,w.$Zo)(F)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(k=await this.O(i,n,l,$),!k)throw!l&&i.properties.isPreReleaseVersion&&(await this.z.getExtensions([i.identifier],S.CancellationToken.None))[0]?new w.$7o(v.localize(4,null,i.displayName??i.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.$7o(v.localize(5,null,i.identifier.id,this.G.nameLong,this.G.version),w.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",k.identifier.id);const O=await this.z.getManifest(k,S.CancellationToken.None);if(O===null)throw new w.$7o(`Missing manifest for extension ${k.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(O.version!==k.version)throw new w.$7o(`Cannot install '${k.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:k,manifest:O}}async O(i,n,l,$){const k=await this.getTargetPlatform();let j=null;return!n&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==l&&(j=(await this.z.getExtensions([{...i.identifier,preRelease:l}],{targetPlatform:k,compatible:!0,productVersion:$},S.CancellationToken.None))[0]||null),!j&&await this.z.isExtensionCompatible(i,l,k,$)&&(j=i),j||(n?j=(await this.z.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:k,compatible:!0,productVersion:$},S.CancellationToken.None))[0]||null:j=await this.z.getCompatibleExtension(i,l,k,$)),j}async P(i,n){const l={...n,profileLocation:i.isApplicationScoped?this.H.defaultProfile.extensionsResource:n.profileLocation??this.X()},$=V=>`${V.id.toLowerCase()}${l.versionOnly?`-${i.manifest.version}`:""}${l.profileLocation?`@${l.profileLocation.toString()}`:""}`,k=this.m.get($(i.identifier));if(k)return this.F.info("Extensions is already requested to uninstall",i.identifier.id),k.waitUntilTaskIsFinished();const j=V=>{const Z=this.Z(V,l);return this.m.set($(Z.extension.identifier),Z),l.profileLocation?this.F.info("Uninstalling extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,l.profileLocation.toString()):this.F.info("Uninstalling extension:",`${V.identifier.id}@${V.manifest.version}`),this.t.fire({identifier:V.identifier,profileLocation:l.profileLocation,applicationScoped:V.isApplicationScoped}),Z},A=(V,Z)=>{Z?l.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${V.identifier.id}@${V.manifest.version}`,l.profileLocation.toString(),Z.message):this.F.error("Failed to uninstall extension:",`${V.identifier.id}@${V.manifest.version}`,Z.message):l.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${V.identifier.id}@${V.manifest.version}`,l.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${V.identifier.id}@${V.manifest.version}`),t(this.C,"extensionGallery:uninstall",{extensionData:(0,m.$Bp)(V),error:Z}),this.u.fire({identifier:V.identifier,error:Z?.code,profileLocation:l.profileLocation,applicationScoped:V.isApplicationScoped})},O=[],F=[];try{O.push(j(i));const V=await this.getInstalled(1,l.profileLocation);if(l.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const Z=this.S(i,V);for(const oe of Z)this.m.has($(oe.identifier))?this.F.info("Extensions is already requested to uninstall",oe.identifier.id):O.push(j(oe))}l.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.Q(O.map(Z=>Z.extension),V,i),await this.L(O.map(async Z=>{try{if(await Z.run(),await this.L(this.y.map(oe=>oe.postUninstall(Z.extension,l,S.CancellationToken.None))),Z.extension.identifier.uuid)try{await this.z.reportStatistic(Z.extension.manifest.publisher,Z.extension.manifest.name,Z.extension.manifest.version,"uninstall")}catch{}A(Z.extension)}catch(oe){const le=h(oe);throw A(Z.extension,le),le}finally{F.push(Z)}}))}catch(V){const Z=h(V);for(const oe of O){try{oe.cancel()}catch{}F.includes(oe)||A(oe.extension,Z)}throw Z}finally{for(const V of O)this.m.delete($(V.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",V.extension.identifier.id)}}Q(i,n,l){for(const $ of i){const k=this.U($,n);if(k.length){const j=k.filter(A=>!i.some(O=>(0,m.$up)(O.identifier,A.identifier)));if(j.length)throw new Error(this.R($,j,l))}}}R(i,n,l){return l===i?n.length===1?v.localize(6,null,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?v.localize(7,null,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):v.localize(8,null,l.manifest.displayName||l.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):n.length===1?v.localize(9,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name):n.length===2?v.localize(10,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name):v.localize(11,null,l.manifest.displayName||l.manifest.name,i.manifest.displayName||i.manifest.name,n[0].manifest.displayName||n[0].manifest.name,n[1].manifest.displayName||n[1].manifest.name)}S(i,n,l=[]){if(l.indexOf(i)!==-1)return[];l.push(i);const $=i.manifest.extensionPack?i.manifest.extensionPack:[];if($.length){const k=n.filter(A=>!A.isBuiltin&&$.some(O=>(0,m.$up)({id:O},A.identifier))),j=[];for(const A of k)j.push(...this.S(A,n,l));return[...k,...j]}return[]}U(i,n){return n.filter(l=>l.manifest.extensionDependencies&&l.manifest.extensionDependencies.some($=>(0,m.$up)({id:$},i.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(i){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,D.$0)(i)),{malicious:[],deprecated:{},search:[]}}}};e.$lq=E,e.$lq=E=Le([Ne(0,w.$6o),Ne(1,c.$2l),Ne(2,d.$Al),Ne(3,a.$3j),Ne(4,f.$jk),Ne(5,p.$Cl)],E);function h(r){if(r instanceof w.$7o)return r;if(r instanceof w.$8o){const n=new w.$7o(r.message,w.ExtensionManagementErrorCode.Gallery);return n.stack=r.stack,n}const i=new w.$7o(r.message,(0,D.$4)(r)?w.ExtensionManagementErrorCode.Cancelled:w.ExtensionManagementErrorCode.Internal);return i.stack=r.stack,i}function t(r,i,{extensionData:n,verificationStatus:l,duration:$,error:k,durationSinceUpdate:j}){let A,O;(0,g.$eg)(l)&&(l===!0?l="Verified":(l===!1||(A=w.ExtensionManagementErrorCode.Signature,O=l),l="Unverified")),k&&(A=k.code,k.code===w.ExtensionManagementErrorCode.Signature&&(O=k.message)),r.publicLog(i,{...n,verificationStatus:l,success:!k,duration:$,errorcode:A,errorcodeDetail:O,durationSinceUpdate:j})}class s{constructor(){this.d=new C.$vh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,C.$jh)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,C.$jh)(i=>new Promise((n,l)=>{const $=i.onCancellationRequested(()=>{$.dispose(),l(new D.$5)})})),this.d.open()),this.g.cancel()}}e.$nq=s}),define(ye[50],Ee([1,0,14,15,2,6,24,4,32,38,16,5,12,33,34,10,11,29]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=e.$pq=e.$oq=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(s){s.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",s.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class p extends Error{constructor(r,i){super(r),this.code=i}}e.$oq=p,e.$pq=(0,v.$wi)("IExtensionsProfileScannerService");let E=class extends S.$Vc{constructor(r,i,n,l,$,k){super(),this.j=r,this.m=i,this.n=n,this.r=l,this.s=$,this.t=k,this.b=this.B(new D.$ee),this.onAddExtensions=this.b.event,this.c=this.B(new D.$ee),this.onDidAddExtensions=this.c.event,this.f=this.B(new D.$ee),this.onRemoveExtensions=this.f.event,this.g=this.B(new D.$ee),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Bc}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i,n){const l=[],$=[];try{return await this.u(i,k=>{const j=[];if(n)j.push(...k);else for(const A of k)r.some(([O])=>(0,g.$up)(O.identifier,A.identifier)&&O.manifest.version!==A.version)?l.push(A):j.push(A);for(const[A,O]of r){const F=j.findIndex(Z=>(0,g.$up)(Z.identifier,A.identifier)&&Z.version===A.manifest.version),V={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:O};F===-1?($.push(V),j.push(V)):j.splice(F,1,V)}return $.length&&this.b.fire({extensions:$,profileLocation:i}),l.length&&this.f.fire({extensions:l,profileLocation:i}),j}),$.length&&this.c.fire({extensions:$,profileLocation:i}),l.length&&this.g.fire({extensions:l,profileLocation:i}),$}catch(k){throw $.length&&this.c.fire({extensions:$,error:k,profileLocation:i}),l.length&&this.g.fire({extensions:l,error:k,profileLocation:i}),k}}async updateMetadata(r,i){const n=[];return await this.u(i,l=>{const $=[];for(const k of l){const j=r.find(([A])=>(0,g.$up)(A.identifier,k.identifier)&&A.manifest.version===k.version);j&&(k.metadata={...k.metadata,...j[1]},n.push(k)),$.push(k)}return $}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,l=>{const $=[];for(const k of l)(0,g.$up)(k.identifier,r.identifier)?n.push(k):$.push(k);return n.length&&this.f.fire({extensions:n,profileLocation:i}),$}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(l){throw n.length&&this.g.fire({extensions:n,error:l,profileLocation:i}),l}}async u(r,i,n){return this.F(r).queue(async()=>{let l=[],$;try{const k=await this.m.readFile(r);$=JSON.parse(k.value.toString().trim()||"[]")}catch(k){if((0,y.$hl)(k)!==1)throw k;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&($=await this.D()),!$&&n?.bailOutWhenFileNotFound)throw new p((0,f.$0)(k),"ERROR_PROFILE_NOT_FOUND")}if($){Array.isArray($)||this.w(r);let k=!1;for(const j of $){h(j)||this.w(r);let A;if((0,a.$9f)(j.relativeLocation)&&j.relativeLocation)A=this.z(j.relativeLocation);else if((0,a.$9f)(j.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${j.location}`);continue}else{A=P.URI.revive(j.location);const O=this.y(A);O&&(k=!0,j.relativeLocation=O)}(0,a.$dg)(j.metadata?.hasPreReleaseVersion)&&j.metadata?.preRelease&&(k=!0,j.metadata.hasPreReleaseVersion=!0),l.push({identifier:j.identifier,location:A,version:j.version,metadata:j.metadata})}k&&await this.m.writeFile(r,C.$Ge.fromString(JSON.stringify($)))}if(i){l=i(l);const k=l.map(j=>({identifier:j.identifier,version:j.version,location:j.location.toJSON(),relativeLocation:this.y(j.location),metadata:j.metadata}));await this.m.writeFile(r,C.$Ge.fromString(JSON.stringify(k)))}return l})}w(r){const i=new p(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch($){if((0,y.$hl)($)===1)return;throw $}this.t.info("Migrating extensions from old default profile location",r.toString());let l;try{const $=JSON.parse(n);Array.isArray($)&&$.every(k=>h(k))?l=$:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",$)}catch($){this.t.error($)}if(l)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$Ge.fromString(JSON.stringify(l)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch($){if((0,y.$hl)($)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw $}try{await this.m.del(r)}catch($){(0,y.$hl)($)!==1&&this.t.error($)}try{await this.m.del(i)}catch($){(0,y.$hl)($)!==1&&this.t.error($)}return l})()),this.C}F(r){let i=this.h.get(r);return i||(i=new o.$Dh,this.h.set(r,i)),i}};e.$qq=E,e.$qq=E=Le([Ne(1,y.$3k),Ne(2,m.$Cl),Ne(3,u.$Al),Ne(4,c.$2l),Ne(5,w.$3j)],E);function h(s){return(0,a.$$f)(s)&&(0,b.$5o)(s.identifier)&&(t(s.location)||(0,a.$9f)(s.location)&&s.location)&&((0,a.$dg)(s.relativeLocation)||(0,a.$9f)(s.relativeLocation))&&s.version&&(0,a.$9f)(s.version)}function t(s){return s?(0,a.$9f)(s.path)&&(0,a.$9f)(s.scheme):!1}}),define(ye[59],Ee([1,0,18,14,21,15,11,43,175,2,13,7,3,19,57,63,10,4,195,26,38,40,82,16,5,12,28,6,54,50,33,34,227]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h,t,s,r,i,n,l,$,k,j,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xq=e.$vq=e.$uq=e.$tq=e.Translations=void 0,e.$wq=te;var F;(function(W){function K(Y,M){if(Y===M)return!0;const Q=Object.keys(Y),ce=new Set;for(const ie of Object.keys(M))ce.add(ie);if(Q.length!==ce.size)return!1;for(const ie of Q){if(Y[ie]!==M[ie])return!1;ce.delete(ie)}return ce.size===0}W.equals=K})(F||(e.Translations=F={})),e.$tq=(0,r.$wi)("IExtensionsScannerService");let V=class extends g.$Vc{constructor(K,Y,M,Q,ce,ie,be,re,X,B,N,z){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=Y,this.r=M,this.s=Q,this.t=ce,this.u=ie,this.w=be,this.y=re,this.z=X,this.C=B,this.D=N,this.F=z,this.g=this.B(new l.$ee),this.onDidChangeCache=this.g.event,this.h=(0,m.$0g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(le,this.s,this.h)),this.m=this.B(this.F.createInstance(le,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,E.$Fp)(this.w,this.y)),this.G}async scanAllExtensions(K,Y,M){const[Q,ce]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(Y)]),ie=M?await this.scanExtensionsUnderDevelopment(K,[...Q,...ce]):[];return this.L(Q,ce,ie,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const Y=[];Y.push(this.M(!!K.useCache,K.language)),Y.push(this.N(K.language,!!K.checkControlFile));const[M,Q]=await Promise.all(Y);return this.J([...M,...Q],0,K,!1)}async scanUserExtensions(K){const Y=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const M=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,Q=await this.P(Y,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,M,K.productVersion??this.R()),ce=K.useCache&&!Q.devMode&&Q.excludeObsolete?this.m:this.n;let ie;try{ie=await ce.scanExtensions(Q)}catch(be){if(be instanceof k.$oq&&be.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),ie=await ce.scanExtensions(Q);else throw be}return ie=await this.J(ie,1,K,!0),this.y.trace("Scanned user extensions:",ie.length),ie}async scanExtensionsUnderDevelopment(K,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(Q=>Q.scheme===y.Schemas.file).map(async Q=>{const ce=await this.P(Q,!1,1,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(ce)).map(be=>(be.type=Y.find(re=>(0,E.$up)(re.identifier,be.identifier))?.type??be.type,this.n.validate(be,ce)))}))).flat();return this.J(M,"development",K,!0)}return[]}async scanExistingExtension(K,Y,M){const Q=await this.P(K,!1,Y,!0,M.language,!0,void 0,M.productVersion??this.R()),ce=await this.n.scanExtension(Q);return!ce||!M.includeInvalid&&!ce.isValid?null:ce}async scanOneOrMultipleExtensions(K,Y,M){const Q=await this.P(K,!1,Y,!0,M.language,!0,void 0,M.productVersion??this.R()),ce=await this.n.scanOneOrMultipleExtensions(Q);return this.J(ce,Y,M,!0)}async scanMultipleExtensions(K,Y,M){const Q=[];return await Promise.all(K.map(async ce=>{const ie=await this.scanOneOrMultipleExtensions(ce,Y,M);Q.push(...ie)})),this.J(Q,Y,M,!0)}async scanMetadata(K){const Y=(0,m.$0g)(K,"package.json"),M=(await this.w.readFile(Y)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(K,Y){const M=(0,m.$0g)(K,"package.json"),Q=(await this.w.readFile(M)).value.toString(),ce=JSON.parse(Q);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,ce.__metadata={...ce.__metadata,...Y},await this.w.writeFile((0,m.$0g)(K,"package.json"),D.$Ge.fromString(JSON.stringify(ce,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof k.$oq&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,D.$Ge.fromString(JSON.stringify([])))}catch(Y){(0,s.$hl)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,Y,M,Q){return M.includeAllVersions||(K=this.L(Y===0?K:void 0,Y===1?K:void 0,Y==="development"?K:void 0,await this.getTargetPlatform(),Q)),M.includeInvalid||(K=K.filter(ce=>ce.isValid)),K.sort((ce,ie)=>{const be=v.$oc(ce.location.fsPath),re=v.$oc(ie.location.fsPath);return be<re?-1:be>re?1:0})}L(K,Y,M,Q,ce){const ie=(re,X,B)=>{if(re.isValid&&!X.isValid)return!1;if(re.isValid===X.isValid){if(ce&&u.gt(re.manifest.version,X.manifest.version))return this.y.debug(`Skipping extension ${X.location.path} with lower version ${X.manifest.version} in favour of ${re.location.path} with version ${re.manifest.version}`),!1;if(u.eq(re.manifest.version,X.manifest.version)){if(re.type===0)return this.y.debug(`Skipping extension ${X.location.path} in favour of system extension ${re.location.path} with same version`),!1;if(re.targetPlatform===Q)return this.y.debug(`Skipping extension ${X.location.path} from different target platform ${X.targetPlatform}`),!1}}return B?this.y.warn(`Overwriting user extension ${re.location.path} with ${X.location.path}.`):this.y.debug(`Overwriting user extension ${re.location.path} with ${X.location.path}.`),!0},be=new h.$Tm;return K?.forEach(re=>{const X=be.get(re.identifier.id);(!X||ie(X,re,!1))&&be.set(re.identifier.id,re)}),Y?.forEach(re=>{const X=be.get(re.identifier.id);if(!X&&K&&re.type===0){this.y.debug(`Skipping obsolete system extension ${re.location.path}.`);return}(!X||ie(X,re,!1))&&be.set(re.identifier.id,re)}),M?.forEach(re=>{const X=be.get(re.identifier.id);(!X||ie(X,re,!0))&&be.set(re.identifier.id,re),be.set(re.identifier.id,re)}),[...be.values()]}async M(K,Y){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0,this.R()),ce=await(K&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",ce.length),ce}async N(K,Y){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const Q=Y?await this.O():{},ce=[],ie=c.URI.file(v.$ic(v.$kc(y.$Qg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const re of M){const X=Q[re.name]||"marketplace";switch(X){case"disabled":break;case"marketplace":ce.push((0,m.$0g)(ie,re.name));break;default:ce.push(c.URI.file(X));break}}const be=await Promise.all(ce.map(async re=>this.n.scanExtension(await this.P(re,!1,0,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",be.length),(0,o.$Hb)(be)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,Y,M,Q,ce,ie,be,re){const X=await this.f(ce??w.$w),B=await this.Q(K),N=Y&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,z=N?await this.Q(N):void 0;return new Z(K,B,N,z,Y,be,M,Q,ie,re.version,re.date,this.C.commit,!this.z.isBuilt,ce,X)}async Q(K){try{const Y=await this.w.stat(K);if(typeof Y.mtime=="number")return Y.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$uq=V,e.$uq=V=Le([Ne(4,j.$Cl),Ne(5,k.$pq),Ne(6,s.$3k),Ne(7,i.$3j),Ne(8,p.$Di),Ne(9,n.$jk),Ne(10,A.$Al),Ne(11,r.$vi)],V);class Z{constructor(K,Y,M,Q,ce,ie,be,re,X,B,N,z,J,ue,x){this.location=K,this.mtime=Y,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=Q,this.profile=ce,this.profileScanOptions=ie,this.type=be,this.excludeObsolete=re,this.validate=X,this.productVersion=B,this.productDate=N,this.productCommit=z,this.devMode=J,this.language=ue,this.translations=x}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,Y){return(0,m.$3g)(K.location,Y.location)&&K.mtime===Y.mtime&&(0,m.$3g)(K.applicationExtensionslocation,Y.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&K.profile===Y.profile&&S.$7n(K.profileScanOptions,Y.profileScanOptions)&&K.type===Y.type&&K.excludeObsolete===Y.excludeObsolete&&K.validate===Y.validate&&K.productVersion===Y.productVersion&&K.productDate===Y.productDate&&K.productCommit===Y.productCommit&&K.devMode===Y.devMode&&K.language===Y.language&&F.equals(K.translations,Y.translations)}}e.$vq=Z;let oe=class extends g.$Vc{constructor(K,Y,M,Q,ce){super(),this.f=K,this.g=Y,this.h=M,this.j=Q,this.m=ce}async scanExtensions(K){const Y=K.profile?await this.r(K):await this.n(K);let M={};if(K.excludeObsolete&&K.type===1)try{const Q=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(Q)}catch{}return(0,f.$jg)(M)?Y:Y.filter(Q=>!M[E.$vp.create(Q).toString()])}async n(K){const Y=await this.j.resolve(K.location);if(!Y.children?.length)return[];const M=await Promise.all(Y.children.map(async Q=>{if(!Q.isDirectory||K.type===1&&(0,m.$7g)(Q.resource).indexOf(".")===0)return null;const ce=new Z(Q.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(ce)}));return(0,o.$Hb)(M).sort((Q,ce)=>Q.location.path<ce.location.path?-1:1)}async r(K){let Y=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){Y=Y.filter(Q=>!Q.metadata?.isApplicationScoped);const M=await this.s(K.applicationExtensionslocation,Q=>!!Q.metadata?.isBuiltin||!!Q.metadata?.isApplicationScoped,K);Y.push(...M)}return Y}async s(K,Y,M){const Q=await this.g.scanProfileExtensions(K,M.profileScanOptions);if(!Q.length)return[];const ce=await Promise.all(Q.map(async ie=>{if(Y(ie)){const be=new Z(ie.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(be,ie.metadata)}return null}));return(0,o.$Hb)(ce)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,m.$0g)(K.location,"package.json"))){const Y=await this.scanExtension(K);return Y?[Y]:[]}else return await this.scanExtensions(K)}catch(Y){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,I.$0)(Y)),[]}}async scanExtension(K,Y){try{let M=await this.scanExtensionManifest(K.location);if(M){M.publisher||(M.publisher=h.$Nm),Y=Y??M.__metadata,delete M.__metadata;const Q=(0,E.$zp)(M.publisher,M.name),ce=Y?.id?{id:Q,uuid:Y.id}:{id:Q},ie=Y?.isSystem?0:K.type,be=ie===0||!!Y?.isBuiltin;M=await this.t(K.location,M,Z.createNlsConfiguration(K));const re={type:ie,identifier:ce,manifest:M,location:K.location,isBuiltin:be,targetPlatform:Y?.targetPlatform??"undefined",publisherDisplayName:Y?.publisherDisplayName,metadata:Y,isValid:!0,validations:[]};return K.validate?this.validate(re,K):re}}catch(M){K.type!==0&&this.m.error(M)}return null}validate(K,Y){let M=!0;const Q=(0,t.$Kp)(Y.productVersion,Y.productDate,Y.location,K.manifest,K.isBuiltin);for(const[ce,ie]of Q)ce===a.default.Error&&(M=!1,this.m.error(this.z(Y.location,ie)));return K.isValid=M,K.validations=Q,K}async scanExtensionManifest(K){const Y=(0,m.$0g)(K,"package.json");let M;try{M=(await this.j.readFile(Y)).value.toString()}catch(ce){return(0,s.$hl)(ce)!==1&&this.m.error(this.z(K,(0,d.localize)(0,null,Y.path,ce.message))),null}let Q;try{Q=JSON.parse(M)}catch{const ie=[];(0,P.$Jn)(M,ie);for(const be of ie)this.m.error(this.z(K,(0,d.localize)(1,null,Y.path,be.offset,be.length,(0,b.$rq)(be.error))));return null}return(0,P.$Sn)(Q)!=="object"?(this.m.error(this.z(K,(0,d.localize)(2,null,Y.path))),null):Q}async t(K,Y,M){const Q=await this.u(K,Y,M);if(Q)try{const ce=[],ie=await this.w(Q.default,ce);if(ce.length>0)return ce.forEach(re=>{this.m.error(this.z(K,(0,d.localize)(3,null,Q.default?.path,(0,b.$rq)(re.error))))}),Y;if((0,P.$Sn)(Q)!=="object")return this.m.error(this.z(K,(0,d.localize)(4,null,Q.default?.path))),Y;const be=Q.values||Object.create(null);return(0,O.$sq)(this.m,Y,be,ie)}catch{}return Y}async u(K,Y,M){const Q=(0,m.$0g)(K,"package.nls.json"),ce=(X,B)=>{B.forEach(N=>{this.m.error(this.z(K,(0,d.localize)(5,null,X?.path,(0,b.$rq)(N.error))))})},ie=X=>{this.m.error(this.z(K,(0,d.localize)(6,null,X?.path)))},be=`${Y.publisher}.${Y.name}`,re=M.translations[be];if(re)try{const X=c.URI.file(re),B=(await this.j.readFile(X)).value.toString(),N=[],z=(0,P.$Jn)(B,N);return N.length>0?(ce(X,N),{values:void 0,default:Q}):(0,P.$Sn)(z)!=="object"?(ie(X),{values:void 0,default:Q}):{values:z.contents?z.contents.package:void 0,default:Q}}catch{return{values:void 0,default:Q}}else{if(!await this.j.exists(Q))return;let B;try{B=await this.y(K,M)}catch{return}if(!B.localized)return{values:void 0,default:B.original};try{const N=(await this.j.readFile(B.localized)).value.toString(),z=[],J=(0,P.$Jn)(N,z);return z.length>0?(ce(B.localized,z),{values:void 0,default:B.original}):(0,P.$Sn)(J)!=="object"?(ie(B.localized),{values:void 0,default:B.original}):{values:J,default:B.original}}catch{return{values:void 0,default:B.original}}}}async w(K,Y){if(K)try{const M=(await this.j.readFile(K)).value.toString();return(0,P.$Jn)(M,Y)}catch{}}y(K,Y){return new Promise((M,Q)=>{const ce=ie=>{const be=(0,m.$0g)(K,`package.nls.${ie}.json`);this.j.exists(be).then(re=>{re&&M({localized:be,original:(0,m.$0g)(K,"package.nls.json")});const X=ie.lastIndexOf("-");X===-1?M({localized:(0,m.$0g)(K,"package.nls.json"),original:null}):(ie=ie.substring(0,X),ce(ie))})};if(Y.devMode||Y.pseudo||!Y.language)return M({localized:(0,m.$0g)(K,"package.nls.json"),original:null});ce(Y.language)})}z(K,Y){return`[${K.path}]: ${Y}`}};oe=Le([Ne(1,k.$pq),Ne(2,A.$Al),Ne(3,s.$3k),Ne(4,i.$3j)],oe);let le=class extends oe{constructor(K,Y,M,Q,ce,ie,be){super(Y,Q,ce,ie,be),this.G=K,this.H=M,this.D=this.B(new C.$uh(3e3)),this.F=this.B(new l.$ee),this.onDidChangeCache=this.F.event}async scanExtensions(K){const Y=this.M(K),M=await this.I(Y);if(this.C=K,M&&M.input&&Z.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),M.result.map(ce=>(ce.location=c.URI.revive(ce.location),ce));const Q=await super.scanExtensions(K);return await this.J(Y,{input:K,result:Q}),Q}async I(K){try{const Y=await this.j.readFile(K),M=JSON.parse(Y.value.toString());return{result:M.result,input:(0,$.$6h)(M.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",K.path,(0,I.$0)(Y))}return null}async J(K,Y){try{await this.j.writeFile(K,D.$Ge.fromString(JSON.stringify(Y)))}catch(M){this.m.debug("Error while writing the extension cache file:",K.path,(0,I.$0)(M))}}async L(){if(!this.C)return;const K=this.M(this.C),Y=await this.I(K);if(!Y)return;const M=Y.result,Q=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!S.$7n(Q,M))try{this.m.info("Invalidating Cache",M,Q),await this.j.del(K),this.F.fire()}catch(ce){this.m.error(ce)}}M(K){const Y=this.N(K);return this.h.extUri.joinPath(Y.cacheHome,K.type===0?h.$Mm:h.$Lm)}N(K){return K.type===0?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(K.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};le=Le([Ne(2,j.$Cl),Ne(3,k.$pq),Ne(4,A.$Al),Ne(5,s.$3k),Ne(6,i.$3j)],le);function te(W,K){const Y=(0,E.$xp)(W.manifest.publisher,W.manifest.name);return{id:Y,identifier:new h.$Rm(Y),isBuiltin:W.type===0,isUserBuiltin:W.type===1&&W.isBuiltin,isUnderDevelopment:K,extensionLocation:W.location,uuid:W.identifier.uuid,targetPlatform:W.targetPlatform,publisherDisplayName:W.publisherDisplayName,...W.manifest}}class _ extends V{constructor(K,Y,M,Q,ce,ie,be,re,X,B,N,z){super(K,Y,(0,m.$0g)(M,".vscode-oss-dev","extensions","control.json"),Q,ce,ie,be,re,X,B,N,z),this.S=(async()=>{if(w.$z)try{const J=await this.w.readFile(c.URI.file(w.$z));return JSON.parse(J.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$xq=_}),define(ye[272],Ee([1,0,56,14,39,6,2,13,7,23,12,33]),function(he,e,o,C,S,D,I,P,b,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;let w=class extends I.$Vc{constructor(u,a){super(),this.b=u,this.f=a,this.a=new C.$Ch(5)}async postUninstall(u){const a=this.g(u,"uninstall");a&&(this.f.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(a.script,"uninstall",a.args,!0,u),this.f.info("Finished running post uninstall script",u.identifier.id,u.manifest.version)}catch(f){this.f.error("Failed to run post uninstall script",u.identifier.id,u.manifest.version),this.f.error(f)}}));try{await g.Promises.rm(this.m(u))}catch(f){this.f.error("Error while removing extension storage path",u.identifier.id),this.f.error(f)}}g(u,a){const f=`vscode:${a}`;if(u.location.scheme===P.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[f]=="string"){const c=u.manifest.scripts[f].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn(u.identifier.id,u.manifest.version,`${f} should be a node script`),null):{script:(0,b.$kc)(u.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h(u,a,f,c,d){return new Promise((p,E)=>{const h=this.j(u,a,f,d);let t;const s=r=>{t&&(clearTimeout(t),t=null),r?E(r):p(void 0)};h.on("error",r=>{s((0,S.$hj)(r)||"Unknown")}),h.on("exit",(r,i)=>{s(r?`post-${a} process exited with code ${r}`:void 0)}),c&&(t=setTimeout(()=>{t=null,h.kill(),E("timed out")},5e3))})}j(u,a,f,c){const d={silent:!0,execArgv:void 0},p=(0,o.fork)(u,[`--type=extension-post-${a}`,...f],d);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const E=D.Event.fromNodeEventEmitter(p.stdout,"data"),h=D.Event.fromNodeEventEmitter(p.stderr,"data");this.B(E(r=>this.f.info(c.identifier.id,c.manifest.version,`post-${a}`,r))),this.B(h(r=>this.f.error(c.identifier.id,c.manifest.version,`post-${a}`,r)));const t=D.Event.any(D.Event.map(E,r=>({data:`%c${r}`,format:[""]}),this.q),D.Event.map(h,r=>({data:`%c${r}`,format:["color: red"]}),this.q));return D.Event.debounce(t,(r,i)=>r?{data:r.data+i.data,format:[...r.format,...i.format]}:{data:i.data,format:i.format},100,void 0,void 0,void 0,this.q)(r=>{console.group(c.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),p}m(u){return(0,b.$kc)(this.b.defaultProfile.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};e.$zq=w,e.$zq=w=Le([Ne(0,v.$Cl),Ne(1,y.$3j)],w)}),define(ye[127],Ee([1,0,14,15,20,39,11,6,62,2,24,13,7,19,57,10,4,22,23,81,196,83,26,271,32,38,50,59,256,272,228,247,257,82,16,5,12,28,29,34,33]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h,t,s,r,i,n,l,$,k,j,A,O,F,V,Z,oe,le,te,_,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=e.$Fq=e.$Eq=e.$Dq=void 0,e.$Dq=(0,Z.$xi)(r.$9o);const K=".vsctmp";let Y=class extends s.$lq{constructor(X,B,N,z,J,ue,x,G,U,T,q,se){super(X,B,q,N,T,se),this.eb=J,this.fb=ue,this.gb=x,this.hb=U,this.db=new Map,this.qb=new y.$Cc;const ae=this.B(G.createInstance(k.$zq));this.ab=this.B(G.createInstance(M,ee=>ae.postUninstall(ee))),this.bb=this.B(new A.$Bq(se,U,q,this,this.F)),this.cb=this.B(G.createInstance($.$yq));const me=this.B(new O.$Cq(this,this.eb,se,ue,q,U,N));this.B(me.onDidChangeExtensionsByAnotherSource(ee=>this.pb(ee))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,i.$Fp)(this.hb,this.F)),this.ib}async zip(X){this.F.trace("ExtensionManagementService#zip",X.identifier.id);const B=await this.ob(X),N=await(0,p.zip)((0,m.$0g)(this.cb.extensionsDownloadDir,(0,c.$Sg)()).fsPath,B);return f.URI.file(N)}async unzip(X){return this.F.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const{location:B,cleanup:N}=await this.kb(X),z=w.$lc(B.fsPath);try{return await(0,j.$Aq)(z)}finally{await N()}}getInstalled(X,B=this.H.defaultProfile.extensionsResource,N={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(X??null,B,N)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.ab.scanUserExtensionAtLocation(X)}async install(X,B={}){this.F.trace("ExtensionManagementService#install",X.toString());const{location:N,cleanup:z}=await this.kb(X);try{const J=await(0,j.$Aq)(w.$lc(N.fsPath)),ue=(0,i.$zp)(J.publisher,J.name);if(J.engines&&J.engines.vscode&&!(0,F.$Mp)(J.engines.vscode,this.G.version,this.G.date))throw new Error(E.localize(0,null,ue,this.G.version));const G=(await this.I([{manifest:J,extension:N,options:B}])).find(({identifier:U})=>(0,i.$up)(U,{id:ue}));if(G?.local)return G.local;throw G?.error?G.error:(0,s.$mq)(new Error(`Unknown error while installing extension ${ue}`))}finally{await z()}}async installFromLocation(X,B){this.F.trace("ExtensionManagementService#installFromLocation",X.toString());const N=await this.ab.scanUserExtensionAtLocation(X);if(!N||!N.manifest.name||!N.manifest.version)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.tb([[N,{source:"resource"}]],B),this.F.info("Successfully installed extension",N.identifier.id,B.toString()),N}async installExtensionsFromProfile(X,B,N){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",X,B.toString(),N.toString());const z=(await this.getInstalled(1,B)).filter(J=>X.some(ue=>(0,i.$up)(ue,J.identifier)));if(z.length){const J=await Promise.all(z.map(ue=>this.ab.scanMetadata(ue,B)));await this.tb(z.map((ue,x)=>[ue,J[x]]),N),this.F.info("Successfully installed extensions",z.map(ue=>ue.identifier.id),N.toString())}return z}async updateMetadata(X,B,N=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",X.identifier.id),B.isPreReleaseVersion&&(B.preRelease=!0,B.hasPreReleaseVersion=!0),B.isMachineScoped===!1&&(B.isMachineScoped=void 0),B.isBuiltin===!1&&(B.isBuiltin=void 0),B.pinned===!1&&(B.pinned=void 0),X=await this.ab.updateMetadata(X,B,N),this.bb.invalidate(N),this.w.fire(X),X}async reinstallFromGallery(X){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.z.isEnabled())throw new Error(E.localize(1,null));const B=await this.getTargetPlatform(),[N]=await this.z.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:B,compatible:!0},S.CancellationToken.None);if(!N)throw new Error(E.localize(2,null));await this.ab.setUninstalled(X);try{await this.ab.removeUninstalledExtension(X)}catch(z){throw new Error(E.localize(3,null,(0,D.$hj)(z)))}return this.installFromGallery(N)}$(X,B,N,z){return this.ab.copyExtension(X,B,N,z)}copyExtensions(X,B){return this.ab.copyExtensions(X,B,{version:this.G.version,date:this.G.date})}markAsUninstalled(...X){return this.ab.setUninstalled(...X)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(X){this.F.error(X)}}async download(X,B,N){const{location:z}=await this.cb.download(X,B,!N);return z}async kb(X){if(X.scheme===v.Schemas.file)return{location:X,async cleanup(){}};this.F.trace("Downloading extension from",X.toString());const B=(0,m.$0g)(this.cb.extensionsDownloadDir,(0,c.$Sg)());return await this.gb.download(X,B),this.F.info("Downloaded extension to",B.toString()),{location:B,cleanup:async()=>{try{await this.hb.del(B)}catch(z){this.F.error(z)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(X,B,N){if(f.URI.isUri(B))return new ie(X,B,N,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const z=i.$vp.create(B).toString();let J=this.db.get(z);return J||(this.db.set(z,J=new ce(X,B,N,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F,this.C)),J.waitUntilTaskIsFinished().finally(()=>this.db.delete(z))),J}Z(X,B){return new be(X,B.profileLocation,this.fb)}async ob(X){const B=async z=>{let J=await d.Promises.readdir(z);J=J.map(G=>w.$kc(z,G));const ue=await Promise.all(J.map(G=>d.Promises.stat(G)));let x=Promise.resolve([]);return ue.forEach((G,U)=>{const T=J[U];G.isFile()&&(x=x.then(q=>[...q,T])),G.isDirectory()&&(x=x.then(q=>B(T).then(se=>[...q,...se])))}),x};return(await B(X.location.fsPath)).map(z=>({path:`extension/${w.$mc(X.location.fsPath,z)}`,localPath:z}))}async pb({added:X,removed:B}){if(B){const N=X&&this.D.extUri.isEqual(B.profileLocation,X.profileLocation)?B.extensions.filter(z=>X.extensions.every(J=>!(0,i.$up)(J,z))):B.extensions;for(const z of N)this.F.info("Extensions removed from another source",z.id,B.profileLocation.toString()),this.u.fire({identifier:z,profileLocation:B.profileLocation})}if(X){const z=(await this.getInstalled(1,X.profileLocation)).filter(J=>X.extensions.some(ue=>(0,i.$up)(ue,J.identifier)));this.s.fire(z.map(J=>(this.F.info("Extensions added from another source",J.identifier.id,X.profileLocation.toString()),{identifier:J.identifier,local:J,profileLocation:X.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(B=>this.qb.add(B)));const X=await this.hb.resolve(this.eb.userExtensionsLocation);for(const B of X.children??[])B.isDirectory&&this.qb.add(B.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(B=>this.sb(B)))}async sb(X){if(!X.affects(this.eb.userExtensionsLocation,1))return;const B=[];for(const N of X.rawAdded){if(this.qb.has(N)||!this.D.extUri.isEqual(this.D.extUri.dirname(N),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(N,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(N).startsWith(".")||!(await this.hb.stat(N)).isDirectory)continue;const z=await this.ab.scanUserExtensionAtLocation(N);z&&z.installedTimestamp===void 0&&(this.qb.add(N),B.push(z))}B.length&&(await this.tb(B.map(N=>[N,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",B.map(N=>N.identifier.id)))}async tb(X,B){const N=X.map(z=>z[0]);await this.ub(N),await this.fb.addExtensionsToProfile(X,B),this.s.fire(N.map(z=>({local:z,identifier:z.identifier,operation:1,profileLocation:B})))}async ub(X){const B=await this.ab.getUninstalledExtensions();for(const N of X){const z=i.$vp.create(N);B[z.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",z.id),await this.ab.setInstalled(z),this.F.info("Removed the extension from uninstalled list:",z.id))}}};e.$Eq=Y,e.$Eq=Y=Le([Ne(0,r.$6o),Ne(1,te.$2l),Ne(2,oe.$3j),Ne(3,t.$Ei),Ne(4,l.$tq),Ne(5,n.$pq),Ne(6,h.$Ko),Ne(7,Z.$vi),Ne(8,V.$3k),Ne(9,le.$jk),Ne(10,_.$Al),Ne(11,W.$Cl)],Y);let M=class extends g.$Vc{constructor(X,B,N,z,J,ue){super(),this.j=X,this.m=B,this.n=N,this.s=z,this.t=J,this.u=ue,this.h=this.B(new P.$ee),this.onExtract=this.h.event,this.c=(0,m.$0g)(this.n.userExtensionsLocation,".obsolete"),this.g=new o.$Dh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(X,B,N){const z={includeInvalid:!0,profileLocation:B,productVersion:N};let J=[];return X===null||X===0?J.push(...await this.n.scanAllExtensions({includeInvalid:!0},z,!1)):X===1&&J.push(...await this.n.scanUserExtensions(z)),J=X!==null?J.filter(ue=>ue.type===X):J,Promise.all(J.map(ue=>this.F(ue)))}async scanAllUserExtensions(X){const B=await this.n.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return Promise.all(B.map(N=>this.F(N)))}async scanUserExtensionAtLocation(X){try{const B=await this.n.scanExistingExtension(X,1,{includeInvalid:!0});if(B)return await this.F(B)}catch(B){this.u.error(B)}return null}async extractUserExtension(X,B,N,z,J){const ue=X.toString(),x=f.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Sg)()}`)),G=f.URI.file(w.$kc(this.n.userExtensionsLocation.fsPath,ue));let U=await this.m.exists(G);if(U&&z){try{await this.y(X.id,G,"removeExisting")}catch{throw new r.$7o(E.localize(4,null,G.fsPath,X.id),r.ExtensionManagementErrorCode.Delete)}U=!1}if(U)await this.n.updateMetadata(G,N);else try{try{this.u.trace(`Started extracting the extension from ${B} to ${G.fsPath}`),await(0,p.$jq)(B,x.fsPath,{sourcePath:"extension",overwrite:!0},J),this.u.info(`Extracted extension to ${G}:`,X.id)}catch(T){let q=r.ExtensionManagementErrorCode.Extract;throw T instanceof p.$hq&&(T.type==="CorruptZip"?q=r.ExtensionManagementErrorCode.CorruptZip:T.type==="Incomplete"&&(q=r.ExtensionManagementErrorCode.IncompleteZip)),new r.$7o(T.message,q)}await this.n.updateMetadata(x,N);try{this.u.trace(`Started renaming the extension from ${x.fsPath} to ${G.fsPath}`),await this.C(x.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(T){if(T.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(T)}. Deleted from extracted location`,x),T}this.h.fire(G)}catch(T){try{await this.m.del(x,{recursive:!0})}catch{}throw T}return this.D(G,1)}async scanMetadata(X,B){return B?(await this.w(X,B))?.metadata:this.n.scanMetadata(X.location)}async w(X,B){return(await this.s.scanProfileExtensions(B)).find(z=>(0,i.$up)(z.identifier,X.identifier))}async updateMetadata(X,B,N){return N?await this.s.updateMetadata([[X,B]],N):await this.n.updateMetadata(X.location,B),this.D(X.location,X.type,N)}getUninstalledExtensions(){return this.z()}async setUninstalled(...X){const B=X.map(N=>i.$vp.create(N));await this.z(N=>B.forEach(z=>{N[z.toString()]=!0,this.u.info("Marked extension as uninstalled",z.toString())}))}async setInstalled(X){await this.z(B=>delete B[X.toString()])}async removeExtension(X,B){if(this.t.extUri.isEqualOrParent(X.location,this.n.userExtensionsLocation))return this.y(X.identifier.id,X.location,B)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.z(B=>delete B[i.$vp.create(X).toString()])}async copyExtension(X,B,N,z){const J=await this.w(X,B),ue=await this.w(X,N);if(z={...J?.metadata,...z},ue)if(this.t.extUri.isEqual(ue.location,X.location))await this.s.updateMetadata([[X,{...ue.metadata,...z}]],N);else{const x=await this.D(ue.location,X.type,N);await this.s.removeExtensionFromProfile(x,N),await this.s.addExtensionsToProfile([[X,{...ue.metadata,...z}]],N)}else await this.s.addExtensionsToProfile([[X,z]],N);return this.D(X.location,X.type,N)}async copyExtensions(X,B,N){const z=await this.scanExtensions(1,X,N),J=await Promise.all(z.filter(ue=>!ue.isApplicationScoped).map(async ue=>[ue,await this.scanMetadata(ue,X)]));await this.s.addExtensionsToProfile(J,B)}async y(X,B,N){this.u.trace(`Deleting ${N} extension from disk`,X,B.fsPath);const z=this.t.extUri.joinPath(this.t.extUri.dirname(B),`${this.t.extUri.basename(B)}.${(0,b.$kj)((0,c.$Sg)()).toString(16)}${K}`);await this.C(B.fsPath,z.fsPath),await this.m.del(z,{recursive:!0}),this.u.info(`Deleted ${N} extension from disk`,X,B.fsPath)}async z(X){return this.g.queue(async()=>{let B;try{B=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(z){if((0,V.$hl)(z)!==1)throw z}let N={};if(B)try{N=JSON.parse(B)}catch{}return X&&(X(N),Object.keys(N).length?await this.m.writeFile(this.c,C.$Ge.fromString(JSON.stringify(N))):await this.m.del(this.c)),N})}async C(X,B){try{await d.Promises.rename(X,B,2*60*1e3)}catch(N){throw new r.$7o(N.message||E.localize(5,null,X,B),N.code||r.ExtensionManagementErrorCode.Rename)}}async D(X,B,N){if(N){const J=(await this.n.scanUserExtensions({profileLocation:N})).find(ue=>this.t.extUri.isEqual(ue.location,X));if(J)return this.F(J)}else{const z=await this.n.scanExistingExtension(X,B,{includeInvalid:!0});if(z)return this.F(z)}throw new Error(E.localize(6,null,X.path))}async F(X){const B=await this.m.resolve(X.location);let N,z;return B.children&&(N=B.children.find(({name:J})=>/^readme(\.txt|\.md|)$/i.test(J))?.resource,z=B.children.find(({name:J})=>/^changelog(\.txt|\.md|)$/i.test(J))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:N,changelogUrl:z,publisherDisplayName:X.metadata?.publisherDisplayName,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!X.metadata?.hasPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned,isWorkspaceScoped:!1,source:X.metadata?.source??(X.identifier.uuid?"gallery":"vsix")}}async G(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(X));const B=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),N=new Set;for(const J of B)X[i.$vp.create(J).toString()]||N.add(J.identifier.id.toLowerCase());try{const J=(0,i.$Ap)(B,ue=>ue.identifier);await o.Promises.settled(J.map(async ue=>{const x=ue.sort((G,U)=>u.rcompare(G.manifest.version,U.manifest.version))[0];N.has(x.identifier.id.toLowerCase())||await this.j(await this.F(x))}))}catch(J){this.u.error(J)}const z=B.filter(J=>J.metadata&&X[i.$vp.create(J).toString()]);await Promise.allSettled(z.map(J=>this.removeUninstalledExtension(J)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let X;try{X=await this.m.resolve(this.n.userExtensionsLocation)}catch(B){(0,V.$hl)(B)!==1&&this.u.error(B);return}if(X?.children)try{await Promise.allSettled(X.children.map(async B=>{if(!(!B.isDirectory||!B.name.endsWith(K))){this.u.trace("Deleting the temporarily deleted folder",B.resource.toString());try{await this.m.del(B.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",B.resource.toString())}catch(N){(0,V.$hl)(N)!==1&&this.u.error(N)}}}))}catch{}}};e.$Fq=M,e.$Fq=M=Le([Ne(1,V.$3k),Ne(2,l.$tq),Ne(3,n.$pq),Ne(4,_.$Al),Ne(5,oe.$3j)],M);class Q extends s.$nq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,a.$dg)(this.options.operation)?this.l:this.options.operation}constructor(X,B,N,z,J,ue,x,G,U,T){super(),this.manifest=X,this.identifier=B,this.source=N,this.options=z,this.m=J,this.n=ue,this.o=x,this.p=G,this.q=U,this.s=T,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(X){const[B,N]=await this.x(X);return this.j=B.isBuiltin||B.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[B,N]],this.j,!B.isValid),B}async u({zipPath:X,key:B,metadata:N},z,J){let ue=await this.v(B);return ue?ue=await this.m.updateMetadata(ue,N):(this.s.trace("Extracting extension...",B.id),ue=await this.m.extractUserExtension(B,X,N,z,J),this.s.info("Extracting extension completed.",B.id)),ue}async v(X){return await this.w(X)?(this.s.trace("Removing the extension from uninstalled list:",X.id),await this.m.setInstalled(X),this.s.info("Removed the extension from uninstalled list:",X.id),(await this.m.scanAllUserExtensions(!0)).find(z=>i.$vp.create(z).equals(X))):void 0}async w(X){return!!(await this.m.getUninstalledExtensions())[X.toString()]}}class ce extends Q{constructor(X,B,N,z,J,ue,x,G,U,T,q){super(X,B.identifier,B,N,J,ue,x,G,U,T),this.y=B,this.z=z,this.A=q}async x(X){let B;try{B=await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)}catch(J){throw new r.$7o(J,r.ExtensionManagementErrorCode.Scanning)}const N=B.find(J=>(0,i.$up)(J.identifier,this.y.identifier));N&&(this.l=3);const z={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||N?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||N?.isMachineScoped,isBuiltin:this.options.isBuiltin||N?.isBuiltin,isSystem:N?.type===0?!0:void 0,updated:!!N,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,hasPreReleaseVersion:N?.hasPreReleaseVersion||this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??N?.pinned,preRelease:(0,a.$cg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.y.properties.isPreReleaseVersion||N?.preRelease,source:"gallery"};if(N&&N.type!==0&&N.manifest.version===this.y.version)try{return[await this.m.updateMetadata(N,z),z]}catch(J){throw new r.$7o((0,I.$0)(J),r.ExtensionManagementErrorCode.UpdateMetadata)}try{return await this.C(z,X)}catch(J){if(J instanceof r.$7o&&(J.code===r.ExtensionManagementErrorCode.CorruptZip||J.code===r.ExtensionManagementErrorCode.IncompleteZip)){this.s.info("Downloaded VSIX is invalid. Trying to download and install again...",this.y.identifier.id);try{const ue=await this.C(z,X);return this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!0}),ue}catch(ue){throw this.A.publicLog2("extensiongallery:install:retry",{extensionId:this.y.identifier.id,succeeded:!1}),ue}}else throw J}}async C(X,B){const{location:N,verificationStatus:z}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=z,this.D(N.fsPath),[await this.u({zipPath:N.fsPath,key:i.$vp.create(this.y),metadata:X},!1,B),X]}catch(J){try{await this.z.delete(N)}catch(ue){this.s.warn("Error while deleting the downloaded file",N.toString(),(0,I.$0)(ue))}throw J}}async D(X){try{await(0,j.$Aq)(X)}catch(B){throw new r.$7o(B.message,r.ExtensionManagementErrorCode.Invalid)}}}e.$Gq=ce;class ie extends Q{constructor(X,B,N,z,J,ue,x,G,U,T){super(X,{id:(0,i.$zp)(X.publisher,X.name)},B,N,J,ue,x,G,U,T),this.y=B,this.z=z}async h(X){const B=await super.h(X);return this.C(B,X),B}async x(X){const B=new i.$vp(this.identifier,this.manifest.version),z=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(x=>(0,i.$up)(this.identifier,x.identifier)),J={isApplicationScoped:this.options.isApplicationScoped||z?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||z?.isMachineScoped,isBuiltin:this.options.isBuiltin||z?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??z?.pinned,source:"vsix"};if(z)if(this.l=3,B.equals(new i.$vp(z.identifier,z.manifest.version)))try{await this.m.removeExtension(z,"existing")}catch{throw new Error(E.localize(7,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&u.gt(z.manifest.version,this.manifest.version)&&await this.m.setUninstalled(z);else{const x=await this.v(B);if(x)try{await this.m.removeExtension(x,"existing")}catch{throw new Error(E.localize(8,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:w.$lc(this.y.fsPath),key:B,metadata:J},!0,X),J]}async C(X,B){try{let[N]=await this.z.getExtensions([{id:X.identifier.id,version:X.manifest.version}],B);if(N||([N]=await this.z.getExtensions([{id:X.identifier.id}],B)),N){const z={id:N.identifier.uuid,publisherDisplayName:N.publisherDisplayName,publisherId:N.publisherId,isPreReleaseVersion:N.properties.isPreReleaseVersion,hasPreReleaseVersion:X.hasPreReleaseVersion||N.properties.isPreReleaseVersion,preRelease:N.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(X,z,this.options.profileLocation)}}catch{}}}class be extends s.$nq{constructor(X,B,N){super(),this.extension=X,this.j=B,this.k=N}async h(X){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ye[128],Ee([1,0,12,33,34,29,50,16,26,4]),function(he,e,o,C,S,D,I,P,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TQ=void 0;let y=class extends I.$qq{constructor(w,m,u,a,f,c){super(g.URI.file(w.extensionsPath),m,u,a,f,c)}};e.$TQ=y,e.$TQ=y=Le([Ne(0,b.$Ei),Ne(1,P.$3k),Ne(2,C.$Cl),Ne(3,S.$Al),Ne(4,D.$2l),Ne(5,o.$3j)],y)}),define(ye[129],Ee([1,0,14,6,2,44,10,182,5,33]),function(he,e,o,C,S,D,I,P,b,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=e.$3p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$1p=e.$Zp=e.$Yp=void 0,e.$2p=m,e.$4p=a,e.$6p=c,e.$Yp="__$__isNewStorageMarker",e.$Zp="__$__targetStorageMarker",e.$1p=(0,b.$wi)("storageService");var y;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(y||(e.WillSaveStateReason=y={}));var v;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(v||(e.StorageScope=v={}));var w;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function m(d){const p=d.get(e.$Zp);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}class u extends S.$Vc{static{this.a=60*1e3}constructor(p={flushInterval:u.a}){super(),this.m=p,this.b=this.B(new C.$he),this.c=this.B(new C.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new o.$Ih(()=>this.n(),this.m.flushInterval)),this.j=this.B(new S.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(p,E,h){return C.Event.filter(this.b.event,t=>t.scope===p&&(E===void 0||t.key===E),h)}n(){this.j.value=(0,o.$Mh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,S.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.O()}finally{(0,D.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(p,E){const{key:h,external:t}=E;if(h===e.$Zp){switch(p){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:h,target:this.J(p)[h],external:t})}w(p){this.f.fire({reason:p})}get(p,E,h){return this.P(E)?.get(p,h)}getBoolean(p,E,h){return this.P(E)?.getBoolean(p,h)}getNumber(p,E,h){return this.P(E)?.getNumber(p,h)}getObject(p,E,h){return this.P(E)?.getObject(p,h)}storeAll(p,E){this.y(()=>{for(const h of p)this.store(h.key,h.value,h.scope,h.target,E)})}store(p,E,h,t,s=!1){if((0,I.$fg)(E)){this.remove(p,h,s);return}this.y(()=>{this.z(p,h,t),this.P(h)?.set(p,E,s)})}remove(p,E,h=!1){this.y(()=>{this.z(p,E,void 0),this.P(E)?.delete(p,h)})}y(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,E){const h=[],t=this.J(p);for(const s of Object.keys(t))t[s]===E&&h.push(s);return h}z(p,E,h,t=!1){const s=this.J(E);typeof h=="number"?s[p]!==h&&(s[p]=h,this.P(E)?.set(e.$Zp,JSON.stringify(s),t)):typeof s[p]=="number"&&(delete s[p],this.P(E)?.set(e.$Zp,JSON.stringify(s),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(p){switch(p){case-1:return this.I;case 0:return this.G;default:return this.D}}L(p){const E=this.P(p);return E?m(E):Object.create(null)}isNew(p){return this.getBoolean(e.$Yp,p)===!0}async flush(p=y.NONE){this.f.fire({reason:p});const E=this.P(-1),h=this.P(0),t=this.P(1);switch(p){case y.NONE:await o.Promises.settled([E?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case y.SHUTDOWN:await o.Promises.settled([E?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.P(-1)?.items??new Map,E=this.P(0)?.items??new Map,h=this.P(1)?.items??new Map;return c(p,E,h,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(p){return await this.flush(),this.P(p)?.optimize()}async switch(p,E){return this.w(y.NONE),(0,g.$Bl)(p)?this.R(p,E):this.S(p,E)}M(p,E){return!(p.id===E.id||a(E)&&a(p))}N(p,E,h){this.y(()=>{const t=new Set;for(const[s,r]of p)t.add(s),E.get(s)!==r&&this.u(h,{key:s,external:!0});for(const[s]of E.items)t.has(s)||this.u(h,{key:s,external:!0})})}}e.$3p=u;function a(d){return d.isDefault||!!d.useDefaultFlags?.globalState}class f extends u{constructor(){super(),this.U=this.B(new P.$Wp(new P.$Xp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$Wp(new P.$Xp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$Wp(new P.$Xp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(p=>this.u(1,p))),this.B(this.W.onDidChangeStorage(p=>this.u(0,p))),this.B(this.U.onDidChangeStorage(p=>this.u(-1,p)))}P(p){switch(p){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(p){return!1}}e.$5p=f;async function c(d,p,E,h,t,s){const r=F=>{try{return JSON.parse(F)}catch{return F}},i=new Map,n=new Map;d.forEach((F,V)=>{i.set(V,F),n.set(V,r(F))});const l=new Map,$=new Map;p.forEach((F,V)=>{l.set(V,F),$.set(V,r(F))});const k=new Map,j=new Map;E.forEach((F,V)=>{k.set(V,F),j.set(V,r(F))}),console.group(h!==t?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const A=[];if(i.forEach((F,V)=>{A.push({key:V,value:F})}),console.table(A),console.groupEnd(),console.log(n),h!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const F=[];l.forEach((V,Z)=>{F.push({key:Z,value:V})}),console.table(F),console.groupEnd(),console.log($)}console.group(`Storage: Workspace (path: ${s})`);const O=[];k.forEach((F,V)=>{O.push({key:V,value:F})}),console.table(O),console.groupEnd(),console.log(j)}}),define(ye[130],Ee([1,0,18,20,11,3,31,10,4,25,26,32,38,82,16,12,28,42,258,129,29,61]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=e.$0p=void 0,e.$9p=ie;const t=D.$o?"web":(0,v.$2o)(D.$u,I.$fc),s="X-Market-Search-Activity-Id";var r;(function(z){z[z.None=0]="None",z[z.IncludeVersions=1]="IncludeVersions",z[z.IncludeFiles=2]="IncludeFiles",z[z.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",z[z.IncludeSharedAccounts=8]="IncludeSharedAccounts",z[z.IncludeVersionProperties=16]="IncludeVersionProperties",z[z.ExcludeNonValidated=32]="ExcludeNonValidated",z[z.IncludeInstallationTargets=64]="IncludeInstallationTargets",z[z.IncludeAssetUri=128]="IncludeAssetUri",z[z.IncludeStatistics=256]="IncludeStatistics",z[z.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",z[z.Unpublished=4096]="Unpublished",z[z.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function i(...z){return String(z.reduce((J,ue)=>J|ue,0))}var n;(function(z){z[z.Tag=1]="Tag",z[z.ExtensionId=4]="ExtensionId",z[z.Category=5]="Category",z[z.ExtensionName=7]="ExtensionName",z[z.Target=8]="Target",z[z.Featured=9]="Featured",z[z.SearchText=10]="SearchText",z[z.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const l={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},$={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},j={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class A{constructor(J=j){this.d=J}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(J,ue=this.d.pageSize){return new A({...this.d,pageNumber:J,pageSize:ue})}withFilter(J,...ue){const x=[...this.d.criteria,...ue.length?ue.map(G=>({filterType:J,value:G})):[{filterType:J}]];return new A({...this.d,criteria:x})}withSortBy(J){return new A({...this.d,sortBy:J})}withSortOrder(J){return new A({...this.d,sortOrder:J})}withFlags(...J){return new A({...this.d,flags:J.reduce((ue,x)=>ue|x,0)})}withAssetTypes(...J){return new A({...this.d,assetTypes:J})}withSource(J){return new A({...this.d,source:J})}get raw(){const{criteria:J,pageNumber:ue,pageSize:x,sortBy:G,sortOrder:U,flags:T,assetTypes:q}=this.d;return{filters:[{criteria:J,pageNumber:ue,pageSize:x,sortBy:G,sortOrder:U}],assetTypes:q,flags:T}}get searchText(){const J=this.d.criteria.filter(ue=>ue.filterType===n.SearchText)[0];return J&&J.value?J.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(J=>String(J.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function O(z,J){const ue=(z||[]).filter(x=>x.statisticName===J)[0];return ue?ue.value:0}function F(z){const J="Microsoft.VisualStudio.Code.Translation.";return z.files.filter(x=>x.assetType.indexOf(J)===0).reduce((x,G)=>{const U=oe(z,G.assetType);return U&&x.push([G.assetType.substring(J.length),U]),x},[])}function V(z){if(z.properties){const J=z.properties.filter(G=>G.key===l.Repository),ue=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),x=J.filter(G=>ue.test(G.value))[0];return x?{uri:x.value,fallbackUri:x.value}:null}return oe(z,l.Repository)}function Z(z){return{uri:`${z.fallbackAssetUri}/${l.VSIX}?redirect=true${z.targetPlatform?`&targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${l.VSIX}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}}function oe(z,J){return z.files.filter(x=>x.assetType===J)[0]?{uri:`${z.assetUri}/${J}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`,fallbackUri:`${z.fallbackAssetUri}/${J}${z.targetPlatform?`?targetPlatform=${z.targetPlatform}`:""}`}:null}function le(z,J){const ue=z.properties?z.properties.filter(G=>G.key===J):[],x=ue.length>0&&ue[0].value;return x?x.split(",").map(G=>(0,w.$yp)(G)):[]}function te(z){const J=z.properties?z.properties.filter(ue=>ue.key===$.Engine):[];return J.length>0&&J[0].value||""}function _(z){const J=z.properties?z.properties.filter(ue=>ue.key===$.PreRelease):[];return J.length>0&&J[0].value==="true"}function W(z){const J=z.properties?z.properties.filter(x=>x.key===$.LocalizedLanguages):[],ue=J.length>0&&J[0].value||"";return ue?ue.split(","):[]}function K(z){return z.properties?.find(J=>J.key===$.SponsorLink)?.value}function Y(z){return z.properties?.find(J=>J.key===$.SupportLink)?.value}function M(z){return z.indexOf("preview")!==-1}function Q(z){return z.targetPlatform?(0,v.$1o)(z.targetPlatform):"undefined"}function ce(z){const J=(0,o.$Mb)(z.versions.map(Q)),ue=!!z.tags?.includes(v.$Vo),x=J.indexOf("web");return ue?x===-1&&J.push("web"):x!==-1&&J.splice(x,1),J}function ie(z,J){for(let ue=0;ue<z.length;ue++){const x=z[ue];if(x.version===z[ue-1]?.version){let G=ue;if(Q(x)===J)for(;G>0&&z[G-1].version===x.version;)G--;G!==ue&&(z.splice(ue,1),z.splice(G,0,x))}}return z}function be(z,J,ue){z.telemetryData={index:J,querySource:ue,queryActivityId:z.queryContext?.[s]}}function re(z,J,ue,x){const G=z.versions[0],U={manifest:oe(J,l.Manifest),readme:oe(J,l.Details),changelog:oe(J,l.Changelog),license:oe(J,l.License),repository:V(J),download:Z(J),icon:oe(J,l.Icon),signature:oe(J,l.Signature),coreTranslations:F(J)};return{identifier:{id:(0,w.$zp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},name:z.extensionName,version:J.version,displayName:z.displayName,publisherId:z.publisher.publisherId,publisher:z.publisher.publisherName,publisherDisplayName:z.publisher.displayName,publisherDomain:z.publisher.domain?{link:z.publisher.domain,verified:!!z.publisher.isDomainVerified}:void 0,publisherSponsorLink:K(G),description:z.shortDescription??"",installCount:O(z.statistics,"install"),rating:O(z.statistics,"averagerating"),ratingCount:O(z.statistics,"ratingcount"),categories:z.categories||[],tags:z.tags||[],releaseDate:Date.parse(z.releaseDate),lastUpdated:Date.parse(z.lastUpdated),allTargetPlatforms:ue,assets:U,properties:{dependencies:le(J,$.Dependency),extensionPack:le(J,$.ExtensionPack),engine:te(J),localizedLanguages:W(J),targetPlatform:Q(J),isPreReleaseVersion:_(J)},hasPreReleaseVersion:_(G),hasReleaseVersion:!0,preview:M(z.flags),isSigned:!!U.signature,queryContext:x,supportLink:Y(G)}}let X=class{constructor(J,ue,x,G,U,T,q,se){this.k=ue,this.l=x,this.n=G,this.o=U,this.q=T,this.u=q,this.w=se;const ae=q.extensionsGallery,me=ae?.servicePPEUrl&&se.getValue("_extensionsGallery.enablePPE");this.d=me?ae.servicePPEUrl:ae?.serviceUrl,this.g=me?void 0:ae?.searchUrl,this.h=ae?.controlUrl,this.j=(0,d.$8p)(q.version,q,this.n,this.w,this.q,J,this.o)}x(J=""){return`${this.d}${J}`}isEnabled(){return!!this.d}async getExtensions(J,ue,x){const G=C.CancellationToken.isCancellationToken(ue)?{}:ue,U=C.CancellationToken.isCancellationToken(ue)?ue:x,T=[],q=[],se=[],ae=[];let me=!0;for(const $e of J){$e.uuid?q.push($e.uuid):T.push($e.id);const Ce=!!($e.version||$e.preRelease);se.push({id:$e.id,uuid:$e.uuid,includePreRelease:Ce}),$e.version&&ae.push({id:$e.id,uuid:$e.uuid,version:$e.version}),me=me&&!!$e.hasPreRelease&&!Ce}if(!q.length&&!T.length)return[];let ee=new A().withPage(1,J.length);q.length&&(ee=ee.withFilter(n.ExtensionId,...q)),T.length&&(ee=ee.withFilter(n.ExtensionName,...T)),(G.queryAllVersions||me)&&(ee=ee.withFlags(ee.flags,r.IncludeVersions)),G.source&&(ee=ee.withSource(G.source));const{extensions:ge}=await this.z(ee,{targetPlatform:G.targetPlatform??t,includePreRelease:se,versions:ae,compatible:!!G.compatible,productVersion:G.productVersion??{version:this.u.version,date:this.u.date}},U);return G.source&&ge.forEach(($e,Ce)=>be($e,Ce,G.source)),ge}async getCompatibleExtension(J,ue,x,G={version:this.u.version,date:this.u.date}){if((0,v.$3o)(J.allTargetPlatforms,x))return null;if(await this.isExtensionCompatible(J,ue,x))return J;const U=new A().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,J.identifier.uuid),{extensions:T}=await this.z(U,{targetPlatform:x,compatible:!0,includePreRelease:ue,productVersion:G},C.CancellationToken.None);return T[0]||null}async isExtensionCompatible(J,ue,x,G={version:this.u.version,date:this.u.date}){if(!(0,v.$4o)(J.properties.targetPlatform,J.allTargetPlatforms,x)||!ue&&J.properties.isPreReleaseVersion)return!1;let U=J.properties.engine;if(!U){const T=await this.getManifest(J,C.CancellationToken.None);if(!T)throw new Error("Manifest was not found");U=T.engines.vscode}return(0,m.$Mp)(U,G.version,G.date)}async y(J,ue,x,G,U,T,q={version:this.u.version,date:this.u.date}){if(!(0,v.$4o)(Q(ue),U,T)||x!=="any"&&_(ue)!==(x==="prerelease"))return!1;if(G)try{const se=await this.E(J,ue);if(!(0,m.$Mp)(se,q.version,q.date))return!1}catch(se){return this.l.error(`Error while getting the engine for the version ${ue.version}.`,(0,S.$0)(se)),!1}return!0}async query(J,ue){let x=J.text||"";const G=J.pageSize??50;let U=new A().withPage(1,G);x?(x=x.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ee,ge)=>(U=U.withFilter(n.Category,ge||ee),"")),x=x.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ee,ge)=>(U=U.withFilter(n.Tag,ge||ee),"")),x=x.replace(/\bfeatured(\s+|\b|$)/g,()=>(U=U.withFilter(n.Featured),"")),x=x.trim(),x&&(x=x.length<200?x:x.substring(0,200),U=U.withFilter(n.SearchText,x)),U=U.withSortBy(0)):J.ids?U=U.withFilter(n.ExtensionId,...J.ids):J.names?U=U.withFilter(n.ExtensionName,...J.names):U=U.withSortBy(4),typeof J.sortBy=="number"&&(U=U.withSortBy(J.sortBy)),typeof J.sortOrder=="number"&&(U=U.withSortOrder(J.sortOrder)),J.source&&(U=U.withSource(J.source));const T=async(me,ee)=>{const{extensions:ge,total:$e}=await this.z(me,{targetPlatform:t,compatible:!1,includePreRelease:!!J.includePreRelease,productVersion:J.productVersion??{version:this.u.version,date:this.u.date}},ee);return ge.forEach((Ce,je)=>be(Ce,(me.pageNumber-1)*me.pageSize+je,J.source)),{extensions:ge,total:$e}},{extensions:q,total:se}=await T(U,ue),ae=async(me,ee)=>{if(ee.isCancellationRequested)throw new S.$5;const{extensions:ge}=await T(U.withPage(me+1),ee);return ge};return{firstPage:q,total:se,pageSize:U.pageSize,getPage:ae}}async z(J,ue,x){const G=J.flags;J.flags&r.IncludeLatestVersionOnly&&J.flags&r.IncludeVersions&&(J=J.withFlags(J.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(J.flags&r.IncludeLatestVersionOnly)&&!(J.flags&r.IncludeVersions)&&(J=J.withFlags(J.flags,r.IncludeLatestVersionOnly)),ue.versions?.length&&(J=J.withFlags(J.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),J=J.withFlags(J.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:U,total:T,context:q}=await this.B(J,x);if(!(J.flags&r.IncludeLatestVersionOnly)){const ee=[];for(const ge of U){const $e=await this.A(ge,ue,q);$e&&ee.push($e)}return{extensions:ee,total:T}}const ae=[],me=new Map;for(let ee=0;ee<U.length;ee++){const ge=U[ee],$e={id:(0,w.$zp)(ge.publisher.publisherName,ge.extensionName),uuid:ge.extensionId},Ce=(0,P.$cg)(ue.includePreRelease)?ue.includePreRelease:!!ue.includePreRelease.find(de=>(0,w.$up)(de,$e))?.includePreRelease;if(ue.compatible&&(0,v.$3o)(ce(ge),ue.targetPlatform))continue;const je=await this.A(ge,ue,q);!je||je.properties.isPreReleaseVersion&&(!Ce||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==ue.targetPlatform&&je.hasPreReleaseVersion?me.set(ge.extensionId,ee):ae.push([ee,je])}if(me.size){const ee=new h.$ae,ge=new A().withFlags(G&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,me.size).withFilter(n.ExtensionId,...me.keys()),{extensions:$e}=await this.z(ge,ue,x);this.o.publicLog2("galleryService:additionalQuery",{duration:ee.elapsed(),count:me.size});for(const Ce of $e){const je=me.get(Ce.identifier.uuid);ae.push([je,Ce])}}return{extensions:ae.sort((ee,ge)=>ee[0]-ge[0]).map(([,ee])=>ee),total:T}}async A(J,ue,x){const G={id:(0,w.$zp)(J.publisher.publisherName,J.extensionName),uuid:J.extensionId},U=ue.versions?.find(ae=>(0,w.$up)(ae,G))?.version,T=(0,P.$cg)(ue.includePreRelease)?ue.includePreRelease:!!ue.includePreRelease.find(ae=>(0,w.$up)(ae,G))?.includePreRelease,q=ce(J),se=ie(J.versions,ue.targetPlatform);if(ue.compatible&&(0,v.$3o)(q,ue.targetPlatform))return null;for(let ae=0;ae<se.length;ae++){const me=se[ae];if(!(U&&me.version!==U)){if(await this.y((0,w.$zp)(J.publisher.publisherName,J.extensionName),me,T?"any":"release",ue.compatible,q,ue.targetPlatform,ue.productVersion))return re(J,me,q,x);if(U&&me.version===U)return null}}return U||ue.compatible?null:re(J,J.versions[0],q)}async B(J,ue){if(!this.isEnabled())throw new Error("No extension gallery service configured.");J=J.withFlags(J.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(r.Unpublished));const x=await this.j,G=JSON.stringify(J.raw),U={...x,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},T=new h.$ae;let q,se,ae=0;try{if(q=await this.k.request({type:"POST",url:this.g&&J.criteria.some(ee=>ee.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:U},ue),q.res.statusCode&&q.res.statusCode>=400&&q.res.statusCode<500)return{galleryExtensions:[],total:ae};const me=await(0,c.$Tp)(q);if(me){const ee=me.results[0],ge=ee.extensions,$e=ee.resultMetadata&&ee.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ae=$e&&$e.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ae,context:{[s]:q.res.headers.activityid}}}return{galleryExtensions:[],total:ae}}catch(me){const ee=(0,S.$4)(me)?v.ExtensionGalleryErrorCode.Cancelled:(0,S.$0)(me).startsWith("XHR timeout")?v.ExtensionGalleryErrorCode.Timeout:v.ExtensionGalleryErrorCode.Failed;throw se=new v.$8o((0,S.$0)(me),ee),se}finally{this.o.publicLog2("galleryService:query",{...J.telemetryData,requestBodySize:String(G.length),duration:T.elapsed(),success:!!q&&(0,c.$Pp)(q),responseBodySize:q?.res.headers["Content-Length"],statusCode:q?String(q.res.statusCode):void 0,errorCode:se?.code,count:String(ae)})}}async reportStatistic(J,ue,x,G){if(!this.isEnabled())return;const U=D.$o?this.x(`/itemName/${J}.${ue}/version/${x}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${J}/extensions/${ue}/${x}/stats?statType=${G}`),T=D.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",se={...await this.j,Accept:T};try{await this.k.request({type:"POST",url:U,headers:se},C.CancellationToken.None)}catch{}}async download(J,ue,x){this.l.trace("ExtensionGalleryService#download",J.identifier.id);const G=(0,w.$Cp)(J),U=new Date().getTime(),T=ee=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:ee}),q=x===2?"install":x===3?"update":"",se=q?{uri:`${J.assets.download.uri}${b.URI.parse(J.assets.download.uri).query?"&":"?"}${q}=true`,fallbackUri:`${J.assets.download.fallbackUri}${b.URI.parse(J.assets.download.fallbackUri).query?"&":"?"}${q}=true`}:J.assets.download,ae=J.queryContext?.[s]?{[s]:J.queryContext[s]}:void 0,me=await this.D(J.identifier.id,se,l.VSIX,ae?{headers:ae}:void 0);await this.q.writeFile(ue,me.stream),T(new Date().getTime()-U)}async downloadSignatureArchive(J,ue){if(!J.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",J.identifier.id);const x=await this.D(J.identifier.id,J.assets.signature,l.Signature);await this.q.writeFile(ue,x.stream)}async getReadme(J,ue){if(J.assets.readme){const x=await this.D(J.identifier.id,J.assets.readme,l.Details,{},ue);return await(0,c.$Sp)(x)||""}return""}async getManifest(J,ue){if(J.assets.manifest){const x=await this.D(J.identifier.id,J.assets.manifest,l.Manifest,{},ue),G=await(0,c.$Sp)(x);return G?JSON.parse(G):null}return null}async C(J,ue,x){const G=oe(ue,l.Manifest);if(!G)throw new Error("Manifest was not found");const U={"Accept-Encoding":"gzip"},T=await this.D(J,G,l.Manifest,{headers:U});return await(0,c.$Tp)(T)}async getCoreTranslation(J,ue){const x=J.assets.coreTranslations.filter(G=>G[0]===ue.toUpperCase())[0];if(x){const G=await this.D(J.identifier.id,x[1],x[0]),U=await(0,c.$Sp)(G);return U?JSON.parse(U):null}return null}async getChangelog(J,ue){if(J.assets.changelog){const x=await this.D(J.identifier.id,J.assets.changelog,l.Changelog,{},ue);return await(0,c.$Sp)(x)||""}return""}async getAllCompatibleVersions(J,ue,x){let G=new A().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);J.identifier.uuid?G=G.withFilter(n.ExtensionId,J.identifier.uuid):G=G.withFilter(n.ExtensionName,J.identifier.id);const{galleryExtensions:U}=await this.B(G,C.CancellationToken.None);if(!U.length)return[];const T=ce(U[0]);if((0,v.$3o)(T,x))return[];const q=[];await Promise.all(U[0].versions.map(async me=>{try{await this.y(J.identifier.id,me,ue?"any":"release",!0,T,x)&&q.push(me)}catch{}}));const se=[],ae=new Set;for(const me of ie(q,x))ae.has(me.version)||(ae.add(me.version),se.push({version:me.version,date:me.lastUpdated,isPreReleaseVersion:_(me)}));return se}async D(J,ue,x,G={},U=C.CancellationToken.None){const T=await this.j,q={type:"GET"},se={...T,...G.headers||{}};G={...G,...q,headers:se};const ae=ue.uri,me=ue.fallbackUri,ee={...G,url:ae};try{const ge=await this.k.request(ee,U);if(ge.res.statusCode===200)return ge;const $e=await(0,c.$Sp)(ge);throw new Error(`Expected 200, got back ${ge.res.statusCode} instead.

${$e}`)}catch(ge){if((0,S.$4)(ge))throw ge;const $e=(0,S.$0)(ge);this.o.publicLog2("galleryService:cdnFallback",{extension:J,assetType:x,message:$e});const Ce={...G,url:me};return this.k.request(Ce,U)}}async E(J,ue){let x=te(ue);if(!x){this.o.publicLog2("galleryService:engineFallback",{extension:J,version:ue.version});const G=await this.C(J,ue,C.CancellationToken.None);if(!G)throw new Error("Manifest was not found");x=G.engines.vscode}return x}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const J=await this.k.request({type:"GET",url:this.h},C.CancellationToken.None);if(J.res.statusCode!==200)throw new Error("Could not get extensions report.");const ue=await(0,c.$Tp)(J),x=[],G={},U=[];if(ue){for(const T of ue.malicious)x.push({id:T});if(ue.migrateToPreRelease)for(const[T,q]of Object.entries(ue.migrateToPreRelease))(!q.engine||(0,m.$Mp)(q.engine,this.u.version,this.u.date))&&(G[T.toLowerCase()]={disallowInstall:!0,extension:{id:q.id,displayName:q.displayName,autoMigrate:{storage:!!q.migrateStorage},preRelease:!0}});if(ue.deprecated)for(const[T,q]of Object.entries(ue.deprecated))q&&(G[T.toLowerCase()]=(0,P.$cg)(q)?{}:q);if(ue.search)for(const T of ue.search)U.push(T)}return{malicious:x,deprecated:G,search:U}}};X=Le([Ne(1,c.$Np),Ne(2,a.$3j),Ne(3,y.$Di),Ne(4,E.$2l),Ne(5,u.$3k),Ne(6,f.$jk),Ne(7,g.$3i)],X);let B=class extends X{constructor(J,ue,x,G,U,T,q,se){super(J,ue,x,G,U,T,q,se)}};e.$0p=B,e.$0p=B=Le([Ne(0,p.$1p),Ne(1,c.$Np),Ne(2,a.$3j),Ne(3,y.$Di),Ne(4,E.$2l),Ne(5,u.$3k),Ne(6,f.$jk),Ne(7,g.$3i)],B);let N=class extends X{constructor(J,ue,x,G,U,T,q){super(void 0,J,ue,x,G,U,T,q)}};e.$$p=N,e.$$p=N=Le([Ne(0,c.$Np),Ne(1,a.$3j),Ne(2,y.$Di),Ne(3,E.$2l),Ne(4,u.$3k),Ne(5,f.$jk),Ne(6,g.$3i)],N)}),define(ye[273],Ee([1,0,6,2,33,55]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Q=e.$1Q=void 0;class I{constructor(g,y){this.a=g,this.b=y}listen(g,y){const v=this.b(g);switch(y){case"onDidChangeProfiles":return o.Event.map(this.a.onDidChangeProfiles,w=>({all:w.all.map(m=>(0,D.$An)({...m},v)),added:w.added.map(m=>(0,D.$An)({...m},v)),removed:w.removed.map(m=>(0,D.$An)({...m},v)),updated:w.updated.map(m=>(0,D.$An)({...m},v))}))}throw new Error(`Invalid listen ${y}`)}async call(g,y,v){const w=this.b(g);switch(y){case"createProfile":{const m=await this.a.createProfile(v[0],v[1],v[2]);return(0,D.$An)({...m},w)}case"updateProfile":{let m=(0,S.$Dl)((0,D.$Bn)(v[0],w),this.a.profilesHome.scheme);return m=await this.a.updateProfile(m,v[1]),(0,D.$An)({...m},w)}case"removeProfile":{const m=(0,S.$Dl)((0,D.$Bn)(v[0],w),this.a.profilesHome.scheme);return this.a.removeProfile(m)}}throw new Error(`Invalid call ${y}`)}}e.$1Q=I;class P extends C.$Vc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,y,v){super(),this.profilesHome=y,this.f=v,this.a=[],this.b=this.B(new o.$ee),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(w=>(0,S.$Dl)(w,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(w=>{const m=w.added.map(f=>(0,S.$Dl)(f,this.profilesHome.scheme)),u=w.removed.map(f=>(0,S.$Dl)(f,this.profilesHome.scheme)),a=w.updated.map(f=>(0,S.$Dl)(f,this.profilesHome.scheme));this.a=w.all.map(f=>(0,S.$Dl)(f,this.profilesHome.scheme)),this.b.fire({added:m,removed:u,updated:a,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,y,v){const w=await this.f.call("createNamedProfile",[g,y,v]);return(0,S.$Dl)(w,this.profilesHome.scheme)}async createProfile(g,y,v,w){const m=await this.f.call("createProfile",[g,y,v,w]);return(0,S.$Dl)(m,this.profilesHome.scheme)}async createTransientProfile(g){const y=await this.f.call("createTransientProfile",[g]);return(0,S.$Dl)(y,this.profilesHome.scheme)}async setProfileForWorkspace(g,y){await this.f.call("setProfileForWorkspace",[g,y])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,y){const v=await this.f.call("updateProfile",[g,y]);return(0,S.$Dl)(v,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$2Q=P}),define(ye[131],Ee([1,0,4,26,16,12,251,34,33,10,252]),function(he,e,o,C,S,D,I,P,b,g,y){"use strict";var v,w;Object.defineProperty(e,"__esModule",{value:!0}),e.$SQ=e.$RQ=e.$QQ=void 0;let m=class extends b.$Fl{static{v=this}static{this.a="profileAssociationsMigration"}constructor(c,d,p,E,h){super(p,E,d,h),this.U=c,this.W=p}O(){return this.U.getItem(v.b,[]).map(d=>({...d,location:(0,g.$9f)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):o.URI.revive(d.location)}))}Q(){const c=this.U.getItem(v.c,{});return this.U.getItem(v.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(o.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$QQ=m,e.$QQ=m=v=Le([Ne(0,I.$LQ),Ne(1,P.$Al),Ne(2,C.$Ei),Ne(3,S.$3k),Ne(4,D.$3j)],m);let u=w=class extends m{constructor(c,d,p,E,h){super(c,d,p,E,h),this.$=c}P(c){c.length?this.$.setItem(w.b,c.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(w.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(w.c,c):this.$.removeItem(w.c)}Q(){const c="workspaceAndProfileInfo",d=this.$.getItem(c,void 0);if(d){this.$.removeItem(c);const E=d.reduce((h,{workspace:t,profile:s})=>(h[o.URI.revive(t).toString()]=o.URI.revive(s).toString(),h),{});this.$.setItem(w.c,{workspaces:E})}const p=super.Q();return this.$.getItem(w.a,!1)||(this.R(p),this.$.setItem(w.a,!0)),p}};e.$RQ=u,e.$RQ=u=w=Le([Ne(0,I.$MQ),Ne(1,P.$Al),Ne(2,C.$Ei),Ne(3,S.$3k),Ne(4,D.$3j)],u);let a=class extends u{constructor(c,d,p,E){super(new y.$PQ(0,d,E,p),c,d,p,E)}async init(){return await this.$.init(),super.init()}};e.$SQ=a,e.$SQ=a=Le([Ne(0,P.$Al),Ne(1,C.$Ei),Ne(2,S.$3k),Ne(3,D.$3j)],a)}),define(ye[132],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,o.$wi)("extensionHostStatusService");class C{constructor(){this.a=new Map}setExitInfo(D,I){this.a.set(D,I)}getExitInfo(D){return this.a.get(D)||null}}e.$jn=C}),define(ye[274],Ee([1,0,6,14]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0;function S(I){let P=0,b=0,g=0;I>=1e3&&(g=Math.floor(I/1e3),I-=g*1e3),g>=60&&(b=Math.floor(g/60),g-=b*60),b>=60&&(P=Math.floor(b/60),b-=P*60);const y=P?`${P}h`:"",v=b?`${b}m`:"",w=g?`${g}s`:"",m=I?`${I}ms`:"";return`${y}${v}${w}${m}`}class D{constructor(P,b,g,y){this.i=P,this.j=b,this.a=new o.$ee,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=g,this.protocol=y,this.e=!1,this.f=new C.$Jh(()=>{this.k(`The reconnection grace time of ${S(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new C.$Jh(()=>{this.k(`The reconnection short grace time of ${S(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${S(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${S(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,b,g){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(b,g),this.protocol.endAcceptReconnection()}}e.$rn=D}),define(ye[133],Ee([1,0,27,13,7,164,58]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=void 0,e.$am=y;const P=S.$kc(C.$Qg.asFileUri("").fsPath,"nls.metadata.json"),b=new Map;function g(w){return new Promise(m=>o.exists(w,m))}function y(w,m){return g(P).then(u=>{if(!u||!I.default.commit)return Promise.resolve({locale:"en",osLocale:"en",availableLanguages:{}});const a=`${w}||${m}`;let f=b.get(a);return f||(f=D.getNLSConfiguration(I.default.commit,m,P,w,w).then(c=>(v.is(c)&&(c._languagePackSupport=!0),c)),b.set(a,f)),f})}var v;(function(w){function m(u){const a=u;return a&&typeof a._languagePackId=="string"}w.is=m})(v||(e.InternalNLSConfiguration=v={}))}),define(ye[134],Ee([1,0,19,4,26,50,59,16,5,12,28,34,33,133]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GQ=void 0;let u=class extends I.$uq{constructor(f,c,d,p,E,h,t,s){super(C.URI.file(E.builtinExtensionsPath),C.URI.file(E.extensionsPath),(0,o.$0g)(E.userHome,".vscode-oss-dev","extensions","control.json"),f.defaultProfile,f,c,d,p,E,h,t,s),this.S=E}async f(f){const c=await(0,m.$am)(f,this.S.userDataPath);if(m.InternalNLSConfiguration.is(c))try{const d=await this.w.readFile(C.URI.file(c._translationsConfigFile));return JSON.parse(d.value.toString())}catch{}return Object.create(null)}};e.$GQ=u,e.$GQ=u=Le([Ne(0,w.$Cl),Ne(1,D.$pq),Ne(2,P.$3k),Ne(3,g.$3j),Ne(4,S.$Ei),Ne(5,y.$jk),Ne(6,v.$Al),Ne(7,b.$vi)],u)}),define(ye[275],Ee([1,0,276,27,7,22,13,23]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.ServerConnectionTokenType=void 0,e.$vn=m,e.$wn=u,e.$xn=a;const b=/^[0-9A-Za-z_-]+$/;var g;(function(f){f[f.None=0]="None",f[f.Optional=1]="Optional",f[f.Mandatory=2]="Mandatory"})(g||(e.ServerConnectionTokenType=g={}));class y{constructor(){this.type=0}validate(c){return!0}}e.$sn=y;class v{constructor(c){this.value=c,this.type=2}validate(c){return c===this.value}}e.$tn=v;class w{constructor(c){this.message=c}}e.$un=w;async function m(f,c){const d=f["without-connection-token"],p=f["connection-token"],E=f["connection-token-file"];if(d)return typeof p<"u"||typeof E<"u"?new w("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new y;if(typeof E<"u"){if(typeof p<"u")return new w("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let h;try{h=C.readFileSync(E).toString().replace(/\r?\n$/,"")}catch{return new w(`Unable to read the connection token file at '${E}'.`)}return b.test(h)?new v(h):new w(`The connection token defined in '${E} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof p<"u"?b.test(p)?new v(p):new w(`The connection token '${p} does not adhere to the characters 0-9, a-z, A-Z or -.`):new v(await c())}async function u(f){return m(f,async()=>{if(!f["user-data-dir"])return(0,D.$Sg)();const d=S.$kc(f["user-data-dir"],"token");try{const h=(await P.Promises.readFile(d)).toString().replace(/\r?\n$/,"");if(b.test(h))return h}catch{}const p=(0,D.$Sg)();try{await P.Promises.writeFile(d,p,{mode:384})}catch{}return p})}function a(f,c,d){if(f.validate(d.query[I.$Ig]))return!0;const p=o.parse(c.headers.cookie||"");return f.validate(p[I.$Hg])}}),define(ye[51],Ee([1,0,214,109,67,5,26,74]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bn=e.$an=e.$_m=void 0,e.$_m={host:{type:"string",cat:"o",args:"ip-address",description:o.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:o.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:o.localize(2,null)},"server-base-path":{type:"string",cat:"o",args:"path",description:o.localize(3,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:o.localize(4,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:o.localize(5,null)},"without-connection-token":{type:"boolean",cat:"o",description:o.localize(6,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:o.localize(7,null)},"server-data-dir":{type:"string",cat:"o",description:o.localize(8,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:o.localize(9,null)},"user-data-dir":S.$sm["user-data-dir"],"enable-smoke-test-driver":S.$sm["enable-smoke-test-driver"],"disable-telemetry":S.$sm["disable-telemetry"],"disable-workspace-trust":S.$sm["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:S.$sm.log,logsPath:S.$sm.logsPath,"force-disable-user-env":S.$sm["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:o.localize(10,null)},"default-workspace":{type:"string",description:o.localize(11,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"use-test-resolver":{type:"boolean"},"extensions-dir":S.$sm["extensions-dir"],"extensions-download-dir":S.$sm["extensions-download-dir"],"builtin-extensions-dir":S.$sm["builtin-extensions-dir"],"install-extension":S.$sm["install-extension"],"install-builtin-extension":S.$sm["install-builtin-extension"],"update-extensions":S.$sm["update-extensions"],"uninstall-extension":S.$sm["uninstall-extension"],"list-extensions":S.$sm["list-extensions"],"locate-extension":S.$sm["locate-extension"],"show-versions":S.$sm["show-versions"],category:S.$sm.category,force:S.$sm.force,"do-not-sync":S.$sm["do-not-sync"],"pre-release":S.$sm["pre-release"],"start-server":{type:"boolean",cat:"e",description:o.localize(12,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:S.$sm.help,version:S.$sm.version,"locate-shell-integration-path":S.$sm["locate-shell-integration-path"],compatibility:{type:"string"},_:S.$sm._},e.$an=(0,D.$xi)(I.$Di);class b extends C.$9m{get userRoamingDataHome(){return this.appSettingsHome}get args(){return super.args}}e.$bn=b,Le([P.$1h],b.prototype,"userRoamingDataHome",null)}),define(ye[277],Ee([1,0,27,23,77,87,276,90,35,65,3,12,51,7,13,22,28,42,20,4,15,10]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8Q=e.CacheControl=void 0,e.$6Q=s,e.$7Q=i;const t={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function s($,k,j,A){k.writeHead(j,{"Content-Type":"text/plain"}),k.end(A)}var r;(function($){$[$.NO_CACHING=0]="NO_CACHING",$[$.ETAG=1]="ETAG",$[$.NO_EXPIRY=2]="NO_EXPIRY"})(r||(e.CacheControl=r={}));async function i($,k,j,A,O,F){try{const V=await C.Promises.stat($);if(k===1){const Z=`W/"${[V.ino,V.size,V.mtime.getTime()].join("-")}"`;if(A.headers["if-none-match"]===Z)return O.writeHead(304),void O.end();F.Etag=Z}else k===2?F["Cache-Control"]="public, max-age=31536000":k===0&&(F["Cache-Control"]="no-store");F["Content-Type"]=t[(0,m.$pc)($)]||(0,g.$Ss)($)||"text/plain",O.writeHead(200,F),(0,o.createReadStream)($).pipe(O)}catch(V){return V.code!=="ENOENT"?(j.error(V),console.error(V.toString())):console.error(`File not found: ${$}`),O.writeHead(404,{"Content-Type":"text/plain"}),void O.end("Not found")}}const n=(0,m.$nc)(u.$Qg.asFileUri("").fsPath);let l=class{constructor(k,j,A,O,F,V,Z){this.f=k,this.g=j,this.serverRootPath=A,this.h=O,this.i=F,this.j=V,this.k=Z,this.a=this.k.extensionsGallery?.resourceUrlTemplate?p.URI.parse(this.k.extensionsGallery.resourceUrlTemplate):void 0,this.b=`${A}/static`,this.c=`${A}/callback`,this.d=`${A}/web-extension-resource`}async handle(k,j,A){try{const O=A.pathname;return O.startsWith(this.b)&&O.charCodeAt(this.b.length)===47?this.l(k,j,A):O===this.g?this.o(k,j,A):O===this.c?this.q(j):O.startsWith(this.d)&&O.charCodeAt(this.d.length)===47?this.n(k,j,A):s(k,j,404,"Not found.")}catch(O){return this.i.error(O),console.error(O.toString()),s(k,j,500,"Internal Server Error.")}}async l(k,j,A){const O=Object.create(null),V=decodeURIComponent(A.pathname).substring(this.b.length+1),Z=(0,m.$kc)(n,V);return(0,b.$vg)(Z,n,!y.$k)?i(Z,this.h.isBuilt?2:1,this.i,k,j,O):s(k,j,400,"Bad request.")}m(k){const j=k.authority.indexOf(".");return j!==-1?k.authority.substring(j+1):void 0}async n(k,j,A){if(!this.a)return s(k,j,500,"No extension gallery service configured.");const O=decodeURIComponent(A.pathname),F=(0,m.$ic)(O.substring(this.d.length+1)),V=p.URI.parse(F).with({scheme:this.a.scheme,authority:F.substring(0,F.indexOf("/")),path:F.substring(F.indexOf("/")+1)});if(this.m(this.a)!==this.m(V))return s(k,j,403,"Request Forbidden");const Z={},oe=Y=>{const M=k.headers[Y];M&&((0,h.$9f)(M)||M[0])?Z[Y]=(0,h.$9f)(M)?M:M[0]:Y!==Y.toLowerCase()&&oe(Y.toLowerCase())};oe("X-Client-Name"),oe("X-Client-Version"),oe("X-Machine-Id"),oe("X-Client-Commit");const le=await this.j.request({type:"GET",url:V.toString(!0),headers:Z},d.CancellationToken.None),te=le.res.statusCode||500;if(te!==200){let Y=null;try{Y=await(0,c.$Sp)(le)}catch{}return s(k,j,te,Y||`Request failed with status ${te}`)}const _=Object.create(null),W=Y=>{const M=le.res.headers[Y];M?_[Y]=M:Y!==Y.toLowerCase()&&W(Y.toLowerCase())};W("Cache-Control"),W("Content-Type"),j.writeHead(200,_);const K=await(0,E.$Se)(le.stream);return void j.end(K.buffer)}async o(k,j,A){const O=A.query[u.$Ig];if(typeof O=="string"){const X=Object.create(null);X["Set-Cookie"]=I.serialize(u.$Hg,O,{sameSite:"lax",maxAge:60*60*24*7});const B=Object.create(null);for(const z in A.query)z!==u.$Ig&&(B[z]=A.query[z]);const N=D.format({pathname:A.pathname,query:B});return X.Location=N,j.writeHead(302,X),void j.end()}const F=X=>{const B=k.headers[X];return Array.isArray(B)?B[0]:B},V=!this.h.isBuilt&&this.h.args["use-test-resolver"],Z=V?"test+test":F("x-original-host")||F("x-forwarded-host")||k.headers.host;if(!Z)return s(k,j,400,"Bad request.");function oe(X){return JSON.stringify(X).replace(/"/g,"&quot;")}let le;this.h.args["enable-smoke-test-driver"]&&(le=!1);const te=X=>X&&p.URI.file(S.resolve(X)).with({scheme:u.Schemas.vscodeRemote,authority:Z}),_=u.$Qg.asFileUri(this.h.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,W=!this.h.isBuilt&&this.h.args["github-auth"]?{id:(0,a.$Sg)(),providerId:"github",accessToken:this.h.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,K={embedderIdentifier:"server-distro",extensionsGallery:this.a?{...this.k.extensionsGallery,resourceUrlTemplate:this.a.with({scheme:"http",authority:Z,path:`${this.d}/${this.a.authority}${this.a.path}`}).toString(!0)}:void 0};if(!this.h.isBuilt)try{const X=JSON.parse((await C.Promises.readFile((0,m.$kc)(n,"product.overrides.json"))).toString());Object.assign(K,X)}catch{}const Y={remoteAuthority:Z,serverBasePath:this.g,_wrapWebWorkerExtHostInIframe:le,developmentOptions:{enableSmokeTestDriver:this.h.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.i.getLevel()},settingsSyncOptions:!this.h.isBuilt&&this.h.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.h.args["disable-workspace-trust"],folderUri:te(this.h.args["default-folder"]),workspaceUri:te(this.h.args["default-workspace"]),productConfiguration:K,callbackRoute:this.c},M=this.k.extensionsGallery?.nlsBaseUrl,Q={WORKBENCH_WEB_CONFIGURATION:oe(Y),WORKBENCH_AUTH_SESSION:W?oe(W):"",WORKBENCH_WEB_BASE_URL:this.b,WORKBENCH_NLS_BASE_URL:M?`${M}${M.endsWith("/")?"":"/"}${this.k.commit}/${this.k.version}/`:""};if(V){const X=[];for(const B of["vscode-test-resolver","github-authentication"]){const N=JSON.parse((await C.Promises.readFile(u.$Qg.asFileUri(`${u.$Lg}/${B}/package.json`).fsPath)).toString());X.push({extensionPath:B,packageJSON:N})}Q.WORKBENCH_BUILTIN_EXTENSIONS=oe(X)}let ce;try{ce=(await C.Promises.readFile(_)).toString().replace(/\{\{([^}]+)\}\}/g,(B,N)=>Q[N]??"undefined")}catch{return j.writeHead(404,{"Content-Type":"text/plain"}),void j.end("Not found")}const re={"Content-Type":"text/html","Content-Security-Policy":["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.p(ce).join(" ")} 'sha256-75NYUUvf+5++1WbfCZOV3PSWxBhONpaxwx+mkOFRv/Y=' ${V?"":`http://${Z}`};`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ")};return this.f.type!==0&&(re["Set-Cookie"]=I.serialize(u.$Hg,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),j.writeHead(200,re),void j.end(ce)}p(k){const j=/<script>([\s\S]+?)<\/script>/img,A=[];let O;for(;O=j.exec(k);){const F=P.createHash("sha256"),V=O[1].replace(/\r\n/g,`
`),Z=F.update(Buffer.from(V)).digest().toString("base64");A.push(`'sha256-${Z}'`)}return A}async q(k){const j=u.$Qg.asFileUri("vs/code/browser/workbench/callback.html").fsPath,A=(await C.Promises.readFile(j)).toString(),O=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.p(A).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return k.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":O}),void k.end(A)}};e.$8Q=l,e.$8Q=l=Le([Ne(3,w.$an),Ne(4,v.$3j),Ne(5,c.$Np),Ne(6,f.$jk)],l)}),define(ye[278],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MP=void 0,e.$MP=(0,o.$wi)("IExtHostInitDataService")}),define(ye[279],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xP=e.$wP=void 0,e.$wP=(0,o.$wi)("IExtHostRpcService");class C{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.dispose=D.dispose.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.$xP=C}),define(ye[71],Ee([1,0,55]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bs=S;function C(D){return{transformIncoming:I=>I.scheme==="vscode-remote"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="file"?{scheme:"vscode-local",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoing:I=>I.scheme==="file"?{scheme:"vscode-remote",authority:D,path:I.path,query:I.query,fragment:I.fragment}:I.scheme==="vscode-local"?{scheme:"file",path:I.path,query:I.query,fragment:I.fragment}:I,transformOutgoingScheme:I=>I==="file"?"vscode-remote":I==="vscode-local"?"file":I}}function S(D){return new o.$yn(C(D))}}),define(ye[280],Ee([1,0,3,44,4,71,55,105,255,7,19]),function(he,e,o,C,S,D,I,P,b,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Is=void 0;class v{static{this.a=1}constructor(m,u,a,f){this.b=m,this.c=u,this.d=a,this.e=f}async call(m,u,a){switch(u){case"getEnvironmentData":{const f=a,c=(0,D.$Bs)(f.remoteAuthority);let d=await this.f(f.profile);return d=(0,I.$An)(d,c),d}case"getExtensionHostExitInfo":{const f=a;return this.e.getExitInfo(f.reconnectionToken)}case"getDiagnosticInfo":{const f=a,c={machineInfo:(0,b.$Fs)()},d=f.includeProcesses?(0,P.$Ds)(process.pid):Promise.resolve();let p=[];const E={};if(f.folders){const h=(0,D.$Bs)("");p=f.folders.map(s=>S.URI.revive(h.transformIncoming(s))).filter(s=>s.scheme==="file").map(s=>(0,b.$Es)(s.fsPath,["node_modules",".git"]).then(r=>{E[(0,g.$oc)(s.fsPath)]=r}))}return Promise.all([d,...p]).then(([h,t])=>(c.processes=h||void 0,c.workspaceMetadata=f.folders?E:void 0,c))}}throw new Error(`IPC Command ${u} not found`)}listen(m,u,a){throw new Error("Not supported")}async f(m){m&&!this.d.profiles.some(a=>a.id===m)&&await this.d.createProfile(m,m);let u=!1;if(process.platform==="linux"){const a=process.glibcVersion;u=(a?parseInt(a.split(".")[1]):28)<=27}return{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:S.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:this.c.logsHome,extensionHostLogsPath:(0,y.$0g)(this.c.logsHome,`exthost${v.a++}`),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:o.OS,arch:process.arch,marks:C.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(a=>({...a}))},isUnsupportedGlibc:u}}}e.$Is=v}),define(ye[281],Ee([1,0,4,71,69,7,241]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ls=void 0;class P extends I.$Js{constructor(y,v){super(new S.$_q(y),y),this.N=v,this.M=new Map,this.B(this.a)}c(y){let v=this.M.get(y.remoteAuthority);return v||(v=(0,C.$Bs)(y.remoteAuthority),this.M.set(y.remoteAuthority,v)),v}f(y,v,w=!1){if(w&&v.path==="/vscode-resource"&&v.query){const m=JSON.parse(v.query).requestResourcePath;return o.URI.from({scheme:"file",path:m})}return o.URI.revive(y.transformIncoming(v))}L(y,v){return new b(y,v,this.b,this.N)}}e.$Ls=P;class b extends I.$Ks{constructor(y,v,w,m){super(y,v,w,m)}j(y){const v=y.args["file-watcher-polling"];if(v){const w=v.split(D.$uc),m=Number(w[0]);if(m>0)return{usePolling:w.length>1?w.slice(1):!0,pollingInterval:m}}}m(y){if(y.extensionsPath)return[D.$hc.join(y.extensionsPath,"**")]}}}),define(ye[94],Ee([1,0,217,10,4,2,5,36,16,13,39,170,63]),function(he,e,o,C,S,D,I,P,b,g,y,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$QF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$HF=e.EditorInputCapabilities=e.$GF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$wF=e.$vF=e.$uF=e.$tF=e.$sF=void 0,e.$xF=a,e.$yF=f,e.$zF=c,e.$AF=d,e.$BF=p,e.$CF=E,e.$DF=h,e.$EF=t,e.$FF=s,e.$IF=k,e.$JF=A,e.$KF=O,e.$LF=F,e.$MF=V,e.$NF=Z,e.$OF=oe,e.$PF=Y,e.$RF=ce,e.$SF=be,e.$TF=re,e.$UF=X,e.$sF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$tF={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.$uF="workbench.editor.sidebysideEditor",e.$vF="workbench.editors.textDiffEditor",e.$wF="workbench.editors.binaryResourceDiffEditor";var m;(function(B){B[B.PROGRAMMATIC=1]="PROGRAMMATIC",B[B.USER=2]="USER",B[B.EDIT=3]="EDIT",B[B.NAVIGATION=4]="NAVIGATION",B[B.JUMP=5]="JUMP"})(m||(e.EditorPaneSelectionChangeReason=m={}));var u;(function(B){B[B.IDENTICAL=1]="IDENTICAL",B[B.SIMILAR=2]="SIMILAR",B[B.DIFFERENT=3]="DIFFERENT"})(u||(e.EditorPaneSelectionCompareResult=u={}));function a(B){const N=B;return!!N&&typeof N.getSelection=="function"&&!!N.onDidChangeSelection}function f(B){const N=B;return!!N&&typeof N.getScrollPosition=="function"&&typeof N.setScrollPosition=="function"&&!!N.onDidChangeScroll}function c(B,N,z){for(const J of z.visibleEditorPanes)if(J.group.id===N&&B.matches(J.input))return J.getViewState()}function d(B){if(k(B))return!1;const N=B;return S.URI.isUri(N?.resource)}function p(B){if(k(B))return!1;const N=B;return N?.original!==void 0&&N.modified!==void 0}function E(B){if(k(B))return!1;const N=B;return!N||N.resources&&!Array.isArray(N.resources)?!1:!!N.resources||!!N.multiDiffSource}function h(B){if(k(B)||p(B))return!1;const N=B;return N?.primary!==void 0&&N.secondary!==void 0}function t(B){if(k(B))return!1;const N=B;return N?N.resource===void 0||N.resource.scheme===g.Schemas.untitled||N.forceUntitled===!0:!1}function s(B){if(k(B))return!1;const N=B;return S.URI.isUri(N?.base?.resource)&&S.URI.isUri(N?.input1?.resource)&&S.URI.isUri(N?.input2?.resource)&&S.URI.isUri(N?.result?.resource)}var r;(function(B){B[B.SHORT=0]="SHORT",B[B.MEDIUM=1]="MEDIUM",B[B.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var i;(function(B){B[B.EXPLICIT=1]="EXPLICIT",B[B.AUTO=2]="AUTO",B[B.FOCUS_CHANGE=3]="FOCUS_CHANGE",B[B.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(i||(e.SaveReason=i={}));class n{constructor(){this.a=new Map}registerSource(N,z){let J=this.a.get(N);return J||(J={source:N,label:z},this.a.set(N,J)),J.source}getSourceLabel(N){return this.a.get(N)?.label??N}}e.$GF=new n;var l;(function(B){B[B.None=0]="None",B[B.Readonly=2]="Readonly",B[B.Untitled=4]="Untitled",B[B.Singleton=8]="Singleton",B[B.RequiresTrust=16]="RequiresTrust",B[B.CanSplitInGroup=32]="CanSplitInGroup",B[B.ForceDescription=64]="ForceDescription",B[B.CanDropIntoEditor=128]="CanDropIntoEditor",B[B.MultipleEditors=256]="MultipleEditors",B[B.Scratchpad=512]="Scratchpad"})(l||(e.EditorInputCapabilities=l={}));class $ extends D.$Vc{}e.$HF=$;function k(B){return B instanceof $}function j(B){const N=B;return S.URI.isUri(N?.preferredResource)}function A(B){const N=B;return k(N?.primary)&&k(N?.secondary)}function O(B){const N=B;return k(N?.modified)&&k(N?.original)}function F(B,N,z,J,ue){return X(J,[(0,v.$gj)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const x={...z,limits:{size:Number.MAX_VALUE}};B.openEditor(N,x)}}),(0,v.$gj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>ue.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}function V(B){return k(B?.editor)}function Z(B){const N=B;return V(B)&&N?.group!==void 0}function oe(B){const N=B;return typeof N?.groupId=="number"&&k(N.editor)}var le;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.REPLACE=1]="REPLACE",B[B.MOVE=2]="MOVE",B[B.UNPIN=3]="UNPIN"})(le||(e.EditorCloseContext=le={}));var te;(function(B){B[B.GROUP_ACTIVE=0]="GROUP_ACTIVE",B[B.GROUP_INDEX=1]="GROUP_INDEX",B[B.GROUP_LABEL=2]="GROUP_LABEL",B[B.GROUP_LOCKED=3]="GROUP_LOCKED",B[B.EDITOR_OPEN=4]="EDITOR_OPEN",B[B.EDITOR_CLOSE=5]="EDITOR_CLOSE",B[B.EDITOR_MOVE=6]="EDITOR_MOVE",B[B.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",B[B.EDITOR_LABEL=8]="EDITOR_LABEL",B[B.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",B[B.EDITOR_PIN=10]="EDITOR_PIN",B[B.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",B[B.EDITOR_STICKY=12]="EDITOR_STICKY",B[B.EDITOR_DIRTY=13]="EDITOR_DIRTY",B[B.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(te||(e.GroupModelChangeKind=te={}));var _;(function(B){B[B.PRIMARY=1]="PRIMARY",B[B.SECONDARY=2]="SECONDARY",B[B.BOTH=3]="BOTH",B[B.ANY=4]="ANY"})(_||(e.SideBySideEditor=_={}));class W{getOriginalUri(N,z){if(!N)return;if(s(N))return e.$QF.getOriginalUri(N.result,z);if(z?.supportSideBySide){const{primary:ue,secondary:x}=this.a(N);if(ue&&x){if(z?.supportSideBySide===_.BOTH)return{primary:this.getOriginalUri(ue,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===_.ANY)return this.getOriginalUri(ue,{filterByScheme:z.filterByScheme})??this.getOriginalUri(x,{filterByScheme:z.filterByScheme});N=z.supportSideBySide===_.PRIMARY?ue:x}}if(p(N)||E(N)||h(N)||s(N))return;const J=j(N)?N.preferredResource:N.resource;return!J||!z||!z.filterByScheme?J:this.b(J,z.filterByScheme)}a(N){return A(N)||h(N)?{primary:N.primary,secondary:N.secondary}:O(N)||p(N)?{primary:N.modified,secondary:N.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(N,z){if(!N)return;if(s(N))return e.$QF.getCanonicalUri(N.result,z);if(z?.supportSideBySide){const{primary:ue,secondary:x}=this.a(N);if(ue&&x){if(z?.supportSideBySide===_.BOTH)return{primary:this.getCanonicalUri(ue,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(x,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===_.ANY)return this.getCanonicalUri(ue,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(x,{filterByScheme:z.filterByScheme});N=z.supportSideBySide===_.PRIMARY?ue:x}}if(p(N)||E(N)||h(N)||s(N))return;const J=N.resource;return!J||!z||!z.filterByScheme?J:this.b(J,z.filterByScheme)}b(N,z){if(Array.isArray(z)){if(z.some(J=>N.scheme===J))return N}else if(z===N.scheme)return N}}var K;(function(B){B[B.UNKNOWN=0]="UNKNOWN",B[B.KEYBOARD=1]="KEYBOARD",B[B.MOUSE=2]="MOUSE"})(K||(e.EditorCloseMethod=K={}));function Y(B,N,z,J){if(!B.isSticky(N))return!1;switch(J.preventPinnedEditorClose){case"keyboardAndMouse":return z===K.MOUSE||z===K.KEYBOARD;case"mouse":return z===K.MOUSE;case"keyboard":return z===K.KEYBOARD}return!1}e.$QF=new W;var M;(function(B){B[B.LEFT=0]="LEFT",B[B.RIGHT=1]="RIGHT"})(M||(e.CloseDirection=M={}));class Q{constructor(){this.c=new Map,this.d=new Map}start(N){const z=this.a=N.get(I.$vi);for(const[J,ue]of this.c)this.e(J,ue,z);this.c.clear()}e(N,z,J){const ue=J.createInstance(z);this.d.set(N,ue)}registerFileEditorFactory(N){if(this.b)throw new Error("Can only register one file editor factory.");this.b=N}getFileEditorFactory(){return(0,C.$hg)(this.b)}registerEditorSerializer(N,z){if(this.c.has(N)||this.d.has(N))throw new Error(`A editor serializer with type ID '${N}' was already registered.`);return this.a?this.e(N,z,this.a):this.c.set(N,z),(0,D.$Tc)(()=>{this.c.delete(N),this.d.delete(N)})}getEditorSerializer(N){return this.d.get(typeof N=="string"?N:N.typeId)}}P.$co.add(e.$sF.EditorFactory,new Q);async function ce(B,N,z){return!B||!B.length?[]:await Promise.all(B.map(async J=>{const ue=S.URI.revive(J.fileUri);if(!ue){z.info("Cannot resolve the path because it is not valid.",J);return}if(!await N.canHandleResource(ue)){z.info("Cannot resolve the path because it cannot be handled",J);return}let G=J.exists,U=J.type;if(typeof G!="boolean"||typeof U!="number")try{U=(await N.stat(ue)).isDirectory?b.FileType.Directory:b.FileType.Unknown,G=!0}catch(q){z.error(q),G=!1}if(!G&&J.openOnlyIfExists){z.info("Cannot resolve the path because it does not exist",J);return}if(U===b.FileType.Directory){z.info("Cannot resolve the path because it is a directory",J);return}const T={...J.options,pinned:!0};return G?{resource:ue,options:T}:{resource:ue,options:T,forceUntitled:!0}}))}var ie;(function(B){B[B.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",B[B.SEQUENTIAL=1]="SEQUENTIAL"})(ie||(e.EditorsOrder=ie={}));function be(B){const N=B;if(!N)return!1;const z=N;if(z.modified)return be(z.modified);const J=N;return!!(J.contributionsState&&J.viewState&&Array.isArray(J.cursorState))}function re(B){return(0,y.$ij)(B)}function X(B,N,z){const J=(0,y.$jj)(B,N);return J.forceMessage=z?.forceMessage,J.forceSeverity=z?.forceSeverity,J.allowDialog=z?.allowDialog,J}}),define(ye[282],Ee([1,0,218,47]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=void 0,e.$7F=new C.$Nj("chatSessionResponseVote","",{type:"string",description:(0,o.localize)(0,null)}),e.$8F=new C.$Nj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,o.localize)(1,null)}),e.$9F=new C.$Nj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,o.localize)(2,null)}),e.$0F=new C.$Nj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,o.localize)(3,null)}),e.$$F=new C.$Nj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,o.localize)(4,null)}),e.$_F=new C.$Nj("chatResponse",!1,{type:"boolean",description:(0,o.localize)(5,null)}),e.$aG=new C.$Nj("chatRequest",!1,{type:"boolean",description:(0,o.localize)(6,null)}),e.$bG=new C.$Nj("chatEditApplied",!1,{type:"boolean",description:(0,o.localize)(7,null)}),e.$cG=new C.$Nj("chatInputHasText",!1,{type:"boolean",description:(0,o.localize)(8,null)}),e.$dG=new C.$Nj("chatInputHasFocus",!1,{type:"boolean",description:(0,o.localize)(9,null)}),e.$eG=new C.$Nj("inChatInput",!1,{type:"boolean",description:(0,o.localize)(10,null)}),e.$fG=new C.$Nj("inChat",!1,{type:"boolean",description:(0,o.localize)(11,null)}),e.$gG=new C.$Nj("chatIsEnabled",!1,{type:"boolean",description:(0,o.localize)(12,null)}),e.$hG=new C.$Nj("chatCursorAtTop",!1),e.$iG=new C.$Nj("chatInputHasAgent",!1),e.$jG=new C.$Nj("chatLocation",void 0)}),define(ye[283],Ee([1,0,14,20,6,41,2,155,17,47,5,12,28,42,129,282]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.ChatAgentLocation=void 0;var c;(function(h){h.Panel="panel",h.Terminal="terminal",h.Notebook="notebook",h.Editor="editor"})(c||(e.ChatAgentLocation=c={})),function(h){function t(s){switch(s){case"panel":return h.Panel;case"terminal":return h.Terminal;case"notebook":return h.Notebook;case"editor":return h.Editor}return h.Panel}h.fromRaw=t}(c||(e.ChatAgentLocation=c={})),e.$hH=(0,y.$wi)("chatAgentService");let d=class{static{this.AGENT_LEADER="@"}constructor(t){this.f=t,this.b=[],this.d=new S.$ee,this.onDidChangeAgents=this.d.event,this.e=a.$gG.bindTo(this.f)}registerAgent(t,s){if(this.getAgent(t))throw new Error(`Agent already registered: ${JSON.stringify(t)}`);const i=this,n=s.slashCommands;s={...s,get slashCommands(){return n.filter($=>!$.when||i.f.contextMatchesRules(g.$uj.deserialize($.when)))}};const l={data:s};return this.b.push(l),(0,I.$Tc)(()=>{this.b=this.b.filter($=>$!==l),this.d.fire(void 0)})}registerAgentImplementation(t,s){const r=this.g(t);if(!r)throw new Error(`Unknown agent: ${JSON.stringify(t)}`);if(r.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(t)}`);return r.data.isDefault&&this.e.set(!0),r.impl=s,this.d.fire(new p(r.data,s)),(0,I.$Tc)(()=>{r.impl=void 0,this.d.fire(void 0),r.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(t,s){const r={data:t,impl:s};return this.b.push(r),this.d.fire(new p(t,s)),(0,I.$Tc)(()=>{this.b=this.b.filter(i=>i!==r),this.d.fire(void 0)})}updateAgent(t,s){const r=this.g(t);if(!r?.impl)throw new Error(`No activated agent with id ${JSON.stringify(t)} registered`);r.data.metadata={...r.data.metadata,...s},this.d.fire(new p(r.data,r.impl))}getDefaultAgent(t){return this.getActivatedAgents().find(s=>!!s.isDefault&&s.locations.includes(t))}getContributedDefaultAgent(t){return this.getAgents().find(s=>!!s.isDefault&&s.locations.includes(t))}getSecondaryAgent(){return D.Iterable.find(this.b.values(),t=>!!t.data.metadata.isSecondary)?.data}g(t){return this.b.find(s=>s.data.id===t)}getAgent(t){return this.g(t)?.data}getAgents(){return this.b.map(t=>t.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(t=>!!t.impl).map(t=>new p(t.data,t.impl))}getAgentsByName(t){return this.getAgents().filter(s=>s.name===t)}async invokeAgent(t,s,r,i,n){const l=this.g(t);if(!l?.impl)throw new Error(`No activated agent with id ${t}`);return await l.impl.invoke(s,r,i,n)}async getFollowups(t,s,r,i,n){const l=this.g(t);if(!l?.impl)throw new Error(`No activated agent with id ${t}`);return l.impl?.provideFollowups?l.impl.provideFollowups(s,r,i,n):[]}};e.$iH=d,e.$iH=d=Le([Ne(0,g.$Oj)],d);class p{constructor(t,s){this.b=t,this.d=s}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.extensionPublisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(t,s,r,i){return this.d.invoke(t,s,r,i)}async provideFollowups(t,s,r,i){return this.d.provideFollowups?this.d.provideFollowups(t,s,r,i):[]}provideWelcomeMessage(t,s){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(t,s)}provideSampleQuestions(t,s){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(t,s)}}e.$jH=p,e.$kH=(0,y.$wi)("chatAgentNameService");let E=class{static{f=this}static{this.b="chat.participantNameRegistry"}constructor(t,s,r,i){if(this.g=s,this.h=r,this.i=i,this.e=(0,P.$2d)(this,Object.create(null)),this.f=!1,!t.chatParticipantRegistry)return;this.d=t.chatParticipantRegistry;const n=i.get(f.b,-1);try{this.e.set(JSON.parse(n??"{}"),void 0)}catch{i.remove(f.b,-1)}this.j()}j(){this.f||this.k().catch(t=>this.h.warn("Failed to fetch chat participant registry",t)).then(()=>(0,o.$xh)(5*60*1e3)).then(()=>this.j())}async k(){const t=await this.g.request({type:"GET",url:this.d},C.CancellationToken.None);if(t.res.statusCode!==200)throw new Error("Could not get extensions report.");const s=await(0,m.$Tp)(t);if(!s||s.version!==1)throw new Error("Unexpected chat participant registry response.");const r=s.restrictedChatParticipants;this.e.set(r,void 0),this.i.store(f.b,JSON.stringify(r),-1,1)}getAgentNameRestriction(t){return this.e.map(r=>r[t.name.toLowerCase()]).map(r=>r?r.some(i=>(0,b.$yf)(i,i.includes(".")?t.extensionId.value:t.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$lH=E,e.$lH=E=f=Le([Ne(0,w.$jk),Ne(1,m.$Np),Ne(2,v.$3j),Ne(3,u.$1p)],E)}),define(ye[284],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZP=void 0,e.$ZP=(0,o.$wi)("environmentVariableService")}),define(ye[285],Ee([1,0,7,4,66,3,125,10]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pQ=b,e.$qQ=y,e.$rQ=m,e.$sQ=u,e.$tQ=a,e.$uQ=c,e.$vQ=d,e.$wQ=p,e.$xQ=E;function b(h,t){if(t)if(D.$i)for(const s in t){let r=s;for(const n in h)if(s.toLowerCase()===n.toLowerCase()){r=n;break}const i=t[s];i!==void 0&&g(h,r,i)}else Object.keys(t).forEach(s=>{const r=t[s];r!==void 0&&g(h,s,r)})}function g(h,t,s){typeof s=="string"?h[t]=s:delete h[t]}function y(h,t,s,r){h.TERM_PROGRAM="vscode",t&&(h.TERM_PROGRAM_VERSION=t),m(h,r)&&(h.LANG=u(s)),h.COLORTERM="truecolor"}function v(h,t){if(t)for(const s of Object.keys(t)){const r=t[s];r!=null&&(h[s]=r)}}async function w(h,t){return await Promise.all(Object.entries(t).map(async([s,r])=>{if(typeof r=="string")try{t[s]=await h(r)}catch{t[s]=r}})),t}function m(h,t){if(t==="on")return!0;if(t==="auto"){const s=h.LANG;return!s||s.search(/\.UTF\-8$/)===-1&&s.search(/\.utf8$/)===-1&&s.search(/\.euc.+/)===-1}return!1}function u(h){const t=h?h.split("-"):[],s=t.length;if(s===0)return"en_US.UTF-8";if(s===1){const r={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in r&&t.push(r[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}async function a(h,t,s,r,i,n){if(h.cwd){const $=typeof h.cwd=="object"?h.cwd.fsPath:h.cwd,k=await f($,s);return(0,I.$mQ)(k||$)}let l;return!h.ignoreConfigurationCwd&&i&&(s&&(i=await f(i,s,n)),i&&(o.$jc(i)?l=i:r&&(l=o.$kc(r.fsPath,i)))),l||(l=r?r.fsPath:t||""),(0,I.$mQ)(l)}async function f(h,t,s){if(t)try{return await t(h)}catch(r){s?.error("Could not resolve terminal cwd",r);return}return h}function c(h,t,s){if(s)return r=>s.resolveWithEnvironment(t,h,r)}async function d(h,t,s,r,i,n){const l={};if(h.strictEnv)v(l,h.env);else{v(l,n);const $={...t};s&&($&&await w(s,$),h.env&&await w(s,h.env)),D.$j&&(l.VSCODE_NODE_OPTIONS&&(l.NODE_OPTIONS=l.VSCODE_NODE_OPTIONS,delete l.VSCODE_NODE_OPTIONS),l.VSCODE_NODE_REPL_EXTERNAL_MODULE&&(l.NODE_REPL_EXTERNAL_MODULE=l.VSCODE_NODE_REPL_EXTERNAL_MODULE,delete l.VSCODE_NODE_REPL_EXTERNAL_MODULE)),(0,S.$mm)(l,"VSCODE_IPC_HOOK_CLI"),b(l,$),b(l,h.env),y(l,r,D.$w,i)}return l}async function p(h,t,s,r,i,n,l=D.$i){let $;if((0,P.$9f)(h)?$=h:($=h.fsPath,l&&n!==1?$=$.replace(/\\/g,"/"):!l&&n===1&&($=$.replace(/\//g,"\\"))),!t)return $;const k=$.includes(" "),j=$.includes("(")||$.includes(")"),A=o.$oc(t,".exe"),O=A==="pwsh"||s==="pwsh"||A==="powershell"||s==="powershell";if(O&&(k||$.includes("'")))return`& '${$.replace(/'/g,"''")}'`;if(j&&O)return`& '${$}'`;if(n===1){if(r!==void 0)return r==="gitbash"?(0,I.$kQ)($.replace(/\\/g,"/")):r==="wsl"?i?.getWslPath($,"win-to-unix")||$:k?`"${$}"`:$;const F=t.toLowerCase();return F.includes("wsl")||F.includes("bash.exe")&&!F.toLowerCase().includes("git")?i?.getWslPath($,"win-to-unix")||$:k?`"${$}"`:$}return(0,I.$kQ)($)}function E(h,t,s){const r=typeof h=="string"?C.URI.parse(h):h;let i=r?t.getWorkspaceFolder(r)??void 0:void 0;if(!i){const n=s.getLastActiveWorkspaceRoot();i=n?t.getWorkspaceFolder(n)??void 0:void 0}return i}}),define(ye[72],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(D){D.Delimiter="\0"})(o||(e.TestIdPathParts=o={}));var C;(function(D){D[D.IsSame=0]="IsSame",D[D.Disconnected=1]="Disconnected",D[D.IsChild=2]="IsChild",D[D.IsParent=3]="IsParent"})(C||(e.TestPosition=C={}));class S{static fromExtHostTestItem(I,P,b=I.parent){if(I._isRoot)return new S([P]);const g=[I.id];for(let y=b;y&&y.id!==P;y=y.parent)g.push(y.id);return g.push(P),new S(g.reverse())}static isRoot(I){return!I.includes("\0")}static root(I){const P=I.indexOf("\0");return P===-1?I:I.slice(0,P)}static fromString(I){return new S(I.split("\0"))}static join(I,P){return new S([...I.path,P])}static joinToString(I,P){return I.toString()+"\0"+P}static parentId(I){const P=I.lastIndexOf("\0");return P===-1?void 0:I.slice(0,P)}static localId(I){const P=I.lastIndexOf("\0");return P===-1?I:I.slice(P+1)}static isChild(I,P){return P.startsWith(I)&&P[I.length]==="\0"}static compare(I,P){return I===P?0:S.isChild(I,P)?2:S.isChild(P,I)?3:1}constructor(I,P=I.length){if(this.path=I,this.d=P,I.length===0||P<1)throw new Error("cannot create test with empty path")}get rootId(){return new S(this.path,1)}get parentId(){return this.d>1?new S(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let I=1;I<=this.d;I++)yield new S(this.path,I)}*idsToRoot(){for(let I=this.d;I>0;I--)yield new S(this.path,I)}compare(I){if(typeof I=="string")return S.compare(this.toString(),I);for(let P=0;P<I.d&&P<this.d;P++)if(I.path[P]!==this.path[P])return 1;return I.d>this.d?2:I.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let I=1;I<this.d;I++)this.c+="\0",this.c+=this.path[I]}return this.c}}e.$UL=S}),define(ye[95],Ee([1,0,4,79,45,72]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4L=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$3L=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$2L=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$1L=e.$ZL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$YL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$XL=e.$WL=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$VL=e.TestResultState=void 0;var I;(function(te){te[te.Unset=0]="Unset",te[te.Queued=1]="Queued",te[te.Running=2]="Running",te[te.Passed=3]="Passed",te[te.Failed=4]="Failed",te[te.Skipped=5]="Skipped",te[te.Errored=6]="Errored"})(I||(e.TestResultState=I={})),e.$VL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var P;(function(te){te[te.Run=1]="Run",te[te.Debug=2]="Debug",te[te.Coverage=3]="Coverage"})(P||(e.ExtTestRunProfileKind=P={}));var b;(function(te){te[te.Run=2]="Run",te[te.Debug=4]="Debug",te[te.Coverage=8]="Coverage",te[te.HasNonDefaultProfile=16]="HasNonDefaultProfile",te[te.HasConfigurable=32]="HasConfigurable",te[te.SupportsContinuousRun=64]="SupportsContinuousRun"})(b||(e.TestRunProfileBitset=b={})),e.$WL=[2,4,8,16,32,64];const g=te=>"runId"in te;e.$XL=g;var y;(function(te){te.serialize=_=>({range:_.range.toJSON(),uri:_.uri.toJSON()}),te.deserialize=(_,W)=>({range:S.$ut.lift(W.range),uri:_.asCanonicalUri(o.URI.revive(W.uri))})})(y||(e.IRichLocation=y={}));var v;(function(te){te[te.Error=0]="Error",te[te.Output=1]="Output"})(v||(e.TestMessageType=v={}));var w;(function(te){te.serialize=_=>({message:_.message,type:0,expected:_.expected,actual:_.actual,contextValue:_.contextValue,location:_.location&&y.serialize(_.location)}),te.deserialize=(_,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&y.deserialize(_,W.location)})})(w||(e.ITestErrorMessage=w={}));const m=(te,_)=>`${_?"s":"e"}${te}`;e.$YL=m;var u;(function(te){te.serialize=_=>({message:_.message,type:1,offset:_.offset,length:_.length,location:_.location&&y.serialize(_.location)}),te.deserialize=(_,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&y.deserialize(_,W.location)})})(u||(e.ITestOutputMessage=u={}));var a;(function(te){te.serialize=_=>_.type===0?w.serialize(_):u.serialize(_),te.deserialize=(_,W)=>W.type===0?w.deserialize(_,W):u.deserialize(_,W)})(a||(e.ITestMessage=a={}));var f;(function(te){te.serializeWithoutMessages=_=>({state:_.state,duration:_.duration,messages:[]}),te.serialize=_=>({state:_.state,duration:_.duration,messages:_.messages.map(a.serialize)}),te.deserialize=(_,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(K=>a.deserialize(_,K))})})(f||(e.ITestTaskState=f={}));const c="\0",d=(te,_)=>te+c+_;e.$ZL=d;const p=te=>{const _=te.indexOf(c);return{ctrlId:te.slice(0,_),tagId:te.slice(_+1)}};e.$1L=p;var E;(function(te){te.serialize=_=>({extId:_.extId,label:_.label,tags:_.tags,busy:_.busy,children:void 0,uri:_.uri?.toJSON(),range:_.range?.toJSON()||null,description:_.description,error:_.error,sortText:_.sortText}),te.deserialize=(_,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?_.asCanonicalUri(o.URI.revive(W.uri)):void 0,range:W.range?S.$ut.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(E||(e.ITestItem=E={}));var h;(function(te){te[te.NotExpandable=0]="NotExpandable",te[te.Expandable=1]="Expandable",te[te.BusyExpanding=2]="BusyExpanding",te[te.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var t;(function(te){te.serialize=_=>({expand:_.expand,item:E.serialize(_.item)}),te.deserialize=(_,W)=>({controllerId:D.$UL.root(W.item.extId),expand:W.expand,item:E.deserialize(_,W.item)})})(t||(e.InternalTestItem=t={}));var s;(function(te){te.serialize=_=>{let W;return _.item&&(W={},_.item.label!==void 0&&(W.label=_.item.label),_.item.tags!==void 0&&(W.tags=_.item.tags),_.item.busy!==void 0&&(W.busy=_.item.busy),_.item.uri!==void 0&&(W.uri=_.item.uri?.toJSON()),_.item.range!==void 0&&(W.range=_.item.range?.toJSON()),_.item.description!==void 0&&(W.description=_.item.description),_.item.error!==void 0&&(W.error=_.item.error),_.item.sortText!==void 0&&(W.sortText=_.item.sortText)),{extId:_.extId,expand:_.expand,item:W}},te.deserialize=_=>{let W;return _.item&&(W={},_.item.label!==void 0&&(W.label=_.item.label),_.item.tags!==void 0&&(W.tags=_.item.tags),_.item.busy!==void 0&&(W.busy=_.item.busy),_.item.range!==void 0&&(W.range=_.item.range?S.$ut.lift(_.item.range):null),_.item.description!==void 0&&(W.description=_.item.description),_.item.error!==void 0&&(W.error=_.item.error),_.item.sortText!==void 0&&(W.sortText=_.item.sortText)),{extId:_.extId,expand:_.expand,item:W}}})(s||(e.ITestItemUpdate=s={}));const r=(te,_)=>{_.expand!==void 0&&(te.expand=_.expand),_.item!==void 0&&(te.item=te.item?Object.assign(te.item,_.item):_.item)};e.$2L=r;var i;(function(te){te.serializeWithoutMessages=_=>({...t.serialize(_),ownComputedState:_.ownComputedState,computedState:_.computedState,tasks:_.tasks.map(f.serializeWithoutMessages)}),te.serialize=_=>({...t.serialize(_),ownComputedState:_.ownComputedState,computedState:_.computedState,tasks:_.tasks.map(f.serialize)}),te.deserialize=(_,W)=>({...t.deserialize(_,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(K=>f.deserialize(_,K)),retired:!0})})(i||(e.TestResultItem=i={}));var n;(function(te){te.empty=()=>({covered:0,total:0}),te.sum=(_,W)=>{_.covered+=W.covered,_.total+=W.total}})(n||(e.ICoverageCount=n={}));var l;(function(te){te.serialize=_=>({id:_.id,statement:_.statement,branch:_.branch,declaration:_.declaration,uri:_.uri.toJSON()}),te.deserialize=(_,W)=>({id:W.id,statement:W.statement,branch:W.branch,declaration:W.declaration,uri:_.asCanonicalUri(o.URI.revive(W.uri))})})(l||(e.IFileCoverage=l={}));function $(te){return{...te,location:te.location?.toJSON()}}function k(te){return te.location=te.location?C.$tt.isIPosition(te.location)?C.$tt.lift(te.location):S.$ut.lift(te.location):void 0,te}e.$3L=3;var j;(function(te){te[te.Declaration=0]="Declaration",te[te.Statement=1]="Statement",te[te.Branch=2]="Branch"})(j||(e.DetailType=j={}));var A;(function(te){te.serialize=_=>_.type===0?F.serialize(_):V.serialize(_),te.deserialize=_=>_.type===0?F.deserialize(_):V.deserialize(_)})(A||(e.CoverageDetails=A={}));var O;(function(te){te.serialize=$,te.deserialize=k})(O||(e.IBranchCoverage=O={}));var F;(function(te){te.serialize=$,te.deserialize=k})(F||(e.IDeclarationCoverage=F={}));var V;(function(te){te.serialize=_=>({...$(_),branches:_.branches?.map(O.serialize)}),te.deserialize=_=>({...k(_),branches:_.branches?.map(O.deserialize)})})(V||(e.IStatementCoverage=V={}));var Z;(function(te){te[te.Add=0]="Add",te[te.Update=1]="Update",te[te.DocumentSynced=2]="DocumentSynced",te[te.Remove=3]="Remove",te[te.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",te[te.Retire=5]="Retire",te[te.AddTag=6]="AddTag",te[te.RemoveTag=7]="RemoveTag"})(Z||(e.TestDiffOpType=Z={}));var oe;(function(te){te.deserialize=(_,W)=>W.op===0?{op:W.op,item:t.deserialize(_,W.item)}:W.op===1?{op:W.op,item:s.deserialize(W.item)}:W.op===2?{op:W.op,uri:_.asCanonicalUri(o.URI.revive(W.uri)),docv:W.docv}:W,te.serialize=_=>_.op===0?{op:_.op,item:t.serialize(_.item)}:_.op===1?{op:_.op,item:s.serialize(_.item)}:_})(oe||(e.TestsDiffOp=oe={}));class le{constructor(_){this.k=_,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(_){const W=this.v();for(const K of _)switch(K.op){case 0:this.l(t.deserialize(this.k,K.item),W);break;case 1:this.o(s.deserialize(K.item),W);break;case 3:this.p(K.itemId,W);break;case 5:this.q(K.itemId);break;case 4:this.updatePendingRoots(K.amount);break;case 6:this.c.set(K.tag.id,K.tag);break;case 7:this.c.delete(K.id);break}W.complete?.()}l(_,W){const K=D.$UL.parentId(_.item.extId)?.toString();let Y;if(!K)Y=this.w(_),this.g.add(Y),this.f.set(_.item.extId,Y);else if(this.f.has(K)){const M=this.f.get(K);M.children.add(_.item.extId),Y=this.w(_,M),this.f.set(_.item.extId,Y)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(_)}`);return}return W.add?.(Y),_.expand===2&&this.h++,Y}o(_,W){const K=this.f.get(_.extId);if(K)return _.expand!==void 0&&(K.expand===2&&this.h--,_.expand===2&&this.h++),(0,e.$2L)(K,_),W.update?.(K),K}p(_,W){const K=this.f.get(_);if(!K)return;const Y=D.$UL.parentId(K.item.extId)?.toString();Y?this.f.get(Y).children.delete(K.item.extId):this.g.delete(K);const M=[[_]];for(;M.length;)for(const Q of M.pop()){const ce=this.f.get(Q);ce&&(M.push(ce.children),this.f.delete(Q),W.remove?.(ce,ce!==K),ce.expand===2&&this.h--)}}q(_){}updatePendingRoots(_){this.j+=_}v(){return{}}}e.$4L=le}),define(ye[135],Ee([1,0,14,6,2,97,95,72]),function(he,e,o,C,S,D,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qP=e.$pP=e.$oP=e.$nP=e.$mP=e.TestItemEventOp=void 0;var b;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(b||(e.TestItemEventOp=b={}));const g=(d,p)=>d===p,v=Object.entries({range:(d,p)=>d===p?!0:!d||!p?!1:d.equalsRange(p),busy:g,label:g,description:g,error:g,sortText:g,tags:(d,p)=>!(d.length!==p.length||d.some(E=>!p.includes(E)))}),w=(d,p)=>{let E;for(const[h,t]of v)t(d[h],p[h])||(E?E[h]=p[h]:E={[h]:p[h]});return E};class m extends S.$Vc{get root(){return this.s.root}constructor(p){super(),this.s=p,this.f=this.B(new o.$Ih(()=>this.flushDiff(),200)),this.g=this.B(new C.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(p){this.h=p;for(const E of this.tree.values())this.J(E)}get resolveHandler(){return this.h}collectDiff(){const p=this.m;return this.m=[],p}pushDiff(p){switch(p.op){case 2:{for(const E of this.m)if(E.op===2&&E.uri===p.uri){E.docv=p.docv;return}break}case 1:{const E=this.m[this.m.length-1];if(E){if(E.op===1&&E.item.extId===p.item.extId){(0,I.$2L)(E.item,p.item);return}if(E.op===0&&E.item.item.extId===p.item.extId){(0,I.$2L)(E.item,p.item);return}}break}}this.m.push(p),this.f.isScheduled()||this.f.schedule()}expand(p,E){const h=this.tree.get(p);if(h){if((h.expandLevels===void 0||E>h.expandLevels)&&(h.expandLevels=E),h.expand===1){const t=this.M(h);return t.isOpen()?this.L(h,E-1):t.wait().then(()=>this.L(h,E-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,E-1)):this.L(h,E-1)}}dispose(){for(const p of this.tree.values())this.s.getApiFor(p.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(p,E){switch(E.op){case 3:this.O(P.$UL.joinToString(p.fullId,E.id));break;case 0:this.z(E.item,p);break;case 5:for(const h of E.ops)this.w(p,h);break;case 1:this.C(E.new,E.old,p.fullId.toString());break;case 2:this.J(p);break;case 4:this.pushDiff({op:1,item:{extId:p.fullId.toString(),item:E.update}});break;case 6:this.y(p.actual.uri);break;default:(0,D.$fd)(E)}}y(p){p&&this.pushDiff({op:2,uri:p,docv:this.s.getDocumentVersion(p)})}z(p,E){const h=P.$UL.fromExtHostTestItem(p,this.root.id,E?.actual),t=this.s.getApiFor(p);t.parent&&t.parent!==E?.actual&&this.s.getChildren(t.parent).delete(p.id);let s=this.tree.get(h.toString());if(!s){s={fullId:h,actual:p,expandLevels:E?.expandLevels?E.expandLevels-1:void 0,expand:0},p.tags.forEach(this.D,this),this.tree.set(s.fullId.toString(),s),this.G(p,E),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:s.expand,item:this.s.toITestItem(p)}}),this.I(p,s,E);return}if(s.actual===p){this.H(p,s,E);return}if(s.actual.uri?.toString()!==p.uri?.toString())return this.O(h.toString()),this.z(p,E);const r=this.s.getChildren(s.actual),i=s.actual,n=w(this.s.toITestItem(i),this.s.toITestItem(p));this.s.getApiFor(i).listener=void 0,s.actual=p,s.resolveBarrier=void 0,s.expand=0,n&&(n.hasOwnProperty("tags")&&(this.C(p.tags,i.tags,h.toString()),delete n.tags),this.w(s,{op:4,update:n})),this.I(p,s,E);for(const[$,k]of r)this.s.getChildren(p).get(k.id)||this.O(P.$UL.joinToString(h,k.id));const l=s.expandLevels;l!==void 0&&queueMicrotask(()=>{s.expand===1&&(s.expandLevels=void 0,this.expand(h.toString(),l))}),this.y(s.actual.uri)}C(p,E,h){const t=new Set(E.map(s=>s.id));for(const s of p)t.delete(s.id)||this.D(s);this.pushDiff({op:1,item:{extId:h,item:{tags:p.map(s=>(0,I.$ZL)(this.s.controllerId,s.id))}}}),t.forEach(this.F,this)}D(p){const E=this.j.get(p.id);E?E.refCount++:(this.j.set(p.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,I.$ZL)(this.s.controllerId,p.id)}}))}F(p){const E=this.j.get(p);E&&!--E.refCount&&(this.j.delete(p),this.pushDiff({op:7,id:(0,I.$ZL)(this.s.controllerId,p)}))}G(p,E){this.s.getApiFor(p).parent=E&&E.actual!==this.root?E.actual:void 0}H(p,E,h){this.G(p,h);const t=this.s.getApiFor(p);t.parent=h?.actual,t.listener=s=>this.w(E,s),this.J(E)}I(p,E,h){this.H(p,E,h);for(const[t,s]of this.s.getChildren(p))this.z(s,E)}J(p){let E;this.h?p.resolveBarrier?E=p.resolveBarrier.isOpen()?3:2:E=p.actual.canResolveChildren?1:0:E=0,E!==p.expand&&(p.expand=E,this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:E}}),E===1&&p.expandLevels!==void 0&&this.M(p))}L(p,E){if(E<0)return;const h=[];for(const[t,s]of this.s.getChildren(p.actual)){const r=this.expand(P.$UL.joinToString(p.fullId,s.id),E);(0,o.$ih)(r)&&h.push(r)}if(h.length)return Promise.all(h).then(()=>{})}M(p){if(p.resolveBarrier)return p.resolveBarrier;if(!this.h){const s=new o.$vh;return s.open(),s}p.expand=2,this.N(p);const E=p.resolveBarrier=new o.$vh,h=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,s)};let t;try{t=this.h(p.actual===this.root?void 0:p.actual)}catch(s){h(s)}return(0,o.$ih)(t)?t.catch(h).then(()=>{E.open(),this.J(p)}):(E.open(),this.J(p)),p.resolveBarrier}N(p){this.pushDiff({op:1,item:{extId:p.fullId.toString(),expand:p.expand}})}O(p){const E=this.tree.get(p);if(!E)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:p});const h=[E];for(;h.length;){const t=h.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.F(s.id);this.tree.delete(t.fullId.toString());for(const[s,r]of this.s.getChildren(t.actual))h.push(this.tree.get(P.$UL.joinToString(t.fullId,r.id)))}}}flushDiff(){const p=this.collectDiff();p.length&&this.g.fire(p)}}e.$mP=m;class u extends Error{constructor(p){super(`Attempted to insert a duplicate test item ID ${p}`)}}e.$nP=u;class a extends Error{constructor(p){super(`TestItem with ID "${p}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$oP=a;class f extends Error{constructor(p,E,h){super(`TestItem with ID "${p}" is from controller "${E}" and cannot be added as a child of an item from controller "${h}".`)}}e.$pP=f;const c=(d,p,E)=>{let h=new Map;return{get size(){return h.size},forEach(t,s){for(const r of h.values())t.call(s,r,this)},[Symbol.iterator](){return h.entries()},replace(t){const s=new Map,r=new Set(h.keys()),i={op:5,ops:[]};for(const n of t){if(!(n instanceof E))throw new a(n.id);const l=p(n).controllerId;if(l!==d.controllerId)throw new f(n.id,l,d.controllerId);if(s.has(n.id))throw new u(n.id);s.set(n.id,n),r.delete(n.id),i.ops.push({op:0,item:n})}for(const n of r.keys())i.ops.push({op:3,id:n});d.listener?.(i),h=s},add(t){if(!(t instanceof E))throw new a(t.id);h.set(t.id,t),d.listener?.({op:0,item:t})},delete(t){h.delete(t)&&d.listener?.({op:3,id:t})},get(t){return h.get(t)},toJSON(){return Array.from(h.values())}}};e.$qP=c}),define(ye[136],Ee([1,0,135]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sP=e.$rP=void 0;const C=new WeakMap,S=(I,P)=>{const b={controllerId:P};return C.set(I,b),b};e.$rP=S;const D=I=>{const P=C.get(I);if(!P)throw new o.$oP(I?.id||"<unknown>");return P};e.$sP=D}),define(ye[286],Ee([1,0,25,5]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.$$E=e.$0E=e.$9E=e.$8E=e.$7E=e.$6E=e.$5E=e.$4E=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=void 0,e.$OE=".vscode",e.$PE="settings",e.$QE=`${e.$OE}/${e.$PE}.json`,e.$RE="vscode://schemas/settings/default",e.$SE="vscode://schemas/settings/user",e.$TE="vscode://schemas/settings/profile",e.$UE="vscode://schemas/settings/machine",e.$VE="vscode://schemas/settings/workspace",e.$WE="vscode://schemas/settings/folder",e.$XE="vscode://schemas/launch",e.$YE="vscode://schemas/tasks",e.$ZE=[1],e.$1E=[2,3,4,5,6],e.$2E=[3,4,5],e.$3E=[1,...e.$2E],e.$4E=[2,3,4,5,6],e.$5E=[3,4,5,6],e.$6E=[4,5,6],e.$7E="tasks",e.$8E="launch",e.$9E=Object.create(null),e.$9E[e.$7E]=`${e.$OE}/${e.$7E}.json`,e.$9E[e.$8E]=`${e.$OE}/${e.$8E}.json`,e.$0E=Object.create(null),e.$0E[e.$7E]=`${e.$7E}.json`,e.$$E=(0,C.$xi)(o.$3i),e.$_E=`{
	"version": "2.0.0",
	"tasks": []
}`,e.$aF="workbench.settings.applyToAllProfiles"}),define(ye[137],Ee([1,0,5]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jQ=e.VariableKind=e.$iQ=void 0,e.$iQ=(0,o.$wi)("configurationResolverService");var C;(function(D){D.Unknown="unknown",D.Env="env",D.Config="config",D.Command="command",D.Input="input",D.ExtensionInstallFolder="extensionInstallFolder",D.WorkspaceFolder="workspaceFolder",D.Cwd="cwd",D.WorkspaceFolderBasename="workspaceFolderBasename",D.UserHome="userHome",D.LineNumber="lineNumber",D.SelectedText="selectedText",D.File="file",D.FileWorkspaceFolder="fileWorkspaceFolder",D.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",D.RelativeFile="relativeFile",D.RelativeFileDirname="relativeFileDirname",D.FileDirname="fileDirname",D.FileExtname="fileExtname",D.FileBasename="fileBasename",D.FileBasenameNoExtension="fileBasenameNoExtension",D.FileDirnameBasename="fileDirnameBasename",D.ExecPath="execPath",D.ExecInstallFolder="execInstallFolder",D.PathSeparator="pathSeparator",D.PathSeparatorAlias="/"})(C||(e.VariableKind=C={}));class S extends Error{constructor(I,P){super(P),this.variable=I}}e.$jQ=S}),define(ye[287],Ee([1,0,7,31,10,21,3,179,219,137,17]),function(he,e,o,C,S,D,I,P,b,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0;class v{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(m,u,a,f){this.h=new Map,this.a=m,this.b=u,this.g=a,f&&(this.c=f.then(c=>this.i(c)))}i(m){if(I.$i){const u=Object.create(null);return Object.keys(m).forEach(a=>{u[a.toLowerCase()]=m[a]}),u}return m}resolveWithEnvironment(m,u,a){return this.l({env:this.i(m),userHome:void 0},u?u.uri:void 0,a)}async resolveAsync(m,u){const a={env:await this.c,userHome:await this.g};return this.l(a,m?m.uri:void 0,u)}async j(m,u,a,f){const c=D.$3n(u);I.$i&&c.windows?Object.keys(c.windows).forEach(p=>c[p]=c.windows[p]):I.$j&&c.osx?Object.keys(c.osx).forEach(p=>c[p]=c.osx[p]):I.$k&&c.linux&&Object.keys(c.linux).forEach(p=>c[p]=c.linux[p]),delete c.windows,delete c.osx,delete c.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,m?m.uri:void 0,c,a,f)}async resolveAnyAsync(m,u,a){return this.j(m,u,a)}async resolveAnyMap(m,u,a){const f=new Map;return{newConfig:await this.j(m,u,a,f),resolvedVariables:f}}resolveWithInteractionReplace(m,u,a,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,u,a,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,u){if(this.h.has(m))throw new Error("Variable "+m+" is contributed twice.");this.h.set(m,u)}async l(m,u,a,f,c){if(S.$9f(a))return this.m(m,u,a,f,c);if(Array.isArray(a))return Promise.all(a.map(d=>this.l(m,u,d,f,c)));if(S.$$f(a)){const d=Object.create(null),p=await Promise.all(Object.keys(a).map(async E=>[await this.m(m,u,E,f,c),await this.l(m,u,a[E],f,c)]));for(const[E,h]of p)d[E]=h;return d}return a}m(m,u,a,f,c){return(0,y.$qf)(a,v.VARIABLE_REGEXP,async(d,p)=>{if(p.includes(v.VARIABLE_LHS))return d;let E=await this.o(m,d,p,u,f);return c?.set(p,E),E!==d&&S.$9f(E)&&E.match(v.VARIABLE_REGEXP)&&(E=await this.m(m,u,E,f,c)),E})}n(m){return this.b?this.b.getUriLabel(m,{noPrefix:!0}):m.fsPath}async o(m,u,a,f,c){let d;const p=a.split(":");p.length>1&&(a=p[0],d=p[1]);const E=s=>{const r=this.a.getFilePath();if(r)return(0,P.$Ew)(r);throw new g.$jQ(s,(0,b.localize)(0,null,u))},h=s=>{const r=E(s);if(this.a.getWorkspaceFolderPathForFile){const i=this.a.getWorkspaceFolderPathForFile();if(i)return(0,P.$Ew)(i)}throw new g.$jQ(s,(0,b.localize)(1,null,u,o.$oc(r)))},t=s=>{if(d){const r=this.a.getFolderUri(d);if(r)return r;throw new g.$jQ(s,(0,b.localize)(2,null,u,d))}if(f)return f;throw this.a.getWorkspaceFolderCount()>1?new g.$jQ(s,(0,b.localize)(3,null,u)):new g.$jQ(s,(0,b.localize)(4,null,u))};switch(a){case"env":if(d){if(m.env){const s=m.env[I.$i?d.toLowerCase():d];if(S.$9f(s))return s}return""}throw new g.$jQ(g.VariableKind.Env,(0,b.localize)(5,null,u));case"config":if(d){const s=this.a.getConfigurationValue(f,d);if(S.$fg(s))throw new g.$jQ(g.VariableKind.Config,(0,b.localize)(6,null,u,d));if(S.$$f(s))throw new g.$jQ(g.VariableKind.Config,(0,b.localize)(7,null,u,d));return s}throw new g.$jQ(g.VariableKind.Config,(0,b.localize)(8,null,u));case"command":return this.p(g.VariableKind.Command,u,d,c,"command");case"input":return this.p(g.VariableKind.Input,u,d,c,"input");case"extensionInstallFolder":if(d){const s=await this.a.getExtension(d);if(!s)throw new g.$jQ(g.VariableKind.ExtensionInstallFolder,(0,b.localize)(9,null,u,d));return this.n(s.extensionLocation)}throw new g.$jQ(g.VariableKind.ExtensionInstallFolder,(0,b.localize)(10,null,u));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,P.$Ew)(this.n(t(g.VariableKind.WorkspaceFolder)));case"cwd":return f||d?(0,P.$Ew)(this.n(t(g.VariableKind.Cwd))):C.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.$Ew)(o.$oc(this.n(t(g.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(m.userHome)return m.userHome;throw new g.$jQ(g.VariableKind.UserHome,(0,b.localize)(11,null,u))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new g.$jQ(g.VariableKind.LineNumber,(0,b.localize)(12,null,u))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new g.$jQ(g.VariableKind.SelectedText,(0,b.localize)(13,null,u))}case"file":return E(g.VariableKind.File);case"fileWorkspaceFolder":return h(g.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return o.$oc(h(g.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return f||d?o.$mc(this.n(t(g.VariableKind.RelativeFile)),E(g.VariableKind.RelativeFile)):E(g.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.$nc(E(g.VariableKind.RelativeFileDirname));if(f||d){const r=o.$mc(this.n(t(g.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return o.$nc(E(g.VariableKind.FileDirname));case"fileExtname":return o.$pc(E(g.VariableKind.FileExtname));case"fileBasename":return o.$oc(E(g.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.$oc(E(g.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.$pc(s).length)}case"fileDirnameBasename":return o.$oc(o.$nc(E(g.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||u}case"execInstallFolder":{const s=this.a.getAppRoot();return s||u}case"pathSeparator":case"/":return o.sep;default:try{const s=d?`${a}:${d}`:a;return this.p(g.VariableKind.Unknown,u,s,c,void 0)}catch{return u}}}}p(m,u,a,f,c){if(a&&f){const d=c===void 0?f[a]:f[c+":"+a];if(typeof d=="string")return d;throw new g.$jQ(m,(0,b.localize)(14,null,u))}return u}}e.$yQ=v}),define(ye[288],Ee([1,0,5,94]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$XD=void 0,e.$YD=g,e.$ZD=w,e.$1D=m,e.$XD=(0,o.$wi)("editorGroupsService");var S;(function(u){u[u.UP=0]="UP",u[u.DOWN=1]="DOWN",u[u.LEFT=2]="LEFT",u[u.RIGHT=3]="RIGHT"})(S||(e.GroupDirection=S={}));var D;(function(u){u[u.HORIZONTAL=0]="HORIZONTAL",u[u.VERTICAL=1]="VERTICAL"})(D||(e.GroupOrientation=D={}));var I;(function(u){u[u.FIRST=0]="FIRST",u[u.LAST=1]="LAST",u[u.NEXT=2]="NEXT",u[u.PREVIOUS=3]="PREVIOUS"})(I||(e.GroupLocation=I={}));var P;(function(u){u[u.MAXIMIZE=0]="MAXIMIZE",u[u.EXPAND=1]="EXPAND",u[u.EVEN=2]="EVEN"})(P||(e.GroupsArrangement=P={}));var b;(function(u){u[u.COPY_EDITORS=0]="COPY_EDITORS",u[u.MOVE_EDITORS=1]="MOVE_EDITORS"})(b||(e.MergeGroupMode=b={}));function g(u){const a=u;return(0,C.$IF)(a?.editor)&&(0,C.$IF)(a?.replacement)}var y;(function(u){u[u.CREATION_TIME=0]="CREATION_TIME",u[u.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",u[u.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(y||(e.GroupsOrder=y={}));var v;(function(u){u[u.NEW_EDITOR=1]="NEW_EDITOR",u[u.MOVE_EDITOR=2]="MOVE_EDITOR",u[u.COPY_EDITOR=3]="COPY_EDITOR"})(v||(e.OpenEditorContext=v={}));function w(u){const a=u;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}function m(u){return u.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(ye[138],Ee([1,0,5,288]),function(he,e,o,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5D=e.$4D=e.$3D=e.$2D=void 0,e.$6D=S,e.$2D=(0,o.$wi)("editorService"),e.$3D=-1,e.$4D=-2,e.$5D=-3;function S(D){const I=D;return typeof D=="number"||(0,C.$ZD)(I)}}),define(ye[289],Ee([1,0,286,119,93,91,137,94,138,13,239,284,92]),function(he,e,o,C,S,D,I,P,b,g,y,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=e.$AQ=void 0,e.$AQ="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(a,f,c,d,p,E,h,t,s,r){this.a=a,this.b=f,this.c=c,this.d=d,this.e=p,this.f=E,this.g=h,this.h=t,this.i=s,this.j=r}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(a,f,c,d,p,E,h,t){await this.c.whenRemoteConfigurationLoaded();const s=Object.create(null),r=c?this.d.getWorkspaceFolder(c)??void 0:void 0;let i;try{i=(await this.e.resolveAnyMap(r,{shellLaunchConfig:a,configuration:f})).resolvedVariables}catch(V){this.h.error(V)}if(i)for(const[V,Z]of i.entries())(/^config:/.test(V)||V==="selectedText"||V==="lineNumber")&&(s[V]=Z);const n=[];for(const[V,Z]of this.f.collections.entries())n.push([V,(0,D.$ls)(Z.map),(0,D.$ms)(Z.descriptionMap)]);const l=await this.g.resolveAuthority(this.a),$=l.options&&l.options.extensionHostEnv,k=this.d.getWorkspace(),j=k.folders,A=c?this.d.getWorkspaceFolder(c):null,O=P.$QF.getOriginalUri(this.i.activeEditor,{supportSideBySide:P.SideBySideEditor.PRIMARY,filterByScheme:[g.Schemas.file,g.Schemas.vscodeUserData,g.Schemas.vscodeRemote]}),F={configuration:f,resolvedVariables:s,envVariableCollections:n,shellLaunchConfig:a,workspaceId:k.id,workspaceName:this.j.getWorkspaceLabel(k),workspaceFolders:j,activeWorkspaceFolder:A,activeFileResource:O,shouldPersistTerminal:p,options:d,cols:E,rows:h,unicodeVersion:t,resolverEnv:$};return await this.b.call("$createProcess",F)}requestDetachInstance(a,f){return this.b.call("$requestDetachInstance",[a,f])}acceptDetachInstanceReply(a,f){return this.b.call("$acceptDetachInstanceReply",[a,f])}attachToProcess(a){return this.b.call("$attachToProcess",[a])}detachFromProcess(a,f){return this.b.call("$detachFromProcess",[a,f])}listProcesses(){return this.b.call("$listProcesses")}getLatency(){return this.b.call("$getLatency")}getPerformanceMarks(){return this.b.call("$getPerformanceMarks")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(a,f){return this.b.call("$processBinary",[a,f])}start(a){return this.b.call("$start",[a])}input(a,f){return this.b.call("$input",[a,f])}acknowledgeDataEvent(a,f){return this.b.call("$acknowledgeDataEvent",[a,f])}setUnicodeVersion(a,f){return this.b.call("$setUnicodeVersion",[a,f])}shutdown(a,f){return this.b.call("$shutdown",[a,f])}resize(a,f,c){return this.b.call("$resize",[a,f,c])}clearBuffer(a){return this.b.call("$clearBuffer",[a])}getInitialCwd(a){return this.b.call("$getInitialCwd",[a])}getCwd(a){return this.b.call("$getCwd",[a])}orphanQuestionReply(a){return this.b.call("$orphanQuestionReply",[a])}sendCommandResult(a,f,c){return this.b.call("$sendCommandResult",[a,f,c])}freePortKillProcess(a){return this.b.call("$freePortKillProcess",[a])}installAutoReply(a,f){return this.b.call("$installAutoReply",[a,f])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(a){return this.b.call("$getDefaultSystemShell",[a])}getProfiles(a,f,c){return this.b.call("$getProfiles",[this.d.getWorkspace().id,a,f,c])}acceptPtyHostResolvedVariables(a,f){return this.b.call("$acceptPtyHostResolvedVariables",[a,f])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(a,f){return this.b.call("$getWslPath",[a,f])}setTerminalLayoutInfo(a){const c={workspaceId:this.d.getWorkspace().id,tabs:a?a.tabs:[]};return this.b.call("$setTerminalLayoutInfo",c)}updateTitle(a,f,c){return this.b.call("$updateTitle",[a,f,c])}updateIcon(a,f,c,d){return this.b.call("$updateIcon",[a,f,c,d])}refreshProperty(a,f){return this.b.call("$refreshProperty",[a,f])}updateProperty(a,f,c){return this.b.call("$updateProperty",[a,f,c])}getTerminalLayoutInfo(){const f={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",f)}reviveTerminalProcesses(a,f,c){return this.b.call("$reviveTerminalProcesses",[a,f,c])}getRevivedPtyNewId(a){return this.b.call("$getRevivedPtyNewId",[a])}serializeTerminalState(a){return this.b.call("$serializeTerminalState",[a])}};e.$BQ=m,e.$BQ=m=Le([Ne(2,o.$$E),Ne(3,S.$Fi),Ne(4,I.$iQ),Ne(5,v.$ZP),Ne(6,C.$Hl),Ne(7,w.$$r),Ne(8,b.$2D),Ne(9,y.$9v)],m)}),define(ye[290],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mn=e.$ln=e.$kn=e.ExtHostConnectionType=void 0,e.$nn=P,e.$on=b;var o;(function(y){y[y.IPC=1]="IPC",y[y.Socket=2]="Socket",y[y.MessagePort=3]="MessagePort"})(o||(e.ExtHostConnectionType=o={}));class C{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(v){this.pipeName=v,this.type=1}serialize(v){v[C.ENV_KEY]=this.pipeName}}e.$kn=C;class S{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(v){v[S.ENV_KEY]="1"}}e.$ln=S;class D{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(v){v[D.ENV_KEY]="1"}}e.$mn=D;function I(y){delete y[C.ENV_KEY],delete y[S.ENV_KEY],delete y[D.ENV_KEY]}function P(y,v){I(v),y.serialize(v)}function b(y){if(y[C.ENV_KEY])return g(y,new C(y[C.ENV_KEY]));if(y[S.ENV_KEY])return g(y,new S);if(y[D.ENV_KEY])return g(y,new D);throw new Error("No connection information defined in environment!")}function g(y,v){return I(y),v}}),define(ye[291],Ee([1,0,15]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Zm=I,e.$1m=P;var C;(function(g){g[g.Desktop=1]="Desktop",g[g.Web=2]="Web"})(C||(e.UIKind=C={}));var S;(function(g){g[g.VersionMismatch=55]="VersionMismatch",g[g.UnexpectedError=81]="UnexpectedError"})(S||(e.ExtensionHostExitCode=S={}));var D;(function(g){g[g.Initialized=0]="Initialized",g[g.Ready=1]="Ready",g[g.Terminate=2]="Terminate"})(D||(e.MessageType=D={}));function I(g){const y=o.$Ge.alloc(1);switch(g){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}function P(g,y){if(g.byteLength!==1)return!1;switch(g.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}var b;(function(g){g.Start="START_NATIVE_LOG",g.End="END_NATIVE_LOG"})(b||(e.NativeLogMarkers=b={}))}),define(ye[292],Ee([1,0,5,6,12,278,291,86,37,21,4,2,216]),function(he,e,o,C,S,D,I,P,b,g,y,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QP=e.$OP=e.$NP=void 0,e.$PP=a;let m=class extends v.$Vc{constructor(c,d){super(),this.s=c,this.t=d,this.a=this.B(new C.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new C.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=y.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=d.createLogger(this.m,{id:b.$kp,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(d.onDidChangeLogLevel(p=>{(0,S.$5j)(p)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===S.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(c,d,p){const E=this.getTelemetryDetails(),h=new u(d,p,c,this.n,this.j,this.getBuiltInCommonProperties(c),{isUsageEnabled:E.isUsageEnabled,isErrorsEnabled:E.isErrorsEnabled}),t=this.r.get(c.identifier.value)??[];return this.r.set(c.identifier.value,[...t,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(c,d,p){this.f=c,this.g=d,this.c=p??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(c){const d=Object.create(null);switch(d["common.extname"]=`${c.publisher}.${c.name}`,d["common.extversion"]=c.version,d["common.vscodemachineid"]=this.s.telemetryInfo.machineId,d["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,d["common.sqmid"]=this.s.telemetryInfo.sqmId,d["common.vscodeversion"]=this.s.version,d["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),d["common.product"]=this.s.environment.appHost,this.s.uiKind){case I.UIKind.Web:d["common.uikind"]="web";break;case I.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,P.$Im)((0,b.$qp)(this.s.remote.authority)),d}$onDidChangeTelemetryLevel(c){this.h=this.getTelemetryConfiguration(),this.f=c;const d=this.getTelemetryDetails();this.r.forEach((p,E)=>{const h=p.filter(t=>!t.isDisposed);h.length===0?this.r.delete(E):this.r.set(E,h)}),this.r.forEach(p=>{for(const E of p)E.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(c,d){const E=this.r.get(c.value)?.filter(t=>!t.isDisposed);if(!E)return this.r.delete(c.value),!1;let h=!1;for(const t of E)t.ignoreUnhandledExtHostErrors||(t.logError(d),h=!0);return h}};e.$NP=m,e.$NP=m=Le([Ne(0,D.$MP),Ne(1,S.$4j)],m);class u{static validateSender(c){if(typeof c!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof c.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof c.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof c.flush<"u"&&typeof c.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(c,d,p,E,h,t,s){this.g=p,this.h=E,this.i=h,this.j=t,this.a=new C.$ee,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=c,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(c,d){this.e&&(this.d={isUsageEnabled:c,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(c){let d="properties"in c?c.properties??{}:c;return d=(0,b.$tp)(d,[]),this.c&&(d=(0,g.$6n)(d,this.c)),this.b||(d=(0,g.$6n)(d,this.j)),"properties"in c?c.properties=d:c=d,c}k(c,d){this.f&&(this.g.publisher==="vscode"?c=this.g.name+"/"+c:c=this.g.identifier.value+"/"+c,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(c,d),this.h.trace(c,d))}logUsage(c,d){this.d.isUsageEnabled&&this.k(c,d)}logError(c,d){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof c=="string")this.k(c,d);else{const p={name:c.name,message:c.message,stack:c.stack,cause:c.cause},E=(0,b.$tp)(p,[]),h=new Error(E.message,{cause:E.cause});h.stack=E.stack,h.name=E.name,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f.sendErrorData(h,d),this.h.trace("exception",d)}}get apiTelemetryLogger(){if(!this.e){const c=this,d={logUsage:c.logUsage.bind(c),get isUsageEnabled(){return c.d.isUsageEnabled},get isErrorsEnabled(){return c.d.isErrorsEnabled},logError:c.logError.bind(c),dispose:c.dispose.bind(c),onDidChangeEnableStates:c.a.event.bind(c)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let c=this.f;this.f=void 0,Promise.resolve(c.flush()).then(c=void 0),this.e=void 0}else this.f=void 0}}e.$OP=u;function a(f){const c=Date.now()-new Date(f).getTime();return isNaN(c)?!1:c<1e3*60*60*24}e.$QP=(0,o.$wi)("IExtHostTelemetry")}),define(ye[293],Ee([1,0,40,220,57]),function(he,e,o,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VQ=D;function D(I,P,b,g){const y=new o.$Tm;return I.forEach(v=>{const w=y.get(v.identifier);w&&g.warn((0,C.localize)(0,null,w.extensionLocation.fsPath,v.extensionLocation.fsPath)),y.set(v.identifier,v)}),P.forEach(v=>{const w=y.get(v.identifier);if(w)if(w.isBuiltin){if(S.gte(w.version,v.version)){g.warn(`Skipping extension ${v.extensionLocation.path} in favour of the builtin extension ${w.extensionLocation.path}.`);return}v.isBuiltin=!0}else g.warn((0,C.localize)(1,null,w.extensionLocation.fsPath,v.extensionLocation.fsPath));else if(v.isBuiltin){g.warn(`Skipping obsolete builtin extension ${v.extensionLocation.path}`);return}y.set(v.identifier,v)}),b.forEach(v=>{g.info((0,C.localize)(2,null,v.extensionLocation.fsPath));const w=y.get(v.identifier);w&&w.isBuiltin&&(v.isBuiltin=!0),y.set(v.identifier,v)}),Array.from(y.values())}}),define(ye[294],Ee([1,0,7,3,31,4,44,55,47,59,293,13]),function(he,e,o,C,S,D,I,P,b,g,y,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZQ=e.$YQ=void 0;class w{constructor(a,f,c,d,p,E,h){this.c=a,this.d=c,this.f=d,this.g=p,this.h=E,this.i=h,this.a=Promise.resolve(),this.b=Promise.resolve();const t=f.args["install-builtin-extension"];if(t){p.trace("Installing builtin extensions passed via args...");const r={isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"]};I.mark("code/server/willInstallBuiltinExtensions"),this.b=this.a=a.installExtensions([],this.j(t),r,!!f.args.force).then(()=>{I.mark("code/server/didInstallBuiltinExtensions"),p.trace("Finished installing builtin extensions")},i=>{p.error(i)})}const s=f.args["install-extension"];s&&(p.trace("Installing extensions passed via args..."),this.b=this.a.then(()=>a.installExtensions(this.j(s),[],{isMachineScoped:!!f.args["do-not-sync"],installPreReleaseVersion:!!f.args["pre-release"],isApplicationScoped:!0},!!f.args.force)).then(()=>{p.trace("Finished installing extensions")},r=>{p.error(r)}))}j(a){return a.map(f=>/\.vsix$/i.test(f)?D.URI.file((0,o.$jc)(f)?f:(0,o.$kc)((0,S.cwd)(),f)):f)}whenExtensionsReady(){return this.b}async scanExtensions(a,f,c,d){I.mark("code/server/willScanExtensions"),this.g.trace(`Scanning extensions using UI language: ${a}`),await this.a;const p=c?c.filter(h=>h.scheme===v.Schemas.file).map(h=>h.fsPath):void 0;f=f??this.d.defaultProfile.extensionsResource;const E=await this.k(f,a??C.$w,p,d);return this.g.trace("Scanned Extensions",E),this.r(E),I.mark("code/server/didScanExtensions"),E}async scanSingleExtension(a,f,c){await this.a;const d=a.scheme===v.Schemas.file?a.fsPath:null;if(!d)return null;const p=await this.o(d,f,c??C.$w);return p?(this.r([p]),p):null}async k(a,f,c,d){await this.q(f,d);const[p,E,h]=await Promise.all([this.m(f),this.n(a,f),this.l(f,c)]);return(0,y.$VQ)(p,E,h,this.g)}async l(a,f){return f?(await Promise.all(f.map(c=>this.f.scanOneOrMultipleExtensions(D.URI.file((0,o.$lc)(c)),1,{language:a})))).flat().map(c=>(0,g.$wq)(c,!0)):[]}async m(a){return(await this.f.scanSystemExtensions({language:a,useCache:!0})).map(c=>(0,g.$wq)(c,!1))}async n(a,f){return(await this.f.scanUserExtensions({profileLocation:a,language:f,useCache:!0})).map(d=>(0,g.$wq)(d,!1))}async o(a,f,c){const d=D.URI.file((0,o.$lc)(a)),p=f?0:1,E=await this.f.scanExistingExtension(d,p,{language:c});return E?(0,g.$wq)(E,!1):null}async q(a,f){if(!(a===C.$g||!this.h.isEnabled())){try{if((await this.i.getInstalledLanguages()).find(d=>d.id===a)){this.g.trace(`Language Pack ${a} is already installed. Skipping language pack installation.`);return}}catch(c){this.g.error(c)}if(!f){this.g.trace(`No language pack id provided for language ${a}. Skipping language pack installation.`);return}this.g.trace(`Language Pack ${f} for language ${a} is not installed. It will be installed now.`);try{await this.c.installExtensions([f],[],{isMachineScoped:!0},!0)}catch(c){this.g.error(c)}}}r(a){const f=(t,s)=>t.replace(/file/g,"vscode-remote"),c=t=>{let s="";return s+=t.global?"g":"",s+=t.ignoreCase?"i":"",s+=t.multiline?"m":"",new RegExp(f(t.source,!0),s)},d=new class{mapDefined(t){return b.$zj.create(t)}mapNot(t){return b.$Ej.create(t)}mapEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?b.$Aj.create(t,f(s,!1)):b.$Aj.create(t,s)}mapNotEquals(t,s){return t==="resourceScheme"&&typeof s=="string"?b.$Dj.create(t,f(s,!1)):b.$Dj.create(t,s)}mapGreater(t,s){return b.$Fj.create(t,s)}mapGreaterEquals(t,s){return b.$Gj.create(t,s)}mapSmaller(t,s){return b.$Hj.create(t,s)}mapSmallerEquals(t,s){return b.$Ij.create(t,s)}mapRegex(t,s){return t==="resourceScheme"&&s?b.$Jj.create(t,c(s)):b.$Jj.create(t,s)}mapIn(t,s){return b.$Bj.create(t,s)}mapNotIn(t,s){return b.$Cj.create(t,s)}},p=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const s=b.$uj.deserialize(t.when);if(!s)return;const r=s.map(d);t.when=r.serialize()},E=t=>{if(Array.isArray(t))for(const s of t)p(s);else p(t)},h=t=>{for(const s in t)E(t[s])};a.forEach(t=>{t.contributes&&(t.contributes.menus&&h(t.contributes.menus),t.contributes.keybindings&&E(t.contributes.keybindings),t.contributes.views&&h(t.contributes.views))})}}e.$YQ=w;class m{constructor(a,f){this.a=a,this.b=f}listen(a,f){throw new Error("Invalid listen")}async call(a,f,c){const d=this.b(a);switch(f){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const p=c[0],E=c[1]?D.URI.revive(d.transformIncoming(c[1])):void 0,h=Array.isArray(c[2])?c[2].map(r=>D.URI.revive(d.transformIncoming(r))):void 0,t=c[3];return(await this.a.scanExtensions(p,E,h,t)).map(r=>(0,P.$An)(r,d))}case"scanSingleExtension":{const p=await this.a.scanSingleExtension(D.URI.revive(d.transformIncoming(c[0])),c[1],c[2]);return p?(0,P.$An)(p,d):null}}throw new Error("Invalid call")}}e.$ZQ=m}),define(ye[139],Ee([1,0]),function(he,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bw=e.$yw=void 0,e.$zw=S,e.$Aw=D;class o{static{this.count=0}constructor(b){this._proxyIdentifierBrand=void 0,this.sid=b,this.nid=++o.count}}e.$yw=o;const C=[];function S(P){const b=new o(P);return C[b.nid]=b,b}function D(P){return C[P].sid}class I{constructor(b){this.value=b}}e.$Bw=I}),define(ye[295],Ee([1,0,139]),function(he,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$8M=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var C;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(C||(e.TextEditorRevealType=C={}));var S;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput",a[a.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(S||(e.TabInputKind=S={}));var D;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(D||(e.TabModelOperationKind=D={}));var I;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(I||(e.WebviewEditorCapabilities=I={}));var P;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var b;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(b||(e.CellOutputKind=b={}));var g;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(g||(e.NotebookEditorRevealType=g={}));var y;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(y||(e.CandidatePortSource=y={}));class v{static{this.a=0}static mixin(f){return f._id=v.a++,f}}e.$8M=v;var w;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var m;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(m||(e.ISuggestResultDtoField=m={}));var u;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(u||(e.ExtHostTestingResource=u={})),e.$9M={MainThreadAuthentication:(0,o.$zw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.$zw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,o.$zw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,o.$zw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,o.$zw)("MainThreadChatVariables"),MainThreadClipboard:(0,o.$zw)("MainThreadClipboard"),MainThreadCommands:(0,o.$zw)("MainThreadCommands"),MainThreadComments:(0,o.$zw)("MainThreadComments"),MainThreadConfiguration:(0,o.$zw)("MainThreadConfiguration"),MainThreadConsole:(0,o.$zw)("MainThreadConsole"),MainThreadDebugService:(0,o.$zw)("MainThreadDebugService"),MainThreadDecorations:(0,o.$zw)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.$zw)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.$zw)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.$zw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.$zw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.$zw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.$zw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.$zw)("MainThreadEditorTabs"),MainThreadErrors:(0,o.$zw)("MainThreadErrors"),MainThreadTreeViews:(0,o.$zw)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.$zw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,o.$zw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.$zw)("MainThreadLanguages"),MainThreadLogger:(0,o.$zw)("MainThreadLogger"),MainThreadMessageService:(0,o.$zw)("MainThreadMessageService"),MainThreadOutputService:(0,o.$zw)("MainThreadOutputService"),MainThreadProgress:(0,o.$zw)("MainThreadProgress"),MainThreadQuickDiff:(0,o.$zw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.$zw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.$zw)("MainThreadStatusBar"),MainThreadSecretState:(0,o.$zw)("MainThreadSecretState"),MainThreadStorage:(0,o.$zw)("MainThreadStorage"),MainThreadSpeech:(0,o.$zw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,o.$zw)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.$zw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,o.$zw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,o.$zw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.$zw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.$zw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.$zw)("MainThreadCustomEditors"),MainThreadUrls:(0,o.$zw)("MainThreadUrls"),MainThreadUriOpeners:(0,o.$zw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.$zw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.$zw)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.$zw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,o.$zw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,o.$zw)("MainThreadExtensionService"),MainThreadSCM:(0,o.$zw)("MainThreadSCM"),MainThreadSearch:(0,o.$zw)("MainThreadSearch"),MainThreadShare:(0,o.$zw)("MainThreadShare"),MainThreadTask:(0,o.$zw)("MainThreadTask"),MainThreadWindow:(0,o.$zw)("MainThreadWindow"),MainThreadLabelService:(0,o.$zw)("MainThreadLabelService"),MainThreadNotebook:(0,o.$zw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.$zw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.$zw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.$zw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.$zw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.$zw)("MainThreadInteractive"),MainThreadInlineChat:(0,o.$zw)("MainThreadInlineChatShape"),MainThreadTheming:(0,o.$zw)("MainThreadTheming"),MainThreadTunnelService:(0,o.$zw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,o.$zw)("MainThreadManagedSockets"),MainThreadTimeline:(0,o.$zw)("MainThreadTimeline"),MainThreadTesting:(0,o.$zw)("MainThreadTesting"),MainThreadLocalization:(0,o.$zw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,o.$zw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,o.$zw)("MainThreadAiEmbeddingVector")},e.$0M={ExtHostCommands:(0,o.$zw)("ExtHostCommands"),ExtHostConfiguration:(0,o.$zw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.$zw)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.$zw)("ExtHostDebugService"),ExtHostDecorations:(0,o.$zw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.$zw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.$zw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.$zw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.$zw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.$zw)("ExtHostEditors"),ExtHostTreeViews:(0,o.$zw)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.$zw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.$zw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.$zw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.$zw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.$zw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.$zw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.$zw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,o.$zw)("ExtHostStatusBar"),ExtHostShare:(0,o.$zw)("ExtHostShare"),ExtHostExtensionService:(0,o.$zw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.$zw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.$zw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,o.$zw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,o.$zw)("ExtHostSCM"),ExtHostSearch:(0,o.$zw)("ExtHostSearch"),ExtHostTask:(0,o.$zw)("ExtHostTask"),ExtHostWorkspace:(0,o.$zw)("ExtHostWorkspace"),ExtHostWindow:(0,o.$zw)("ExtHostWindow"),ExtHostWebviews:(0,o.$zw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.$zw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.$zw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.$zw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.$zw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.$zw)("ExtHostEditorTabs"),ExtHostProgress:(0,o.$zw)("ExtHostProgress"),ExtHostComments:(0,o.$zw)("ExtHostComments"),ExtHostSecretState:(0,o.$zw)("ExtHostSecretState"),ExtHostStorage:(0,o.$zw)("ExtHostStorage"),ExtHostUrls:(0,o.$zw)("ExtHostUrls"),ExtHostUriOpeners:(0,o.$zw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.$zw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.$zw)("ExtHostOutputService"),ExtHostLabelService:(0,o.$zw)("ExtHostLabelService"),ExtHostNotebook:(0,o.$zw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.$zw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.$zw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.$zw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.$zw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,o.$zw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,o.$zw)("ExtHostInteractive"),ExtHostInlineChat:(0,o.$zw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,o.$zw)("ExtHostChatAgents"),ExtHostChatVariables:(0,o.$zw)("ExtHostChatVariables"),ExtHostChatProvider:(0,o.$zw)("ExtHostChatProvider"),ExtHostSpeech:(0,o.$zw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,o.$zw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,o.$zw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,o.$zw)("ExtHostTheming"),ExtHostTunnelService:(0,o.$zw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,o.$zw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,o.$zw)("ExtHostAuthentication"),ExtHostTimeline:(0,o.$zw)("ExtHostTimeline"),ExtHostTesting:(0,o.$zw)("ExtHostTesting"),ExtHostTelemetry:(0,o.$zw)("ExtHostTelemetry"),ExtHostLocalization:(0,o.$zw)("ExtHostLocalization")}}),define(ye[296],Ee([1,0,15,24,13,110,5]),function(he,e,o,C,S,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$KK=void 0,e.$LK=y,e.$MK=v,e.$KK=(0,I.$wi)("notebookDocumentService");const P=["W","X","Y","Z","a","b","c","d","e","f"],b=new RegExp(`^[${P.join("")}]+`),g=7;function y(m){if(m.scheme!==S.Schemas.vscodeNotebookCell)return;const u=m.fragment.indexOf("s");if(u<0)return;const a=parseInt(m.fragment.substring(0,u).replace(b,""),g),f=(0,o.$Ze)(m.fragment.substring(u+1)).toString();if(!isNaN(a))return{handle:a,notebook:m.with({scheme:f,fragment:null})}}function v(m,u){const a=u.toString(g),c=`${a.length<P.length?P[a.length-1]:"z"}${a}s${(0,o.$1e)(o.$Ge.fromString(m.scheme),!0,!0)}`;return m.with({scheme:S.Schemas.vscodeNotebookCell,fragment:c})}class w{constructor(){this.a=new C.$Bc}getNotebook(u){if(u.scheme===S.Schemas.vscodeNotebookCell){const a=y(u);if(a){const f=this.a.get(a.notebook);if(f)return f}}return this.a.get(u)}addNotebookDocument(u){this.a.set(u.uri,u)}removeNotebookDocument(u){this.a.delete(u.uri)}}e.$NK=w,(0,D.$xs)(e.$KK,w,1)}),define(ye[140],Ee([1,0,15,80,41,65,13,7,3,47,296]),function(he,e,o,C,S,D,I,P,b,g,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8K=e.$5K=e.CellStatusbarAlignment=e.$4K=e.NotebookEditorPriority=e.$1K=e.$ZK=e.$XK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$WK=e.$VK=e.$UK=e.$TK=e.CellKind=e.$SK=e.$RK=e.$QK=void 0,e.$YK=s,e.$2K=i,e.$3K=n,e.$6K=k,e.$7K=A,e.$QK="workbench.editor.notebook",e.$RK="workbench.editor.notebookTextDiffEditor",e.$SK="workbench.editor.interactive";var v;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(v||(e.CellKind=v={})),e.$TK=["application/json","application/javascript","text/html","image/svg+xml",D.$Qs.latex,D.$Qs.markdown,"image/png","image/jpeg",D.$Qs.text],e.$UK=[D.$Qs.latex,D.$Qs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",D.$Qs.text],e.$VK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$WK="_notAvailable";var w;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var m;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var u;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(u||(e.NotebookExecutionState=u={}));var a;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(a||(e.NotebookRendererMatch=a={}));var f;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var c;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(c||(e.NotebookCellsChangeType=c={}));var d;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(d||(e.SelectionStateType=d={}));var p;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(p||(e.CellEditType=p={}));var E;(function(W){W.scheme=I.Schemas.vscodeNotebookCell;function K(be,re){return(0,y.$MK)(be,re)}W.generate=K;function Y(be){return(0,y.$LK)(be)}W.parse=Y;function M(be,re){return be.with({scheme:I.Schemas.vscodeNotebookCellOutput,fragment:`op${re??""},${be.scheme!==I.Schemas.file?be.scheme:""}`})}W.generateCellOutputUri=M;function Q(be){if(be.scheme!==I.Schemas.vscodeNotebookCellOutput)return;const re=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(be.fragment);if(!re)return;const X=re[1]&&re[1]!==""?re[1]:void 0,B=re[2];return{outputId:X,notebook:be.with({scheme:B||I.Schemas.file,fragment:null})}}W.parseCellOutputUri=Q;function ce(be,re,X){return W.generate(be,re).with({scheme:X})}W.generateCellPropertyUri=ce;function ie(be,re){if(be.scheme===re)return W.parse(be.with({scheme:W.scheme}))}W.parseCellPropertyUri=ie})(E||(e.CellUri=E={}));const h=W=>b.$i?W.replace(/\//g,"\\"):W;class t{constructor(K=[],Y=e.$TK){this.e=Y,this.d=[...new Set(K)].map(M=>({pattern:M,matches:C.$qk(h(M))}))}sort(K){const Y=new Map(S.Iterable.map(K,Q=>[Q,h(Q)]));let M=[];for(const{matches:Q}of this.d)for(const[ce,ie]of Y)if(Q(ie)){M.push(ce),Y.delete(ce);break}return Y.size&&(M=M.concat([...Y.keys()].sort((Q,ce)=>this.e.indexOf(Q)-this.e.indexOf(ce)))),M}prioritize(K,Y){const M=this.f(K);if(M===-1){this.d.unshift({pattern:K,matches:C.$qk(h(K))});return}const Q=new Set(Y.map(ie=>this.f(ie,M)));Q.delete(-1);const ce=Array.from(Q).sort();this.d.splice(M+1,0,...ce.map(ie=>this.d[ie]));for(let ie=ce.length-1;ie>=0;ie--)this.d.splice(ce[ie],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,Y=this.d.length){const M=h(K);for(let Q=0;Q<Y;Q++)if(this.d[Q].matches(M))return Q;return-1}}e.$XK=t;function s(W,K,Y,M=(Q,ce)=>Q===ce){const Q=[];function ce(re,X,B){if(X===0&&B.length===0)return;const N=Q[Q.length-1];N&&N.start+N.deleteCount===re?(N.deleteCount+=X,N.toInsert.push(...B)):Q.push({start:re,deleteCount:X,toInsert:B})}let ie=0,be=0;for(;;){if(ie===W.length){ce(ie,0,K.slice(be));break}if(be===K.length){ce(ie,W.length-ie,[]);break}const re=W[ie],X=K[be];if(M(re,X)){ie+=1,be+=1;continue}Y(X)?(ce(ie,1,[]),ie+=1):(ce(ie,0,[X]),be+=1)}return Q}e.$ZK=new g.$Nj("notebookEditorCursorAtBoundary","none"),e.$1K=new g.$Nj("notebookEditorCursorAtLineBoundary","none");var r;(function(W){W.default="default",W.option="option"})(r||(e.NotebookEditorPriority=r={}));function i(W){const K=W;return!!((typeof K.include=="string"||C.$rk(K.include))&&(typeof K.exclude=="string"||C.$rk(K.exclude)))}function n(W,K,Y){if(Array.isArray(W.viewType)&&W.viewType.indexOf(K)>=0||W.viewType===K)return!0;if(W.filenamePattern){const M=i(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,Q=i(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(C.$pk(M,(0,P.$oc)(Y.fsPath).toLowerCase()))return!(Q&&C.$pk(Q,(0,P.$oc)(Y.fsPath).toLowerCase()))}return!1}e.$4K={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var l;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class ${static{this.d="notebook/"}static create(K){return`${$.d}${K}`}static parse(K){if(K.startsWith($.d))return K.substring($.d.length)}}e.$5K=$;function k(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}const j=new TextDecoder;function A(W){const K=[];let Y=!1;for(const ie of W)(K.length===0||Y)&&(K.push(ie),Y=!0);let M=V(K);const Q=o.$Ge.concat(K.map(ie=>o.$Ge.wrap(ie))),ce=_(Q);return M=M||ce.byteLength!==Q.byteLength,{data:ce,didCompression:M}}e.$8K="\x1B[A";const O=e.$8K.split("").map(W=>W.charCodeAt(0)),F=10;function V(W){let K=!1;return W.forEach((Y,M)=>{if(M===0||Y.length<e.$8K.length)return;const Q=W[M-1],ce=Y.subarray(0,e.$8K.length);if(ce[0]===O[0]&&ce[1]===O[1]&&ce[2]===O[2]){const ie=Q.lastIndexOf(F);if(ie===-1)return;K=!0,W[M-1]=Q.subarray(0,ie),W[M]=Y.subarray(e.$8K.length)}}),K}function Z(W){let K=W;do W=K,K=W.replace(/[^\n]\x08/gm,"");while(K.length<W.length);return W}function oe(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const K=W.match(/^(.*)\r+/m)[1];let Y=W.match(/\r+(.*)$/m)[1];Y=Y+K.slice(Y.length,K.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return W}const le=8,te=13;function _(W){return!W.buffer.includes(le)&&!W.buffer.includes(te)?W:o.$Ge.fromString(oe(Z(j.decode(W.buffer))))}}),define(ye[141],Ee([1,0,18,11,101,24,65,17,10,4,22,40,16,119,140]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u){"use strict";var a,f,c,d,p,E,h,t,s,r,i,n,l,$,k,j,A;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$kP=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$jP=e.$iP=e.$hP=e.$gP=e.ChatLocation=e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=e.$0O=e.$9O=e.$8O=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$7O=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.$VO=e.$UO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$TO=e.$SO=e.$RO=e.$QO=e.$OO=e.$NO=e.$MO=e.$LO=e.TestRunProfileKind=e.TestResultState=e.$KO=e.$JO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$IO=e.NotebookVariablesRequestKind=e.$HO=e.$GO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$FO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$EO=e.$DO=e.$CO=e.$BO=e.$AO=e.ColorThemeKind=e.$zO=e.$yO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$xO=e.$wO=e.DebugConsoleMode=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$qO=e.$pO=e.FileChangeType=e.$oO=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$nO=e.$mO=e.$lO=e.$kO=e.InlineCompletionTriggerKind=e.$jO=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$0N=e.ConfigurationTarget=e.$9N=e.$8N=e.$7N=e.$6N=e.DocumentPasteTriggerKind=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$ZN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$YN=e.ViewBadge=e.ProgressLocation=e.$XN=e.$WN=e.TaskScope=e.ShellQuoting=e.$VN=e.$UN=e.$TN=e.TaskPanelKind=e.TaskRevealKind=e.$SN=e.TerminalLocation=e.$RN=e.$QN=e.$PN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$ON=e.$NN=e.$MN=e.$LN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$JN=e.$IN=e.$HN=e.$GN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$FN=e.$EN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$DN=e.$CN=e.$BN=e.$AN=e.$zN=e.LanguageStatusSeverity=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.CodeActionTriggerKind=e.$sN=e.$rN=e.SymbolTag=e.SymbolKind=e.$qN=e.$pN=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$oN=e.$nN=e.$mN=e.$lN=e.$kN=e.DiagnosticSeverity=e.DiagnosticTag=e.$jN=e.$iN=e.FileEditType=e.$hN=e.$gN=e.$fN=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$eN=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$KN=lt,e.$$N=ke,e.$PO=oi;function O(L){return Object.assign(L,{apply:function(...ne){if(ne.length===0)return Reflect.construct(L,[]);{const ve=ne.length===1?[]:ne[1];return Reflect.construct(L,ve,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(L,[]);{const[ve,...Be]=ne;return Reflect.construct(L,Be,ve.constructor)}}})}var F;(function(L){L[L.Top=0]="Top",L[L.Bottom=1]="Bottom"})(F||(e.TerminalOutputAnchor=F={}));var V;(function(L){L[L.TerminalCommand=0]="TerminalCommand",L[L.Opener=1]="Opener",L[L.Command=3]="Command"})(V||(e.TerminalQuickFixType=V={}));let Z=a=class{static from(...R){let ne=R;return new a(function(){if(ne){for(const ve of ne)ve&&typeof ve.dispose=="function"&&ve.dispose();ne=void 0}})}#e;constructor(R){this.#e=R}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$$M=Z,e.$$M=Z=a=Le([O],Z);let oe=f=class{static Min(...R){if(R.length===0)throw new TypeError;let ne=R[0];for(let ve=1;ve<R.length;ve++){const Be=R[ve];Be.isBefore(ne)&&(ne=Be)}return ne}static Max(...R){if(R.length===0)throw new TypeError;let ne=R[0];for(let ve=1;ve<R.length;ve++){const Be=R[ve];Be.isAfter(ne)&&(ne=Be)}return ne}static isPosition(R){if(!R)return!1;if(R instanceof f)return!0;const{line:ne,character:ve}=R;return typeof ne=="number"&&typeof ve=="number"}static of(R){if(R instanceof f)return R;if(this.isPosition(R))return new f(R.line,R.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(R,ne){if(R<0)throw(0,C.$7)("line must be non-negative");if(ne<0)throw(0,C.$7)("character must be non-negative");this.c=R,this.e=ne}isBefore(R){return this.c<R.c?!0:R.c<this.c?!1:this.e<R.e}isBeforeOrEqual(R){return this.c<R.c?!0:R.c<this.c?!1:this.e<=R.e}isAfter(R){return!this.isBeforeOrEqual(R)}isAfterOrEqual(R){return!this.isBefore(R)}isEqual(R){return this.c===R.c&&this.e===R.e}compareTo(R){return this.c<R.c?-1:this.c>R.line?1:this.e<R.e?-1:this.e>R.e?1:0}translate(R,ne=0){if(R===null||ne===null)throw(0,C.$7)();let ve;return typeof R>"u"?ve=0:typeof R=="number"?ve=R:(ve=typeof R.lineDelta=="number"?R.lineDelta:0,ne=typeof R.characterDelta=="number"?R.characterDelta:0),ve===0&&ne===0?this:new f(this.line+ve,this.character+ne)}with(R,ne=this.character){if(R===null||ne===null)throw(0,C.$7)();let ve;return typeof R>"u"?ve=this.line:typeof R=="number"?ve=R:(ve=typeof R.line=="number"?R.line:this.line,ne=typeof R.character=="number"?R.character:this.character),ve===this.line&&ne===this.character?this:new f(ve,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$_M=oe,e.$_M=oe=f=Le([O],oe);let le=c=class{static isRange(R){return R instanceof c?!0:R?oe.isPosition(R.start)&&oe.isPosition(R.end):!1}static of(R){if(R instanceof c)return R;if(this.isRange(R))return new c(R.start,R.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(R,ne,ve,Be){let We,Ye;if(typeof R=="number"&&typeof ne=="number"&&typeof ve=="number"&&typeof Be=="number"?(We=new oe(R,ne),Ye=new oe(ve,Be)):oe.isPosition(R)&&oe.isPosition(ne)&&(We=oe.of(R),Ye=oe.of(ne)),!We||!Ye)throw new Error("Invalid arguments");We.isBefore(Ye)?(this.c=We,this.e=Ye):(this.c=Ye,this.e=We)}contains(R){return c.isRange(R)?this.contains(R.start)&&this.contains(R.end):oe.isPosition(R)?!(oe.of(R).isBefore(this.c)||this.e.isBefore(R)):!1}isEqual(R){return this.c.isEqual(R.c)&&this.e.isEqual(R.e)}intersection(R){const ne=oe.Max(R.start,this.c),ve=oe.Min(R.end,this.e);if(!ne.isAfter(ve))return new c(ne,ve)}union(R){if(this.contains(R))return this;if(R.contains(this))return R;const ne=oe.Min(R.start,this.c),ve=oe.Max(R.end,this.end);return new c(ne,ve)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(R,ne=this.end){if(R===null||ne===null)throw(0,C.$7)();let ve;return R?oe.isPosition(R)?ve=R:(ve=R.start||this.start,ne=R.end||this.end):ve=this.start,ve.isEqual(this.c)&&ne.isEqual(this.end)?this:new c(ve,ne)}toJSON(){return[this.start,this.end]}};e.$aN=le,e.$aN=le=c=Le([O],le);let te=d=class extends le{static isSelection(R){return R instanceof d?!0:R?le.isRange(R)&&oe.isPosition(R.anchor)&&oe.isPosition(R.active)&&typeof R.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(R,ne,ve,Be){let We,Ye;if(typeof R=="number"&&typeof ne=="number"&&typeof ve=="number"&&typeof Be=="number"?(We=new oe(R,ne),Ye=new oe(ve,Be)):oe.isPosition(R)&&oe.isPosition(ne)&&(We=oe.of(R),Ye=oe.of(ne)),!We||!Ye)throw new Error("Invalid arguments");super(We,Ye),this.f=We,this.g=Ye}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$bN=te,e.$bN=te=d=Le([O],te);const _=L=>{if(typeof L!="string"||L.length===0||!/^[0-9A-Za-z_\-]+$/.test(L))throw(0,C.$7)("connectionToken")};class W{static isResolvedAuthority(R){return R&&typeof R=="object"&&typeof R.host=="string"&&typeof R.port=="number"&&(R.connectionToken===void 0||typeof R.connectionToken=="string")}constructor(R,ne,ve){if(typeof R!="string"||R.length===0)throw(0,C.$7)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,C.$7)("port");typeof ve<"u"&&_(ve),this.host=R,this.port=Math.round(ne),this.connectionToken=ve}}e.$cN=W;class K{static isManagedResolvedAuthority(R){return R&&typeof R=="object"&&typeof R.makeConnection=="function"&&(R.connectionToken===void 0||typeof R.connectionToken=="string")}constructor(R,ne){this.makeConnection=R,this.connectionToken=ne,typeof ne<"u"&&_(ne)}}e.$dN=K;class Y extends Error{static NotAvailable(R,ne){return new Y(R,m.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(R){return new Y(R,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(R,ne=m.RemoteAuthorityResolverErrorCode.Unknown,ve){super(R),this._message=R,this._code=ne,this._detail=ve,Object.setPrototypeOf(this,Y.prototype)}}e.$eN=Y;var M;(function(L){L[L.LF=1]="LF",L[L.CRLF=2]="CRLF"})(M||(e.EndOfLine=M={}));var Q;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let ce=p=class{static isTextEdit(R){return R instanceof p?!0:R?le.isRange(R)&&typeof R.newText=="string":!1}static replace(R,ne){return new p(R,ne)}static insert(R,ne){return p.replace(new le(R,R),ne)}static delete(R){return p.replace(R,"")}static setEndOfLine(R){const ne=new p(new le(new oe(0,0),new oe(0,0)),"");return ne.newEol=R,ne}get range(){return this.c}set range(R){if(R&&!le.isRange(R))throw(0,C.$7)("range");this.c=R}get newText(){return this.e||""}set newText(R){if(R&&typeof R!="string")throw(0,C.$7)("newText");this.e=R}get newEol(){return this.f}set newEol(R){if(R&&typeof R!="number")throw(0,C.$7)("newEol");this.f=R}constructor(R,ne){this.c=R,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$fN=ce,e.$fN=ce=p=Le([O],ce);let ie=E=class{static isNotebookCellEdit(R){return R instanceof E?!0:R?Vt.isNotebookRange(R)&&Array.isArray(R.newCells):!1}static replaceCells(R,ne){return new E(R,ne)}static insertCells(R,ne){return new E(new Vt(R,R),ne)}static deleteCells(R){return new E(R,[])}static updateCellMetadata(R,ne){const ve=new E(new Vt(R,R),[]);return ve.newCellMetadata=ne,ve}static updateNotebookMetadata(R){const ne=new E(new Vt(0,0),[]);return ne.newNotebookMetadata=R,ne}constructor(R,ne){this.range=R,this.newCells=ne}};e.$gN=ie,e.$gN=ie=E=Le([O],ie);class be{static isSnippetTextEdit(R){return R instanceof be?!0:R?le.isRange(R.range)&&B.isSnippetString(R.snippet):!1}static replace(R,ne){return new be(R,ne)}static insert(R,ne){return be.replace(new le(R,R),ne)}constructor(R,ne){this.range=R,this.snippet=ne}}e.$hN=be;var re;(function(L){L[L.File=1]="File",L[L.Text=2]="Text",L[L.Cell=3]="Cell",L[L.CellReplace=5]="CellReplace",L[L.Snippet=6]="Snippet"})(re||(e.FileEditType=re={}));let X=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(R,ne,ve,Be){this.c.push({_type:1,from:R,to:ne,options:ve,metadata:Be})}createFile(R,ne,ve){this.c.push({_type:1,from:void 0,to:R,options:ne,metadata:ve})}deleteFile(R,ne,ve){this.c.push({_type:1,from:R,to:void 0,options:ne,metadata:ve})}e(R,ne,ve){this.c.push({_type:3,metadata:ve,uri:R,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(R,ne,ve,Be){const We=ne.start,Ye=ne.end;(We!==Ye||ve.length>0)&&this.c.push({_type:5,uri:R,index:We,count:Ye-We,cells:ve,metadata:Be})}g(R,ne,ve,Be){this.c.push({_type:3,metadata:Be,uri:R,edit:{editType:3,index:ne,metadata:ve}})}replace(R,ne,ve,Be){this.c.push({_type:2,uri:R,edit:new ce(ne,ve),metadata:Be})}insert(R,ne,ve,Be){this.replace(R,new le(ne,ne),ve,Be)}delete(R,ne,ve){this.replace(R,ne,"",ve)}has(R){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===R.toString())}set(R,ne){if(ne)for(const ve of ne){if(!ve)continue;let Be,We;Array.isArray(ve)?(Be=ve[0],We=ve[1]):Be=ve,ie.isNotebookCellEdit(Be)?Be.newCellMetadata?this.g(R,Be.range.start,Be.newCellMetadata,We):Be.newNotebookMetadata?this.e(R,Be.newNotebookMetadata,We):this.f(R,Be.range,Be.newCells,We):be.isSnippetTextEdit(Be)?this.c.push({_type:6,uri:R,range:Be.range,edit:Be.snippet,metadata:We}):this.c.push({_type:2,uri:R,edit:Be,metadata:We})}else{for(let ve=0;ve<this.c.length;ve++){const Be=this.c[ve];switch(Be._type){case 2:case 6:case 3:case 5:Be.uri.toString()===R.toString()&&(this.c[ve]=void 0);break}}(0,o.$Ib)(this.c)}}get(R){const ne=[];for(const ve of this.c)ve._type===2&&ve.uri.toString()===R.toString()&&ne.push(ve.edit);return ne}entries(){const R=new D.$Bc;for(const ne of this.c)if(ne._type===2){let ve=R.get(ne.uri);ve||(ve=[ne.uri,[]],R.set(ne.uri,ve)),ve[1].push(ne.edit)}return[...R.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$iN=X,e.$iN=X=Le([O],X);let B=h=class{static isSnippetString(R){return R instanceof h?!0:R?typeof R.value=="string":!1}static c(R){return R.replace(/\$|}|\\/g,"\\$&")}constructor(R){this.e=1,this.value=R||""}appendText(R){return this.value+=h.c(R),this}appendTabstop(R=this.e++){return this.value+="$",this.value+=R,this}appendPlaceholder(R,ne=this.e++){if(typeof R=="function"){const ve=new h;ve.e=this.e,R(ve),this.e=ve.e,R=ve.value}else R=h.c(R);return this.value+="${",this.value+=ne,this.value+=":",this.value+=R,this.value+="}",this}appendChoice(R,ne=this.e++){const ve=R.map(Be=>Be.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=ve,this.value+="|}",this}appendVariable(R,ne){if(typeof ne=="function"){const ve=new h;ve.e=this.e,ne(ve),this.e=ve.e,ne=ve.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=R,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$jN=B,e.$jN=B=h=Le([O],B);var N;(function(L){L[L.Unnecessary=1]="Unnecessary",L[L.Deprecated=2]="Deprecated"})(N||(e.DiagnosticTag=N={}));var z;(function(L){L[L.Hint=3]="Hint",L[L.Information=2]="Information",L[L.Warning=1]="Warning",L[L.Error=0]="Error"})(z||(e.DiagnosticSeverity=z={}));let J=t=class{static isLocation(R){return R instanceof t?!0:R?le.isRange(R.range)&&g.URI.isUri(R.uri):!1}constructor(R,ne){if(this.uri=R,ne)if(le.isRange(ne))this.range=le.of(ne);else if(oe.isPosition(ne))this.range=new le(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$kN=J,e.$kN=J=t=Le([O],J);let ue=class{static is(R){return R?typeof R.message=="string"&&R.location&&le.isRange(R.location.range)&&g.URI.isUri(R.location.uri):!1}constructor(R,ne){this.location=R,this.message=ne}static isEqual(R,ne){return R===ne?!0:!R||!ne?!1:R.message===ne.message&&R.location.range.isEqual(ne.location.range)&&R.location.uri.toString()===ne.location.uri.toString()}};e.$lN=ue,e.$lN=ue=Le([O],ue);let x=class{constructor(R,ne,ve=z.Error){if(!le.isRange(R))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=R,this.message=ne,this.severity=ve}toJSON(){return{severity:z[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(R,ne){return R===ne?!0:!R||!ne?!1:R.message===ne.message&&R.severity===ne.severity&&R.code===ne.code&&R.severity===ne.severity&&R.source===ne.source&&R.range.isEqual(ne.range)&&(0,o.$ub)(R.tags,ne.tags)&&(0,o.$ub)(R.relatedInformation,ne.relatedInformation,ue.isEqual)}};e.$mN=x,e.$mN=x=Le([O],x);let G=class{constructor(R,ne){if(!R)throw new Error("Illegal argument, contents must be defined");Array.isArray(R)?this.contents=R:this.contents=[R],this.range=ne}};e.$nN=G,e.$nN=G=Le([O],G);let U=class extends G{constructor(R,ne,ve,Be){super(R,ne),this.canIncreaseHover=ve,this.canDecreaseHover=Be}};e.$oN=U,e.$oN=U=Le([O],U);var T;(function(L){L[L.Increase=0]="Increase",L[L.Decrease=1]="Decrease"})(T||(e.HoverVerbosityAction=T={}));var q;(function(L){L[L.Text=0]="Text",L[L.Read=1]="Read",L[L.Write=2]="Write"})(q||(e.DocumentHighlightKind=q={}));let se=class{constructor(R,ne=q.Text){this.range=R,this.kind=ne}toJSON(){return{range:this.range,kind:q[this.kind]}}};e.$pN=se,e.$pN=se=Le([O],se);let ae=class{constructor(R,ne){this.uri=R,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(R=>R.toJSON())}}};e.$qN=ae,e.$qN=ae=Le([O],ae);var me;(function(L){L[L.File=0]="File",L[L.Module=1]="Module",L[L.Namespace=2]="Namespace",L[L.Package=3]="Package",L[L.Class=4]="Class",L[L.Method=5]="Method",L[L.Property=6]="Property",L[L.Field=7]="Field",L[L.Constructor=8]="Constructor",L[L.Enum=9]="Enum",L[L.Interface=10]="Interface",L[L.Function=11]="Function",L[L.Variable=12]="Variable",L[L.Constant=13]="Constant",L[L.String=14]="String",L[L.Number=15]="Number",L[L.Boolean=16]="Boolean",L[L.Array=17]="Array",L[L.Object=18]="Object",L[L.Key=19]="Key",L[L.Null=20]="Null",L[L.EnumMember=21]="EnumMember",L[L.Struct=22]="Struct",L[L.Event=23]="Event",L[L.Operator=24]="Operator",L[L.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var ee;(function(L){L[L.Deprecated=1]="Deprecated"})(ee||(e.SymbolTag=ee={}));let ge=s=class{static validate(R){if(!R.name)throw new Error("name must not be falsy")}constructor(R,ne,ve,Be,We){this.name=R,this.kind=ne,this.containerName=We,typeof ve=="string"&&(this.containerName=ve),Be instanceof J?this.location=Be:ve instanceof le&&(this.location=new J(Be,ve)),s.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$rN=ge,e.$rN=ge=s=Le([O],ge);let $e=r=class{static validate(R){if(!R.name)throw new Error("name must not be falsy");if(!R.range.contains(R.selectionRange))throw new Error("selectionRange must be contained in fullRange");R.children?.forEach(r.validate)}constructor(R,ne,ve,Be,We){this.name=R,this.detail=ne,this.kind=ve,this.range=Be,this.selectionRange=We,this.children=[],r.validate(this)}};e.$sN=$e,e.$sN=$e=r=Le([O],$e);var Ce;(function(L){L[L.Invoke=1]="Invoke",L[L.Automatic=2]="Automatic"})(Ce||(e.CodeActionTriggerKind=Ce={}));let je=class{constructor(R,ne){this.title=R,this.kind=ne}};e.$tN=je,e.$tN=je=Le([O],je);let de=class{static{i=this}static{this.c="."}constructor(R){this.value=R}append(R){return new i(this.value?this.value+i.c+R:R)}intersects(R){return this.contains(R)||R.contains(this)}contains(R){return this.value===R.value||R.value.startsWith(this.value+i.c)}};e.$uN=de,e.$uN=de=i=Le([O],de),de.Empty=new de(""),de.QuickFix=de.Empty.append("quickfix"),de.Refactor=de.Empty.append("refactor"),de.RefactorExtract=de.Refactor.append("extract"),de.RefactorInline=de.Refactor.append("inline"),de.RefactorMove=de.Refactor.append("move"),de.RefactorRewrite=de.Refactor.append("rewrite"),de.Source=de.Empty.append("source"),de.SourceOrganizeImports=de.Source.append("organizeImports"),de.SourceFixAll=de.Source.append("fixAll"),de.Notebook=de.Empty.append("notebook");let Pe=class{constructor(R,ne){if(this.range=R,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$vN=Pe,e.$vN=Pe=Le([O],Pe);class De{constructor(R,ne,ve,Be,We,Ye){this.kind=R,this.name=ne,this.detail=ve,this.uri=Be,this.range=We,this.selectionRange=Ye}}e.$wN=De;class Me{constructor(R,ne){this.fromRanges=ne,this.from=R}}e.$xN=Me;class Fe{constructor(R,ne){this.fromRanges=ne,this.to=R}}e.$yN=Fe;var Ue;(function(L){L[L.Information=0]="Information",L[L.Warning=1]="Warning",L[L.Error=2]="Error"})(Ue||(e.LanguageStatusSeverity=Ue={}));let Ve=class{constructor(R,ne){this.range=R,this.command=ne}get isResolved(){return!!this.command}};e.$zN=Ve,e.$zN=Ve=Le([O],Ve);let Ge=n=class{#e;static isMarkdownString(R){return R instanceof n?!0:R&&R.appendCodeblock&&R.appendMarkdown&&R.appendText&&R.value!==void 0}constructor(R,ne=!1){this.#e=new S.$Tk(R,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(R){this.#e.value=R}get isTrusted(){return this.#e.isTrusted}set isTrusted(R){this.#e.isTrusted=R}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(R){this.#e.supportThemeIcons=R}get supportHtml(){return this.#e.supportHtml}set supportHtml(R){this.#e.supportHtml=R}get baseUri(){return this.#e.baseUri}set baseUri(R){this.#e.baseUri=R}appendText(R){return this.#e.appendText(R),this}appendMarkdown(R){return this.#e.appendMarkdown(R),this}appendCodeblock(R,ne){return this.#e.appendCodeblock(ne??"",R),this}};e.$AN=Ge,e.$AN=Ge=n=Le([O],Ge);let Ze=class{constructor(R,ne){this.label=R,this.documentation=ne}};e.$BN=Ze,e.$BN=Ze=Le([O],Ze);let _e=class{constructor(R,ne){this.label=R,this.documentation=ne,this.parameters=[]}};e.$CN=_e,e.$CN=_e=Le([O],_e);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$DN=et,e.$DN=et=Le([O],et);var xe;(function(L){L[L.Invoke=1]="Invoke",L[L.TriggerCharacter=2]="TriggerCharacter",L[L.ContentChange=3]="ContentChange"})(xe||(e.SignatureHelpTriggerKind=xe={}));var pe;(function(L){L[L.Type=1]="Type",L[L.Parameter=2]="Parameter"})(pe||(e.InlayHintKind=pe={}));let Ie=class{constructor(R){this.value=R}};e.$EN=Ie,e.$EN=Ie=Le([O],Ie);let Re=class{constructor(R,ne,ve){this.position=R,this.label=ne,this.kind=ve}};e.$FN=Re,e.$FN=Re=Le([O],Re);var Ae;(function(L){L[L.Invoke=0]="Invoke",L[L.TriggerCharacter=1]="TriggerCharacter",L[L.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ae||(e.CompletionTriggerKind=Ae={}));var Te;(function(L){L[L.Text=0]="Text",L[L.Method=1]="Method",L[L.Function=2]="Function",L[L.Constructor=3]="Constructor",L[L.Field=4]="Field",L[L.Variable=5]="Variable",L[L.Class=6]="Class",L[L.Interface=7]="Interface",L[L.Module=8]="Module",L[L.Property=9]="Property",L[L.Unit=10]="Unit",L[L.Value=11]="Value",L[L.Enum=12]="Enum",L[L.Keyword=13]="Keyword",L[L.Snippet=14]="Snippet",L[L.Color=15]="Color",L[L.File=16]="File",L[L.Reference=17]="Reference",L[L.Folder=18]="Folder",L[L.EnumMember=19]="EnumMember",L[L.Constant=20]="Constant",L[L.Struct=21]="Struct",L[L.Event=22]="Event",L[L.Operator=23]="Operator",L[L.TypeParameter=24]="TypeParameter",L[L.User=25]="User",L[L.Issue=26]="Issue"})(Te||(e.CompletionItemKind=Te={}));var Qe;(function(L){L[L.Deprecated=1]="Deprecated"})(Qe||(e.CompletionItemTag=Qe={}));let He=class{constructor(R,ne){this.label=R,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&Te[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$GN=He,e.$GN=He=Le([O],He);let Je=class{constructor(R=[],ne=!1){this.items=R,this.isIncomplete=ne}};e.$HN=Je,e.$HN=Je=Le([O],Je);let it=class{constructor(R,ne,ve){this.insertText=R,this.range=ne,this.command=ve}};e.$IN=it,e.$IN=it=Le([O],it);let Ke=class{constructor(R){this.commands=void 0,this.suppressSuggestions=void 0,this.items=R}};e.$JN=Ke,e.$JN=Ke=Le([O],Ke);var nt;(function(L){L[L.Unknown=0]="Unknown",L[L.Word=1]="Word",L[L.Line=2]="Line",L[L.Suggest=3]="Suggest"})(nt||(e.PartialAcceptTriggerKind=nt={}));var ot;(function(L){L[L.Active=-1]="Active",L[L.Beside=-2]="Beside",L[L.One=1]="One",L[L.Two=2]="Two",L[L.Three=3]="Three",L[L.Four=4]="Four",L[L.Five=5]="Five",L[L.Six=6]="Six",L[L.Seven=7]="Seven",L[L.Eight=8]="Eight",L[L.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var at;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(at||(e.StatusBarAlignment=at={}));function lt(L,R){return`${v.$Rm.toKey(L)}.${R}`}var ht;(function(L){L[L.Off=0]="Off",L[L.On=1]="On",L[L.Relative=2]="Relative",L[L.Interval=3]="Interval"})(ht||(e.TextEditorLineNumbersStyle=ht={}));var kt;(function(L){L[L.Manual=1]="Manual",L[L.AfterDelay=2]="AfterDelay",L[L.FocusOut=3]="FocusOut"})(kt||(e.TextDocumentSaveReason=kt={}));var At;(function(L){L[L.Default=0]="Default",L[L.InCenter=1]="InCenter",L[L.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",L[L.AtTop=3]="AtTop"})(At||(e.TextEditorRevealType=At={}));var bt;(function(L){L[L.Keyboard=1]="Keyboard",L[L.Mouse=2]="Mouse",L[L.Command=3]="Command"})(bt||(e.TextEditorSelectionChangeKind=bt={}));var Lt;(function(L){L[L.Undo=1]="Undo",L[L.Redo=2]="Redo"})(Lt||(e.TextDocumentChangeReason=Lt={}));var Dt;(function(L){L[L.OpenOpen=0]="OpenOpen",L[L.ClosedClosed=1]="ClosedClosed",L[L.OpenClosed=2]="OpenClosed",L[L.ClosedOpen=3]="ClosedOpen"})(Dt||(e.DecorationRangeBehavior=Dt={})),function(L){function R(ne){switch(ne){case"keyboard":return L.Keyboard;case"mouse":return L.Mouse;case"api":return L.Command}}L.fromValue=R}(bt||(e.TextEditorSelectionChangeKind=bt={}));var Pt;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(Pt||(e.SyntaxTokenType=Pt={})),function(L){function R(ne){switch(ne){case L.Other:return"other";case L.Comment:return"comment";case L.String:return"string";case L.RegEx:return"regex"}return"other"}L.toString=R}(Pt||(e.SyntaxTokenType=Pt={}));let Tt=class{constructor(R,ne){if(ne&&!g.URI.isUri(ne))throw(0,C.$7)("target");if(!le.isRange(R)||R.isEmpty)throw(0,C.$7)("range");this.range=R,this.target=ne}};e.$LN=Tt,e.$LN=Tt=Le([O],Tt);let dt=class{constructor(R,ne,ve,Be){this.red=R,this.green=ne,this.blue=ve,this.alpha=Be}};e.$MN=dt,e.$MN=dt=Le([O],dt);let Ot=class{constructor(R,ne){if(ne&&!(ne instanceof dt))throw(0,C.$7)("color");if(!le.isRange(R)||R.isEmpty)throw(0,C.$7)("range");this.range=R,this.color=ne}};e.$NN=Ot,e.$NN=Ot=Le([O],Ot);let gt=class{constructor(R){if(!R||typeof R!="string")throw(0,C.$7)("label");this.label=R}};e.$ON=gt,e.$ON=gt=Le([O],gt);var rt;(function(L){L[L.RGB=0]="RGB",L[L.HEX=1]="HEX",L[L.HSL=2]="HSL"})(rt||(e.ColorFormat=rt={}));var mt;(function(L){L[L.Error=0]="Error",L[L.Warning=1]="Warning",L[L.Information=2]="Information"})(mt||(e.SourceControlInputBoxValidationType=mt={}));var $t;(function(L){L[L.Unknown=0]="Unknown",L[L.Shutdown=1]="Shutdown",L[L.Process=2]="Process",L[L.User=3]="User",L[L.Extension=4]="Extension"})($t||(e.TerminalExitReason=$t={}));var Ut;(function(L){L[L.Low=0]="Low",L[L.Medium=1]="Medium",L[L.High=2]="High"})(Ut||(e.TerminalShellExecutionCommandLineConfidence=Ut={}));class en{constructor(R,ne,ve){if(this.startIndex=R,this.length=ne,this.tooltip=ve,typeof R!="number"||R<0)throw(0,C.$7)("startIndex");if(typeof ne!="number"||ne<1)throw(0,C.$7)("length");if(ve!==void 0&&typeof ve!="string")throw(0,C.$7)("tooltip")}}e.$PN=en;class tn{constructor(R){this.uri=R}}e.$QN=tn;class Mt{constructor(R){this.terminalCommand=R}}e.$RN=Mt;var zt;(function(L){L[L.Panel=1]="Panel",L[L.Editor=2]="Editor"})(zt||(e.TerminalLocation=zt={}));class Ht{constructor(R){if(this.options=R,typeof R!="object")throw(0,C.$7)("options")}}e.$SN=Ht;var Wt;(function(L){L[L.Always=1]="Always",L[L.Silent=2]="Silent",L[L.Never=3]="Never"})(Wt||(e.TaskRevealKind=Wt={}));var Nt;(function(L){L[L.Shared=1]="Shared",L[L.Dedicated=2]="Dedicated",L[L.New=3]="New"})(Nt||(e.TaskPanelKind=Nt={}));let Bt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(R){switch(R){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(R,ne){if(this.label=ne,typeof R!="string"||typeof ne!="string")throw(0,C.$7)("name");this.c=R}get id(){return this.c}};e.$TN=Bt,e.$TN=Bt=l=Le([O],Bt);function Gt(L){let R="";for(let ne=0;ne<L.length;ne++)R+=L[ne].replace(/,/g,",,")+",";return R}let xt=class{constructor(R,ne,ve){if(typeof R!="string")throw(0,C.$7)("process");this.e=[],this.c=R,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=ve):this.f=ne)}get process(){return this.c}set process(R){if(typeof R!="string")throw(0,C.$7)("process");this.c=R}get args(){return this.e}set args(R){Array.isArray(R)||(R=[]),this.e=R}get options(){return this.f}set options(R){this.f=R}computeId(){const R=[];if(R.push("process"),this.c!==void 0&&R.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)R.push(ne);return Gt(R)}};e.$UN=xt,e.$UN=xt=Le([O],xt);let Rt=class{constructor(R,ne,ve){if(this.f=[],Array.isArray(ne)){if(!R)throw(0,C.$7)("command can't be undefined or null");if(typeof R!="string"&&typeof R.value!="string")throw(0,C.$7)("command");this.e=R,this.f=ne,this.g=ve}else{if(typeof R!="string")throw(0,C.$7)("commandLine");this.c=R,this.g=ne}}get commandLine(){return this.c}set commandLine(R){if(typeof R!="string")throw(0,C.$7)("commandLine");this.c=R}get command(){return this.e?this.e:""}set command(R){if(typeof R!="string"&&typeof R.value!="string")throw(0,C.$7)("command");this.e=R}get args(){return this.f}set args(R){this.f=R||[]}get options(){return this.g}set options(R){this.g=R}computeId(){const R=[];if(R.push("shell"),this.c!==void 0&&R.push(this.c),this.e!==void 0&&R.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)R.push(typeof ne=="string"?ne:ne.value);return Gt(R)}};e.$VN=Rt,e.$VN=Rt=Le([O],Rt);var nn;(function(L){L[L.Escape=1]="Escape",L[L.Strong=2]="Strong",L[L.Weak=3]="Weak"})(nn||(e.ShellQuoting=nn={}));var qt;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace"})(qt||(e.TaskScope=qt={}));class Jt{constructor(R){this.c=R}computeId(){return"customExecution"+(0,y.$Sg)()}set callback(R){this.c=R}get callback(){return this.c}}e.$WN=Jt;let Qt=class{static{$=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(R,ne,ve,Be,We,Ye){this.k=!1,this.l=this.definition=R;let tt;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=ve,this.execution=Be,tt=We,this.k=!0):ne===qt.Global||ne===qt.Workspace?(this.target=ne,this.o=this.name=ve,this.w=this.source=Be,this.execution=We,tt=Ye):(this.target=ne,this.o=this.name=ve,this.w=this.source=Be,this.execution=We,tt=Ye),typeof tt=="string"?(this.r=[tt],this.t=!0):Array.isArray(tt)?(this.r=tt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(R){this.j=R}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof xt?this.l={type:$.e,id:this.q.computeId()}:this.q instanceof Rt?this.l={type:$.f,id:this.q.computeId()}:this.q instanceof Jt?this.l={type:$.c,id:this.q.computeId()}:this.l={type:$.g,id:(0,y.$Sg)()}}get definition(){return this.l}set definition(R){if(R==null)throw(0,C.$7)("Kind can't be undefined or null");this.B(),this.l=R}get scope(){return this.m}set target(R){this.B(),this.m=R}get name(){return this.o}set name(R){if(typeof R!="string")throw(0,C.$7)("name");this.B(),this.o=R}get execution(){return this.q}set execution(R){R===null&&(R=void 0),this.B(),this.q=R;const ne=this.l.type;($.g===ne||$.e===ne||$.f===ne||$.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(R){if(Array.isArray(R))this.B(),this.r=R,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(R){R!==!0&&R!==!1&&(R=!1),this.B(),this.u=R}get source(){return this.w}set source(R){if(typeof R!="string"||R.length===0)throw(0,C.$7)("source must be a string of length > 0");this.B(),this.w=R}get group(){return this.x}set group(R){R===null&&(R=void 0),this.B(),this.x=R}get detail(){return this.A}set detail(R){R===null&&(R=void 0),this.A=R}get presentationOptions(){return this.y}set presentationOptions(R){R==null&&(R=Object.create(null)),this.B(),this.y=R}get runOptions(){return this.z}set runOptions(R){R==null&&(R=Object.create(null)),this.B(),this.z=R}};e.$XN=Qt,e.$XN=Qt=$=Le([O],Qt);var rn;(function(L){L[L.SourceControl=1]="SourceControl",L[L.Window=10]="Window",L[L.Notification=15]="Notification"})(rn||(e.ProgressLocation=rn={}));var Zt;(function(L){function R(ne){const ve=ne;return(0,b.$ag)(ve.value)?ve.tooltip&&!(0,b.$9f)(ve.tooltip)?(console.log("INVALID view badge, invalid tooltip",ve.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ve.value),!1)}L.isViewBadge=R})(Zt||(e.ViewBadge=Zt={}));let Xt=k=class{static isTreeItem(R,ne){const ve=R;if(ve.checkboxState!==void 0){const Be=(0,b.$ag)(ve.checkboxState)?ve.checkboxState:(0,b.$$f)(ve.checkboxState)&&(0,b.$ag)(ve.checkboxState.state)?ve.checkboxState.state:void 0,We=!(0,b.$ag)(ve.checkboxState)&&(0,b.$$f)(ve.checkboxState)?ve.checkboxState.tooltip:void 0;if(Be===void 0||Be!==Kt.Checked&&Be!==Kt.Unchecked||We!==void 0&&!(0,b.$9f)(We))return console.log("INVALID tree item, invalid checkboxState",ve.checkboxState),!1}if(R instanceof k)return!0;if(ve.label!==void 0&&!(0,b.$9f)(ve.label)&&!ve.label?.label)return console.log("INVALID tree item, invalid label",ve.label),!1;if(ve.id!==void 0&&!(0,b.$9f)(ve.id))return console.log("INVALID tree item, invalid id",ve.id),!1;if(ve.iconPath!==void 0&&!(0,b.$9f)(ve.iconPath)&&!g.URI.isUri(ve.iconPath)&&(!ve.iconPath||!(0,b.$9f)(ve.iconPath.id))){const Be=ve.iconPath;if(!Be||!(0,b.$9f)(Be.light)&&!g.URI.isUri(Be.light)&&!(0,b.$9f)(Be.dark)&&!g.URI.isUri(Be.dark))return console.log("INVALID tree item, invalid iconPath",ve.iconPath),!1}return ve.description!==void 0&&!(0,b.$9f)(ve.description)&&typeof ve.description!="boolean"?(console.log("INVALID tree item, invalid description",ve.description),!1):ve.resourceUri!==void 0&&!g.URI.isUri(ve.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ve.resourceUri),!1):ve.tooltip!==void 0&&!(0,b.$9f)(ve.tooltip)&&!(ve.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",ve.tooltip),!1):ve.command!==void 0&&!ve.command.command?(console.log("INVALID tree item, invalid command",ve.command),!1):ve.collapsibleState!==void 0&&ve.collapsibleState<St.None&&ve.collapsibleState>St.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ve.collapsibleState),!1):ve.contextValue!==void 0&&!(0,b.$9f)(ve.contextValue)?(console.log("INVALID tree item, invalid contextValue",ve.contextValue),!1):ve.accessibilityInformation!==void 0&&!ve.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ve.accessibilityInformation),!1):!0}constructor(R,ne=St.None){this.collapsibleState=ne,g.URI.isUri(R)?this.resourceUri=R:this.label=R}};e.$YN=Xt,e.$YN=Xt=k=Le([O],Xt);var St;(function(L){L[L.None=0]="None",L[L.Collapsed=1]="Collapsed",L[L.Expanded=2]="Expanded"})(St||(e.TreeItemCollapsibleState=St={}));var Kt;(function(L){L[L.Unchecked=0]="Unchecked",L[L.Checked=1]="Checked"})(Kt||(e.TreeItemCheckboxState=Kt={}));let Yt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(R){this.value=R}};e.$ZN=Yt,e.$ZN=Yt=Le([O],Yt);class sn extends Yt{}e.$1N=sn;class cn extends sn{#e;constructor(R){super(""),this.#e=R}asFile(){return this.#e}}e.$2N=cn;class dn{constructor(R,ne,ve,Be){this.name=R,this.uri=ne,this._itemId=ve,this.c=Be}data(){return this.c()}}e.$3N=dn;let _t=class{#e=new Map;constructor(R){for(const[ne,ve]of R??[]){const Be=this.#e.get(this.#t(ne));Be?Be.push(ve):this.#e.set(this.#t(ne),[ve])}}get(R){return this.#e.get(this.#t(R))?.[0]}set(R,ne){this.#e.set(this.#t(R),[ne])}forEach(R,ne){for(const[ve,Be]of this.#e)for(const We of Be)R.call(ne,We,ve,this)}*[Symbol.iterator](){for(const[R,ne]of this.#e)for(const ve of ne)yield[R,ve]}#t(R){return R.toLowerCase()}};e.$4N=_t,e.$4N=_t=Le([O],_t);let on=class{constructor(R,ne,ve){this.insertText=R,this.title=ne,this.kind=ve}};e.$5N=on,e.$5N=on=Le([O],on);var ln;(function(L){L[L.Automatic=0]="Automatic",L[L.PasteAs=1]="PasteAs"})(ln||(e.DocumentPasteTriggerKind=ln={}));class It{static{this.c="."}constructor(R){this.value=R}append(...R){return new It((this.value?[this.value,...R]:R).join(It.c))}intersects(R){return this.contains(R)||R.contains(this)}contains(R){return this.value===R.value||R.value.startsWith(this.value+It.c)}}e.$6N=It,It.Empty=new It("");class un{constructor(R,ne,ve){this.title=ne,this.insertText=R,this.kind=ve}}e.$7N=un;let wt=class{constructor(R,ne){this.id=R,this.color=ne}static isThemeIcon(R){return typeof R.id!="string"?(console.log("INVALID ThemeIcon, invalid id",R.id),!1):!0}};e.$8N=wt,e.$8N=wt=Le([O],wt),wt.File=new wt("file"),wt.Folder=new wt("folder");let we=class{constructor(R){this.id=R}};e.$9N=we,e.$9N=we=Le([O],we);var Se;(function(L){L[L.Global=1]="Global",L[L.Workspace=2]="Workspace",L[L.WorkspaceFolder=3]="WorkspaceFolder"})(Se||(e.ConfigurationTarget=Se={}));let fe=class{get base(){return this.c}set base(R){this.c=R,this.e=g.URI.file(R)}get baseUri(){return this.e}set baseUri(R){this.e=R,this.c=R.fsPath}constructor(R,ne){if(typeof R!="string"&&(!R||!g.URI.isUri(R)&&!g.URI.isUri(R.uri)))throw(0,C.$7)("base");if(typeof ne!="string")throw(0,C.$7)("pattern");typeof R=="string"?this.baseUri=g.URI.file(R):g.URI.isUri(R)?this.baseUri=R:this.baseUri=R.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$0N=fe,e.$0N=fe=Le([O],fe);const H=new WeakMap;function ke(L,R){H.set(L,R)}let Oe=class{constructor(R,ne,ve,Be,We){this.enabled=typeof R=="boolean"?R:!0,typeof ne=="string"&&(this.condition=ne),typeof ve=="string"&&(this.hitCondition=ve),typeof Be=="string"&&(this.logMessage=Be),typeof We=="string"&&(this.mode=We)}get id(){return this.c||(this.c=H.get(this)??(0,y.$Sg)()),this.c}};e.$_N=Oe,e.$_N=Oe=Le([O],Oe);let qe=class extends Oe{constructor(R,ne,ve,Be,We,Ye){if(super(ne,ve,Be,We,Ye),R===null)throw(0,C.$7)("location");this.location=R}};e.$aO=qe,e.$aO=qe=Le([O],qe);let ze=class extends Oe{constructor(R,ne,ve,Be,We,Ye){super(ne,ve,Be,We,Ye),this.functionName=R}};e.$bO=ze,e.$bO=ze=Le([O],ze);let Xe=class extends Oe{constructor(R,ne,ve,Be,We,Ye,tt,ut){if(super(Be,We,Ye,tt,ut),!ne)throw(0,C.$7)("dataId");this.label=R,this.dataId=ne,this.canPersist=ve}};e.$cO=Xe,e.$cO=Xe=Le([O],Xe);let st=class{constructor(R,ne,ve){this.command=R,this.args=ne||[],this.options=ve}};e.$dO=st,e.$dO=st=Le([O],st);let ft=class{constructor(R,ne){this.port=R,this.host=ne}};e.$eO=ft,e.$eO=ft=Le([O],ft);let pt=class{constructor(R){this.path=R}};e.$fO=pt,e.$fO=pt=Le([O],pt);let ct=class{constructor(R){this.implementation=R}};e.$gO=ct,e.$gO=ct=Le([O],ct);class vt{constructor(R,ne,ve){this.session=R,this.threadId=ne,this.frameId=ve}}e.$hO=vt;class yi{constructor(R,ne){this.session=R,this.threadId=ne}}e.$iO=yi;let pn=class{constructor(R,ne){this.range=R,this.expression=ne}};e.$jO=pn,e.$jO=pn=Le([O],pn);var Rn;(function(L){L[L.Invoke=0]="Invoke",L[L.Automatic=1]="Automatic"})(Rn||(e.InlineCompletionTriggerKind=Rn={}));let bn=class{constructor(R,ne){this.range=R,this.text=ne}};e.$kO=bn,e.$kO=bn=Le([O],bn);let wn=class{constructor(R,ne,ve=!0){this.range=R,this.variableName=ne,this.caseSensitiveLookup=ve}};e.$lO=wn,e.$lO=wn=Le([O],wn);let vn=class{constructor(R,ne){this.range=R,this.expression=ne}};e.$mO=vn,e.$mO=vn=Le([O],vn);let yn=class{constructor(R,ne){this.frameId=R,this.stoppedLocation=ne}};e.$nO=yn,e.$nO=yn=Le([O],yn);var Fn;(function(L){L[L.AIGenerated=1]="AIGenerated"})(Fn||(e.NewSymbolNameTag=Fn={}));var Ln;(function(L){L[L.Invoke=0]="Invoke",L[L.Automatic=1]="Automatic"})(Ln||(e.NewSymbolNameTriggerKind=Ln={}));class Ei{constructor(R,ne){this.newSymbolName=R,this.tags=ne}}e.$oO=Ei;var Tn;(function(L){L[L.Changed=1]="Changed",L[L.Created=2]="Created",L[L.Deleted=3]="Deleted"})(Tn||(e.FileChangeType=Tn={}));let En=j=class extends Error{static FileExists(R){return new j(R,w.FileSystemProviderErrorCode.FileExists,j.FileExists)}static FileNotFound(R){return new j(R,w.FileSystemProviderErrorCode.FileNotFound,j.FileNotFound)}static FileNotADirectory(R){return new j(R,w.FileSystemProviderErrorCode.FileNotADirectory,j.FileNotADirectory)}static FileIsADirectory(R){return new j(R,w.FileSystemProviderErrorCode.FileIsADirectory,j.FileIsADirectory)}static NoPermissions(R){return new j(R,w.FileSystemProviderErrorCode.NoPermissions,j.NoPermissions)}static Unavailable(R){return new j(R,w.FileSystemProviderErrorCode.Unavailable,j.Unavailable)}constructor(R,ne=w.FileSystemProviderErrorCode.Unknown,ve){super(g.URI.isUri(R)?R.toString(!0):R),this.code=ve?.name??"Unknown",(0,w.$fl)(this,ne),Object.setPrototypeOf(this,j.prototype),typeof Error.captureStackTrace=="function"&&typeof ve=="function"&&Error.captureStackTrace(this,ve)}};e.$pO=En,e.$pO=En=j=Le([O],En);let kn=class{constructor(R,ne,ve){this.start=R,this.end=ne,this.kind=ve}};e.$qO=kn,e.$qO=kn=Le([O],kn);var Mn;(function(L){L[L.Comment=1]="Comment",L[L.Imports=2]="Imports",L[L.Region=3]="Region"})(Mn||(e.FoldingRangeKind=Mn={}));var zn;(function(L){L[L.Collapsed=0]="Collapsed",L[L.Expanded=1]="Expanded"})(zn||(e.CommentThreadCollapsibleState=zn={}));var Bn;(function(L){L[L.Editing=0]="Editing",L[L.Preview=1]="Preview"})(Bn||(e.CommentMode=Bn={}));var qn;(function(L){L[L.Published=0]="Published",L[L.Draft=1]="Draft"})(qn||(e.CommentState=qn={}));var Qn;(function(L){L[L.Unresolved=0]="Unresolved",L[L.Resolved=1]="Resolved"})(Qn||(e.CommentThreadState=Qn={}));var Vn;(function(L){L[L.Current=0]="Current",L[L.Outdated=1]="Outdated"})(Vn||(e.CommentThreadApplicability=Vn={}));class ki{constructor(R,ne=[]){this.tokenTypes=R,this.tokenModifiers=ne}}e.$rO=ki;function Di(L){return typeof L>"u"||(0,b.$0f)(L)}class Dn{constructor(R){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,R){this.m=!0;for(let ne=0,ve=R.tokenTypes.length;ne<ve;ne++)this.k.set(R.tokenTypes[ne],ne);for(let ne=0,ve=R.tokenModifiers.length;ne<ve;ne++)this.l.set(R.tokenModifiers[ne],ne)}}push(R,ne,ve,Be,We){if(typeof R=="number"&&typeof ne=="number"&&typeof ve=="number"&&typeof Be=="number"&&(typeof We=="number"||typeof We>"u"))return typeof We>"u"&&(We=0),this.q(R,ne,ve,Be,We);if(le.isRange(R)&&typeof ne=="string"&&Di(ve))return this.o(R,ne,ve);throw(0,C.$7)()}o(R,ne,ve){if(!this.m)throw new Error("Legend must be provided in constructor");if(R.start.line!==R.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Be=R.start.line,We=R.start.character,Ye=R.end.character-R.start.character,tt=this.k.get(ne);let ut=0;if(ve)for(const yt of ve){if(!this.l.has(yt))throw new Error("`tokenModifier` is not in the provided legend");const Et=this.l.get(yt);ut|=1<<Et>>>0}this.q(Be,We,Ye,tt,ut)}q(R,ne,ve,Be,We){if(this.f&&(R<this.c||R===this.c&&ne<this.e)){this.f=!1;const ut=this.g.length/5|0;let yt=0,Et=0;for(let jt=0;jt<ut;jt++){let Ft=this.g[5*jt],hn=this.g[5*jt+1];Ft===0?(Ft=yt,hn+=Et):Ft+=yt,this.g[5*jt]=Ft,this.g[5*jt+1]=hn,yt=Ft,Et=hn}}let Ye=R,tt=ne;this.f&&this.j>0&&(Ye-=this.c,Ye===0&&(tt-=this.e)),this.g[this.j++]=Ye,this.g[this.j++]=tt,this.g[this.j++]=ve,this.g[this.j++]=Be,this.g[this.j++]=We,this.c=R,this.e=ne}static r(R){const ne=[],ve=R.length/5|0;for(let tt=0;tt<ve;tt++)ne[tt]=tt;ne.sort((tt,ut)=>{const yt=R[5*tt],Et=R[5*ut];if(yt===Et){const jt=R[5*tt+1],Ft=R[5*ut+1];return jt-Ft}return yt-Et});const Be=new Uint32Array(R.length);let We=0,Ye=0;for(let tt=0;tt<ve;tt++){const ut=5*ne[tt],yt=R[ut+0],Et=R[ut+1],jt=R[ut+2],Ft=R[ut+3],hn=R[ut+4],vi=yt-We,fr=vi===0?Et-Ye:Et,fn=5*tt;Be[fn+0]=vi,Be[fn+1]=fr,Be[fn+2]=jt,Be[fn+3]=Ft,Be[fn+4]=hn,We=yt,Ye=Et}return Be}build(R){return this.f?new Pn(new Uint32Array(this.g),R):new Pn(Dn.r(this.g),R)}}e.$sO=Dn;class Pn{constructor(R,ne){this.resultId=ne,this.data=R}}e.$tO=Pn;class Pi{constructor(R,ne,ve){this.start=R,this.deleteCount=ne,this.data=ve}}e.$uO=Pi;class Si{constructor(R,ne){this.resultId=ne,this.edits=R}}e.$vO=Si;var Un;(function(L){L[L.Separate=0]="Separate",L[L.MergeWithParent=1]="MergeWithParent"})(Un||(e.DebugConsoleMode=Un={}));class Ii{constructor(R){this.name=R}}e.$wO=Ii;let Sn=class{static{this.Back={iconPath:new wt("arrow-left")}}constructor(){}};e.$xO=Sn,e.$xO=Sn=Le([O],Sn);var Hn;(function(L){L[L.Separator=-1]="Separator",L[L.Default=0]="Default"})(Hn||(e.QuickPickItemKind=Hn={}));var Wn;(function(L){L[L.Info=1]="Info",L[L.Warning=2]="Warning",L[L.Error=3]="Error"})(Wn||(e.InputBoxValidationSeverity=Wn={}));var Gn;(function(L){L[L.UI=1]="UI",L[L.Workspace=2]="Workspace"})(Gn||(e.ExtensionKind=Gn={}));class Ci{static validate(R){if(typeof R.badge=="string"){let ne=(0,P.$If)(R.badge,0);if(ne<R.badge.length&&(ne+=(0,P.$If)(R.badge,ne)),R.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(R.badge&&!wt.isThemeIcon(R.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!R.color&&!R.badge&&!R.tooltip)throw new Error("The decoration is empty");return!0}constructor(R,ne,ve){this.badge=R,this.tooltip=ne,this.color=ve}}e.$yO=Ci;let In=class{constructor(R){this.kind=R}};e.$zO=In,e.$zO=In=Le([O],In);var xn;(function(L){L[L.Light=1]="Light",L[L.Dark=2]="Dark",L[L.HighContrast=3]="HighContrast",L[L.HighContrastLight=4]="HighContrastLight"})(xn||(e.ColorThemeKind=xn={}));class Vt{static isNotebookRange(R){return R instanceof Vt?!0:R?typeof R.start=="number"&&typeof R.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(R,ne){if(R<0)throw(0,C.$7)("start must be positive");if(ne<0)throw(0,C.$7)("end must be positive");R<=ne?(this.c=R,this.e=ne):(this.c=ne,this.e=R)}with(R){let ne=this.c,ve=this.e;return R.start!==void 0&&(ne=R.start),R.end!==void 0&&(ve=R.end),ne===this.c&&ve===this.e?this:new Vt(ne,ve)}}e.$AO=Vt;class mn{static validate(R){if(typeof R.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof R.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof R.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(R){return Array.isArray(R)&&R.every(ne=>mn.isNotebookCellData(ne))}static isNotebookCellData(R){return!0}constructor(R,ne,ve,Be,We,Ye,tt){this.kind=R,this.value=ne,this.languageId=ve,this.mime=Be,this.outputs=We??[],this.metadata=Ye,this.executionSummary=tt,mn.validate(this)}}e.$BO=mn;class ji{constructor(R){this.cells=R}}e.$CO=ji;class Ct{static isNotebookCellOutputItem(R){return R instanceof Ct?!0:R?typeof R.mime=="string"&&R.data instanceof Uint8Array:!1}static error(R){const ne={name:R.name,message:R.message,stack:R.stack};return Ct.json(ne,"application/vnd.code.notebook.error")}static stdout(R){return Ct.text(R,"application/vnd.code.notebook.stdout")}static stderr(R){return Ct.text(R,"application/vnd.code.notebook.stderr")}static bytes(R,ne="application/octet-stream"){return new Ct(R,ne)}static#e=new TextEncoder;static text(R,ne=I.$Qs.text){const ve=Ct.#e.encode(String(R));return new Ct(ve,ne)}static json(R,ne="text/x-json"){const ve=JSON.stringify(R,void 0,"	");return Ct.text(ve,ne)}constructor(R,ne){this.data=R,this.mime=ne;const ve=(0,I.$Us)(ne,!0);if(!ve)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ve}}e.$DO=Ct;class gn{static isNotebookCellOutput(R){return R instanceof gn?!0:!R||typeof R!="object"?!1:typeof R.id=="string"&&Array.isArray(R.items)}static ensureUniqueMimeTypes(R,ne=!1){const ve=new Set,Be=new Set;for(let We=0;We<R.length;We++){const Ye=R[We],tt=(0,I.$Us)(Ye.mime);if(!ve.has(tt)||(0,u.$6K)(tt)){ve.add(tt);continue}Be.add(We),ne&&console.warn(`DUPLICATED mime type '${Ye.mime}' will be dropped`)}return Be.size===0?R:R.filter((We,Ye)=>!Be.has(Ye))}constructor(R,ne,ve){this.items=gn.ensureUniqueMimeTypes(R,!0),typeof ne=="string"?(this.id=ne,this.metadata=ve):(this.id=(0,y.$Sg)(),this.metadata=ne??ve)}}e.$EO=gn;var Jn;(function(L){L[L.Markup=1]="Markup",L[L.Code=2]="Code"})(Jn||(e.NotebookCellKind=Jn={}));var Zn;(function(L){L[L.Idle=1]="Idle",L[L.Pending=2]="Pending",L[L.Executing=3]="Executing"})(Zn||(e.NotebookCellExecutionState=Zn={}));var Xn;(function(L){L[L.Left=1]="Left",L[L.Right=2]="Right"})(Xn||(e.NotebookCellStatusBarAlignment=Xn={}));var Kn;(function(L){L[L.Default=0]="Default",L[L.InCenter=1]="InCenter",L[L.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",L[L.AtTop=3]="AtTop"})(Kn||(e.NotebookEditorRevealType=Kn={}));class Ai{constructor(R,ne){this.text=R,this.alignment=ne}}e.$FO=Ai;var Yn;(function(L){L[L.Default=1]="Default",L[L.Preferred=2]="Preferred"})(Yn||(e.NotebookControllerAffinity=Yn={}));var _n;(function(L){L[L.Default=1]="Default",L[L.Preferred=2]="Preferred",L[L.Hidden=-1]="Hidden"})(_n||(e.NotebookControllerAffinity2=_n={}));class Oi{constructor(R,ne=[]){this.uri=R,this.provides=(0,o.$3b)(ne)}}e.$GO=Oi;class Ni{constructor(R){this.label=R}}e.$HO=Ni;var ei;(function(L){L[L.Named=1]="Named",L[L.Indexed=2]="Indexed"})(ei||(e.NotebookVariablesRequestKind=ei={}));let Cn=class{constructor(R,ne){this.label=R,this.timestamp=ne}};e.$IO=Cn,e.$IO=Cn=Le([O],Cn);var ti;(function(L){L[L.Production=1]="Production",L[L.Development=2]="Development",L[L.Test=3]="Test"})(ti||(e.ExtensionMode=ti={}));var ni;(function(L){L[L.Node=1]="Node",L[L.Webworker=2]="Webworker"})(ni||(e.ExtensionRuntime=ni={}));var ii;(function(L){L[L.Other=0]="Other",L[L.Comment=1]="Comment",L[L.String=2]="String",L[L.RegEx=3]="RegEx"})(ii||(e.StandardTokenType=ii={}));class Ri{constructor(R,ne){this.ranges=R,this.wordPattern=ne}}e.$JO=Ri;class Fi{constructor(R){this.c=R}get autoForwardAction(){return this.c}}e.$KO=Fi;var ri;(function(L){L[L.Queued=1]="Queued",L[L.Running=2]="Running",L[L.Passed=3]="Passed",L[L.Failed=4]="Failed",L[L.Skipped=5]="Skipped",L[L.Errored=6]="Errored"})(ri||(e.TestResultState=ri={}));var si;(function(L){L[L.Run=1]="Run",L[L.Debug=2]="Debug",L[L.Coverage=3]="Coverage"})(si||(e.TestRunProfileKind=si={}));let jn=class{constructor(R=void 0,ne=void 0,ve=void 0,Be=!1,We=!0){this.include=R,this.exclude=ne,this.profile=ve,this.continuous=Be,this.preserveFocus=We}};e.$LO=jn,e.$LO=jn=Le([O],jn);let An=A=class{static diff(R,ne,ve){const Be=new A(R);return Be.expectedOutput=ne,Be.actualOutput=ve,Be}constructor(R){this.message=R}};e.$MO=An,e.$MO=An=A=Le([O],An);let On=class{constructor(R){this.id=R}};e.$NO=On,e.$NO=On=Le([O],On);class $n{constructor(R,ne){this.covered=R,this.total=ne,oi(this)}}e.$OO=$n;function oi(L){if(L){if(L.covered>L.total)throw new Error(`The total number of covered items (${L.covered}) cannot be greater than the total (${L.total})`);if(L.total<0)throw new Error(`The number of covered items (${L.total}) cannot be negative`)}}class Nn{static fromDetails(R,ne){const ve=new $n(0,0),Be=new $n(0,0),We=new $n(0,0);for(const tt of ne)if("branches"in tt){ve.total+=1,ve.covered+=tt.executed?1:0;for(const ut of tt.branches)Be.total+=1,Be.covered+=ut.executed?1:0}else We.total+=1,We.covered+=tt.executed?1:0;const Ye=new Nn(R,ve,Be.total>0?Be:void 0,We.total>0?We:void 0);return Ye.detailedCoverage=ne,Ye}constructor(R,ne,ve,Be){this.uri=R,this.statementCoverage=ne,this.branchCoverage=ve,this.declarationCoverage=Be}}e.$QO=Nn;class Li{get executionCount(){return+this.executed}set executionCount(R){this.executed=R}constructor(R,ne,ve=[]){this.executed=R,this.location=ne,this.branches=ve}}e.$RO=Li;class Ti{get executionCount(){return+this.executed}set executionCount(R){this.executed=R}constructor(R,ne,ve){this.executed=R,this.location=ne,this.label=ve}}e.$SO=Ti;class Mi{get executionCount(){return+this.executed}set executionCount(R){this.executed=R}constructor(R,ne,ve){this.name=R,this.executed=ne,this.location=ve}}e.$TO=Mi;var ai;(function(L){L[L.None=0]="None",L[L.Option=1]="Option",L[L.Default=2]="Default",L[L.Preferred=3]="Preferred"})(ai||(e.ExternalUriOpenerPriority=ai={}));var ci;(function(L){L[L.Untrusted=0]="Untrusted",L[L.Trusted=1]="Trusted",L[L.Unspecified=2]="Unspecified"})(ci||(e.WorkspaceTrustState=ci={}));var li;(function(L){L[L.Notify=1]="Notify",L[L.OpenBrowser=2]="OpenBrowser",L[L.OpenPreview=3]="OpenPreview",L[L.Silent=4]="Silent",L[L.Ignore=5]="Ignore",L[L.OpenBrowserOnce=6]="OpenBrowserOnce"})(li||(e.PortAutoForwardAction=li={}));class zi{constructor(R,ne,ve,Be,We,Ye){this.kind=R,this.name=ne,this.detail=ve,this.uri=Be,this.range=We,this.selectionRange=Ye}}e.$UO=zi;class Bi{constructor(R){this.uri=R}}e.$VO=Bi;class qi{constructor(R,ne){this.original=R,this.modified=ne}}e.$WO=qi;class Qi{constructor(R,ne,ve,Be){this.base=R,this.input1=ne,this.input2=ve,this.result=Be}}e.$XO=Qi;class Vi{constructor(R,ne){this.uri=R,this.viewType=ne}}e.$YO=Vi;class Ui{constructor(R){this.viewType=R}}e.$ZO=Ui;class Hi{constructor(R,ne){this.uri=R,this.notebookType=ne}}e.$1O=Hi;class Wi{constructor(R,ne,ve){this.original=R,this.modified=ne,this.notebookType=ve}}e.$2O=Wi;class Gi{constructor(){}}e.$3O=Gi;class xi{constructor(R,ne){this.uri=R,this.inputBoxUri=ne}}e.$4O=xi;class Ji{constructor(){}}e.$5O=Ji;class Zi{constructor(R){this.textDiffs=R}}e.$6O=Zi;var ui;(function(L){L[L.Down=0]="Down",L[L.Up=1]="Up"})(ui||(e.InteractiveSessionVoteDirection=ui={}));var hi;(function(L){L[L.Action=1]="Action",L[L.Toolbar=2]="Toolbar"})(hi||(e.ChatCopyKind=hi={}));var fi;(function(L){L[L.Short=1]="Short",L[L.Medium=2]="Medium",L[L.Full=3]="Full"})(fi||(e.ChatVariableLevel=fi={}));class Xi{constructor(R,ne){this.label=R,this.values=ne}}e.$7O=Xi;var di;(function(L){L[L.Unhelpful=0]="Unhelpful",L[L.Helpful=1]="Helpful",L[L.Undone=2]="Undone",L[L.Accepted=3]="Accepted",L[L.Bug=4]="Bug"})(di||(e.InteractiveEditorResponseFeedbackKind=di={}));var mi;(function(L){L[L.Unhelpful=0]="Unhelpful",L[L.Helpful=1]="Helpful"})(mi||(e.ChatResultFeedbackKind=mi={}));class Ki{constructor(R){if(typeof R!="string"&&R.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof R=="string"?new Ge(R):R}}e.$8O=Ki;class Yi{constructor(R,ne){if(typeof R!="string"&&R.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof R=="string"?new Ge(R):R,this.vulnerabilities=ne}}e.$9O=Yi;class _i{constructor(R,ne){this.participant=R,this.command=ne}}e.$0O=_i;class er{constructor(R,ne){this.value=R,this.baseUri=ne}}e.$$O=er;class tr{constructor(R,ne){this.value=R,this.title=ne}}e.$_O=tr;class nr{constructor(R){this.value=R}}e.$aP=nr;class ir{constructor(R){this.value=R}}e.$bP=ir;class rr{constructor(R,ne){this.value=R,this.iconPath=ne}}e.$cP=rr;class sr{constructor(R,ne){this.uri=R,this.edits=Array.isArray(ne)?ne:[ne]}}e.$dP=sr;class or{constructor(R,ne,ve,Be){this.prompt=R,this.command=ne,this.variables=ve,this.participant=Be}}e.$eP=or;class ar{constructor(R,ne,ve,Be){this.response=R,this.result=ne,this.participant=ve,this.command=Be}}e.$fP=ar;var gi;(function(L){L[L.Panel=1]="Panel",L[L.Terminal=2]="Terminal",L[L.Notebook=3]="Notebook",L[L.Editor=4]="Editor"})(gi||(e.ChatLocation=gi={}));class cr{constructor(R){this.content=R}}e.$gP=cr;class lr{constructor(R,ne){this.content=R,this.name=ne}}e.$hP=lr;class ur{constructor(R,ne){this.content=R,this.name=ne}}e.$iP=ur;class an extends Error{static NotFound(R){return new an(R,an.NotFound.name)}static NoPermissions(R){return new an(R,an.NoPermissions.name)}constructor(R,ne,ve){super(R,{cause:ve}),this.name="LanguageModelError",this.code=ne??""}}e.$jP=an;var $i;(function(L){L[L.SymbolInformation=1]="SymbolInformation",L[L.CommandInformation=2]="CommandInformation",L[L.SearchInformation=3]="SearchInformation",L[L.SettingInformation=4]="SettingInformation"})($i||(e.RelatedInformationType=$i={}));var pi;(function(L){L[L.Started=1]="Started",L[L.Recognizing=2]="Recognizing",L[L.Recognized=3]="Recognized",L[L.Stopped=4]="Stopped",L[L.Error=5]="Error"})(pi||(e.SpeechToTextStatus=pi={}));var bi;(function(L){L[L.Recognized=1]="Recognized",L[L.Stopped=2]="Stopped"})(bi||(e.KeywordRecognitionStatus=bi={}));class hr{constructor(R,ne){this.text=R,this.range=ne}}e.$kP=hr;var wi;(function(L){L[L.Invoke=0]="Invoke",L[L.Automatic=1]="Automatic"})(wi||(e.InlineEditTriggerKind=wi={}))}),define(ye[142],Ee([1,0,18,15,163,75,101,24,150,54,65,21,156,19,10,4,45,185,243,136,94,283,140,72,95,138,141,76]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h,t,s,r,i,n,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$tP=W,e.$uP=Y,e.$vP=M;var $;(function(we){function Se(H){const{selectionStartLineNumber:ke,selectionStartColumn:Oe,positionLineNumber:qe,positionColumn:ze}=H,Xe=new n.$_M(ke-1,Oe-1),st=new n.$_M(qe-1,ze-1);return new n.$bN(Xe,st)}we.to=Se;function fe(H){const{anchor:ke,active:Oe}=H;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Oe.line+1,positionColumn:Oe.character+1}}we.from=fe})($||(e.Selection=$={}));var k;(function(we){function Se(H){if(!H)return;const{start:ke,end:Oe}=H;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Oe.line+1,endColumn:Oe.character+1}}we.from=Se;function fe(H){if(!H)return;const{startLineNumber:ke,startColumn:Oe,endLineNumber:qe,endColumn:ze}=H;return new n.$aN(ke-1,Oe-1,qe-1,ze-1)}we.to=fe})(k||(e.Range=k={}));var j;(function(we){function Se(H){return{uri:H.uri,range:k.from(H.range)}}we.from=Se;function fe(H){return new n.$kN(a.URI.revive(H.uri),k.to(H.range))}we.to=fe})(j||(e.Location=j={}));var A;(function(we){function Se(fe){switch(fe){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}we.to=Se})(A||(e.TokenType=A={}));var O;(function(we){function Se(H){return new n.$_M(H.lineNumber-1,H.column-1)}we.to=Se;function fe(H){return{lineNumber:H.line+1,column:H.character+1}}we.from=fe})(O||(e.Position=O={}));var F;(function(we){function Se(ke,Oe,qe){return(0,o.$Hb)((0,o.$3b)(ke).map(ze=>fe(ze,Oe,qe)))}we.from=Se;function fe(ke,Oe,qe){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:qe?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:H(ke.scheme,Oe),pattern:Je.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:qe?.isBuiltin}}function H(ke,Oe){return Oe&&typeof ke=="string"?Oe.transformOutgoingScheme(ke):ke}})(F||(e.DocumentSelector=F={}));var V;(function(we){function Se(H){switch(H){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}we.from=Se;function fe(H){switch(H){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}we.to=fe})(V||(e.DiagnosticTag=V={}));var Z;(function(we){function Se(H){let ke;return H.code&&((0,u.$9f)(H.code)||(0,u.$ag)(H.code)?ke=String(H.code):ke={value:String(H.code.value),target:H.code.target}),{...k.from(H.range),message:H.message,source:H.source,code:ke,severity:le.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(oe.from),tags:Array.isArray(H.tags)?(0,o.$Hb)(H.tags.map(V.from)):void 0}}we.from=Se;function fe(H){const ke=new n.$mN(k.to(H),H.message,le.to(H.severity));return ke.source=H.source,ke.code=(0,u.$9f)(H.code)?H.code:H.code?.value,ke.relatedInformation=H.relatedInformation&&H.relatedInformation.map(oe.to),ke.tags=H.tags&&(0,o.$Hb)(H.tags.map(V.to)),ke}we.to=fe})(Z||(e.Diagnostic=Z={}));var oe;(function(we){function Se(H){return{...k.from(H.location.range),message:H.message,resource:H.location.uri}}we.from=Se;function fe(H){return new n.$lN(new n.$kN(H.resource,k.to(H)),H.message)}we.to=fe})(oe||(e.DiagnosticRelatedInformation=oe={}));var le;(function(we){function Se(H){switch(H){case n.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}we.from=Se;function fe(H){switch(H){case d.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}we.to=fe})(le||(e.DiagnosticSeverity=le={}));var te;(function(we){function Se(H){return typeof H=="number"&&H>=n.ViewColumn.One?H-1:H===n.ViewColumn.Beside?i.$4D:i.$3D}we.from=Se;function fe(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=fe})(te||(e.ViewColumn=te={}));function _(we){return typeof we.range<"u"}function W(we){return we.length===0?!0:!!_(we[0])}var K;(function(we){function Se(ze){return ze.map(we.from)}we.fromMany=Se;function fe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function H(ze){let Xe;if(fe(ze)){const{language:ct,value:vt}=ze;Xe={value:"```"+ct+`
`+vt+"\n```\n"}}else n.$AN.isMarkdownString(ze)?Xe={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons,supportHtml:ze.supportHtml,baseUri:ze.baseUri}:typeof ze=="string"?Xe={value:ze}:Xe={value:""};const st=Object.create(null);Xe.uris=st;const ft=ct=>{try{let vt=a.URI.parse(ct,!0);vt=vt.with({query:ke(vt.query,st)}),st[ct]=vt}catch{}return""},pt=new b.marked.Renderer;return pt.link=ft,pt.image=ct=>typeof ct=="string"?ft(I.$2k(ct).href):"",(0,b.marked)(Xe.value,{renderer:pt}),Xe}we.from=H;function ke(ze,Xe){if(!ze)return ze;let st;try{st=(0,g.$5h)(ze)}catch{}if(!st)return ze;let ft=!1;return st=(0,v.$5n)(st,pt=>{if(a.URI.isUri(pt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return Xe[ct]=pt,ft=!0,ct}else return}),ft?JSON.stringify(st):ze}function Oe(ze){const Xe=new n.$AN(ze.value,ze.supportThemeIcons);return Xe.isTrusted=ze.isTrusted,Xe.supportHtml=ze.supportHtml,Xe.baseUri=ze.baseUri?a.URI.from(ze.baseUri):void 0,Xe}we.to=Oe;function qe(ze){if(ze)return typeof ze=="string"?ze:we.from(ze)}we.fromStrict=qe})(K||(e.MarkdownString=K={}));function Y(we){return W(we)?we.map(Se=>({range:k.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):we.map(Se=>({range:k.from(Se)}))}function M(we){return typeof we>"u"?we:typeof we=="string"?a.URI.file(we):we}var Q;(function(we){function Se(fe){return typeof fe>"u"?fe:{contentText:fe.contentText,contentIconPath:fe.contentIconPath?M(fe.contentIconPath):void 0,border:fe.border,borderColor:fe.borderColor,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,color:fe.color,backgroundColor:fe.backgroundColor,margin:fe.margin,width:fe.width,height:fe.height}}we.from=Se})(Q||(e.ThemableDecorationAttachmentRenderOptions=Q={}));var ce;(function(we){function Se(fe){return typeof fe>"u"?fe:{backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?M(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Q.from(fe.before):void 0,after:fe.after?Q.from(fe.after):void 0}}we.from=Se})(ce||(e.ThemableDecorationRenderOptions=ce={}));var ie;(function(we){function Se(fe){if(typeof fe>"u")return fe;switch(fe){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=Se})(ie||(e.DecorationRangeBehavior=ie={}));var be;(function(we){function Se(fe){return{isWholeLine:fe.isWholeLine,rangeBehavior:fe.rangeBehavior?ie.from(fe.rangeBehavior):void 0,overviewRulerLane:fe.overviewRulerLane,light:fe.light?ce.from(fe.light):void 0,dark:fe.dark?ce.from(fe.dark):void 0,backgroundColor:fe.backgroundColor,outline:fe.outline,outlineColor:fe.outlineColor,outlineStyle:fe.outlineStyle,outlineWidth:fe.outlineWidth,border:fe.border,borderColor:fe.borderColor,borderRadius:fe.borderRadius,borderSpacing:fe.borderSpacing,borderStyle:fe.borderStyle,borderWidth:fe.borderWidth,fontStyle:fe.fontStyle,fontWeight:fe.fontWeight,textDecoration:fe.textDecoration,cursor:fe.cursor,color:fe.color,opacity:fe.opacity,letterSpacing:fe.letterSpacing,gutterIconPath:fe.gutterIconPath?M(fe.gutterIconPath):void 0,gutterIconSize:fe.gutterIconSize,overviewRulerColor:fe.overviewRulerColor,before:fe.before?Q.from(fe.before):void 0,after:fe.after?Q.from(fe.after):void 0}}we.from=Se})(be||(e.DecorationRenderOptions=be={}));var re;(function(we){function Se(H){return{text:H.newText,eol:H.newEol&&Re.from(H.newEol),range:k.from(H.range)}}we.from=Se;function fe(H){const ke=new n.$fN(k.to(H.range),H.text);return ke.newEol=typeof H.eol>"u"?void 0:Re.to(H.eol),ke}we.to=fe})(re||(e.TextEdit=re={}));var X;(function(we){function Se(H,ke){const Oe={edits:[]};if(H instanceof n.$iN){const qe=new P.$Cc;for(const ze of H._allEntries())ze._type===1&&a.URI.isUri(ze.to)&&ze.from===void 0&&qe.add(ze.to);for(const ze of H._allEntries())if(ze._type===1){let Xe;ze.options?.contents&&(ArrayBuffer.isView(ze.options.contents)?Xe={type:"base64",value:(0,C.$1e)(C.$Ge.wrap(ze.options.contents))}:Xe={type:"dataTransferItem",id:ze.options.contents._itemId}),Oe.edits.push({oldResource:ze.from,newResource:ze.to,options:{...ze.options,contents:Xe},metadata:ze.metadata})}else ze._type===2?Oe.edits.push({resource:ze.uri,textEdit:re.from(ze.edit),versionId:qe.has(ze.uri)?void 0:ke?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===6?Oe.edits.push({resource:ze.uri,textEdit:{range:k.from(ze.range),text:ze.edit.value,insertAsSnippet:!0},versionId:qe.has(ze.uri)?void 0:ke?.getTextDocumentVersion(ze.uri),metadata:ze.metadata}):ze._type===3?Oe.edits.push({metadata:ze.metadata,resource:ze.uri,cellEdit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(ze.uri)}):ze._type===5&&Oe.edits.push({metadata:ze.metadata,resource:ze.uri,notebookVersionId:ke?.getNotebookDocumentVersion(ze.uri),cellEdit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(kt.from)}})}return Oe}we.from=Se;function fe(H){const ke=new n.$iN,Oe=new P.$Bc;for(const qe of H.edits)if(qe.textEdit){const ze=qe,Xe=a.URI.revive(ze.resource),st=k.to(ze.textEdit.range),ft=ze.textEdit.text,pt=ze.textEdit.insertAsSnippet;let ct;pt?ct=n.$hN.replace(st,new n.$jN(ft)):ct=n.$fN.replace(st,ft);const vt=Oe.get(Xe);vt?vt.push(ct):Oe.set(Xe,[ct])}else ke.renameFile(a.URI.revive(qe.oldResource),a.URI.revive(qe.newResource),qe.options);for(const[qe,ze]of Oe)ke.set(qe,ze);return ke}we.to=fe})(X||(e.WorkspaceEdit=X={}));var B;(function(we){const Se=Object.create(null);Se[n.SymbolKind.File]=0,Se[n.SymbolKind.Module]=1,Se[n.SymbolKind.Namespace]=2,Se[n.SymbolKind.Package]=3,Se[n.SymbolKind.Class]=4,Se[n.SymbolKind.Method]=5,Se[n.SymbolKind.Property]=6,Se[n.SymbolKind.Field]=7,Se[n.SymbolKind.Constructor]=8,Se[n.SymbolKind.Enum]=9,Se[n.SymbolKind.Interface]=10,Se[n.SymbolKind.Function]=11,Se[n.SymbolKind.Variable]=12,Se[n.SymbolKind.Constant]=13,Se[n.SymbolKind.String]=14,Se[n.SymbolKind.Number]=15,Se[n.SymbolKind.Boolean]=16,Se[n.SymbolKind.Array]=17,Se[n.SymbolKind.Object]=18,Se[n.SymbolKind.Key]=19,Se[n.SymbolKind.Null]=20,Se[n.SymbolKind.EnumMember]=21,Se[n.SymbolKind.Struct]=22,Se[n.SymbolKind.Event]=23,Se[n.SymbolKind.Operator]=24,Se[n.SymbolKind.TypeParameter]=25;function fe(ke){return typeof Se[ke]=="number"?Se[ke]:6}we.from=fe;function H(ke){for(const Oe in Se)if(Se[Oe]===ke)return Number(Oe);return n.SymbolKind.Property}we.to=H})(B||(e.SymbolKind=B={}));var N;(function(we){function Se(H){switch(H){case n.SymbolTag.Deprecated:return 1}}we.from=Se;function fe(H){switch(H){case 1:return n.SymbolTag.Deprecated}}we.to=fe})(N||(e.SymbolTag=N={}));var z;(function(we){function Se(H){return{name:H.name,kind:B.from(H.kind),tags:H.tags&&H.tags.map(N.from),containerName:H.containerName,location:U.from(H.location)}}we.from=Se;function fe(H){const ke=new n.$rN(H.name,B.to(H.kind),H.containerName,U.to(H.location));return ke.tags=H.tags&&H.tags.map(N.to),ke}we.to=fe})(z||(e.WorkspaceSymbol=z={}));var J;(function(we){function Se(H){const ke={name:H.name||"!!MISSING: name!!",detail:H.detail,range:k.from(H.range),selectionRange:k.from(H.selectionRange),kind:B.from(H.kind),tags:H.tags?.map(N.from)??[]};return H.children&&(ke.children=H.children.map(Se)),ke}we.from=Se;function fe(H){const ke=new n.$sN(H.name,H.detail,B.to(H.kind),k.to(H.range),k.to(H.selectionRange));return(0,o.$Lb)(H.tags)&&(ke.tags=H.tags.map(N.to)),H.children&&(ke.children=H.children.map(fe)),ke}we.to=fe})(J||(e.DocumentSymbol=J={}));var ue;(function(we){function Se(H){const ke=new n.$wN(B.to(H.kind),H.name,H.detail||"",a.URI.revive(H.uri),k.to(H.range),k.to(H.selectionRange));return ke._sessionId=H._sessionId,ke._itemId=H._itemId,ke}we.to=Se;function fe(H,ke,Oe){if(ke=ke??H._sessionId,Oe=Oe??H._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,name:H.name,detail:H.detail,kind:B.from(H.kind),uri:H.uri,range:k.from(H.range),selectionRange:k.from(H.selectionRange),tags:H.tags?.map(N.from)}}we.from=fe})(ue||(e.CallHierarchyItem=ue={}));var x;(function(we){function Se(fe){return new n.$xN(ue.to(fe.from),fe.fromRanges.map(H=>k.to(H)))}we.to=Se})(x||(e.CallHierarchyIncomingCall=x={}));var G;(function(we){function Se(fe){return new n.$yN(ue.to(fe.to),fe.fromRanges.map(H=>k.to(H)))}we.to=Se})(G||(e.CallHierarchyOutgoingCall=G={}));var U;(function(we){function Se(H){return{range:H.range&&k.from(H.range),uri:H.uri}}we.from=Se;function fe(H){return new n.$kN(a.URI.revive(H.uri),k.to(H.range))}we.to=fe})(U||(e.location=U={}));var T;(function(we){function Se(H){const ke=H,Oe=H;return{originSelectionRange:ke.originSelectionRange?k.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Oe.uri,range:k.from(ke.targetRange?ke.targetRange:Oe.range),targetSelectionRange:ke.targetSelectionRange?k.from(ke.targetSelectionRange):void 0}}we.from=Se;function fe(H){return{targetUri:a.URI.revive(H.uri),targetRange:k.to(H.range),targetSelectionRange:H.targetSelectionRange?k.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?k.to(H.originSelectionRange):void 0}}we.to=fe})(T||(e.DefinitionLink=T={}));var q;(function(we){function Se(H){return{range:k.from(H.range),contents:K.fromMany(H.contents),canIncreaseVerbosity:H.canIncreaseVerbosity,canDecreaseVerbosity:H.canDecreaseVerbosity}}we.from=Se;function fe(H){const ke=H.contents.map(K.to),Oe=k.to(H.range),qe=H.canIncreaseVerbosity,ze=H.canDecreaseVerbosity;return new n.$oN(ke,Oe,qe,ze)}we.to=fe})(q||(e.Hover=q={}));var se;(function(we){function Se(H){return{range:k.from(H.range),expression:H.expression}}we.from=Se;function fe(H){return new n.$jO(k.to(H.range),H.expression)}we.to=fe})(se||(e.EvaluatableExpression=se={}));var ae;(function(we){function Se(H){if(H instanceof n.$kO)return{type:"text",range:k.from(H.range),text:H.text};if(H instanceof n.$lO)return{type:"variable",range:k.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof n.$mO)return{type:"expression",range:k.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}we.from=Se;function fe(H){switch(H.type){case"text":return{range:k.to(H.range),text:H.text};case"variable":return{range:k.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:k.to(H.range),expression:H.expression}}}we.to=fe})(ae||(e.InlineValue=ae={}));var me;(function(we){function Se(H){return{frameId:H.frameId,stoppedLocation:k.from(H.stoppedLocation)}}we.from=Se;function fe(H){return new n.$nO(H.frameId,k.to(H.stoppedLocation))}we.to=fe})(me||(e.InlineValueContext=me={}));var ee;(function(we){function Se(H){return{range:k.from(H.range),kind:H.kind}}we.from=Se;function fe(H){return new n.$pN(k.to(H.range),H.kind)}we.to=fe})(ee||(e.DocumentHighlight=ee={}));var ge;(function(we){function Se(H){return{uri:H.uri,highlights:H.highlights.map(ee.from)}}we.from=Se;function fe(H){return new n.$qN(a.URI.revive(H.uri),H.highlights.map(ee.to))}we.to=fe})(ge||(e.MultiDocumentHighlight=ge={}));var $e;(function(we){function Se(fe){switch(fe){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}we.to=Se})($e||(e.CompletionTriggerKind=$e={}));var Ce;(function(we){function Se(fe){return{triggerKind:$e.to(fe.triggerKind),triggerCharacter:fe.triggerCharacter}}we.to=Se})(Ce||(e.CompletionContext=Ce={}));var je;(function(we){function Se(H){switch(H){case n.CompletionItemTag.Deprecated:return 1}}we.from=Se;function fe(H){switch(H){case 1:return n.CompletionItemTag.Deprecated}}we.to=fe})(je||(e.CompletionItemTag=je={}));var de;(function(we){const Se=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function fe(Oe){return Se.get(Oe)??9}we.from=fe;const H=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function ke(Oe){return H.get(Oe)??n.CompletionItemKind.Property}we.to=ke})(de||(e.CompletionItemKind=de={}));var Pe;(function(we){function Se(fe,H){const ke=new n.$GN(fe.label);return ke.insertText=fe.insertText,ke.kind=de.to(fe.kind),ke.tags=fe.tags?.map(je.to),ke.detail=fe.detail,ke.documentation=I.$Vk(fe.documentation)?K.to(fe.documentation):fe.documentation,ke.sortText=fe.sortText,ke.filterText=fe.filterText,ke.preselect=fe.preselect,ke.commitCharacters=fe.commitCharacters,f.$ut.isIRange(fe.range)?ke.range=k.to(fe.range):typeof fe.range=="object"&&(ke.range={inserting:k.to(fe.range.insert),replacing:k.to(fe.range.replace)}),ke.keepWhitespace=typeof fe.insertTextRules>"u"?!1:!!(fe.insertTextRules&1),typeof fe.insertTextRules<"u"&&fe.insertTextRules&4?ke.insertText=new n.$jN(fe.insertText):(ke.insertText=fe.insertText,ke.textEdit=ke.range instanceof n.$aN?new n.$fN(ke.range,ke.insertText):void 0),fe.additionalTextEdits&&fe.additionalTextEdits.length>0&&(ke.additionalTextEdits=fe.additionalTextEdits.map(Oe=>re.to(Oe))),ke.command=H&&fe.command?H.fromInternal(fe.command):void 0,ke}we.to=Se})(Pe||(e.CompletionItem=Pe={}));var De;(function(we){function Se(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:K.fromStrict(H.documentation)}}we.from=Se;function fe(H){return{label:H.label,documentation:I.$Vk(H.documentation)?K.to(H.documentation):H.documentation}}we.to=fe})(De||(e.ParameterInformation=De={}));var Me;(function(we){function Se(H){return{label:H.label,documentation:K.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(De.from):[],activeParameter:H.activeParameter}}we.from=Se;function fe(H){return{label:H.label,documentation:I.$Vk(H.documentation)?K.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(De.to):[],activeParameter:H.activeParameter}}we.to=fe})(Me||(e.SignatureInformation=Me={}));var Fe;(function(we){function Se(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(Me.from):[]}}we.from=Se;function fe(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(Me.to):[]}}we.to=fe})(Fe||(e.SignatureHelp=Fe={}));var Ue;(function(we){function Se(fe,H){const ke=new n.$FN(O.to(H.position),typeof H.label=="string"?H.label:H.label.map(Ve.to.bind(void 0,fe)),H.kind&&Ge.to(H.kind));return ke.textEdits=H.textEdits&&H.textEdits.map(re.to),ke.tooltip=I.$Vk(H.tooltip)?K.to(H.tooltip):H.tooltip,ke.paddingLeft=H.paddingLeft,ke.paddingRight=H.paddingRight,ke}we.to=Se})(Ue||(e.InlayHint=Ue={}));var Ve;(function(we){function Se(fe,H){const ke=new n.$EN(H.label);return ke.tooltip=I.$Vk(H.tooltip)?K.to(H.tooltip):H.tooltip,c.Command.is(H.command)&&(ke.command=fe.fromInternal(H.command)),H.location&&(ke.location=U.to(H.location)),ke}we.to=Se})(Ve||(e.InlayHintLabelPart=Ve={}));var Ge;(function(we){function Se(H){return H}we.from=Se;function fe(H){return H}we.to=fe})(Ge||(e.InlayHintKind=Ge={}));var Ze;(function(we){function Se(H){return{range:k.from(H.range),url:H.target,tooltip:H.tooltip}}we.from=Se;function fe(H){let ke;if(H.url)try{ke=typeof H.url=="string"?a.URI.parse(H.url,!0):a.URI.revive(H.url)}catch{}return new n.$LN(k.to(H.range),ke)}we.to=fe})(Ze||(e.DocumentLink=Ze={}));var _e;(function(we){function Se(H){const ke=new n.$ON(H.label);return H.textEdit&&(ke.textEdit=re.to(H.textEdit)),H.additionalTextEdits&&(ke.additionalTextEdits=H.additionalTextEdits.map(Oe=>re.to(Oe))),ke}we.to=Se;function fe(H){return{label:H.label,textEdit:H.textEdit?re.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(ke=>re.from(ke)):void 0}}we.from=fe})(_e||(e.ColorPresentation=_e={}));var et;(function(we){function Se(H){return new n.$MN(H[0],H[1],H[2],H[3])}we.to=Se;function fe(H){return[H.red,H.green,H.blue,H.alpha]}we.from=fe})(et||(e.Color=et={}));var xe;(function(we){function Se(H){return{range:k.from(H.range)}}we.from=Se;function fe(H){return new n.$vN(k.to(H.range))}we.to=fe})(xe||(e.SelectionRange=xe={}));var pe;(function(we){function Se(fe){switch(fe){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}we.to=Se})(pe||(e.TextDocumentSaveReason=pe={}));var Ie;(function(we){function Se(H){switch(H){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.Interval:return 3;case n.TextEditorLineNumbersStyle.On:default:return 1}}we.from=Se;function fe(H){switch(H){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 3:return n.TextEditorLineNumbersStyle.Interval;case 1:default:return n.TextEditorLineNumbersStyle.On}}we.to=fe})(Ie||(e.TextEditorLineNumbersStyle=Ie={}));var Re;(function(we){function Se(H){if(H===n.EndOfLine.CRLF)return 1;if(H===n.EndOfLine.LF)return 0}we.from=Se;function fe(H){if(H===1)return n.EndOfLine.CRLF;if(H===0)return n.EndOfLine.LF}we.to=fe})(Re||(e.EndOfLine=Re={}));var Ae;(function(we){function Se(fe){if(typeof fe=="object")return fe.viewId;switch(fe){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=Se})(Ae||(e.ProgressLocation=Ae={}));var Te;(function(we){function Se(H){const ke={start:H.start+1,end:H.end+1};return H.kind&&(ke.kind=Qe.from(H.kind)),ke}we.from=Se;function fe(H){const ke={start:H.start-1,end:H.end-1};return H.kind&&(ke.kind=Qe.to(H.kind)),ke}we.to=fe})(Te||(e.FoldingRange=Te={}));var Qe;(function(we){function Se(H){if(H)switch(H){case n.FoldingRangeKind.Comment:return c.$du.Comment;case n.FoldingRangeKind.Imports:return c.$du.Imports;case n.FoldingRangeKind.Region:return c.$du.Region}}we.from=Se;function fe(H){if(H)switch(H.value){case c.$du.Comment.value:return n.FoldingRangeKind.Comment;case c.$du.Imports.value:return n.FoldingRangeKind.Imports;case c.$du.Region.value:return n.FoldingRangeKind.Region}}we.to=fe})(Qe||(e.FoldingRangeKind=Qe={}));var He;(function(we){function Se(fe){if(fe)return{pinned:typeof fe.preview=="boolean"?!fe.preview:void 0,inactive:fe.background,preserveFocus:fe.preserveFocus,selection:typeof fe.selection=="object"?k.from(fe.selection):void 0,override:typeof fe.override=="boolean"?E.$tF.id:void 0}}we.from=Se})(He||(e.TextEditorOpenOptions=He={}));var Je;(function(we){function Se(Oe){return Oe instanceof n.$0N?Oe.toJSON():typeof Oe=="string"?Oe:fe(Oe)||H(Oe)?new n.$0N(Oe.baseUri??Oe.base,Oe.pattern).toJSON():Oe}we.from=Se;function fe(Oe){const qe=Oe;return qe?a.URI.isUri(qe.baseUri)&&typeof qe.pattern=="string":!1}function H(Oe){const qe=Oe;return qe?typeof qe.base=="string"&&typeof qe.pattern=="string":!1}function ke(Oe){return typeof Oe=="string"?Oe:new n.$0N(a.URI.revive(Oe.baseUri),Oe.pattern)}we.to=ke})(Je||(e.GlobPattern=Je={}));var it;(function(we){function Se(fe){if(fe){if(Array.isArray(fe))return fe.map(Se);if(typeof fe=="string")return fe;{const H=fe;return{language:H.language,scheme:H.scheme,pattern:Je.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}we.from=Se})(it||(e.LanguageSelector=it={}));var Ke;(function(we){function Se(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(ke=>Array.isArray(ke)&&ke.every(Oe=>Oe&&typeof Oe=="object"&&"uri"in Oe&&a.URI.isUri(Oe.uri)&&"version"in Oe&&typeof Oe.version=="number"&&"ranges"in Oe&&Array.isArray(Oe.ranges)&&Oe.ranges.every(qe=>qe instanceof n.$aN)))}we.is=Se;function fe(H){return{documents:H.documents.map(ke=>ke.map(Oe=>({uri:a.URI.from(Oe.uri),version:Oe.version,ranges:Oe.ranges.map(qe=>k.from(qe))})))}}we.from=fe})(Ke||(e.MappedEditsContext=Ke={}));var nt;(function(we){function Se(H){return{start:H.start,end:H.end}}we.from=Se;function fe(H){return new n.$AO(H.start,H.end)}we.to=fe})(nt||(e.NotebookRange=nt={}));var ot;(function(we){function Se(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}we.to=Se;function fe(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}we.from=fe})(ot||(e.NotebookCellExecutionSummary=ot={}));var at;(function(we){function Se(fe){if(fe===t.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(fe===t.NotebookCellExecutionState.Pending)return;if(fe===t.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${fe}`)}we.to=Se})(at||(e.NotebookCellExecutionState=at={}));var lt;(function(we){function Se(H){switch(H){case n.NotebookCellKind.Markup:return t.CellKind.Markup;case n.NotebookCellKind.Code:default:return t.CellKind.Code}}we.from=Se;function fe(H){switch(H){case t.CellKind.Markup:return n.NotebookCellKind.Markup;case t.CellKind.Code:default:return n.NotebookCellKind.Code}}we.to=fe})(lt||(e.NotebookCellKind=lt={}));var ht;(function(we){function Se(H){const ke={metadata:H.metadata??Object.create(null),cells:[]};for(const Oe of H.cells)n.$BO.validate(Oe),ke.cells.push(kt.from(Oe));return ke}we.from=Se;function fe(H){const ke=new n.$CO(H.cells.map(kt.to));return(0,u.$jg)(H.metadata)||(ke.metadata=H.metadata),ke}we.to=fe})(ht||(e.NotebookData=ht={}));var kt;(function(we){function Se(H){return{cellKind:lt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:ot.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(bt.from):[]}}we.from=Se;function fe(H){return new n.$BO(lt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(bt.to):void 0,H.metadata,H.internalMetadata?ot.to(H.internalMetadata):void 0)}we.to=fe})(kt||(e.NotebookCellData=kt={}));var At;(function(we){function Se(H){return{mime:H.mime,valueBytes:C.$Ge.wrap(H.data)}}we.from=Se;function fe(H){return new n.$DO(H.valueBytes.buffer,H.mime)}we.to=fe})(At||(e.NotebookCellOutputItem=At={}));var bt;(function(we){function Se(H){return{outputId:H.id,items:H.items.map(At.from),metadata:H.metadata}}we.from=Se;function fe(H){const ke=H.items.map(At.to);return new n.$EO(ke,H.outputId,H.metadata)}we.to=fe})(bt||(e.NotebookCellOutput=bt={}));var Lt;(function(we){function Se(ke){return H(ke)?{include:Je.from(ke.include)??void 0,exclude:Je.from(ke.exclude)??void 0}:Je.from(ke)??void 0}we.from=Se;function fe(ke){return H(ke)?{include:Je.to(ke.include),exclude:Je.to(ke.exclude)}:Je.to(ke)}we.to=fe;function H(ke){const Oe=ke;return Oe?!(0,u.$fg)(Oe.include)&&!(0,u.$fg)(Oe.exclude):!1}})(Lt||(e.NotebookExclusiveDocumentPattern=Lt={}));var Dt;(function(we){function Se(fe,H,ke){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{alignment:fe.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(Oe,ke),text:fe.text,tooltip:fe.tooltip,accessibilityInformation:fe.accessibilityInformation,priority:fe.priority}}we.from=Se})(Dt||(e.NotebookStatusBarItem=Dt={}));var Pt;(function(we){function Se(fe,H,ke){const Oe=typeof fe.command=="string"?{title:"",command:fe.command}:fe.command;return{command:H.toInternal(Oe,ke),label:fe.label,description:fe.description,detail:fe.detail,documentation:fe.documentation}}we.from=Se})(Pt||(e.NotebookKernelSourceAction=Pt={}));var Tt;(function(we){function Se(fe){return{transientOutputs:fe?.transientOutputs??!1,transientCellMetadata:fe?.transientCellMetadata??{},transientDocumentMetadata:fe?.transientDocumentMetadata??{},cellContentMetadata:fe?.cellContentMetadata??{}}}we.from=Se})(Tt||(e.NotebookDocumentContentOptions=Tt={}));var dt;(function(we){function Se(H){return{uri:H.uri,provides:H.provides}}we.from=Se;function fe(H){return new n.$GO(a.URI.revive(H.uri),H.provides)}we.to=fe})(dt||(e.NotebookRendererScript=dt={}));var Ot;(function(we){function Se(H){return{message:K.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:k.from(H.location.range),uri:H.location.uri}}}we.from=Se;function fe(H){const ke=new n.$MO(typeof H.message=="string"?H.message:K.to(H.message));return ke.actualOutput=H.actual,ke.expectedOutput=H.expected,ke.contextValue=H.contextValue,ke.location=H.location?U.to(H.location):void 0,ke}we.to=fe})(Ot||(e.TestMessage=Ot={}));var gt;(function(we){we.namespace=r.$ZL,we.denamespace=r.$1L})(gt||(e.TestTag=gt={}));var rt;(function(we){function Se(H){const ke=(0,p.$sP)(H).controllerId;return{extId:s.$UL.fromExtHostTestItem(H,ke).toString(),label:H.label,uri:a.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(Oe=>gt.namespace(ke,Oe.id)),range:f.$ut.lift(k.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&K.fromStrict(H.error)||null}}we.from=Se;function fe(H){return{parent:void 0,error:void 0,id:s.$UL.fromString(H.extId).localId,label:H.label,uri:a.URI.revive(H.uri),tags:(H.tags||[]).map(ke=>{const{tagId:Oe}=gt.denamespace(ke);return new n.$NO(Oe)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:k.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}we.toPlain=fe})(rt||(e.TestItem=rt={})),function(we){function Se(H){return{id:H.id}}we.from=Se;function fe(H){return new n.$NO(H.id)}we.to=fe}(gt||(e.TestTag=gt={}));var mt;(function(we){const Se=(H,ke)=>{const Oe=H.value;if(!Oe)return;const qe={...rt.toPlain(Oe.item),parent:ke,taskStates:Oe.tasks.map(ze=>({state:ze.state,duration:ze.duration,messages:ze.messages.filter(Xe=>Xe.type===0).map(Ot.to)})),children:[]};if(H.children)for(const ze of H.children.values()){const Xe=Se(ze,qe);Xe&&qe.children.push(Xe)}return qe};function fe(H){const ke=new w.$lP;for(const ze of H.items)ke.insert(s.$UL.fromString(ze.item.extId).path,ze);const Oe=[ke.nodes],qe=[];for(;Oe.length;)for(const ze of Oe.pop())ze.value?qe.push(ze):ze.children&&Oe.push(ze.children.values());return{completedAt:H.completedAt,results:qe.map(ze=>Se(ze)).filter(u.$eg)}}we.to=fe})(mt||(e.TestResults=mt={}));var $t;(function(we){function Se(Oe){return{covered:Oe.covered,total:Oe.total}}function fe(Oe){return"line"in Oe?O.from(Oe):k.from(Oe)}function H(Oe){if(typeof Oe.executed=="number"&&Oe.executed<0)throw new Error(`Invalid coverage count ${Oe.executed}`);return"branches"in Oe?{count:Oe.executed,location:fe(Oe.location),type:1,branches:Oe.branches.length?Oe.branches.map(qe=>({count:qe.executed,location:qe.location&&fe(qe.location),label:qe.label})):void 0}:{type:0,name:Oe.name,count:Oe.executed,location:fe(Oe.location)}}we.fromDetails=H;function ke(Oe,qe){return n.$PO(qe.statementCoverage),n.$PO(qe.branchCoverage),n.$PO(qe.declarationCoverage),{id:Oe,uri:qe.uri,statement:Se(qe.statementCoverage),branch:qe.branchCoverage&&Se(qe.branchCoverage),declaration:qe.declarationCoverage&&Se(qe.declarationCoverage)}}we.fromFile=ke})($t||(e.TestCoverage=$t={}));var Ut;(function(we){function Se(fe){switch(fe){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}we.to=Se})(Ut||(e.CodeActionTriggerKind=Ut={}));var en;(function(we){function Se(H){const ke=new n.$UO(B.to(H.kind),H.name,H.detail||"",a.URI.revive(H.uri),k.to(H.range),k.to(H.selectionRange));return ke._sessionId=H._sessionId,ke._itemId=H._itemId,ke}we.to=Se;function fe(H,ke,Oe){if(ke=ke??H._sessionId,Oe=Oe??H._itemId,ke===void 0||Oe===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Oe,kind:B.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:k.from(H.range),selectionRange:k.from(H.selectionRange),tags:H.tags?.map(N.from)}}we.from=fe})(en||(e.TypeHierarchyItem=en={}));var tn;(function(we){function Se(fe){if(fe)return{value:fe.value,tooltip:fe.tooltip}}we.from=Se})(tn||(e.ViewBadge=tn={}));var Mt;(function(we){function Se(Oe,qe,ze){const Xe=qe.fileData;return Xe?new n.$2N(new n.$3N(Xe.name,a.URI.revive(Xe.uri),Xe.id,(0,D.$db)(()=>ze(Xe.id)))):Oe===y.$Qs.uriList&&qe.uriListData?new n.$1N(ke(qe.uriListData)):new n.$1N(qe.asString)}we.to=Se;async function fe(Oe,qe){const ze=await qe.asString();if(Oe===y.$Qs.uriList)return{asString:ze,fileData:void 0,uriListData:H(ze)};const Xe=qe.asFile();return{asString:ze,fileData:Xe?{name:Xe.name,uri:Xe.uri,id:Xe._itemId??Xe.id}:void 0}}we.from=fe;function H(Oe){return S.$Ut.split(Oe).map(qe=>{if(qe.startsWith("#"))return qe;try{return a.URI.parse(qe)}catch{}return qe})}function ke(Oe){return S.$Ut.create(Oe.map(qe=>typeof qe=="string"?qe:a.URI.revive(qe)))}})(Mt||(e.DataTransferItem=Mt={}));var zt;(function(we){function Se(H,ke){const Oe=H.items.map(([qe,ze])=>[qe,Mt.to(qe,ze,ke)]);return new n.$4N(Oe)}we.toDataTransfer=Se;async function fe(H){const ke={items:[]},Oe=[];for(const[qe,ze]of H)Oe.push((async()=>{ke.items.push([qe,await Mt.from(qe,ze)])})());return await Promise.all(Oe),ke}we.from=fe})(zt||(e.DataTransfer=zt={}));var Ht;(function(we){function Se(H,ke){return{kind:"reply",agentId:H.participant??ke?.agentId??"",subCommand:H.command??ke?.command,message:H.prompt,title:H.label}}we.from=Se;function fe(H){return{prompt:H.message,label:H.title,participant:H.agentId,command:H.subCommand}}we.to=fe})(Ht||(e.ChatFollowup=Ht={}));var Wt;(function(we){function Se(fe){return"commandId"in fe?{kind:"command",title:fe.title??"",commandId:fe.commandId??"",when:fe.when??"",args:fe.args}:{kind:"reply",message:fe.message,title:fe.title,tooltip:fe.tooltip}}we.from=Se})(Wt||(e.ChatInlineFollowup=Wt={}));var Nt;(function(we){function Se(H){switch(H.role){case 0:return new n.$gP(H.content);case 1:return new n.$hP(H.content);case 2:return new n.$iP(H.content)}}we.to=Se;function fe(H){if(H instanceof n.$gP)return{role:0,content:H.content};if(H instanceof n.$hP)return{role:1,content:H.content};if(H instanceof n.$iP)return{role:2,content:H.content};throw new Error("Invalid LanguageModelMessage")}we.from=fe})(Nt||(e.LanguageModelMessage=Nt={}));var Bt;(function(we){function Se(ke){const Oe={};for(const qe of Object.keys(ke))Oe[qe]=ke[qe].map(we.to);return Oe}we.objectTo=Se;function fe(ke){return{level:Gt.to(ke.level),kind:ke.kind,value:(0,a.$wc)(ke.value)?a.URI.revive(ke.value):ke.value,description:ke.description}}we.to=fe;function H(ke){return{level:Gt.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}we.from=H})(Bt||(e.ChatVariable=Bt={}));var Gt;(function(we){function Se(H){switch(H){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}we.to=Se;function fe(H){switch(H){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}we.from=fe})(Gt||(e.ChatVariableLevel=Gt={}));var xt;(function(we){function Se(fe){switch(fe){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}we.to=Se})(xt||(e.InteractiveEditorResponseFeedbackKind=xt={}));var Rt;(function(we){function Se(H){return{kind:"markdownContent",content:K.from(H.value)}}we.from=Se;function fe(H){return new n.$8O(K.to(H.content))}we.to=fe})(Rt||(e.ChatResponseMarkdownPart=Rt={}));var nn;(function(we){function Se(H){return{kind:"markdownVuln",content:K.from(H.value),vulnerabilities:H.vulnerabilities}}we.from=Se;function fe(H){return new n.$9O(K.to(H.content),H.vulnerabilities)}we.to=fe})(nn||(e.ChatResponseMarkdownWithVulnerabilitiesPart=nn={}));var qt;(function(we){function Se(H){return{kind:"agentDetection",agentId:H.participant,command:H.command}}we.from=Se;function fe(H){return new n.$0O(H.agentId,H.command)}we.to=fe})(qt||(e.ChatResponseDetectedParticipantPart=qt={}));var Jt;(function(we){function Se(H){const{value:ke,baseUri:Oe}=H;function qe(ze,Xe){return ze.map(st=>{const ft=a.URI.joinPath(Xe,st.name);return{label:st.name,uri:ft,children:st.children&&qe(st.children,ft)}})}return{kind:"treeData",treeData:{label:(0,m.$7g)(Oe),uri:Oe,children:qe(ke,Oe)}}}we.from=Se;function fe(H){const ke=(0,g.$6h)(H.treeData);function Oe(Xe){return Xe.map(st=>({name:st.label,children:st.children&&Oe(st.children)}))}const qe=ke.uri,ze=ke.children?Oe(ke.children):[];return new n.$$O(ze,qe)}we.to=fe})(Jt||(e.ChatResponseFilesPart=Jt={}));var Qt;(function(we){function Se(H){return{kind:"inlineReference",name:H.title,inlineReference:a.URI.isUri(H.value)?H.value:j.from(H.value)}}we.from=Se;function fe(H){const ke=(0,g.$6h)(H);return new n.$_O(a.URI.isUri(ke.inlineReference)?ke.inlineReference:j.to(ke.inlineReference),H.name)}we.to=fe})(Qt||(e.ChatResponseAnchorPart=Qt={}));var rn;(function(we){function Se(H){return{kind:"progressMessage",content:K.from(H.value)}}we.from=Se;function fe(H){return new n.$aP(H.content.value)}we.to=fe})(rn||(e.ChatResponseProgressPart=rn={}));var Zt;(function(we){function Se(H,ke,Oe){return{kind:"command",command:ke.toInternal(H.value,Oe)??{command:H.value.command,title:H.value.title}}}we.from=Se;function fe(H,ke){return new n.$bP(ke.fromInternal(H.command)??{command:H.command.id,title:H.command.title})}we.to=fe})(Zt||(e.ChatResponseCommandButtonPart=Zt={}));var Xt;(function(we){function Se(H){return{kind:"textEdit",uri:H.uri,edits:H.edits.map(ke=>re.from(ke))}}we.from=Se;function fe(H){return new n.$dP(a.URI.revive(H.uri),H.edits.map(ke=>re.to(ke)))}we.to=fe})(Xt||(e.ChatResponseTextEditPart=Xt={}));var St;(function(we){function Se(H){const ke=l.ThemeIcon.isThemeIcon(H.iconPath)?H.iconPath:void 0;return"variableName"in H.value?{kind:"reference",reference:{variableName:H.value.variableName,value:a.URI.isUri(H.value.value)||!H.value.value?H.value.value:j.from(H.value.value)},iconPath:ke}:{kind:"reference",reference:a.URI.isUri(H.value)?H.value:j.from(H.value),iconPath:ke}}we.from=Se;function fe(H){const ke=(0,g.$6h)(H),Oe=qe=>a.URI.isUri(qe)?qe:j.to(qe);return new n.$cP("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Oe(ke.reference.value)}:Oe(ke.reference))}we.to=fe})(St||(e.ChatResponseReferencePart=St={}));var Kt;(function(we){function Se(ke,Oe,qe){return ke instanceof n.$8O?Rt.from(ke):ke instanceof n.$_O?Qt.from(ke):ke instanceof n.$cP?St.from(ke):ke instanceof n.$aP?rn.from(ke):ke instanceof n.$$O?Jt.from(ke):ke instanceof n.$bP?Zt.from(ke,Oe,qe):ke instanceof n.$dP?Xt.from(ke):ke instanceof n.$9O?nn.from(ke):ke instanceof n.$0O?qt.from(ke):{kind:"markdownContent",content:K.from("")}}we.from=Se;function fe(ke,Oe){switch(ke.kind){case"reference":return St.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return H(ke,Oe)}}we.to=fe;function H(ke,Oe){switch(ke.kind){case"markdownContent":return Rt.to(ke);case"inlineReference":return Qt.to(ke);case"progressMessage":return;case"treeData":return Jt.to(ke);case"command":return Zt.to(ke,Oe)}}we.toContent=H})(Kt||(e.ChatResponsePart=Kt={}));var Yt;(function(we){function Se(fe){return{prompt:fe.message,command:fe.command,attempt:fe.attempt??0,enableCommandDetection:fe.enableCommandDetection??!0,variables:fe.variables.variables.map(cn.to),location:sn.to(fe.location)}}we.to=Se})(Yt||(e.ChatAgentRequest=Yt={}));var sn;(function(we){function Se(fe){switch(fe){case h.ChatAgentLocation.Notebook:return n.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return n.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return n.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return n.ChatLocation.Editor}}we.to=Se})(sn||(e.ChatLocation=sn={}));var cn;(function(we){function Se(fe){return{name:fe.name,range:fe.range&&[fe.range.start,fe.range.endExclusive],values:fe.values.map(Bt.to)}}we.to=Se})(cn||(e.ChatAgentResolvedVariable=cn={}));var dn;(function(we){function Se(fe,H,ke){return{label:fe.label,values:fe.values.map(Bt.from),insertText:fe.insertText,detail:fe.detail,documentation:fe.documentation,command:H.toInternal(fe.command,ke)}}we.from=Se})(dn||(e.ChatAgentCompletionItem=dn={}));var _t;(function(we){function Se(fe){return{errorDetails:fe.errorDetails,metadata:fe.metadata}}we.to=Se})(_t||(e.ChatAgentResult=_t={}));var on;(function(we){function Se(fe,H,ke){if(H.action.kind==="vote")return;const Oe=_t.to(fe);if(H.action.kind==="command"){const qe=H.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(qe)??{command:qe.id,title:qe.title}}},result:Oe}}else return H.action.kind==="followUp"?{action:{kind:"followUp",followup:Ht.to(H.action.followup)},result:Oe}:H.action.kind==="inlineChat"?{action:{kind:"editor",accepted:H.action.action==="accepted"},result:Oe}:{action:H.action,result:Oe}}we.to=Se})(on||(e.ChatAgentUserActionEvent=on={}));var ln;(function(we){function Se(fe,H,ke){return"terminalCommand"in fe?{terminalCommand:fe.terminalCommand,shouldExecute:fe.shouldExecute}:"uri"in fe?{uri:fe.uri}:H.toInternal(fe,ke)}we.from=Se})(ln||(e.TerminalQuickFix=ln={}));var It;(function(we){function Se(fe){return{kind:un.to(fe.kind)}}we.to=Se})(It||(e.PartialAcceptInfo=It={}));var un;(function(we){function Se(fe){switch(fe){case 0:return n.PartialAcceptTriggerKind.Word;case 1:return n.PartialAcceptTriggerKind.Line;case 2:return n.PartialAcceptTriggerKind.Suggest;default:return n.PartialAcceptTriggerKind.Unknown}}we.to=Se})(un||(e.PartialAcceptTriggerKind=un={}));var wt;(function(we){function Se(fe,H){return{id:H,label:fe.label,description:fe.description,canEdit:fe.canEdit,collapsibleState:fe.collapsibleState||0,contextValue:fe.contextValue}}we.from=Se})(wt||(e.DebugTreeItem=wt={}))}),define(ye[297],Ee([1,0,45,136,72,135,95,142,4]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=e.$KP=e.$JP=e.$IP=void 0;const g=(p,E,h,t)=>{let s=E;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!h(s,r)){const i=s;s=r,p.listener?.(t(r,i))}}}},y=(p,E)=>p===E,v={range:(p,E)=>p===E?!0:!p||!E?!1:p.isEqual(E),label:y,description:y,sortText:y,busy:y,error:y,canResolveChildren:y,tags:(p,E)=>!(p.length!==E.length||p.some(h=>!E.find(t=>h.id===t.id)))},w=p=>E=>({op:4,update:p(E)}),m=(p,E)=>({range:(()=>{let h;const t=w(s=>({range:o.$ut.lift(P.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return h},set(s){p.listener?.({op:6}),v.range(h,s)||(h=s,p.listener?.(t(s)))}}})(),label:g(p,E,v.label,w(h=>({label:h}))),description:g(p,void 0,v.description,w(h=>({description:h}))),sortText:g(p,void 0,v.sortText,w(h=>({sortText:h}))),canResolveChildren:g(p,!1,v.canResolveChildren,h=>({op:2,state:h})),busy:g(p,!1,v.busy,w(h=>({busy:h}))),error:g(p,void 0,v.error,w(h=>({error:P.MarkdownString.fromStrict(h)||null}))),tags:g(p,[],v.tags,(h,t)=>({op:1,new:h.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),u=p=>{const E=S.$UL.fromString(p.extId),h=new f(E.controllerId,E.localId,p.label,b.URI.revive(p.uri)||void 0);return h.range=P.Range.to(p.range||void 0),h.description=p.description||void 0,h.sortText=p.sortText||void 0,h.tags=p.tags.map(t=>P.TestTag.to({id:(0,I.$1L)(t).tagId})),h},a=p=>{let E;for(const h of p.tests){const t=u(h.item);(0,C.$sP)(t).parent=E,E=t}return E};e.$IP=a;class f{constructor(E,h,t,s){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const r=(0,C.$rP)(this,E);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof c?void 0:r.parent}},children:{value:(0,D.$qP)(r,C.$sP,f),enumerable:!0,writable:!1},...m(r,t)})}}e.$JP=f;class c extends f{constructor(E,h){super(E,E,h,void 0),this._isRoot=!0}}e.$KP=c;class d extends D.$mP{constructor(E,h,t){super({controllerId:E,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:C.$sP,getChildren:s=>s.children,root:new c(E,h),toITestItem:P.TestItem.from})}}e.$LP=d}),define(ye[298],Ee([1,0,10,141,142,21,295,18,12,54,45,79,4,2,5,279,297,15,139,39,61,37,292,22]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WP=e.$VP=e.$UP=e.$TP=e.$SP=e.$RP=void 0;let r=class{#e;#t;#n;constructor(j,A,O){this.b=new Map,this.c=new Map,this.#e=j.getProxy(I.$9M.MainThreadCommands),this.d=A,this.#n=O,this.#t=j.getProxy(I.$9M.MainThreadTelemetry),this.converter=new i(this,F=>{const V=this.c.get(F);return V?.result===l.Void?V:void 0},A),this.f=[{processArgument(F){return(0,g.$6h)(F)}},{processArgument(F){return(0,D.$5n)(F,function(V){if(y.$ut.isIRange(V))return S.Range.to(V);if(v.$tt.isIPosition(V))return S.Position.to(V);if(y.$ut.isIRange(V.range)&&w.URI.isUri(V.uri))return S.location.to(V);if(V instanceof c.$Ge)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(j){this.f.push(j)}registerApiCommand(j){const A=this.registerCommand(!1,j.id,async(...O)=>{const F=j.args.map((Z,oe)=>{if(!Z.validate(O[oe]))throw new Error(`Invalid argument '${Z.name}' when running '${j.id}', received: ${typeof O[oe]=="object"?JSON.stringify(O[oe],null,"	"):O[oe]} `);return Z.convert(O[oe])}),V=await this.executeCommand(j.internalId,...F);return j.result.convert(V,O,this.converter)},void 0,{description:j.description,args:j.args,returns:j.result.description});return this.c.set(j.id,j),new C.$$M(()=>{A.dispose(),this.c.delete(j.id)})}registerCommand(j,A,O,F,V,Z){if(this.d.trace("ExtHostCommands#registerCommand",A),!A.trim().length)throw new Error("invalid id");if(this.b.has(A))throw new Error(`command '${A}' already exists`);return this.b.set(A,{callback:O,thisArg:F,metadata:V,extension:Z}),j&&this.#e.$registerCommand(A),new C.$$M(()=>{this.b.delete(A)&&j&&this.#e.$unregisterCommand(A)})}executeCommand(j,...A){return this.d.trace("ExtHostCommands#executeCommand",j),this.g(j,A,!0)}async g(j,A,O){if(this.b.has(j))return this.#e.$fireCommandActivationEvent(j),this.h(j,A,!1);{let F=!1;const V=(0,D.$5n)(A,function(Z){if(Z instanceof C.$_M)return S.Position.from(Z);if(Z instanceof C.$aN)return S.Range.from(Z);if(Z instanceof C.$kN)return S.location.from(Z);if(C.$AO.isNotebookRange(Z))return S.NotebookRange.from(Z);if(Z instanceof ArrayBuffer)return F=!0,c.$Ge.wrap(new Uint8Array(Z));if(Z instanceof Uint8Array)return F=!0,c.$Ge.wrap(Z);if(Z instanceof c.$Ge)return F=!0,Z;if(!Array.isArray(Z))return Z});try{const Z=await this.#e.$executeCommand(j,F?new d.$Bw(V):V,O);return(0,g.$6h)(Z)}catch(Z){if(Z instanceof Error&&Z.message==="$executeCommand:retry")return this.g(j,A,!1);throw Z}}}async h(j,A,O){const F=this.b.get(j);if(!F)throw new Error("Unknown command");const{callback:V,thisArg:Z,metadata:oe}=F;if(oe?.args)for(let te=0;te<oe.args.length;te++)try{(0,o.$ng)(A[te],oe.args[te].constraint)}catch{throw new Error(`Running the contributed command: '${j}' failed. Illegal argument '${oe.args[te].name}' - ${oe.args[te].description}`)}const le=E.$ae.create();try{return await V.apply(Z,A)}catch(te){if(j===this.converter.delegatingCommandId){const _=this.converter.getActualCommand(...A);_&&(j=_.command)}if(this.d.error(te,j,F.extension?.identifier),!O)throw te;if(F.extension?.identifier){const _=this.#n.onExtensionError(F.extension.identifier,te);this.d.trace("forwarded error to extension?",_,F.extension?.identifier)}throw new class extends Error{constructor(){super((0,p.$hj)(te)),this.id=j,this.source=F.extension?.displayName??F.extension?.name}}}finally{this.j(F,j,le.elapsed())}}j(j,A,O){j.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:j.extension.identifier.value,id:new h.$fp(A),duration:O})}$executeContributedCommand(j,...A){this.d.trace("ExtHostCommands#$executeContributedCommand",j);const O=this.b.get(j);return O?(A=A.map(F=>this.f.reduce((V,Z)=>Z.processArgument(V,O.extension?.identifier),F)),this.h(j,A,!0)):Promise.reject(new Error(`Contributed command '${j}' does not exist.`))}getCommands(j=!1){return this.d.trace("ExtHostCommands#getCommands",j),this.#e.$getCommands().then(A=>(j&&(A=A.filter(O=>O[0]!=="_")),A))}$getContributedCommandMetadata(){const j=Object.create(null);for(const[A,O]of this.b){const{metadata:F}=O;F&&(j[A]=F)}return Promise.resolve(j)}};e.$RP=r,e.$RP=r=Le([Ne(0,a.$wP),Ne(1,b.$3j),Ne(2,t.$QP)],r),e.$SP=(0,u.$wi)("IExtHostCommands");class i{constructor(j,A,O){this.d=j,this.f=A,this.g=O,this.delegatingCommandId=`__vsc${(0,s.$Sg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(j,A){if(!j)return;const O={$ident:void 0,id:j.command,title:j.title,tooltip:j.tooltip};if(!j.command)return O;const F=this.f(j.command);if(F)O.id=F.internalId,O.arguments=F.args.map((V,Z)=>V.convert(j.arguments&&j.arguments[Z]));else if((0,P.$Lb)(j.arguments)){const V=`${j.command} /${++this.c}`;this.b.set(V,j),A.add((0,m.$Tc)(()=>{this.b.delete(V),this.g.trace("CommandsConverter#DISPOSE",V)})),O.$ident=V,O.id=this.delegatingCommandId,O.arguments=[V],this.g.trace("CommandsConverter#CREATE",j.command,V)}return O}fromInternal(j){return typeof j.$ident=="string"?this.b.get(j.$ident):{command:j.id,title:j.title,arguments:j.arguments}}getActualCommand(...j){return this.b.get(j[0])}h(...j){const A=this.getActualCommand(...j);return this.g.trace("CommandsConverter#EXECUTE",j[0],A?A.command:"MISSING"),A?this.d.executeCommand(A.command,...A.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${j[0]}`)}}e.$TP=i;class n{static{this.Uri=new n("uri","Uri of a text document",j=>w.URI.isUri(j),j=>j)}static{this.Position=new n("position","A position in a text document",j=>C.$_M.isPosition(j),S.Position.from)}static{this.Range=new n("range","A range in a text document",j=>C.$aN.isRange(j),S.Range.from)}static{this.Selection=new n("selection","A selection in a text document",j=>C.$bN.isSelection(j),S.Selection.from)}static{this.Number=new n("number","",j=>typeof j=="number",j=>j)}static{this.String=new n("string","",j=>typeof j=="string",j=>j)}static{this.StringArray=n.Arr(n.String)}static Arr(j){return new n(`${j.name}_array`,`Array of ${j.name}, ${j.description}`,A=>Array.isArray(A)&&A.every(O=>j.validate(O)),A=>A.map(O=>j.convert(O)))}static{this.CallHierarchyItem=new n("item","A call hierarchy item",j=>j instanceof C.$wN,S.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new n("item","A type hierarchy item",j=>j instanceof C.$UO,S.TypeHierarchyItem.from)}static{this.TestItem=new n("testItem","A VS Code TestItem",j=>j instanceof f.$JP,S.TestItem.from)}constructor(j,A,O,F){this.name=j,this.description=A,this.validate=O,this.convert=F}optional(){return new n(this.name,`(optional) ${this.description}`,j=>j==null||this.validate(j),j=>j===void 0?void 0:j===null?null:this.convert(j))}with(j,A){return new n(j??this.name,A??this.description,this.validate,this.convert)}}e.$UP=n;class l{static{this.Void=new l("no result",j=>j)}constructor(j,A){this.description=j,this.convert=A}}e.$VP=l;class ${constructor(j,A,O,F,V){this.id=j,this.internalId=A,this.description=O,this.args=F,this.result=V}}e.$WP=$}),define(ye[299],Ee([1,0,11,2,13,233]),function(he,e,o,C,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FQ=e.$EQ=void 0,e.$EQ="remoteFilesystem";class I extends D.$DQ{static register(b,g,y){const v=b.getConnection();if(!v)return C.$Vc.None;const w=new C.$Uc,m=(async()=>{try{const u=await b.getRawEnvironment();u?g.registerProvider(S.Schemas.vscodeRemote,w.add(new I(u,v))):y.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(u){y.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,o.$0)(u))}})();return w.add(g.onWillActivateFileSystemProvider(u=>{u.scheme===S.Schemas.vscodeRemote&&u.join(m)})),w}constructor(b,g){super(g.getChannel(e.$EQ),{pathCaseSensitive:b.os===3})}}e.$FQ=I}),define(ye[73],Ee([1,0,90,78,30,300,15,11,6,2,7,3,22,46,107]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qi=e.$ni=e.$mi=e.$li=void 0,e.$oi=r,e.$pi=i,e.$ri=$,e.$si=k;class a{traceSocketEvent(A,O){u.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,A,O)}constructor(A,O=""){this.f=!0,this.debugLabel=O,this.socket=A,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=F=>{if(this.traceSocketEvent("error",{code:F?.code,message:F?.message}),F){if(F.code==="EPIPE")return;(0,P.$1)(F)}},this.socket.on("error",this.a),this.b=F=>{this.traceSocketEvent("close",{hadError:F}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(A){const O=F=>{this.traceSocketEvent("read",F),A(I.$Ge.wrap(F))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(A){const O=F=>{A({type:0,hadError:F,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(A){const O=()=>{A()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(A){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",A),this.socket.write(A.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,P.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,P.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((A,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),A();return}const F=()=>{this.socket.off("close",F),this.socket.off("end",F),this.socket.off("error",F),this.socket.off("timeout",F),this.socket.off("drain",F),this.traceSocketEvent("nodeDrainEnd"),A()};this.socket.on("close",F),this.socket.on("end",F),this.socket.on("error",F),this.socket.on("timeout",F),this.socket.on("drain",F)})}}e.$li=a;var f;(function(j){j[j.MinHeaderByteSize=2]="MinHeaderByteSize",j[j.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(f||(f={}));var c;(function(j){j[j.PeekHeader=1]="PeekHeader",j[j.ReadHeader=2]="ReadHeader",j[j.ReadBody=3]="ReadBody",j[j.Fin=4]="Fin"})(c||(c={}));class d extends g.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(A,O){this.socket.traceSocketEvent(A,O)}constructor(A,O,F,V){super(),this.f=this.B(new b.$ee),this.g=this.B(new b.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=A,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:F?.byteLength||0,recordInflateBytes:V}),this.a=this.B(new p(this,O,F,V,this.f,(Z,oe)=>this.m(Z,oe))),this.B(this.a.onError(Z=>{console.error(Z),(0,P.$1)(Z),this.g.fire({type:0,hadError:!0,error:Z})})),this.b=new u.$gi,this.B(this.socket.onData(Z=>this.n(Z))),this.B(this.socket.onClose(async Z=>{this.a.isProcessingReadQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(Z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(A){return this.f.event(A)}onClose(A){return this.g.event(A)}onEnd(A){return this.socket.onEnd(A)}write(A){let O=0;for(;O<A.byteLength;)this.a.writeMessage(A.slice(O,Math.min(O+262144,A.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(A,{compressed:O,opcode:F}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",A);let V=2;A.byteLength<126?V+=0:A.byteLength<2**16?V+=2:V+=8;const Z=I.$Ge.alloc(V),oe=O?64:0,le=F&15;if(Z.writeUInt8(128|oe|le,0),A.byteLength<126)Z.writeUInt8(A.byteLength,1);else if(A.byteLength<2**16){Z.writeUInt8(126,1);let te=1;Z.writeUInt8(A.byteLength>>>8&255,++te),Z.writeUInt8(A.byteLength>>>0&255,++te)}else{Z.writeUInt8(127,1);let te=1;Z.writeUInt8(0,++te),Z.writeUInt8(0,++te),Z.writeUInt8(0,++te),Z.writeUInt8(0,++te),Z.writeUInt8(A.byteLength>>>24&255,++te),Z.writeUInt8(A.byteLength>>>16&255,++te),Z.writeUInt8(A.byteLength>>>8&255,++te),Z.writeUInt8(A.byteLength>>>0&255,++te)}this.socket.write(I.$Ge.concat([Z,A]))}end(){this.h=!0,this.socket.end()}n(A){if(A.byteLength!==0){for(this.b.acceptChunk(A);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),F=O.readUInt8(0),V=(F&128)>>>7,Z=(F&64)>>>6,oe=F&15,le=O.readUInt8(1),te=(le&128)>>>7,_=le&127;this.j.state=2,this.j.readLen=2+(te?4:0)+(_===126?2:0)+(_===127?8:0),this.j.fin=V,this.j.firstFrameOfMessage&&(this.j.compressed=!!Z),this.j.firstFrameOfMessage=!!V,this.j.mask=0,this.j.opcode=oe,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),F=O.readUInt8(1),V=(F&128)>>>7;let Z=F&127,oe=1;Z===126?Z=O.readUInt8(++oe)*2**8+O.readUInt8(++oe):Z===127&&(Z=O.readUInt8(++oe)*0+O.readUInt8(++oe)*0+O.readUInt8(++oe)*0+O.readUInt8(++oe)*0+O.readUInt8(++oe)*2**24+O.readUInt8(++oe)*2**16+O.readUInt8(++oe)*2**8+O.readUInt8(++oe));let le=0;V&&(le=O.readUInt8(++oe)*2**24+O.readUInt8(++oe)*2**16+O.readUInt8(++oe)*2**8+O.readUInt8(++oe)),this.j.state=3,this.j.readLen=Z,this.j.mask=le,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await b.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$mi=d;class p extends g.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$Ge.alloc(0)}constructor(A,O,F,V,Z,oe){super(),this.n=A,this.r=Z,this.s=oe,this.a=this.B(new b.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new b.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new b.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new E(this.n,V,F,{windowBits:15})),this.f=this.B(new h(this.n,{windowBits:15})),this.B(this.b.onError(le=>this.a.fire(le))),this.B(this.f.onError(le=>this.a.fire(le)))):(this.b=null,this.f=null)}writeMessage(A,O){this.g.push({data:A,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:A,options:O}=this.g.shift();if(this.f&&O.compressed){const F=await this.w(this.f,A);this.s(F,O)}else this.s(A,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(A,O){return new Promise((F,V)=>{A.write(O),A.flush(Z=>F(Z))})}acceptFrame(A,O,F){this.h.push({data:A,isCompressed:O,isLastFrameOfMessage:F}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const A=this.h.shift();if(this.b&&A.isCompressed){const O=await this.C(this.b,A.data,A.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(A.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(A,O,F){return new Promise((V,Z)=>{A.write(O),F&&A.write(I.$Ge.fromByteArray([0,0,255,255])),A.flush(oe=>V(oe))})}}class E extends g.$Vc{get recordedInflateBytes(){return this.j?I.$Ge.concat(this.f):I.$Ge.alloc(0)}constructor(A,O,F,V){super(),this.h=A,this.j=O,this.a=this.B(new b.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,D.createInflateRaw)(V),this.b.on("error",Z=>{this.h.traceSocketEvent("zlibInflateError",{message:Z?.message,code:Z?.code}),this.a.fire(Z)}),this.b.on("data",Z=>{this.h.traceSocketEvent("zlibInflateData",Z),this.g.push(I.$Ge.wrap(Z))}),F&&(this.h.traceSocketEvent("zlibInflateInitialWrite",F.buffer),this.b.write(F.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(A){this.j&&this.f.push(A.clone()),this.h.traceSocketEvent("zlibInflateWrite",A),this.b.write(A.buffer)}flush(A){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=I.$Ge.concat(this.g);this.g.length=0,A(O)})}}class h extends g.$Vc{constructor(A,O){super(),this.g=A,this.a=this.B(new b.$ee),this.onError=this.a.event,this.f=[],this.b=(0,D.createDeflateRaw)({windowBits:15}),this.b.on("error",F=>{this.g.traceSocketEvent("zlibDeflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.g.traceSocketEvent("zlibDeflateData",F),this.f.push(I.$Ge.wrap(F))})}write(A){this.g.traceSocketEvent("zlibDeflateWrite",A.buffer),this.b.write(A.buffer)}flush(A){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=I.$Ge.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),A(O)})}}function t(j,A){if(A===0)return;const O=j.byteLength>>>2;for(let te=0;te<O;te++){const _=j.readUInt32BE(te*4);j.writeUInt32BE(_^A,te*4)}const F=O*4,V=j.byteLength-F,Z=A>>>24&255,oe=A>>>16&255,le=A>>>8&255;V>=1&&j.writeUInt8(j.readUInt8(F)^Z,F),V>=2&&j.writeUInt8(j.readUInt8(F+1)^oe,F+1),V>=3&&j.writeUInt8(j.readUInt8(F+2)^le,F+2)}e.$ni=process.env.XDG_RUNTIME_DIR;const s={2:107,1:103};function r(){const j=(0,w.$Sg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${j}-sock`;const A=process.platform!=="darwin"&&e.$ni?e.$ni:(0,S.tmpdir)(),O=(0,y.$kc)(A,`vscode-ipc-${j}.sock`);return n(O),O}function i(j,A,O){const V=(0,o.createHash)("sha256").update(j).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${V}-${O}-${A}-sock`;const Z=O.substr(0,4),oe=A.substr(0,6);let le;return process.platform!=="darwin"&&e.$ni&&!process.env.VSCODE_PORTABLE?le=(0,y.$kc)(e.$ni,`vscode-${V}-${Z}-${oe}.sock`):le=(0,y.$kc)(j,`${Z}-${oe}.sock`),n(le),le}function n(j){const A=s[v.$u];typeof A=="number"&&j.length>=A&&console.warn(`WARNING: IPC handle "${j}" is longer than ${A} chars, try a shorter --user-data-dir`)}class l extends m.$ai{static b(A){const O=b.Event.fromNodeEventEmitter(A,"connection");return b.Event.map(O,F=>({protocol:new u.$hi(new a(F,"ipc-server-connection")),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(F,"close"))}))}constructor(A){super(l.b(A)),this.d=A}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$qi=l;function $(j){return new Promise((A,O)=>{const F=(0,C.createServer)();F.on("error",O),F.listen(j,()=>{F.removeListener("error",O),A(new l(F))})})}function k(j,A){return new Promise((O,F)=>{const V=(0,C.createConnection)(j,()=>{V.removeListener("error",F),O(u.$ii.fromSocket(new a(V,`ipc-client${A}`),A))});V.once("error",F)})}}),define(ye[143],Ee([1,0,87,14,15,11,10,25,26,88,12,42,250,300]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0,e.$Yr=f;let u=class extends v.$Op{constructor(d,p,E,h){super(h),this.m=d,this.n=p,this.r=E,this.s(),this.B(d.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,p){const{f:E,g:h}=this;let t;try{t=await(0,g.$Gm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,D.$0)(i)))}const s={...process.env,...t},r=d.agent?d.agent:await(0,w.$Wr)(d.url||"",s,{proxyUrl:E,strictSSL:h});return d.agent=r,d.strictSSL=h,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>f(d,p))}async resolveProxy(d){}async loadCertificates(){return(await new Promise((p,E)=>{he(["@vscode/proxy-agent"],p,E)})).loadSystemCertificates({log:this.r})}};e.$Xr=u,e.$Xr=u=Le([Ne(0,P.$3i),Ne(1,b.$Ei),Ne(2,y.$3j),Ne(3,y.$4j)],u);async function a(c){return((0,o.parse)(c.url).protocol==="https:"?await new Promise((E,h)=>{he(["https"],E,h)}):await new Promise((E,h)=>{he(["http"],E,h)})).request}async function f(c,d){return C.Promises.withAsyncBody(async(p,E)=>{const h=(0,o.parse)(c.url),t=c.getRawRequest?c.getRawRequest(c):await a(c),s={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,I.$cg)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(s.auth=c.user+":"+c.password);const r=t(s,i=>{const n=(0,I.$ag)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)f({...c,url:i.headers.location,followRedirects:n-1},d).then(p,E);else{let l=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(l=i.pipe((0,m.createGunzip)())),p({res:i,stream:(0,S.$Ve)(l)})}});r.on("error",E),c.timeout&&r.setTimeout(c.timeout),c.isChromiumNetwork&&r.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&r.write(c.data),r.end(),d.onCancellationRequested(()=>{r.abort(),E(new D.$5)})})}}),define(ye[144],Ee([1,0,56,78,133,13,7,15,6,73,88,12,51,3,66,132,2,290,25]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0,e.$pn=p;async function p(i={},n,l,$,k,j){const A=await(0,S.$am)(l,$.userDataPath);let O={};if(n)try{O=await(0,y.$Gm)(j,k,$.args,process.env)}catch(te){k.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",te)}const V={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(A,void 0,0),...i},Z=$.isBuilt?(0,I.$kc)($.appRoot,"bin"):(0,I.$kc)($.appRoot,"resources","server","bin-dev"),oe=(0,I.$kc)(Z,"remote-cli");let le=t(V,"PATH");return le?le=oe+I.$uc+le:le=oe,s(V,"PATH",le),$.args["without-browser-env-var"]||(V.BROWSER=(0,I.$kc)(Z,"helpers",m.$i?"browser.cmd":"browser.sh")),r(V),V}class E{constructor(n,l){this.socket=n,this.initialDataChunk=l}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let n,l,$;return this.socket instanceof g.$li?(n=!0,l=!1,$=P.$Ge.alloc(0)):(n=!1,l=this.socket.permessageDeflate,$=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:n,permessageDeflate:l,inflateBytes:$.buffer.toString("base64")}}}let h=class{constructor(n,l,$,k,j,A,O,F){this.i=n,this.j=j,this.l=A,this.m=O,this.n=F,this.b=new b.$ee,this.onClose=this.b.event,this.c=!m.$i||!this.j.args["socket-path"],this.d=!1,this.f=l,this.g=null,this.h=new E($,k),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(n){this.l.info(`${this.o}${n}`)}q(n){this.l.error(`${this.o}${n}`)}async r(n,l){const $=new f.$Uc;$.add(l.socket),$.add((0,f.$Tc)(()=>{n.destroy()}));const k=()=>{$.dispose()};$.add(l.socket.onEnd(k)),$.add(l.socket.onClose(k)),$.add(b.Event.fromNodeEventEmitter(n,"end")(k)),$.add(b.Event.fromNodeEventEmitter(n,"close")(k)),$.add(b.Event.fromNodeEventEmitter(n,"error")(k)),$.add(l.socket.onData(j=>n.write(j.buffer))),$.add(b.Event.fromNodeEventEmitter(n,"data")(j=>{l.socket.write(P.$Ge.wrap(j))})),l.initialDataChunk.byteLength>0&&n.write(l.initialDataChunk.buffer)}async s(n,l){await l.socketDrain();const $=l.toIExtHostSocketMessage();let k;l.socket instanceof g.$li?k=l.socket.socket:k=l.socket.socket.socket,n.send($,k)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const n={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(n)}acceptReconnection(n,l,$){this.f=n,this.p("The client has reconnected.");const k=new E(l,$);if(!this.g){this.h=k;return}this.s(this.g,k)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(n){try{let l=process.execArgv?process.execArgv.filter(oe=>!/^--inspect(-brk)?=/.test(oe)):[];n.port&&!process.pkg&&(l=[`--inspect${n.break?"-brk":""}=${n.port}`]);const $=await p(n.env,!0,n.language,this.j,this.l,this.n);(0,u.$nm)($);let k;if(this.c)(0,c.$nn)(new c.$ln,$),k=null;else{const{namedPipeServer:oe,pipeName:le}=await this.u();(0,c.$nn)(new c.$kn(le),$),k=oe}const j={env:$,execArgv:l,silent:!0};j.execArgv.unshift("--dns-result-order=ipv4first");const A=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];A.push(`--useHostProxy=${O?"true":"false"}`),this.g=o.fork(D.$Qg.asFileUri("bootstrap-fork").fsPath,A,j);const F=this.g.pid;this.p(`<${F}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const V=b.Event.fromNodeEventEmitter(this.g.stdout,"data"),Z=b.Event.fromNodeEventEmitter(this.g.stderr,"data");if(V(oe=>this.p(`<${F}> ${oe}`)),Z(oe=>this.p(`<${F}><stderr> ${oe}`)),this.g.on("error",oe=>{this.q(`<${F}> Extension Host Process had an error`),this.l.error(oe),this.t()}),this.g.on("exit",(oe,le)=>{this.m.setExitInfo(this.i,{code:oe,signal:le}),this.p(`<${F}> Extension Host Process exited with code: ${oe}, signal: ${le}.`),this.t()}),k)k.on("connection",oe=>{k.close(),this.r(oe,this.h)});else{const oe=le=>{le.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",oe),this.s(this.g,this.h),this.h=null)};this.g.on("message",oe)}}catch(l){console.error("ExtensionHostConnection errored"),l&&console.error(l)}}u(){return new Promise((n,l)=>{const $=(0,g.$oi)(),k=C.createServer();k.on("error",l),k.listen($,()=>{k?.removeListener("error",l),n({pipeName:$,namedPipeServer:k})})})}};e.$qn=h,e.$qn=h=Le([Ne(4,w.$an),Ne(5,v.$3j),Ne(6,a.$in),Ne(7,d.$3i)],h);function t(i,n){const l=Object.keys(i).filter(k=>k.toLowerCase()===n.toLowerCase()),$=l.length>0?l[0]:n;return i[$]}function s(i,n,l){const $=Object.keys(i).filter(j=>j.toLowerCase()===n.toLowerCase()),k=$.length>0?$[0]:n;i[k]=l}function r(i){for(const n of Object.keys(i))i[n]===null&&delete i[n]}}),define(ye[301],Ee([1,0,84,12,68,118,25,42,143,37,29,32,130,127,89,112,58,2,113,69,13,16,28,51,121,85,122,11,4,7,31,248,83,34,126,67,3,59,134,33,50,70,131,128,115,116,213,302]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h,t,s,r,i,n,l,$,k,j,A,O,F,V,Z,oe,le,te,_,W,K,Y,M,Q,ce,ie,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=B;class re extends c.$Vc{constructor(z,J){super(),this.a=z,this.b=J,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const z=await this.f();await z.invokeFunction(async J=>{const ue=J.get(I.$3i),x=J.get(C.$3j);oe.$i&&(ue.getValue("security.restrictUNCAccess")===!1?(0,be.disableUNCAccessRestrictions)():(0,be.addUNCHostToAllowlist)(ue.getValue("security.allowedUNCHosts")));try{await this.g(z.createInstance(r.$cq,new C.$$j(x.getLevel(),!1)))}catch(G){throw x.error(G),console.error((0,l.$0)(G)),G}})}async f(){const z=new o.$ui,J={_serviceBrand:void 0,...f.default};z.set(t.$jk,J);const ue=new s.$bn(this.a,J);z.set(s.$an,ue);const x=new ce.$KQ((0,C.$ek)(ue),ue.logsHome);z.set(C.$4j,x);const G=new Q.$UQ(this.B(x.createLogger("remoteCLI",{name:(0,ie.localize)(0,null)})));z.set(C.$3j,G),G.trace(`Remote configuration data at ${this.b}`),G.trace("process arguments:",this.a);const U=this.B(new d.$Iq(G));z.set(h.$3k,U),U.registerProvider(E.Schemas.file,this.B(new p.$_q(G)));const T=new V.$As(U);z.set(F.$Al,T);const q=this.B(new Y.$SQ(T,ue,U,G));z.set(_.$Cl,q);const se=this.B(new D.$Go(q.defaultProfile.settingsResource,U,new K.$go,G));return z.set(I.$3i,se),await Promise.all([se.initialize(),q.init()]),z.set(P.$Np,new S.$ti(b.$Xr)),z.set(O.$Ko,new S.$ti(A.$0Q)),z.set(y.$2l,g.$hp),z.set(v.$6o,new S.$ti(w.$$p)),z.set(W.$pq,new S.$ti(M.$TQ)),z.set(le.$tq,new S.$ti(te.$GQ)),z.set(u.$_p,new S.$ti(u.$bq)),z.set(m.$Dq,new S.$ti(m.$Eq)),z.set(i.$Rr,new S.$ti(n.$Tr)),new a.$cr(z)}async g(z){if(this.a["list-extensions"])return z.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const J={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return z.installExtensions(this.h(this.a["install-extension"]||[]),this.h(this.a["install-builtin-extension"]||[]),J,!!this.a.force)}else{if(this.a["uninstall-extension"])return z.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["update-extensions"])return z.updateExtensions();if(this.a["locate-extension"])return z.locateExtension(this.a["locate-extension"])}}h(z){return z.map(J=>/\.vsix$/i.test(J)?$.URI.file((0,k.$jc)(J)?J:(0,k.$kc)((0,j.cwd)(),J)):J)}}function X(N){setTimeout(()=>process.exit(N),0)}async function B(N,z,J){if(N.help){const x=f.default.serverApplicationName+(oe.$i?".cmd":"");console.log((0,Z.$vm)(f.default.nameLong,x,f.default.version,J,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,Z.$wm)(f.default.version,f.default.commit));return}const ue=new re(N,z);try{await ue.run(),X(0)}catch{X(1)}finally{ue.dispose()}}}),define(ye[303],Ee([1,0,73,315,27,298,4,12,93]),function(he,e,o,C,S,D,I,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YP=e.$XP=void 0;class g{constructor(w,m,u){this.b=w,this.c=m,this.f=u,this.a=C.createServer((a,f)=>this.h(a,f)),this.g().catch(a=>(m.error(a),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,m){const u=(f,c)=>{m.writeHead(f,{"content-type":"application/json"}),m.end(JSON.stringify(c||null),d=>d&&this.c.error(d))},a=[];w.setEncoding("utf8"),w.on("data",f=>a.push(f)),w.on("end",async()=>{try{const f=JSON.parse(a.join(""));let c;switch(f.type){case"open":c=await this.i(f);break;case"openExternal":c=await this.j(f);break;case"status":c=await this.l(f);break;case"extensionManagement":c=await this.k(f);break;default:u(404,`Unknown message type: ${f.type}`);break}u(200,c)}catch(f){const c=f instanceof Error?f.message:JSON.stringify(f);u(500,c),this.c.error("Error while processing pipe request",f)}})}async i(w){const{fileURIs:m,folderURIs:u,forceNewWindow:a,diffMode:f,mergeMode:c,addMode:d,forceReuseWindow:p,gotoLineMode:E,waitMarkerFilePath:h,remoteAuthority:t}=w,s=[];if(Array.isArray(u))for(const l of u)try{s.push({folderUri:I.URI.parse(l)})}catch{}if(Array.isArray(m))for(const l of m)try{(0,b.$2i)(l)?s.push({workspaceUri:I.URI.parse(l)}):s.push({fileUri:I.URI.parse(l)})}catch{}const r=h?I.URI.file(h):void 0,n={forceNewWindow:a,diffMode:f,mergeMode:c,addMode:d,gotoLineMode:E,forceReuseWindow:p,preferNewWindow:!p&&!r&&!d,waitMarkerFileURI:r,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",s,n)}async j(w){for(const m of w.uris){const u=I.URI.parse(m),a=u.scheme==="file"?u:m;await this.b.executeCommand("_remoteCLI.openExternal",a)}}async k(w){const m=a=>a?.map(f=>/\.vsix$/i.test(f)?I.URI.parse(f):f),u={list:w.list,install:m(w.install),uninstall:m(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",u)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&S.existsSync(this.f)&&S.unlinkSync(this.f)}}e.$XP=g;let y=class extends g{constructor(w,m){super(w,m,(0,o.$oi)())}};e.$YP=y,e.$YP=y=Le([Ne(0,D.$SP),Ne(1,P.$3j)],y)}),define(ye[304],Ee([1,0,30,6,21,2,7,3,4,73,71,303,124,91,285,287,144,14,125]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;class p extends a.$yQ{constructor(t,s,r,i,n){super({getFolderUri:l=>{const $=s.filter(k=>k.name===l);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>s.length,getConfigurationValue:(l,$)=>i[`config:${$}`],getExecPath:()=>t.VSCODE_EXEC_PATH,getAppRoot:()=>t.VSCODE_CWD,getFilePath:()=>{if(r)return I.$ic(r.fsPath)},getSelectedText:()=>i.selectedText,getLineNumber:()=>i.lineNumber,getExtension:async l=>{const k=(await n.getInstalled()).find(j=>j.identifier.id===l);return k&&{extensionLocation:k.location}}},void 0,Promise.resolve(o.homedir()),Promise.resolve(t))}}class E extends D.$Vc{constructor(t,s,r,i,n,l){super(),this.g=t,this.h=s,this.j=r,this.m=i,this.n=n,this.r=l,this.a=0,this.b=new Map,this.c=this.B(new C.$ee),this.onExecuteCommand=this.c.event}async call(t,s,r){switch(s){case"$restartPtyHost":return this.j.restartPtyHost.apply(this.j,r);case"$createProcess":{const i=(0,y.$Bs)(t.remoteAuthority);return this.s(i,r)}case"$attachToProcess":return this.j.attachToProcess.apply(this.j,r);case"$detachFromProcess":return this.j.detachFromProcess.apply(this.j,r);case"$listProcesses":return this.j.listProcesses.apply(this.j,r);case"$getLatency":return this.j.getLatency.apply(this.j,r);case"$getPerformanceMarks":return this.j.getPerformanceMarks.apply(this.j,r);case"$orphanQuestionReply":return this.j.orphanQuestionReply.apply(this.j,r);case"$acceptPtyHostResolvedVariables":return this.j.acceptPtyHostResolvedVariables.apply(this.j,r);case"$start":return this.j.start.apply(this.j,r);case"$input":return this.j.input.apply(this.j,r);case"$acknowledgeDataEvent":return this.j.acknowledgeDataEvent.apply(this.j,r);case"$shutdown":return this.j.shutdown.apply(this.j,r);case"$resize":return this.j.resize.apply(this.j,r);case"$clearBuffer":return this.j.clearBuffer.apply(this.j,r);case"$getInitialCwd":return this.j.getInitialCwd.apply(this.j,r);case"$getCwd":return this.j.getCwd.apply(this.j,r);case"$processBinary":return this.j.processBinary.apply(this.j,r);case"$sendCommandResult":return this.u(r[0],r[1],r[2]);case"$installAutoReply":return this.j.installAutoReply.apply(this.j,r);case"$uninstallAllAutoReplies":return this.j.uninstallAllAutoReplies.apply(this.j,r);case"$getDefaultSystemShell":return this.w.apply(this,r);case"$getProfiles":return this.y.apply(this,r);case"$getEnvironment":return this.z();case"$getWslPath":return this.C(r[0],r[1]);case"$getTerminalLayoutInfo":return this.j.getTerminalLayoutInfo(r);case"$setTerminalLayoutInfo":return this.j.setTerminalLayoutInfo(r);case"$serializeTerminalState":return this.j.serializeTerminalState.apply(this.j,r);case"$reviveTerminalProcesses":return this.j.reviveTerminalProcesses.apply(this.j,r);case"$getRevivedPtyNewId":return this.j.getRevivedPtyNewId.apply(this.j,r);case"$setUnicodeVersion":return this.j.setUnicodeVersion.apply(this.j,r);case"$reduceConnectionGraceTime":return this.D();case"$updateIcon":return this.j.updateIcon.apply(this.j,r);case"$updateTitle":return this.j.updateTitle.apply(this.j,r);case"$updateProperty":return this.j.updateProperty.apply(this.j,r);case"$refreshProperty":return this.j.refreshProperty.apply(this.j,r);case"$requestDetachInstance":return this.j.requestDetachInstance(r[0],r[1]);case"$acceptDetachedInstance":return this.j.acceptDetachInstanceReply(r[0],r[1]);case"$freePortKillProcess":return this.j.freePortKillProcess.apply(this.j,r);case"$acceptDetachInstanceReply":return this.j.acceptDetachInstanceReply.apply(this.j,r)}throw new Error(`IPC Command ${s} not found`)}listen(t,s,r){switch(s){case"$onPtyHostExitEvent":return this.j.onPtyHostExit||C.Event.None;case"$onPtyHostStartEvent":return this.j.onPtyHostStart||C.Event.None;case"$onPtyHostUnresponsiveEvent":return this.j.onPtyHostUnresponsive||C.Event.None;case"$onPtyHostResponsiveEvent":return this.j.onPtyHostResponsive||C.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.j.onPtyHostRequestResolveVariables||C.Event.None;case"$onProcessDataEvent":return this.j.onProcessData;case"$onProcessReadyEvent":return this.j.onProcessReady;case"$onProcessExitEvent":return this.j.onProcessExit;case"$onProcessReplayEvent":return this.j.onProcessReplay;case"$onProcessOrphanQuestion":return this.j.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.j.onDidRequestDetach||C.Event.None;case"$onDidChangeProperty":return this.j.onDidChangeProperty}throw new Error(`IPC Command ${s} not found`)}async s(t,s){const r={name:s.shellLaunchConfig.name,executable:s.shellLaunchConfig.executable,args:s.shellLaunchConfig.args,cwd:typeof s.shellLaunchConfig.cwd=="string"||typeof s.shellLaunchConfig.cwd>"u"?s.shellLaunchConfig.cwd:b.URI.revive(t.transformIncoming(s.shellLaunchConfig.cwd)),env:s.shellLaunchConfig.env,useShellEnvironment:s.shellLaunchConfig.useShellEnvironment,reconnectionProperties:s.shellLaunchConfig.reconnectionProperties,type:s.shellLaunchConfig.type,isFeatureTerminal:s.shellLaunchConfig.isFeatureTerminal},i=await(0,f.$pn)(s.resolverEnv,!!s.shellLaunchConfig.useShellEnvironment,P.$w,this.g,this.h,this.r);this.h.trace("baseEnv",i);const n=W=>({uri:b.URI.revive(t.transformIncoming(W.uri)),name:W.name,index:W.index,toResource:()=>{throw new Error("Not implemented")}}),l=s.workspaceFolders.map(n),$=s.activeWorkspaceFolder?n(s.activeWorkspaceFolder):void 0,k=s.activeFileResource?b.URI.revive(t.transformIncoming(s.activeFileResource)):void 0,j=new p(i,l,k,s.resolvedVariables,this.n),A=u.$uQ($,process.env,j),O=await u.$tQ(r,o.homedir(),A,$?.uri,s.configuration["terminal.integrated.cwd"],this.h);r.cwd=O;const F=P.$i?"terminal.integrated.env.windows":P.$j?"terminal.integrated.env.osx":"terminal.integrated.env.linux",V=s.configuration[F],Z=await u.$vQ(r,V,A,this.m.version,s.configuration["terminal.integrated.detectLocale"],i);if((0,d.$nQ)(r)){const W=[];for(const[Q,ce,ie]of s.envVariableCollections)W.push([Q,{map:(0,m.$ns)(ce),descriptionMap:(0,m.$os)(ie)}]);const K=new Map(W),Y=new w.$rs(K),M=$?$??void 0:void 0;await Y.applyToProcessEnvironment(Z,{workspaceFolder:M},A)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:r,initialCwd:O,cols:s.cols,rows:s.rows,env:Z});const oe=(0,g.$oi)();Z.VSCODE_IPC_HOOK_CLI=oe;const le=await this.j.createProcess(r,O,s.cols,s.rows,s.unicodeVersion,Z,i,s.options,s.shouldPersistTerminal,s.workspaceId,s.workspaceName),te={executeCommand:(W,...K)=>this.t(le,W,K,t)},_=new v.$XP(te,this.h,oe);return this.j.onProcessExit(W=>W.id===le&&_.dispose()),{persistentTerminalId:le,resolvedShellLaunchConfig:r}}t(t,s,r,i){const{resolve:n,reject:l,promise:$}=(0,c.$ph)(),k=++this.a;this.b.set(k,{resolve:n,reject:l,uriTransformer:i});const j=(0,S.$5n)(r,A=>{if(A&&A.$mid===1)return i.transformOutgoing(A);if(A&&A instanceof b.URI)return i.transformOutgoingURI(A)});return this.c.fire({reqId:k,persistentProcessId:t,commandId:s,commandArgs:j}),$}u(t,s,r){const i=this.b.get(t);if(!i)return;this.b.delete(t);const n=(0,S.$5n)(r,l=>{if(l&&l.$mid===1)return i.uriTransformer.transformIncoming(l)});s?i.reject(n):i.resolve(n)}w(t){return this.j.getDefaultSystemShell(t)}async y(t,s,r,i){return this.j.getProfiles(t,s,r,i)||[]}z(){return{...process.env}}C(t,s){return this.j.getWslPath(t,s)}D(){return this.j.reduceConnectionGraceTime()}}e.$zQ=E}),define(ye[305],Ee([1,0,30,6,2,13,7,102,23,46,25,118,222,83,223,26,130,32,89,121,232,127,16,113,69,68,112,84,85,122,12,58,28,42,249,143,120,29,37,263,92,270,34,126,280,281,254,261,304,71,51,289,299,132,59,134,50,33,70,262,116,131,128,115,114,215,294,246,273,267]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h,t,s,r,i,n,l,$,k,j,A,O,F,V,Z,oe,le,te,_,W,K,Y,M,Q,ce,ie,be,re,X,B,N,z,J,ue,x,G,U,T,q,se,ae,me,ee,ge,$e,Ce,je,de,Pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5Q=void 0,e.$4Q=Me;const De="monacoworkbench";async function Me(xe,pe,Ie,Re){const Ae=new l.$ui,Te=new Ve,Qe={_serviceBrand:void 0,...A.default};Ae.set(O.$jk,Qe);const He=new B.$bn(pe,Qe);Ae.set(a.$Di,He),Ae.set(a.$Ei,He);const Je=new se.$KQ((0,j.$ek)(He),He.logsHome);Ae.set(j.$4j,Je),Te.registerChannel("logger",new ge.$as(Je,rt=>Ue(rt.remoteAuthority)));const it=Je.createLogger("remoteagent",{name:(0,$e.localize)(0,null)}),Ke=new ee.$UQ(it,[new Ge((0,j.$ek)(He))]);Ae.set(j.$3j,Ke),setTimeout(()=>et(He.logsHome.with({scheme:D.Schemas.file}).fsPath).then(null,rt=>Ke.error(rt)),1e4),Ke.onDidChangeLogLevel(rt=>(0,j.log)(Ke,rt,`Log level changed to ${(0,j.$fk)(Ke.getLevel())}`)),Ke.trace(`Remote configuration data at ${Ie}`),Ke.trace("process arguments:",He.args),Array.isArray(Qe.serverGreeting)&&Ke.info(`

${Qe.serverGreeting.join(`
`)}

`),Te.registerChannel(w.$Io.ChannelName,new w.$Io);const nt=new g.$ei(rt=>rt.clientId==="renderer"),ot=Re.add(new s.$Iq(Ke));Ae.set(t.$3k,ot),ot.registerProvider(D.Schemas.file,Re.add(new r.$_q(Ke)));const at=new M.$As(ot);Ae.set(Y.$Al,at);const lt=new v.$Go(He.machineSettingsResource,ot,new T.$go,Ke);Ae.set(y.$3i,lt);const ht=new ae.$SQ(at,He,ot,Ke);Ae.set(U.$Cl,ht),Te.registerChannel("userDataProfiles",new de.$1Q(ht,rt=>Ue(rt.remoteAuthority)));const[,,kt,At]=await Promise.all([lt.initialize(),ht.init(),(0,P.$Fn)(Ke.error.bind(Ke)),(0,P.$Gn)(Ke.error.bind(Ke))]),bt=new J.$jn;Ae.set(J.$in,bt);const Lt=new Z.$Xr(lt,He,Ke,Je);Ae.set(F.$Np,Lt);let Dt=te.$lp;const Pt=(0,te.$rp)(Qe,lt);if((0,te.$mp)(Qe,He)){!(0,te.$np)(Qe,He)&&Qe.aiConfig?.ariaKey&&(Dt=new q.$IQ(Lt,Pt,De,null,Qe.aiConfig.ariaKey),Re.add((0,S.$Tc)(()=>Dt?.flush())));const rt={appenders:[Dt],commonProperties:(0,oe.$dp)((0,o.release)(),(0,o.hostname)(),process.arch,Qe.commit,Qe.version+"-remote",kt,At,Pt,"remoteAgent"),piiPaths:(0,te.$sp)(He)},mt=He.args["telemetry-level"];let $t=3;mt==="all"?$t=3:mt==="error"?$t=2:mt==="crash"?$t=1:mt!==void 0&&($t=0),Ae.set(be.$Os,new i.$ti(be.$Ms,[rt,$t]))}else Ae.set(be.$Os,be.$Ns);Ae.set(c.$6o,new i.$ti(f.$$p));const Tt=Te.getChannel("download",nt);Ae.set(m.$Ko,new u.$Mo(Tt,()=>Ue("renderer"))),Ae.set(G.$pq,new i.$ti(me.$TQ)),Ae.set(ue.$tq,new i.$ti(x.$GQ)),Ae.set(d.$_p,new i.$ti(d.$bq)),Ae.set(h.$Dq,new i.$ti(h.$Eq));const dt=new n.$cr(Ae);Ae.set($.$Rr,dt.createInstance(k.$Tr));const Ot=dt.createInstance(Pe.$3Q,{graceTime:108e5,shortGraceTime:3e5,scrollback:lt.getValue("terminal.integrated.persistentSessionScrollback")??100}),gt=dt.createInstance(K.$ws,Ot);return Ae.set(W.$8r,gt),dt.invokeFunction(rt=>{const mt=rt.get(h.$Dq),$t=rt.get(ue.$tq),Ut=rt.get(c.$6o),en=rt.get($.$Rr),tn=new Q.$Is(xe,He,ht,bt);Te.registerChannel("remoteextensionsenvironment",tn);const Mt=new ie.$Ps(rt.get(be.$Os),Dt);Te.registerChannel("telemetry",Mt),Te.registerChannel(N.$AQ,new re.$zQ(He,Ke,gt,Qe,mt,lt));const zt=new Ce.$YQ(dt.createInstance(p.$cq,Ke),He,ht,$t,Ke,Ut,en);Te.registerChannel(je.$XQ,new Ce.$ZQ(zt,Nt=>Ue(Nt.remoteAuthority)));const Ht=new ce.$Ls(Ke,He);Te.registerChannel(z.$EQ,Ht),Te.registerChannel("request",new V.$Ur(rt.get(F.$Np)));const Wt=new E.$dq(mt,Nt=>Ue(Nt.remoteAuthority));return Te.registerChannel("extensions",Wt),zt.whenExtensionsReady().then(()=>mt.cleanUp()),Re.add(new _.default(rt.get(le.$2l))),{telemetryService:rt.get(le.$2l)}}),{socketServer:Te,instantiationService:dt}}const Fe=Object.create(null);function Ue(xe){return Fe[xe]||(Fe[xe]=(0,X.$Bs)(xe)),Fe[xe]}class Ve extends g.$ai{constructor(){const pe=new C.$ee;super(pe.event),this.b=pe}acceptConnection(pe,Ie){this.b.fire({protocol:pe,onDidClientDisconnect:Ie})}}e.$5Q=Ve;class Ge extends j.$8j{constructor(pe=j.$6j){super(),this.setLevel(pe),this.g=!!process.stdout.isTTY}trace(pe,...Ie){this.f(j.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,pe,...Ie):console.log(`[${Ze()}]`,pe,...Ie))}debug(pe,...Ie){this.f(j.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,pe,...Ie):console.log(`[${Ze()}]`,pe,...Ie))}info(pe,...Ie){this.f(j.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ze()}]\x1B[0m`,pe,...Ie):console.log(`[${Ze()}]`,pe,...Ie))}warn(pe,...Ie){this.f(j.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ze()}]\x1B[0m`,pe,...Ie):console.warn(`[${Ze()}]`,pe,...Ie))}error(pe,...Ie){this.f(j.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ze()}]\x1B[0m`,pe,...Ie):console.error(`[${Ze()}]`,pe,...Ie))}flush(){}}function Ze(){const xe=new Date;return`${_e(xe.getHours())}:${_e(xe.getMinutes())}:${_e(xe.getSeconds())}`}function _e(xe){return xe<10?`0${xe}`:String(xe)}async function et(xe){const pe=I.$oc(xe),Ie=I.$nc(xe),Te=(await b.Promises.readdir(Ie)).filter(He=>/^\d{8}T\d{6}$/.test(He)).sort().filter(He=>He!==pe),Qe=Te.slice(0,Math.max(0,Te.length-9));await Promise.all(Qe.map(He=>b.Promises.rm(I.$kc(Ie,He))))}}),define(ye[306],Ee([1,0,90,27,78,307,87,96,15,11,35,2,13,7,44,3,17,4,22,180,166,302,107,73,25,5,12,28,29,144,274,275,51,305,277]),function(he,e,o,C,S,D,I,P,b,g,y,v,w,m,u,a,f,c,d,p,E,h,t,s,r,i,n,l,$,k,j,A,O,F,V){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Q=le;const Z=5*60*1e3;let oe=class extends v.$Vc{constructor(W,K,Y,M,Q,ce,ie,be,re){super(),this.n=W,this.r=K,this.s=Y,this.t=ce,this.u=ie,this.w=be,this.y=re,this.h=te.create(this.u),this.j=(0,w.$Kg)(ie,Q),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=M?this.y.createInstance(V.$8Q,this.r,Q??"/",this.j):null,this.w.info("Extension host agent started."),this.L(!0)}async handleRequest(W,K){if(W.method!=="GET")return(0,V.$6Q)(W,K,405,`Unsupported method ${W.method}`);if(!W.url)return(0,V.$6Q)(W,K,400,"Bad request.");const Y=I.parse(W.url,!0);let M=Y.pathname;if(!M)return(0,V.$6Q)(W,K,400,"Bad request.");if(M.startsWith(this.j)&&M.charCodeAt(this.j.length)===47&&(M=M.substring(this.j.length)),M==="/version")return K.writeHead(200,{"Content-Type":"text/plain"}),void K.end(this.u.commit||"");if(M==="/delay-shutdown")return this.N(),K.writeHead(200),void K.end("OK");if(!(0,A.$xn)(this.r,W,Y))return(0,V.$6Q)(W,K,403,"Forbidden.");if(M==="/vscode-remote-resource"){const Q=Y.query.path;if(typeof Q!="string")return(0,V.$6Q)(W,K,400,"Bad request.");let ce;try{ce=c.URI.from({scheme:w.Schemas.file,path:Q}).fsPath}catch{return(0,V.$6Q)(W,K,400,"Bad request.")}const ie=Object.create(null);this.t.isBuilt&&((0,y.$vg)(ce,this.t.builtinExtensionsPath,!a.$k)||(0,y.$vg)(ce,this.t.extensionsPath,!a.$k))&&(ie["Cache-Control"]="public, max-age=31536000"),ie.Vary="Origin";const be=W.headers.origin;return be&&this.h.matches(be)&&(ie["Access-Control-Allow-Origin"]=be),(0,V.$7Q)(ce,1,this.w,W,K,ie)}if(this.g){this.g.handle(W,K,Y);return}return K.writeHead(404,{"Content-Type":"text/plain"}),void K.end("Not found")}handleUpgrade(W,K){let Y=(0,d.$Sg)(),M=!1,Q=!1;if(W.url){const B=I.parse(W.url,!0).query;typeof B.reconnectionToken=="string"&&(Y=B.reconnectionToken),B.reconnection==="true"&&(M=!0),B.skipWebSocketFrames==="true"&&(Q=!0)}if(W.headers.upgrade===void 0||W.headers.upgrade.toLowerCase()!=="websocket"){K.end("HTTP/1.1 400 Bad Request");return}const ce=W.headers["sec-websocket-key"],ie=o.createHash("sha1");ie.update(ce+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const re=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ie.digest("base64")}`];let X=!1;if(!Q&&!this.t.args["disable-websocket-compression"]&&W.headers["sec-websocket-extensions"]){const B=Array.isArray(W.headers["sec-websocket-extensions"])?W.headers["sec-websocket-extensions"]:[W.headers["sec-websocket-extensions"]];for(const N of B)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(N)){if(/\b(permessage-deflate)\b/.test(N)){X=!0,re.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(N)){X=!0,re.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}K.write(re.join(`\r
`)+`\r
\r
`),K.setTimeout(0),K.setNoDelay(!0),Q?this.D(new s.$li(K,`server-connection-${Y}`),M,Y):this.D(new s.$mi(new s.$li(K,`server-connection-${Y}`),X,null,!0),M,Y)}handleServerError(W){this.w.error("Error occurred in server"),this.w.error(W)}z(W){let K;return W instanceof s.$li?K=W.socket:K=W.socket.socket,K.remoteAddress||"<unknown>"}async C(W,K,Y){const M=K.getSocket();this.w.error(`${W} ${Y}.`);const Q={type:"error",reason:Y};K.sendControl(b.$Ge.fromString(JSON.stringify(Q))),K.dispose(),await M.drain(),M.dispose()}D(W,K,Y){const M=this.z(W),Q=`[${M}][${Y.substr(0,8)}]`,ce=new t.$ki({socket:W}),ie=this.s?new this.s.validator:null,be=this.s?new this.s.signer:null;let re;(function(z){z[z.WaitingForAuth=0]="WaitingForAuth",z[z.WaitingForConnectionType=1]="WaitingForConnectionType",z[z.Done=2]="Done",z[z.Error=3]="Error"})(re||(re={}));let X=0;const B=z=>{X=3,N.dispose(),this.C(Q,ce,z)},N=ce.onControlMessage(z=>{if(X===0){let J;try{J=JSON.parse(z.toString())}catch{return B("Malformed first message")}if(J.type!=="auth")return B("Invalid first message");if(this.r.type===2&&!this.r.validate(J.auth))return B("Unauthorized client refused: auth mismatch");let ue=(0,d.$Sg)();if(be)try{ue=be.sign(J.data)}catch{}let x=(0,d.$Sg)();if(ie)try{x=ie.createNewMessage(x)}catch{}const G={type:"sign",data:x,signedData:ue};ce.sendControl(b.$Ge.fromString(JSON.stringify(G))),X=1}else if(X===1){let J;try{J=JSON.parse(z.toString())}catch{return B("Malformed second message")}if(J.type!=="connectionType")return B("Invalid second message");if(typeof J.signedData!="string")return B("Invalid second message field type");const ue=J.commit,x=this.u.commit;if(ue&&x&&ue!==x)return B("Client refused: version mismatch");let G=!1;if(!ie)G=!0;else if(this.r.validate(J.signedData))G=!0;else try{G=ie.validate(J.signedData)==="ok"}catch{}if(!G){if(this.t.isBuilt)return B("Unauthorized client refused");this.w.error(`${Q} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const U in this.b)this.b[U].shortenReconnectionGraceTimeIfNecessary();for(const U in this.a)this.a[U].shortenReconnectionGraceTimeIfNecessary();X=2,N.dispose(),this.F(M,Q,ce,W,K,Y,J)}})}async F(W,K,Y,M,Q,ce,ie){const be=ie.desiredConnectionType===1?`${K}[ManagementConnection]`:ie.desiredConnectionType===2?`${K}[ExtensionHostConnection]`:K;if(ie.desiredConnectionType===1)if(Q){if(!this.b[ce])return this.f.has(ce)?this.C(be,Y,"Unknown reconnection token (seen before)"):this.C(be,Y,"Unknown reconnection token (never seen)");Y.sendControl(b.$Ge.fromString(JSON.stringify({type:"ok"})));const re=Y.readEntireBuffer();Y.dispose(),this.b[ce].acceptReconnection(W,M,re)}else{if(this.b[ce])return this.C(be,Y,"Duplicate reconnection token");Y.sendControl(b.$Ge.fromString(JSON.stringify({type:"ok"})));const re=new j.$rn(this.w,ce,W,Y);this.n.acceptConnection(re.protocol,re.onClose),this.b[ce]=re,this.f.add(ce),re.onClose(()=>{delete this.b[ce]})}else if(ie.desiredConnectionType===2){const re=ie.args||{language:"en"},X=await this.I(re);if(X.port&&this.w.trace(`${be} - startParams debug port ${X.port}`),this.w.trace(`${be} - startParams language: ${X.language}`),this.w.trace(`${be} - startParams env: ${JSON.stringify(X.env)}`),Q){if(!this.a[ce])return this.f.has(ce)?this.C(be,Y,"Unknown reconnection token (seen before)"):this.C(be,Y,"Unknown reconnection token (never seen)");Y.sendPause(),Y.sendControl(b.$Ge.fromString(JSON.stringify(X.port?{debugPort:X.port}:{})));const B=Y.readEntireBuffer();Y.dispose(),this.a[ce].acceptReconnection(W,M,B)}else{if(this.a[ce])return this.C(be,Y,"Duplicate reconnection token");Y.sendPause(),Y.sendControl(b.$Ge.fromString(JSON.stringify(X.port?{debugPort:X.port}:{})));const B=Y.readEntireBuffer();Y.dispose();const N=this.y.createInstance(k.$qn,ce,W,M,B);this.a[ce]=N,this.f.add(ce),N.onClose(()=>{delete this.a[ce],this.J()}),N.start(X)}}else if(ie.desiredConnectionType===3){const re=ie.args;this.G(Y,re)}else return this.C(be,Y,"Unknown initial data received")}async G(W,K){const Y=W.getSocket().socket,M=W.readEntireBuffer();W.dispose(),Y.pause();const Q=await this.H(K.host,K.port);M.byteLength>0&&Q.write(M.buffer),Q.on("end",()=>Y.end()),Q.on("close",()=>Y.end()),Q.on("error",()=>Y.destroy()),Y.on("end",()=>Q.end()),Y.on("close",()=>Q.end()),Y.on("error",()=>Q.destroy()),Q.pipe(Y),Y.pipe(Q)}H(W,K){return new Promise((Y,M)=>{const Q=S.createConnection({host:W,port:K,autoSelectFamily:!0},()=>{Q.removeListener("error",M),Q.pause(),Y(Q)});Q.once("error",M)})}I(W){return typeof W.port=="number"?(0,E.$Ug)(W.port,10,5e3).then(K=>(W.port=K,W)):(W.debugId=void 0,W.port=void 0,W.break=void 0,Promise.resolve(W))}async J(){if(!this.t.args["enable-remote-auto-shutdown"])return;this.O(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.w.info("Last EH closed, waiting before shutting down"),this.L())}L(W=!1){this.t.args["enable-remote-auto-shutdown"]&&(this.t.args["remote-auto-shutdown-without-delay"]&&!W?this.M():this.m=setTimeout(()=>{this.m=void 0,this.M()},Z))}M(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.w.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.w.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}N(){this.m&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.w.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.O(),this.L())}O(){this.m&&(console.log("Cancelling previous shutdown timeout"),this.w.info("Cancelling previous shutdown timeout"),clearTimeout(this.m),this.m=void 0)}};oe=Le([Ne(5,O.$an),Ne(6,l.$jk),Ne(7,n.$3j),Ne(8,i.$vi)],oe);async function le(_,W,K){const Y=await(0,A.$wn)(W);Y instanceof A.$un&&(console.warn(Y.message),process.exit(1));function M(U){(0,g.setUnexpectedErrorHandler)(T=>{(0,g.$Z)(T)&&T.stack&&/unexpectedErrorHandler/.test(T.stack)||U(T)})}const Q=[];M(U=>{Q.push(U),console.error(U)});let ce=!1;process.on("SIGPIPE",()=>{ce||(ce=!0,(0,g.$1)(new Error("Unexpected SIGPIPE")))});const ie=new v.$Uc,{socketServer:be,instantiationService:re}=await(0,F.$4Q)(Y,W,K,ie);re.invokeFunction(U=>{const T=U.get(n.$3j);Q.forEach(q=>T.error(q)),Q.length=0,M(q=>T.error(q))}),re.invokeFunction(U=>{const T=U.get(r.$3i);a.$i&&(T.getValue("security.restrictUNCAccess")===!1?(0,h.disableUNCAccessRestrictions)():(0,h.addUNCHostToAllowlist)(T.getValue("security.allowedUNCHosts")))}),re.invokeFunction(U=>{const T=U.get(n.$3j);if(a.$i&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const q=(0,m.$kc)(process.env.HOMEDRIVE,"node_modules"),se=(0,m.$nc)((0,m.$kc)(process.env.HOMEDRIVE,process.env.HOMEPATH)),ae=(0,m.$kc)(se,"node_modules");if(C.existsSync(q)||C.existsSync(ae)){const me=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${q}
* ${ae}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;T.warn(me),console.warn(me),process.exit(0)}}});const X=re.invokeFunction(U=>{const T=U.get(n.$3j);if(C.existsSync((0,m.$kc)(w.$Qg.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(se){T.error(se)}return null});let B=W["server-base-path"];B&&!B.startsWith("/")&&(B=`/${B}`);const N=C.existsSync(w.$Qg.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(N&&_&&typeof _!="string"){const U=Y.type!==0?`?${w.$Ig}=${Y.value}`:"";console.log(`Web UI available at http://localhost${_.port===80?"":`:${_.port}`}${B??""}${U}`)}const z=re.createInstance(oe,be,Y,X,N,B);u.mark("code/server/ready");const J=D.performance.now(),ue=global.vscodeServerStartTime,x=global.vscodeServerListenTime,G=global.vscodeServerCodeLoadedTime;if(re.invokeFunction(async U=>{const T=U.get($.$2l);if(T.publicLog2("serverStart",{startTime:ue,startedTime:x,codeLoadedTime:G,readyTime:J}),a.$k){const q=U.get(n.$3j),se=await(0,p.$Tg)(q.error.bind(q));se&&T.publicLog2("serverPlatformInfo",{platformId:se.id,platformVersionId:se.version_id,platformIdLike:se.id_like})}}),W["print-startup-performance"]){const U=P.$U.get();let T="";T+=`

### Load AMD-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],U.amdLoad),T+=`

### Load commonjs-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],U.nodeRequire),T+=`

### Invoke AMD-module factory
`,T+=P.$U.toMarkdownTable(["Module","Duration"],U.amdInvoke),T+=`

### Invoke commonjs-module
`,T+=P.$U.toMarkdownTable(["Module","Duration"],U.nodeEval),T+=`Start-up time: ${x-ue}
`,T+=`Code loading time: ${G-ue}
`,T+=`Initialized time: ${J-ue}
`,T+=`
`,console.log(T)}return z}class te{static create(W){const K=W.webEndpointUrlTemplate,Y=W.commit,M=W.quality;if(!K||!Y||!M)return new te(null);const Q=(0,d.$Sg)(),ie=new URL(K.replace("{{uuid}}",Q).replace("{{commit}}",Y).replace("{{quality}}",M)).origin,be=(0,f.$af)(ie).replace(Q,"[a-zA-Z0-9\\-]+");try{const re=(0,f.$jf)(`^${be}$`,!0,{matchCase:!1});return new te(re)}catch{return new te(null)}}constructor(W){this.a=W}matches(W){return this.a?this.a.test(W):!1}}}),define(ye[316],Ee([1,0,30,27,13,301,306,67,7,307,51,58,44]),function(he,e,o,C,S,D,I,P,b,g,y,v,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spawnCli=s,e.createServer=r,w.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=g.performance.now();const m={onMultipleValues:(i,n)=>{console.error(`Option '${i}' can only be defined once. Using value ${n}.`)},onEmptyValue:i=>{console.error(`Ignoring option '${i}': Value must not be empty.`)},onUnknownOption:i=>{console.error(`Ignoring option '${i}': not supported for server.`)},onDeprecatedOption:(i,n)=>{console.warn(`Option '${i}' is deprecated: ${n}`)}},u=(0,P.$tm)(process.argv.slice(2),y.$_m,m),a=u["server-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,b.$kc)(o.homedir(),v.default.serverDataFolderName||".vscode-remote"),f=(0,b.$kc)(a,"data"),c=(0,b.$kc)(f,"User"),d=(0,b.$kc)(c,"globalStorage"),p=(0,b.$kc)(c,"History"),E=(0,b.$kc)(f,"Machine");u["user-data-dir"]=f;const h=(0,b.$nc)(S.$Qg.asFileUri("").fsPath),t=(0,b.$kc)(h,"extensions");u["builtin-extensions-dir"]=t,u["extensions-dir"]=u["extensions-dir"]||(0,b.$kc)(a,"extensions"),[a,u["extensions-dir"],f,c,E,d,p].forEach(i=>{try{C.existsSync(i)||C.mkdirSync(i,{mode:448})}catch(n){console.error(n)}});function s(){(0,D.run)(u,a,y.$_m)}function r(i){return(0,I.$9Q)(i,u,a)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/dc96b837cf6bb4af9cd736aa3af08cf8279f7685/core/vs/server/node/server.main.js.map
